__secure7_driver_hal_gpio_map:
;__secure7_hal.c,313 :: 		static void hal_gpio_map(hal_p_t gpio_obj)
; gpio_obj start address is: 0 (R0)
; gpio_obj end address is: 0 (R0)
; gpio_obj start address is: 0 (R0)
;__secure7_hal.c,342 :: 		hal_gpio_rx_get = tmp->gpio_get[ __RX_PIN_INPUT__ ];
ADDW	R1, R0, #48
ADDS	R1, #32
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(__secure7_driver_hal_gpio_rx_get+0)
MOVT	R1, #hi_addr(__secure7_driver_hal_gpio_rx_get+0)
STR	R2, [R1, #0]
;__secure7_hal.c,378 :: 		hal_gpio_rx_set = tmp->gpio_set[ __RX_PIN_OUTPUT__ ];
ADDW	R1, R0, #32
; gpio_obj end address is: 0 (R0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(__secure7_driver_hal_gpio_rx_set+0)
MOVT	R1, #hi_addr(__secure7_driver_hal_gpio_rx_set+0)
STR	R2, [R1, #0]
;__secure7_hal.c,389 :: 		}
L_end_hal_gpio_map:
BX	LR
; end of __secure7_driver_hal_gpio_map
__secure7_driver_hal_uart_map:
;__hal_stm32.c,133 :: 		static void hal_uart_map(hal_p_t uart_obj)
; uart_obj start address is: 0 (R0)
; uart_obj end address is: 0 (R0)
; uart_obj start address is: 0 (R0)
;__hal_stm32.c,137 :: 		fp_uart_write = tmp->uart_write;
LDR	R2, [R0, #0]
MOVW	R1, #lo_addr(__secure7_driver_fp_uart_write+0)
MOVT	R1, #hi_addr(__secure7_driver_fp_uart_write+0)
STR	R2, [R1, #0]
;__hal_stm32.c,138 :: 		fp_uart_read  = tmp->uart_read;
ADDS	R1, R0, #4
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(__secure7_driver_fp_uart_read+0)
MOVT	R1, #hi_addr(__secure7_driver_fp_uart_read+0)
STR	R2, [R1, #0]
;__hal_stm32.c,139 :: 		fp_uart_ready = tmp->uart_ready;
ADDW	R1, R0, #8
; uart_obj end address is: 0 (R0)
LDR	R2, [R1, #0]
MOVW	R1, #lo_addr(__secure7_driver_fp_uart_ready+0)
MOVT	R1, #hi_addr(__secure7_driver_fp_uart_ready+0)
STR	R2, [R1, #0]
;__hal_stm32.c,140 :: 		}
L_end_hal_uart_map:
BX	LR
; end of __secure7_driver_hal_uart_map
__secure7_driver_hal_uart_write:
;__hal_stm32.c,142 :: 		static void hal_uart_write(uint8_t input)
; input start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; input end address is: 0 (R0)
; input start address is: 0 (R0)
;__hal_stm32.c,144 :: 		fp_uart_write(input);
; input end address is: 0 (R0)
MOVW	R4, #lo_addr(__secure7_driver_fp_uart_write+0)
MOVT	R4, #hi_addr(__secure7_driver_fp_uart_write+0)
LDR	R4, [R4, #0]
BLX	R4
;__hal_stm32.c,145 :: 		}
L_end_hal_uart_write:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of __secure7_driver_hal_uart_write
__secure7_driver_hal_uart_read:
;__hal_stm32.c,147 :: 		static uint8_t hal_uart_read()
SUB	SP, SP, #4
STR	LR, [SP, #0]
;__hal_stm32.c,149 :: 		return ( uint8_t )fp_uart_read();
MOVW	R4, #lo_addr(__secure7_driver_fp_uart_read+0)
MOVT	R4, #hi_addr(__secure7_driver_fp_uart_read+0)
LDR	R4, [R4, #0]
BLX	R4
UXTB	R0, R0
;__hal_stm32.c,150 :: 		}
L_end_hal_uart_read:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of __secure7_driver_hal_uart_read
__secure7_driver_hal_uart_ready:
;__hal_stm32.c,152 :: 		static uint8_t hal_uart_ready()
SUB	SP, SP, #4
STR	LR, [SP, #0]
;__hal_stm32.c,154 :: 		return ( uint8_t )fp_uart_ready();
MOVW	R4, #lo_addr(__secure7_driver_fp_uart_ready+0)
MOVT	R4, #hi_addr(__secure7_driver_fp_uart_ready+0)
LDR	R4, [R4, #0]
BLX	R4
UXTB	R0, R0
;__hal_stm32.c,155 :: 		}
L_end_hal_uart_ready:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of __secure7_driver_hal_uart_ready
_secure7_uart_driver_init:
;__secure7_driver.c,76 :: 		void secure7_uart_driver_init(secure7_obj_t gpio_obj, secure7_obj_t uart_obj)
; uart_obj start address is: 4 (R1)
; gpio_obj start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
MOV	R3, R0
; uart_obj end address is: 4 (R1)
; gpio_obj end address is: 0 (R0)
; gpio_obj start address is: 12 (R3)
; uart_obj start address is: 4 (R1)
;__secure7_driver.c,78 :: 		hal_uart_map( (hal_p_t)uart_obj );
MOV	R0, R1
; uart_obj end address is: 4 (R1)
BL	__secure7_driver_hal_uart_map+0
;__secure7_driver.c,79 :: 		hal_gpio_map( (hal_p_t)gpio_obj );
MOV	R0, R3
; gpio_obj end address is: 12 (R3)
BL	__secure7_driver_hal_gpio_map+0
;__secure7_driver.c,83 :: 		}
L_end_secure7_uart_driver_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _secure7_uart_driver_init
_secure7_gpio_driver_init:
;__secure7_driver.c,88 :: 		void secure7_gpio_driver_init(secure7_obj_t gpio_obj)
; gpio_obj start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; gpio_obj end address is: 0 (R0)
; gpio_obj start address is: 0 (R0)
;__secure7_driver.c,90 :: 		hal_gpio_map( (hal_p_t)gpio_obj );
; gpio_obj end address is: 0 (R0)
BL	__secure7_driver_hal_gpio_map+0
;__secure7_driver.c,93 :: 		secure7_set_output( );
BL	_secure7_set_output+0
;__secure7_driver.c,94 :: 		hal_gpio_rx_set( 1 );
MOVS	R0, #1
MOVW	R4, #lo_addr(__secure7_driver_hal_gpio_rx_set+0)
MOVT	R4, #hi_addr(__secure7_driver_hal_gpio_rx_set+0)
LDR	R4, [R4, #0]
BLX	R4
;__secure7_driver.c,95 :: 		}
L_end_secure7_gpio_driver_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _secure7_gpio_driver_init
_secure7_write_byte:
;__secure7_driver.c,99 :: 		void secure7_write_byte ( uint8_t input )
; input start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; input end address is: 0 (R0)
; input start address is: 0 (R0)
;__secure7_driver.c,101 :: 		hal_uart_write( input );
; input end address is: 0 (R0)
BL	__secure7_driver_hal_uart_write+0
;__secure7_driver.c,102 :: 		}
L_end_secure7_write_byte:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _secure7_write_byte
_secure7_read_byte:
;__secure7_driver.c,104 :: 		uint8_t secure7_read_byte( void  )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;__secure7_driver.c,106 :: 		return hal_uart_read( );
BL	__secure7_driver_hal_uart_read+0
;__secure7_driver.c,107 :: 		}
L_end_secure7_read_byte:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _secure7_read_byte
_secure7_byte_ready:
;__secure7_driver.c,109 :: 		uint8_t secure7_byte_ready ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;__secure7_driver.c,111 :: 		return hal_uart_ready( );
BL	__secure7_driver_hal_uart_ready+0
;__secure7_driver.c,112 :: 		}
L_end_secure7_byte_ready:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _secure7_byte_ready
_secure7_send_wake_token:
;__secure7_driver.c,114 :: 		void secure7_send_wake_token ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;__secure7_driver.c,116 :: 		hal_gpio_rx_set( 0 );
MOVS	R0, #0
MOVW	R4, #lo_addr(__secure7_driver_hal_gpio_rx_set+0)
MOVT	R4, #hi_addr(__secure7_driver_hal_gpio_rx_set+0)
LDR	R4, [R4, #0]
BLX	R4
;__secure7_driver.c,117 :: 		secure7_delay_wake( );
BL	_secure7_delay_wake+0
;__secure7_driver.c,118 :: 		hal_gpio_rx_set( 1 );
MOVS	R0, #1
MOVW	R4, #lo_addr(__secure7_driver_hal_gpio_rx_set+0)
MOVT	R4, #hi_addr(__secure7_driver_hal_gpio_rx_set+0)
LDR	R4, [R4, #0]
BLX	R4
;__secure7_driver.c,119 :: 		}
L_end_secure7_send_wake_token:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _secure7_send_wake_token
_secure7_send_bytes:
;__secure7_driver.c,121 :: 		void secure7_send_bytes ( uint8_t count, uint8_t *p_buf )
SUB	SP, SP, #16
STR	LR, [SP, #0]
STRB	R0, [SP, #8]
STR	R1, [SP, #12]
;__secure7_driver.c,126 :: 		secure7_set_output( );
BL	_secure7_set_output+0
;__secure7_driver.c,127 :: 		secure7_disable_irq( );
BL	_secure7_disable_irq+0
;__secure7_driver.c,129 :: 		for ( n_cnt = 0; n_cnt < count; n_cnt++ )
MOVS	R2, #0
STRB	R2, [SP, #4]
L_secure7_send_bytes0:
LDRB	R3, [SP, #8]
LDRB	R2, [SP, #4]
CMP	R2, R3
IT	CS
BCS	L_secure7_send_bytes1
;__secure7_driver.c,131 :: 		for ( bit_mask = 1; bit_mask > 0; bit_mask <<= 1 )
MOVS	R2, #1
STRB	R2, [SP, #5]
L_secure7_send_bytes3:
LDRB	R2, [SP, #5]
CMP	R2, #0
IT	LS
BLS	L_secure7_send_bytes4
;__secure7_driver.c,133 :: 		if ( bit_mask & p_buf[ n_cnt ] )
LDRB	R3, [SP, #4]
LDR	R2, [SP, #12]
ADDS	R2, R2, R3
LDRB	R3, [R2, #0]
LDRB	R2, [SP, #5]
ANDS	R2, R3
UXTB	R2, R2
CMP	R2, #0
IT	EQ
BEQ	L_secure7_send_bytes6
;__secure7_driver.c,135 :: 		hal_gpio_rx_set( 0 );
MOVS	R0, #0
MOVW	R4, #lo_addr(__secure7_driver_hal_gpio_rx_set+0)
MOVT	R4, #hi_addr(__secure7_driver_hal_gpio_rx_set+0)
LDR	R4, [R4, #0]
BLX	R4
;__secure7_driver.c,136 :: 		secure7_delay_1L( );
BL	_secure7_delay_1L+0
;__secure7_driver.c,137 :: 		hal_gpio_rx_set( 1 );
MOVS	R0, #1
MOVW	R4, #lo_addr(__secure7_driver_hal_gpio_rx_set+0)
MOVT	R4, #hi_addr(__secure7_driver_hal_gpio_rx_set+0)
LDR	R4, [R4, #0]
BLX	R4
;__secure7_driver.c,138 :: 		secure7_delay_7( );
BL	_secure7_delay_7+0
;__secure7_driver.c,139 :: 		}
IT	AL
BAL	L_secure7_send_bytes7
L_secure7_send_bytes6:
;__secure7_driver.c,142 :: 		hal_gpio_rx_set( 0 );
MOVS	R0, #0
MOVW	R4, #lo_addr(__secure7_driver_hal_gpio_rx_set+0)
MOVT	R4, #hi_addr(__secure7_driver_hal_gpio_rx_set+0)
LDR	R4, [R4, #0]
BLX	R4
;__secure7_driver.c,143 :: 		secure7_delay_1L( );
BL	_secure7_delay_1L+0
;__secure7_driver.c,144 :: 		hal_gpio_rx_set( 1 );
MOVS	R0, #1
MOVW	R4, #lo_addr(__secure7_driver_hal_gpio_rx_set+0)
MOVT	R4, #hi_addr(__secure7_driver_hal_gpio_rx_set+0)
LDR	R4, [R4, #0]
BLX	R4
;__secure7_driver.c,145 :: 		secure7_delay_1H( );
BL	_secure7_delay_1H+0
;__secure7_driver.c,146 :: 		hal_gpio_rx_set( 0 );
MOVS	R0, #0
MOVW	R4, #lo_addr(__secure7_driver_hal_gpio_rx_set+0)
MOVT	R4, #hi_addr(__secure7_driver_hal_gpio_rx_set+0)
LDR	R4, [R4, #0]
BLX	R4
;__secure7_driver.c,147 :: 		secure7_delay_1L( );
BL	_secure7_delay_1L+0
;__secure7_driver.c,148 :: 		hal_gpio_rx_set( 1 );
MOVS	R0, #1
MOVW	R4, #lo_addr(__secure7_driver_hal_gpio_rx_set+0)
MOVT	R4, #hi_addr(__secure7_driver_hal_gpio_rx_set+0)
LDR	R4, [R4, #0]
BLX	R4
;__secure7_driver.c,149 :: 		secure7_delay_5( );
BL	_secure7_delay_5+0
;__secure7_driver.c,150 :: 		}
L_secure7_send_bytes7:
;__secure7_driver.c,131 :: 		for ( bit_mask = 1; bit_mask > 0; bit_mask <<= 1 )
LDRB	R2, [SP, #5]
LSLS	R2, R2, #1
STRB	R2, [SP, #5]
;__secure7_driver.c,151 :: 		}
IT	AL
BAL	L_secure7_send_bytes3
L_secure7_send_bytes4:
;__secure7_driver.c,129 :: 		for ( n_cnt = 0; n_cnt < count; n_cnt++ )
LDRB	R2, [SP, #4]
ADDS	R2, R2, #1
STRB	R2, [SP, #4]
;__secure7_driver.c,152 :: 		}
IT	AL
BAL	L_secure7_send_bytes0
L_secure7_send_bytes1:
;__secure7_driver.c,154 :: 		secure7_enable_irq( );
BL	_secure7_enable_irq+0
;__secure7_driver.c,155 :: 		}
L_end_secure7_send_bytes:
LDR	LR, [SP, #0]
ADD	SP, SP, #16
BX	LR
; end of _secure7_send_bytes
_secure7_send_byte:
;__secure7_driver.c,157 :: 		void secure7_send_byte ( uint8_t s_byte )
SUB	SP, SP, #8
STR	LR, [SP, #0]
STRB	R0, [SP, #4]
;__secure7_driver.c,159 :: 		secure7_send_bytes( 1, &s_byte );
ADD	R1, SP, #4
MOVS	R0, #1
BL	_secure7_send_bytes+0
;__secure7_driver.c,160 :: 		}
L_end_secure7_send_byte:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _secure7_send_byte
_secure7_receive_bytes:
;__secure7_driver.c,162 :: 		uint8_t secure7_receive_bytes ( uint8_t count, uint8_t *p_buf )
SUB	SP, SP, #20
STR	LR, [SP, #0]
STRB	R0, [SP, #12]
STR	R1, [SP, #16]
;__secure7_driver.c,164 :: 		uint8_t status = SECURE7_ATCA_SUCCESS;
MOVS	R2, #0
STRB	R2, [SP, #10]
;__secure7_driver.c,171 :: 		secure7_set_input( );
BL	_secure7_set_input+0
;__secure7_driver.c,172 :: 		secure7_disable_irq( );
BL	_secure7_disable_irq+0
;__secure7_driver.c,175 :: 		for ( n_cnt = 0; n_cnt < count; n_cnt++ )
MOVS	R2, #0
STRB	R2, [SP, #4]
L_secure7_receive_bytes8:
LDRB	R3, [SP, #12]
LDRB	R2, [SP, #4]
CMP	R2, R3
IT	CS
BCS	L_secure7_receive_bytes9
;__secure7_driver.c,177 :: 		p_buf[ n_cnt ] = 0;
LDRB	R3, [SP, #4]
LDR	R2, [SP, #16]
ADDS	R3, R2, R3
MOVS	R2, #0
STRB	R2, [R3, #0]
;__secure7_driver.c,179 :: 		for ( bit_mask = 1; bit_mask > 0; bit_mask <<= 1 )
MOVS	R2, #1
STRB	R2, [SP, #5]
L_secure7_receive_bytes11:
LDRB	R2, [SP, #5]
CMP	R2, #0
IT	LS
BLS	L_secure7_receive_bytes12
;__secure7_driver.c,181 :: 		pulse_count = 0;
MOVS	R2, #0
STRB	R2, [SP, #6]
;__secure7_driver.c,182 :: 		timeout_count = SECURE7_START_PULSE_TIME_OUT;
MOVW	R2, #600
STRH	R2, [SP, #8]
;__secure7_driver.c,185 :: 		while ( --timeout_count > 0 )
L_secure7_receive_bytes14:
LDRH	R4, [SP, #8]
SUBS	R4, R4, #1
UXTH	R4, R4
STRH	R4, [SP, #8]
CMP	R4, #0
IT	LS
BLS	L_secure7_receive_bytes15
;__secure7_driver.c,188 :: 		asm nop;
NOP
;__secure7_driver.c,190 :: 		if ( hal_gpio_rx_get() == 0 )
MOVW	R4, #lo_addr(__secure7_driver_hal_gpio_rx_get+0)
MOVT	R4, #hi_addr(__secure7_driver_hal_gpio_rx_get+0)
LDR	R4, [R4, #0]
BLX	R4
CMP	R0, #0
IT	NE
BNE	L_secure7_receive_bytes16
;__secure7_driver.c,192 :: 		break;
IT	AL
BAL	L_secure7_receive_bytes15
;__secure7_driver.c,193 :: 		}
L_secure7_receive_bytes16:
;__secure7_driver.c,194 :: 		}
IT	AL
BAL	L_secure7_receive_bytes14
L_secure7_receive_bytes15:
;__secure7_driver.c,195 :: 		if ( timeout_count == 0 )
LDRH	R2, [SP, #8]
CMP	R2, #0
IT	NE
BNE	L_secure7_receive_bytes17
;__secure7_driver.c,197 :: 		status = SECURE7_ATCA_RX_TIMEOUT;
MOVS	R2, #235
STRB	R2, [SP, #10]
;__secure7_driver.c,198 :: 		break;
IT	AL
BAL	L_secure7_receive_bytes12
;__secure7_driver.c,199 :: 		}
L_secure7_receive_bytes17:
;__secure7_driver.c,201 :: 		timeout_count = SECURE7_START_PULSE_TIME_OUT;
MOVW	R4, #600
STRH	R4, [SP, #8]
;__secure7_driver.c,203 :: 		do
L_secure7_receive_bytes18:
;__secure7_driver.c,206 :: 		if ( hal_gpio_rx_get() != 0 )
MOVW	R4, #lo_addr(__secure7_driver_hal_gpio_rx_get+0)
MOVT	R4, #hi_addr(__secure7_driver_hal_gpio_rx_get+0)
LDR	R4, [R4, #0]
BLX	R4
CMP	R0, #0
IT	EQ
BEQ	L_secure7_receive_bytes21
;__secure7_driver.c,208 :: 		pulse_count = 1;
MOVS	R2, #1
STRB	R2, [SP, #6]
;__secure7_driver.c,209 :: 		break;
IT	AL
BAL	L_secure7_receive_bytes19
;__secure7_driver.c,210 :: 		}
L_secure7_receive_bytes21:
;__secure7_driver.c,212 :: 		while ( --timeout_count > 0 );
LDRH	R2, [SP, #8]
SUBS	R2, R2, #1
UXTH	R2, R2
STRH	R2, [SP, #8]
CMP	R2, #0
IT	HI
BHI	L_secure7_receive_bytes18
L_secure7_receive_bytes19:
;__secure7_driver.c,214 :: 		if ( pulse_count == 0 )
LDRB	R2, [SP, #6]
CMP	R2, #0
IT	NE
BNE	L_secure7_receive_bytes22
;__secure7_driver.c,216 :: 		status = SECURE7_ATCA_RX_TIMEOUT;
MOVS	R2, #235
STRB	R2, [SP, #10]
;__secure7_driver.c,217 :: 		break;
IT	AL
BAL	L_secure7_receive_bytes12
;__secure7_driver.c,218 :: 		}
L_secure7_receive_bytes22:
;__secure7_driver.c,222 :: 		timeout_count = SECURE7_ZERO_PULSE_TIME_OUT;
MOVW	R2, #40
STRH	R2, [SP, #8]
;__secure7_driver.c,225 :: 		do
L_secure7_receive_bytes23:
;__secure7_driver.c,227 :: 		if ( hal_gpio_rx_get() == 0 )
MOVW	R4, #lo_addr(__secure7_driver_hal_gpio_rx_get+0)
MOVT	R4, #hi_addr(__secure7_driver_hal_gpio_rx_get+0)
LDR	R4, [R4, #0]
BLX	R4
CMP	R0, #0
IT	NE
BNE	L_secure7_receive_bytes26
;__secure7_driver.c,229 :: 		pulse_count = 2;
MOVS	R2, #2
STRB	R2, [SP, #6]
;__secure7_driver.c,230 :: 		break;
IT	AL
BAL	L_secure7_receive_bytes24
;__secure7_driver.c,231 :: 		}
L_secure7_receive_bytes26:
;__secure7_driver.c,233 :: 		while ( --timeout_count > 0 );
LDRH	R2, [SP, #8]
SUBS	R2, R2, #1
UXTH	R2, R2
STRH	R2, [SP, #8]
CMP	R2, #0
IT	HI
BHI	L_secure7_receive_bytes23
L_secure7_receive_bytes24:
;__secure7_driver.c,237 :: 		if ( pulse_count == 2 )
LDRB	R2, [SP, #6]
CMP	R2, #2
IT	NE
BNE	L_secure7_receive_bytes27
;__secure7_driver.c,239 :: 		timeout_count = SECURE7_ZERO_PULSE_TIME_OUT;
MOVW	R2, #40
STRH	R2, [SP, #8]
;__secure7_driver.c,241 :: 		do
L_secure7_receive_bytes28:
;__secure7_driver.c,243 :: 		if ( hal_gpio_rx_get() != 0 )
MOVW	R4, #lo_addr(__secure7_driver_hal_gpio_rx_get+0)
MOVT	R4, #hi_addr(__secure7_driver_hal_gpio_rx_get+0)
LDR	R4, [R4, #0]
BLX	R4
CMP	R0, #0
IT	EQ
BEQ	L_secure7_receive_bytes31
;__secure7_driver.c,245 :: 		break;
IT	AL
BAL	L_secure7_receive_bytes29
;__secure7_driver.c,246 :: 		}
L_secure7_receive_bytes31:
;__secure7_driver.c,249 :: 		while ( timeout_count-- > 0 );
LDRH	R3, [SP, #8]
LDRH	R2, [SP, #8]
SUBS	R2, R2, #1
STRH	R2, [SP, #8]
CMP	R3, #0
IT	HI
BHI	L_secure7_receive_bytes28
L_secure7_receive_bytes29:
;__secure7_driver.c,251 :: 		}
IT	AL
BAL	L_secure7_receive_bytes32
L_secure7_receive_bytes27:
;__secure7_driver.c,256 :: 		p_buf[ n_cnt ] |= bit_mask;
LDRB	R3, [SP, #4]
LDR	R2, [SP, #16]
ADDS	R4, R2, R3
LDRB	R3, [R4, #0]
LDRB	R2, [SP, #5]
ORR	R2, R3, R2, LSL #0
STRB	R2, [R4, #0]
;__secure7_driver.c,257 :: 		}
L_secure7_receive_bytes32:
;__secure7_driver.c,179 :: 		for ( bit_mask = 1; bit_mask > 0; bit_mask <<= 1 )
LDRB	R2, [SP, #5]
LSLS	R2, R2, #1
STRB	R2, [SP, #5]
;__secure7_driver.c,258 :: 		}
IT	AL
BAL	L_secure7_receive_bytes11
L_secure7_receive_bytes12:
;__secure7_driver.c,260 :: 		if ( status != SECURE7_ATCA_SUCCESS  )
LDRB	R2, [SP, #10]
CMP	R2, #0
IT	EQ
BEQ	L_secure7_receive_bytes33
;__secure7_driver.c,262 :: 		break;
IT	AL
BAL	L_secure7_receive_bytes9
;__secure7_driver.c,263 :: 		}
L_secure7_receive_bytes33:
;__secure7_driver.c,265 :: 		if ( n_cnt == 0 )
LDRB	R2, [SP, #4]
CMP	R2, #0
IT	NE
BNE	L_secure7_receive_bytes34
;__secure7_driver.c,267 :: 		if ( p_buf[ SECURE7_ATCA_RSP_SIZE_MIN ] < 4 )
LDR	R2, [SP, #16]
LDRB	R2, [R2, #0]
CMP	R2, #4
IT	CS
BCS	L_secure7_receive_bytes35
;__secure7_driver.c,269 :: 		status = SECURE7_ATCA_INVALID_SIZE;
MOVS	R2, #228
STRB	R2, [SP, #10]
;__secure7_driver.c,270 :: 		break;
IT	AL
BAL	L_secure7_receive_bytes9
;__secure7_driver.c,271 :: 		}
L_secure7_receive_bytes35:
;__secure7_driver.c,272 :: 		else if ( p_buf[ 0 ] > count )
LDR	R2, [SP, #16]
LDRB	R3, [R2, #0]
LDRB	R2, [SP, #12]
CMP	R3, R2
IT	LS
BLS	L_secure7_receive_bytes37
;__secure7_driver.c,274 :: 		status = SECURE7_ATCA_SMALL_BUFFER;
MOVS	R2, #237
STRB	R2, [SP, #10]
;__secure7_driver.c,275 :: 		break;
IT	AL
BAL	L_secure7_receive_bytes9
;__secure7_driver.c,276 :: 		}
L_secure7_receive_bytes37:
;__secure7_driver.c,279 :: 		count = p_buf[ 0 ] ;
LDR	R2, [SP, #16]
LDRB	R2, [R2, #0]
STRB	R2, [SP, #12]
;__secure7_driver.c,281 :: 		}
L_secure7_receive_bytes34:
;__secure7_driver.c,175 :: 		for ( n_cnt = 0; n_cnt < count; n_cnt++ )
LDRB	R2, [SP, #4]
ADDS	R2, R2, #1
STRB	R2, [SP, #4]
;__secure7_driver.c,282 :: 		}
IT	AL
BAL	L_secure7_receive_bytes8
L_secure7_receive_bytes9:
;__secure7_driver.c,284 :: 		secure7_enable_irq( );
BL	_secure7_enable_irq+0
;__secure7_driver.c,285 :: 		secure7_delay_txrx( );
BL	_secure7_delay_txrx+0
;__secure7_driver.c,287 :: 		if ( status == SECURE7_ATCA_RX_TIMEOUT  )
LDRB	R2, [SP, #10]
CMP	R2, #235
IT	NE
BNE	L_secure7_receive_bytes39
;__secure7_driver.c,289 :: 		if ( n_cnt > 0 )
LDRB	R2, [SP, #4]
CMP	R2, #0
IT	LS
BLS	L_secure7_receive_bytes40
;__secure7_driver.c,292 :: 		status = SECURE7_ATCA_RX_FAIL;
MOVS	R2, #230
STRB	R2, [SP, #10]
;__secure7_driver.c,293 :: 		}
L_secure7_receive_bytes40:
;__secure7_driver.c,294 :: 		}
L_secure7_receive_bytes39:
;__secure7_driver.c,296 :: 		return status;
LDRB	R0, [SP, #10]
;__secure7_driver.c,297 :: 		}
L_end_secure7_receive_bytes:
LDR	LR, [SP, #0]
ADD	SP, SP, #20
BX	LR
; end of _secure7_receive_bytes
_secure7_delay_txrx:
;__secure7_driver.c,306 :: 		void secure7_delay_txrx ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;__secure7_driver.c,308 :: 		Delay_50us();
BL	_Delay_50us+0
;__secure7_driver.c,309 :: 		Delay_22us();
BL	_Delay_22us+0
;__secure7_driver.c,310 :: 		Delay_22us();
BL	_Delay_22us+0
;__secure7_driver.c,311 :: 		Delay_1us();
BL	_Delay_1us+0
;__secure7_driver.c,312 :: 		Delay_1us();
BL	_Delay_1us+0
;__secure7_driver.c,313 :: 		}
L_end_secure7_delay_txrx:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _secure7_delay_txrx
_secure7_delay_wake:
;__secure7_driver.c,318 :: 		void secure7_delay_wake ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;__secure7_driver.c,320 :: 		Delay_80us();
BL	_Delay_80us+0
;__secure7_driver.c,321 :: 		}
L_end_secure7_delay_wake:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _secure7_delay_wake
_secure7_delay_1L:
;__secure7_driver.c,326 :: 		void secure7_delay_1L ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;__secure7_driver.c,328 :: 		Delay_1us();
BL	_Delay_1us+0
;__secure7_driver.c,329 :: 		Delay_1us();
BL	_Delay_1us+0
;__secure7_driver.c,330 :: 		Delay_1us();
BL	_Delay_1us+0
;__secure7_driver.c,331 :: 		Delay_1us();
BL	_Delay_1us+0
;__secure7_driver.c,332 :: 		}
L_end_secure7_delay_1L:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _secure7_delay_1L
_secure7_delay_1H:
;__secure7_driver.c,337 :: 		void secure7_delay_1H ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;__secure7_driver.c,339 :: 		Delay_1us();
BL	_Delay_1us+0
;__secure7_driver.c,340 :: 		Delay_1us();
BL	_Delay_1us+0
;__secure7_driver.c,341 :: 		Delay_1us();
BL	_Delay_1us+0
;__secure7_driver.c,342 :: 		Delay_1us();
BL	_Delay_1us+0
;__secure7_driver.c,343 :: 		}
L_end_secure7_delay_1H:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _secure7_delay_1H
_secure7_delay_5:
;__secure7_driver.c,348 :: 		void secure7_delay_5 ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;__secure7_driver.c,350 :: 		Delay_22us();
BL	_Delay_22us+0
;__secure7_driver.c,351 :: 		Delay_1us();
BL	_Delay_1us+0
;__secure7_driver.c,352 :: 		Delay_1us();
BL	_Delay_1us+0
;__secure7_driver.c,353 :: 		Delay_1us();
BL	_Delay_1us+0
;__secure7_driver.c,354 :: 		Delay_1us();
BL	_Delay_1us+0
;__secure7_driver.c,355 :: 		}
L_end_secure7_delay_5:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _secure7_delay_5
_secure7_delay_7:
;__secure7_driver.c,360 :: 		void secure7_delay_7 ( void )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;__secure7_driver.c,362 :: 		Delay_22us();
BL	_Delay_22us+0
;__secure7_driver.c,363 :: 		Delay_10us();
BL	_Delay_10us+0
;__secure7_driver.c,364 :: 		Delay_1us();
BL	_Delay_1us+0
;__secure7_driver.c,365 :: 		Delay_1us();
BL	_Delay_1us+0
;__secure7_driver.c,366 :: 		Delay_1us();
BL	_Delay_1us+0
;__secure7_driver.c,367 :: 		}
L_end_secure7_delay_7:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _secure7_delay_7
_secure7_disable_irq:
;__secure7_driver.c,369 :: 		void secure7_disable_irq ( void )
;__secure7_driver.c,372 :: 		}
L_end_secure7_disable_irq:
BX	LR
; end of _secure7_disable_irq
_secure7_enable_irq:
;__secure7_driver.c,374 :: 		void secure7_enable_irq ( void )
;__secure7_driver.c,377 :: 		}
L_end_secure7_enable_irq:
BX	LR
; end of _secure7_enable_irq
