#line 1 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/__secure7_driver.c"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/__secure7_driver.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 49 "e:/git/secure_7_click/secure_7_click/sw/library/__secure7_driver.h"
extern const uint16_t SECURE7_START_PULSE_TIME_OUT;
#line 60 "e:/git/secure_7_click/secure_7_click/sw/library/__secure7_driver.h"
extern const uint16_t SECURE7_ZERO_PULSE_TIME_OUT;
#line 74 "e:/git/secure_7_click/secure_7_click/sw/library/__secure7_driver.h"
extern void secure7_set_output( void );
extern void secure7_set_input( void );
#line 83 "e:/git/secure_7_click/secure_7_click/sw/library/__secure7_driver.h"
extern void secure7_disable_irq();
#line 91 "e:/git/secure_7_click/secure_7_click/sw/library/__secure7_driver.h"
extern void secure7_enable_irq();
#line 100 "e:/git/secure_7_click/secure_7_click/sw/library/__secure7_driver.h"
void secure7_uart_driver_init( const uint8_t*  gpio_obj,  const uint8_t*  uart_obj);



void secure7_gpio_driver_init( const uint8_t*  gpio_obj);
#line 116 "e:/git/secure_7_click/secure_7_click/sw/library/__secure7_driver.h"
void secure7_write_byte ( uint8_t input );
#line 125 "e:/git/secure_7_click/secure_7_click/sw/library/__secure7_driver.h"
uint8_t secure7_read_byte( );
#line 134 "e:/git/secure_7_click/secure_7_click/sw/library/__secure7_driver.h"
uint8_t secure7_byte_ready ( );
#line 143 "e:/git/secure_7_click/secure_7_click/sw/library/__secure7_driver.h"
void secure7_send_wake_token();
#line 156 "e:/git/secure_7_click/secure_7_click/sw/library/__secure7_driver.h"
void secure7_send_bytes ( uint8_t count, uint8_t *p_buf );
#line 169 "e:/git/secure_7_click/secure_7_click/sw/library/__secure7_driver.h"
void secure7_send_byte(uint8_t byte);

uint8_t secure7_receive_bytes(uint8_t count, uint8_t *buffer);
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/__secure7_hal.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"
#line 194 "e:/git/secure_7_click/secure_7_click/sw/library/__secure7_hal.c"
static void hal_uart_map( const uint8_t*  uart_obj);
#line 203 "e:/git/secure_7_click/secure_7_click/sw/library/__secure7_hal.c"
static void hal_uart_write(uint8_t input);
#line 212 "e:/git/secure_7_click/secure_7_click/sw/library/__secure7_hal.c"
static uint8_t hal_uart_read();
#line 221 "e:/git/secure_7_click/secure_7_click/sw/library/__secure7_hal.c"
static uint8_t hal_uart_ready();





typedef void (*hal_gpio_set_fp_t)(uint8_t);
typedef uint8_t (*hal_gpio_get_fp_t)();

typedef struct
{
 hal_gpio_set_fp_t gpio_set[ 12 ];
 hal_gpio_get_fp_t gpio_get[ 12 ];

}hal_struct_gpio_t;
#line 262 "e:/git/secure_7_click/secure_7_click/sw/library/__secure7_hal.c"
static hal_gpio_get_fp_t hal_gpio_rx_get;
#line 298 "e:/git/secure_7_click/secure_7_click/sw/library/__secure7_hal.c"
static hal_gpio_set_fp_t hal_gpio_rx_set;
#line 313 "e:/git/secure_7_click/secure_7_click/sw/library/__secure7_hal.c"
static void hal_gpio_map( const uint8_t*  gpio_obj)
{
  const hal_struct_gpio_t*  tmp = ( const hal_struct_gpio_t* )gpio_obj;
#line 342 "e:/git/secure_7_click/secure_7_click/sw/library/__secure7_hal.c"
 hal_gpio_rx_get = tmp->gpio_get[  8  ];
#line 378 "e:/git/secure_7_click/secure_7_click/sw/library/__secure7_hal.c"
 hal_gpio_rx_set = tmp->gpio_set[  8  ];
#line 389 "e:/git/secure_7_click/secure_7_click/sw/library/__secure7_hal.c"
}
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/hal/__hal_stm32.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"
#line 117 "e:/git/secure_7_click/secure_7_click/sw/library/hal/__hal_stm32.c"
typedef void ( *hal_uart_write_fp_t )(unsigned int);
typedef unsigned int ( *hal_uart_read_fp_t )();
typedef unsigned int ( *hal_uart_ready_fp_t )();

typedef struct
{
 hal_uart_write_fp_t uart_write;
 hal_uart_read_fp_t uart_read;
 hal_uart_ready_fp_t uart_ready;

}hal_struct_uart_t;

static hal_uart_write_fp_t fp_uart_write;
static hal_uart_read_fp_t fp_uart_read;
static hal_uart_ready_fp_t fp_uart_ready;

static void hal_uart_map( const uint8_t*  uart_obj)
{
  const hal_struct_uart_t*  tmp = ( const hal_struct_uart_t* )uart_obj;

 fp_uart_write = tmp->uart_write;
 fp_uart_read = tmp->uart_read;
 fp_uart_ready = tmp->uart_ready;
}

static void hal_uart_write(uint8_t input)
{
 fp_uart_write(input);
}

static uint8_t hal_uart_read()
{
 return ( uint8_t )fp_uart_read();
}

static uint8_t hal_uart_ready()
{
 return ( uint8_t )fp_uart_ready();
}
#line 19 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/__secure7_driver.c"
const uint16_t SECURE7_START_PULSE_TIME_OUT = 600;
const uint16_t SECURE7_ZERO_PULSE_TIME_OUT = 40;

const uint8_t SECURE7_ATCA_SUCCESS = 0x00;
const uint8_t SECURE7_ATCA_RX_TIMEOUT = 0xEB;
const uint8_t SECURE7_ATCA_INVALID_SIZE = 0xE4;
const uint8_t SECURE7_ATCA_SMALL_BUFFER = 0xED;
const uint8_t SECURE7_ATCA_RSP_SIZE_MIN = 0x00;
const uint8_t SECURE7_ATCA_RX_FAIL = 0xE6;
#line 38 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/__secure7_driver.c"
void secure7_delay_txrx ( void );
void secure7_delay_wake ( void );
void secure7_delay_1L ( void );
void secure7_delay_1H ( void );
void secure7_delay_5 ( void );
void secure7_delay_7 ( void );
void secure7_disable_irq ( void );
void secure7_enable_irq ( void );
#line 76 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/__secure7_driver.c"
void secure7_uart_driver_init( const uint8_t*  gpio_obj,  const uint8_t*  uart_obj)
{
 hal_uart_map( ( const uint8_t* )uart_obj );
 hal_gpio_map( ( const uint8_t* )gpio_obj );



}




void secure7_gpio_driver_init( const uint8_t*  gpio_obj)
{
 hal_gpio_map( ( const uint8_t* )gpio_obj );


 secure7_set_output( );
 hal_gpio_rx_set( 1 );
}



void secure7_write_byte ( uint8_t input )
{
 hal_uart_write( input );
}

uint8_t secure7_read_byte( void )
{
 return hal_uart_read( );
}

uint8_t secure7_byte_ready ( void )
{
 return hal_uart_ready( );
}

void secure7_send_wake_token ( void )
{
 hal_gpio_rx_set( 0 );
 secure7_delay_wake( );
 hal_gpio_rx_set( 1 );
}

void secure7_send_bytes ( uint8_t count, uint8_t *p_buf )
{
 uint8_t n_cnt;
 uint8_t bit_mask;

 secure7_set_output( );
 secure7_disable_irq( );

 for ( n_cnt = 0; n_cnt < count; n_cnt++ )
 {
 for ( bit_mask = 1; bit_mask > 0; bit_mask <<= 1 )
 {
 if ( bit_mask & p_buf[ n_cnt ] )
 {
 hal_gpio_rx_set( 0 );
 secure7_delay_1L( );
 hal_gpio_rx_set( 1 );
 secure7_delay_7( );
 }
 else
 {
 hal_gpio_rx_set( 0 );
 secure7_delay_1L( );
 hal_gpio_rx_set( 1 );
 secure7_delay_1H( );
 hal_gpio_rx_set( 0 );
 secure7_delay_1L( );
 hal_gpio_rx_set( 1 );
 secure7_delay_5( );
 }
 }
 }

 secure7_enable_irq( );
}

void secure7_send_byte ( uint8_t s_byte )
{
 secure7_send_bytes( 1, &s_byte );
}

uint8_t secure7_receive_bytes ( uint8_t count, uint8_t *p_buf )
{
 uint8_t status = SECURE7_ATCA_SUCCESS;
 uint8_t n_cnt;
 uint8_t bit_mask;
 uint8_t pulse_count;
 uint16_t timeout_count;


 secure7_set_input( );
 secure7_disable_irq( );


 for ( n_cnt = 0; n_cnt < count; n_cnt++ )
 {
 p_buf[ n_cnt ] = 0;

 for ( bit_mask = 1; bit_mask > 0; bit_mask <<= 1 )
 {
 pulse_count = 0;
 timeout_count = SECURE7_START_PULSE_TIME_OUT;


 while ( --timeout_count > 0 )
 {

 asm nop;

 if ( hal_gpio_rx_get() == 0 )
 {
 break;
 }
 }
 if ( timeout_count == 0 )
 {
 status = SECURE7_ATCA_RX_TIMEOUT;
 break;
 }

 timeout_count = SECURE7_START_PULSE_TIME_OUT;

 do
 {

 if ( hal_gpio_rx_get() != 0 )
 {
 pulse_count = 1;
 break;
 }
 }
 while ( --timeout_count > 0 );

 if ( pulse_count == 0 )
 {
 status = SECURE7_ATCA_RX_TIMEOUT;
 break;
 }



 timeout_count = SECURE7_ZERO_PULSE_TIME_OUT;


 do
 {
 if ( hal_gpio_rx_get() == 0 )
 {
 pulse_count = 2;
 break;
 }
 }
 while ( --timeout_count > 0 );



 if ( pulse_count == 2 )
 {
 timeout_count = SECURE7_ZERO_PULSE_TIME_OUT;

 do
 {
 if ( hal_gpio_rx_get() != 0 )
 {
 break;
 }
 }

 while ( timeout_count-- > 0 );

 }

 else
 {

 p_buf[ n_cnt ] |= bit_mask;
 }
 }

 if ( status != SECURE7_ATCA_SUCCESS )
 {
 break;
 }

 if ( n_cnt == 0 )
 {
 if ( p_buf[ SECURE7_ATCA_RSP_SIZE_MIN ] < 4 )
 {
 status = SECURE7_ATCA_INVALID_SIZE;
 break;
 }
 else if ( p_buf[ 0 ] > count )
 {
 status = SECURE7_ATCA_SMALL_BUFFER;
 break;
 }
 else
 {
 count = p_buf[ 0 ] ;
 }
 }
 }

 secure7_enable_irq( );
 secure7_delay_txrx( );

 if ( status == SECURE7_ATCA_RX_TIMEOUT )
 {
 if ( n_cnt > 0 )
 {

 status = SECURE7_ATCA_RX_FAIL;
 }
 }

 return status;
}
#line 306 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/__secure7_driver.c"
void secure7_delay_txrx ( void )
{
 Delay_50us();
 Delay_22us();
 Delay_22us();
 Delay_1us();
 Delay_1us();
}
#line 318 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/__secure7_driver.c"
void secure7_delay_wake ( void )
{
 Delay_80us();
}
#line 326 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/__secure7_driver.c"
void secure7_delay_1L ( void )
{
 Delay_1us();
 Delay_1us();
 Delay_1us();
 Delay_1us();
}
#line 337 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/__secure7_driver.c"
void secure7_delay_1H ( void )
{
 Delay_1us();
 Delay_1us();
 Delay_1us();
 Delay_1us();
}
#line 348 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/__secure7_driver.c"
void secure7_delay_5 ( void )
{
 Delay_22us();
 Delay_1us();
 Delay_1us();
 Delay_1us();
 Delay_1us();
}
#line 360 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/__secure7_driver.c"
void secure7_delay_7 ( void )
{
 Delay_22us();
 Delay_10us();
 Delay_1us();
 Delay_1us();
 Delay_1us();
}

void secure7_disable_irq ( void )
{

}

void secure7_enable_irq ( void )
{

}
