#line 1 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_cfgs.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stddef.h"



typedef long ptrdiff_t;


 typedef unsigned long size_t;

typedef unsigned long wchar_t;
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_cfgs.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_iface.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_compiler.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_status.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdbool.h"



 typedef char _Bool;
#line 55 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_status.h"
typedef enum
{
 ATCA_SUCCESS = 0x00,
 ATCA_CONFIG_ZONE_LOCKED = 0x01,
 ATCA_DATA_ZONE_LOCKED = 0x02,
 ATCA_WAKE_FAILED = 0xD0,
 ATCA_CHECKMAC_VERIFY_FAILED = 0xD1,
 ATCA_PARSE_ERROR = 0xD2,
 ATCA_STATUS_CRC = 0xD4,
 ATCA_STATUS_UNKNOWN = 0xD5,
 ATCA_STATUS_ECC = 0xD6,
 ATCA_STATUS_SELFTEST_ERROR = 0xD7,
 ATCA_FUNC_FAIL = 0xE0,
 ATCA_GEN_FAIL = 0xE1,
 ATCA_BAD_PARAM = 0xE2,
 ATCA_INVALID_ID = 0xE3,
 ATCA_INVALID_SIZE = 0xE4,
 ATCA_RX_CRC_ERROR = 0xE5,
 ATCA_RX_FAIL = 0xE6,
 ATCA_RX_NO_RESPONSE = 0xE7,
 ATCA_RESYNC_WITH_WAKEUP = 0xE8,
 ATCA_PARITY_ERROR = 0xE9,
 ATCA_TX_TIMEOUT = 0xEA,
 ATCA_RX_TIMEOUT = 0xEB,
 ATCA_TOO_MANY_COMM_RETRIES = 0xEC,
 ATCA_SMALL_BUFFER = 0xED,
 ATCA_COMM_FAIL = 0xF0,
 ATCA_TIMEOUT = 0xF1,
 ATCA_BAD_OPCODE = 0xF2,
 ATCA_WAKE_SUCCESS = 0xF3,
 ATCA_EXECUTION_ERROR = 0xF4,
 ATCA_UNIMPLEMENTED = 0xF5,
 ATCA_ASSERT_FAILURE = 0xF6,
 ATCA_TX_FAIL = 0xF7,
 ATCA_NOT_LOCKED = 0xF8,
 ATCA_NO_DEVICES = 0xF9,
 ATCA_HEALTH_TEST_ERROR = 0xFA,
 ATCA_ALLOC_FAILURE = 0xFB,
} ATCA_STATUS;
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_devtypes.h"
#line 53 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_devtypes.h"
typedef enum {
 ATSHA204A,
 ATECC108A,
 ATECC508A,
 ATECC608A,
 ATCA_DEV_UNKNOWN = 0x20
} ATCADeviceType;
#line 62 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
struct atca_command {
 ATCADeviceType dt;
 uint16_t *execution_times;
};


typedef struct atca_command * ATCACommand;
ATCACommand newATCACommand(ATCADeviceType device_type);
#pragma pack( push, ATCAPacket, 2 )
#line 97 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
typedef struct {


 uint8_t _reserved;


 uint8_t txsize;
 uint8_t opcode;
 uint8_t param1;
 uint16_t param2;
 uint8_t  _data [130];






 uint8_t execTime;
 uint16_t rxsize;




} ATCAPacket;
#pragma pack( pop, ATCAPacket)
#line 123 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
ATCA_STATUS atCheckMAC(ATCACommand cacmd, ATCAPacket *packet);
ATCA_STATUS atCounter(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atDeriveKey(ATCACommand cacmd, ATCAPacket *packet,  _Bool  hasMAC );
ATCA_STATUS atECDH(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atGenDig(ATCACommand cacmd, ATCAPacket *packet,  _Bool  hasMACKey );
ATCA_STATUS atGenKey(ATCACommand cacmd, ATCAPacket *packet,  _Bool  isPubKey );
ATCA_STATUS atHMAC(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atInfo(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atLock(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atMAC(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atNonce(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atPause(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atPrivWrite(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atRandom(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atRead(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atSHA(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atSign(ATCACommand cacmd, ATCAPacket *packet);
ATCA_STATUS atUpdateExtra(ATCACommand cacmd, ATCAPacket *packet);
ATCA_STATUS atVerify(ATCACommand cacmd, ATCAPacket *packet);
ATCA_STATUS atWrite(ATCACommand cacmd, ATCAPacket *packet);
ATCA_STATUS atWriteEnc(ATCACommand cacmd, ATCAPacket *packet);

 _Bool  atIsSHAFamily( ATCADeviceType deviceType );
 _Bool  atIsECCFamily( ATCADeviceType deviceType );
ATCA_STATUS isATCAError( uint8_t * _data  );


typedef enum {
 WAKE_TWHI,
 CMD_CHECKMAC,
 CMD_COUNTER,
 CMD_DERIVEKEY,
 CMD_ECDH,
 CMD_GENDIG,
 CMD_GENKEY,
 CMD_HMAC,
 CMD_INFO,
 CMD_LOCK,
 CMD_MAC,
 CMD_NONCE,
 CMD_PAUSE,
 CMD_PRIVWRITE,
 CMD_RANDOM,
 CMD_READMEM,
 CMD_SHA,
 CMD_SIGN,
 CMD_UPDATEEXTRA,
 CMD_VERIFY,
 CMD_WRITEMEM,
 CMD_LASTCOMMAND
} ATCA_CmdMap;

ATCA_STATUS atInitExecTimes(ATCACommand cacmd, ATCADeviceType device_type);
uint16_t atGetExecTime( ATCACommand cacmd, ATCA_CmdMap cmd );

void deleteATCACommand( ATCACommand * );



void atCRC( uint8_t length, uint8_t * _data , uint8_t *crc);
void atCalcCrc( ATCAPacket *pkt);
uint8_t atCheckCrc(uint8_t *response);
#line 316 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
typedef enum {
 COUNTER_MODE_READ = 0,
 COUNTER_MODE_INCREASE = 1
} enum_counter_mode;
#line 330 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
typedef enum {
 SHA_MODE_SHA256_START = ((uint8_t) 0x00),
 SHA_MODE_SHA256_UPDATE = ((uint8_t) 0x01),
 SHA_MODE_SHA256_END = ((uint8_t) 0x02),
 SHA_MODE_SHA256_PUBLIC = ((uint8_t) 0x03),
 SHA_MODE_HMAC_START = ((uint8_t) 0x04),
 SHA_MODE_HMAC_UPDATE = ((uint8_t) 0x05),
 SHA_MODE_HMAC_END = ((uint8_t) 0x04)
} enum_sha_mode;
#line 407 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
typedef enum {
 GENKEY_MODE_PRIVATE_KEY_GENERATE = ((uint8_t) 0x04),
 GENKEY_MODE_PUBLIC_KEY_DIGEST = ((uint8_t) 0x08),
 GENKEY_MODE_DIGEST_IN_TEMPKEY = ((uint8_t) 0x10)
} enum_genkey_mode;
#line 58 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_iface.h"
typedef enum {
 ATCA_I2C_IFACE,
 ATCA_SWI_IFACE,
 ATCA_UART_IFACE,
 ATCA_SPI_IFACE,
 ATCA_HID_IFACE

} ATCAIfaceType;
#line 74 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_iface.h"
typedef struct {

 ATCAIfaceType iface_type;
 ATCADeviceType devtype;

 union {
 struct ATCAI2C {
 uint8_t slave_address;
 uint8_t bus;
 uint32_t baud;
 } atcai2c;

 struct ATCASWI {
 uint8_t bus;
 } atcaswi;

 struct ATCAUART {
 int port;
 uint32_t baud;
 uint8_t wordsize;
 uint8_t parity;
 uint8_t stopbits;
 } atcauart;

 struct ATCAHID {
 int idx;
 uint32_t vid;
 uint32_t pid;
 uint32_t packetsize;
 uint8_t guid[16];
 } atcahid;

 };

 uint16_t wake_delay;
 int rx_retries;
 void *cfg_data;
} ATCAIfaceCfg;
#line 117 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_iface.h"
typedef struct atca_iface
{
 ATCAIfaceType mType;
 ATCAIfaceCfg *mIfaceCFG;

 ATCA_STATUS (*atinit)(void *hal, ATCAIfaceCfg *cfg);
 ATCA_STATUS (*atpostinit)(struct atca_iface *hal);
 ATCA_STATUS (*atsend)(struct atca_iface *hal, uint8_t *txdata, int txlength);
 ATCA_STATUS (*atreceive)(struct atca_iface *hal, uint8_t *rxdata, uint16_t *rxlength);
 ATCA_STATUS (*atwake)(struct atca_iface *hal);
 ATCA_STATUS (*atidle)(struct atca_iface *hal);
 ATCA_STATUS (*atsleep)(struct atca_iface *hal);


 void *hal_data;

}T_atca_iface;

typedef T_atca_iface* ATCAIface;

ATCAIface newATCAIface(ATCAIfaceCfg *cfg);


ATCA_STATUS atinit(ATCAIface caiface);
ATCA_STATUS atpostinit(ATCAIface caiface);
ATCA_STATUS atsend(ATCAIface caiface, uint8_t *txdata, int txlength);
ATCA_STATUS atreceive(ATCAIface caiface, uint8_t *rxdata, uint16_t *rxlength);
ATCA_STATUS atwake(ATCAIface caiface);
ATCA_STATUS atidle(ATCAIface caiface);
ATCA_STATUS atsleep(ATCAIface caiface);


ATCAIfaceCfg * atgetifacecfg(ATCAIface caiface);
void* atgetifacehaldat(ATCAIface caiface);

void deleteATCAIface( ATCAIface *dev );
#line 53 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_cfgs.h"
extern ATCAIfaceCfg SECURE7_ATCA_CFG;
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_iface.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_device.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_iface.h"
#line 59 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_device.h"
struct atca_device {
 ATCACommand mCommands;
 ATCAIface mIface;
};

typedef struct atca_device* ATCADevice;
ATCADevice newATCADevice(ATCAIfaceCfg *cfg );


ATCACommand atGetCommands( ATCADevice dev );
ATCAIface atGetIFace( ATCADevice dev );

void deleteATCADevice( ATCADevice *dev );
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_devtypes.h"
#line 56 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_cfgs.c"
ATCAIfaceCfg SECURE7_ATCA_CFG =
{
 ATCA_SWI_IFACE,
 ATECC508A,
 1,
 1500,
 20
};
