_newATCACommand:
;atca_command.c,64 :: 		ATCACommand newATCACommand( ATCADeviceType device_type )  // constructor
; device_type start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
UXTB	R9, R0
; device_type end address is: 0 (R0)
; device_type start address is: 36 (R9)
;atca_command.c,66 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atca_command.c,67 :: 		ATCACommand cacmd = (ATCACommand)Malloc(sizeof(struct atca_command));
MOVS	R0, #8
BL	_Malloc+0
; cacmd start address is: 16 (R4)
MOV	R4, R0
;atca_command.c,69 :: 		cacmd->dt = device_type;
STRB	R9, [R0, #0]
;atca_command.c,70 :: 		status = atInitExecTimes(cacmd, device_type);  // setup typical execution times for this device type
UXTB	R1, R9
; device_type end address is: 36 (R9)
MOV	R0, R4
BL	_atInitExecTimes+0
;atca_command.c,72 :: 		if (status != ATCA_SUCCESS) {
CMP	R0, #0
IT	EQ
BEQ	L__newATCACommand105
;atca_command.c,73 :: 		Free((void*)cacmd, sizeof(cacmd));
MOVS	R1, #4
MOV	R0, R4
; cacmd end address is: 16 (R4)
BL	_Free+0
;atca_command.c,74 :: 		cacmd = NULL;
; cacmd start address is: 0 (R0)
MOVS	R0, #0
; cacmd end address is: 0 (R0)
;atca_command.c,75 :: 		}
IT	AL
BAL	L_newATCACommand0
L__newATCACommand105:
;atca_command.c,72 :: 		if (status != ATCA_SUCCESS) {
MOV	R0, R4
;atca_command.c,75 :: 		}
L_newATCACommand0:
;atca_command.c,77 :: 		return cacmd;
; cacmd start address is: 0 (R0)
; cacmd end address is: 0 (R0)
;atca_command.c,78 :: 		}
L_end_newATCACommand:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _newATCACommand
_atCheckMAC:
;atca_command.c,88 :: 		ATCA_STATUS atCheckMAC(ATCACommand cacmd, ATCAPacket *packet )
; packet start address is: 4 (R1)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; packet end address is: 4 (R1)
; packet start address is: 4 (R1)
;atca_command.c,91 :: 		packet->opcode = ATCA_CHECKMAC;
ADDS	R3, R1, #2
MOVS	R2, #40
STRB	R2, [R3, #0]
;atca_command.c,92 :: 		packet->txsize = CHECKMAC_COUNT;
ADDS	R3, R1, #1
MOVS	R2, #84
STRB	R2, [R3, #0]
;atca_command.c,93 :: 		packet->rxsize = CHECKMAC_RSP_SIZE;
ADDW	R3, R1, #138
MOVS	R2, #4
STRH	R2, [R3, #0]
;atca_command.c,95 :: 		atCalcCrc( packet );
MOV	R0, R1
; packet end address is: 4 (R1)
BL	_atCalcCrc+0
;atca_command.c,96 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_command.c,97 :: 		}
L_end_atCheckMAC:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atCheckMAC
_atCounter:
;atca_command.c,104 :: 		ATCA_STATUS atCounter(ATCACommand cacmd, ATCAPacket *packet )
; packet start address is: 4 (R1)
; cacmd start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; packet end address is: 4 (R1)
; cacmd end address is: 0 (R0)
; cacmd start address is: 0 (R0)
; packet start address is: 4 (R1)
;atca_command.c,106 :: 		if ( !atIsECCFamily( cacmd->dt ) )
LDRB	R2, [R0, #0]
; cacmd end address is: 0 (R0)
UXTB	R0, R2
BL	_atIsECCFamily+0
CMP	R0, #0
IT	NE
BNE	L_atCounter1
; packet end address is: 4 (R1)
;atca_command.c,107 :: 		return ATCA_BAD_OPCODE;
MOVS	R0, #242
IT	AL
BAL	L_end_atCounter
L_atCounter1:
;atca_command.c,110 :: 		packet->opcode = ATCA_COUNTER;
; packet start address is: 4 (R1)
ADDS	R3, R1, #2
MOVS	R2, #36
STRB	R2, [R3, #0]
;atca_command.c,111 :: 		packet->txsize = COUNTER_COUNT;
ADDS	R3, R1, #1
MOVS	R2, #7
STRB	R2, [R3, #0]
;atca_command.c,112 :: 		packet->rxsize = COUNTER_RSP_SIZE;
ADDW	R3, R1, #138
MOVS	R2, #7
STRH	R2, [R3, #0]
;atca_command.c,114 :: 		atCalcCrc( packet );
MOV	R0, R1
; packet end address is: 4 (R1)
BL	_atCalcCrc+0
;atca_command.c,115 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_command.c,116 :: 		}
L_end_atCounter:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atCounter
_atDeriveKey:
;atca_command.c,124 :: 		ATCA_STATUS atDeriveKey(ATCACommand cacmd, ATCAPacket *packet, bool hasMAC )
; hasMAC start address is: 8 (R2)
; packet start address is: 4 (R1)
SUB	SP, SP, #4
STR	LR, [SP, #0]
MOV	R10, R1
; hasMAC end address is: 8 (R2)
; packet end address is: 4 (R1)
; packet start address is: 40 (R10)
; hasMAC start address is: 8 (R2)
;atca_command.c,127 :: 		packet->opcode = ATCA_DERIVE_KEY;
ADD	R4, R10, #2
MOVS	R3, #28
STRB	R3, [R4, #0]
;atca_command.c,131 :: 		switch ( hasMAC ) {
IT	AL
BAL	L_atDeriveKey2
; hasMAC end address is: 8 (R2)
;atca_command.c,132 :: 		case true:
L_atDeriveKey4:
;atca_command.c,133 :: 		packet->txsize = DERIVE_KEY_COUNT_LARGE;
ADD	R4, R10, #1
MOVS	R3, #39
STRB	R3, [R4, #0]
;atca_command.c,134 :: 		break;
IT	AL
BAL	L_atDeriveKey3
;atca_command.c,135 :: 		case false:
L_atDeriveKey5:
;atca_command.c,136 :: 		packet->txsize = DERIVE_KEY_COUNT_SMALL;
ADD	R4, R10, #1
MOVS	R3, #7
STRB	R3, [R4, #0]
;atca_command.c,137 :: 		break;
IT	AL
BAL	L_atDeriveKey3
;atca_command.c,138 :: 		}
L_atDeriveKey2:
; hasMAC start address is: 8 (R2)
CMP	R2, #1
IT	EQ
BEQ	L_atDeriveKey4
CMP	R2, #0
IT	EQ
BEQ	L_atDeriveKey5
; hasMAC end address is: 8 (R2)
L_atDeriveKey3:
;atca_command.c,140 :: 		packet->rxsize = DERIVE_KEY_RSP_SIZE;
ADD	R4, R10, #138
MOVS	R3, #4
STRH	R3, [R4, #0]
;atca_command.c,141 :: 		atCalcCrc( packet );
MOV	R0, R10
; packet end address is: 40 (R10)
BL	_atCalcCrc+0
;atca_command.c,142 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_command.c,143 :: 		}
L_end_atDeriveKey:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atDeriveKey
_atECDH:
;atca_command.c,150 :: 		ATCA_STATUS atECDH(ATCACommand cacmd, ATCAPacket *packet )
; packet start address is: 4 (R1)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; packet end address is: 4 (R1)
; packet start address is: 4 (R1)
;atca_command.c,154 :: 		packet->opcode = ATCA_ECDH;
ADDS	R3, R1, #2
MOVS	R2, #67
STRB	R2, [R3, #0]
;atca_command.c,155 :: 		packet->txsize = ECDH_COUNT;
ADDS	R3, R1, #1
MOVS	R2, #71
STRB	R2, [R3, #0]
;atca_command.c,156 :: 		packet->rxsize = ECDH_RSP_SIZE;
ADDW	R3, R1, #138
MOVS	R2, #35
STRH	R2, [R3, #0]
;atca_command.c,158 :: 		atCalcCrc( packet );
MOV	R0, R1
; packet end address is: 4 (R1)
BL	_atCalcCrc+0
;atca_command.c,159 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_command.c,160 :: 		}
L_end_atECDH:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atECDH
_atGenDig:
;atca_command.c,168 :: 		ATCA_STATUS atGenDig(ATCACommand cacmd, ATCAPacket *packet, bool hasMACKey )
; hasMACKey start address is: 8 (R2)
; packet start address is: 4 (R1)
SUB	SP, SP, #4
STR	LR, [SP, #0]
MOV	R10, R1
; hasMACKey end address is: 8 (R2)
; packet end address is: 4 (R1)
; packet start address is: 40 (R10)
; hasMACKey start address is: 8 (R2)
;atca_command.c,172 :: 		packet->opcode = ATCA_GENDIG;
ADD	R4, R10, #2
MOVS	R3, #21
STRB	R3, [R4, #0]
;atca_command.c,174 :: 		if ( packet->param1 == 0x03 ) // shared nonce mode
ADD	R3, R10, #3
LDRB	R3, [R3, #0]
CMP	R3, #3
IT	NE
BNE	L_atGenDig6
; hasMACKey end address is: 8 (R2)
;atca_command.c,175 :: 		packet->txsize = GENDIG_COUNT + 32;
ADD	R4, R10, #1
MOVS	R3, #39
STRB	R3, [R4, #0]
IT	AL
BAL	L_atGenDig7
L_atGenDig6:
;atca_command.c,176 :: 		else if ( hasMACKey == true )
; hasMACKey start address is: 8 (R2)
CMP	R2, #1
IT	NE
BNE	L_atGenDig8
; hasMACKey end address is: 8 (R2)
;atca_command.c,177 :: 		packet->txsize = GENDIG_COUNT_DATA;
ADD	R4, R10, #1
MOVS	R3, #11
STRB	R3, [R4, #0]
IT	AL
BAL	L_atGenDig9
L_atGenDig8:
;atca_command.c,179 :: 		packet->txsize = GENDIG_COUNT;
ADD	R4, R10, #1
MOVS	R3, #7
STRB	R3, [R4, #0]
L_atGenDig9:
L_atGenDig7:
;atca_command.c,181 :: 		packet->rxsize = GENDIG_RSP_SIZE;
ADD	R4, R10, #138
MOVS	R3, #4
STRH	R3, [R4, #0]
;atca_command.c,183 :: 		atCalcCrc( packet );
MOV	R0, R10
; packet end address is: 40 (R10)
BL	_atCalcCrc+0
;atca_command.c,184 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_command.c,185 :: 		}
L_end_atGenDig:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atGenDig
_atGenKey:
;atca_command.c,193 :: 		ATCA_STATUS atGenKey(ATCACommand cacmd, ATCAPacket *packet, bool isPubKey )
; isPubKey start address is: 8 (R2)
; packet start address is: 4 (R1)
SUB	SP, SP, #4
STR	LR, [SP, #0]
MOV	R10, R1
; isPubKey end address is: 8 (R2)
; packet end address is: 4 (R1)
; packet start address is: 40 (R10)
; isPubKey start address is: 8 (R2)
;atca_command.c,197 :: 		packet->opcode = ATCA_GENKEY;
ADD	R4, R10, #2
MOVS	R3, #64
STRB	R3, [R4, #0]
;atca_command.c,199 :: 		switch ( isPubKey ) {
IT	AL
BAL	L_atGenKey10
; isPubKey end address is: 8 (R2)
;atca_command.c,200 :: 		case true:
L_atGenKey12:
;atca_command.c,201 :: 		packet->txsize = GENKEY_COUNT_DATA;
ADD	R4, R10, #1
MOVS	R3, #10
STRB	R3, [R4, #0]
;atca_command.c,202 :: 		break;
IT	AL
BAL	L_atGenKey11
;atca_command.c,203 :: 		case false:
L_atGenKey13:
;atca_command.c,204 :: 		packet->txsize = GENKEY_COUNT;
ADD	R4, R10, #1
MOVS	R3, #7
STRB	R3, [R4, #0]
;atca_command.c,205 :: 		break;
IT	AL
BAL	L_atGenKey11
;atca_command.c,206 :: 		}
L_atGenKey10:
; isPubKey start address is: 8 (R2)
CMP	R2, #1
IT	EQ
BEQ	L_atGenKey12
CMP	R2, #0
IT	EQ
BEQ	L_atGenKey13
; isPubKey end address is: 8 (R2)
L_atGenKey11:
;atca_command.c,208 :: 		packet->rxsize = GENKEY_RSP_SIZE_LONG;
ADD	R4, R10, #138
MOVS	R3, #75
STRH	R3, [R4, #0]
;atca_command.c,210 :: 		atCalcCrc( packet );
MOV	R0, R10
; packet end address is: 40 (R10)
BL	_atCalcCrc+0
;atca_command.c,211 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_command.c,212 :: 		}
L_end_atGenKey:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atGenKey
_atHMAC:
;atca_command.c,219 :: 		ATCA_STATUS atHMAC(ATCACommand cacmd, ATCAPacket *packet )
; packet start address is: 4 (R1)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; packet end address is: 4 (R1)
; packet start address is: 4 (R1)
;atca_command.c,223 :: 		packet->opcode = ATCA_HMAC;
ADDS	R3, R1, #2
MOVS	R2, #17
STRB	R2, [R3, #0]
;atca_command.c,224 :: 		packet->txsize = HMAC_COUNT;
ADDS	R3, R1, #1
MOVS	R2, #7
STRB	R2, [R3, #0]
;atca_command.c,225 :: 		packet->rxsize = HMAC_RSP_SIZE;
ADDW	R3, R1, #138
MOVS	R2, #35
STRH	R2, [R3, #0]
;atca_command.c,227 :: 		atCalcCrc( packet );
MOV	R0, R1
; packet end address is: 4 (R1)
BL	_atCalcCrc+0
;atca_command.c,228 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_command.c,229 :: 		}
L_end_atHMAC:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atHMAC
_atInfo:
;atca_command.c,236 :: 		ATCA_STATUS atInfo( ATCACommand cacmd, ATCAPacket *packet )
; packet start address is: 4 (R1)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; packet end address is: 4 (R1)
; packet start address is: 4 (R1)
;atca_command.c,240 :: 		packet->opcode = ATCA_INFO;
ADDS	R3, R1, #2
MOVS	R2, #48
STRB	R2, [R3, #0]
;atca_command.c,241 :: 		packet->txsize = INFO_COUNT;
ADDS	R3, R1, #1
MOVS	R2, #7
STRB	R2, [R3, #0]
;atca_command.c,242 :: 		packet->rxsize = INFO_RSP_SIZE;
ADDW	R3, R1, #138
MOVS	R2, #7
STRH	R2, [R3, #0]
;atca_command.c,244 :: 		atCalcCrc( packet );
MOV	R0, R1
; packet end address is: 4 (R1)
BL	_atCalcCrc+0
;atca_command.c,245 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_command.c,246 :: 		}
L_end_atInfo:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atInfo
_atLock:
;atca_command.c,253 :: 		ATCA_STATUS atLock(  ATCACommand cacmd, ATCAPacket *packet )
; packet start address is: 4 (R1)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; packet end address is: 4 (R1)
; packet start address is: 4 (R1)
;atca_command.c,257 :: 		packet->opcode = ATCA_LOCK;
ADDS	R3, R1, #2
MOVS	R2, #23
STRB	R2, [R3, #0]
;atca_command.c,258 :: 		packet->txsize = LOCK_COUNT;
ADDS	R3, R1, #1
MOVS	R2, #7
STRB	R2, [R3, #0]
;atca_command.c,259 :: 		packet->rxsize = LOCK_RSP_SIZE;
ADDW	R3, R1, #138
MOVS	R2, #4
STRH	R2, [R3, #0]
;atca_command.c,261 :: 		atCalcCrc( packet );
MOV	R0, R1
; packet end address is: 4 (R1)
BL	_atCalcCrc+0
;atca_command.c,262 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_command.c,263 :: 		}
L_end_atLock:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atLock
_atMAC:
;atca_command.c,270 :: 		ATCA_STATUS atMAC( ATCACommand cacmd, ATCAPacket *packet )
; packet start address is: 4 (R1)
SUB	SP, SP, #4
STR	LR, [SP, #0]
MOV	R10, R1
; packet end address is: 4 (R1)
; packet start address is: 40 (R10)
;atca_command.c,275 :: 		packet->opcode = ATCA_MAC;
ADD	R3, R10, #2
MOVS	R2, #8
STRB	R2, [R3, #0]
;atca_command.c,276 :: 		if ( packet->param1 == 0 )
ADD	R2, R10, #3
LDRB	R2, [R2, #0]
CMP	R2, #0
IT	NE
BNE	L_atMAC14
;atca_command.c,277 :: 		packet->txsize = MAC_COUNT_LONG;
ADD	R3, R10, #1
MOVS	R2, #39
STRB	R2, [R3, #0]
IT	AL
BAL	L_atMAC15
L_atMAC14:
;atca_command.c,279 :: 		packet->txsize = MAC_COUNT_SHORT;
ADD	R3, R10, #1
MOVS	R2, #7
STRB	R2, [R3, #0]
L_atMAC15:
;atca_command.c,281 :: 		packet->rxsize = MAC_RSP_SIZE;
ADD	R3, R10, #138
MOVS	R2, #35
STRH	R2, [R3, #0]
;atca_command.c,283 :: 		atCalcCrc( packet );
MOV	R0, R10
; packet end address is: 40 (R10)
BL	_atCalcCrc+0
;atca_command.c,284 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_command.c,285 :: 		}
L_end_atMAC:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atMAC
_atNonce:
;atca_command.c,292 :: 		ATCA_STATUS atNonce( ATCACommand cacmd, ATCAPacket *packet )
; packet start address is: 4 (R1)
SUB	SP, SP, #4
STR	LR, [SP, #0]
MOV	R10, R1
; packet end address is: 4 (R1)
; packet start address is: 40 (R10)
;atca_command.c,297 :: 		packet->opcode = ATCA_NONCE;
ADD	R3, R10, #2
MOVS	R2, #22
STRB	R2, [R3, #0]
;atca_command.c,298 :: 		mode = packet->param1 & 0x03;
ADD	R2, R10, #3
LDRB	R2, [R2, #0]
AND	R2, R2, #3
UXTB	R2, R2
; mode start address is: 0 (R0)
UXTB	R0, R2
;atca_command.c,300 :: 		if ( (mode == 0 || mode == 1) ) {       // mode[0:1] == 0 | 1 then NumIn is 20 bytes
CMP	R0, #0
IT	EQ
BEQ	L__atNonce109
CMP	R0, #1
IT	EQ
BEQ	L__atNonce108
IT	AL
BAL	L_atNonce18
; mode end address is: 0 (R0)
L__atNonce109:
L__atNonce108:
;atca_command.c,301 :: 		packet->txsize = NONCE_COUNT_SHORT; // 20 byte challenge
ADD	R3, R10, #1
MOVS	R2, #27
STRB	R2, [R3, #0]
;atca_command.c,302 :: 		packet->rxsize = NONCE_RSP_SIZE_LONG;
ADD	R3, R10, #138
MOVS	R2, #35
STRH	R2, [R3, #0]
;atca_command.c,303 :: 		} else if ( mode == 0x03 ) {            // NumIn is 32 bytes
IT	AL
BAL	L_atNonce19
L_atNonce18:
; mode start address is: 0 (R0)
CMP	R0, #3
IT	NE
BNE	L_atNonce20
; mode end address is: 0 (R0)
;atca_command.c,304 :: 		packet->txsize = NONCE_COUNT_LONG;  // 32 byte challenge
ADD	R3, R10, #1
MOVS	R2, #39
STRB	R2, [R3, #0]
;atca_command.c,305 :: 		packet->rxsize = NONCE_RSP_SIZE_SHORT;
ADD	R3, R10, #138
MOVS	R2, #4
STRH	R2, [R3, #0]
;atca_command.c,306 :: 		} else
IT	AL
BAL	L_atNonce21
; packet end address is: 40 (R10)
L_atNonce20:
;atca_command.c,307 :: 		return ATCA_BAD_PARAM;
MOVS	R0, #226
IT	AL
BAL	L_end_atNonce
L_atNonce21:
; packet start address is: 40 (R10)
L_atNonce19:
;atca_command.c,309 :: 		atCalcCrc( packet );
MOV	R0, R10
; packet end address is: 40 (R10)
BL	_atCalcCrc+0
;atca_command.c,310 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_command.c,311 :: 		}
L_end_atNonce:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atNonce
_atPause:
;atca_command.c,318 :: 		ATCA_STATUS atPause( ATCACommand cacmd, ATCAPacket *packet )
; packet start address is: 4 (R1)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; packet end address is: 4 (R1)
; packet start address is: 4 (R1)
;atca_command.c,321 :: 		packet->opcode = ATCA_PAUSE;
ADDS	R3, R1, #2
MOVS	R2, #1
STRB	R2, [R3, #0]
;atca_command.c,322 :: 		packet->txsize = PAUSE_COUNT;
ADDS	R3, R1, #1
MOVS	R2, #7
STRB	R2, [R3, #0]
;atca_command.c,323 :: 		packet->rxsize = PAUSE_RSP_SIZE;
ADDW	R3, R1, #138
MOVS	R2, #4
STRH	R2, [R3, #0]
;atca_command.c,325 :: 		atCalcCrc( packet );
MOV	R0, R1
; packet end address is: 4 (R1)
BL	_atCalcCrc+0
;atca_command.c,326 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_command.c,327 :: 		}
L_end_atPause:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atPause
_atPrivWrite:
;atca_command.c,334 :: 		ATCA_STATUS atPrivWrite( ATCACommand cacmd, ATCAPacket *packet )
; packet start address is: 4 (R1)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; packet end address is: 4 (R1)
; packet start address is: 4 (R1)
;atca_command.c,337 :: 		packet->opcode = ATCA_PRIVWRITE;
ADDS	R3, R1, #2
MOVS	R2, #70
STRB	R2, [R3, #0]
;atca_command.c,338 :: 		packet->txsize = PRIVWRITE_COUNT;
ADDS	R3, R1, #1
MOVS	R2, #75
STRB	R2, [R3, #0]
;atca_command.c,339 :: 		packet->rxsize = PRIVWRITE_RSP_SIZE;
ADDW	R3, R1, #138
MOVS	R2, #4
STRH	R2, [R3, #0]
;atca_command.c,341 :: 		atCalcCrc( packet );
MOV	R0, R1
; packet end address is: 4 (R1)
BL	_atCalcCrc+0
;atca_command.c,342 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_command.c,343 :: 		}
L_end_atPrivWrite:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atPrivWrite
_atRandom:
;atca_command.c,350 :: 		ATCA_STATUS atRandom( ATCACommand cacmd, ATCAPacket *packet )
; packet start address is: 4 (R1)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; packet end address is: 4 (R1)
; packet start address is: 4 (R1)
;atca_command.c,354 :: 		packet->opcode = ATCA_RANDOM;
ADDS	R3, R1, #2
MOVS	R2, #27
STRB	R2, [R3, #0]
;atca_command.c,355 :: 		packet->txsize = RANDOM_COUNT;
ADDS	R3, R1, #1
MOVS	R2, #7
STRB	R2, [R3, #0]
;atca_command.c,356 :: 		packet->rxsize = RANDOM_RSP_SIZE;
ADDW	R3, R1, #138
MOVS	R2, #35
STRH	R2, [R3, #0]
;atca_command.c,358 :: 		atCalcCrc( packet );
MOV	R0, R1
; packet end address is: 4 (R1)
BL	_atCalcCrc+0
;atca_command.c,359 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_command.c,360 :: 		}
L_end_atRandom:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atRandom
_atRead:
;atca_command.c,367 :: 		ATCA_STATUS atRead( ATCACommand cacmd, ATCAPacket *packet )
; packet start address is: 4 (R1)
SUB	SP, SP, #4
STR	LR, [SP, #0]
MOV	R10, R1
; packet end address is: 4 (R1)
; packet start address is: 40 (R10)
;atca_command.c,371 :: 		packet->opcode = ATCA_READ;
ADD	R3, R10, #2
MOVS	R2, #2
STRB	R2, [R3, #0]
;atca_command.c,372 :: 		packet->txsize = READ_COUNT;
ADD	R3, R10, #1
MOVS	R2, #7
STRB	R2, [R3, #0]
;atca_command.c,375 :: 		if ((packet->param1 & 0x80) == 0 )
ADD	R2, R10, #3
LDRB	R2, [R2, #0]
AND	R2, R2, #128
UXTB	R2, R2
CMP	R2, #0
IT	NE
BNE	L_atRead22
;atca_command.c,376 :: 		packet->rxsize = READ_4_RSP_SIZE;
ADD	R3, R10, #138
MOVS	R2, #7
STRH	R2, [R3, #0]
IT	AL
BAL	L_atRead23
L_atRead22:
;atca_command.c,378 :: 		packet->rxsize = READ_32_RSP_SIZE;
ADD	R3, R10, #138
MOVS	R2, #35
STRH	R2, [R3, #0]
L_atRead23:
;atca_command.c,380 :: 		atCalcCrc( packet );
MOV	R0, R10
; packet end address is: 40 (R10)
BL	_atCalcCrc+0
;atca_command.c,381 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_command.c,382 :: 		}
L_end_atRead:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atRead
_atSHA:
;atca_command.c,389 :: 		ATCA_STATUS atSHA( ATCACommand cacmd, ATCAPacket *packet )
; packet start address is: 4 (R1)
SUB	SP, SP, #4
STR	LR, [SP, #0]
MOV	R10, R1
; packet end address is: 4 (R1)
; packet start address is: 40 (R10)
;atca_command.c,391 :: 		if ( packet->param2 > SHA_BLOCK_SIZE )
ADD	R2, R10, #4
LDRH	R2, [R2, #0]
CMP	R2, #64
IT	LS
BLS	L_atSHA24
; packet end address is: 40 (R10)
;atca_command.c,392 :: 		return ATCA_BAD_PARAM;
MOVS	R0, #226
IT	AL
BAL	L_end_atSHA
L_atSHA24:
;atca_command.c,394 :: 		if ( packet->param1 == 0x01 && packet->param2 != SHA_BLOCK_SIZE )
; packet start address is: 40 (R10)
ADD	R2, R10, #3
LDRB	R2, [R2, #0]
CMP	R2, #1
IT	NE
BNE	L__atSHA113
ADD	R2, R10, #4
LDRH	R2, [R2, #0]
CMP	R2, #64
IT	EQ
BEQ	L__atSHA112
; packet end address is: 40 (R10)
L__atSHA111:
;atca_command.c,395 :: 		return ATCA_BAD_PARAM;                                              // updates should always have 64 bytes of data
MOVS	R0, #226
IT	AL
BAL	L_end_atSHA
;atca_command.c,394 :: 		if ( packet->param1 == 0x01 && packet->param2 != SHA_BLOCK_SIZE )
L__atSHA113:
; packet start address is: 40 (R10)
L__atSHA112:
;atca_command.c,397 :: 		if ( packet->param1 == 0x02 && packet->param2 > SHA_BLOCK_SIZE - 1 )    // END should be 0-63 bytes
ADD	R2, R10, #3
LDRB	R2, [R2, #0]
CMP	R2, #2
IT	NE
BNE	L__atSHA115
ADD	R2, R10, #4
LDRH	R2, [R2, #0]
CMP	R2, #63
IT	LS
BLS	L__atSHA114
; packet end address is: 40 (R10)
L__atSHA110:
;atca_command.c,398 :: 		return ATCA_BAD_PARAM;
MOVS	R0, #226
IT	AL
BAL	L_end_atSHA
;atca_command.c,397 :: 		if ( packet->param1 == 0x02 && packet->param2 > SHA_BLOCK_SIZE - 1 )    // END should be 0-63 bytes
L__atSHA115:
; packet start address is: 40 (R10)
L__atSHA114:
;atca_command.c,401 :: 		packet->opcode = ATCA_SHA;
ADD	R3, R10, #2
MOVS	R2, #71
STRB	R2, [R3, #0]
;atca_command.c,403 :: 		switch ( packet->param1 ) {
ADD	R4, R10, #3
IT	AL
BAL	L_atSHA31
;atca_command.c,404 :: 		case 0x00: // START
L_atSHA33:
;atca_command.c,405 :: 		packet->rxsize = SHA_RSP_SIZE_SHORT;
ADD	R3, R10, #138
MOVS	R2, #4
STRH	R2, [R3, #0]
;atca_command.c,406 :: 		packet->txsize = SHA_COUNT_LONG;
ADD	R3, R10, #1
MOVS	R2, #7
STRB	R2, [R3, #0]
;atca_command.c,407 :: 		break;
IT	AL
BAL	L_atSHA32
;atca_command.c,408 :: 		case 0x01: // UPDATE
L_atSHA34:
;atca_command.c,409 :: 		packet->rxsize = SHA_RSP_SIZE_SHORT;
ADD	R3, R10, #138
MOVS	R2, #4
STRH	R2, [R3, #0]
;atca_command.c,410 :: 		packet->txsize = SHA_COUNT_LONG + SHA_BLOCK_SIZE;
ADD	R3, R10, #1
MOVS	R2, #71
STRB	R2, [R3, #0]
;atca_command.c,411 :: 		break;
IT	AL
BAL	L_atSHA32
;atca_command.c,412 :: 		case 0x02: // END
L_atSHA35:
;atca_command.c,413 :: 		packet->rxsize = SHA_RSP_SIZE_LONG;
ADD	R3, R10, #138
MOVS	R2, #35
STRH	R2, [R3, #0]
;atca_command.c,416 :: 		packet->txsize = SHA_COUNT_LONG + packet->param2;
ADD	R3, R10, #1
ADD	R2, R10, #4
LDRH	R2, [R2, #0]
ADDS	R2, R2, #7
STRB	R2, [R3, #0]
;atca_command.c,417 :: 		break;
IT	AL
BAL	L_atSHA32
;atca_command.c,418 :: 		}
L_atSHA31:
LDRB	R2, [R4, #0]
CMP	R2, #0
IT	EQ
BEQ	L_atSHA33
LDRB	R2, [R4, #0]
CMP	R2, #1
IT	EQ
BEQ	L_atSHA34
LDRB	R2, [R4, #0]
CMP	R2, #2
IT	EQ
BEQ	L_atSHA35
L_atSHA32:
;atca_command.c,420 :: 		atCalcCrc( packet );
MOV	R0, R10
; packet end address is: 40 (R10)
BL	_atCalcCrc+0
;atca_command.c,421 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_command.c,422 :: 		}
L_end_atSHA:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atSHA
_atSign:
;atca_command.c,429 :: 		ATCA_STATUS atSign( ATCACommand cacmd, ATCAPacket *packet )
; packet start address is: 4 (R1)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; packet end address is: 4 (R1)
; packet start address is: 4 (R1)
;atca_command.c,433 :: 		packet->opcode = ATCA_SIGN;
ADDS	R3, R1, #2
MOVS	R2, #65
STRB	R2, [R3, #0]
;atca_command.c,434 :: 		packet->txsize = SIGN_COUNT;
ADDS	R3, R1, #1
MOVS	R2, #7
STRB	R2, [R3, #0]
;atca_command.c,437 :: 		packet->rxsize = ATCA_RSP_SIZE_64;
ADDW	R3, R1, #138
MOVS	R2, #67
STRH	R2, [R3, #0]
;atca_command.c,439 :: 		atCalcCrc( packet );
MOV	R0, R1
; packet end address is: 4 (R1)
BL	_atCalcCrc+0
;atca_command.c,440 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_command.c,441 :: 		}
L_end_atSign:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atSign
_atUpdateExtra:
;atca_command.c,448 :: 		ATCA_STATUS atUpdateExtra( ATCACommand cacmd, ATCAPacket *packet )
; packet start address is: 4 (R1)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; packet end address is: 4 (R1)
; packet start address is: 4 (R1)
;atca_command.c,452 :: 		packet->opcode = ATCA_UPDATE_EXTRA;
ADDS	R3, R1, #2
MOVS	R2, #32
STRB	R2, [R3, #0]
;atca_command.c,453 :: 		packet->txsize = UPDATE_COUNT;
ADDS	R3, R1, #1
MOVS	R2, #7
STRB	R2, [R3, #0]
;atca_command.c,454 :: 		packet->rxsize = UPDATE_RSP_SIZE;
ADDW	R3, R1, #138
MOVS	R2, #4
STRH	R2, [R3, #0]
;atca_command.c,456 :: 		atCalcCrc( packet );
MOV	R0, R1
; packet end address is: 4 (R1)
BL	_atCalcCrc+0
;atca_command.c,457 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_command.c,458 :: 		}
L_end_atUpdateExtra:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atUpdateExtra
_atVerify:
;atca_command.c,465 :: 		ATCA_STATUS atVerify( ATCACommand cacmd, ATCAPacket *packet )
; packet start address is: 4 (R1)
SUB	SP, SP, #4
STR	LR, [SP, #0]
MOV	R10, R1
; packet end address is: 4 (R1)
; packet start address is: 40 (R10)
;atca_command.c,469 :: 		packet->opcode = ATCA_VERIFY;
ADD	R3, R10, #2
MOVS	R2, #69
STRB	R2, [R3, #0]
;atca_command.c,472 :: 		switch ( packet->param1 ) {
ADD	R4, R10, #3
IT	AL
BAL	L_atVerify36
;atca_command.c,473 :: 		case 0:  // Stored mode
L_atVerify38:
;atca_command.c,474 :: 		packet->txsize = VERIFY_256_STORED_COUNT;
ADD	R3, R10, #1
MOVS	R2, #71
STRB	R2, [R3, #0]
;atca_command.c,475 :: 		break;
IT	AL
BAL	L_atVerify37
;atca_command.c,476 :: 		case 1:  // ValidateExternal mode
L_atVerify39:
;atca_command.c,477 :: 		packet->txsize = VERIFY_256_EXTERNAL_COUNT;
ADD	R3, R10, #1
MOVS	R2, #135
STRB	R2, [R3, #0]
;atca_command.c,478 :: 		break;
IT	AL
BAL	L_atVerify37
;atca_command.c,479 :: 		case 2:  // External mode
L_atVerify40:
;atca_command.c,480 :: 		packet->txsize = VERIFY_256_EXTERNAL_COUNT;
ADD	R3, R10, #1
MOVS	R2, #135
STRB	R2, [R3, #0]
;atca_command.c,481 :: 		break;
IT	AL
BAL	L_atVerify37
;atca_command.c,482 :: 		case 3:     // Validate mode
L_atVerify41:
;atca_command.c,483 :: 		case 7:     // Invalidate mode
L_atVerify42:
;atca_command.c,484 :: 		packet->txsize = VERIFY_256_VALIDATE_COUNT;
ADD	R3, R10, #1
MOVS	R2, #90
STRB	R2, [R3, #0]
;atca_command.c,485 :: 		break;
IT	AL
BAL	L_atVerify37
; packet end address is: 40 (R10)
;atca_command.c,486 :: 		default:
L_atVerify43:
;atca_command.c,487 :: 		return ATCA_BAD_PARAM;
MOVS	R0, #226
IT	AL
BAL	L_end_atVerify
;atca_command.c,488 :: 		}
L_atVerify36:
; packet start address is: 40 (R10)
LDRB	R2, [R4, #0]
CMP	R2, #0
IT	EQ
BEQ	L_atVerify38
LDRB	R2, [R4, #0]
CMP	R2, #1
IT	EQ
BEQ	L_atVerify39
LDRB	R2, [R4, #0]
CMP	R2, #2
IT	EQ
BEQ	L_atVerify40
LDRB	R2, [R4, #0]
CMP	R2, #3
IT	EQ
BEQ	L_atVerify41
LDRB	R2, [R4, #0]
CMP	R2, #7
IT	EQ
BEQ	L_atVerify42
; packet end address is: 40 (R10)
IT	AL
BAL	L_atVerify43
L_atVerify37:
;atca_command.c,489 :: 		packet->rxsize = VERIFY_RSP_SIZE;
; packet start address is: 40 (R10)
ADD	R3, R10, #138
MOVS	R2, #4
STRH	R2, [R3, #0]
;atca_command.c,491 :: 		atCalcCrc( packet );
MOV	R0, R10
; packet end address is: 40 (R10)
BL	_atCalcCrc+0
;atca_command.c,492 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_command.c,493 :: 		}
L_end_atVerify:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atVerify
_atWrite:
;atca_command.c,500 :: 		ATCA_STATUS atWrite( ATCACommand cacmd, ATCAPacket *packet )
; packet start address is: 4 (R1)
SUB	SP, SP, #4
STR	LR, [SP, #0]
MOV	R10, R1
; packet end address is: 4 (R1)
; packet start address is: 40 (R10)
;atca_command.c,506 :: 		packet->opcode = ATCA_WRITE;
ADD	R3, R10, #2
MOVS	R2, #18
STRB	R2, [R3, #0]
;atca_command.c,508 :: 		macsize = ( packet->param1 & 0x40 ? 32 : 0 );  // if encrypted, use MAC
ADD	R2, R10, #3
LDRB	R2, [R2, #0]
AND	R2, R2, #64
UXTB	R2, R2
CMP	R2, #0
IT	EQ
BEQ	L_atWrite44
; ?FLOC___atWrite?T473 start address is: 4 (R1)
MOVS	R1, #32
SXTB	R1, R1
; ?FLOC___atWrite?T473 end address is: 4 (R1)
IT	AL
BAL	L_atWrite45
L_atWrite44:
; ?FLOC___atWrite?T473 start address is: 4 (R1)
MOVS	R1, #0
SXTB	R1, R1
; ?FLOC___atWrite?T473 end address is: 4 (R1)
L_atWrite45:
; ?FLOC___atWrite?T473 start address is: 4 (R1)
; macsize start address is: 0 (R0)
SXTB	R0, R1
; ?FLOC___atWrite?T473 end address is: 4 (R1)
;atca_command.c,509 :: 		writesize = ( packet->param1 & 0x80 ? 32 : 4 );
ADD	R2, R10, #3
LDRB	R2, [R2, #0]
AND	R2, R2, #128
UXTB	R2, R2
CMP	R2, #0
IT	EQ
BEQ	L_atWrite46
; ?FLOC___atWrite?T480 start address is: 8 (R2)
MOVS	R2, #32
SXTB	R2, R2
; ?FLOC___atWrite?T480 end address is: 8 (R2)
IT	AL
BAL	L_atWrite47
L_atWrite46:
; ?FLOC___atWrite?T480 start address is: 8 (R2)
MOVS	R2, #4
SXTB	R2, R2
; ?FLOC___atWrite?T480 end address is: 8 (R2)
L_atWrite47:
; ?FLOC___atWrite?T480 start address is: 8 (R2)
; writesize start address is: 4 (R1)
SXTB	R1, R2
; ?FLOC___atWrite?T480 end address is: 8 (R2)
;atca_command.c,511 :: 		if ( macsize == 32 && writesize == 32 )
CMP	R0, #32
IT	NE
BNE	L__atWrite121
CMP	R1, #32
IT	NE
BNE	L__atWrite120
; macsize end address is: 0 (R0)
; writesize end address is: 4 (R1)
L__atWrite119:
;atca_command.c,512 :: 		packet->txsize = WRITE_COUNT_LONG_MAC;
ADD	R3, R10, #1
MOVS	R2, #71
STRB	R2, [R3, #0]
IT	AL
BAL	L_atWrite51
;atca_command.c,511 :: 		if ( macsize == 32 && writesize == 32 )
L__atWrite121:
; writesize start address is: 4 (R1)
; macsize start address is: 0 (R0)
L__atWrite120:
;atca_command.c,513 :: 		else if ( macsize == 32 && writesize == 4 )
CMP	R0, #32
IT	NE
BNE	L__atWrite123
CMP	R1, #4
IT	NE
BNE	L__atWrite122
; macsize end address is: 0 (R0)
; writesize end address is: 4 (R1)
L__atWrite118:
;atca_command.c,514 :: 		packet->txsize = WRITE_COUNT_SHORT_MAC;
ADD	R3, R10, #1
MOVS	R2, #43
STRB	R2, [R3, #0]
IT	AL
BAL	L_atWrite55
;atca_command.c,513 :: 		else if ( macsize == 32 && writesize == 4 )
L__atWrite123:
; writesize start address is: 4 (R1)
; macsize start address is: 0 (R0)
L__atWrite122:
;atca_command.c,515 :: 		else if ( macsize == 0 && writesize == 32 )
CMP	R0, #0
IT	NE
BNE	L__atWrite125
CMP	R1, #32
IT	NE
BNE	L__atWrite124
; macsize end address is: 0 (R0)
; writesize end address is: 4 (R1)
L__atWrite117:
;atca_command.c,516 :: 		packet->txsize = WRITE_COUNT_LONG;
ADD	R3, R10, #1
MOVS	R2, #39
STRB	R2, [R3, #0]
IT	AL
BAL	L_atWrite59
;atca_command.c,515 :: 		else if ( macsize == 0 && writesize == 32 )
L__atWrite125:
; writesize start address is: 4 (R1)
; macsize start address is: 0 (R0)
L__atWrite124:
;atca_command.c,517 :: 		else if ( macsize == 0 && writesize == 4 )
CMP	R0, #0
IT	NE
BNE	L__atWrite127
; macsize end address is: 0 (R0)
CMP	R1, #4
IT	NE
BNE	L__atWrite126
; writesize end address is: 4 (R1)
L__atWrite116:
;atca_command.c,518 :: 		packet->txsize = WRITE_COUNT_SHORT;
ADD	R3, R10, #1
MOVS	R2, #11
STRB	R2, [R3, #0]
;atca_command.c,517 :: 		else if ( macsize == 0 && writesize == 4 )
L__atWrite127:
L__atWrite126:
;atca_command.c,518 :: 		packet->txsize = WRITE_COUNT_SHORT;
L_atWrite59:
L_atWrite55:
L_atWrite51:
;atca_command.c,520 :: 		packet->rxsize = WRITE_RSP_SIZE;
ADD	R3, R10, #138
MOVS	R2, #4
STRH	R2, [R3, #0]
;atca_command.c,521 :: 		atCalcCrc( packet );
MOV	R0, R10
; packet end address is: 40 (R10)
BL	_atCalcCrc+0
;atca_command.c,522 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_command.c,523 :: 		}
L_end_atWrite:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atWrite
_atWriteEnc:
;atca_command.c,530 :: 		ATCA_STATUS atWriteEnc(ATCACommand cacmd, ATCAPacket *packet)
; packet start address is: 4 (R1)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; packet end address is: 4 (R1)
; packet start address is: 4 (R1)
;atca_command.c,533 :: 		packet->opcode = ATCA_WRITE;
ADDS	R3, R1, #2
MOVS	R2, #18
STRB	R2, [R3, #0]
;atca_command.c,534 :: 		packet->txsize = WRITE_COUNT_LONG_MAC;
ADDS	R3, R1, #1
MOVS	R2, #71
STRB	R2, [R3, #0]
;atca_command.c,535 :: 		packet->rxsize = WRITE_RSP_SIZE;
ADDW	R3, R1, #138
MOVS	R2, #4
STRH	R2, [R3, #0]
;atca_command.c,536 :: 		atCalcCrc( packet );
MOV	R0, R1
; packet end address is: 4 (R1)
BL	_atCalcCrc+0
;atca_command.c,537 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_command.c,538 :: 		}
L_end_atWriteEnc:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atWriteEnc
_deleteATCACommand:
;atca_command.c,544 :: 		void deleteATCACommand( ATCACommand *cacmd )  // destructor
; cacmd start address is: 0 (R0)
SUB	SP, SP, #8
STR	LR, [SP, #0]
; cacmd end address is: 0 (R0)
; cacmd start address is: 0 (R0)
;atca_command.c,546 :: 		if ( *cacmd )
LDR	R1, [R0, #0]
CMP	R1, #0
IT	EQ
BEQ	L_deleteATCACommand63
;atca_command.c,547 :: 		Free((void*)*cacmd,sizeof(*cacmd));
LDR	R1, [R0, #0]
STR	R0, [SP, #4]
MOV	R0, R1
MOVS	R1, #4
BL	_Free+0
LDR	R0, [SP, #4]
L_deleteATCACommand63:
;atca_command.c,549 :: 		*cacmd = NULL;
MOVS	R1, #0
STR	R1, [R0, #0]
; cacmd end address is: 0 (R0)
;atca_command.c,550 :: 		}
L_end_deleteATCACommand:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _deleteATCACommand
_atInitExecTimes:
;atca_command.c,613 :: 		ATCA_STATUS atInitExecTimes(ATCACommand cacmd, ATCADeviceType device_type)
; device_type start address is: 4 (R1)
; cacmd start address is: 0 (R0)
; device_type end address is: 4 (R1)
; cacmd end address is: 0 (R0)
; cacmd start address is: 0 (R0)
; device_type start address is: 4 (R1)
;atca_command.c,615 :: 		switch ( device_type ) {
IT	AL
BAL	L_atInitExecTimes64
; device_type end address is: 4 (R1)
;atca_command.c,616 :: 		case ATECC108A:
L_atInitExecTimes66:
;atca_command.c,617 :: 		case ATECC508A:
L_atInitExecTimes67:
;atca_command.c,618 :: 		cacmd->execution_times = exectimes_x08a;
ADDS	R3, R0, #4
; cacmd end address is: 0 (R0)
MOVW	R2, #lo_addr(_exectimes_x08a+0)
MOVT	R2, #hi_addr(_exectimes_x08a+0)
STR	R2, [R3, #0]
;atca_command.c,619 :: 		break;
IT	AL
BAL	L_atInitExecTimes65
;atca_command.c,620 :: 		case ATSHA204A:
L_atInitExecTimes68:
;atca_command.c,621 :: 		cacmd->execution_times = exectimes_204a;
; cacmd start address is: 0 (R0)
ADDS	R3, R0, #4
; cacmd end address is: 0 (R0)
MOVW	R2, #lo_addr(_exectimes_204a+0)
MOVT	R2, #hi_addr(_exectimes_204a+0)
STR	R2, [R3, #0]
;atca_command.c,622 :: 		break;
IT	AL
BAL	L_atInitExecTimes65
;atca_command.c,623 :: 		default:
L_atInitExecTimes69:
;atca_command.c,624 :: 		return ATCA_BAD_PARAM;
MOVS	R0, #226
IT	AL
BAL	L_end_atInitExecTimes
;atca_command.c,626 :: 		}
L_atInitExecTimes64:
; device_type start address is: 4 (R1)
; cacmd start address is: 0 (R0)
CMP	R1, #1
IT	EQ
BEQ	L_atInitExecTimes66
CMP	R1, #2
IT	EQ
BEQ	L_atInitExecTimes67
CMP	R1, #0
IT	EQ
BEQ	L_atInitExecTimes68
; cacmd end address is: 0 (R0)
; device_type end address is: 4 (R1)
IT	AL
BAL	L_atInitExecTimes69
L_atInitExecTimes65:
;atca_command.c,628 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_command.c,629 :: 		}
L_end_atInitExecTimes:
BX	LR
; end of _atInitExecTimes
_atGetExecTime:
;atca_command.c,638 :: 		uint16_t atGetExecTime( ATCACommand cacmd, ATCA_CmdMap cmd )
; cmd start address is: 4 (R1)
; cacmd start address is: 0 (R0)
; cmd end address is: 4 (R1)
; cacmd end address is: 0 (R0)
; cacmd start address is: 0 (R0)
; cmd start address is: 4 (R1)
;atca_command.c,640 :: 		return cacmd->execution_times[cmd];
ADDS	R2, R0, #4
; cacmd end address is: 0 (R0)
LDR	R3, [R2, #0]
LSLS	R2, R1, #1
; cmd end address is: 4 (R1)
ADDS	R2, R3, R2
LDRH	R2, [R2, #0]
UXTH	R0, R2
;atca_command.c,641 :: 		}
L_end_atGetExecTime:
BX	LR
; end of _atGetExecTime
_atCRC:
;atca_command.c,651 :: 		void atCRC( uint8_t length, uint8_t *data, uint8_t *crc)
; crc start address is: 8 (R2)
; _data start address is: 4 (R1)
; length start address is: 0 (R0)
; crc end address is: 8 (R2)
; _data end address is: 4 (R1)
; length end address is: 0 (R0)
; length start address is: 0 (R0)
; _data start address is: 4 (R1)
; crc start address is: 8 (R2)
;atca_command.c,654 :: 		uint16_t crc_register = 0;
; crc_register start address is: 32 (R8)
MOVW	R8, #0
;atca_command.c,655 :: 		uint16_t polynom = 0x8005;
; polynom start address is: 20 (R5)
MOVW	R5, #32773
;atca_command.c,659 :: 		for (counter = 0; counter < length; counter++) {
; counter start address is: 24 (R6)
MOVS	R6, #0
; length end address is: 0 (R0)
; _data end address is: 4 (R1)
; crc end address is: 8 (R2)
; polynom end address is: 20 (R5)
; crc_register end address is: 32 (R8)
; counter end address is: 24 (R6)
L_atCRC70:
; counter start address is: 24 (R6)
; polynom start address is: 20 (R5)
; crc_register start address is: 32 (R8)
; crc start address is: 8 (R2)
; _data start address is: 4 (R1)
; length start address is: 0 (R0)
CMP	R6, R0
IT	CS
BCS	L_atCRC71
;atca_command.c,660 :: 		for (shift_register = 0x01; shift_register > 0x00; shift_register <<= 1) {
; shift_register start address is: 28 (R7)
MOVS	R7, #1
; length end address is: 0 (R0)
; _data end address is: 4 (R1)
; crc end address is: 8 (R2)
; polynom end address is: 20 (R5)
; crc_register end address is: 32 (R8)
; shift_register end address is: 28 (R7)
; counter end address is: 24 (R6)
L_atCRC73:
; shift_register start address is: 28 (R7)
; length start address is: 0 (R0)
; _data start address is: 4 (R1)
; crc start address is: 8 (R2)
; crc_register start address is: 32 (R8)
; polynom start address is: 20 (R5)
; counter start address is: 24 (R6)
CMP	R7, #0
IT	LS
BLS	L_atCRC74
;atca_command.c,661 :: 		data_bit = (data[counter] & shift_register) ? 1 : 0;
ADDS	R3, R1, R6
LDRB	R3, [R3, #0]
ANDS	R3, R7
UXTB	R3, R3
CMP	R3, #0
IT	EQ
BEQ	L_atCRC76
; ?FLOC___atCRC?T563 start address is: 36 (R9)
MOVW	R9, #1
SXTB	R9, R9
; ?FLOC___atCRC?T563 end address is: 36 (R9)
IT	AL
BAL	L_atCRC77
L_atCRC76:
; ?FLOC___atCRC?T563 start address is: 36 (R9)
MOVW	R9, #0
SXTB	R9, R9
; ?FLOC___atCRC?T563 end address is: 36 (R9)
L_atCRC77:
;atca_command.c,662 :: 		crc_bit = crc_register >> 15;
; ?FLOC___atCRC?T563 start address is: 36 (R9)
LSR	R4, R8, #15
;atca_command.c,663 :: 		crc_register <<= 1;
LSL	R8, R8, #1
UXTH	R8, R8
;atca_command.c,664 :: 		if (data_bit != crc_bit)
UXTB	R4, R4
UXTB	R3, R9
; ?FLOC___atCRC?T563 end address is: 36 (R9)
CMP	R3, R4
IT	EQ
BEQ	L__atCRC106
;atca_command.c,665 :: 		crc_register ^= polynom;
EOR	R8, R8, R5, LSL #0
UXTH	R8, R8
; crc_register end address is: 32 (R8)
IT	AL
BAL	L_atCRC78
L__atCRC106:
;atca_command.c,664 :: 		if (data_bit != crc_bit)
;atca_command.c,665 :: 		crc_register ^= polynom;
L_atCRC78:
;atca_command.c,660 :: 		for (shift_register = 0x01; shift_register > 0x00; shift_register <<= 1) {
; crc_register start address is: 32 (R8)
LSLS	R3, R7, #1
UXTB	R7, R3
;atca_command.c,666 :: 		}
; shift_register end address is: 28 (R7)
IT	AL
BAL	L_atCRC73
L_atCRC74:
;atca_command.c,659 :: 		for (counter = 0; counter < length; counter++) {
ADDS	R6, R6, #1
UXTB	R6, R6
;atca_command.c,667 :: 		}
; length end address is: 0 (R0)
; _data end address is: 4 (R1)
; polynom end address is: 20 (R5)
; counter end address is: 24 (R6)
IT	AL
BAL	L_atCRC70
L_atCRC71:
;atca_command.c,668 :: 		crc[0] = (uint8_t)(crc_register & 0x00FF);
AND	R3, R8, #255
UXTB	R3, R3
STRB	R3, [R2, #0]
;atca_command.c,669 :: 		crc[1] = (uint8_t)(crc_register >> 8);
ADDS	R4, R2, #1
; crc end address is: 8 (R2)
LSR	R3, R8, #8
; crc_register end address is: 32 (R8)
UXTB	R3, R3
STRB	R3, [R4, #0]
;atca_command.c,670 :: 		}
L_end_atCRC:
BX	LR
; end of _atCRC
_atCalcCrc:
;atca_command.c,677 :: 		void atCalcCrc( ATCAPacket *packet )
; packet start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; packet end address is: 0 (R0)
; packet start address is: 0 (R0)
;atca_command.c,681 :: 		length = packet->txsize - ATCA_CRC_SIZE;
ADDS	R3, R0, #1
; packet end address is: 0 (R0)
LDRB	R1, [R3, #0]
SUBS	R2, R1, #2
SXTH	R2, R2
;atca_command.c,683 :: 		crc = &(packet->txsize) + length;
UXTB	R1, R2
ADDS	R1, R3, R1
;atca_command.c,686 :: 		atCRC(length, &(packet->txsize), crc);
UXTB	R0, R2
MOV	R2, R1
MOV	R1, R3
BL	_atCRC+0
;atca_command.c,687 :: 		}
L_end_atCalcCrc:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atCalcCrc
_atCheckCrc:
;atca_command.c,695 :: 		uint8_t atCheckCrc(uint8_t *response)
; response start address is: 0 (R0)
SUB	SP, SP, #8
STR	LR, [SP, #0]
MOV	R10, R0
; response end address is: 0 (R0)
; response start address is: 40 (R10)
;atca_command.c,698 :: 		uint8_t count = response[ATCA_COUNT_IDX];
LDRB	R1, [R10, #0]
;atca_command.c,700 :: 		count -= ATCA_CRC_SIZE;
SUBS	R2, R1, #2
; count start address is: 44 (R11)
UXTB	R11, R2
;atca_command.c,701 :: 		atCRC(count, response, crc);
ADD	R1, SP, #4
UXTB	R0, R2
MOV	R2, R1
MOV	R1, R10
BL	_atCRC+0
;atca_command.c,703 :: 		return (crc[0] == response[count] && crc[1] == response[count + 1]) ? ATCA_SUCCESS : ATCA_RX_CRC_ERROR;
ADD	R1, SP, #4
LDRB	R2, [R1, #0]
ADD	R1, R10, R11, LSL #0
LDRB	R1, [R1, #0]
CMP	R2, R1
IT	NE
BNE	L__atCheckCrc130
ADD	R1, SP, #4
ADDS	R3, R1, #1
ADD	R1, R11, #1
SXTH	R1, R1
; count end address is: 44 (R11)
ADD	R1, R10, R1, LSL #0
; response end address is: 40 (R10)
LDRB	R2, [R1, #0]
LDRB	R1, [R3, #0]
CMP	R1, R2
IT	NE
BNE	L__atCheckCrc129
L__atCheckCrc128:
; ?FLOC___atCheckCrc?T620 start address is: 0 (R0)
MOVS	R0, #0
; ?FLOC___atCheckCrc?T620 end address is: 0 (R0)
IT	AL
BAL	L_atCheckCrc82
L__atCheckCrc130:
L__atCheckCrc129:
; ?FLOC___atCheckCrc?T620 start address is: 0 (R0)
MOVS	R0, #229
; ?FLOC___atCheckCrc?T620 end address is: 0 (R0)
L_atCheckCrc82:
; ?FLOC___atCheckCrc?T620 start address is: 0 (R0)
; ?FLOC___atCheckCrc?T620 end address is: 0 (R0)
;atca_command.c,704 :: 		}
L_end_atCheckCrc:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _atCheckCrc
_atIsSHAFamily:
;atca_command.c,712 :: 		bool atIsSHAFamily( ATCADeviceType deviceType )
; deviceType start address is: 0 (R0)
; deviceType end address is: 0 (R0)
; deviceType start address is: 0 (R0)
;atca_command.c,714 :: 		switch (deviceType) {
IT	AL
BAL	L_atIsSHAFamily83
; deviceType end address is: 0 (R0)
;atca_command.c,715 :: 		case ATSHA204A:
L_atIsSHAFamily85:
;atca_command.c,716 :: 		case ATECC108A:
L_atIsSHAFamily86:
;atca_command.c,717 :: 		case ATECC508A:
L_atIsSHAFamily87:
;atca_command.c,718 :: 		return true;
MOVS	R0, #1
IT	AL
BAL	L_end_atIsSHAFamily
;atca_command.c,720 :: 		default:
L_atIsSHAFamily88:
;atca_command.c,721 :: 		return false;
MOVS	R0, #0
IT	AL
BAL	L_end_atIsSHAFamily
;atca_command.c,723 :: 		}
L_atIsSHAFamily83:
; deviceType start address is: 0 (R0)
CMP	R0, #0
IT	EQ
BEQ	L_atIsSHAFamily85
CMP	R0, #1
IT	EQ
BEQ	L_atIsSHAFamily86
CMP	R0, #2
IT	EQ
BEQ	L_atIsSHAFamily87
; deviceType end address is: 0 (R0)
IT	AL
BAL	L_atIsSHAFamily88
;atca_command.c,724 :: 		}
L_end_atIsSHAFamily:
BX	LR
; end of _atIsSHAFamily
_atIsECCFamily:
;atca_command.c,731 :: 		bool atIsECCFamily( ATCADeviceType deviceType )
; deviceType start address is: 0 (R0)
; deviceType end address is: 0 (R0)
; deviceType start address is: 0 (R0)
;atca_command.c,733 :: 		switch (deviceType) {
IT	AL
BAL	L_atIsECCFamily89
; deviceType end address is: 0 (R0)
;atca_command.c,734 :: 		case ATECC108A:
L_atIsECCFamily91:
;atca_command.c,735 :: 		case ATECC508A:
L_atIsECCFamily92:
;atca_command.c,736 :: 		return true;
MOVS	R0, #1
IT	AL
BAL	L_end_atIsECCFamily
;atca_command.c,738 :: 		default:
L_atIsECCFamily93:
;atca_command.c,739 :: 		return false;
MOVS	R0, #0
IT	AL
BAL	L_end_atIsECCFamily
;atca_command.c,741 :: 		}
L_atIsECCFamily89:
; deviceType start address is: 0 (R0)
CMP	R0, #1
IT	EQ
BEQ	L_atIsECCFamily91
CMP	R0, #2
IT	EQ
BEQ	L_atIsECCFamily92
; deviceType end address is: 0 (R0)
IT	AL
BAL	L_atIsECCFamily93
;atca_command.c,742 :: 		}
L_end_atIsECCFamily:
BX	LR
; end of _atIsECCFamily
_isATCAError:
;atca_command.c,749 :: 		ATCA_STATUS isATCAError( uint8_t *data )
; _data start address is: 0 (R0)
SUB	SP, SP, #8
STR	LR, [SP, #0]
MOV	R5, R0
; _data end address is: 0 (R0)
; _data start address is: 20 (R5)
;atca_command.c,751 :: 		uint8_t good[4] = { 0x04, 0x00, 0x03, 0x40 };
MOVS	R1, #4
STRB	R1, [SP, #4]
MOVS	R1, #0
STRB	R1, [SP, #5]
MOVS	R1, #3
STRB	R1, [SP, #6]
MOVS	R1, #64
STRB	R1, [SP, #7]
;atca_command.c,753 :: 		if ( memcmp( data, good, 4 ) == 0 )
ADD	R1, SP, #4
MOVS	R2, #4
SXTH	R2, R2
MOV	R0, R5
BL	_memcmp+0
CMP	R0, #0
IT	NE
BNE	L_isATCAError94
; _data end address is: 20 (R5)
;atca_command.c,754 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
IT	AL
BAL	L_end_isATCAError
L_isATCAError94:
;atca_command.c,756 :: 		if ( data[0] == 0x04 ) {    // error packets are always 4 bytes long
; _data start address is: 20 (R5)
LDRB	R1, [R5, #0]
CMP	R1, #4
IT	NE
BNE	L_isATCAError95
;atca_command.c,757 :: 		switch ( data[1] ) {
ADDS	R2, R5, #1
; _data end address is: 20 (R5)
IT	AL
BAL	L_isATCAError96
;atca_command.c,758 :: 		case 0x01:              // checkmac or verify failed
L_isATCAError98:
;atca_command.c,759 :: 		return ATCA_CHECKMAC_VERIFY_FAILED;
MOVS	R0, #209
IT	AL
BAL	L_end_isATCAError
;atca_command.c,761 :: 		case 0x03: // command received byte length, opcode or parameter was illegal
L_isATCAError99:
;atca_command.c,762 :: 		return ATCA_BAD_OPCODE;
MOVS	R0, #242
IT	AL
BAL	L_end_isATCAError
;atca_command.c,764 :: 		case 0x0f: // chip can't execute the command
L_isATCAError100:
;atca_command.c,765 :: 		return ATCA_EXECUTION_ERROR;
MOVS	R0, #244
IT	AL
BAL	L_end_isATCAError
;atca_command.c,767 :: 		case 0x11: // chip was successfully woken up
L_isATCAError101:
;atca_command.c,768 :: 		return ATCA_WAKE_SUCCESS;
MOVS	R0, #243
IT	AL
BAL	L_end_isATCAError
;atca_command.c,770 :: 		case 0xff: // bad crc found or other comm error
L_isATCAError102:
;atca_command.c,771 :: 		return ATCA_STATUS_CRC;
MOVS	R0, #212
IT	AL
BAL	L_end_isATCAError
;atca_command.c,773 :: 		default:
L_isATCAError103:
;atca_command.c,774 :: 		return ATCA_GEN_FAIL;
MOVS	R0, #225
IT	AL
BAL	L_end_isATCAError
;atca_command.c,776 :: 		}
L_isATCAError96:
LDRB	R1, [R2, #0]
CMP	R1, #1
IT	EQ
BEQ	L_isATCAError98
LDRB	R1, [R2, #0]
CMP	R1, #3
IT	EQ
BEQ	L_isATCAError99
LDRB	R1, [R2, #0]
CMP	R1, #15
IT	EQ
BEQ	L_isATCAError100
LDRB	R1, [R2, #0]
CMP	R1, #17
IT	EQ
BEQ	L_isATCAError101
LDRB	R1, [R2, #0]
CMP	R1, #255
IT	EQ
BEQ	L_isATCAError102
IT	AL
BAL	L_isATCAError103
;atca_command.c,777 :: 		} else
L_isATCAError95:
;atca_command.c,778 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_command.c,779 :: 		}
L_end_isATCAError:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _isATCAError
