#line 1 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atcacert/atcacert_def.c"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stddef.h"



typedef long ptrdiff_t;


 typedef unsigned long size_t;

typedef unsigned long wchar_t;
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stddef.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_date.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert.h"
#line 58 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_date.h"
typedef struct atcacert_tm_utc_s {
 int tm_sec;
 int tm_min;
 int tm_hour;
 int tm_mday;
 int tm_mon;
 int tm_year;
} atcacert_tm_utc_t;
#line 70 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_date.h"
typedef enum atcacert_date_format_e {
 DATEFMT_ISO8601_SEP,
 DATEFMT_RFC5280_UTC,
 DATEFMT_POSIX_UINT32_BE,
 DATEFMT_POSIX_UINT32_LE,
 DATEFMT_RFC5280_GEN
} atcacert_date_format_t;








static size_t ATCACERT_DATE_FORMAT_SIZES[] = {
  (20) ,
  (13) ,
  (4) ,
  (4) ,
  (15) 
};
#line 109 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_date.h"
int atcacert_date_enc( atcacert_date_format_t format,
 atcacert_tm_utc_t* timestamp,
 uint8_t* formatted_date,
 size_t* formatted_date_size);
#line 124 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_date.h"
int atcacert_date_dec( atcacert_date_format_t format,
 uint8_t* formatted_date,
 size_t formatted_date_size,
 atcacert_tm_utc_t* timestamp);
#line 140 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_date.h"
int atcacert_date_enc_compcert( atcacert_tm_utc_t * issue_date,
 uint8_t expire_years,
 uint8_t enc_dates[3]);
#line 157 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_date.h"
int atcacert_date_dec_compcert( uint8_t enc_dates[3],
 atcacert_date_format_t expire_date_format,
 atcacert_tm_utc_t* issue_date,
 atcacert_tm_utc_t* expire_date);
#line 170 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_date.h"
int atcacert_date_get_max_date( atcacert_date_format_t format, atcacert_tm_utc_t* timestamp );

int atcacert_date_enc_iso8601_sep( atcacert_tm_utc_t * timestamp,
 uint8_t formatted_date[ (20) ]);

int atcacert_date_dec_iso8601_sep( uint8_t formatted_date[ (20) ],
 atcacert_tm_utc_t* timestamp);

int atcacert_date_enc_rfc5280_utc( atcacert_tm_utc_t * timestamp,
 uint8_t formatted_date[ (13) ]);

int atcacert_date_dec_rfc5280_utc( uint8_t formatted_date[ (13) ],
 atcacert_tm_utc_t* timestamp);

int atcacert_date_enc_rfc5280_gen( atcacert_tm_utc_t * timestamp,
 uint8_t formatted_date[ (15) ]);

int atcacert_date_dec_rfc5280_gen( uint8_t formatted_date[ (15) ],
 atcacert_tm_utc_t* timestamp);

int atcacert_date_enc_posix_uint32_be( atcacert_tm_utc_t * timestamp,
 uint8_t formatted_date[ (4) ]);

int atcacert_date_dec_posix_uint32_be( uint8_t formatted_date[ (4) ],
 atcacert_tm_utc_t* timestamp);

int atcacert_date_enc_posix_uint32_le( atcacert_tm_utc_t * timestamp,
 uint8_t formatted_date[ (4) ]);

int atcacert_date_dec_posix_uint32_le( uint8_t formatted_date[ (4) ],
 atcacert_tm_utc_t* timestamp);
#line 72 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
typedef enum atcacert_cert_type_e {
 CERTTYPE_X509,
 CERTTYPE_CUSTOM
} atcacert_cert_type_t;
#line 80 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
typedef enum atcacert_cert_sn_src_e {
 SNSRC_STORED = 0x0,
 SNSRC_DEVICE_SN = 0x8,
 SNSRC_SIGNER_ID = 0x9,
 SNSRC_PUB_KEY_HASH = 0xA,
 SNSRC_DEVICE_SN_HASH = 0xB,
 SNSRC_PUB_KEY_HASH_POS = 0xC,
 SNSRC_DEVICE_SN_HASH_POS = 0xD,
 SNSRC_PUB_KEY_HASH_RAW = 0xE,
 SNSRC_DEVICE_SN_HASH_RAW = 0xF
} atcacert_cert_sn_src_t;
#line 95 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
typedef enum atcacert_device_zone_e {
 DEVZONE_CONFIG = 0x00,
 DEVZONE_OTP = 0x01,
 DEVZONE_DATA = 0x02,
 DEVZONE_NONE = 0x07
} atcacert_device_zone_t;
#line 105 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
typedef enum atcacert_std_cert_element_e {
 STDCERT_PUBLIC_KEY,
 STDCERT_SIGNATURE,
 STDCERT_ISSUE_DATE,
 STDCERT_EXPIRE_DATE,
 STDCERT_SIGNER_ID,
 STDCERT_CERT_SN,
 STDCERT_AUTH_KEY_ID,
 STDCERT_SUBJ_KEY_ID,
 STDCERT_NUM_ELEMENTS
} atcacert_std_cert_element_t;
#pragma pack(push, 1)
#line 123 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
typedef struct atcacert_device_loc_s {
 atcacert_device_zone_t zone;
 uint8_t slot;
 uint8_t is_genkey;
 uint16_t offset;
 uint16_t count;
} atcacert_device_loc_t;
#line 134 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
typedef struct atcacert_cert_loc_s {
 uint16_t offset;
 uint16_t count;
} atcacert_cert_loc_t;
#line 142 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
typedef struct atcacert_cert_element_s {
 char id[16];
 atcacert_device_loc_t device_loc;
 atcacert_cert_loc_t cert_loc;
} atcacert_cert_element_t;
#line 154 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
typedef struct atcacert_def_s {
 atcacert_cert_type_t type;
 uint8_t template_id;
 uint8_t chain_id;
 uint8_t private_key_slot;
 atcacert_cert_sn_src_t sn_source;
 atcacert_device_loc_t cert_sn_dev_loc;
 atcacert_date_format_t issue_date_format;
 atcacert_date_format_t expire_date_format;
 atcacert_cert_loc_t tbs_cert_loc;
 uint8_t expire_years;
 atcacert_device_loc_t public_key_dev_loc;
 atcacert_device_loc_t comp_cert_dev_loc;
 atcacert_cert_loc_t std_cert_elements[STDCERT_NUM_ELEMENTS];
 atcacert_cert_element_t* cert_elements;
 uint8_t cert_elements_count;
 uint8_t* cert_template;
 uint16_t cert_template_size;
} atcacert_def_t;
#line 177 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
typedef struct atcacert_build_state_s {
 atcacert_def_t* cert_def;
 uint8_t* cert;
 size_t* cert_size;
 size_t max_cert_size;
 uint8_t is_device_sn;
 uint8_t device_sn[9];
} atcacert_build_state_t;
#pragma pack(pop)
#line 212 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_get_device_locs( atcacert_def_t* cert_def,
 atcacert_device_loc_t* device_locs,
 size_t* device_locs_count,
 size_t device_locs_max_count,
 size_t block_size);
#line 233 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_cert_build_start( atcacert_build_state_t* build_state,
 atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t* cert_size,
 uint8_t ca_public_key[64]);
#line 251 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_cert_build_process( atcacert_build_state_t* build_state,
 atcacert_device_loc_t* device_loc,
 uint8_t* device_data);
#line 267 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_cert_build_finish( atcacert_build_state_t* build_state );
#line 286 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_get_device_data( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 atcacert_device_loc_t* device_loc,
 uint8_t* device_data);
#line 302 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_set_subj_public_key( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 uint8_t subj_public_key[64]);
#line 318 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_get_subj_public_key( atcacert_def_t * cert_def,
 uint8_t * cert,
 size_t cert_size,
 uint8_t subj_public_key[64]);
#line 333 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_get_subj_key_id( atcacert_def_t * cert_def,
 uint8_t * cert,
 size_t cert_size,
 uint8_t subj_key_id[20]);
#line 350 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_set_signature( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t* cert_size,
 size_t max_cert_size,
 uint8_t signature[64]);
#line 367 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_get_signature( atcacert_def_t * cert_def,
 uint8_t * cert,
 size_t cert_size,
 uint8_t signature[64]);
#line 383 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_set_issue_date( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 atcacert_tm_utc_t* timestamp);
#line 399 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_get_issue_date( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 atcacert_tm_utc_t* timestamp);
#line 415 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_set_expire_date( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 atcacert_tm_utc_t* timestamp);
#line 431 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_get_expire_date( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 atcacert_tm_utc_t* timestamp);
#line 446 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_set_signer_id( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 uint8_t signer_id[2]);
#line 461 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_get_signer_id( atcacert_def_t * cert_def,
 uint8_t * cert,
 size_t cert_size,
 uint8_t signer_id[2]);
#line 477 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_set_cert_sn( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 uint8_t* cert_sn,
 size_t cert_sn_size);
#line 500 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_gen_cert_sn( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 uint8_t device_sn[9]);
#line 517 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_get_cert_sn( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 uint8_t* cert_sn,
 size_t* cert_sn_size);
#line 535 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_set_auth_key_id( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 uint8_t auth_public_key[64]);
#line 550 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_get_auth_key_id( atcacert_def_t * cert_def,
 uint8_t * cert,
 size_t cert_size,
 uint8_t auth_key_id[20]);
#line 570 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_set_comp_cert( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t* cert_size,
 size_t max_cert_size,
 uint8_t comp_cert[72]);
#line 586 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_get_comp_cert( atcacert_def_t * cert_def,
 uint8_t * cert,
 size_t cert_size,
 uint8_t comp_cert[72]);
#line 602 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_get_tbs( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 uint8_t** tbs,
 size_t* tbs_size);
#line 618 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_get_tbs_digest( atcacert_def_t * cert_def,
 uint8_t * cert,
 size_t cert_size,
 uint8_t tbs_digest[32]);
#line 635 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_set_cert_element( atcacert_cert_loc_t* cert_loc,
 uint8_t* cert,
 size_t cert_size,
 uint8_t*  _data ,
 size_t data_size);
#line 653 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_get_cert_element( atcacert_cert_loc_t* cert_loc,
 uint8_t* cert,
 size_t cert_size,
 uint8_t*  _data ,
 size_t data_size);
#line 676 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_get_key_id( uint8_t public_key[64], uint8_t key_id[20] );
#line 700 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_merge_device_loc( atcacert_device_loc_t* device_locs,
 size_t* device_locs_count,
 size_t device_locs_max_count,
 atcacert_device_loc_t* device_loc,
 size_t block_size);

int atcacert_is_device_loc_overlap( atcacert_device_loc_t* device_loc1,
 atcacert_device_loc_t* device_loc2);
#line 720 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
void atcacert_public_key_add_padding( uint8_t raw_key[64], uint8_t padded_key[72] );
#line 732 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
void atcacert_public_key_remove_padding( uint8_t padded_key[72], uint8_t raw_key[64] );
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/crypto/atca_crypto_sw_sha1.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/crypto/atca_crypto_sw.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_status.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdbool.h"



 typedef char _Bool;
#line 55 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_status.h"
typedef enum
{
 ATCA_SUCCESS = 0x00,
 ATCA_CONFIG_ZONE_LOCKED = 0x01,
 ATCA_DATA_ZONE_LOCKED = 0x02,
 ATCA_WAKE_FAILED = 0xD0,
 ATCA_CHECKMAC_VERIFY_FAILED = 0xD1,
 ATCA_PARSE_ERROR = 0xD2,
 ATCA_STATUS_CRC = 0xD4,
 ATCA_STATUS_UNKNOWN = 0xD5,
 ATCA_STATUS_ECC = 0xD6,
 ATCA_STATUS_SELFTEST_ERROR = 0xD7,
 ATCA_FUNC_FAIL = 0xE0,
 ATCA_GEN_FAIL = 0xE1,
 ATCA_BAD_PARAM = 0xE2,
 ATCA_INVALID_ID = 0xE3,
 ATCA_INVALID_SIZE = 0xE4,
 ATCA_RX_CRC_ERROR = 0xE5,
 ATCA_RX_FAIL = 0xE6,
 ATCA_RX_NO_RESPONSE = 0xE7,
 ATCA_RESYNC_WITH_WAKEUP = 0xE8,
 ATCA_PARITY_ERROR = 0xE9,
 ATCA_TX_TIMEOUT = 0xEA,
 ATCA_RX_TIMEOUT = 0xEB,
 ATCA_TOO_MANY_COMM_RETRIES = 0xEC,
 ATCA_SMALL_BUFFER = 0xED,
 ATCA_COMM_FAIL = 0xF0,
 ATCA_TIMEOUT = 0xF1,
 ATCA_BAD_OPCODE = 0xF2,
 ATCA_WAKE_SUCCESS = 0xF3,
 ATCA_EXECUTION_ERROR = 0xF4,
 ATCA_UNIMPLEMENTED = 0xF5,
 ATCA_ASSERT_FAILURE = 0xF6,
 ATCA_TX_FAIL = 0xF7,
 ATCA_NOT_LOCKED = 0xF8,
 ATCA_NO_DEVICES = 0xF9,
 ATCA_HEALTH_TEST_ERROR = 0xFA,
 ATCA_ALLOC_FAILURE = 0xFB,
} ATCA_STATUS;
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stddef.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"
#line 59 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/crypto/atca_crypto_sw_sha1.h"
typedef struct {
 uint32_t pad[32];
} atcac_sha1_ctx;
#line 67 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/crypto/atca_crypto_sw_sha1.h"
int atcac_sw_sha1_init(atcac_sha1_ctx* ctx);
int atcac_sw_sha1_update(atcac_sha1_ctx* ctx, uint8_t*  _data , size_t data_size);
int atcac_sw_sha1_finish(atcac_sha1_ctx * ctx, uint8_t digest[ (20) ]);
int atcac_sw_sha1( uint8_t *  _data , size_t data_size, uint8_t digest[ (20) ]);
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/crypto/atca_crypto_sw_sha2.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/crypto/atca_crypto_sw.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stddef.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"
#line 59 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/crypto/atca_crypto_sw_sha2.h"
typedef struct {
 uint32_t pad[48];
} atcac_sha2_256_ctx;
#line 67 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/crypto/atca_crypto_sw_sha2.h"
int atcac_sw_sha2_256_init(atcac_sha2_256_ctx* ctx);
int atcac_sw_sha2_256_update(atcac_sha2_256_ctx* ctx, uint8_t*  _data , size_t data_size);
int atcac_sw_sha2_256_finish(atcac_sha2_256_ctx * ctx, uint8_t digest[ (32) ]);
int atcac_sw_sha2_256( uint8_t *  _data , size_t data_size, uint8_t digest[ (32) ]);
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_der.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stddef.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert.h"
#line 75 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_der.h"
int atcacert_der_enc_length(uint32_t length, uint8_t* der_length, size_t* der_length_size);
#line 89 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_der.h"
int atcacert_der_dec_length( uint8_t* der_length, size_t* der_length_size, uint32_t* length);
#line 106 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_der.h"
int atcacert_der_enc_integer( uint8_t* int_data,
 size_t int_data_size,
 uint8_t is_unsigned,
 uint8_t* der_int,
 size_t* der_int_size);
#line 128 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_der.h"
int atcacert_der_dec_integer( uint8_t* der_int,
 size_t* der_int_size,
 uint8_t* int_data,
 size_t* int_data_size);
#line 149 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_der.h"
int atcacert_der_enc_ecdsa_sig_value( uint8_t raw_sig[64],
 uint8_t* der_sig,
 size_t* der_sig_size);
#line 168 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_der.h"
int atcacert_der_dec_ecdsa_sig_value( uint8_t * der_sig,
 size_t * der_sig_size,
 uint8_t raw_sig[64]);
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_date.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/string.h"





void * memchr(void *p, char n, unsigned int v);
int memcmp(void *s1, void *s2, int n);
void * memcpy(void * d1, void * s1, int n);
void * memmove(void * to, void * from, int n);
void * memset(void * p1, char character, int n);
char * strcat(char * to, char * from);
char * strchr(char * ptr, char chr);
int strcmp(char * s1, char * s2);
char * strcpy(char * to, char * from);
int strlen(char * s);
char * strncat(char * to, char * from, int size);
char * strncpy(char * to, char * from, int size);
int strspn(char * str1, char * str2);
char strcspn(char * s1, char * s2);
int strncmp(char * s1, char * s2, char len);
char * strpbrk(char * s1, char * s2);
char * strrchr(char *ptr, char chr);
char * strstr(char * s1, char * s2);
char * strtok(char * s1, char * s2);
#line 52 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atcacert/atcacert_def.c"
int atcacert_merge_device_loc( atcacert_device_loc_t* device_locs,
 size_t* device_locs_count,
 size_t device_locs_max_count,
 atcacert_device_loc_t* device_loc,
 size_t block_size)
{
 size_t i = 0;
 size_t new_offset;
 size_t new_end;

 if (device_locs ==  ((void *)0)  || device_locs_count ==  ((void *)0)  || device_loc ==  ((void *)0)  || block_size <= 0)
 return  2 ;

 if (device_loc->zone == DEVZONE_NONE || device_loc->count == 0)
 return  0 ;

 new_offset = (device_loc->offset / block_size) * block_size;
 new_end = device_loc->offset + device_loc->count;
 new_end = ((new_end % block_size) ? new_end / block_size + 1 : new_end / block_size) * block_size;


 for (i = 0; i < *device_locs_count; ++i) {
 atcacert_device_loc_t* cur_device_loc = &device_locs[i];
 size_t cur_end = cur_device_loc->offset + cur_device_loc->count;

 if (device_loc->zone != cur_device_loc->zone)
 continue;
 if (device_loc->zone == DEVZONE_DATA && device_loc->slot != cur_device_loc->slot)
 continue;
 if (device_loc->zone == DEVZONE_DATA && device_loc->is_genkey != cur_device_loc->is_genkey)
 continue;
 if (new_end < cur_device_loc->offset || new_offset > cur_end)
 continue;

 if (device_loc->offset < cur_device_loc->offset)
 cur_device_loc->offset = device_loc->offset;

 if (new_end > cur_end)
 cur_device_loc->count = (uint16_t)(new_end - cur_device_loc->offset);
 else
 cur_device_loc->count = (uint16_t)(cur_end - cur_device_loc->offset);
 break;
 }

 if (i == *device_locs_count) {

 if (*device_locs_count >= device_locs_max_count)
 return  3 ;

 device_locs[*device_locs_count] = *device_loc;

 device_locs[*device_locs_count].offset = (uint16_t)new_offset;
 device_locs[*device_locs_count].count = (uint16_t)(new_end - new_offset);
 (*device_locs_count)++;
 }

 return  0 ;
}

int atcacert_get_device_locs( atcacert_def_t* cert_def,
 atcacert_device_loc_t* device_locs,
 size_t* device_locs_count,
 size_t device_locs_max_count,
 size_t block_size)
{
 int ret = 0;
 size_t i;

 if (cert_def ==  ((void *)0)  || device_locs ==  ((void *)0)  || device_locs_count ==  ((void *)0) )
 return  2 ;

 ret = atcacert_merge_device_loc(
 device_locs,
 device_locs_count,
 device_locs_max_count,
 &cert_def->cert_sn_dev_loc,
 block_size);
 if (ret !=  0 )
 return ret;

 ret = atcacert_merge_device_loc(
 device_locs,
 device_locs_count,
 device_locs_max_count,
 &cert_def->public_key_dev_loc,
 block_size);
 if (ret !=  0 )
 return ret;

 ret = atcacert_merge_device_loc(
 device_locs,
 device_locs_count,
 device_locs_max_count,
 &cert_def->comp_cert_dev_loc,
 block_size);
 if (ret !=  0 )
 return ret;

 if (cert_def->cert_elements_count > 0 && cert_def->cert_elements ==  ((void *)0) )
 return  10 ;

 for (i = 0; i < cert_def->cert_elements_count; i++) {
 ret = atcacert_merge_device_loc(
 device_locs,
 device_locs_count,
 device_locs_max_count,
 &cert_def->cert_elements[i].device_loc,
 block_size);
 if (ret !=  0 )
 return ret;
 }


 if ( cert_def->sn_source == SNSRC_DEVICE_SN
 || cert_def->sn_source == SNSRC_DEVICE_SN_HASH
 || cert_def->sn_source == SNSRC_DEVICE_SN_HASH_POS
 || cert_def->sn_source == SNSRC_DEVICE_SN_HASH_RAW) {

 atcacert_device_loc_t device_sn_loc =
 {
 DEVZONE_CONFIG,
 0,
  0 ,
 0,
 13
 };
 ret = atcacert_merge_device_loc(
 device_locs,
 device_locs_count,
 device_locs_max_count,
 &device_sn_loc,
 block_size);
 if (ret !=  0 )
 return ret;
 }

 return  0 ;
}

static uint8_t* atcacert_is_device_loc_match( atcacert_device_loc_t* device_loc_dest,
 atcacert_device_loc_t* device_loc_src,
 uint8_t* src_data)
{
 size_t dest_end = device_loc_dest->offset + device_loc_dest->count;
 size_t src_end = device_loc_src->offset + device_loc_src->count;

 if (device_loc_dest->zone == DEVZONE_NONE || device_loc_dest->count <= 0)
 return  ((void *)0) ;
 if (device_loc_src->zone == DEVZONE_NONE || device_loc_src->count <= 0)
 return  ((void *)0) ;
 if (device_loc_dest->zone != device_loc_src->zone)
 return  ((void *)0) ;
 if (device_loc_dest->zone == DEVZONE_DATA && device_loc_dest->slot != device_loc_src->slot)
 return  ((void *)0) ;
 if (device_loc_dest->zone == DEVZONE_DATA && device_loc_dest->is_genkey != device_loc_src->is_genkey)
 return  ((void *)0) ;

 if (device_loc_dest->offset < device_loc_src->offset || dest_end > src_end)
 return  ((void *)0) ;


 return src_data + (device_loc_dest->offset - device_loc_src->offset);
}

int atcacert_cert_build_start( atcacert_build_state_t* build_state,
 atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t* cert_size,
 uint8_t ca_public_key[64])
{
 int ret = 0;

 if (build_state ==  ((void *)0)  || cert_def ==  ((void *)0)  || cert ==  ((void *)0)  || cert_size ==  ((void *)0)  || ca_public_key ==  ((void *)0) )
 return  2 ;

 memset(build_state, 0, sizeof(*build_state));

 build_state->cert_def = cert_def;
 build_state->cert = cert;
 build_state->cert_size = cert_size;
 build_state->max_cert_size = *cert_size;
 build_state->is_device_sn =  (0) ;

 if (build_state->max_cert_size < build_state->cert_def->cert_template_size) {
 *build_state->cert_size = build_state->cert_def->cert_template_size;
 return  3 ;
 }


 *build_state->cert_size = build_state->cert_def->cert_template_size;
 memcpy(build_state->cert, build_state->cert_def->cert_template, build_state->cert_def->cert_template_size);

 if (build_state->cert_def->type == CERTTYPE_X509) {


 uint8_t large_sig[64];
 memset(large_sig, 0xFF, sizeof(large_sig));
 ret = atcacert_set_signature(
 build_state->cert_def,
 build_state->cert,
 build_state->cert_size,
 build_state->max_cert_size,
 large_sig);
 if (ret !=  0 )
 return ret;
 }


 ret = atcacert_set_auth_key_id(
 build_state->cert_def,
 build_state->cert,
 *build_state->cert_size,
 ca_public_key);
 if (ret !=  0 )
 return ret;

 return  0 ;
}

int atcacert_cert_build_process( atcacert_build_state_t* build_state,
 atcacert_device_loc_t* device_loc,
 uint8_t* device_data)
{
 int ret = 0;
 size_t i = 0;
 uint8_t*  _data  =  ((void *)0) ;
 uint8_t public_key[64];
 static atcacert_device_loc_t device_sn_dev_loc = {
 DEVZONE_CONFIG,
 0,
  0 ,
 0,
 13
 };

 if (build_state ==  ((void *)0)  || device_loc ==  ((void *)0)  || device_data ==  ((void *)0) )
 return  2 ;

  _data  = atcacert_is_device_loc_match(&build_state->cert_def->cert_sn_dev_loc, device_loc, device_data);
 if ( _data  !=  ((void *)0) ) {
 ret = atcacert_set_cert_sn(
 build_state->cert_def,
 build_state->cert,
 *build_state->cert_size,
  _data ,
 build_state->cert_def->cert_sn_dev_loc.count);
 if (ret !=  0 )
 return ret;
 }

  _data  = atcacert_is_device_loc_match(&build_state->cert_def->public_key_dev_loc, device_loc, device_data);
 if ( _data  !=  ((void *)0) ) {
 if (build_state->cert_def->public_key_dev_loc.count == 72) {

 atcacert_public_key_remove_padding( _data , public_key);
 ret = atcacert_set_subj_public_key(
 build_state->cert_def,
 build_state->cert,
 *build_state->cert_size,
 public_key);
 }else if (build_state->cert_def->public_key_dev_loc.count == 64) {
 ret = atcacert_set_subj_public_key(
 build_state->cert_def,
 build_state->cert,
 *build_state->cert_size,
  _data );
 }else
 return  10 ;

 if (ret !=  0 )
 return ret;
 }

  _data  = atcacert_is_device_loc_match(&build_state->cert_def->comp_cert_dev_loc, device_loc, device_data);
 if ( _data  !=  ((void *)0) ) {
 if (build_state->cert_def->comp_cert_dev_loc.count != 72)
 return  10 ;

 ret = atcacert_set_comp_cert(
 build_state->cert_def,
 build_state->cert,
 build_state->cert_size,
 build_state->max_cert_size,
  _data );
 if (ret !=  0 )
 return ret;
 }

 if (build_state->cert_def->cert_elements_count > 0 && build_state->cert_def->cert_elements ==  ((void *)0) )
 return  10 ;
 for (i = 0; i < build_state->cert_def->cert_elements_count; i++) {
  _data  = atcacert_is_device_loc_match(&build_state->cert_def->cert_elements[i].device_loc, device_loc, device_data);
 if ( _data  !=  ((void *)0) ) {
 if (build_state->cert_def->cert_elements[i].device_loc.count != build_state->cert_def->cert_elements[i].cert_loc.count)
 return  10 ;
 ret = atcacert_set_cert_element(
 &build_state->cert_def->cert_elements[i].cert_loc,
 build_state->cert,
 *build_state->cert_size,
  _data ,
 build_state->cert_def->cert_elements[i].cert_loc.count);
 if (ret !=  0 )
 return ret;
 }
 }

  _data  = atcacert_is_device_loc_match(&device_sn_dev_loc, device_loc, device_data);
 if ( _data  !=  ((void *)0) ) {

 build_state->is_device_sn =  (1) ;
 memcpy(&build_state->device_sn[0], & _data [0], 4);
 memcpy(&build_state->device_sn[4], & _data [8], 5);
 }

 return  0 ;
}

int atcacert_cert_build_finish( atcacert_build_state_t* build_state )
{
 int ret = 0;
 uint8_t* device_sn =  ((void *)0) ;

 if (build_state ==  ((void *)0) )
 return  2 ;

 if (build_state->is_device_sn)
 device_sn = build_state->device_sn;

 ret = atcacert_gen_cert_sn(build_state->cert_def, build_state->cert, *build_state->cert_size, device_sn);
 if (ret !=  0 )
 return ret;

 return ret;
}

int atcacert_is_device_loc_overlap( atcacert_device_loc_t* device_loc1,
 atcacert_device_loc_t* device_loc2)
{
 if (device_loc1->zone != device_loc2->zone)
 return  (0) ;
 if (device_loc1->zone == DEVZONE_DATA && device_loc1->slot != device_loc2->slot)
 return  (0) ;
 if (device_loc1->zone == DEVZONE_DATA && device_loc1->is_genkey != device_loc2->is_genkey)
 return  (0) ;

 return !( device_loc1->offset + device_loc1->count <= device_loc2->offset
 || device_loc1->offset >= device_loc2->offset + device_loc2->count);
}

static void atcacert_copy_device_loc_data( atcacert_device_loc_t* device_loc_src,
 uint8_t* data_src,
 atcacert_device_loc_t* device_loc_dest,
 uint8_t* data_dest)
{
 size_t offset =  ((device_loc_src->offset) >= (device_loc_dest->offset) ? (device_loc_src->offset) : (device_loc_dest->offset)) ;
 size_t end =  ((device_loc_src->offset + device_loc_src->count) < (device_loc_dest->offset + device_loc_dest->count) ? (device_loc_src->offset + device_loc_src->count) : (device_loc_dest->offset + device_loc_dest->count)) ;

 memcpy(&data_dest[offset - device_loc_dest->offset], &data_src[offset - device_loc_src->offset], end - offset);
}

int atcacert_get_device_data( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 atcacert_device_loc_t* device_loc,
 uint8_t* device_data)
{
 int ret = 0;
 int i = 0;
 uint8_t temp_buf[256];
 size_t temp_buf_size = sizeof(temp_buf);

 if (cert_def ==  ((void *)0)  || cert ==  ((void *)0)  || device_loc ==  ((void *)0)  || device_data ==  ((void *)0) )
 return  2 ;


 if (atcacert_is_device_loc_overlap(&cert_def->cert_sn_dev_loc, device_loc)) {
 temp_buf_size = sizeof(temp_buf);
 ret = atcacert_get_cert_sn(cert_def, cert, cert_size, temp_buf, &temp_buf_size);
 if (ret !=  0 )
 return ret;
 atcacert_copy_device_loc_data(&cert_def->cert_sn_dev_loc, temp_buf, device_loc, device_data);
 }


 if (atcacert_is_device_loc_overlap(&cert_def->public_key_dev_loc, device_loc)) {
 ret = atcacert_get_subj_public_key(cert_def, cert, cert_size, temp_buf);
 if (ret !=  0 )
 return ret;
 if (cert_def->public_key_dev_loc.count == 72)

 atcacert_public_key_add_padding(temp_buf, temp_buf);
 else if (cert_def->public_key_dev_loc.count != 64)
 return  10 ;
 atcacert_copy_device_loc_data(&cert_def->public_key_dev_loc, temp_buf, device_loc, device_data);
 }


 if (atcacert_is_device_loc_overlap(&cert_def->comp_cert_dev_loc, device_loc)) {
 ret = atcacert_get_comp_cert(cert_def, cert, cert_size, temp_buf);
 if (ret !=  0 )
 return ret;
 if (cert_def->comp_cert_dev_loc.count != 72)
 return  10 ;
 atcacert_copy_device_loc_data(&cert_def->comp_cert_dev_loc, temp_buf, device_loc, device_data);
 }


 if (cert_def->cert_elements_count > 0 && cert_def->cert_elements ==  ((void *)0) )
 return  10 ;
 for (i = 0; i < cert_def->cert_elements_count; i++) {
 if (atcacert_is_device_loc_overlap(&cert_def->cert_elements[i].device_loc, device_loc)) {
 if (sizeof(temp_buf) < cert_def->cert_elements[i].device_loc.count)
 return  3 ;
 ret = atcacert_get_cert_element(
 &cert_def->cert_elements[i].cert_loc,
 cert,
 cert_size,
 temp_buf,
 cert_def->cert_elements[i].device_loc.count);
 if (ret !=  0 )
 return ret;
 atcacert_copy_device_loc_data(&cert_def->cert_elements[i].device_loc, temp_buf, device_loc, device_data);
 }
 }

 return  0 ;
}

int atcacert_set_subj_public_key( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 uint8_t subj_public_key[64])
{
 int ret = 0;
 uint8_t key_id[20];

 if (cert_def ==  ((void *)0)  || cert ==  ((void *)0)  || subj_public_key ==  ((void *)0) )
 return  2 ;

 ret = atcacert_set_cert_element(&cert_def->std_cert_elements[STDCERT_PUBLIC_KEY], cert, cert_size, subj_public_key, 64);
 if (ret !=  0 )
 return ret;

 ret = atcacert_get_key_id(subj_public_key, key_id);
 if (ret !=  0 )
 return ret;

 ret = atcacert_set_cert_element(&cert_def->std_cert_elements[STDCERT_SUBJ_KEY_ID], cert, cert_size, key_id, 20);
 if (ret !=  0 )
 return ret;

 return  0 ;
}

int atcacert_get_subj_public_key( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 uint8_t subj_public_key[64])
{
 if (cert_def ==  ((void *)0)  || cert ==  ((void *)0)  || subj_public_key ==  ((void *)0) )
 return  2 ;

 return atcacert_get_cert_element(&cert_def->std_cert_elements[STDCERT_PUBLIC_KEY], cert, cert_size, subj_public_key, 64);
}

int atcacert_get_subj_key_id( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 uint8_t subj_key_id[20])
{
 if (cert_def ==  ((void *)0)  || cert ==  ((void *)0)  || subj_key_id ==  ((void *)0) )
 return  2 ;

 return atcacert_get_cert_element(&cert_def->std_cert_elements[STDCERT_SUBJ_KEY_ID], cert, cert_size, subj_key_id, 20);
}

int atcacert_set_signature( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t* cert_size,
 size_t max_cert_size,
 uint8_t signature[64])
{
 int ret = 0;
 uint16_t sig_offset;
 size_t cur_der_sig_size;
 size_t new_der_sig_size;
 size_t old_cert_der_length_size;
 size_t new_cert_der_length_size;
 size_t new_cert_length;
 uint8_t new_cert_der_length[5];

 if (cert_def ==  ((void *)0)  || cert ==  ((void *)0)  || cert_size ==  ((void *)0)  || signature ==  ((void *)0) )
 return  2 ;

 sig_offset = cert_def->std_cert_elements[STDCERT_SIGNATURE].offset;


 if (cert_def->type != CERTTYPE_X509)
 return atcacert_set_cert_element(&cert_def->std_cert_elements[STDCERT_SIGNATURE], cert, *cert_size, signature, 64);

 if (sig_offset >= *cert_size)
 return  9 ;


 cur_der_sig_size = *cert_size - sig_offset;


 new_der_sig_size = max_cert_size - sig_offset;


 ret = atcacert_der_enc_ecdsa_sig_value(signature, &cert[sig_offset], &new_der_sig_size);
 if (ret !=  0 ) {
 if (ret ==  3 )
 *cert_size += (int)new_der_sig_size - (int)cur_der_sig_size;
 return ret;
 }

 *cert_size += (int)new_der_sig_size - (int)cur_der_sig_size;

 old_cert_der_length_size = *cert_size - 1;
 ret = atcacert_der_dec_length(&cert[1], &old_cert_der_length_size,  ((void *)0) );
 if (ret !=  0 )
 return ret;

 if ((1 + old_cert_der_length_size) > *cert_size)
 return  10 ;
 new_cert_length = *cert_size - (1 + old_cert_der_length_size);

 new_cert_der_length_size = sizeof(new_cert_der_length);
 ret = atcacert_der_enc_length(new_cert_length, new_cert_der_length, &new_cert_der_length_size);
 if (ret !=  0 )
 return ret;

 if (old_cert_der_length_size != new_cert_der_length_size)
 return  10 ;

 memcpy(&cert[1], new_cert_der_length, new_cert_der_length_size);

 return  0 ;
}

int atcacert_get_signature( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 uint8_t signature[64])
{
 uint16_t sig_offset;
 size_t der_sig_size = 0;

 if (cert_def ==  ((void *)0)  || cert ==  ((void *)0)  || signature ==  ((void *)0) )
 return  2 ;

 sig_offset = cert_def->std_cert_elements[STDCERT_SIGNATURE].offset;


 if (cert_def->type != CERTTYPE_X509)
 return atcacert_get_cert_element(&cert_def->std_cert_elements[STDCERT_SIGNATURE], cert, cert_size, signature, 64);

 if (sig_offset >= cert_size)
 return  9 ;

 der_sig_size = cert_size - sig_offset;
 return atcacert_der_dec_ecdsa_sig_value(&cert[sig_offset], &der_sig_size, signature);
}

int atcacert_set_issue_date( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 atcacert_tm_utc_t* timestamp)
{
 int ret = 0;
 uint8_t formatted_date[ (20) ];
 size_t formatted_date_size = sizeof(formatted_date);

 if (cert_def ==  ((void *)0)  || cert ==  ((void *)0)  || timestamp ==  ((void *)0) )
 return  2 ;

 if (cert_def->std_cert_elements[STDCERT_ISSUE_DATE].count == 0)
 return  0 ;

 ret = atcacert_date_enc(cert_def->issue_date_format, timestamp, formatted_date, &formatted_date_size);
 if (ret !=  0 )
 return ret;

 ret = atcacert_set_cert_element(&cert_def->std_cert_elements[STDCERT_ISSUE_DATE], cert, cert_size, formatted_date, formatted_date_size);
 if (ret !=  0 )
 return ret;

 return  0 ;
}

int atcacert_get_issue_date( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 atcacert_tm_utc_t* timestamp)
{
 int ret = 0;
 uint8_t formatted_date[ (20) ];
 size_t formatted_date_size = sizeof(formatted_date);

 if (cert_def ==  ((void *)0)  || cert ==  ((void *)0)  || timestamp ==  ((void *)0) )
 return  2 ;

 if (cert_def->issue_date_format > sizeof(ATCACERT_DATE_FORMAT_SIZES) / sizeof(ATCACERT_DATE_FORMAT_SIZES[0]))
 return  1 ;

 formatted_date_size = ATCACERT_DATE_FORMAT_SIZES[cert_def->issue_date_format];
 if (formatted_date_size > sizeof(formatted_date))
 return  1 ;

 ret = atcacert_get_cert_element(&cert_def->std_cert_elements[STDCERT_ISSUE_DATE], cert, cert_size, formatted_date, formatted_date_size);
 if (ret !=  0 )
 return ret;

 ret = atcacert_date_dec(cert_def->issue_date_format, formatted_date, formatted_date_size, timestamp);
 if (ret !=  0 )
 return ret;

 return  0 ;
}

int atcacert_set_expire_date( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 atcacert_tm_utc_t* timestamp)
{
 int ret = 0;
 uint8_t formatted_date[ (20) ];
 size_t formatted_date_size = sizeof(formatted_date);

 if (cert_def ==  ((void *)0)  || cert ==  ((void *)0)  || timestamp ==  ((void *)0) )
 return  2 ;

 if (cert_def->std_cert_elements[STDCERT_EXPIRE_DATE].count == 0)
 return  0 ;

 ret = atcacert_date_enc(cert_def->expire_date_format, timestamp, formatted_date, &formatted_date_size);
 if (ret !=  0 )
 return ret;

 ret = atcacert_set_cert_element(&cert_def->std_cert_elements[STDCERT_EXPIRE_DATE], cert, cert_size, formatted_date, formatted_date_size);
 if (ret !=  0 )
 return ret;

 return  0 ;
}

int atcacert_get_expire_date( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 atcacert_tm_utc_t* timestamp)
{
 int ret = 0;
 uint8_t formatted_date[ (20) ];
 size_t formatted_date_size = sizeof(formatted_date);

 if (cert_def ==  ((void *)0)  || cert ==  ((void *)0)  || timestamp ==  ((void *)0) )
 return  2 ;

 if (cert_def->expire_date_format > sizeof(ATCACERT_DATE_FORMAT_SIZES) / sizeof(ATCACERT_DATE_FORMAT_SIZES[0]))
 return  1 ;

 formatted_date_size = ATCACERT_DATE_FORMAT_SIZES[cert_def->expire_date_format];
 if (formatted_date_size > sizeof(formatted_date))
 return  1 ;

 ret = atcacert_get_cert_element(&cert_def->std_cert_elements[STDCERT_EXPIRE_DATE], cert, cert_size, formatted_date, formatted_date_size);
 if (ret !=  0 )
 return ret;

 ret = atcacert_date_dec(cert_def->expire_date_format, formatted_date, formatted_date_size, timestamp);
 if (ret !=  0 )
 return ret;

 return  0 ;
}

static void uint8_to_hex(uint8_t num, uint8_t* hex_str)
{
 uint8_t nibble = (num >> 4) & 0x0F;

 if (nibble < 10)
 *(hex_str++) = '0' + nibble;
 else
 *(hex_str++) = 'A' + (nibble - 10);
 nibble = num & 0x0F;
 if (nibble < 10)
 *(hex_str++) = '0' + nibble;
 else
 *(hex_str++) = 'A' + (nibble - 10);
}

int atcacert_set_signer_id( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 uint8_t signer_id[2])
{
 uint8_t hex_str[4];

 if (cert_def ==  ((void *)0)  || cert ==  ((void *)0)  || signer_id ==  ((void *)0) )
 return  2 ;

 uint8_to_hex(signer_id[0], &hex_str[0]);
 uint8_to_hex(signer_id[1], &hex_str[2]);

 return atcacert_set_cert_element(&cert_def->std_cert_elements[STDCERT_SIGNER_ID], cert, cert_size, hex_str, 4);
}

static int hex_to_uint8( uint8_t hex_str[2], uint8_t* num)
{
 *num = 0;

 if (hex_str[0] >= '0' && hex_str[0] <= '9')
 *num += (hex_str[0] - '0') << 4;
 else if (hex_str[0] >= 'A' && hex_str[0] <= 'F')
 *num += (hex_str[0] - 'A' + 10) << 4;
 else if (hex_str[0] >= 'a' && hex_str[0] <= 'f')
 *num += (hex_str[0] - 'a' + 10) << 4;
 else
 return  4 ;

 if (hex_str[1] >= '0' && hex_str[1] <= '9')
 *num += (hex_str[1] - '0');
 else if (hex_str[1] >= 'A' && hex_str[1] <= 'F')
 *num += (hex_str[1] - 'A' + 10);
 else if (hex_str[1] >= 'a' && hex_str[1] <= 'f')
 *num += (hex_str[1] - 'a' + 10);
 else
 return  4 ;

 return  0 ;
}

int atcacert_get_signer_id( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 uint8_t signer_id[2])
{
 int ret = 0;
 uint8_t hex_str[4];

 if (cert_def ==  ((void *)0)  || cert ==  ((void *)0)  || signer_id ==  ((void *)0) )
 return  2 ;

 ret = atcacert_get_cert_element(&cert_def->std_cert_elements[STDCERT_SIGNER_ID], cert, cert_size, hex_str, 4);
 if (ret !=  0 )
 return ret;

 ret = hex_to_uint8(&hex_str[0], &signer_id[0]);
 if (ret !=  0 )
 return ret;

 ret = hex_to_uint8(&hex_str[2], &signer_id[1]);
 if (ret !=  0 )
 return ret;

 return  0 ;
}

int atcacert_set_cert_sn( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 uint8_t* cert_sn,
 size_t cert_sn_size)
{
 if (cert_def ==  ((void *)0)  || cert ==  ((void *)0)  || cert_sn ==  ((void *)0) )
 return  2 ;

 return atcacert_set_cert_element(&cert_def->std_cert_elements[STDCERT_CERT_SN], cert, cert_size, cert_sn, cert_sn_size);
}

int atcacert_gen_cert_sn( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 uint8_t device_sn[9])
{
 int ret = 0;
 size_t sn_size = 0;
 uint8_t msg[64 + 3];
 uint8_t sn[32];
 atcacert_tm_utc_t issue_date;

 if (cert_def ==  ((void *)0)  || cert ==  ((void *)0) )
 return  2 ;

 if (cert_def->sn_source == SNSRC_STORED || cert_def->std_cert_elements[STDCERT_CERT_SN].count == 0)
 return  0 ;

 switch (cert_def->sn_source) {
 case SNSRC_DEVICE_SN:
 if (device_sn ==  ((void *)0) )
 return  2 ;
 sn_size = 1 + 9;
 sn[0] = 0x40;
 memcpy(&sn[1], device_sn, 9);
 break;

 case SNSRC_SIGNER_ID:
 sn_size = 1 + 2;
 sn[0] = 0x40;
 ret = atcacert_get_signer_id(cert_def, cert, cert_size, &sn[1]);
 if (ret !=  0 )
 return ret;
 break;

 case SNSRC_PUB_KEY_HASH_RAW:
 case SNSRC_PUB_KEY_HASH_POS:
 case SNSRC_PUB_KEY_HASH:
 if (cert_def->std_cert_elements[STDCERT_CERT_SN].count > 32)
 return  7 ;
 sn_size = cert_def->std_cert_elements[STDCERT_CERT_SN].count;


 ret = atcacert_get_subj_public_key(cert_def, cert, cert_size, &msg[0]);
 if (ret !=  0 )
 return ret;


 ret = atcacert_get_issue_date(cert_def, cert, cert_size, &issue_date);
 if (ret !=  0 )
 return ret;
 ret = atcacert_date_enc_compcert(&issue_date, cert_def->expire_years, &msg[64]);
 if (ret !=  0 )
 return ret;
 ret = atcac_sw_sha2_256(msg, 64 + 3, sn);
 if (ret !=  0 )
 return ret;

 if (cert_def->sn_source == SNSRC_PUB_KEY_HASH_POS || cert_def->sn_source == SNSRC_PUB_KEY_HASH)
 sn[0] &= 0x7F;
 if (cert_def->sn_source == SNSRC_PUB_KEY_HASH)
 sn[0] |= 0x40;
 break;

 case SNSRC_DEVICE_SN_HASH_RAW:
 case SNSRC_DEVICE_SN_HASH_POS:
 case SNSRC_DEVICE_SN_HASH:
 if (device_sn ==  ((void *)0) )
 return  2 ;
 if (cert_def->std_cert_elements[STDCERT_CERT_SN].count > 32)
 return  7 ;
 sn_size = cert_def->std_cert_elements[STDCERT_CERT_SN].count;


 memcpy(&msg[0], device_sn, 9);


 ret = atcacert_get_issue_date(cert_def, cert, cert_size, &issue_date);
 if (ret !=  0 )
 return ret;
 ret = atcacert_date_enc_compcert(&issue_date, cert_def->expire_years, &msg[9]);
 if (ret !=  0 )
 return ret;
 ret = atcac_sw_sha2_256(msg, 9 + 3, sn);
 if (ret !=  0 )
 return ret;

 if (cert_def->sn_source == SNSRC_DEVICE_SN_HASH_POS || cert_def->sn_source == SNSRC_DEVICE_SN_HASH)
 sn[0] &= 0x7F;
 if (cert_def->sn_source == SNSRC_DEVICE_SN_HASH)
 sn[0] |= 0x40;
 break;

 default:
 return  2 ;
 }

 return atcacert_set_cert_element(&cert_def->std_cert_elements[STDCERT_CERT_SN], cert, cert_size, sn, sn_size);
}

int atcacert_get_cert_sn( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 uint8_t* cert_sn,
 size_t* cert_sn_size)
{
 if (cert_def ==  ((void *)0)  || cert ==  ((void *)0)  || cert_sn ==  ((void *)0)  || cert_sn_size ==  ((void *)0) )
 return  2 ;

 if (*cert_sn_size < cert_def->std_cert_elements[STDCERT_CERT_SN].count) {
 *cert_sn_size = cert_def->std_cert_elements[STDCERT_CERT_SN].count;
 return  3 ;
 }

 *cert_sn_size = cert_def->std_cert_elements[STDCERT_CERT_SN].count;

 return atcacert_get_cert_element(&cert_def->std_cert_elements[STDCERT_CERT_SN], cert, cert_size, cert_sn, *cert_sn_size);
}

int atcacert_set_auth_key_id( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 uint8_t auth_public_key[64])
{
 int ret = 0;
 uint8_t key_id[20];

 if (cert_def ==  ((void *)0)  || cert ==  ((void *)0)  || auth_public_key ==  ((void *)0) )
 return  2 ;

 ret = atcacert_get_key_id(auth_public_key, key_id);
 if (ret !=  0 )
 return ret;

 ret = atcacert_set_cert_element(&cert_def->std_cert_elements[STDCERT_AUTH_KEY_ID], cert, cert_size, key_id, 20);
 if (ret !=  0 )
 return ret;

 return  0 ;
}

int atcacert_get_auth_key_id( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 uint8_t auth_key_id[20])
{
 if (cert_def ==  ((void *)0)  || cert ==  ((void *)0)  || auth_key_id ==  ((void *)0) )
 return  2 ;

 return atcacert_get_cert_element(&cert_def->std_cert_elements[STDCERT_AUTH_KEY_ID], cert, cert_size, auth_key_id, 20);
}

int atcacert_set_comp_cert( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t* cert_size,
 size_t max_cert_size,
 uint8_t comp_cert[72])
{
 int ret = 0;
 uint8_t enc_dates[3];
 uint8_t signer_id[2];
 uint8_t template_id;
 uint8_t chain_id;
 uint8_t sn_source;
 uint8_t format;
 atcacert_tm_utc_t issue_date;
 atcacert_tm_utc_t expire_date;

 if (cert_def ==  ((void *)0)  || cert ==  ((void *)0)  || cert_size ==  ((void *)0)  || comp_cert ==  ((void *)0) )
 return  2 ;

 format = comp_cert[70] & 0x0F;
 if (format != 0)
 return  4 ;

 memcpy(enc_dates, &comp_cert[64], 3);
 memcpy(signer_id, &comp_cert[67], 2);
 template_id = (comp_cert[69] >> 4) & 0x0F;
 chain_id = comp_cert[69] & 0x0F;
 sn_source = (comp_cert[70] >> 4) & 0x0F;

 if (template_id != cert_def->template_id || chain_id != cert_def->chain_id || sn_source != cert_def->sn_source)
 return  11 ;

 ret = atcacert_set_signature(
 cert_def,
 cert,
 cert_size,
 max_cert_size,
 &comp_cert[0]);
 if (ret !=  0 )
 return ret;

 ret = atcacert_date_dec_compcert(enc_dates, cert_def->expire_date_format, &issue_date, &expire_date);
 if (ret !=  0 )
 return ret;

 ret = atcacert_set_issue_date(cert_def, cert, *cert_size, &issue_date);
 if (ret !=  0 )
 return ret;

 ret = atcacert_set_expire_date(cert_def, cert, *cert_size, &expire_date);
 if (ret !=  0 )
 return ret;

 ret = atcacert_set_signer_id(cert_def, cert, *cert_size, signer_id);
 if (ret !=  0 )
 return ret;

 return  0 ;
}

int atcacert_get_comp_cert( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 uint8_t comp_cert[72])
{
 int ret = 0;
 atcacert_tm_utc_t issue_date;

 if (cert_def ==  ((void *)0)  || cert ==  ((void *)0)  || comp_cert ==  ((void *)0) )
 return  2 ;

 ret = atcacert_get_signature(cert_def, cert, cert_size, &comp_cert[0]);
 if (ret !=  0 )
 return ret;

 ret = atcacert_get_issue_date(cert_def, cert, cert_size, &issue_date);
 if (ret !=  0 )
 return ret;
 ret = atcacert_date_enc_compcert(&issue_date, cert_def->expire_years, &comp_cert[64]);
 if (ret !=  0 )
 return ret;

 ret = atcacert_get_signer_id(cert_def, cert, cert_size, &comp_cert[67]);
 if (ret !=  0 )
 return ret;

 comp_cert[69] = ((cert_def->template_id & 0x0F) << 4) | (cert_def->chain_id & 0x0F);
 comp_cert[70] = ((uint8_t)(cert_def->sn_source & 0x0F) << 4) | 0;
 comp_cert[71] = 0;

 return  0 ;
}

int atcacert_get_tbs( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 uint8_t** tbs,
 size_t* tbs_size)
{
 if (cert_def ==  ((void *)0)  || cert ==  ((void *)0)  || tbs ==  ((void *)0)  || tbs_size ==  ((void *)0) )
 return  2 ;

 if ((size_t)cert_def->tbs_cert_loc.offset + (size_t)cert_def->tbs_cert_loc.count > cert_size)
 return  10 ;

 *tbs = &cert[cert_def->tbs_cert_loc.offset];
 *tbs_size = cert_def->tbs_cert_loc.count;

 return  0 ;
}

int atcacert_get_tbs_digest( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 uint8_t tbs_digest[32])
{
 int ret =  0 ;
 uint8_t* tbs =  ((void *)0) ;
 size_t tbs_size = 0;

 if (cert_def ==  ((void *)0)  || cert ==  ((void *)0)  || tbs_digest ==  ((void *)0) )
 return  2 ;

 ret = atcacert_get_tbs(cert_def, cert, cert_size, &tbs, &tbs_size);
 if (ret !=  0 )
 return ret;

 ret = atcac_sw_sha2_256(tbs, tbs_size, tbs_digest);
 if (ret !=  0 )
 return ret;

 return ret;
}

int atcacert_set_cert_element( atcacert_cert_loc_t* cert_loc,
 uint8_t* cert,
 size_t cert_size,
 uint8_t*  _data ,
 size_t data_size)
{
 if (cert_loc ==  ((void *)0)  || cert ==  ((void *)0) )
 return  2 ;

 if (cert_loc->count == 0)
 return  0 ;

 if ( _data  ==  ((void *)0) )
 return  2 ;

 if (data_size != cert_loc->count)
 return  7 ;

 if ((size_t)cert_loc->offset + cert_loc->count > cert_size)
 return  9 ;

 memcpy(&cert[cert_loc->offset],  _data , data_size);

 return  0 ;
}

int atcacert_get_cert_element( atcacert_cert_loc_t* cert_loc,
 uint8_t* cert,
 size_t cert_size,
 uint8_t*  _data ,
 size_t data_size)
{
 if (cert_loc ==  ((void *)0)  || cert ==  ((void *)0)  ||  _data  ==  ((void *)0) )
 return  2 ;

 if (cert_loc->count == 0)
 return  8 ;

 if (cert_loc->count != data_size)
 return  7 ;

 if ((size_t)cert_loc->offset + cert_loc->count > cert_size)
 return  9 ;

 memcpy( _data , &cert[cert_loc->offset], data_size);

 return  0 ;
}

int atcacert_get_key_id( uint8_t public_key[64], uint8_t key_id[20])
{
 uint8_t msg[65];

 if (public_key ==  ((void *)0)  || key_id ==  ((void *)0) )
 return  2 ;

 msg[0] = 0x04;
 memcpy(&msg[1], public_key, 64);

 return atcac_sw_sha1(msg, sizeof(msg), key_id);
}

void atcacert_public_key_add_padding( uint8_t raw_key[64], uint8_t padded_key[72])
{
 memmove(&padded_key[40], &raw_key[32], 32);
 memset(&padded_key[36], 0, 4);
 memmove(&padded_key[4], &raw_key[0], 32);
 memset(&padded_key[0], 0, 4);
}

void atcacert_public_key_remove_padding( uint8_t padded_key[72], uint8_t raw_key[64])
{
 memmove(&raw_key[0], &padded_key[4], 32);
 memmove(&raw_key[32], &padded_key[40], 32);
}
