_atcacert_der_enc_length:
;atcacert_der.c,46 :: 		int atcacert_der_enc_length(uint32_t length, uint8_t* der_length, size_t* der_length_size)
; der_length_size start address is: 8 (R2)
; der_length start address is: 4 (R1)
; length start address is: 0 (R0)
SUB	SP, SP, #4
MOV	R5, R0
MOV	R4, R1
; der_length_size end address is: 8 (R2)
; der_length end address is: 4 (R1)
; length end address is: 0 (R0)
; length start address is: 20 (R5)
; der_length start address is: 16 (R4)
; der_length_size start address is: 8 (R2)
;atcacert_der.c,48 :: 		size_t der_length_size_calc = 0;
;atcacert_der.c,49 :: 		int exp = sizeof(length) - 1;
; exp start address is: 0 (R0)
MOVW	R0, #3
SXTH	R0, R0
;atcacert_der.c,51 :: 		if (der_length_size == NULL)
CMP	R2, #0
IT	NE
BNE	L_atcacert_der_enc_length0
; length end address is: 20 (R5)
; der_length end address is: 16 (R4)
; der_length_size end address is: 8 (R2)
; exp end address is: 0 (R0)
;atcacert_der.c,52 :: 		return ATCACERT_E_BAD_PARAMS;
MOVS	R0, #2
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_enc_length
L_atcacert_der_enc_length0:
;atcacert_der.c,54 :: 		if (length < 0x80) {
; exp start address is: 0 (R0)
; der_length_size start address is: 8 (R2)
; der_length start address is: 16 (R4)
; length start address is: 20 (R5)
CMP	R5, #128
IT	CS
BCS	L_atcacert_der_enc_length1
; exp end address is: 0 (R0)
;atcacert_der.c,56 :: 		der_length_size_calc = 1;
; der_length_size_calc start address is: 4 (R1)
MOVS	R1, #1
;atcacert_der.c,57 :: 		exp = 0;
; exp start address is: 0 (R0)
MOVS	R0, #0
SXTH	R0, R0
;atcacert_der.c,58 :: 		}else {
; der_length_size_calc end address is: 4 (R1)
IT	AL
BAL	L_atcacert_der_enc_length2
L_atcacert_der_enc_length1:
;atcacert_der.c,62 :: 		while (length / ((uint32_t)1 << (8 * exp)) == 0)
; der_length end address is: 16 (R4)
; der_length_size end address is: 8 (R2)
; exp end address is: 0 (R0)
MOV	R1, R2
MOV	R2, R4
L_atcacert_der_enc_length3:
; length end address is: 20 (R5)
; exp start address is: 0 (R0)
; der_length_size start address is: 4 (R1)
; der_length start address is: 8 (R2)
; length start address is: 20 (R5)
LSLS	R4, R0, #3
SXTH	R4, R4
MOV	R3, #1
LSLS	R3, R4
UDIV	R3, R5, R3
CMP	R3, #0
IT	NE
BNE	L_atcacert_der_enc_length4
;atcacert_der.c,63 :: 		exp--;
SUBS	R0, R0, #1
SXTH	R0, R0
IT	AL
BAL	L_atcacert_der_enc_length3
L_atcacert_der_enc_length4:
;atcacert_der.c,65 :: 		der_length_size_calc = 2 + exp;
ADDS	R3, R0, #2
SXTH	R3, R3
; der_length_size_calc start address is: 16 (R4)
SXTH	R4, R3
; der_length_size end address is: 4 (R1)
; der_length end address is: 8 (R2)
; der_length_size_calc end address is: 16 (R4)
; length end address is: 20 (R5)
; exp end address is: 0 (R0)
STR	R4, [SP, #0]
MOV	R4, R2
MOV	R2, R1
LDR	R1, [SP, #0]
;atcacert_der.c,66 :: 		}
L_atcacert_der_enc_length2:
;atcacert_der.c,68 :: 		if (der_length != NULL && *der_length_size < der_length_size_calc) {
; der_length_size_calc start address is: 4 (R1)
; length start address is: 20 (R5)
; der_length start address is: 16 (R4)
; der_length_size start address is: 8 (R2)
; exp start address is: 0 (R0)
CMP	R4, #0
IT	EQ
BEQ	L__atcacert_der_enc_length114
LDR	R3, [R2, #0]
CMP	R3, R1
IT	CS
BCS	L__atcacert_der_enc_length113
; length end address is: 20 (R5)
; der_length end address is: 16 (R4)
; exp end address is: 0 (R0)
L__atcacert_der_enc_length112:
;atcacert_der.c,69 :: 		*der_length_size = der_length_size_calc;
STR	R1, [R2, #0]
; der_length_size_calc end address is: 4 (R1)
; der_length_size end address is: 8 (R2)
;atcacert_der.c,70 :: 		return ATCACERT_E_BUFFER_TOO_SMALL;
MOVS	R0, #3
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_enc_length
;atcacert_der.c,68 :: 		if (der_length != NULL && *der_length_size < der_length_size_calc) {
L__atcacert_der_enc_length114:
; exp start address is: 0 (R0)
; der_length_size start address is: 8 (R2)
; der_length start address is: 16 (R4)
; length start address is: 20 (R5)
; der_length_size_calc start address is: 4 (R1)
L__atcacert_der_enc_length113:
;atcacert_der.c,73 :: 		*der_length_size = der_length_size_calc;
STR	R1, [R2, #0]
; der_length_size end address is: 8 (R2)
;atcacert_der.c,75 :: 		if (der_length == NULL)
CMP	R4, #0
IT	NE
BNE	L_atcacert_der_enc_length8
; der_length_size_calc end address is: 4 (R1)
; length end address is: 20 (R5)
; der_length end address is: 16 (R4)
; exp end address is: 0 (R0)
;atcacert_der.c,76 :: 		return ATCACERT_E_SUCCESS; // Caller is only requesting the size
MOVS	R0, #0
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_enc_length
L_atcacert_der_enc_length8:
;atcacert_der.c,79 :: 		for (; exp >= 0; exp--)
; exp start address is: 0 (R0)
; der_length start address is: 16 (R4)
; length start address is: 20 (R5)
; der_length_size_calc start address is: 4 (R1)
MOV	R2, R1
; length end address is: 20 (R5)
; der_length end address is: 16 (R4)
; exp end address is: 0 (R0)
MOV	R1, R5
SXTH	R5, R0
MOV	R0, R4
L_atcacert_der_enc_length9:
; der_length_size_calc end address is: 4 (R1)
; exp start address is: 20 (R5)
; length start address is: 4 (R1)
; der_length start address is: 0 (R0)
; length start address is: 4 (R1)
; length end address is: 4 (R1)
; der_length_size_calc start address is: 8 (R2)
CMP	R5, #0
IT	LT
BLT	L_atcacert_der_enc_length10
; length end address is: 4 (R1)
;atcacert_der.c,80 :: 		der_length[der_length_size_calc - 1 - exp] = (uint8_t)((length >> (exp * 8)) & 0xFF);
; length start address is: 4 (R1)
SUBS	R3, R2, #1
SUB	R3, R3, R5
ADDS	R4, R0, R3
LSLS	R3, R5, #3
SXTH	R3, R3
LSR	R3, R1, R3
AND	R3, R3, #255
UXTB	R3, R3
STRB	R3, [R4, #0]
;atcacert_der.c,79 :: 		for (; exp >= 0; exp--)
SUBS	R5, R5, #1
SXTH	R5, R5
;atcacert_der.c,80 :: 		der_length[der_length_size_calc - 1 - exp] = (uint8_t)((length >> (exp * 8)) & 0xFF);
; length end address is: 4 (R1)
; exp end address is: 20 (R5)
IT	AL
BAL	L_atcacert_der_enc_length9
L_atcacert_der_enc_length10:
;atcacert_der.c,82 :: 		if (der_length_size_calc > 1)
CMP	R2, #1
IT	LS
BLS	L_atcacert_der_enc_length12
;atcacert_der.c,83 :: 		der_length[0] = 0x80 | (uint8_t)(der_length_size_calc - 1); // Set number of bytes octet with long-form flag
SUBS	R3, R2, #1
; der_length_size_calc end address is: 8 (R2)
UXTB	R3, R3
ORR	R3, R3, #128
STRB	R3, [R0, #0]
; der_length end address is: 0 (R0)
L_atcacert_der_enc_length12:
;atcacert_der.c,85 :: 		return ATCACERT_E_SUCCESS;
MOVS	R0, #0
SXTH	R0, R0
;atcacert_der.c,86 :: 		}
L_end_atcacert_der_enc_length:
ADD	SP, SP, #4
BX	LR
; end of _atcacert_der_enc_length
_atcacert_der_dec_length:
;atcacert_der.c,88 :: 		int atcacert_der_dec_length( uint8_t* der_length, size_t* der_length_size, uint32_t* length)
; length start address is: 8 (R2)
; der_length_size start address is: 4 (R1)
; der_length start address is: 0 (R0)
MOV	R5, R2
MOV	R2, R1
; length end address is: 8 (R2)
; der_length_size end address is: 4 (R1)
; der_length end address is: 0 (R0)
; der_length start address is: 0 (R0)
; der_length_size start address is: 8 (R2)
; length start address is: 20 (R5)
;atcacert_der.c,90 :: 		if (der_length == NULL || der_length_size == NULL)
CMP	R0, #0
IT	EQ
BEQ	L__atcacert_der_dec_length117
CMP	R2, #0
IT	EQ
BEQ	L__atcacert_der_dec_length116
IT	AL
BAL	L_atcacert_der_dec_length15
; der_length end address is: 0 (R0)
; length end address is: 20 (R5)
; der_length_size end address is: 8 (R2)
L__atcacert_der_dec_length117:
L__atcacert_der_dec_length116:
;atcacert_der.c,91 :: 		return ATCACERT_E_BAD_PARAMS;
MOVS	R0, #2
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_dec_length
L_atcacert_der_dec_length15:
;atcacert_der.c,93 :: 		if (*der_length_size < 1)
; der_length_size start address is: 8 (R2)
; length start address is: 20 (R5)
; der_length start address is: 0 (R0)
LDR	R3, [R2, #0]
CMP	R3, #1
IT	CS
BCS	L_atcacert_der_dec_length16
; der_length end address is: 0 (R0)
; length end address is: 20 (R5)
; der_length_size end address is: 8 (R2)
;atcacert_der.c,94 :: 		return ATCACERT_E_DECODING_ERROR;
MOVS	R0, #4
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_dec_length
L_atcacert_der_dec_length16:
;atcacert_der.c,96 :: 		if (der_length[0] & 0x80) {
; der_length_size start address is: 8 (R2)
; length start address is: 20 (R5)
; der_length start address is: 0 (R0)
LDRB	R3, [R0, #0]
AND	R3, R3, #128
UXTB	R3, R3
CMP	R3, #0
IT	EQ
BEQ	L_atcacert_der_dec_length17
;atcacert_der.c,98 :: 		size_t num_bytes = der_length[0] & 0x7F;
LDRB	R3, [R0, #0]
AND	R1, R3, #127
; num_bytes start address is: 4 (R1)
UXTB	R1, R1
;atcacert_der.c,100 :: 		if (*der_length_size < num_bytes + 1)
LDR	R4, [R2, #0]
ADDS	R3, R1, #1
CMP	R4, R3
IT	CS
BCS	L_atcacert_der_dec_length18
; der_length end address is: 0 (R0)
; length end address is: 20 (R5)
; num_bytes end address is: 4 (R1)
; der_length_size end address is: 8 (R2)
;atcacert_der.c,101 :: 		return ATCACERT_E_DECODING_ERROR;   //  Invalid DER length format, not enough data.
MOVS	R0, #4
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_dec_length
L_atcacert_der_dec_length18:
;atcacert_der.c,102 :: 		if (num_bytes == 0)
; der_length_size start address is: 8 (R2)
; num_bytes start address is: 4 (R1)
; length start address is: 20 (R5)
; der_length start address is: 0 (R0)
CMP	R1, #0
IT	NE
BNE	L_atcacert_der_dec_length19
; der_length end address is: 0 (R0)
; length end address is: 20 (R5)
; num_bytes end address is: 4 (R1)
; der_length_size end address is: 8 (R2)
;atcacert_der.c,103 :: 		return ATCACERT_E_DECODING_ERROR;   //  Invalid DER length format, indefinite length not supported.
MOVS	R0, #4
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_dec_length
L_atcacert_der_dec_length19:
;atcacert_der.c,104 :: 		if (num_bytes > sizeof(*length))
; der_length_size start address is: 8 (R2)
; num_bytes start address is: 4 (R1)
; length start address is: 20 (R5)
; der_length start address is: 0 (R0)
CMP	R1, #4
IT	LS
BLS	L_atcacert_der_dec_length20
; der_length end address is: 0 (R0)
; length end address is: 20 (R5)
; num_bytes end address is: 4 (R1)
; der_length_size end address is: 8 (R2)
;atcacert_der.c,105 :: 		return ATCACERT_E_DECODING_ERROR;   //  Can't parse DER length format, larger than length.
MOVS	R0, #4
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_dec_length
L_atcacert_der_dec_length20:
;atcacert_der.c,107 :: 		if (length != NULL) {
; der_length_size start address is: 8 (R2)
; num_bytes start address is: 4 (R1)
; length start address is: 20 (R5)
; der_length start address is: 0 (R0)
CMP	R5, #0
IT	EQ
BEQ	L__atcacert_der_dec_length118
;atcacert_der.c,109 :: 		*length = 0;
MOVS	R3, #0
STR	R3, [R5, #0]
;atcacert_der.c,110 :: 		for (i = 1; i <= num_bytes; i++)
; i start address is: 12 (R3)
MOVS	R3, #1
; der_length end address is: 0 (R0)
; length end address is: 20 (R5)
; i end address is: 12 (R3)
; num_bytes end address is: 4 (R1)
; der_length_size end address is: 8 (R2)
MOV	R7, R0
MOV	R0, R3
MOV	R6, R5
L_atcacert_der_dec_length22:
; i start address is: 0 (R0)
; der_length start address is: 28 (R7)
; length start address is: 24 (R6)
; num_bytes start address is: 4 (R1)
; length start address is: 24 (R6)
; length end address is: 24 (R6)
; der_length_size start address is: 8 (R2)
; der_length start address is: 28 (R7)
; der_length end address is: 28 (R7)
CMP	R0, R1
IT	HI
BHI	L_atcacert_der_dec_length23
; length end address is: 24 (R6)
; der_length end address is: 28 (R7)
;atcacert_der.c,111 :: 		*length += der_length[i] * ((uint32_t)1 << (8 * (num_bytes - i)));
; der_length start address is: 28 (R7)
; length start address is: 24 (R6)
ADDS	R3, R7, R0
LDRB	R5, [R3, #0]
SUB	R3, R1, R0
LSLS	R4, R3, #3
MOV	R3, #1
LSLS	R3, R4
MUL	R4, R5, R3
LDR	R3, [R6, #0]
ADDS	R3, R3, R4
STR	R3, [R6, #0]
;atcacert_der.c,110 :: 		for (i = 1; i <= num_bytes; i++)
ADDS	R0, R0, #1
;atcacert_der.c,111 :: 		*length += der_length[i] * ((uint32_t)1 << (8 * (num_bytes - i)));
; length end address is: 24 (R6)
; der_length end address is: 28 (R7)
; i end address is: 0 (R0)
IT	AL
BAL	L_atcacert_der_dec_length22
L_atcacert_der_dec_length23:
;atcacert_der.c,112 :: 		}
MOV	R0, R1
; der_length_size end address is: 8 (R2)
MOV	R1, R2
IT	AL
BAL	L_atcacert_der_dec_length21
; num_bytes end address is: 4 (R1)
L__atcacert_der_dec_length118:
;atcacert_der.c,107 :: 		if (length != NULL) {
MOV	R0, R1
MOV	R1, R2
;atcacert_der.c,112 :: 		}
L_atcacert_der_dec_length21:
;atcacert_der.c,113 :: 		*der_length_size = num_bytes + 1; // Return the actual number of bytes the DER length encoding used.
; num_bytes start address is: 0 (R0)
; der_length_size start address is: 4 (R1)
ADDS	R3, R0, #1
; num_bytes end address is: 0 (R0)
STR	R3, [R1, #0]
; der_length_size end address is: 4 (R1)
;atcacert_der.c,114 :: 		}else {
IT	AL
BAL	L_atcacert_der_dec_length25
L_atcacert_der_dec_length17:
;atcacert_der.c,115 :: 		if (length != NULL)
; der_length_size start address is: 8 (R2)
; length start address is: 20 (R5)
; der_length start address is: 0 (R0)
CMP	R5, #0
IT	EQ
BEQ	L_atcacert_der_dec_length26
;atcacert_der.c,116 :: 		*length = der_length[0];
LDRB	R3, [R0, #0]
; der_length end address is: 0 (R0)
STR	R3, [R5, #0]
; length end address is: 20 (R5)
L_atcacert_der_dec_length26:
;atcacert_der.c,117 :: 		*der_length_size = 1; // Return the actual number of bytes the DER length encoding used.
MOVS	R3, #1
STR	R3, [R2, #0]
; der_length_size end address is: 8 (R2)
;atcacert_der.c,118 :: 		}
L_atcacert_der_dec_length25:
;atcacert_der.c,120 :: 		return ATCACERT_E_SUCCESS;
MOVS	R0, #0
SXTH	R0, R0
;atcacert_der.c,121 :: 		}
L_end_atcacert_der_dec_length:
BX	LR
; end of _atcacert_der_dec_length
_atcacert_der_enc_integer:
;atcacert_der.c,127 :: 		size_t*        der_int_size)
; der_int start address is: 12 (R3)
; is_unsigned start address is: 8 (R2)
; int_data_size start address is: 4 (R1)
; int_data start address is: 0 (R0)
SUB	SP, SP, #20
STR	LR, [SP, #0]
STRB	R2, [SP, #4]
MOV	R2, R1
LDRB	R1, [SP, #4]
; der_int end address is: 12 (R3)
; is_unsigned end address is: 8 (R2)
; int_data_size end address is: 4 (R1)
; int_data end address is: 0 (R0)
; int_data start address is: 0 (R0)
; int_data_size start address is: 8 (R2)
; is_unsigned start address is: 4 (R1)
; der_int start address is: 12 (R3)
; der_int_size start address is: 24 (R6)
LDR	R6, [SP, #20]
;atcacert_der.c,130 :: 		size_t der_length_size = sizeof(der_length);
MOV	R4, #5
STR	R4, [SP, #16]
;atcacert_der.c,131 :: 		size_t der_int_size_calc = 0;
;atcacert_der.c,132 :: 		size_t trim = 0;
; trim start address is: 20 (R5)
MOV	R5, #0
;atcacert_der.c,133 :: 		size_t pad = 0;
; pad start address is: 28 (R7)
MOV	R7, #0
;atcacert_der.c,136 :: 		if (int_data == NULL || der_int_size == NULL || int_data_size <= 0)
CMP	R0, #0
IT	EQ
BEQ	L__atcacert_der_enc_integer127
CMP	R6, #0
IT	EQ
BEQ	L__atcacert_der_enc_integer126
CMP	R2, #0
IT	LS
BLS	L__atcacert_der_enc_integer125
IT	AL
BAL	L_atcacert_der_enc_integer29
; int_data end address is: 0 (R0)
; int_data_size end address is: 8 (R2)
; is_unsigned end address is: 4 (R1)
; der_int end address is: 12 (R3)
; der_int_size end address is: 24 (R6)
; trim end address is: 20 (R5)
; pad end address is: 28 (R7)
L__atcacert_der_enc_integer127:
L__atcacert_der_enc_integer126:
L__atcacert_der_enc_integer125:
;atcacert_der.c,137 :: 		return ATCACERT_E_BAD_PARAMS;
MOVS	R0, #2
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_enc_integer
L_atcacert_der_enc_integer29:
;atcacert_der.c,139 :: 		if (!(is_unsigned && (int_data[0] & 0x80))) {
; pad start address is: 28 (R7)
; trim start address is: 20 (R5)
; der_int_size start address is: 24 (R6)
; der_int start address is: 12 (R3)
; is_unsigned start address is: 4 (R1)
; int_data_size start address is: 8 (R2)
; int_data start address is: 0 (R0)
CMP	R1, #0
IT	EQ
BEQ	L_atcacert_der_enc_integer31
; is_unsigned end address is: 4 (R1)
LDRB	R4, [R0, #0]
AND	R4, R4, #128
UXTB	R4, R4
CMP	R4, #0
IT	EQ
BEQ	L_atcacert_der_enc_integer31
MOVS	R4, #1
IT	AL
BAL	L_atcacert_der_enc_integer30
L_atcacert_der_enc_integer31:
MOVS	R4, #0
L_atcacert_der_enc_integer30:
CMP	R4, #0
IT	NE
BNE	L_atcacert_der_enc_integer32
; int_data end address is: 0 (R0)
; int_data_size end address is: 8 (R2)
; der_int end address is: 12 (R3)
; der_int_size end address is: 24 (R6)
; trim end address is: 20 (R5)
; pad end address is: 28 (R7)
MOV	R12, R0
MOV	R11, R2
MOV	R10, R3
MOV	R1, R7
;atcacert_der.c,142 :: 		while (
L_atcacert_der_enc_integer33:
;atcacert_der.c,143 :: 		(int_data_size - trim >= 2) && (
; pad start address is: 4 (R1)
; trim start address is: 20 (R5)
; der_int_size start address is: 24 (R6)
; der_int start address is: 40 (R10)
; int_data_size start address is: 44 (R11)
; int_data start address is: 48 (R12)
SUB	R4, R11, R5, LSL #0
;atcacert_der.c,145 :: 		((int_data[trim] == 0xFF) && ((int_data[trim + 1] & 0x80) != 0))))
CMP	R4, #2
IT	CC
BCC	L__atcacert_der_enc_integer132
;atcacert_der.c,144 :: 		((int_data[trim] == 0x00) && ((int_data[trim + 1] & 0x80) == 0)) ||
ADD	R4, R12, R5, LSL #0
LDRB	R4, [R4, #0]
CMP	R4, #0
IT	NE
BNE	L__atcacert_der_enc_integer129
ADDS	R4, R5, #1
ADD	R4, R12, R4, LSL #0
LDRB	R4, [R4, #0]
AND	R4, R4, #128
UXTB	R4, R4
CMP	R4, #0
IT	NE
BNE	L__atcacert_der_enc_integer128
IT	AL
BAL	L__atcacert_der_enc_integer121
L__atcacert_der_enc_integer129:
L__atcacert_der_enc_integer128:
;atcacert_der.c,145 :: 		((int_data[trim] == 0xFF) && ((int_data[trim + 1] & 0x80) != 0))))
ADD	R4, R12, R5, LSL #0
LDRB	R4, [R4, #0]
CMP	R4, #255
IT	NE
BNE	L__atcacert_der_enc_integer131
ADDS	R4, R5, #1
ADD	R4, R12, R4, LSL #0
LDRB	R4, [R4, #0]
AND	R4, R4, #128
UXTB	R4, R4
CMP	R4, #0
IT	EQ
BEQ	L__atcacert_der_enc_integer130
IT	AL
BAL	L__atcacert_der_enc_integer121
L__atcacert_der_enc_integer131:
L__atcacert_der_enc_integer130:
IT	AL
BAL	L_atcacert_der_enc_integer34
L__atcacert_der_enc_integer121:
L__atcacert_der_enc_integer120:
;atcacert_der.c,146 :: 		trim++;
ADDS	R5, R5, #1
IT	AL
BAL	L_atcacert_der_enc_integer33
L_atcacert_der_enc_integer34:
;atcacert_der.c,145 :: 		((int_data[trim] == 0xFF) && ((int_data[trim + 1] & 0x80) != 0))))
L__atcacert_der_enc_integer132:
;atcacert_der.c,147 :: 		}else
; pad end address is: 4 (R1)
; der_int end address is: 40 (R10)
; int_data_size end address is: 44 (R11)
; int_data end address is: 48 (R12)
MOV	R9, R6
MOV	R8, R5
MOV	R7, R1
IT	AL
BAL	L_atcacert_der_enc_integer43
L_atcacert_der_enc_integer32:
;atcacert_der.c,149 :: 		pad = 1;
; pad start address is: 28 (R7)
; der_int start address is: 12 (R3)
; int_data_size start address is: 8 (R2)
; int_data start address is: 0 (R0)
MOVS	R7, #1
; int_data end address is: 0 (R0)
; int_data_size end address is: 8 (R2)
; der_int end address is: 12 (R3)
; der_int_size end address is: 24 (R6)
; trim end address is: 20 (R5)
; pad end address is: 28 (R7)
MOV	R12, R0
MOV	R11, R2
MOV	R10, R3
MOV	R9, R6
MOV	R8, R5
L_atcacert_der_enc_integer43:
;atcacert_der.c,151 :: 		ret = atcacert_der_enc_length(int_data_size + pad - trim, der_length, &der_length_size);
; pad start address is: 28 (R7)
; trim start address is: 32 (R8)
; der_int_size start address is: 36 (R9)
; der_int start address is: 40 (R10)
; int_data_size start address is: 44 (R11)
; int_data start address is: 48 (R12)
ADD	R6, SP, #16
ADD	R5, SP, #8
ADD	R4, R11, R7, LSL #0
SUB	R4, R4, R8, LSL #0
MOV	R2, R6
MOV	R1, R5
MOV	R0, R4
BL	_atcacert_der_enc_length+0
; ret start address is: 4 (R1)
SXTH	R1, R0
;atcacert_der.c,152 :: 		if (ret != ATCACERT_E_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_atcacert_der_enc_integer44
; pad end address is: 28 (R7)
; trim end address is: 32 (R8)
; der_int_size end address is: 36 (R9)
; der_int end address is: 40 (R10)
; int_data_size end address is: 44 (R11)
; int_data end address is: 48 (R12)
;atcacert_der.c,153 :: 		return ret;
SXTH	R0, R1
; ret end address is: 4 (R1)
IT	AL
BAL	L_end_atcacert_der_enc_integer
L_atcacert_der_enc_integer44:
;atcacert_der.c,155 :: 		der_int_size_calc = 1 + der_length_size + int_data_size + pad - trim;
; int_data start address is: 48 (R12)
; int_data_size start address is: 44 (R11)
; der_int start address is: 40 (R10)
; der_int_size start address is: 36 (R9)
; trim start address is: 32 (R8)
; pad start address is: 28 (R7)
LDR	R4, [SP, #16]
ADDS	R4, R4, #1
ADD	R4, R4, R11, LSL #0
ADDS	R4, R4, R7
SUB	R4, R4, R8, LSL #0
; der_int_size_calc start address is: 0 (R0)
MOV	R0, R4
;atcacert_der.c,157 :: 		if (der_int != NULL && der_int_size_calc > *der_int_size) {
CMP	R10, #0
IT	EQ
BEQ	L__atcacert_der_enc_integer134
LDR	R4, [R9, #0]
CMP	R0, R4
IT	LS
BLS	L__atcacert_der_enc_integer133
; pad end address is: 28 (R7)
; trim end address is: 32 (R8)
; der_int end address is: 40 (R10)
; int_data_size end address is: 44 (R11)
; int_data end address is: 48 (R12)
L__atcacert_der_enc_integer119:
;atcacert_der.c,158 :: 		*der_int_size = der_int_size_calc;
STR	R0, [R9, #0]
; der_int_size end address is: 36 (R9)
; der_int_size_calc end address is: 0 (R0)
;atcacert_der.c,159 :: 		return ATCACERT_E_BUFFER_TOO_SMALL;
MOVS	R0, #3
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_enc_integer
;atcacert_der.c,157 :: 		if (der_int != NULL && der_int_size_calc > *der_int_size) {
L__atcacert_der_enc_integer134:
; der_int_size_calc start address is: 0 (R0)
; int_data start address is: 48 (R12)
; int_data_size start address is: 44 (R11)
; der_int start address is: 40 (R10)
; der_int_size start address is: 36 (R9)
; trim start address is: 32 (R8)
; pad start address is: 28 (R7)
L__atcacert_der_enc_integer133:
;atcacert_der.c,162 :: 		*der_int_size = der_int_size_calc;
STR	R0, [R9, #0]
; der_int_size end address is: 36 (R9)
; der_int_size_calc end address is: 0 (R0)
;atcacert_der.c,164 :: 		if (der_int == NULL)
CMP	R10, #0
IT	NE
BNE	L_atcacert_der_enc_integer48
; pad end address is: 28 (R7)
; trim end address is: 32 (R8)
; der_int end address is: 40 (R10)
; int_data_size end address is: 44 (R11)
; int_data end address is: 48 (R12)
;atcacert_der.c,165 :: 		return ATCACERT_E_SUCCESS;                                                      // Caller just wanted the size of the encoded integer
MOVS	R0, #0
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_enc_integer
L_atcacert_der_enc_integer48:
;atcacert_der.c,167 :: 		der_int[0] = 0x02;                                                                  // Integer tag
; int_data start address is: 48 (R12)
; int_data_size start address is: 44 (R11)
; der_int start address is: 40 (R10)
; trim start address is: 32 (R8)
; pad start address is: 28 (R7)
MOVS	R4, #2
STRB	R4, [R10, #0]
;atcacert_der.c,168 :: 		memcpy(&der_int[1], der_length, der_length_size);                                   // Integer length
ADD	R5, SP, #8
ADD	R4, R10, #1
LDR	R2, [SP, #16]
MOV	R1, R5
MOV	R0, R4
BL	_memcpy+0
;atcacert_der.c,169 :: 		if (pad)
CMP	R7, #0
IT	EQ
BEQ	L_atcacert_der_enc_integer49
;atcacert_der.c,170 :: 		der_int[der_length_size + 1] = 0;                                               // Unsigned integer value requires padding byte so it's not interpreted as negative
LDR	R4, [SP, #16]
ADDS	R4, R4, #1
ADD	R5, R10, R4, LSL #0
MOVS	R4, #0
STRB	R4, [R5, #0]
L_atcacert_der_enc_integer49:
;atcacert_der.c,171 :: 		memcpy(&der_int[der_length_size + 1 + pad], &int_data[trim], int_data_size - trim); // Integer value
SUB	R6, R11, R8, LSL #0
; int_data_size end address is: 44 (R11)
ADD	R5, R12, R8, LSL #0
; trim end address is: 32 (R8)
; int_data end address is: 48 (R12)
LDR	R4, [SP, #16]
ADDS	R4, R4, #1
ADDS	R4, R4, R7
; pad end address is: 28 (R7)
ADD	R4, R10, R4, LSL #0
; der_int end address is: 40 (R10)
SXTH	R2, R6
MOV	R1, R5
MOV	R0, R4
BL	_memcpy+0
;atcacert_der.c,173 :: 		return ATCACERT_E_SUCCESS;
MOVS	R0, #0
SXTH	R0, R0
;atcacert_der.c,174 :: 		}
L_end_atcacert_der_enc_integer:
LDR	LR, [SP, #0]
ADD	SP, SP, #20
BX	LR
; end of _atcacert_der_enc_integer
_atcacert_der_dec_integer:
;atcacert_der.c,179 :: 		size_t*        int_data_size)
; int_data_size start address is: 12 (R3)
; int_data start address is: 8 (R2)
; der_int_size start address is: 4 (R1)
; der_int start address is: 0 (R0)
SUB	SP, SP, #24
STR	LR, [SP, #0]
MOV	R8, R0
; int_data_size end address is: 12 (R3)
; int_data end address is: 8 (R2)
; der_int_size end address is: 4 (R1)
; der_int end address is: 0 (R0)
; der_int start address is: 32 (R8)
; der_int_size start address is: 4 (R1)
; int_data start address is: 8 (R2)
; int_data_size start address is: 12 (R3)
;atcacert_der.c,181 :: 		int ret = 0;
;atcacert_der.c,182 :: 		size_t der_length_size = 0;
ADD	R11, SP, #16
ADD	R10, R11, #8
MOVW	R12, #lo_addr(?ICSatcacert_der_dec_integer_der_length_size_L0+0)
MOVT	R12, #hi_addr(?ICSatcacert_der_dec_integer_der_length_size_L0+0)
BL	___CC2DW+0
;atcacert_der.c,183 :: 		uint32_t int_data_size_calc = 0;
;atcacert_der.c,185 :: 		if (der_int == NULL || der_int_size == NULL || (int_data != NULL && int_data_size == NULL))
CMP	R8, #0
IT	EQ
BEQ	L__atcacert_der_dec_integer142
CMP	R1, #0
IT	EQ
BEQ	L__atcacert_der_dec_integer141
CMP	R2, #0
IT	EQ
BEQ	L__atcacert_der_dec_integer140
CMP	R3, #0
IT	NE
BNE	L__atcacert_der_dec_integer139
; der_int end address is: 32 (R8)
; der_int_size end address is: 4 (R1)
; int_data end address is: 8 (R2)
; int_data_size end address is: 12 (R3)
IT	AL
BAL	L__atcacert_der_dec_integer137
L__atcacert_der_dec_integer140:
; int_data_size start address is: 12 (R3)
; int_data start address is: 8 (R2)
; der_int_size start address is: 4 (R1)
; der_int start address is: 32 (R8)
L__atcacert_der_dec_integer139:
IT	AL
BAL	L_atcacert_der_dec_integer54
; der_int end address is: 32 (R8)
; der_int_size end address is: 4 (R1)
; int_data end address is: 8 (R2)
; int_data_size end address is: 12 (R3)
L__atcacert_der_dec_integer137:
L__atcacert_der_dec_integer142:
L__atcacert_der_dec_integer141:
;atcacert_der.c,186 :: 		return ATCACERT_E_BAD_PARAMS;
MOVS	R0, #2
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_dec_integer
L_atcacert_der_dec_integer54:
;atcacert_der.c,188 :: 		if (*der_int_size < 1)
; int_data_size start address is: 12 (R3)
; int_data start address is: 8 (R2)
; der_int_size start address is: 4 (R1)
; der_int start address is: 32 (R8)
LDR	R4, [R1, #0]
CMP	R4, #1
IT	CS
BCS	L_atcacert_der_dec_integer55
; der_int end address is: 32 (R8)
; der_int_size end address is: 4 (R1)
; int_data end address is: 8 (R2)
; int_data_size end address is: 12 (R3)
;atcacert_der.c,189 :: 		return ATCACERT_E_DECODING_ERROR; // No data to decode
MOVS	R0, #4
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_dec_integer
L_atcacert_der_dec_integer55:
;atcacert_der.c,191 :: 		if (der_int[0] != 0x02)
; int_data_size start address is: 12 (R3)
; int_data start address is: 8 (R2)
; der_int_size start address is: 4 (R1)
; der_int start address is: 32 (R8)
LDRB	R4, [R8, #0]
CMP	R4, #2
IT	EQ
BEQ	L_atcacert_der_dec_integer56
; der_int end address is: 32 (R8)
; der_int_size end address is: 4 (R1)
; int_data end address is: 8 (R2)
; int_data_size end address is: 12 (R3)
;atcacert_der.c,192 :: 		return ATCACERT_E_DECODING_ERROR; // Not an integer tag
MOVS	R0, #4
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_dec_integer
L_atcacert_der_dec_integer56:
;atcacert_der.c,194 :: 		der_length_size = *der_int_size - 1;
; int_data_size start address is: 12 (R3)
; int_data start address is: 8 (R2)
; der_int_size start address is: 4 (R1)
; der_int start address is: 32 (R8)
LDR	R4, [R1, #0]
SUBS	R4, R4, #1
STR	R4, [SP, #16]
;atcacert_der.c,195 :: 		ret = atcacert_der_dec_length(&der_int[1], &der_length_size, &int_data_size_calc);
ADD	R6, SP, #20
ADD	R5, SP, #16
ADD	R4, R8, #1
STR	R3, [SP, #4]
STR	R2, [SP, #8]
STR	R1, [SP, #12]
MOV	R2, R6
MOV	R1, R5
MOV	R0, R4
BL	_atcacert_der_dec_length+0
LDR	R1, [SP, #12]
LDR	R2, [SP, #8]
LDR	R3, [SP, #4]
; ret start address is: 16 (R4)
SXTH	R4, R0
;atcacert_der.c,196 :: 		if (ret != ATCACERT_E_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_atcacert_der_dec_integer57
; der_int end address is: 32 (R8)
; der_int_size end address is: 4 (R1)
; int_data end address is: 8 (R2)
; int_data_size end address is: 12 (R3)
;atcacert_der.c,197 :: 		return ret;
SXTH	R0, R4
; ret end address is: 16 (R4)
IT	AL
BAL	L_end_atcacert_der_dec_integer
L_atcacert_der_dec_integer57:
;atcacert_der.c,199 :: 		if (*der_int_size < (1 + der_length_size + int_data_size_calc))
; int_data_size start address is: 12 (R3)
; int_data start address is: 8 (R2)
; der_int_size start address is: 4 (R1)
; der_int start address is: 32 (R8)
LDR	R6, [R1, #0]
LDR	R4, [SP, #16]
ADDS	R5, R4, #1
LDR	R4, [SP, #20]
ADDS	R4, R5, R4
CMP	R6, R4
IT	CS
BCS	L_atcacert_der_dec_integer58
; der_int end address is: 32 (R8)
; der_int_size end address is: 4 (R1)
; int_data end address is: 8 (R2)
; int_data_size end address is: 12 (R3)
;atcacert_der.c,200 :: 		return ATCACERT_E_DECODING_ERROR; // Invalid DER integer, not enough data.
MOVS	R0, #4
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_dec_integer
L_atcacert_der_dec_integer58:
;atcacert_der.c,202 :: 		*der_int_size = (1 + der_length_size + int_data_size_calc);
; int_data_size start address is: 12 (R3)
; int_data start address is: 8 (R2)
; der_int_size start address is: 4 (R1)
; der_int start address is: 32 (R8)
LDR	R4, [SP, #16]
ADDS	R5, R4, #1
LDR	R4, [SP, #20]
ADDS	R4, R5, R4
STR	R4, [R1, #0]
; der_int_size end address is: 4 (R1)
;atcacert_der.c,204 :: 		if (int_data == NULL && int_data_size == NULL)
CMP	R2, #0
IT	NE
BNE	L__atcacert_der_dec_integer144
CMP	R3, #0
IT	NE
BNE	L__atcacert_der_dec_integer143
; der_int end address is: 32 (R8)
; int_data end address is: 8 (R2)
; int_data_size end address is: 12 (R3)
L__atcacert_der_dec_integer136:
;atcacert_der.c,205 :: 		return ATCACERT_E_SUCCESS; // Caller doesn't want the actual data, just the der_int_size
MOVS	R0, #0
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_dec_integer
;atcacert_der.c,204 :: 		if (int_data == NULL && int_data_size == NULL)
L__atcacert_der_dec_integer144:
; int_data_size start address is: 12 (R3)
; int_data start address is: 8 (R2)
; der_int start address is: 32 (R8)
L__atcacert_der_dec_integer143:
;atcacert_der.c,207 :: 		if (int_data != NULL && *int_data_size < int_data_size_calc) {
CMP	R2, #0
IT	EQ
BEQ	L__atcacert_der_dec_integer146
LDR	R5, [R3, #0]
LDR	R4, [SP, #20]
CMP	R5, R4
IT	CS
BCS	L__atcacert_der_dec_integer145
; der_int end address is: 32 (R8)
; int_data end address is: 8 (R2)
L__atcacert_der_dec_integer135:
;atcacert_der.c,208 :: 		*int_data_size = int_data_size_calc;
LDR	R4, [SP, #20]
STR	R4, [R3, #0]
; int_data_size end address is: 12 (R3)
;atcacert_der.c,209 :: 		return ATCACERT_E_BUFFER_TOO_SMALL;
MOVS	R0, #3
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_dec_integer
;atcacert_der.c,207 :: 		if (int_data != NULL && *int_data_size < int_data_size_calc) {
L__atcacert_der_dec_integer146:
; int_data_size start address is: 12 (R3)
; int_data start address is: 8 (R2)
; der_int start address is: 32 (R8)
L__atcacert_der_dec_integer145:
;atcacert_der.c,212 :: 		*int_data_size = int_data_size_calc;
LDR	R4, [SP, #20]
STR	R4, [R3, #0]
; int_data_size end address is: 12 (R3)
;atcacert_der.c,214 :: 		if (int_data == NULL)
CMP	R2, #0
IT	NE
BNE	L_atcacert_der_dec_integer65
; der_int end address is: 32 (R8)
; int_data end address is: 8 (R2)
;atcacert_der.c,215 :: 		return ATCACERT_E_SUCCESS; // Caller doesn't want the actual data, just the int_data_size
MOVS	R0, #0
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_dec_integer
L_atcacert_der_dec_integer65:
;atcacert_der.c,217 :: 		memcpy(int_data, &der_int[1 + der_length_size], int_data_size_calc);
; int_data start address is: 8 (R2)
; der_int start address is: 32 (R8)
LDR	R4, [SP, #16]
ADDS	R4, R4, #1
ADD	R4, R8, R4, LSL #0
; der_int end address is: 32 (R8)
MOV	R1, R4
MOV	R0, R2
LDR	R2, [SP, #20]
; int_data end address is: 8 (R2)
BL	_memcpy+0
;atcacert_der.c,219 :: 		return ATCACERT_E_SUCCESS;
MOVS	R0, #0
SXTH	R0, R0
;atcacert_der.c,220 :: 		}
L_end_atcacert_der_dec_integer:
LDR	LR, [SP, #0]
ADD	SP, SP, #24
BX	LR
; end of _atcacert_der_dec_integer
_atcacert_der_enc_ecdsa_sig_value:
;atcacert_der.c,224 :: 		size_t*       der_sig_size)
; der_sig_size start address is: 8 (R2)
; der_sig start address is: 4 (R1)
; raw_sig start address is: 0 (R0)
SUB	SP, SP, #24
STR	LR, [SP, #0]
MOV	R5, R2
MOV	R2, R1
MOV	R1, R0
; der_sig_size end address is: 8 (R2)
; der_sig end address is: 4 (R1)
; raw_sig end address is: 0 (R0)
; raw_sig start address is: 4 (R1)
; der_sig start address is: 8 (R2)
; der_sig_size start address is: 20 (R5)
;atcacert_der.c,226 :: 		int ret = 0;
;atcacert_der.c,227 :: 		size_t r_size = 0;
ADD	R11, SP, #16
ADD	R10, R11, #8
MOVW	R12, #lo_addr(?ICSatcacert_der_enc_ecdsa_sig_value_r_size_L0+0)
MOVT	R12, #hi_addr(?ICSatcacert_der_enc_ecdsa_sig_value_r_size_L0+0)
BL	___CC2DW+0
;atcacert_der.c,228 :: 		size_t s_size = 0;
;atcacert_der.c,229 :: 		size_t der_sig_size_calc = 0;
;atcacert_der.c,231 :: 		if (raw_sig == NULL || der_sig_size == NULL)
CMP	R1, #0
IT	EQ
BEQ	L__atcacert_der_enc_ecdsa_sig_value150
CMP	R5, #0
IT	EQ
BEQ	L__atcacert_der_enc_ecdsa_sig_value149
IT	AL
BAL	L_atcacert_der_enc_ecdsa_sig_value68
; raw_sig end address is: 4 (R1)
; der_sig end address is: 8 (R2)
; der_sig_size end address is: 20 (R5)
L__atcacert_der_enc_ecdsa_sig_value150:
L__atcacert_der_enc_ecdsa_sig_value149:
;atcacert_der.c,232 :: 		return ATCACERT_E_BAD_PARAMS;
MOVS	R0, #2
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_enc_ecdsa_sig_value
L_atcacert_der_enc_ecdsa_sig_value68:
;atcacert_der.c,235 :: 		ret = atcacert_der_enc_integer(&raw_sig[0], 32, TRUE, NULL, &r_size);
; der_sig_size start address is: 20 (R5)
; der_sig start address is: 8 (R2)
; raw_sig start address is: 4 (R1)
ADD	R3, SP, #16
STR	R5, [SP, #4]
STR	R2, [SP, #8]
STR	R1, [SP, #12]
PUSH	(R3)
MOVS	R3, #0
MOVS	R2, #1
MOV	R0, R1
MOVS	R1, #32
BL	_atcacert_der_enc_integer+0
ADD	SP, SP, #4
LDR	R1, [SP, #12]
LDR	R2, [SP, #8]
LDR	R5, [SP, #4]
; ret start address is: 12 (R3)
SXTH	R3, R0
;atcacert_der.c,236 :: 		if (ret != ATCACERT_E_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_atcacert_der_enc_ecdsa_sig_value69
; raw_sig end address is: 4 (R1)
; der_sig end address is: 8 (R2)
; der_sig_size end address is: 20 (R5)
;atcacert_der.c,237 :: 		return ret;
SXTH	R0, R3
; ret end address is: 12 (R3)
IT	AL
BAL	L_end_atcacert_der_enc_ecdsa_sig_value
L_atcacert_der_enc_ecdsa_sig_value69:
;atcacert_der.c,240 :: 		ret = atcacert_der_enc_integer(&raw_sig[32], 32, TRUE, NULL, &s_size);
; der_sig_size start address is: 20 (R5)
; der_sig start address is: 8 (R2)
; raw_sig start address is: 4 (R1)
ADD	R4, SP, #20
ADDW	R3, R1, #32
STR	R5, [SP, #4]
STR	R2, [SP, #8]
STR	R1, [SP, #12]
MOVS	R2, #1
MOVS	R1, #32
MOV	R0, R3
MOVS	R3, #0
PUSH	(R4)
BL	_atcacert_der_enc_integer+0
ADD	SP, SP, #4
LDR	R1, [SP, #12]
LDR	R2, [SP, #8]
LDR	R5, [SP, #4]
; ret start address is: 12 (R3)
SXTH	R3, R0
;atcacert_der.c,241 :: 		if (ret != ATCACERT_E_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_atcacert_der_enc_ecdsa_sig_value70
; raw_sig end address is: 4 (R1)
; der_sig end address is: 8 (R2)
; der_sig_size end address is: 20 (R5)
;atcacert_der.c,242 :: 		return ret;
SXTH	R0, R3
; ret end address is: 12 (R3)
IT	AL
BAL	L_end_atcacert_der_enc_ecdsa_sig_value
L_atcacert_der_enc_ecdsa_sig_value70:
;atcacert_der.c,246 :: 		der_sig_size_calc = 5 + r_size + s_size;
; der_sig_size start address is: 20 (R5)
; der_sig start address is: 8 (R2)
; raw_sig start address is: 4 (R1)
LDR	R3, [SP, #16]
ADDS	R4, R3, #5
LDR	R3, [SP, #20]
ADDS	R3, R4, R3
; der_sig_size_calc start address is: 0 (R0)
MOV	R0, R3
;atcacert_der.c,248 :: 		if (der_sig != NULL && *der_sig_size < der_sig_size_calc) {
CMP	R2, #0
IT	EQ
BEQ	L__atcacert_der_enc_ecdsa_sig_value152
LDR	R3, [R5, #0]
CMP	R3, R0
IT	CS
BCS	L__atcacert_der_enc_ecdsa_sig_value151
; raw_sig end address is: 4 (R1)
; der_sig end address is: 8 (R2)
L__atcacert_der_enc_ecdsa_sig_value147:
;atcacert_der.c,249 :: 		*der_sig_size = der_sig_size_calc;
STR	R0, [R5, #0]
; der_sig_size end address is: 20 (R5)
; der_sig_size_calc end address is: 0 (R0)
;atcacert_der.c,250 :: 		return ATCACERT_E_BUFFER_TOO_SMALL;
MOVS	R0, #3
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_enc_ecdsa_sig_value
;atcacert_der.c,248 :: 		if (der_sig != NULL && *der_sig_size < der_sig_size_calc) {
L__atcacert_der_enc_ecdsa_sig_value152:
; der_sig_size_calc start address is: 0 (R0)
; der_sig_size start address is: 20 (R5)
; der_sig start address is: 8 (R2)
; raw_sig start address is: 4 (R1)
L__atcacert_der_enc_ecdsa_sig_value151:
;atcacert_der.c,253 :: 		*der_sig_size = der_sig_size_calc;
STR	R0, [R5, #0]
; der_sig_size end address is: 20 (R5)
;atcacert_der.c,255 :: 		if (der_sig == NULL)
CMP	R2, #0
IT	NE
BNE	L_atcacert_der_enc_ecdsa_sig_value74
; raw_sig end address is: 4 (R1)
; der_sig end address is: 8 (R2)
; der_sig_size_calc end address is: 0 (R0)
;atcacert_der.c,256 :: 		return ATCACERT_E_SUCCESS;                  // Caller just wanted the encoded size
MOVS	R0, #0
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_enc_ecdsa_sig_value
L_atcacert_der_enc_ecdsa_sig_value74:
;atcacert_der.c,258 :: 		der_sig[0] = 0x03;                              // signatureValue bit string tag
; der_sig_size_calc start address is: 0 (R0)
; der_sig start address is: 8 (R2)
; raw_sig start address is: 4 (R1)
MOVS	R3, #3
STRB	R3, [R2, #0]
;atcacert_der.c,259 :: 		der_sig[1] = (uint8_t)(der_sig_size_calc - 2);  // signatureValue bit string length
ADDS	R4, R2, #1
SUBS	R3, R0, #2
UXTB	R3, R3
STRB	R3, [R4, #0]
;atcacert_der.c,260 :: 		der_sig[2] = 0x00;                              // signatureValue bit string spare bits
ADDS	R4, R2, #2
MOVS	R3, #0
STRB	R3, [R4, #0]
;atcacert_der.c,263 :: 		der_sig[3] = 0x30;                              // sequence tag
ADDS	R4, R2, #3
MOVS	R3, #48
STRB	R3, [R4, #0]
;atcacert_der.c,264 :: 		der_sig[4] = (uint8_t)(der_sig_size_calc - 5);  // sequence length
ADDS	R4, R2, #4
SUBS	R3, R0, #5
; der_sig_size_calc end address is: 0 (R0)
UXTB	R3, R3
STRB	R3, [R4, #0]
;atcacert_der.c,267 :: 		ret = atcacert_der_enc_integer(&raw_sig[0], 32, TRUE, &der_sig[5], &r_size);
ADD	R4, SP, #16
ADDS	R3, R2, #5
STR	R2, [SP, #4]
STR	R1, [SP, #8]
MOVS	R2, #1
MOV	R0, R1
MOVS	R1, #32
PUSH	(R4)
BL	_atcacert_der_enc_integer+0
ADD	SP, SP, #4
LDR	R1, [SP, #8]
LDR	R2, [SP, #4]
; ret start address is: 12 (R3)
SXTH	R3, R0
;atcacert_der.c,268 :: 		if (ret != ATCACERT_E_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_atcacert_der_enc_ecdsa_sig_value75
; raw_sig end address is: 4 (R1)
; der_sig end address is: 8 (R2)
;atcacert_der.c,269 :: 		return ret;
SXTH	R0, R3
; ret end address is: 12 (R3)
IT	AL
BAL	L_end_atcacert_der_enc_ecdsa_sig_value
L_atcacert_der_enc_ecdsa_sig_value75:
;atcacert_der.c,272 :: 		ret = atcacert_der_enc_integer(&raw_sig[32], 32, TRUE, &der_sig[5 + r_size], &s_size);
; der_sig start address is: 8 (R2)
; raw_sig start address is: 4 (R1)
ADD	R5, SP, #20
LDR	R3, [SP, #16]
ADDS	R3, R3, #5
ADDS	R4, R2, R3
; der_sig end address is: 8 (R2)
ADDW	R3, R1, #32
; raw_sig end address is: 4 (R1)
MOVS	R2, #1
MOVS	R1, #32
MOV	R0, R3
MOV	R3, R4
PUSH	(R5)
BL	_atcacert_der_enc_integer+0
ADD	SP, SP, #4
; ret start address is: 4 (R1)
SXTH	R1, R0
;atcacert_der.c,273 :: 		if (ret != ATCACERT_E_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_atcacert_der_enc_ecdsa_sig_value76
;atcacert_der.c,274 :: 		return ret;
SXTH	R0, R1
; ret end address is: 4 (R1)
IT	AL
BAL	L_end_atcacert_der_enc_ecdsa_sig_value
L_atcacert_der_enc_ecdsa_sig_value76:
;atcacert_der.c,276 :: 		return ATCACERT_E_SUCCESS;
MOVS	R0, #0
SXTH	R0, R0
;atcacert_der.c,277 :: 		}
L_end_atcacert_der_enc_ecdsa_sig_value:
LDR	LR, [SP, #0]
ADD	SP, SP, #24
BX	LR
; end of _atcacert_der_enc_ecdsa_sig_value
_atcacert_der_dec_ecdsa_sig_value:
;atcacert_der.c,281 :: 		uint8_t raw_sig[64])
; raw_sig start address is: 8 (R2)
; der_sig_size start address is: 4 (R1)
; der_sig start address is: 0 (R0)
SUB	SP, SP, #80
STR	LR, [SP, #0]
MOV	R7, R0
; raw_sig end address is: 8 (R2)
; der_sig_size end address is: 4 (R1)
; der_sig end address is: 0 (R0)
; der_sig start address is: 28 (R7)
; der_sig_size start address is: 4 (R1)
; raw_sig start address is: 8 (R2)
;atcacert_der.c,283 :: 		int ret = 0;
;atcacert_der.c,284 :: 		size_t curr_idx = 0;
;atcacert_der.c,285 :: 		size_t dec_size = 0;
ADD	R11, SP, #56
ADD	R10, R11, #24
MOVW	R12, #lo_addr(?ICSatcacert_der_dec_ecdsa_sig_value_dec_size_L0+0)
MOVT	R12, #hi_addr(?ICSatcacert_der_dec_ecdsa_sig_value_dec_size_L0+0)
BL	___CC2DW+0
;atcacert_der.c,286 :: 		uint32_t bs_length = 0;
;atcacert_der.c,287 :: 		uint32_t seq_length = 0;
;atcacert_der.c,288 :: 		size_t r_size = 0;
;atcacert_der.c,289 :: 		size_t s_size = 0;
;atcacert_der.c,291 :: 		size_t int_data_size = 0;
;atcacert_der.c,293 :: 		if (der_sig == NULL || der_sig_size == NULL)
CMP	R7, #0
IT	EQ
BEQ	L__atcacert_der_dec_ecdsa_sig_value155
CMP	R1, #0
IT	EQ
BEQ	L__atcacert_der_dec_ecdsa_sig_value154
IT	AL
BAL	L_atcacert_der_dec_ecdsa_sig_value79
; der_sig end address is: 28 (R7)
; der_sig_size end address is: 4 (R1)
; raw_sig end address is: 8 (R2)
L__atcacert_der_dec_ecdsa_sig_value155:
L__atcacert_der_dec_ecdsa_sig_value154:
;atcacert_der.c,294 :: 		return ATCACERT_E_BAD_PARAMS;
MOVS	R0, #2
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_dec_ecdsa_sig_value
L_atcacert_der_dec_ecdsa_sig_value79:
;atcacert_der.c,296 :: 		if (*der_sig_size < 1)
; raw_sig start address is: 8 (R2)
; der_sig_size start address is: 4 (R1)
; der_sig start address is: 28 (R7)
LDR	R3, [R1, #0]
CMP	R3, #1
IT	CS
BCS	L_atcacert_der_dec_ecdsa_sig_value80
; der_sig end address is: 28 (R7)
; der_sig_size end address is: 4 (R1)
; raw_sig end address is: 8 (R2)
;atcacert_der.c,297 :: 		return ATCACERT_E_DECODING_ERROR; // No data to decode
MOVS	R0, #4
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_dec_ecdsa_sig_value
L_atcacert_der_dec_ecdsa_sig_value80:
;atcacert_der.c,300 :: 		curr_idx = 0;
; curr_idx start address is: 0 (R0)
; raw_sig start address is: 8 (R2)
; der_sig_size start address is: 4 (R1)
; der_sig start address is: 28 (R7)
MOVS	R0, #0
;atcacert_der.c,301 :: 		if (der_sig[curr_idx] != 0x03)
LDRB	R3, [R7, #0]
CMP	R3, #3
IT	EQ
BEQ	L_atcacert_der_dec_ecdsa_sig_value81
; der_sig end address is: 28 (R7)
; der_sig_size end address is: 4 (R1)
; raw_sig end address is: 8 (R2)
; curr_idx end address is: 0 (R0)
;atcacert_der.c,302 :: 		return ATCACERT_E_DECODING_ERROR; // Unexpected tag value
MOVS	R0, #4
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_dec_ecdsa_sig_value
L_atcacert_der_dec_ecdsa_sig_value81:
;atcacert_der.c,303 :: 		curr_idx++;
; curr_idx start address is: 0 (R0)
; raw_sig start address is: 8 (R2)
; der_sig_size start address is: 4 (R1)
; der_sig start address is: 28 (R7)
ADDS	R6, R0, #1
; curr_idx end address is: 0 (R0)
; curr_idx start address is: 32 (R8)
MOV	R8, R6
;atcacert_der.c,306 :: 		dec_size = *der_sig_size - curr_idx;
LDR	R3, [R1, #0]
SUB	R3, R3, R6
STR	R3, [SP, #56]
;atcacert_der.c,307 :: 		ret = atcacert_der_dec_length(&der_sig[curr_idx], &dec_size, &bs_length);
ADD	R5, SP, #60
ADD	R4, SP, #56
ADDS	R3, R7, R6
STR	R2, [SP, #4]
STR	R1, [SP, #8]
STR	R7, [SP, #12]
MOV	R2, R5
MOV	R1, R4
MOV	R0, R3
BL	_atcacert_der_dec_length+0
LDR	R7, [SP, #12]
LDR	R1, [SP, #8]
LDR	R2, [SP, #4]
; ret start address is: 12 (R3)
SXTH	R3, R0
;atcacert_der.c,308 :: 		if (ret != ATCACERT_E_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_atcacert_der_dec_ecdsa_sig_value82
; der_sig end address is: 28 (R7)
; der_sig_size end address is: 4 (R1)
; raw_sig end address is: 8 (R2)
; curr_idx end address is: 32 (R8)
;atcacert_der.c,309 :: 		return ret; // Failed to decode length
SXTH	R0, R3
; ret end address is: 12 (R3)
IT	AL
BAL	L_end_atcacert_der_dec_ecdsa_sig_value
L_atcacert_der_dec_ecdsa_sig_value82:
;atcacert_der.c,310 :: 		curr_idx += dec_size;
; curr_idx start address is: 32 (R8)
; raw_sig start address is: 8 (R2)
; der_sig_size start address is: 4 (R1)
; der_sig start address is: 28 (R7)
LDR	R3, [SP, #56]
ADD	R4, R8, R3, LSL #0
; curr_idx end address is: 32 (R8)
; curr_idx start address is: 0 (R0)
MOV	R0, R4
;atcacert_der.c,311 :: 		if (curr_idx + bs_length > *der_sig_size)
LDR	R3, [SP, #60]
ADDS	R4, R4, R3
LDR	R3, [R1, #0]
CMP	R4, R3
IT	LS
BLS	L_atcacert_der_dec_ecdsa_sig_value83
; der_sig end address is: 28 (R7)
; der_sig_size end address is: 4 (R1)
; raw_sig end address is: 8 (R2)
; curr_idx end address is: 0 (R0)
;atcacert_der.c,312 :: 		return ATCACERT_E_DECODING_ERROR; // Not enough data in buffer to decode the rest
MOVS	R0, #4
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_dec_ecdsa_sig_value
L_atcacert_der_dec_ecdsa_sig_value83:
;atcacert_der.c,315 :: 		if (curr_idx >= *der_sig_size)
; curr_idx start address is: 0 (R0)
; raw_sig start address is: 8 (R2)
; der_sig_size start address is: 4 (R1)
; der_sig start address is: 28 (R7)
LDR	R3, [R1, #0]
CMP	R0, R3
IT	CC
BCC	L_atcacert_der_dec_ecdsa_sig_value84
; der_sig end address is: 28 (R7)
; der_sig_size end address is: 4 (R1)
; raw_sig end address is: 8 (R2)
; curr_idx end address is: 0 (R0)
;atcacert_der.c,316 :: 		return ATCACERT_E_DECODING_ERROR;   // No data left
MOVS	R0, #4
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_dec_ecdsa_sig_value
L_atcacert_der_dec_ecdsa_sig_value84:
;atcacert_der.c,317 :: 		if (der_sig[curr_idx] != 0x00)
; curr_idx start address is: 0 (R0)
; raw_sig start address is: 8 (R2)
; der_sig_size start address is: 4 (R1)
; der_sig start address is: 28 (R7)
ADDS	R3, R7, R0
LDRB	R3, [R3, #0]
CMP	R3, #0
IT	EQ
BEQ	L_atcacert_der_dec_ecdsa_sig_value85
; der_sig end address is: 28 (R7)
; der_sig_size end address is: 4 (R1)
; raw_sig end address is: 8 (R2)
; curr_idx end address is: 0 (R0)
;atcacert_der.c,318 :: 		return ATCACERT_E_DECODING_ERROR;   // Unexpected spare bits value
MOVS	R0, #4
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_dec_ecdsa_sig_value
L_atcacert_der_dec_ecdsa_sig_value85:
;atcacert_der.c,319 :: 		curr_idx++;
; curr_idx start address is: 0 (R0)
; raw_sig start address is: 8 (R2)
; der_sig_size start address is: 4 (R1)
; der_sig start address is: 28 (R7)
ADDS	R4, R0, #1
MOV	R0, R4
;atcacert_der.c,324 :: 		if (curr_idx >= *der_sig_size)
LDR	R3, [R1, #0]
CMP	R4, R3
IT	CC
BCC	L_atcacert_der_dec_ecdsa_sig_value86
; der_sig end address is: 28 (R7)
; der_sig_size end address is: 4 (R1)
; raw_sig end address is: 8 (R2)
; curr_idx end address is: 0 (R0)
;atcacert_der.c,325 :: 		return ATCACERT_E_DECODING_ERROR;   // No data left
MOVS	R0, #4
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_dec_ecdsa_sig_value
L_atcacert_der_dec_ecdsa_sig_value86:
;atcacert_der.c,326 :: 		if (der_sig[curr_idx] != 0x30)
; curr_idx start address is: 0 (R0)
; raw_sig start address is: 8 (R2)
; der_sig_size start address is: 4 (R1)
; der_sig start address is: 28 (R7)
ADDS	R3, R7, R0
LDRB	R3, [R3, #0]
CMP	R3, #48
IT	EQ
BEQ	L_atcacert_der_dec_ecdsa_sig_value87
; der_sig end address is: 28 (R7)
; der_sig_size end address is: 4 (R1)
; raw_sig end address is: 8 (R2)
; curr_idx end address is: 0 (R0)
;atcacert_der.c,327 :: 		return ATCACERT_E_DECODING_ERROR;   // Unexpected tag value
MOVS	R0, #4
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_dec_ecdsa_sig_value
L_atcacert_der_dec_ecdsa_sig_value87:
;atcacert_der.c,328 :: 		curr_idx++;
; curr_idx start address is: 0 (R0)
; raw_sig start address is: 8 (R2)
; der_sig_size start address is: 4 (R1)
; der_sig start address is: 28 (R7)
ADDS	R4, R0, #1
; curr_idx end address is: 0 (R0)
; curr_idx start address is: 32 (R8)
MOV	R8, R4
;atcacert_der.c,331 :: 		if (curr_idx >= *der_sig_size)
LDR	R3, [R1, #0]
CMP	R4, R3
IT	CC
BCC	L_atcacert_der_dec_ecdsa_sig_value88
; der_sig end address is: 28 (R7)
; der_sig_size end address is: 4 (R1)
; raw_sig end address is: 8 (R2)
; curr_idx end address is: 32 (R8)
;atcacert_der.c,332 :: 		return ATCACERT_E_DECODING_ERROR; // No data left
MOVS	R0, #4
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_dec_ecdsa_sig_value
L_atcacert_der_dec_ecdsa_sig_value88:
;atcacert_der.c,333 :: 		dec_size = *der_sig_size - curr_idx;
; curr_idx start address is: 32 (R8)
; raw_sig start address is: 8 (R2)
; der_sig_size start address is: 4 (R1)
; der_sig start address is: 28 (R7)
LDR	R3, [R1, #0]
SUB	R3, R3, R8, LSL #0
STR	R3, [SP, #56]
;atcacert_der.c,334 :: 		ret = atcacert_der_dec_length(&der_sig[curr_idx], &dec_size, &seq_length);
ADD	R5, SP, #64
ADD	R4, SP, #56
ADD	R3, R7, R8, LSL #0
STR	R2, [SP, #4]
STR	R1, [SP, #8]
STR	R7, [SP, #12]
MOV	R2, R5
MOV	R1, R4
MOV	R0, R3
BL	_atcacert_der_dec_length+0
LDR	R7, [SP, #12]
LDR	R1, [SP, #8]
LDR	R2, [SP, #4]
; ret start address is: 12 (R3)
SXTH	R3, R0
;atcacert_der.c,335 :: 		if (ret != ATCACERT_E_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_atcacert_der_dec_ecdsa_sig_value89
; der_sig end address is: 28 (R7)
; der_sig_size end address is: 4 (R1)
; raw_sig end address is: 8 (R2)
; curr_idx end address is: 32 (R8)
;atcacert_der.c,336 :: 		return ret; // Failed to decode length
SXTH	R0, R3
; ret end address is: 12 (R3)
IT	AL
BAL	L_end_atcacert_der_dec_ecdsa_sig_value
L_atcacert_der_dec_ecdsa_sig_value89:
;atcacert_der.c,337 :: 		curr_idx += dec_size;
; curr_idx start address is: 32 (R8)
; raw_sig start address is: 8 (R2)
; der_sig_size start address is: 4 (R1)
; der_sig start address is: 28 (R7)
LDR	R3, [SP, #56]
ADD	R4, R8, R3, LSL #0
MOV	R8, R4
;atcacert_der.c,338 :: 		if (curr_idx + seq_length > *der_sig_size)
LDR	R3, [SP, #64]
ADDS	R4, R4, R3
LDR	R3, [R1, #0]
CMP	R4, R3
IT	LS
BLS	L_atcacert_der_dec_ecdsa_sig_value90
; der_sig end address is: 28 (R7)
; der_sig_size end address is: 4 (R1)
; raw_sig end address is: 8 (R2)
; curr_idx end address is: 32 (R8)
;atcacert_der.c,339 :: 		return ATCACERT_E_DECODING_ERROR; // Not enough data in buffer to decode the rest
MOVS	R0, #4
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_dec_ecdsa_sig_value
L_atcacert_der_dec_ecdsa_sig_value90:
;atcacert_der.c,342 :: 		if (curr_idx >= *der_sig_size)
; curr_idx start address is: 32 (R8)
; raw_sig start address is: 8 (R2)
; der_sig_size start address is: 4 (R1)
; der_sig start address is: 28 (R7)
LDR	R3, [R1, #0]
CMP	R8, R3
IT	CC
BCC	L_atcacert_der_dec_ecdsa_sig_value91
; der_sig end address is: 28 (R7)
; der_sig_size end address is: 4 (R1)
; raw_sig end address is: 8 (R2)
; curr_idx end address is: 32 (R8)
;atcacert_der.c,343 :: 		return ATCACERT_E_DECODING_ERROR; // No data left
MOVS	R0, #4
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_dec_ecdsa_sig_value
L_atcacert_der_dec_ecdsa_sig_value91:
;atcacert_der.c,344 :: 		r_size = *der_sig_size - curr_idx;
; curr_idx start address is: 32 (R8)
; raw_sig start address is: 8 (R2)
; der_sig_size start address is: 4 (R1)
; der_sig start address is: 28 (R7)
LDR	R3, [R1, #0]
SUB	R3, R3, R8, LSL #0
STR	R3, [SP, #68]
;atcacert_der.c,345 :: 		int_data_size = sizeof(int_data);
MOVS	R3, #33
STR	R3, [SP, #76]
;atcacert_der.c,346 :: 		ret = atcacert_der_dec_integer(&der_sig[curr_idx], &r_size, int_data, &int_data_size);
ADD	R6, SP, #76
ADD	R5, SP, #20
ADD	R4, SP, #68
ADD	R3, R7, R8, LSL #0
STR	R8, [SP, #4]
STR	R2, [SP, #8]
STR	R1, [SP, #12]
STR	R7, [SP, #16]
MOV	R2, R5
MOV	R1, R4
MOV	R0, R3
MOV	R3, R6
BL	_atcacert_der_dec_integer+0
LDR	R7, [SP, #16]
LDR	R1, [SP, #12]
LDR	R2, [SP, #8]
LDR	R8, [SP, #4]
; ret start address is: 12 (R3)
SXTH	R3, R0
;atcacert_der.c,347 :: 		if (ret != ATCACERT_E_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_atcacert_der_dec_ecdsa_sig_value92
; der_sig end address is: 28 (R7)
; der_sig_size end address is: 4 (R1)
; raw_sig end address is: 8 (R2)
; curr_idx end address is: 32 (R8)
;atcacert_der.c,348 :: 		return ret; // Failed to decode length
SXTH	R0, R3
; ret end address is: 12 (R3)
IT	AL
BAL	L_end_atcacert_der_dec_ecdsa_sig_value
L_atcacert_der_dec_ecdsa_sig_value92:
;atcacert_der.c,349 :: 		curr_idx += r_size;
; curr_idx start address is: 32 (R8)
; raw_sig start address is: 8 (R2)
; der_sig_size start address is: 4 (R1)
; der_sig start address is: 28 (R7)
LDR	R3, [SP, #68]
ADD	R8, R8, R3, LSL #0
;atcacert_der.c,351 :: 		if (raw_sig != NULL)
CMP	R2, #0
IT	EQ
BEQ	L_atcacert_der_dec_ecdsa_sig_value93
;atcacert_der.c,352 :: 		memset(raw_sig, 0, 64); // Zero out the raw sig as the decoded integers may not touch all bytes
STR	R2, [SP, #4]
STR	R1, [SP, #8]
MOVS	R1, #0
MOV	R0, R2
MOVS	R2, #64
SXTH	R2, R2
BL	_memset+0
LDR	R1, [SP, #8]
LDR	R2, [SP, #4]
L_atcacert_der_dec_ecdsa_sig_value93:
;atcacert_der.c,354 :: 		if (int_data_size <= 32) {
LDR	R3, [SP, #76]
CMP	R3, #32
IT	HI
BHI	L_atcacert_der_dec_ecdsa_sig_value94
;atcacert_der.c,355 :: 		if (raw_sig != NULL)
CMP	R2, #0
IT	EQ
BEQ	L_atcacert_der_dec_ecdsa_sig_value95
;atcacert_der.c,356 :: 		memcpy(&raw_sig[32 - int_data_size], &int_data[0], int_data_size);
ADD	R4, SP, #20
LDR	R3, [SP, #76]
RSB	R3, R3, #32
ADDS	R3, R2, R3
STR	R2, [SP, #4]
STR	R1, [SP, #8]
LDR	R2, [SP, #76]
MOV	R1, R4
MOV	R0, R3
BL	_memcpy+0
LDR	R1, [SP, #8]
LDR	R2, [SP, #4]
L_atcacert_der_dec_ecdsa_sig_value95:
;atcacert_der.c,357 :: 		}else if (int_data_size == 33) {
IT	AL
BAL	L_atcacert_der_dec_ecdsa_sig_value96
L_atcacert_der_dec_ecdsa_sig_value94:
LDR	R3, [SP, #76]
CMP	R3, #33
IT	NE
BNE	L_atcacert_der_dec_ecdsa_sig_value97
;atcacert_der.c,358 :: 		if (int_data[0] != 0x00)
ADD	R3, SP, #20
LDRB	R3, [R3, #0]
CMP	R3, #0
IT	EQ
BEQ	L_atcacert_der_dec_ecdsa_sig_value98
; der_sig end address is: 28 (R7)
; der_sig_size end address is: 4 (R1)
; raw_sig end address is: 8 (R2)
; curr_idx end address is: 32 (R8)
;atcacert_der.c,359 :: 		return ATCACERT_E_DECODING_ERROR; // R integer is too large
MOVS	R0, #4
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_dec_ecdsa_sig_value
L_atcacert_der_dec_ecdsa_sig_value98:
;atcacert_der.c,361 :: 		if (raw_sig != NULL)
; curr_idx start address is: 32 (R8)
; raw_sig start address is: 8 (R2)
; der_sig_size start address is: 4 (R1)
; der_sig start address is: 28 (R7)
CMP	R2, #0
IT	EQ
BEQ	L_atcacert_der_dec_ecdsa_sig_value99
;atcacert_der.c,362 :: 		memcpy(&raw_sig[0], &int_data[1], 32);
ADD	R3, SP, #20
ADDS	R3, R3, #1
STR	R2, [SP, #4]
STR	R1, [SP, #8]
MOV	R1, R3
MOV	R0, R2
MOVS	R2, #32
SXTH	R2, R2
BL	_memcpy+0
LDR	R1, [SP, #8]
LDR	R2, [SP, #4]
L_atcacert_der_dec_ecdsa_sig_value99:
;atcacert_der.c,363 :: 		}else
IT	AL
BAL	L_atcacert_der_dec_ecdsa_sig_value100
; der_sig end address is: 28 (R7)
; der_sig_size end address is: 4 (R1)
; raw_sig end address is: 8 (R2)
; curr_idx end address is: 32 (R8)
L_atcacert_der_dec_ecdsa_sig_value97:
;atcacert_der.c,364 :: 		return ATCACERT_E_DECODING_ERROR; // R integer is too large
MOVS	R0, #4
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_dec_ecdsa_sig_value
L_atcacert_der_dec_ecdsa_sig_value100:
; curr_idx start address is: 32 (R8)
; raw_sig start address is: 8 (R2)
; der_sig_size start address is: 4 (R1)
; der_sig start address is: 28 (R7)
L_atcacert_der_dec_ecdsa_sig_value96:
;atcacert_der.c,367 :: 		if (curr_idx >= *der_sig_size)
LDR	R3, [R1, #0]
CMP	R8, R3
IT	CC
BCC	L_atcacert_der_dec_ecdsa_sig_value101
; der_sig end address is: 28 (R7)
; der_sig_size end address is: 4 (R1)
; raw_sig end address is: 8 (R2)
; curr_idx end address is: 32 (R8)
;atcacert_der.c,368 :: 		return ATCACERT_E_DECODING_ERROR; // No data left
MOVS	R0, #4
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_dec_ecdsa_sig_value
L_atcacert_der_dec_ecdsa_sig_value101:
;atcacert_der.c,369 :: 		s_size = *der_sig_size - curr_idx;
; curr_idx start address is: 32 (R8)
; raw_sig start address is: 8 (R2)
; der_sig_size start address is: 4 (R1)
; der_sig start address is: 28 (R7)
LDR	R3, [R1, #0]
SUB	R3, R3, R8, LSL #0
STR	R3, [SP, #72]
;atcacert_der.c,370 :: 		int_data_size = sizeof(int_data);
MOVS	R3, #33
STR	R3, [SP, #76]
;atcacert_der.c,371 :: 		ret = atcacert_der_dec_integer(&der_sig[curr_idx], &s_size, int_data, &int_data_size);
ADD	R6, SP, #76
ADD	R5, SP, #20
ADD	R4, SP, #72
ADD	R3, R7, R8, LSL #0
; der_sig end address is: 28 (R7)
STR	R8, [SP, #4]
STR	R2, [SP, #8]
STR	R1, [SP, #12]
MOV	R2, R5
MOV	R1, R4
MOV	R0, R3
MOV	R3, R6
BL	_atcacert_der_dec_integer+0
LDR	R1, [SP, #12]
LDR	R2, [SP, #8]
LDR	R8, [SP, #4]
; ret start address is: 12 (R3)
SXTH	R3, R0
;atcacert_der.c,372 :: 		if (ret != ATCACERT_E_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_atcacert_der_dec_ecdsa_sig_value102
; der_sig_size end address is: 4 (R1)
; raw_sig end address is: 8 (R2)
; curr_idx end address is: 32 (R8)
;atcacert_der.c,373 :: 		return ret; // Failed to decode length
SXTH	R0, R3
; ret end address is: 12 (R3)
IT	AL
BAL	L_end_atcacert_der_dec_ecdsa_sig_value
L_atcacert_der_dec_ecdsa_sig_value102:
;atcacert_der.c,374 :: 		curr_idx += s_size;
; curr_idx start address is: 32 (R8)
; raw_sig start address is: 8 (R2)
; der_sig_size start address is: 4 (R1)
LDR	R3, [SP, #72]
ADD	R3, R8, R3, LSL #0
; curr_idx end address is: 32 (R8)
; curr_idx start address is: 24 (R6)
MOV	R6, R3
;atcacert_der.c,376 :: 		if (int_data_size <= 32) {
LDR	R3, [SP, #76]
CMP	R3, #32
IT	HI
BHI	L_atcacert_der_dec_ecdsa_sig_value103
;atcacert_der.c,377 :: 		if (raw_sig != NULL)
CMP	R2, #0
IT	EQ
BEQ	L_atcacert_der_dec_ecdsa_sig_value104
;atcacert_der.c,378 :: 		memcpy(&raw_sig[64 - int_data_size], &int_data[0], int_data_size);
ADD	R4, SP, #20
LDR	R3, [SP, #76]
RSB	R3, R3, #64
ADDS	R3, R2, R3
; raw_sig end address is: 8 (R2)
STR	R1, [SP, #4]
LDR	R2, [SP, #76]
MOV	R1, R4
MOV	R0, R3
BL	_memcpy+0
LDR	R1, [SP, #4]
L_atcacert_der_dec_ecdsa_sig_value104:
;atcacert_der.c,379 :: 		}else if (int_data_size == 33) {
IT	AL
BAL	L_atcacert_der_dec_ecdsa_sig_value105
L_atcacert_der_dec_ecdsa_sig_value103:
; raw_sig start address is: 8 (R2)
LDR	R3, [SP, #76]
CMP	R3, #33
IT	NE
BNE	L_atcacert_der_dec_ecdsa_sig_value106
;atcacert_der.c,380 :: 		if (int_data[0] != 0x00)
ADD	R3, SP, #20
LDRB	R3, [R3, #0]
CMP	R3, #0
IT	EQ
BEQ	L_atcacert_der_dec_ecdsa_sig_value107
; der_sig_size end address is: 4 (R1)
; raw_sig end address is: 8 (R2)
; curr_idx end address is: 24 (R6)
;atcacert_der.c,381 :: 		return ATCACERT_E_DECODING_ERROR; // S integer is too large
MOVS	R0, #4
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_dec_ecdsa_sig_value
L_atcacert_der_dec_ecdsa_sig_value107:
;atcacert_der.c,383 :: 		if (raw_sig != NULL)
; curr_idx start address is: 24 (R6)
; raw_sig start address is: 8 (R2)
; der_sig_size start address is: 4 (R1)
CMP	R2, #0
IT	EQ
BEQ	L_atcacert_der_dec_ecdsa_sig_value108
;atcacert_der.c,384 :: 		memcpy(&raw_sig[32], &int_data[1], 32);
ADD	R3, SP, #20
ADDS	R4, R3, #1
ADDW	R3, R2, #32
; raw_sig end address is: 8 (R2)
STR	R1, [SP, #4]
MOVS	R2, #32
SXTH	R2, R2
MOV	R1, R4
MOV	R0, R3
BL	_memcpy+0
LDR	R1, [SP, #4]
L_atcacert_der_dec_ecdsa_sig_value108:
;atcacert_der.c,385 :: 		}else
IT	AL
BAL	L_atcacert_der_dec_ecdsa_sig_value109
; der_sig_size end address is: 4 (R1)
; curr_idx end address is: 24 (R6)
L_atcacert_der_dec_ecdsa_sig_value106:
;atcacert_der.c,386 :: 		return ATCACERT_E_DECODING_ERROR; // S integer is too large
MOVS	R0, #4
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_dec_ecdsa_sig_value
L_atcacert_der_dec_ecdsa_sig_value109:
; curr_idx start address is: 24 (R6)
; der_sig_size start address is: 4 (R1)
L_atcacert_der_dec_ecdsa_sig_value105:
;atcacert_der.c,388 :: 		if (seq_length != r_size + s_size)
LDR	R4, [SP, #72]
LDR	R3, [SP, #68]
ADDS	R4, R3, R4
LDR	R3, [SP, #64]
CMP	R3, R4
IT	EQ
BEQ	L_atcacert_der_dec_ecdsa_sig_value110
; der_sig_size end address is: 4 (R1)
; curr_idx end address is: 24 (R6)
;atcacert_der.c,389 :: 		return ATCACERT_E_DECODING_ERROR; // Unexpected extra data in sequence
MOVS	R0, #4
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_dec_ecdsa_sig_value
L_atcacert_der_dec_ecdsa_sig_value110:
;atcacert_der.c,391 :: 		if (bs_length != r_size + s_size + 3)
; curr_idx start address is: 24 (R6)
; der_sig_size start address is: 4 (R1)
LDR	R4, [SP, #72]
LDR	R3, [SP, #68]
ADDS	R3, R3, R4
ADDS	R4, R3, #3
LDR	R3, [SP, #60]
CMP	R3, R4
IT	EQ
BEQ	L_atcacert_der_dec_ecdsa_sig_value111
; der_sig_size end address is: 4 (R1)
; curr_idx end address is: 24 (R6)
;atcacert_der.c,392 :: 		return ATCACERT_E_DECODING_ERROR; // Unexpected extra data in bit string
MOVS	R0, #4
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_der_dec_ecdsa_sig_value
L_atcacert_der_dec_ecdsa_sig_value111:
;atcacert_der.c,394 :: 		*der_sig_size = curr_idx;
; curr_idx start address is: 24 (R6)
; der_sig_size start address is: 4 (R1)
STR	R6, [R1, #0]
; der_sig_size end address is: 4 (R1)
; curr_idx end address is: 24 (R6)
;atcacert_der.c,396 :: 		return ATCACERT_E_SUCCESS;
MOVS	R0, #0
SXTH	R0, R0
;atcacert_der.c,397 :: 		}
L_end_atcacert_der_dec_ecdsa_sig_value:
LDR	LR, [SP, #0]
ADD	SP, SP, #80
BX	LR
; end of _atcacert_der_dec_ecdsa_sig_value
