#line 1 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atcacert/atcacert_der.c"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_der.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stddef.h"



typedef long ptrdiff_t;


 typedef unsigned long size_t;

typedef unsigned long wchar_t;
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stddef.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"
#line 75 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_der.h"
int atcacert_der_enc_length(uint32_t length, uint8_t* der_length, size_t* der_length_size);
#line 89 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_der.h"
int atcacert_der_dec_length( uint8_t* der_length, size_t* der_length_size, uint32_t* length);
#line 106 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_der.h"
int atcacert_der_enc_integer( uint8_t* int_data,
 size_t int_data_size,
 uint8_t is_unsigned,
 uint8_t* der_int,
 size_t* der_int_size);
#line 128 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_der.h"
int atcacert_der_dec_integer( uint8_t* der_int,
 size_t* der_int_size,
 uint8_t* int_data,
 size_t* int_data_size);
#line 149 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_der.h"
int atcacert_der_enc_ecdsa_sig_value( uint8_t raw_sig[64],
 uint8_t* der_sig,
 size_t* der_sig_size);
#line 168 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_der.h"
int atcacert_der_dec_ecdsa_sig_value( uint8_t * der_sig,
 size_t * der_sig_size,
 uint8_t raw_sig[64]);
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/string.h"





void * memchr(void *p, char n, unsigned int v);
int memcmp(void *s1, void *s2, int n);
void * memcpy(void * d1, void * s1, int n);
void * memmove(void * to, void * from, int n);
void * memset(void * p1, char character, int n);
char * strcat(char * to, char * from);
char * strchr(char * ptr, char chr);
int strcmp(char * s1, char * s2);
char * strcpy(char * to, char * from);
int strlen(char * s);
char * strncat(char * to, char * from, int size);
char * strncpy(char * to, char * from, int size);
int strspn(char * str1, char * str2);
char strcspn(char * s1, char * s2);
int strncmp(char * s1, char * s2, char len);
char * strpbrk(char * s1, char * s2);
char * strrchr(char *ptr, char chr);
char * strstr(char * s1, char * s2);
char * strtok(char * s1, char * s2);
#line 46 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atcacert/atcacert_der.c"
int atcacert_der_enc_length(uint32_t length, uint8_t* der_length, size_t* der_length_size)
{
 size_t der_length_size_calc = 0;
 int exp = sizeof(length) - 1;

 if (der_length_size ==  ((void *)0) )
 return  2 ;

 if (length < 0x80) {

 der_length_size_calc = 1;
 exp = 0;
 }else {



 while (length / ((uint32_t)1 << (8 * exp)) == 0)
 exp--;

 der_length_size_calc = 2 + exp;
 }

 if (der_length !=  ((void *)0)  && *der_length_size < der_length_size_calc) {
 *der_length_size = der_length_size_calc;
 return  3 ;
 }

 *der_length_size = der_length_size_calc;

 if (der_length ==  ((void *)0) )
 return  0 ;


 for (; exp >= 0; exp--)
 der_length[der_length_size_calc - 1 - exp] = (uint8_t)((length >> (exp * 8)) & 0xFF);

 if (der_length_size_calc > 1)
 der_length[0] = 0x80 | (uint8_t)(der_length_size_calc - 1);

 return  0 ;
}

int atcacert_der_dec_length( uint8_t* der_length, size_t* der_length_size, uint32_t* length)
{
 if (der_length ==  ((void *)0)  || der_length_size ==  ((void *)0) )
 return  2 ;

 if (*der_length_size < 1)
 return  4 ;

 if (der_length[0] & 0x80) {

 size_t num_bytes = der_length[0] & 0x7F;
 size_t i;
 if (*der_length_size < num_bytes + 1)
 return  4 ;
 if (num_bytes == 0)
 return  4 ;
 if (num_bytes > sizeof(*length))
 return  4 ;

 if (length !=  ((void *)0) ) {

 *length = 0;
 for (i = 1; i <= num_bytes; i++)
 *length += der_length[i] * ((uint32_t)1 << (8 * (num_bytes - i)));
 }
 *der_length_size = num_bytes + 1;
 }else {
 if (length !=  ((void *)0) )
 *length = der_length[0];
 *der_length_size = 1;
 }

 return  0 ;
}

int atcacert_der_enc_integer( uint8_t* int_data,
 size_t int_data_size,
 uint8_t is_unsigned,
 uint8_t* der_int,
 size_t* der_int_size)
{
 uint8_t der_length[5];
 size_t der_length_size = sizeof(der_length);
 size_t der_int_size_calc = 0;
 size_t trim = 0;
 size_t pad = 0;
 int ret;

 if (int_data ==  ((void *)0)  || der_int_size ==  ((void *)0)  || int_data_size <= 0)
 return  2 ;

 if (!(is_unsigned && (int_data[0] & 0x80))) {


 while (
 (int_data_size - trim >= 2) && (
 ((int_data[trim] == 0x00) && ((int_data[trim + 1] & 0x80) == 0)) ||
 ((int_data[trim] == 0xFF) && ((int_data[trim + 1] & 0x80) != 0))))
 trim++;
 }else

 pad = 1;

 ret = atcacert_der_enc_length(int_data_size + pad - trim, der_length, &der_length_size);
 if (ret !=  0 )
 return ret;

 der_int_size_calc = 1 + der_length_size + int_data_size + pad - trim;

 if (der_int !=  ((void *)0)  && der_int_size_calc > *der_int_size) {
 *der_int_size = der_int_size_calc;
 return  3 ;
 }

 *der_int_size = der_int_size_calc;

 if (der_int ==  ((void *)0) )
 return  0 ;

 der_int[0] = 0x02;
 memcpy(&der_int[1], der_length, der_length_size);
 if (pad)
 der_int[der_length_size + 1] = 0;
 memcpy(&der_int[der_length_size + 1 + pad], &int_data[trim], int_data_size - trim);

 return  0 ;
}

int atcacert_der_dec_integer( uint8_t* der_int,
 size_t* der_int_size,
 uint8_t* int_data,
 size_t* int_data_size)
{
 int ret = 0;
 size_t der_length_size = 0;
 uint32_t int_data_size_calc = 0;

 if (der_int ==  ((void *)0)  || der_int_size ==  ((void *)0)  || (int_data !=  ((void *)0)  && int_data_size ==  ((void *)0) ))
 return  2 ;

 if (*der_int_size < 1)
 return  4 ;

 if (der_int[0] != 0x02)
 return  4 ;

 der_length_size = *der_int_size - 1;
 ret = atcacert_der_dec_length(&der_int[1], &der_length_size, &int_data_size_calc);
 if (ret !=  0 )
 return ret;

 if (*der_int_size < (1 + der_length_size + int_data_size_calc))
 return  4 ;

 *der_int_size = (1 + der_length_size + int_data_size_calc);

 if (int_data ==  ((void *)0)  && int_data_size ==  ((void *)0) )
 return  0 ;

 if (int_data !=  ((void *)0)  && *int_data_size < int_data_size_calc) {
 *int_data_size = int_data_size_calc;
 return  3 ;
 }

 *int_data_size = int_data_size_calc;

 if (int_data ==  ((void *)0) )
 return  0 ;

 memcpy(int_data, &der_int[1 + der_length_size], int_data_size_calc);

 return  0 ;
}

int atcacert_der_enc_ecdsa_sig_value( uint8_t raw_sig[64],
 uint8_t* der_sig,
 size_t* der_sig_size)
{
 int ret = 0;
 size_t r_size = 0;
 size_t s_size = 0;
 size_t der_sig_size_calc = 0;

 if (raw_sig ==  ((void *)0)  || der_sig_size ==  ((void *)0) )
 return  2 ;


 ret = atcacert_der_enc_integer(&raw_sig[0], 32,  (1) ,  ((void *)0) , &r_size);
 if (ret !=  0 )
 return ret;


 ret = atcacert_der_enc_integer(&raw_sig[32], 32,  (1) ,  ((void *)0) , &s_size);
 if (ret !=  0 )
 return ret;



 der_sig_size_calc = 5 + r_size + s_size;

 if (der_sig !=  ((void *)0)  && *der_sig_size < der_sig_size_calc) {
 *der_sig_size = der_sig_size_calc;
 return  3 ;
 }

 *der_sig_size = der_sig_size_calc;

 if (der_sig ==  ((void *)0) )
 return  0 ;

 der_sig[0] = 0x03;
 der_sig[1] = (uint8_t)(der_sig_size_calc - 2);
 der_sig[2] = 0x00;


 der_sig[3] = 0x30;
 der_sig[4] = (uint8_t)(der_sig_size_calc - 5);


 ret = atcacert_der_enc_integer(&raw_sig[0], 32,  (1) , &der_sig[5], &r_size);
 if (ret !=  0 )
 return ret;


 ret = atcacert_der_enc_integer(&raw_sig[32], 32,  (1) , &der_sig[5 + r_size], &s_size);
 if (ret !=  0 )
 return ret;

 return  0 ;
}

int atcacert_der_dec_ecdsa_sig_value( uint8_t* der_sig,
 size_t* der_sig_size,
 uint8_t raw_sig[64])
{
 int ret = 0;
 size_t curr_idx = 0;
 size_t dec_size = 0;
 uint32_t bs_length = 0;
 uint32_t seq_length = 0;
 size_t r_size = 0;
 size_t s_size = 0;
 uint8_t int_data[33];
 size_t int_data_size = 0;

 if (der_sig ==  ((void *)0)  || der_sig_size ==  ((void *)0) )
 return  2 ;

 if (*der_sig_size < 1)
 return  4 ;


 curr_idx = 0;
 if (der_sig[curr_idx] != 0x03)
 return  4 ;
 curr_idx++;


 dec_size = *der_sig_size - curr_idx;
 ret = atcacert_der_dec_length(&der_sig[curr_idx], &dec_size, &bs_length);
 if (ret !=  0 )
 return ret;
 curr_idx += dec_size;
 if (curr_idx + bs_length > *der_sig_size)
 return  4 ;


 if (curr_idx >= *der_sig_size)
 return  4 ;
 if (der_sig[curr_idx] != 0x00)
 return  4 ;
 curr_idx++;




 if (curr_idx >= *der_sig_size)
 return  4 ;
 if (der_sig[curr_idx] != 0x30)
 return  4 ;
 curr_idx++;


 if (curr_idx >= *der_sig_size)
 return  4 ;
 dec_size = *der_sig_size - curr_idx;
 ret = atcacert_der_dec_length(&der_sig[curr_idx], &dec_size, &seq_length);
 if (ret !=  0 )
 return ret;
 curr_idx += dec_size;
 if (curr_idx + seq_length > *der_sig_size)
 return  4 ;


 if (curr_idx >= *der_sig_size)
 return  4 ;
 r_size = *der_sig_size - curr_idx;
 int_data_size = sizeof(int_data);
 ret = atcacert_der_dec_integer(&der_sig[curr_idx], &r_size, int_data, &int_data_size);
 if (ret !=  0 )
 return ret;
 curr_idx += r_size;

 if (raw_sig !=  ((void *)0) )
 memset(raw_sig, 0, 64);

 if (int_data_size <= 32) {
 if (raw_sig !=  ((void *)0) )
 memcpy(&raw_sig[32 - int_data_size], &int_data[0], int_data_size);
 }else if (int_data_size == 33) {
 if (int_data[0] != 0x00)
 return  4 ;

 if (raw_sig !=  ((void *)0) )
 memcpy(&raw_sig[0], &int_data[1], 32);
 }else
 return  4 ;


 if (curr_idx >= *der_sig_size)
 return  4 ;
 s_size = *der_sig_size - curr_idx;
 int_data_size = sizeof(int_data);
 ret = atcacert_der_dec_integer(&der_sig[curr_idx], &s_size, int_data, &int_data_size);
 if (ret !=  0 )
 return ret;
 curr_idx += s_size;

 if (int_data_size <= 32) {
 if (raw_sig !=  ((void *)0) )
 memcpy(&raw_sig[64 - int_data_size], &int_data[0], int_data_size);
 }else if (int_data_size == 33) {
 if (int_data[0] != 0x00)
 return  4 ;

 if (raw_sig !=  ((void *)0) )
 memcpy(&raw_sig[32], &int_data[1], 32);
 }else
 return  4 ;

 if (seq_length != r_size + s_size)
 return  4 ;

 if (bs_length != r_size + s_size + 3)
 return  4 ;

 *der_sig_size = curr_idx;

 return  0 ;
}
