_atcacert_verify_cert_sw:
;atcacert_host_sw.c,50 :: 		uint8_t ca_public_key[64])
; ca_public_key start address is: 12 (R3)
; cert_size start address is: 8 (R2)
; cert start address is: 4 (R1)
; cert_def start address is: 0 (R0)
SUB	SP, SP, #116
STR	LR, [SP, #0]
STR	R3, [SP, #4]
MOV	R5, R2
MOV	R2, R0
MOV	R3, R1
LDR	R1, [SP, #4]
; ca_public_key end address is: 12 (R3)
; cert_size end address is: 8 (R2)
; cert end address is: 4 (R1)
; cert_def end address is: 0 (R0)
; cert_def start address is: 8 (R2)
; cert start address is: 12 (R3)
; cert_size start address is: 20 (R5)
; ca_public_key start address is: 4 (R1)
;atcacert_host_sw.c,52 :: 		int ret = 0;
;atcacert_host_sw.c,56 :: 		if (cert_def == NULL || ca_public_key == NULL || cert == NULL)
CMP	R2, #0
IT	EQ
BEQ	L__atcacert_verify_cert_sw13
CMP	R1, #0
IT	EQ
BEQ	L__atcacert_verify_cert_sw12
CMP	R3, #0
IT	EQ
BEQ	L__atcacert_verify_cert_sw11
IT	AL
BAL	L_atcacert_verify_cert_sw2
; cert_def end address is: 8 (R2)
; cert end address is: 12 (R3)
; cert_size end address is: 20 (R5)
; ca_public_key end address is: 4 (R1)
L__atcacert_verify_cert_sw13:
L__atcacert_verify_cert_sw12:
L__atcacert_verify_cert_sw11:
;atcacert_host_sw.c,57 :: 		return ATCACERT_E_BAD_PARAMS;
MOVS	R0, #2
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_verify_cert_sw
L_atcacert_verify_cert_sw2:
;atcacert_host_sw.c,59 :: 		ret = atcacert_get_tbs_digest(cert_def, cert, cert_size, tbs_digest);
; ca_public_key start address is: 4 (R1)
; cert_size start address is: 20 (R5)
; cert start address is: 12 (R3)
; cert_def start address is: 8 (R2)
ADD	R4, SP, #20
STR	R1, [SP, #4]
STR	R5, [SP, #8]
STR	R3, [SP, #12]
STR	R2, [SP, #16]
MOV	R1, R3
MOV	R3, R4
MOV	R0, R2
MOV	R2, R5
BL	_atcacert_get_tbs_digest+0
LDR	R2, [SP, #16]
LDR	R3, [SP, #12]
LDR	R5, [SP, #8]
LDR	R1, [SP, #4]
; ret start address is: 16 (R4)
SXTH	R4, R0
;atcacert_host_sw.c,60 :: 		if (ret != ATCACERT_E_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_atcacert_verify_cert_sw3
; cert_def end address is: 8 (R2)
; cert end address is: 12 (R3)
; cert_size end address is: 20 (R5)
; ca_public_key end address is: 4 (R1)
;atcacert_host_sw.c,61 :: 		return ret;
SXTH	R0, R4
; ret end address is: 16 (R4)
IT	AL
BAL	L_end_atcacert_verify_cert_sw
L_atcacert_verify_cert_sw3:
;atcacert_host_sw.c,63 :: 		ret = atcacert_get_signature(cert_def, cert, cert_size, signature);
; ca_public_key start address is: 4 (R1)
; cert_size start address is: 20 (R5)
; cert start address is: 12 (R3)
; cert_def start address is: 8 (R2)
ADD	R4, SP, #52
STR	R1, [SP, #4]
MOV	R1, R3
MOV	R3, R4
; cert_size end address is: 20 (R5)
MOV	R0, R2
; cert end address is: 12 (R3)
MOV	R2, R5
; cert_def end address is: 8 (R2)
BL	_atcacert_get_signature+0
LDR	R1, [SP, #4]
; ret start address is: 8 (R2)
SXTH	R2, R0
;atcacert_host_sw.c,64 :: 		if (ret != ATCACERT_E_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_atcacert_verify_cert_sw4
; ca_public_key end address is: 4 (R1)
;atcacert_host_sw.c,65 :: 		return ret;
SXTH	R0, R2
; ret end address is: 8 (R2)
IT	AL
BAL	L_end_atcacert_verify_cert_sw
L_atcacert_verify_cert_sw4:
;atcacert_host_sw.c,67 :: 		ret = atcac_sw_ecdsa_verify_p256(tbs_digest, signature, ca_public_key);
; ca_public_key start address is: 4 (R1)
ADD	R5, SP, #52
ADD	R4, SP, #20
MOV	R2, R1
; ca_public_key end address is: 4 (R1)
MOV	R1, R5
MOV	R0, R4
BL	_atcac_sw_ecdsa_verify_p256+0
; ret start address is: 4 (R1)
SXTH	R1, R0
;atcacert_host_sw.c,68 :: 		if (ret != ATCACERT_E_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_atcacert_verify_cert_sw5
;atcacert_host_sw.c,69 :: 		return ret;
SXTH	R0, R1
; ret end address is: 4 (R1)
IT	AL
BAL	L_end_atcacert_verify_cert_sw
L_atcacert_verify_cert_sw5:
;atcacert_host_sw.c,71 :: 		return ATCACERT_E_SUCCESS;
MOVS	R0, #0
SXTH	R0, R0
;atcacert_host_sw.c,72 :: 		}
L_end_atcacert_verify_cert_sw:
LDR	LR, [SP, #0]
ADD	SP, SP, #116
BX	LR
; end of _atcacert_verify_cert_sw
_atcacert_gen_challenge_sw:
;atcacert_host_sw.c,74 :: 		int atcacert_gen_challenge_sw( uint8_t challenge[32] )
; challenge start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; challenge end address is: 0 (R0)
; challenge start address is: 0 (R0)
;atcacert_host_sw.c,76 :: 		if (challenge == NULL)
CMP	R0, #0
IT	NE
BNE	L_atcacert_gen_challenge_sw6
; challenge end address is: 0 (R0)
;atcacert_host_sw.c,77 :: 		return ATCACERT_E_BAD_PARAMS;
MOVS	R0, #2
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_gen_challenge_sw
L_atcacert_gen_challenge_sw6:
;atcacert_host_sw.c,79 :: 		return atcac_sw_random(challenge, 32);
; challenge start address is: 0 (R0)
MOVS	R1, #32
; challenge end address is: 0 (R0)
BL	_atcac_sw_random+0
;atcacert_host_sw.c,80 :: 		}
L_end_atcacert_gen_challenge_sw:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atcacert_gen_challenge_sw
_atcacert_verify_response_sw:
;atcacert_host_sw.c,84 :: 		uint8_t response[64])
; response start address is: 8 (R2)
; challenge start address is: 4 (R1)
; device_public_key start address is: 0 (R0)
SUB	SP, SP, #8
STR	LR, [SP, #0]
; response end address is: 8 (R2)
; challenge end address is: 4 (R1)
; device_public_key end address is: 0 (R0)
; device_public_key start address is: 0 (R0)
; challenge start address is: 4 (R1)
; response start address is: 8 (R2)
;atcacert_host_sw.c,86 :: 		if (device_public_key == NULL || challenge == NULL || response == NULL)
CMP	R0, #0
IT	EQ
BEQ	L__atcacert_verify_response_sw17
CMP	R1, #0
IT	EQ
BEQ	L__atcacert_verify_response_sw16
CMP	R2, #0
IT	EQ
BEQ	L__atcacert_verify_response_sw15
IT	AL
BAL	L_atcacert_verify_response_sw9
; device_public_key end address is: 0 (R0)
; challenge end address is: 4 (R1)
; response end address is: 8 (R2)
L__atcacert_verify_response_sw17:
L__atcacert_verify_response_sw16:
L__atcacert_verify_response_sw15:
;atcacert_host_sw.c,87 :: 		return ATCACERT_E_BAD_PARAMS;
MOVS	R0, #2
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_verify_response_sw
L_atcacert_verify_response_sw9:
;atcacert_host_sw.c,89 :: 		return atcac_sw_ecdsa_verify_p256(challenge, response, device_public_key);
; response start address is: 8 (R2)
; challenge start address is: 4 (R1)
; device_public_key start address is: 0 (R0)
STR	R1, [SP, #4]
; device_public_key end address is: 0 (R0)
MOV	R1, R2
MOV	R2, R0
; response end address is: 8 (R2)
LDR	R0, [SP, #4]
; challenge end address is: 4 (R1)
BL	_atcac_sw_ecdsa_verify_p256+0
;atcacert_host_sw.c,90 :: 		}
L_end_atcacert_verify_response_sw:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _atcacert_verify_response_sw
