#line 1 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/basic/atca_basic.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/cryptoauthlib.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stddef.h"



typedef long ptrdiff_t;


 typedef unsigned long size_t;

typedef unsigned long wchar_t;
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/string.h"





void * memchr(void *p, char n, unsigned int v);
int memcmp(void *s1, void *s2, int n);
void * memcpy(void * d1, void * s1, int n);
void * memmove(void * to, void * from, int n);
void * memset(void * p1, char character, int n);
char * strcat(char * to, char * from);
char * strchr(char * ptr, char chr);
int strcmp(char * s1, char * s2);
char * strcpy(char * to, char * from);
int strlen(char * s);
char * strncat(char * to, char * from, int size);
char * strncpy(char * to, char * from, int size);
int strspn(char * str1, char * str2);
char strcspn(char * s1, char * s2);
int strncmp(char * s1, char * s2, char len);
char * strpbrk(char * s1, char * s2);
char * strrchr(char *ptr, char chr);
char * strstr(char * s1, char * s2);
char * strtok(char * s1, char * s2);
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/hal/atca_hal.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_status.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdbool.h"



 typedef char _Bool;
#line 55 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_status.h"
typedef enum
{
 ATCA_SUCCESS = 0x00,
 ATCA_CONFIG_ZONE_LOCKED = 0x01,
 ATCA_DATA_ZONE_LOCKED = 0x02,
 ATCA_WAKE_FAILED = 0xD0,
 ATCA_CHECKMAC_VERIFY_FAILED = 0xD1,
 ATCA_PARSE_ERROR = 0xD2,
 ATCA_STATUS_CRC = 0xD4,
 ATCA_STATUS_UNKNOWN = 0xD5,
 ATCA_STATUS_ECC = 0xD6,
 ATCA_STATUS_SELFTEST_ERROR = 0xD7,
 ATCA_FUNC_FAIL = 0xE0,
 ATCA_GEN_FAIL = 0xE1,
 ATCA_BAD_PARAM = 0xE2,
 ATCA_INVALID_ID = 0xE3,
 ATCA_INVALID_SIZE = 0xE4,
 ATCA_RX_CRC_ERROR = 0xE5,
 ATCA_RX_FAIL = 0xE6,
 ATCA_RX_NO_RESPONSE = 0xE7,
 ATCA_RESYNC_WITH_WAKEUP = 0xE8,
 ATCA_PARITY_ERROR = 0xE9,
 ATCA_TX_TIMEOUT = 0xEA,
 ATCA_RX_TIMEOUT = 0xEB,
 ATCA_TOO_MANY_COMM_RETRIES = 0xEC,
 ATCA_SMALL_BUFFER = 0xED,
 ATCA_COMM_FAIL = 0xF0,
 ATCA_TIMEOUT = 0xF1,
 ATCA_BAD_OPCODE = 0xF2,
 ATCA_WAKE_SUCCESS = 0xF3,
 ATCA_EXECUTION_ERROR = 0xF4,
 ATCA_UNIMPLEMENTED = 0xF5,
 ATCA_ASSERT_FAILURE = 0xF6,
 ATCA_TX_FAIL = 0xF7,
 ATCA_NOT_LOCKED = 0xF8,
 ATCA_NO_DEVICES = 0xF9,
 ATCA_HEALTH_TEST_ERROR = 0xFA,
 ATCA_ALLOC_FAILURE = 0xFB,
} ATCA_STATUS;
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_iface.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_compiler.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_status.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_devtypes.h"
#line 53 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_devtypes.h"
typedef enum {
 ATSHA204A,
 ATECC108A,
 ATECC508A,
 ATECC608A,
 ATCA_DEV_UNKNOWN = 0x20
} ATCADeviceType;
#line 62 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
struct atca_command {
 ATCADeviceType dt;
 uint16_t *execution_times;
};


typedef struct atca_command * ATCACommand;
ATCACommand newATCACommand(ATCADeviceType device_type);
#pragma pack( push, ATCAPacket, 2 )
#line 97 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
typedef struct {


 uint8_t _reserved;


 uint8_t txsize;
 uint8_t opcode;
 uint8_t param1;
 uint16_t param2;
 uint8_t  _data [130];






 uint8_t execTime;
 uint16_t rxsize;




} ATCAPacket;
#pragma pack( pop, ATCAPacket)
#line 123 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
ATCA_STATUS atCheckMAC(ATCACommand cacmd, ATCAPacket *packet);
ATCA_STATUS atCounter(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atDeriveKey(ATCACommand cacmd, ATCAPacket *packet,  _Bool  hasMAC );
ATCA_STATUS atECDH(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atGenDig(ATCACommand cacmd, ATCAPacket *packet,  _Bool  hasMACKey );
ATCA_STATUS atGenKey(ATCACommand cacmd, ATCAPacket *packet,  _Bool  isPubKey );
ATCA_STATUS atHMAC(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atInfo(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atLock(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atMAC(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atNonce(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atPause(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atPrivWrite(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atRandom(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atRead(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atSHA(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atSign(ATCACommand cacmd, ATCAPacket *packet);
ATCA_STATUS atUpdateExtra(ATCACommand cacmd, ATCAPacket *packet);
ATCA_STATUS atVerify(ATCACommand cacmd, ATCAPacket *packet);
ATCA_STATUS atWrite(ATCACommand cacmd, ATCAPacket *packet);
ATCA_STATUS atWriteEnc(ATCACommand cacmd, ATCAPacket *packet);

 _Bool  atIsSHAFamily( ATCADeviceType deviceType );
 _Bool  atIsECCFamily( ATCADeviceType deviceType );
ATCA_STATUS isATCAError( uint8_t * _data  );


typedef enum {
 WAKE_TWHI,
 CMD_CHECKMAC,
 CMD_COUNTER,
 CMD_DERIVEKEY,
 CMD_ECDH,
 CMD_GENDIG,
 CMD_GENKEY,
 CMD_HMAC,
 CMD_INFO,
 CMD_LOCK,
 CMD_MAC,
 CMD_NONCE,
 CMD_PAUSE,
 CMD_PRIVWRITE,
 CMD_RANDOM,
 CMD_READMEM,
 CMD_SHA,
 CMD_SIGN,
 CMD_UPDATEEXTRA,
 CMD_VERIFY,
 CMD_WRITEMEM,
 CMD_LASTCOMMAND
} ATCA_CmdMap;

ATCA_STATUS atInitExecTimes(ATCACommand cacmd, ATCADeviceType device_type);
uint16_t atGetExecTime( ATCACommand cacmd, ATCA_CmdMap cmd );

void deleteATCACommand( ATCACommand * );



void atCRC( uint8_t length, uint8_t * _data , uint8_t *crc);
void atCalcCrc( ATCAPacket *pkt);
uint8_t atCheckCrc(uint8_t *response);
#line 316 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
typedef enum {
 COUNTER_MODE_READ = 0,
 COUNTER_MODE_INCREASE = 1
} enum_counter_mode;
#line 330 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
typedef enum {
 SHA_MODE_SHA256_START = ((uint8_t) 0x00),
 SHA_MODE_SHA256_UPDATE = ((uint8_t) 0x01),
 SHA_MODE_SHA256_END = ((uint8_t) 0x02),
 SHA_MODE_SHA256_PUBLIC = ((uint8_t) 0x03),
 SHA_MODE_HMAC_START = ((uint8_t) 0x04),
 SHA_MODE_HMAC_UPDATE = ((uint8_t) 0x05),
 SHA_MODE_HMAC_END = ((uint8_t) 0x04)
} enum_sha_mode;
#line 407 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
typedef enum {
 GENKEY_MODE_PRIVATE_KEY_GENERATE = ((uint8_t) 0x04),
 GENKEY_MODE_PUBLIC_KEY_DIGEST = ((uint8_t) 0x08),
 GENKEY_MODE_DIGEST_IN_TEMPKEY = ((uint8_t) 0x10)
} enum_genkey_mode;
#line 58 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_iface.h"
typedef enum {
 ATCA_I2C_IFACE,
 ATCA_SWI_IFACE,
 ATCA_UART_IFACE,
 ATCA_SPI_IFACE,
 ATCA_HID_IFACE

} ATCAIfaceType;
#line 74 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_iface.h"
typedef struct {

 ATCAIfaceType iface_type;
 ATCADeviceType devtype;

 union {
 struct ATCAI2C {
 uint8_t slave_address;
 uint8_t bus;
 uint32_t baud;
 } atcai2c;

 struct ATCASWI {
 uint8_t bus;
 } atcaswi;

 struct ATCAUART {
 int port;
 uint32_t baud;
 uint8_t wordsize;
 uint8_t parity;
 uint8_t stopbits;
 } atcauart;

 struct ATCAHID {
 int idx;
 uint32_t vid;
 uint32_t pid;
 uint32_t packetsize;
 uint8_t guid[16];
 } atcahid;

 };

 uint16_t wake_delay;
 int rx_retries;
 void *cfg_data;
} ATCAIfaceCfg;
#line 117 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_iface.h"
typedef struct atca_iface
{
 ATCAIfaceType mType;
 ATCAIfaceCfg *mIfaceCFG;

 ATCA_STATUS (*atinit)(void *hal, ATCAIfaceCfg *cfg);
 ATCA_STATUS (*atpostinit)(struct atca_iface *hal);
 ATCA_STATUS (*atsend)(struct atca_iface *hal, uint8_t *txdata, int txlength);
 ATCA_STATUS (*atreceive)(struct atca_iface *hal, uint8_t *rxdata, uint16_t *rxlength);
 ATCA_STATUS (*atwake)(struct atca_iface *hal);
 ATCA_STATUS (*atidle)(struct atca_iface *hal);
 ATCA_STATUS (*atsleep)(struct atca_iface *hal);


 void *hal_data;

}T_atca_iface;

typedef T_atca_iface* ATCAIface;

ATCAIface newATCAIface(ATCAIfaceCfg *cfg);


ATCA_STATUS atinit(ATCAIface caiface);
ATCA_STATUS atpostinit(ATCAIface caiface);
ATCA_STATUS atsend(ATCAIface caiface, uint8_t *txdata, int txlength);
ATCA_STATUS atreceive(ATCAIface caiface, uint8_t *rxdata, uint16_t *rxlength);
ATCA_STATUS atwake(ATCAIface caiface);
ATCA_STATUS atidle(ATCAIface caiface);
ATCA_STATUS atsleep(ATCAIface caiface);


ATCAIfaceCfg * atgetifacecfg(ATCAIface caiface);
void* atgetifacehaldat(ATCAIface caiface);

void deleteATCAIface( ATCAIface *dev );
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/hal/atca_start_config.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/hal/atca_start_iface.h"
#line 63 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/hal/atca_hal.h"
typedef struct
{



 ATCA_STATUS (*halinit)(void *hal, ATCAIfaceCfg *cfg);
 ATCA_STATUS (*halpostinit)(ATCAIface iface);
 ATCA_STATUS (*halsend)(ATCAIface iface, uint8_t *txdata, int txlength);
 ATCA_STATUS (*halreceive)(ATCAIface iface, uint8_t* rxdata, uint16_t* rxlength);
 ATCA_STATUS (*halwake)(ATCAIface iface);
 ATCA_STATUS (*halidle)(ATCAIface iface);
 ATCA_STATUS (*halsleep)(ATCAIface iface);
 ATCA_STATUS (*halrelease)(void* hal_data);

 void *hal_data;
} ATCAHAL_t;
#line 84 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/hal/atca_hal.h"
extern ATCA_STATUS hal_iface_init(ATCAIfaceCfg *, ATCAHAL_t* hal);
extern ATCA_STATUS hal_iface_release(ATCAIfaceType, void* hal_data);
#line 116 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/hal/atca_hal.h"
ATCA_STATUS hal_swi_init(void *hal, ATCAIfaceCfg *cfg);
ATCA_STATUS hal_swi_post_init(ATCAIface iface);
ATCA_STATUS hal_swi_send(ATCAIface iface, uint8_t *txdata, int txlength);
ATCA_STATUS hal_swi_receive( ATCAIface iface, uint8_t *rxdata, uint16_t *rxlength);
ATCA_STATUS hal_swi_wake(ATCAIface iface);
ATCA_STATUS hal_swi_idle(ATCAIface iface);
ATCA_STATUS hal_swi_sleep(ATCAIface iface);
ATCA_STATUS hal_swi_release(void *hal_data );
ATCA_STATUS hal_swi_discover_buses(int swi_buses[], int max_buses);
ATCA_STATUS hal_swi_discover_devices(int busNum, ATCAIfaceCfg *cfg, int *found);
#line 168 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/hal/atca_hal.h"
void atca_delay_us(uint32_t delay);
void atca_delay_10us(uint32_t delay);
void atca_delay_ms(uint32_t delay);
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_status.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_device.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_iface.h"
#line 59 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_device.h"
struct atca_device {
 ATCACommand mCommands;
 ATCAIface mIface;
};

typedef struct atca_device* ATCADevice;
ATCADevice newATCADevice(ATCAIfaceCfg *cfg );


ATCACommand atGetCommands( ATCADevice dev );
ATCAIface atGetIFace( ATCADevice dev );

void deleteATCADevice( ATCADevice *dev );
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_cfgs.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_iface.h"
#line 53 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_cfgs.h"
extern ATCAIfaceCfg SECURE7_ATCA_CFG;
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/basic/atca_basic.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/cryptoauthlib.h"
#line 63 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/basic/atca_basic.h"
ATCA_STATUS atcab_version( char *verstr );
ATCA_STATUS atcab_init(ATCAIfaceCfg *cfg);
ATCA_STATUS atcab_init_device(ATCADevice cadevice);
ATCA_STATUS atcab_release(void);
ATCADevice atcab_getDevice(void);

ATCA_STATUS atcab_wakeup(void);
ATCA_STATUS atcab_idle(void);
ATCA_STATUS atcab_sleep(void);


ATCA_STATUS atcab_cfg_discover( ATCAIfaceCfg cfgArray[], int max);


ATCA_STATUS atcab_info(uint8_t *revision);
ATCA_STATUS atcab_challenge( uint8_t *challenge);
ATCA_STATUS atcab_challenge_seed_update( uint8_t *seed, uint8_t* rand_out);
ATCA_STATUS atcab_nonce( uint8_t *tempkey);
ATCA_STATUS atcab_nonce_rand( uint8_t *seed, uint8_t* rand_out);
ATCA_STATUS atcab_random(uint8_t *rand_out);

ATCA_STATUS atcab_is_locked(uint8_t zone,  _Bool  *lock_state);
ATCA_STATUS atcab_is_slot_locked(uint8_t slot,  _Bool  *lock_state);

ATCA_STATUS atcab_get_addr(uint8_t zone, uint8_t slot, uint8_t block, uint8_t offset, uint16_t* addr);
ATCA_STATUS atcab_read_zone(uint8_t zone, uint8_t slot, uint8_t block, uint8_t offset, uint8_t *_data, uint8_t len);
ATCA_STATUS atcab_write_zone(uint8_t zone, uint8_t slot, uint8_t block, uint8_t offset, uint8_t * _data , uint8_t len);
ATCA_STATUS atcab_write_bytes_slot(uint8_t slot, uint16_t offset, uint8_t * _data , uint8_t len);
ATCA_STATUS atcab_write_bytes_zone(ATCADeviceType dev_type, uint8_t zone, uint16_t address, uint8_t * _data , uint8_t len);
ATCA_STATUS atcab_read_bytes_zone(ATCADeviceType dev_type, uint8_t zone, uint16_t address, uint8_t len, uint8_t * _data );

ATCA_STATUS atcab_read_serial_number(uint8_t* serial_number);
ATCA_STATUS atcab_read_pubkey(uint8_t slot8toF, uint8_t *pubkey);
ATCA_STATUS atcab_write_pubkey(uint8_t slot8toF, uint8_t *pubkey);
ATCA_STATUS atcab_read_sig(uint8_t slot8toF, uint8_t *sig);
ATCA_STATUS atcab_read_ecc_config_zone(uint8_t* config_data);
ATCA_STATUS atcab_write_ecc_config_zone( uint8_t* config_data);
ATCA_STATUS atcab_read_sha_config_zone( uint8_t* config_data);
ATCA_STATUS atcab_write_sha_config_zone( uint8_t* config_data);
ATCA_STATUS atcab_read_config_zone(ATCADeviceType dev_type, uint8_t* config_data);
ATCA_STATUS atcab_write_config_zone(ATCADeviceType dev_type, uint8_t* config_data);
ATCA_STATUS atcab_cmp_config_zone(uint8_t* config_data,  _Bool * same_config);

ATCA_STATUS atcab_read_enc(uint8_t slotid, uint8_t block, uint8_t * _data , uint8_t* enckey, uint16_t enckeyid);
ATCA_STATUS atcab_write_enc(uint8_t slotid, uint8_t block, uint8_t * _data , uint8_t* enckey, uint16_t enckeyid);

ATCA_STATUS atcab_lock_config_zone(uint8_t* lock_response);
ATCA_STATUS atcab_lock_data_zone(uint8_t* lock_response);
ATCA_STATUS atcab_lock_data_slot(uint8_t slot, uint8_t* lock_response);

ATCA_STATUS atcab_priv_write(uint8_t slot, uint8_t priv_key[36], uint8_t write_key_slot, uint8_t write_key[32]);
ATCA_STATUS atcab_genkey( int slot, uint8_t *pubkey );
ATCA_STATUS atcab_get_pubkey(uint8_t privSlotId, uint8_t *pubkey);
ATCA_STATUS atcab_calc_pubkey(uint8_t privSlotId, uint8_t *pubkey);
ATCA_STATUS atcab_sign(uint16_t slot, uint8_t *msg, uint8_t *signature);
ATCA_STATUS atcab_verify_extern( uint8_t *message, uint8_t *signature, uint8_t *pubkey,  _Bool  *verified);
ATCA_STATUS atcab_ecdh(uint16_t key_id, uint8_t* pub_key, uint8_t* ret_ecdh);
ATCA_STATUS atcab_ecdh_enc(uint16_t slotid, uint8_t* pubkey, uint8_t* ret_ecdh, uint8_t* enckey, uint8_t enckeyid);
ATCA_STATUS atcab_gendig(uint8_t zone, uint16_t key_id);
ATCA_STATUS atcab_gendig_host(uint8_t zone, uint16_t key_id, uint8_t *other_data, uint8_t len);
ATCA_STATUS atcab_mac( uint8_t mode, uint16_t key_id, uint8_t* challenge, uint8_t* digest );
ATCA_STATUS atcab_checkmac( uint8_t mode, uint16_t key_id, uint8_t *challenge, uint8_t *response, uint8_t *other_data);

ATCA_STATUS atcab_sha_start(void);
ATCA_STATUS atcab_sha_update(uint16_t length, uint8_t *message);
ATCA_STATUS atcab_sha_end(uint8_t *digest, uint16_t length, uint8_t *message);
ATCA_STATUS atcab_sha(uint16_t length, uint8_t *message, uint8_t *digest);
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/basic/atca_helpers.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/cryptoauthlib.h"
#line 68 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/basic/atca_helpers.h"
ATCA_STATUS packHex( char* asciiHex, int asciiHexLen, char* packedHex, int* packedLen);
 _Bool  isDigit(char c);
 _Bool  isWhiteSpace(char c);
 _Bool  isHexAlpha(char c);
 _Bool  isHex(char c);
 _Bool  isHexDigit(char c);
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/host/atca_host.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/cryptoauthlib.h"
#line 158 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/host/atca_host.h"
typedef struct atca_temp_key {
 uint8_t value[ 32 ];
 unsigned int key_id : 4;
 unsigned int source_flag : 1;
 unsigned int gen_data : 1;
 unsigned int check_flag : 1;
 unsigned int valid : 1;
} atca_temp_key_t;
#line 177 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/host/atca_host.h"
struct atca_include_data_in_out {
 uint8_t *p_temp;
 uint8_t *otp;
 uint8_t *sn;
 uint8_t mode;
};
#line 196 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/host/atca_host.h"
typedef struct atca_nonce_in_out {
 uint8_t mode;
 uint8_t *num_in;
 uint8_t *rand_out;
 struct atca_temp_key *temp_key;
} atca_nonce_in_out_t;
#line 223 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/host/atca_host.h"
struct atca_mac_in_out {
 uint8_t mode;
 uint16_t key_id;
 uint8_t *challenge;
 uint8_t *key;
 uint8_t *otp;
 uint8_t *sn;
 uint8_t *response;
 struct atca_temp_key *temp_key;
};
#line 252 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/host/atca_host.h"
struct atca_hmac_in_out {
 uint8_t mode;
 uint16_t key_id;
 uint8_t *key;
 uint8_t *otp;
 uint8_t *sn;
 uint8_t *response;
 struct atca_temp_key *temp_key;
};
#line 274 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/host/atca_host.h"
typedef struct atca_gen_dig_in_out {
 uint8_t zone;
 uint16_t key_id;
 uint8_t *stored_value;
 struct atca_temp_key *temp_key;
} atca_gen_dig_in_out_t;
#line 298 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/host/atca_host.h"
typedef struct atca_write_mac_in_out {
 uint8_t zone;
 uint16_t key_id;
 uint8_t *encryption_key;
 uint8_t *input_data;
 uint8_t *encrypted_data;
 uint8_t *auth_mac;
 struct atca_temp_key *temp_key;
} atca_write_mac_in_out_t;
#line 321 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/host/atca_host.h"
struct atca_derive_key_in_out {
 uint8_t random;
 uint16_t target_key_id;
 uint8_t *parent_key;
 uint8_t *target_key;
 struct atca_temp_key *temp_key;
};
#line 341 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/host/atca_host.h"
struct atca_derive_key_mac_in_out {
 uint8_t random;
 uint16_t target_key_id;
 uint8_t *parent_key;
 uint8_t *mac;
};
#line 362 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/host/atca_host.h"
struct atca_encrypt_in_out {
 uint8_t zone;
 uint16_t address;
 uint8_t *crypto_data;
 uint8_t *mac;
 struct atca_temp_key *temp_key;
};
#line 378 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/host/atca_host.h"
struct atca_decrypt_in_out {
 uint8_t *crypto_data;
 struct atca_temp_key *temp_key;
};
#line 401 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/host/atca_host.h"
struct atca_check_mac_in_out {
 uint8_t mode;
 uint8_t *password;
 uint8_t *other_data;
 uint8_t *otp;
 uint8_t *target_key;
 uint8_t *client_resp;
 struct atca_temp_key *temp_key;
};
#line 423 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/host/atca_host.h"
struct atca_verify_in_out {
 uint16_t curve_type;
 uint8_t *signature;
 uint8_t *public_key;
 struct atca_temp_key *temp_key;
};
#line 434 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/host/atca_host.h"
ATCA_STATUS atcah_nonce(struct atca_nonce_in_out *param);
ATCA_STATUS atcah_mac(struct atca_mac_in_out *param);
ATCA_STATUS atcah_check_mac(struct atca_check_mac_in_out *param);
ATCA_STATUS atcah_hmac(struct atca_hmac_in_out *param);
ATCA_STATUS atcah_gen_dig(struct atca_gen_dig_in_out *param);
ATCA_STATUS atcah_gen_mac(struct atca_gen_dig_in_out *param);
ATCA_STATUS atcah_write_auth_mac(struct atca_write_mac_in_out *param);
ATCA_STATUS atcah_privwrite_auth_mac(struct atca_write_mac_in_out *param);
ATCA_STATUS atcah_derive_key(struct atca_derive_key_in_out *param);
ATCA_STATUS atcah_derive_key_mac(struct atca_derive_key_mac_in_out *param);
ATCA_STATUS atcah_encrypt(struct atca_encrypt_in_out *param);
ATCA_STATUS atcah_decrypt(struct atca_decrypt_in_out *param);
ATCA_STATUS atcah_sha256(int32_t len, uint8_t *message, uint8_t *digest);
uint8_t *atcah_include_data(struct atca_include_data_in_out *param);
#line 54 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
char atca_version[] = { "20160108" };
#line 62 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_version( char *verstr )
{
 strcpy( verstr, atca_version );
 return ATCA_SUCCESS;
}
#line 74 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCADevice _gDevice =  ((void *)0) ;
ATCACommand _gCommandObj =  ((void *)0) ;
ATCAIface _gIface =  ((void *)0) ;
#line 84 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_init( ATCAIfaceCfg *cfg )
{
 if ( _gDevice )
 atcab_release();

 _gDevice = newATCADevice( cfg );
 if ( _gDevice ==  ((void *)0)  )
 return ATCA_GEN_FAIL;

 _gCommandObj = atGetCommands( _gDevice );
 _gIface = atGetIFace( _gDevice );

 if ( _gCommandObj ==  ((void *)0)  || _gIface ==  ((void *)0)  )
 return ATCA_GEN_FAIL;

 return ATCA_SUCCESS;
}
#line 108 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_init_device( ATCADevice cadevice )
{
 if ( cadevice ==  ((void *)0)  )
 return ATCA_BAD_PARAM;

 if ( _gDevice )
 atcab_release();

 _gDevice = cadevice;
 _gCommandObj = atGetCommands( _gDevice );
 _gIface = atGetIFace(_gDevice);

 if ( _gCommandObj ==  ((void *)0)  || _gIface ==  ((void *)0)  )
 return ATCA_GEN_FAIL;

 return ATCA_SUCCESS;
}
#line 130 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_release(void)
{
 deleteATCADevice(&_gDevice);
 return ATCA_SUCCESS;
}
#line 140 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCADevice atcab_getDevice(void)
{
 return _gDevice;
}
#line 149 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_wakeup(void)
{
 if ( _gDevice ==  ((void *)0)  )
 return ATCA_GEN_FAIL;

 return atwake(_gIface);
}
#line 160 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_idle(void)
{
 if ( _gDevice ==  ((void *)0)  )
 return ATCA_GEN_FAIL;

 return atidle(_gIface);
}
#line 171 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_sleep(void)
{
 if ( _gDevice ==  ((void *)0)  )
 return ATCA_GEN_FAIL;

 return atsleep(_gIface);
}
#line 194 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_cfg_discover( ATCAIfaceCfg cfgArray[], int maxIfaces)
{
 int ifaceNum = 0, i;
 int found = 0;
#line 215 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
 int swi_buses[ 4 ];
 memset( swi_buses, -1, sizeof(swi_buses));
 hal_swi_discover_buses(swi_buses,  4 );
 for ( i = 0; i <  4  && ifaceNum < maxIfaces; i++ ) {
 if ( swi_buses[i] != -1 ) {
 hal_swi_discover_devices( swi_buses[i], &cfgArray[ifaceNum], &found);
 ifaceNum += found;
 }
 }
#line 263 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
 return ATCA_SUCCESS;
}
#line 269 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
static ATCA_STATUS _atcab_exit(void)
{
 return atcab_idle();
}
#line 280 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_info( uint8_t *revision )
{
 ATCAPacket packet;
 ATCA_STATUS status = ATCA_GEN_FAIL;
 uint32_t execution_time;

 if ( !_gDevice )
 return ATCA_GEN_FAIL;


 packet.param1 =  ((uint8_t)0x00) ;
 packet.param2 = 0;

 do {
 if ( (status = atInfo( _gCommandObj, &packet )) != ATCA_SUCCESS )
 break;

 execution_time = atGetExecTime( _gCommandObj, CMD_INFO);

 if ( (status = atcab_wakeup()) != ATCA_SUCCESS )
 break;


 if ( (status = atsend( _gIface, (uint8_t*)&packet, packet.txsize )) != ATCA_SUCCESS )
 break;


 atca_delay_ms(execution_time);


 if ( (status = atreceive( _gIface, &(packet. _data [0]), &(packet.rxsize) )) != ATCA_SUCCESS )
 break;


 if (packet.rxsize < 4) {
 if (packet.rxsize > 0)
 status = ATCA_RX_FAIL;
 else
 status = ATCA_RX_NO_RESPONSE;
 break;
 }

 if ( (status = isATCAError(packet. _data )) != ATCA_SUCCESS )
 break;

 memcpy( revision, &packet. _data [1], 4 );
 } while (0);

 if ( status != ATCA_COMM_FAIL )
 _atcab_exit();

 return status;
}
#line 338 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_random(uint8_t *rand_out)
{
 ATCA_STATUS status = ATCA_GEN_FAIL;
 ATCAPacket packet;
 uint16_t execution_time = 0;

 if ( !_gDevice )
 return ATCA_GEN_FAIL;


 packet.param1 =  ((uint8_t)0x00) ;
 packet.param2 = 0x0000;
 status = atRandom( _gCommandObj, &packet );
 execution_time = atGetExecTime( _gCommandObj, CMD_RANDOM);

 do {
 if ( (status = atcab_wakeup()) != ATCA_SUCCESS )
 break;


 if ( (status = atsend( _gIface, (uint8_t*)&packet, packet.txsize )) != ATCA_SUCCESS)
 break;


 atca_delay_ms(execution_time);

 if ( (status = atreceive( _gIface, packet. _data , &packet.rxsize)) != ATCA_SUCCESS)
 break;


 if (packet.rxsize < 4) {
 if (packet.rxsize > 0)
 status = ATCA_RX_FAIL;
 else
 status = ATCA_RX_NO_RESPONSE;
 break;
 }

 if ( (status = isATCAError(packet. _data )) != ATCA_SUCCESS )
 break;

 memcpy( rand_out, &packet. _data [1], 32 );
 } while (0);

 _atcab_exit();
 return status;
}
#line 391 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_genkey( int slot, uint8_t *pubkey )
{
 ATCAPacket packet;
 uint16_t execution_time = 0;
 ATCA_STATUS status = ATCA_GEN_FAIL;


 packet.param1 = GENKEY_MODE_PRIVATE_KEY_GENERATE;
 packet.param2 = (uint16_t)slot;

 do {
 if ( (status = atGenKey( _gCommandObj, &packet,  0  )) != ATCA_SUCCESS )
 break;

 execution_time = atGetExecTime( _gCommandObj, CMD_GENKEY);

 if ( (status = atcab_wakeup()) != ATCA_SUCCESS )
 break;


 if ( (status = atsend( _gIface, (uint8_t*)&packet, packet.txsize )) != ATCA_SUCCESS )
 break;


 atca_delay_ms(execution_time);


 if ( (status = atreceive( _gIface, packet. _data , &(packet.rxsize) )) != ATCA_SUCCESS )
 break;


 if (packet.rxsize < 4) {
 if (packet.rxsize > 0)
 status = ATCA_RX_FAIL;
 else
 status = ATCA_RX_NO_RESPONSE;
 break;
 }

 if ( (status = isATCAError(packet. _data )) != ATCA_SUCCESS )
 break;

 memcpy(pubkey, &packet. _data [1], 64 );
 } while (0);

 _atcab_exit();
 return status;
}
#line 444 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_nonce( uint8_t *tempkey)
{
 return atcab_challenge(tempkey);
}
#line 454 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_nonce_rand( uint8_t *seed, uint8_t* rand_out)
{
 return atcab_challenge_seed_update(seed, rand_out);
}
#line 463 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_challenge( uint8_t *challenge)
{
 ATCA_STATUS status = ATCA_GEN_FAIL;
 ATCAPacket packet;
 uint16_t execution_time = 0;

 do {

 if (challenge ==  ((void *)0) ) {
 status = ATCA_BAD_PARAM;
 break;
 }


 packet.param1 =  ((uint8_t)0x03) ;
 packet.param2 = 0x0000;
 memcpy( packet. _data , challenge, 32 );

 if ((status = atNonce( _gCommandObj, &packet )) != ATCA_SUCCESS )
 break;

 execution_time = atGetExecTime( _gCommandObj, CMD_NONCE);

 if ((status = atcab_wakeup()) != ATCA_SUCCESS )
 break;


 if ((status = atsend( _gIface, (uint8_t*)&packet, packet.txsize)) != ATCA_SUCCESS )
 break;


 atca_delay_ms(execution_time);


 if ((status = atreceive( _gIface, packet. _data , &(packet.rxsize))) != ATCA_SUCCESS )
 break;


 if (packet.rxsize < 4) {
 if (packet.rxsize > 0)
 status = ATCA_RX_FAIL;
 else
 status = ATCA_RX_NO_RESPONSE;
 break;
 }

 if ( (status = isATCAError(packet. _data )) != ATCA_SUCCESS )
 break;

 } while (0);

 _atcab_exit();
 return status;
}
#line 523 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_challenge_seed_update( uint8_t *seed, uint8_t* rand_out )
{
 ATCA_STATUS status = ATCA_GEN_FAIL;
 ATCAPacket packet;
 uint16_t execution_time = 0;

 do {

 if (seed ==  ((void *)0)  || rand_out ==  ((void *)0) ) {
 status = ATCA_BAD_PARAM;
 break;
 }


 packet.param1 =  ((uint8_t)0x00) ;
 packet.param2 = 0x0000;
 memcpy( packet. _data , seed, 20 );

 if ((status = atNonce(_gCommandObj, &packet)) != ATCA_SUCCESS) break;

 execution_time = atGetExecTime(_gCommandObj, CMD_NONCE);

 if ((status = atcab_wakeup()) != ATCA_SUCCESS ) break;


 if ( (status = atsend( _gIface, (uint8_t*)&packet, packet.txsize)) != ATCA_SUCCESS ) break;


 atca_delay_ms(execution_time);


 if ((status = atreceive(_gIface, packet. _data , &(packet.rxsize))) != ATCA_SUCCESS) break;


 if (packet.rxsize < 4) {
 if (packet.rxsize > 0)
 status = ATCA_RX_FAIL;
 else
 status = ATCA_RX_NO_RESPONSE;
 break;
 }

 if ((status = isATCAError(packet. _data )) != ATCA_SUCCESS) break;

 memcpy(&rand_out[0], &packet. _data [ (1) ], 32);

 } while (0);

 _atcab_exit();
 return status;
}
#line 579 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_read_serial_number(uint8_t* serial_number)
{

 uint8_t status = ATCA_GEN_FAIL;
 uint8_t bytes_read[ (32) ];
 uint8_t block = 0;
 uint8_t cpyIndex = 0;
 uint8_t offset = 0;

 do {
 memset(serial_number, 0x00,  (9) );

 block = 0;
 offset = 0;
 if ( (status = atcab_read_zone( ((uint8_t)0x00) , 0, block, offset, bytes_read,  (4) )) != ATCA_SUCCESS )
 break;

 memcpy(&serial_number[cpyIndex], bytes_read,  (4) );
 cpyIndex +=  (4) ;

 block = 0;
 offset = 2;
 if ( (status = atcab_read_zone( ((uint8_t)0x00) , 0, block, offset, bytes_read,  (4) )) != ATCA_SUCCESS )
 break;

 memcpy(&serial_number[cpyIndex], bytes_read,  (4) );
 cpyIndex +=  (4) ;

 block = 0;
 offset = 3;
 if ( (status = atcab_read_zone( ((uint8_t)0x00) , 0, block, offset, bytes_read,  (4) )) != ATCA_SUCCESS )
 break;

 memcpy(&serial_number[cpyIndex], bytes_read, 1);

 } while (0);

 _atcab_exit();
 return status;
}
#line 627 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_verify_extern (uint8_t *message, uint8_t *signature, uint8_t *pubkey,  _Bool  *verified)
{
 ATCA_STATUS status;
 ATCAPacket packet;
 uint16_t execution_time = 0;

 do {
 *verified =  0 ;


 if ( (status = atcab_challenge(message)) != ATCA_SUCCESS )
 break;


 packet.param1 =  ((uint8_t)0x02) ;
 packet.param2 =  ((uint16_t)0x0004) ;
 memcpy( &packet. _data [0], signature,  (64) );
 memcpy( &packet. _data [64], pubkey,  (64) );

 if ( (status = atVerify( _gCommandObj, &packet )) != ATCA_SUCCESS )
 break;

 execution_time = atGetExecTime( _gCommandObj, CMD_VERIFY );

 if ( (status = atcab_wakeup()) != ATCA_SUCCESS )
 break;


 if ( (status = atsend( _gIface, (uint8_t*)&packet, packet.txsize )) != ATCA_SUCCESS )
 break;


 atca_delay_ms(execution_time);


 if ( (status = atreceive( _gIface, packet. _data , &(packet.rxsize) )) != ATCA_SUCCESS )
 break;


 if (packet.rxsize < 4) {
 if (packet.rxsize > 0)
 status = ATCA_RX_FAIL;
 else
 status = ATCA_RX_NO_RESPONSE;
 break;
 }

 status = isATCAError(packet. _data );
 *verified = (status == 0);
 if (status == ATCA_CHECKMAC_VERIFY_FAILED)
 status = ATCA_SUCCESS;
 } while (0);

 _atcab_exit();
 return status;
}
#line 690 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_ecdh(uint16_t key_id, uint8_t* pubkey, uint8_t* ret_ecdh)
{
 ATCA_STATUS status;
 ATCAPacket packet;
 uint16_t execution_time = 0;

 do {
 if (pubkey ==  ((void *)0)  || ret_ecdh ==  ((void *)0) ) {
 status = ATCA_BAD_PARAM;
 break;
 }
 memset(ret_ecdh, 0,  (32) );


 packet.param1 =  ((uint8_t)0x00) ;
 packet.param2 = key_id;
 memcpy( packet. _data , pubkey,  (64)  );

 if ( (status = atECDH( _gCommandObj, &packet )) != ATCA_SUCCESS ) break;

 execution_time = atGetExecTime( _gCommandObj, CMD_ECDH);

 if ( (status = atcab_wakeup()) != ATCA_SUCCESS ) break;

 if ( (status = atsend(_gIface, (uint8_t*)&packet, packet.txsize)) != ATCA_SUCCESS ) break;

 atca_delay_ms(execution_time);

 if ((status = atreceive(_gIface, packet. _data , &packet.rxsize)) != ATCA_SUCCESS) break;


 if (packet.rxsize < 4) {
 if (packet.rxsize > 0)
 status = ATCA_RX_FAIL;
 else
 status = ATCA_RX_NO_RESPONSE;
 break;
 }

 if ( (status = isATCAError(packet. _data )) != ATCA_SUCCESS ) break;


 memcpy(ret_ecdh, &packet. _data [ (1) ],  (32) );

 } while (0);

 _atcab_exit();
 return status;
}
#line 746 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_ecdh_enc(uint16_t slotid, uint8_t* pubkey, uint8_t* ret_ecdh, uint8_t* enckey, uint8_t enckeyid)
{
 ATCA_STATUS status = ATCA_SUCCESS;
 uint8_t cmpBuf[ (4) ];
 uint8_t block = 0;

 do {

 if (pubkey ==  ((void *)0)  || ret_ecdh ==  ((void *)0)  || enckey ==  ((void *)0) ) {
 status = ATCA_BAD_PARAM;
  break ;
 }

 if ((status = atcab_ecdh(slotid, pubkey, ret_ecdh)) != ATCA_SUCCESS)  break ;


 memset(cmpBuf, 0,  (4) );


 if (memcmp(cmpBuf, &ret_ecdh[18],  (4) ) == 0) {

 if (ret_ecdh[0] !=  ((uint8_t)0x00) )  break ;


 if ((status = atcab_read_enc(slotid + 1, block, ret_ecdh, enckey, enckeyid)) != ATCA_SUCCESS)  break ;
 }
 } while (0);

 return status;
}
#line 786 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_get_addr(uint8_t zone, uint8_t slot, uint8_t block, uint8_t offset, uint16_t* addr)
{
 ATCA_STATUS status = ATCA_SUCCESS;
 uint8_t memzone = zone & 0x03;

 if (addr ==  ((void *)0) )
 return ATCA_BAD_PARAM;
 if ((memzone !=  ((uint8_t)0x00) ) && (memzone !=  ((uint8_t)0x02) ) && (memzone !=  ((uint8_t)0x01) ))
 return ATCA_BAD_PARAM;
 do {

 *addr = 0;

 offset = offset & (uint8_t)0x07;
 if ((memzone ==  ((uint8_t)0x00) ) || (memzone ==  ((uint8_t)0x01) )) {
 *addr = block << 3;
 *addr |= offset;
 }else {
 *addr = slot << 3;
 *addr |= offset;
 *addr |= block << 8;
 }
 } while (0);

 return status;
}
#line 820 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_is_slot_locked(uint8_t slot,  _Bool  *islocked)
{
 uint8_t ret = ATCA_GEN_FAIL;
 uint8_t slotLock_data[ (4) ];
 uint8_t lockable_data[ (4) ];
 uint8_t slotLock_idx = 0;
 uint8_t lockBit_idx = 0;
 uint8_t keyConfig_idx = 0;
 uint8_t lockableBit_idx = 5;

 do {

 if ( (ret = atcab_read_zone( ((uint8_t)0x00) , 0, 2 , 6 , slotLock_data,  (4) )) != ATCA_SUCCESS )
 break;


 if (slot < 8) {
 slotLock_idx = 0;
 lockBit_idx = slot;
 }else if ((slot > 8) && (slot <=  ((uint8_t)15) )) {
 slotLock_idx = 1;
 lockBit_idx = slot - 8;
 }else
 return ATCA_BAD_PARAM;


 if ( ((slotLock_data[slotLock_idx] >> lockBit_idx) & 0x01) == 0x00 )
 *islocked =  1 ;
 else{
 keyConfig_idx = (slot % 2) ? 2 : 0;

 if ( (ret = atcab_read_zone( ((uint8_t)0x00) , 0, 3 , (slot >> 1) , lockable_data,  (4) )) != ATCA_SUCCESS )
 break;

 if (((lockable_data[keyConfig_idx] >> lockableBit_idx) & 0x01) == 0x00)
 *islocked =  1 ;
 else
 *islocked =  0 ;
 }
 } while (0);


 return ret;
}
#line 870 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_is_locked(uint8_t zone,  _Bool  *islocked)
{
 uint8_t ret = ATCA_GEN_FAIL;
 uint8_t word_data[ (4) ];
 uint8_t zone_idx = 2;

 do {

 if ( (ret = atcab_read_zone( ((uint8_t)0x00) , 0, 2 , 5 , word_data,  (4) )) != ATCA_SUCCESS )
 break;


 if (zone ==  ((uint8_t)0x01) ) zone_idx = 2;
 if (zone ==  ((uint8_t)0x00) ) zone_idx = 3;


 if (word_data[zone_idx] == 0)
 *islocked =  1 ;
 else
 *islocked =  0 ;

 } while (0);

 return ret;
}
#line 909 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_write_zone(uint8_t zone, uint8_t slot, uint8_t block, uint8_t offset, uint8_t * _data , uint8_t len)
{
 ATCA_STATUS status = ATCA_GEN_FAIL;
 ATCAPacket packet;
 uint16_t addr;
 uint16_t execution_time = 0;


 if ( _data  ==  ((void *)0) )
 return ATCA_BAD_PARAM;

 if ( len != 4 && len != 32 )
 return ATCA_BAD_PARAM;

 do {

 if ( (status = atcab_get_addr(zone, slot, block, offset, &addr)) != ATCA_SUCCESS )
 break;


 if (len ==  (32) )
 zone = zone |  ((uint8_t)0x80) ;


 packet.param1 = zone;
 packet.param2 = addr;
 memcpy( packet. _data ,  _data , len );

 if ( (status = atWrite( _gCommandObj, &packet )) != ATCA_SUCCESS )
 break;

 execution_time = atGetExecTime( _gCommandObj, CMD_WRITEMEM);

 if ( (status = atcab_wakeup()) != ATCA_SUCCESS )
 break;


 if ( (status = atsend( _gIface, (uint8_t*)&packet, packet.txsize )) != ATCA_SUCCESS )
 break;


 atca_delay_ms(execution_time);


 if ( (status = atreceive( _gIface, packet. _data , &(packet.rxsize) )) != ATCA_SUCCESS )
 break;


 if (packet.rxsize < 4) {
 if (packet.rxsize > 0)
 status = ATCA_RX_FAIL;
 else
 status = ATCA_RX_NO_RESPONSE;
 break;
 }

 status = isATCAError(packet. _data );

 } while (0);

 _atcab_exit();
 return status;
}
#line 988 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_read_zone(uint8_t zone, uint8_t slot, uint8_t block, uint8_t offset, uint8_t * _data , uint8_t len)
{
 ATCA_STATUS status = ATCA_SUCCESS;
 ATCAPacket packet;
 uint16_t addr;
 uint16_t execution_time = 0;

 do {

 if ( _data  ==  ((void *)0) )
 return ATCA_BAD_PARAM;

 if ( len != 4 && len != 32 )
 return ATCA_BAD_PARAM;


 if ( (status = atcab_get_addr(zone, slot, block, offset, &addr)) != ATCA_SUCCESS )
 break;


 if (len ==  (32) )
 zone = zone |  ((uint8_t)0x80) ;


 packet.param1 = zone;
 packet.param2 = addr;

 if ( (status = atRead( _gCommandObj, &packet )) != ATCA_SUCCESS )
 break;

 execution_time = atGetExecTime( _gCommandObj, CMD_READMEM);

 if ( (status = atcab_wakeup()) != ATCA_SUCCESS )
 break;


 if ( (status = atsend( _gIface, (uint8_t*)&packet, packet.txsize )) != ATCA_SUCCESS )
 break;


 atca_delay_ms(execution_time);


 if ( (status = atreceive( _gIface, packet. _data , &(packet.rxsize) )) != ATCA_SUCCESS )
 break;


 if (packet.rxsize < 4) {
 if (packet.rxsize > 0)
 status = ATCA_RX_FAIL;
 else
 status = ATCA_RX_NO_RESPONSE;
 break;
 }

 if ( (status = isATCAError(packet. _data )) != ATCA_SUCCESS )
 break;

 memcpy(  _data , &packet. _data [1], len );
 } while (0);

 _atcab_exit();
 return status;
}
#line 1063 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_read_enc(uint8_t slotid, uint8_t block, uint8_t * _data , uint8_t* enckey, uint16_t enckeyid)
{
 ATCA_STATUS status = ATCA_GEN_FAIL;
 uint8_t zone =  ((uint8_t)0x02)  |  ((uint8_t)0x80) ;
 atca_nonce_in_out_t nonceParam;
 atca_gen_dig_in_out_t genDigParam;
 atca_temp_key_t tempkey;
 uint8_t numin[ (20) ] = { 0 };
 uint8_t randout[ ((uint8_t)0x20) ] = { 0 };
 int i = 0;

 do {

 if ( _data  ==  ((void *)0)  || enckey ==  ((void *)0) ) {
 status = ATCA_BAD_PARAM;
 break;
 }


 nonceParam.mode =  ((uint8_t)0x00) ;
 nonceParam.num_in = (uint8_t*)&numin;
 nonceParam.rand_out = (uint8_t*)&randout;
 nonceParam.temp_key = &tempkey;


 if ((status = atcab_nonce_rand(numin, randout)) != ATCA_SUCCESS)  break ;


 if ((status = atcah_nonce(&nonceParam)) != ATCA_SUCCESS)  break ;


 genDigParam.key_id = enckeyid;
 genDigParam.stored_value = enckey;
 genDigParam.zone =  ((uint8_t)2) ;
 genDigParam.temp_key = &tempkey;


 if ((status = atcab_gendig( ((uint8_t)2) , enckeyid)) != ATCA_SUCCESS)  break ;


 if ((status = atcah_gen_dig(&genDigParam)) != ATCA_SUCCESS)  break ;


 if ((status = atcab_read_zone(zone, slotid, block, 0,  _data ,  (32) )) != ATCA_SUCCESS)  break ;


 for (i = 0; i <  (32) ; i++)
  _data [i] =  _data [i] ^ tempkey.value[i];

 status = ATCA_SUCCESS;

 } while (0);

 _atcab_exit();
 return status;
}
#line 1130 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_write_enc(uint8_t slotid, uint8_t block, uint8_t * _data , uint8_t* enckey, uint16_t enckeyid)
{
 ATCA_STATUS status = ATCA_GEN_FAIL;
 uint8_t i = 0;
 uint8_t zone =  ((uint8_t)0x02)  |  ((uint8_t)0x80) ;
 atca_nonce_in_out_t nonceParam;
 atca_gen_dig_in_out_t genDigParam;
 atca_temp_key_t tempkey;
 uint8_t numin[ (20) ] = { 0 };
 uint8_t randout[ ((uint8_t)0x20) ] = { 0 };
 uint8_t cipher_text[ (32) ] = { 0 };
 ATCAPacket packet;
 uint16_t addr;
 uint16_t execution_time = 0;

 do {

 if ( _data  ==  ((void *)0)  || enckey ==  ((void *)0) ) {
 status = ATCA_BAD_PARAM;
 break;
 }

 nonceParam.mode =  ((uint8_t)0x00) ;
 nonceParam.num_in = (uint8_t*)&numin;
 nonceParam.rand_out = (uint8_t*)&randout;
 nonceParam.temp_key = &tempkey;


 if ((status = atcab_nonce_rand(numin, randout)) != ATCA_SUCCESS)  break ;


 if ((status = atcah_nonce(&nonceParam)) != ATCA_SUCCESS)  break ;


 genDigParam.key_id = enckeyid;
 genDigParam.stored_value = (uint8_t*)enckey;
 genDigParam.zone =  ((uint8_t)2) ;
 genDigParam.temp_key = &tempkey;


 if ((status = atcab_gendig( ((uint8_t)2) , enckeyid)) != ATCA_SUCCESS)  break ;


 if ((status = atcah_gen_dig(&genDigParam)) != ATCA_SUCCESS)  break ;


 for (i = 0; i <  (32) ; i++)
 cipher_text[i] =  _data [i] ^ tempkey.value[i];


 if ((status = atcab_get_addr( ((uint8_t)0x02) , slotid, block, 0, &addr)) != ATCA_SUCCESS)  break ;


 genDigParam.zone = zone;
 genDigParam.key_id = addr;
 genDigParam.stored_value = (uint8_t*) _data ;
 genDigParam.temp_key = &tempkey;

 if ((status = atcah_gen_mac(&genDigParam)) != ATCA_SUCCESS)  break ;


 packet.param1 = zone;
 packet.param2 = addr;
 memcpy(packet. _data , cipher_text,  (32) );
 memcpy(&packet. _data [ (32) ], tempkey.value,  (32) );

 if ((status = atWriteEnc(_gCommandObj, &packet)) != ATCA_SUCCESS)  break ;

 execution_time = atGetExecTime(_gCommandObj, CMD_WRITEMEM);

 if ((status = atcab_wakeup()) != ATCA_SUCCESS)  break ;


 if ((status = atsend(_gIface, (uint8_t*)&packet, packet.txsize)) != ATCA_SUCCESS)  break ;


 atca_delay_ms(execution_time);


 if ((status = atreceive(_gIface, packet. _data , &(packet.rxsize))) != ATCA_SUCCESS)  break ;


 if (packet.rxsize < 4) {
 if (packet.rxsize > 0)
 status = ATCA_RX_FAIL;
 else
 status = ATCA_RX_NO_RESPONSE;
 break;
 }

 status = isATCAError(packet. _data );

 } while (0);

 _atcab_exit();
 return status;
}
#line 1236 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_read_ecc_config_zone(uint8_t* config_data)
{
 ATCA_STATUS status = ATCA_GEN_FAIL;
 ATCAPacket packet;
 uint16_t execution_time = 0;
 uint8_t zone = 0, block = 0, offset = 0, slot = 0, index = 0;
 uint16_t addr = 0x0000;


 do {
 if ((block == 2) && (offset <= 7)) {

 packet.param1 =  ((uint8_t)0x00) ;


 if ( (status = atcab_get_addr(zone, slot, block, offset, &addr)) != ATCA_SUCCESS )
 break;

 packet.param2 = addr;
 status = atRead(_gCommandObj, &packet);
 execution_time = atGetExecTime( _gCommandObj, CMD_READMEM);

 if ( (status = atcab_wakeup()) != ATCA_SUCCESS )
 break;


 if ( (status = atsend( _gIface, (uint8_t*)&packet, packet.txsize )) != ATCA_SUCCESS )
 break;


 atca_delay_ms(execution_time);

 memset(packet. _data , 0x00, 130);


 if ( (status = atreceive( _gIface, packet. _data , &packet.rxsize)) != ATCA_SUCCESS )
 break;


 if (packet.rxsize < 4) {
 if (packet.rxsize > 0)
 status = ATCA_RX_FAIL;
 else
 status = ATCA_RX_NO_RESPONSE;
 break;
 }

 if ( (status = atcab_idle()) != ATCA_SUCCESS )
 break;


 if ( (status = isATCAError(packet. _data )) != ATCA_SUCCESS )
 break;


 ++offset;
 if ((block == 2) && (offset > 7))
 block = 3;


 memcpy(&config_data[index], &packet. _data [1],  (4)  );
 index +=  (4) ;
 }else {

 offset = 0;

 packet.param1 =  ((uint8_t)0x00)  |  ((uint8_t)0x80) ;


 if ( (status = atcab_get_addr(zone, slot, block, offset, &addr)) != ATCA_SUCCESS )
 break;

 packet.param2 = addr;
 status = atRead(_gCommandObj, &packet);
 execution_time = atGetExecTime( _gCommandObj, CMD_READMEM);

 if ( (status = atcab_wakeup()) != ATCA_SUCCESS ) break;


 if ( (status = atsend( _gIface, (uint8_t*)&packet, packet.txsize )) != ATCA_SUCCESS )
 break;


 atca_delay_ms(execution_time);

 memset(packet. _data , 0x00, sizeof(packet. _data ));


 if ( (status = atreceive( _gIface, packet. _data , &packet.rxsize)) != ATCA_SUCCESS )
 break;


 if (packet.rxsize < 4) {
 if (packet.rxsize > 0)
 status = ATCA_RX_FAIL;
 else
 status = ATCA_RX_NO_RESPONSE;
 break;
 }

 if ( (status = atcab_idle()) != ATCA_SUCCESS )
 break;


 if ( (status = isATCAError(packet. _data )) != ATCA_SUCCESS )
 break;


 ++block;


 memcpy(&config_data[index], &packet. _data [1],  (32)  );
 index +=  (32) ;
 }

 } while (block <= 3);

 _atcab_exit();
 return status;
}
#line 1361 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_write_ecc_config_zone(uint8_t* config_data)
{
 ATCA_STATUS status = ATCA_GEN_FAIL;
 ATCAPacket packet;
 uint16_t execution_time = 0;
 uint8_t zone = 0, block = 0, offset = 0, slot = 0, index = 0;
 uint16_t addr = 0;


 offset = 4;
 do {
 if ((block == 0) || (block == 2)) {

 if (offset <= 7) {
 memset(packet. _data , 0x00, 130);

 packet.param1 =  ((uint8_t)0x00) ;

 if ( (status = atcab_get_addr(zone, slot, block, offset, &addr)) != ATCA_SUCCESS )
 break;

 packet.param2 = addr;
 memcpy(&packet. _data [0], &config_data[index + 16],  (4) );
 index +=  (4) ;
 status = atWrite(_gCommandObj, &packet);
 execution_time = atGetExecTime( _gCommandObj, CMD_WRITEMEM);

 if ( (status = atcab_wakeup()) != ATCA_SUCCESS ) break;


 if ( (status = atsend( _gIface, (uint8_t*)&packet, packet.txsize )) != ATCA_SUCCESS )
 break;


 atca_delay_ms(execution_time);


 if ( (status = atreceive( _gIface, packet. _data , &packet.rxsize)) != ATCA_SUCCESS )
 break;


 if (packet.rxsize < 4) {
 if (packet.rxsize > 0)
 status = ATCA_RX_FAIL;
 else
 status = ATCA_RX_NO_RESPONSE;
 break;
 }

 if ( (status = atcab_idle()) != ATCA_SUCCESS ) break;

 if ( (status = isATCAError(packet. _data )) != ATCA_SUCCESS )
 break;


 ++offset;
 if ((block == 2) && (offset == 5)) {

 ++offset; index +=  (4) ;
 }
 }else {

 ++block; offset = 0;
 }
 }else {
 memset(packet. _data , 0x00, 130);

 packet.param1 =  ((uint8_t)0x00)  |  ((uint8_t)0x80) ;

 atcab_get_addr(zone, slot, block, offset, &addr);
 packet.param2 = addr;
 memcpy(&packet. _data [0], &config_data[index + 16],  (32) );
 index +=  (32) ;
 if ( (status = atWrite(_gCommandObj, &packet)) != ATCA_SUCCESS )
 break;

 execution_time = atGetExecTime( _gCommandObj, CMD_WRITEMEM);

 if ( (status = atcab_wakeup()) != ATCA_SUCCESS ) break;


 if ( (status = atsend( _gIface, (uint8_t*)&packet, packet.txsize )) != ATCA_SUCCESS )
 break;


 atca_delay_ms(execution_time);


 if ( (status = atreceive( _gIface, packet. _data , &packet.rxsize)) != ATCA_SUCCESS )
 break;


 if (packet.rxsize < 4) {
 if (packet.rxsize > 0)
 status = ATCA_RX_FAIL;
 else
 status = ATCA_RX_NO_RESPONSE;
 break;
 }

 if ( (status = atcab_idle()) != ATCA_SUCCESS ) break;

 if ( (status = isATCAError(packet. _data )) != ATCA_SUCCESS )
 break;


 ++block; offset = 0;
 }

 } while (block <= 3);

 _atcab_exit();
 return status;
}
#line 1480 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_read_sha_config_zone(uint8_t* config_data)
{
 ATCA_STATUS status = ATCA_GEN_FAIL;

 do {


 if ( config_data ==  ((void *)0)  ) {
 status = ATCA_BAD_PARAM;
 break;
 }

 status = atcab_read_bytes_zone(ATSHA204A,  ((uint8_t)0x00) , 0x00,  (88) , config_data);
 if ( status != ATCA_SUCCESS )
 break;

 } while (0);

 return status;
}
#line 1505 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_write_sha_config_zone(uint8_t* config_data)
{
 ATCA_STATUS status = ATCA_GEN_FAIL;

 do {


 if ( config_data ==  ((void *)0)  ) {
 status = ATCA_BAD_PARAM;
 break;
 }

 status = atcab_write_bytes_zone(ATSHA204A,  ((uint8_t)0x00) , 0x10, &config_data[16], 68);
 if ( status != ATCA_SUCCESS )
 break;

 } while (0);

 return status;
}
#line 1531 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_read_config_zone(ATCADeviceType dev_type, uint8_t* config_data)
{
 ATCA_STATUS status = ATCA_GEN_FAIL;

 do {


 if ( config_data ==  ((void *)0)  ) {
 status = ATCA_BAD_PARAM;
 break;
 }

 if (dev_type == ATSHA204A)
 status = atcab_read_bytes_zone(dev_type,  ((uint8_t)0x00) , 0x00,  (88) , config_data);
 else
 status = atcab_read_bytes_zone(dev_type,  ((uint8_t)0x00) , 0x00,  (128) , config_data);

 if ( status != ATCA_SUCCESS )
 break;

 } while (0);

 return status;
}
#line 1560 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_write_config_zone(ATCADeviceType dev_type, uint8_t* config_data)
{
 ATCA_STATUS status = ATCA_GEN_FAIL;

 do {


 if ( config_data ==  ((void *)0)  ) {
 status = ATCA_BAD_PARAM;
 break;
 }

 if (dev_type == ATSHA204A)
 status = atcab_write_bytes_zone(dev_type,  ((uint8_t)0x00) , 0x00, config_data,  (88) );
 else
 status = atcab_write_bytes_zone(dev_type,  ((uint8_t)0x00) , 0x00, config_data,  (128) );

 if ( status != ATCA_SUCCESS )
 break;

 } while (0);

 return status;
}
#line 1591 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_cmp_config_zone(uint8_t* config_data,  _Bool * same_config)
{
 ATCA_STATUS status = ATCA_GEN_FAIL;
 uint8_t device_config_data[ (128) ];

 do {

 if ((config_data ==  ((void *)0) ) || (same_config ==  ((void *)0) )) {
 status = ATCA_BAD_PARAM;
  break ;
 }

 *same_config =  0 ;


 if ((status = atcab_read_ecc_config_zone(device_config_data)) != ATCA_SUCCESS)  break ;



 if (memcmp(&device_config_data[16], &config_data[16], 52 - 16) == 0
 && memcmp(&device_config_data[90], &config_data[90], 128 - 90) == 0) {
 *same_config =  1 ;
 break;
 }
 } while (0);
 return status;
}
#line 1625 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_lock_config_zone(uint8_t* lock_response)
{
 ATCA_STATUS status = ATCA_GEN_FAIL;
 ATCAPacket packet;
 uint16_t execution_time = 0;


 packet.param1 =  ((uint8_t)0x80)  |  ((uint8_t)0x00) ;

 do {
 if ( (status = atLock(_gCommandObj, &packet)) != ATCA_SUCCESS ) break;

 execution_time = atGetExecTime( _gCommandObj, CMD_LOCK);

 if ( (status = atcab_wakeup()) != ATCA_SUCCESS ) break;


 if ( (status = atsend( _gIface, (uint8_t*)&packet, packet.txsize )) != ATCA_SUCCESS )
 break;


 atca_delay_ms(execution_time);


 if ( (status = atreceive( _gIface, packet. _data , &packet.rxsize)) != ATCA_SUCCESS )
 break;


 if (packet.rxsize < 4) {
 if (packet.rxsize > 0)
 status = ATCA_RX_FAIL;
 else
 status = ATCA_RX_NO_RESPONSE;
 break;
 }


 if ( (status = isATCAError(packet. _data )) != ATCA_SUCCESS )
 break;

 memcpy(lock_response, &packet. _data [1], 1);
 } while (0);

 _atcab_exit();
 return status;
}
#line 1679 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_lock_data_zone(uint8_t* lock_response)
{
 ATCA_STATUS status = ATCA_GEN_FAIL;
 ATCAPacket packet;
 uint16_t execution_time = 0;


 packet.param1 =  ((uint8_t)0x80)  |  ((uint8_t)0x01) ;
 packet.param2 = 0x0000;

 do {
 status = atLock(_gCommandObj, &packet);
 execution_time = atGetExecTime( _gCommandObj, CMD_LOCK);

 if ((status = atcab_wakeup()) != ATCA_SUCCESS ) break;


 if ((status = atsend( _gIface, (uint8_t*)&packet, packet.txsize )) != ATCA_SUCCESS )
 break;


 atca_delay_ms(execution_time);


 if ((status = atreceive( _gIface, packet. _data , &packet.rxsize)) != ATCA_SUCCESS )
 break;


 if (packet.rxsize < 4) {
 if (packet.rxsize > 0)
 status = ATCA_RX_FAIL;
 else
 status = ATCA_RX_NO_RESPONSE;
 break;
 }


 if ((status = isATCAError(packet. _data )) != ATCA_SUCCESS )
 break;

 memcpy(lock_response, &packet. _data [1], 1);
 } while (0);

 _atcab_exit();
 return status;
}
#line 1733 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_lock_data_slot(uint8_t slot, uint8_t* lock_response)
{
 ATCA_STATUS status = ATCA_GEN_FAIL;
 ATCAPacket packet;
 uint16_t execution_time = 0;


 packet.param1 = (slot << 2) |  ((uint8_t)0x02) ;
 packet.param2 = 0x0000;

 do {
 if ( (status = atLock(_gCommandObj, &packet)) != ATCA_SUCCESS ) break;

 execution_time = atGetExecTime( _gCommandObj, CMD_LOCK);

 if ( (status = atcab_wakeup()) != ATCA_SUCCESS ) break;


 if ( (status = atsend( _gIface, (uint8_t*)&packet, packet.txsize )) != ATCA_SUCCESS )
 break;


 atca_delay_ms(execution_time);


 if ( (status = atreceive( _gIface, packet. _data , &packet.rxsize)) != ATCA_SUCCESS )
 break;


 if (packet.rxsize < 4) {
 if (packet.rxsize > 0)
 status = ATCA_RX_FAIL;
 else
 status = ATCA_RX_NO_RESPONSE;
 break;
 }


 if ( (status = isATCAError(packet. _data )) != ATCA_SUCCESS )
 break;

 memcpy(lock_response, &packet. _data [1], 1);
 } while (0);

 _atcab_exit();
 return status;
}
#line 1787 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_sign(uint16_t slot, uint8_t *msg, uint8_t *signature)
{
 ATCA_STATUS status = ATCA_GEN_FAIL;
 ATCAPacket packet;
 uint16_t execution_time = 0;
 uint8_t randomnum[64];

 if ( !_gDevice )
 return ATCA_GEN_FAIL;

 do {
 if ( (status = atcab_random(randomnum)) != ATCA_SUCCESS ) break;
 if ( (status = atcab_challenge( msg )) != ATCA_SUCCESS ) break;


 packet.param1 =  ((uint8_t)0x80) ;
 packet.param2 = slot;
 if ( (status = atSign( _gCommandObj, &packet )) != ATCA_SUCCESS )
 break;

 execution_time = atGetExecTime( _gCommandObj, CMD_SIGN);

 if ( (status != atcab_wakeup()) != ATCA_SUCCESS ) break;


 if ( (status = atsend( _gIface, (uint8_t*)&packet, packet.txsize )) != ATCA_SUCCESS )
 break;


 atca_delay_ms(execution_time);


 if ( (status = atreceive( _gIface, packet. _data , &(packet.rxsize))) != ATCA_SUCCESS )
 break;


 if (packet.rxsize < 4) {
 if (packet.rxsize > 0)
 status = ATCA_RX_FAIL;
 else
 status = ATCA_RX_NO_RESPONSE;
 break;
 }


 if ( (status = isATCAError(packet. _data )) != ATCA_SUCCESS )
 break;

 memcpy( signature, &packet. _data [1],  (64)  );
 } while (0);

 _atcab_exit();
 return status;
}
#line 1849 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_gendig(uint8_t zone, uint16_t key_id)
{
 ATCA_STATUS status = ATCA_GEN_FAIL;
 uint8_t otherDat[ (32) ] = { 0 };

 do {

 if (!_gDevice) return ATCA_GEN_FAIL;


 if ((status = atcab_gendig_host(zone, key_id, otherDat,  (32) )) != ATCA_SUCCESS )  break ;

 } while (0);
 return status;
}
#line 1872 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_gendig_host(uint8_t zone, uint16_t key_id, uint8_t *other_data, uint8_t len)
{
 ATCA_STATUS status = ATCA_GEN_FAIL;
 ATCAPacket packet;
 uint16_t execution_time = 0;
  _Bool  hasMACKey = 0;

 if ( !_gDevice || other_data ==  ((void *)0)  )
 return ATCA_GEN_FAIL;

 do {


 packet.param1 = zone;
 packet.param2 = key_id;

 if ( packet.param1 == 0x03 && len == 0x20)
 memcpy(&packet. _data [0], &other_data[0],  (4) );
 else if ( packet.param1 == 0x02 && len == 0x20) {
 memcpy(&packet. _data [0], &other_data[0],  (4) );
 hasMACKey =  1 ;
 }

 if ( (status = atGenDig( _gCommandObj, &packet, hasMACKey)) != ATCA_SUCCESS )
 break;

 execution_time = atGetExecTime( _gCommandObj, CMD_GENDIG);

 if ( (status != atcab_wakeup()) != ATCA_SUCCESS ) break;


 if ( (status = atsend( _gIface, (uint8_t*)&packet, packet.txsize )) != ATCA_SUCCESS )
 break;


 atca_delay_ms(execution_time);


 if ( (status = atreceive( _gIface, packet. _data , &(packet.rxsize))) != ATCA_SUCCESS )
 break;


 if (packet.rxsize < 4) {
 if (packet.rxsize > 0)
 status = ATCA_RX_FAIL;
 else
 status = ATCA_RX_NO_RESPONSE;
 break;
 }


 if ( (status = isATCAError(packet. _data )) != ATCA_SUCCESS )
 break;

 } while (0);

 _atcab_exit();
 return status;
}
#line 1937 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_read_sig(uint8_t slot8toF, uint8_t *sig)
{
 uint8_t ret = ATCA_GEN_FAIL;
 uint8_t read_buf[ (32) ];
 uint8_t block = 0;
 uint8_t offset = 0;
 uint8_t cpyIndex = 0;

 do {

 if (sig ==  ((void *)0) ) break;


 if (slot8toF < 8 || slot8toF > 0xF) break;


 block = 0;
 if ( (ret = atcab_read_zone( ((uint8_t)0x02) , slot8toF, block, offset, read_buf,  (32) )) != ATCA_SUCCESS )
 break;


 memcpy(&sig[cpyIndex], &read_buf[0],  (32) );
 cpyIndex +=  (32) ;


 block = 1;
 if ( (ret = atcab_read_zone( ((uint8_t)0x02) , slot8toF, block, offset, read_buf,  (32) )) != ATCA_SUCCESS )
 break;


 memcpy(&sig[cpyIndex], &read_buf[0],  (32) );
 cpyIndex +=  (32) ;

 } while (0);

 return ret;
}
#line 1981 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_calc_pubkey(uint8_t privSlotId, uint8_t *pubkey)
{
 return atcab_get_pubkey(privSlotId, pubkey);
}
#line 1992 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_get_pubkey(uint8_t privSlotId, uint8_t *pubkey)
{
 ATCAPacket packet;
 uint16_t execution_time = 0;
 ATCA_STATUS status = ATCA_GEN_FAIL;

 do {

 packet.param1 =  ((uint8_t)0x00) ;
 packet.param2 = (uint16_t)(privSlotId);

 if ( (status = atGenKey( _gCommandObj, &packet,  0  )) != ATCA_SUCCESS ) break;

 execution_time = atGetExecTime( _gCommandObj, CMD_GENKEY);

 if ( (status = atcab_wakeup()) != ATCA_SUCCESS ) break;


 if ( (status = atsend( _gIface, (uint8_t*)&packet, packet.txsize )) != ATCA_SUCCESS )
 break;


 atca_delay_ms(execution_time);


 if ( (status = atreceive( _gIface, packet. _data , &(packet.rxsize) )) != ATCA_SUCCESS )
 break;


 if (packet.rxsize < 4) {
 if (packet.rxsize > 0)
 status = ATCA_RX_FAIL;
 else
 status = ATCA_RX_NO_RESPONSE;
 break;
 }

 if ( (status = isATCAError(packet. _data )) != ATCA_SUCCESS )
 break;


 memcpy(pubkey, &packet. _data [1], 64 );
 } while (0);

 _atcab_exit();
 return status;
}
#line 2047 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_priv_write(uint8_t slot, uint8_t priv_key[36], uint8_t write_key_slot, uint8_t write_key[32])
{
 ATCA_STATUS status = ATCA_GEN_FAIL;
 ATCAPacket packet;
 atca_nonce_in_out_t nonceParam;
 atca_gen_dig_in_out_t genDigParam;
 atca_write_mac_in_out_t hostMacParam;
 atca_temp_key_t tempkey;
 uint8_t numin[ (20) ] = { 0 };
 uint8_t randout[ ((uint8_t)0x20) ] = { 0 };
 uint8_t cipher_text[36] = { 0 };
 uint8_t host_mac[ (32) ] = { 0 };
 uint16_t execution_time = 0;
 uint8_t privKey[36];
 uint8_t writeKey[32];

 if (slot > 15 || priv_key ==  ((void *)0) )
 return ATCA_BAD_PARAM;

 do {

 if (write_key ==  ((void *)0) ) {


 packet.param1 = 0x00;
 packet.param2 = slot;
 memcpy(&packet. _data [0], priv_key, 36);
 memset(&packet. _data [36], 0, 32);
 }else {

 memcpy(privKey, priv_key, 36);
 memcpy(writeKey, write_key, 32);


 if ((status = atcab_nonce_rand(numin, randout)) != ATCA_SUCCESS)
 break;


 nonceParam.mode =  ((uint8_t)0x00) ;
 nonceParam.num_in = numin;
 nonceParam.rand_out = randout;
 nonceParam.temp_key = &tempkey;
 if ((status = atcah_nonce(&nonceParam)) != ATCA_SUCCESS)
 break;


 if ((status = atcab_gendig_host( ((uint8_t)2) , write_key_slot, tempkey.value, 32)) != ATCA_SUCCESS)
 break;


 genDigParam.zone =  ((uint8_t)2) ;
 genDigParam.key_id = write_key_slot;
 genDigParam.stored_value = writeKey;
 genDigParam.temp_key = &tempkey;
 if ((status = atcah_gen_dig(&genDigParam)) != ATCA_SUCCESS)
 break;


 hostMacParam.zone =  ((uint8_t)0x40) ;
 hostMacParam.key_id = slot;
 hostMacParam.encryption_key = &privKey[4];
 hostMacParam.input_data = privKey;
 hostMacParam.encrypted_data = cipher_text;
 hostMacParam.auth_mac = host_mac;
 hostMacParam.temp_key = &tempkey;
 if ((status = atcah_privwrite_auth_mac(&hostMacParam)) != ATCA_SUCCESS)
 break;


 packet.param1 =  ((uint8_t)0x40) ;
 packet.param2 = slot;
 memcpy(&packet. _data [0], cipher_text, sizeof(cipher_text));
 memcpy(&packet. _data [36], host_mac, sizeof(host_mac));
 }

 if ((status = atPrivWrite(_gCommandObj, &packet)) != ATCA_SUCCESS)
 break;

 execution_time = atGetExecTime(_gCommandObj, CMD_PRIVWRITE);

 if ( (status = atcab_wakeup()) != ATCA_SUCCESS ) break;


 if ((status = atsend(_gIface, (uint8_t*)&packet, packet.txsize)) != ATCA_SUCCESS)
 break;


 atca_delay_ms(execution_time);


 if ((status = atreceive(_gIface, packet. _data , &packet.rxsize)) != ATCA_SUCCESS)
 break;


 if (packet.rxsize < 4) {
 if (packet.rxsize > 0)
 status = ATCA_RX_FAIL;
 else
 status = ATCA_RX_NO_RESPONSE;
 break;
 }

 if ( (status = isATCAError(packet. _data )) != ATCA_SUCCESS )
 break;

 } while (0);

 _atcab_exit();
 return status;
}
#line 2163 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_write_pubkey(uint8_t slot8toF, uint8_t *pubkey)
{
 ATCA_STATUS status = ATCA_SUCCESS;
 uint8_t write_block[ (32) ];
 uint8_t block = 0;
 uint8_t offset = 0;
 uint8_t cpyIndex = 0;
 uint8_t cpySize = 0;
 uint8_t writeIndex = 0;

 do {

 if (pubkey ==  ((void *)0) ) {
 status = ATCA_BAD_PARAM;
 break;
 }

 if (slot8toF < 8 || slot8toF > 0xF) {
 status = ATCA_BAD_PARAM;
 break;
 }





 block = 0;
 writeIndex =  (4) ;
 memset(write_block, 0, sizeof(write_block));
 cpySize =  (32)  -  (4) ;
 memcpy(&write_block[writeIndex], &pubkey[cpyIndex], cpySize);
 cpyIndex += cpySize;

 status = atcab_write_zone( ((uint8_t)0x02) , slot8toF, block, offset, write_block,  (32) );
 if (status != ATCA_SUCCESS) break;


 block = 1;
 writeIndex = 0;
 memset(write_block, 0, sizeof(write_block));

 cpySize =  (4) ;
 memcpy(&write_block[writeIndex], &pubkey[cpyIndex], cpySize);
 cpyIndex += cpySize;

 writeIndex += cpySize +  (4) ;
 cpySize =  (32)  - writeIndex;
 memcpy(&write_block[writeIndex], &pubkey[cpyIndex], cpySize);
 cpyIndex += cpySize;

 status = atcab_write_zone( ((uint8_t)0x02) , slot8toF, block, offset, write_block,  (32) );
 if (status != ATCA_SUCCESS) break;


 block = 2;
 writeIndex = 0;
 memset(write_block, 0, sizeof(write_block));

 cpySize =  (4)  +  (4) ;
 memcpy(&write_block[writeIndex], &pubkey[cpyIndex], cpySize);

 status = atcab_write_zone( ((uint8_t)0x02) , slot8toF, block, offset, write_block,  (32) );
 if (status != ATCA_SUCCESS) break;

 } while (0);

 return status;
}
#line 2237 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_read_pubkey(uint8_t slot8toF, uint8_t *pubkey)
{
 uint8_t ret = ATCA_GEN_FAIL;
 uint8_t read_buf[ (32) ];
 uint8_t block = 0;
 uint8_t offset = 0;
 uint8_t cpyIndex = 0;
 uint8_t cpySize = 0;
 uint8_t readIndex = 0;


 if (pubkey ==  ((void *)0) )
 return ATCA_BAD_PARAM;

 if (slot8toF < 8 || slot8toF > 0xF)
 return ATCA_BAD_PARAM;

 do {





 block = 0;
 if ( (ret = atcab_read_zone( ((uint8_t)0x02) , slot8toF, block, offset, read_buf,  (32) )) != ATCA_SUCCESS )
 break;


 cpySize =  (32)  -  (4) ;
 readIndex =  (4) ;
 memcpy(&pubkey[cpyIndex], &read_buf[readIndex], cpySize);
 cpyIndex += cpySize;


 block = 1;
 if ( (ret = atcab_read_zone( ((uint8_t)0x02) , slot8toF, block, offset, read_buf,  (32) )) != ATCA_SUCCESS )
 break;


 cpySize =  (4) ;
 readIndex = 0;
 memcpy(&pubkey[cpyIndex], &read_buf[readIndex], cpySize);
 cpyIndex += cpySize;

 readIndex =  (4)  +  (4) ;
 cpySize =  (32)  - readIndex;
 memcpy(&pubkey[cpyIndex], &read_buf[readIndex], cpySize);
 cpyIndex += cpySize;


 block = 2;
 if ( (ret = atcab_read_zone( ((uint8_t)0x02) , slot8toF, block, offset, read_buf,  (32) )) != ATCA_SUCCESS )
 break;


 cpySize =  (4)  +  (4) ;
 readIndex = 0;
 memcpy(&pubkey[cpyIndex], &read_buf[readIndex], cpySize);

 } while (0);

 return ret;
}
#line 2308 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_write_bytes_slot(uint8_t slot, uint16_t offset, uint8_t * _data , uint8_t len)
{
 ATCA_STATUS status = ATCA_GEN_FAIL;

 uint16_t currAddress = offset;
 uint8_t currBlock = currAddress /  (32) ;
 uint8_t prevBlock = currBlock;
 uint8_t currOffset = (currAddress - (currBlock *  (32) )) /  (4) ;
 uint16_t writeIdx = 0;

 if ( _data  ==  ((void *)0)  || slot > 15)
 return ATCA_BAD_PARAM;

 do {
 status = atcab_write_zone( ((uint8_t)0x02) , slot, currBlock, currOffset, & _data [writeIdx],  (32) );
 if (status != ATCA_SUCCESS) break;

 currAddress +=  (32) ;
 currBlock = currAddress /  (32) ;

 if ( prevBlock == currBlock)
 currOffset++;
 else {
 currOffset = 0;
 prevBlock = currBlock;
 }

 writeIdx +=  (32) ;
 } while (0);

 return status;
}
#line 2349 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_write_bytes_zone(ATCADeviceType dev_type, uint8_t zone, uint16_t address, uint8_t * _data , uint8_t len)
{
 ATCA_STATUS status = ATCA_GEN_FAIL;

 uint8_t dataSlot = 0;
 uint16_t currAddress = address, writeIdx = 0;
 uint8_t currBlock, prevBlock, currOffset;
 static uint16_t slot8_addr = 288, slot9_addr = 704;

 if ( _data  ==  ((void *)0)  || zone >  ((uint8_t)0x02) )
 return ATCA_BAD_PARAM;

 if (zone ==  ((uint8_t)0x00) ) {

 currBlock = currAddress /  (32) ;
 prevBlock = currBlock;
 currOffset = (currAddress - (currBlock *  (32) )) /  (4) ;

 while ( writeIdx < len) {

 if (!(currBlock == 0 && (currOffset == 0 || currOffset == 1 || currOffset == 2 || currOffset == 3))
 && !(currBlock == 2 && (currOffset == 5 || currOffset == 6))
 ) {
 status = atcab_write_zone(zone, 0, currBlock, currOffset, & _data [writeIdx],  (4) );
 if (status != ATCA_SUCCESS) break;
 }

 currAddress +=  (4) ;
 currBlock = currAddress /  (32) ;

 if ( prevBlock == currBlock)
 currOffset++;
 else {
 currOffset = 0;
 prevBlock = currBlock;
 }

 writeIdx +=  (4) ;
 }

 } else if (zone ==  ((uint8_t)0x01) ) {

 currBlock = currAddress /  (32) ;
 prevBlock = currBlock;
 currOffset = (currAddress - (currBlock *  (32) )) /  (4) ;

 while ( writeIdx < len) {

 status = atcab_write_zone(zone, 0, currBlock, currOffset, & _data [writeIdx],  (4) );
 if (status != ATCA_SUCCESS) break;

 currAddress +=  (4) ;
 currBlock = currAddress /  (32) ;

 if ( prevBlock == currBlock)
 currOffset++;
 else {
 currOffset = 0;
 prevBlock = currBlock;
 }

 writeIdx +=  (4) ;
 }

 } else {

 if (dev_type == ATECC508A || dev_type == ATECC108A ) {

 if (currAddress < slot8_addr) {
 dataSlot = currAddress / 36;
 currBlock = (currAddress - (dataSlot * 36)) /  (32) ;
 currOffset = (currAddress - (dataSlot *  (32) )) /  (4) ;
 currAddress = currAddress - (dataSlot * 36);
 } else if (currAddress < slot9_addr) {
 dataSlot = 8;
 currBlock = (currAddress - slot8_addr) /  (32) ;
 currOffset = (currAddress - slot8_addr) /  (4) ;
 currAddress = currAddress - slot8_addr;
 } else {
 dataSlot = (currAddress - slot9_addr) / 72;
 currBlock = (currAddress - slot9_addr) /  (32) ;
 currOffset = (currAddress - slot9_addr) /  (4) ;
 currAddress = currAddress - slot9_addr;
 }

 prevBlock = currBlock;

 } else {

 dataSlot = currAddress /  (32) ;
 currBlock = (currAddress - (dataSlot *  (32) )) /  (32) ;
 currOffset = (currAddress - (dataSlot *  (32) )) /  (4) ;
 currAddress = currAddress - (dataSlot *  (32) );
 prevBlock = currBlock;
 }

 while ( writeIdx < len) {

 status = atcab_write_zone( ((uint8_t)0x02) , dataSlot, currBlock, currOffset, & _data [writeIdx],  (4) );
 if (status != ATCA_SUCCESS) break;

 currAddress +=  (4) ;
 currBlock = currAddress /  (32) ;

 if ( prevBlock == currBlock)
 currOffset++;
 else {
 currOffset = 0;
 prevBlock = currBlock;
 }

 writeIdx +=  (4) ;
 }

 }

 return status;
}
#line 2476 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_read_bytes_zone(ATCADeviceType dev_type, uint8_t zone, uint16_t address, uint8_t len, uint8_t * _data )
{
 ATCA_STATUS status = ATCA_GEN_FAIL;

 uint8_t dataSlot = 0;
 uint16_t currAddress = address, readIdx = 0;
 uint8_t currBlock, prevBlock, currOffset;
 static uint16_t slot8_addr = 288, slot9_addr = 704;

 if ( _data  ==  ((void *)0)  || zone >  ((uint8_t)0x02) )
 return ATCA_BAD_PARAM;

 if (zone ==  ((uint8_t)0x00)  || zone ==  ((uint8_t)0x01) ) {

 currBlock = currAddress /  (32) ;
 prevBlock = currBlock;
 currOffset = (currAddress - (currBlock *  (32) )) /  (4) ;

 while ( readIdx < len) {

 status = atcab_read_zone(zone, 0, currBlock, currOffset, & _data [readIdx],  (4) );
 if (status != ATCA_SUCCESS) break;

 currAddress +=  (4) ;
 currBlock = currAddress /  (32) ;

 if ( prevBlock == currBlock)
 currOffset++;
 else {
 currOffset = 0;
 prevBlock = currBlock;
 }

 readIdx +=  (4) ;
 }

 } else {

 if (dev_type == ATECC508A || dev_type == ATECC108A ) {

 if (currAddress < slot8_addr) {
 dataSlot = currAddress / 36;
 currBlock = (currAddress - (dataSlot * 36)) /  (32) ;
 currOffset = (currAddress - (dataSlot *  (32) )) /  (4) ;
 currAddress = currAddress - (dataSlot * 36);
 } else if (currAddress < slot9_addr) {
 dataSlot = 8;
 currBlock = (currAddress - slot8_addr) /  (32) ;
 currOffset = (currAddress - slot8_addr) /  (4) ;
 currAddress = currAddress - slot8_addr;
 } else {
 dataSlot = (currAddress - slot9_addr) / 72;
 currBlock = (currAddress - slot9_addr) /  (32) ;
 currOffset = (currAddress - slot9_addr) /  (4) ;
 currAddress = currAddress - slot9_addr;
 }

 prevBlock = currBlock;

 } else {

 dataSlot = currAddress /  (32) ;
 currBlock = (currAddress - (dataSlot *  (32) )) /  (32) ;
 currOffset = (currAddress - (dataSlot *  (32) )) /  (4) ;
 currAddress = currAddress - (dataSlot *  (32) );
 prevBlock = currBlock;
 }

 while ( readIdx < len) {

 status = atcab_read_zone( ((uint8_t)0x02) , dataSlot, currBlock, currOffset, & _data [readIdx],  (4) );
 if (status != ATCA_SUCCESS) break;

 currAddress +=  (4) ;
 currBlock = currAddress /  (32) ;

 if ( prevBlock == currBlock)
 currOffset++;
 else {
 currOffset = 0;
 prevBlock = currBlock;
 }

 readIdx +=  (4) ;
 }

 }

 return status;
}
#line 2575 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_mac( uint8_t mode, uint16_t key_id, uint8_t* challenge, uint8_t* digest )
{
 ATCA_STATUS status = ATCA_GEN_FAIL;
 ATCAPacket packet;
 uint16_t execution_time = 0;

 do {


 if ( challenge ==  ((void *)0)  || digest ==  ((void *)0)  ) {
 status = ATCA_BAD_PARAM;
 break;
 }


 packet.param1 = mode;
 packet.param2 = key_id;
 memcpy( &packet. _data [0], challenge, 32 );

 if ( (status = atMAC( _gCommandObj, &packet )) != ATCA_SUCCESS )
 break;

 execution_time = atGetExecTime( _gCommandObj, CMD_MAC);

 if ( (status != atcab_wakeup()) != ATCA_SUCCESS ) break;


 if ( (status = atsend( _gIface, (uint8_t*)&packet, packet.txsize )) != ATCA_SUCCESS )
 break;


 atca_delay_ms(execution_time);


 if ( (status = atreceive( _gIface, packet. _data , &(packet.rxsize))) != ATCA_SUCCESS )
 break;


 if (packet.rxsize < 4) {
 if (packet.rxsize > 0)
 status = ATCA_RX_FAIL;
 else
 status = ATCA_RX_NO_RESPONSE;
 break;
 }


 if ( (status = isATCAError(packet. _data )) != ATCA_SUCCESS )
 break;

 memcpy( digest, &packet. _data [ (1) ],  (32)  );

 } while (0);

 _atcab_exit();
 return status;
}
#line 2641 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_checkmac( uint8_t mode, uint16_t key_id, uint8_t *challenge, uint8_t *response, uint8_t *other_data)
{
 ATCA_STATUS status = ATCA_GEN_FAIL;
 ATCAPacket packet;
 uint16_t execution_time = 0;

 do {


 if ( challenge ==  ((void *)0)  || response ==  ((void *)0)  || other_data ==  ((void *)0)  ) {
 status = ATCA_BAD_PARAM;
 break;
 }


 packet.param1 = mode;
 packet.param2 = key_id;
 memcpy( &packet. _data [0], challenge,  (32)  );
 memcpy( &packet. _data [32], response,  (32)  );
 memcpy( &packet. _data [64], other_data,  (13)  );

 if ( (status = atCheckMAC( _gCommandObj, &packet )) != ATCA_SUCCESS )
 break;

 execution_time = atGetExecTime( _gCommandObj, CMD_CHECKMAC);

 if ( (status != atcab_wakeup()) != ATCA_SUCCESS ) break;


 if ( (status = atsend( _gIface, (uint8_t*)&packet, packet.txsize )) != ATCA_SUCCESS )
 break;


 atca_delay_ms( execution_time );


 if ( (status = atreceive( _gIface, packet. _data , &(packet.rxsize))) != ATCA_SUCCESS )
 break;


 if (packet.rxsize < 4) {
 if (packet.rxsize > 0)
 status = ATCA_RX_FAIL;
 else
 status = ATCA_RX_NO_RESPONSE;
 break;
 }


 if ( (status = isATCAError(packet. _data )) != ATCA_SUCCESS )
 break;

 } while (0);

 _atcab_exit();
 return status;
}
#line 2702 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_sha_start(void)
{
 ATCA_STATUS status = ATCA_GEN_FAIL;
 ATCAPacket packet;
 uint16_t execution_time = 0;

 do {


 packet.param1 =  ((uint8_t)0x00) ;
 packet.param2 = 0;

 if ( (status = atSHA( _gCommandObj, &packet )) != ATCA_SUCCESS )
 break;

 execution_time = atGetExecTime( _gCommandObj, CMD_SHA);

 if ( (status != atcab_wakeup()) != ATCA_SUCCESS )
 break;


 if ( (status = atsend( _gIface, (uint8_t*)&packet, packet.txsize )) != ATCA_SUCCESS )
 break;


 atca_delay_ms( execution_time );


 if ( (status = atreceive( _gIface, packet. _data , &(packet.rxsize))) != ATCA_SUCCESS )
 break;


 if (packet.rxsize < 4) {
 if (packet.rxsize > 0)
 status = ATCA_RX_FAIL;
 else
 status = ATCA_RX_NO_RESPONSE;
 break;
 }


 if ( (status = isATCAError(packet. _data )) != ATCA_SUCCESS )
 break;

 } while (0);

 _atcab_exit();
 return status;
}
#line 2757 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_sha_update(uint16_t length, uint8_t *message)
{
 ATCA_STATUS status = ATCA_GEN_FAIL;
 ATCAPacket packet;
 uint16_t execution_time = 0;

 do {


 if ( message ==  ((void *)0)  || length >  (64)  ) {
 status = ATCA_BAD_PARAM;
 break;
 }


 packet.param1 =  ((uint8_t)0x01) ;
 packet.param2 = length;
 memcpy(&packet. _data [0], message, length);

 if ( (status = atSHA( _gCommandObj, &packet )) != ATCA_SUCCESS )
 break;

 execution_time = atGetExecTime( _gCommandObj, CMD_SHA);

 if ( (status != atcab_wakeup()) != ATCA_SUCCESS ) break;


 if ( (status = atsend( _gIface, (uint8_t*)&packet, packet.txsize )) != ATCA_SUCCESS )
 break;


 atca_delay_ms( execution_time );


 if ( (status = atreceive( _gIface, packet. _data , &(packet.rxsize))) != ATCA_SUCCESS )
 break;


 if (packet.rxsize < 4) {
 if (packet.rxsize > 0)
 status = ATCA_RX_FAIL;
 else
 status = ATCA_RX_NO_RESPONSE;
 break;
 }


 if ( (status = isATCAError(packet. _data )) != ATCA_SUCCESS )
 break;

 } while (0);

 _atcab_exit();
 return status;
}
#line 2817 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_sha_end(uint8_t *digest, uint16_t length, uint8_t *message)
{
 ATCA_STATUS status = ATCA_GEN_FAIL;
 ATCAPacket packet;
 uint16_t execution_time = 0;

 if ( length > 63 || digest ==  ((void *)0)  )
 return ATCA_BAD_PARAM;

 if ( length > 0 && message ==  ((void *)0)  )
 return ATCA_BAD_PARAM;

 do {


 if ( digest ==  ((void *)0)  ) {
 status = ATCA_BAD_PARAM;
 break;
 }


 packet.param1 =  ((uint8_t)0x02) ;
 packet.param2 = length;
 if ( length > 0 )
 memcpy(&packet. _data [0], message, length);

 if ( (status = atSHA( _gCommandObj, &packet )) != ATCA_SUCCESS )
 break;

 execution_time = atGetExecTime( _gCommandObj, CMD_SHA);

 if ( (status != atcab_wakeup()) != ATCA_SUCCESS ) break;


 if ( (status = atsend( _gIface, (uint8_t*)&packet, packet.txsize )) != ATCA_SUCCESS )
 break;


 atca_delay_ms( execution_time );


 if ( (status = atreceive( _gIface, packet. _data , &(packet.rxsize))) != ATCA_SUCCESS )
 break;


 if (packet.rxsize < 4) {
 if (packet.rxsize > 0)
 status = ATCA_RX_FAIL;
 else
 status = ATCA_RX_NO_RESPONSE;
 break;
 }


 if ( (status = isATCAError(packet. _data )) != ATCA_SUCCESS )
 break;

 memcpy( digest, &packet. _data [ (1) ],  (32)  );

 } while (0);

 _atcab_exit();
 return status;
}
#line 2888 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_basic.c"
ATCA_STATUS atcab_sha(uint16_t length, uint8_t *message, uint8_t *digest)
{
 ATCA_STATUS status = ATCA_GEN_FAIL;
 int blocks = 0, remainder = 0, msgIndex = 0;

 if ( length == 0 || message ==  ((void *)0)  || digest ==  ((void *)0)  )
 return ATCA_BAD_PARAM;

 do {

 blocks = length /  (64) ;
 remainder = length %  (64) ;

 status = atcab_sha_start();
 if ( status != ATCA_SUCCESS )
 break;

 while ( blocks-- > 0 ) {
 status = atcab_sha_update( (64) , &message[msgIndex]);
 if ( status != ATCA_SUCCESS )
 break;
 msgIndex +=  (64) ;
 }

 status = atcab_sha_end(digest, remainder, &message[msgIndex]);

 if ( status != ATCA_SUCCESS )
 break;

 } while (0);

 return status;
}
