#line 1 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_helpers.c"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/basic/atca_helpers.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/cryptoauthlib.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stddef.h"



typedef long ptrdiff_t;


 typedef unsigned long size_t;

typedef unsigned long wchar_t;
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/string.h"





void * memchr(void *p, char n, unsigned int v);
int memcmp(void *s1, void *s2, int n);
void * memcpy(void * d1, void * s1, int n);
void * memmove(void * to, void * from, int n);
void * memset(void * p1, char character, int n);
char * strcat(char * to, char * from);
char * strchr(char * ptr, char chr);
int strcmp(char * s1, char * s2);
char * strcpy(char * to, char * from);
int strlen(char * s);
char * strncat(char * to, char * from, int size);
char * strncpy(char * to, char * from, int size);
int strspn(char * str1, char * str2);
char strcspn(char * s1, char * s2);
int strncmp(char * s1, char * s2, char len);
char * strpbrk(char * s1, char * s2);
char * strrchr(char *ptr, char chr);
char * strstr(char * s1, char * s2);
char * strtok(char * s1, char * s2);
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/hal/atca_hal.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_status.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdbool.h"



 typedef char _Bool;
#line 55 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_status.h"
typedef enum
{
 ATCA_SUCCESS = 0x00,
 ATCA_CONFIG_ZONE_LOCKED = 0x01,
 ATCA_DATA_ZONE_LOCKED = 0x02,
 ATCA_WAKE_FAILED = 0xD0,
 ATCA_CHECKMAC_VERIFY_FAILED = 0xD1,
 ATCA_PARSE_ERROR = 0xD2,
 ATCA_STATUS_CRC = 0xD4,
 ATCA_STATUS_UNKNOWN = 0xD5,
 ATCA_STATUS_ECC = 0xD6,
 ATCA_STATUS_SELFTEST_ERROR = 0xD7,
 ATCA_FUNC_FAIL = 0xE0,
 ATCA_GEN_FAIL = 0xE1,
 ATCA_BAD_PARAM = 0xE2,
 ATCA_INVALID_ID = 0xE3,
 ATCA_INVALID_SIZE = 0xE4,
 ATCA_RX_CRC_ERROR = 0xE5,
 ATCA_RX_FAIL = 0xE6,
 ATCA_RX_NO_RESPONSE = 0xE7,
 ATCA_RESYNC_WITH_WAKEUP = 0xE8,
 ATCA_PARITY_ERROR = 0xE9,
 ATCA_TX_TIMEOUT = 0xEA,
 ATCA_RX_TIMEOUT = 0xEB,
 ATCA_TOO_MANY_COMM_RETRIES = 0xEC,
 ATCA_SMALL_BUFFER = 0xED,
 ATCA_COMM_FAIL = 0xF0,
 ATCA_TIMEOUT = 0xF1,
 ATCA_BAD_OPCODE = 0xF2,
 ATCA_WAKE_SUCCESS = 0xF3,
 ATCA_EXECUTION_ERROR = 0xF4,
 ATCA_UNIMPLEMENTED = 0xF5,
 ATCA_ASSERT_FAILURE = 0xF6,
 ATCA_TX_FAIL = 0xF7,
 ATCA_NOT_LOCKED = 0xF8,
 ATCA_NO_DEVICES = 0xF9,
 ATCA_HEALTH_TEST_ERROR = 0xFA,
 ATCA_ALLOC_FAILURE = 0xFB,
} ATCA_STATUS;
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_iface.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_compiler.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_status.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_devtypes.h"
#line 53 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_devtypes.h"
typedef enum {
 ATSHA204A,
 ATECC108A,
 ATECC508A,
 ATECC608A,
 ATCA_DEV_UNKNOWN = 0x20
} ATCADeviceType;
#line 62 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
struct atca_command {
 ATCADeviceType dt;
 uint16_t *execution_times;
};


typedef struct atca_command * ATCACommand;
ATCACommand newATCACommand(ATCADeviceType device_type);
#pragma pack( push, ATCAPacket, 2 )
#line 97 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
typedef struct {


 uint8_t _reserved;


 uint8_t txsize;
 uint8_t opcode;
 uint8_t param1;
 uint16_t param2;
 uint8_t  _data [130];






 uint8_t execTime;
 uint16_t rxsize;




} ATCAPacket;
#pragma pack( pop, ATCAPacket)
#line 123 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
ATCA_STATUS atCheckMAC(ATCACommand cacmd, ATCAPacket *packet);
ATCA_STATUS atCounter(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atDeriveKey(ATCACommand cacmd, ATCAPacket *packet,  _Bool  hasMAC );
ATCA_STATUS atECDH(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atGenDig(ATCACommand cacmd, ATCAPacket *packet,  _Bool  hasMACKey );
ATCA_STATUS atGenKey(ATCACommand cacmd, ATCAPacket *packet,  _Bool  isPubKey );
ATCA_STATUS atHMAC(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atInfo(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atLock(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atMAC(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atNonce(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atPause(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atPrivWrite(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atRandom(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atRead(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atSHA(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atSign(ATCACommand cacmd, ATCAPacket *packet);
ATCA_STATUS atUpdateExtra(ATCACommand cacmd, ATCAPacket *packet);
ATCA_STATUS atVerify(ATCACommand cacmd, ATCAPacket *packet);
ATCA_STATUS atWrite(ATCACommand cacmd, ATCAPacket *packet);
ATCA_STATUS atWriteEnc(ATCACommand cacmd, ATCAPacket *packet);

 _Bool  atIsSHAFamily( ATCADeviceType deviceType );
 _Bool  atIsECCFamily( ATCADeviceType deviceType );
ATCA_STATUS isATCAError( uint8_t * _data  );


typedef enum {
 WAKE_TWHI,
 CMD_CHECKMAC,
 CMD_COUNTER,
 CMD_DERIVEKEY,
 CMD_ECDH,
 CMD_GENDIG,
 CMD_GENKEY,
 CMD_HMAC,
 CMD_INFO,
 CMD_LOCK,
 CMD_MAC,
 CMD_NONCE,
 CMD_PAUSE,
 CMD_PRIVWRITE,
 CMD_RANDOM,
 CMD_READMEM,
 CMD_SHA,
 CMD_SIGN,
 CMD_UPDATEEXTRA,
 CMD_VERIFY,
 CMD_WRITEMEM,
 CMD_LASTCOMMAND
} ATCA_CmdMap;

ATCA_STATUS atInitExecTimes(ATCACommand cacmd, ATCADeviceType device_type);
uint16_t atGetExecTime( ATCACommand cacmd, ATCA_CmdMap cmd );

void deleteATCACommand( ATCACommand * );



void atCRC( uint8_t length, uint8_t * _data , uint8_t *crc);
void atCalcCrc( ATCAPacket *pkt);
uint8_t atCheckCrc(uint8_t *response);
#line 316 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
typedef enum {
 COUNTER_MODE_READ = 0,
 COUNTER_MODE_INCREASE = 1
} enum_counter_mode;
#line 330 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
typedef enum {
 SHA_MODE_SHA256_START = ((uint8_t) 0x00),
 SHA_MODE_SHA256_UPDATE = ((uint8_t) 0x01),
 SHA_MODE_SHA256_END = ((uint8_t) 0x02),
 SHA_MODE_SHA256_PUBLIC = ((uint8_t) 0x03),
 SHA_MODE_HMAC_START = ((uint8_t) 0x04),
 SHA_MODE_HMAC_UPDATE = ((uint8_t) 0x05),
 SHA_MODE_HMAC_END = ((uint8_t) 0x04)
} enum_sha_mode;
#line 407 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
typedef enum {
 GENKEY_MODE_PRIVATE_KEY_GENERATE = ((uint8_t) 0x04),
 GENKEY_MODE_PUBLIC_KEY_DIGEST = ((uint8_t) 0x08),
 GENKEY_MODE_DIGEST_IN_TEMPKEY = ((uint8_t) 0x10)
} enum_genkey_mode;
#line 58 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_iface.h"
typedef enum {
 ATCA_I2C_IFACE,
 ATCA_SWI_IFACE,
 ATCA_UART_IFACE,
 ATCA_SPI_IFACE,
 ATCA_HID_IFACE

} ATCAIfaceType;
#line 74 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_iface.h"
typedef struct {

 ATCAIfaceType iface_type;
 ATCADeviceType devtype;

 union {
 struct ATCAI2C {
 uint8_t slave_address;
 uint8_t bus;
 uint32_t baud;
 } atcai2c;

 struct ATCASWI {
 uint8_t bus;
 } atcaswi;

 struct ATCAUART {
 int port;
 uint32_t baud;
 uint8_t wordsize;
 uint8_t parity;
 uint8_t stopbits;
 } atcauart;

 struct ATCAHID {
 int idx;
 uint32_t vid;
 uint32_t pid;
 uint32_t packetsize;
 uint8_t guid[16];
 } atcahid;

 };

 uint16_t wake_delay;
 int rx_retries;
 void *cfg_data;
} ATCAIfaceCfg;
#line 117 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_iface.h"
typedef struct atca_iface
{
 ATCAIfaceType mType;
 ATCAIfaceCfg *mIfaceCFG;

 ATCA_STATUS (*atinit)(void *hal, ATCAIfaceCfg *cfg);
 ATCA_STATUS (*atpostinit)(struct atca_iface *hal);
 ATCA_STATUS (*atsend)(struct atca_iface *hal, uint8_t *txdata, int txlength);
 ATCA_STATUS (*atreceive)(struct atca_iface *hal, uint8_t *rxdata, uint16_t *rxlength);
 ATCA_STATUS (*atwake)(struct atca_iface *hal);
 ATCA_STATUS (*atidle)(struct atca_iface *hal);
 ATCA_STATUS (*atsleep)(struct atca_iface *hal);


 void *hal_data;

}T_atca_iface;

typedef T_atca_iface* ATCAIface;

ATCAIface newATCAIface(ATCAIfaceCfg *cfg);


ATCA_STATUS atinit(ATCAIface caiface);
ATCA_STATUS atpostinit(ATCAIface caiface);
ATCA_STATUS atsend(ATCAIface caiface, uint8_t *txdata, int txlength);
ATCA_STATUS atreceive(ATCAIface caiface, uint8_t *rxdata, uint16_t *rxlength);
ATCA_STATUS atwake(ATCAIface caiface);
ATCA_STATUS atidle(ATCAIface caiface);
ATCA_STATUS atsleep(ATCAIface caiface);


ATCAIfaceCfg * atgetifacecfg(ATCAIface caiface);
void* atgetifacehaldat(ATCAIface caiface);

void deleteATCAIface( ATCAIface *dev );
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/hal/atca_start_config.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/hal/atca_start_iface.h"
#line 63 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/hal/atca_hal.h"
typedef struct
{



 ATCA_STATUS (*halinit)(void *hal, ATCAIfaceCfg *cfg);
 ATCA_STATUS (*halpostinit)(ATCAIface iface);
 ATCA_STATUS (*halsend)(ATCAIface iface, uint8_t *txdata, int txlength);
 ATCA_STATUS (*halreceive)(ATCAIface iface, uint8_t* rxdata, uint16_t* rxlength);
 ATCA_STATUS (*halwake)(ATCAIface iface);
 ATCA_STATUS (*halidle)(ATCAIface iface);
 ATCA_STATUS (*halsleep)(ATCAIface iface);
 ATCA_STATUS (*halrelease)(void* hal_data);

 void *hal_data;
} ATCAHAL_t;
#line 84 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/hal/atca_hal.h"
extern ATCA_STATUS hal_iface_init(ATCAIfaceCfg *, ATCAHAL_t* hal);
extern ATCA_STATUS hal_iface_release(ATCAIfaceType, void* hal_data);
#line 116 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/hal/atca_hal.h"
ATCA_STATUS hal_swi_init(void *hal, ATCAIfaceCfg *cfg);
ATCA_STATUS hal_swi_post_init(ATCAIface iface);
ATCA_STATUS hal_swi_send(ATCAIface iface, uint8_t *txdata, int txlength);
ATCA_STATUS hal_swi_receive( ATCAIface iface, uint8_t *rxdata, uint16_t *rxlength);
ATCA_STATUS hal_swi_wake(ATCAIface iface);
ATCA_STATUS hal_swi_idle(ATCAIface iface);
ATCA_STATUS hal_swi_sleep(ATCAIface iface);
ATCA_STATUS hal_swi_release(void *hal_data );
ATCA_STATUS hal_swi_discover_buses(int swi_buses[], int max_buses);
ATCA_STATUS hal_swi_discover_devices(int busNum, ATCAIfaceCfg *cfg, int *found);
#line 168 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/hal/atca_hal.h"
void atca_delay_us(uint32_t delay);
void atca_delay_10us(uint32_t delay);
void atca_delay_ms(uint32_t delay);
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_status.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_device.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_iface.h"
#line 59 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_device.h"
struct atca_device {
 ATCACommand mCommands;
 ATCAIface mIface;
};

typedef struct atca_device* ATCADevice;
ATCADevice newATCADevice(ATCAIfaceCfg *cfg );


ATCACommand atGetCommands( ATCADevice dev );
ATCAIface atGetIFace( ATCADevice dev );

void deleteATCADevice( ATCADevice *dev );
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_cfgs.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_iface.h"
#line 53 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_cfgs.h"
extern ATCAIfaceCfg SECURE7_ATCA_CFG;
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/basic/atca_basic.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/cryptoauthlib.h"
#line 63 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/basic/atca_basic.h"
ATCA_STATUS atcab_version( char *verstr );
ATCA_STATUS atcab_init(ATCAIfaceCfg *cfg);
ATCA_STATUS atcab_init_device(ATCADevice cadevice);
ATCA_STATUS atcab_release(void);
ATCADevice atcab_getDevice(void);

ATCA_STATUS atcab_wakeup(void);
ATCA_STATUS atcab_idle(void);
ATCA_STATUS atcab_sleep(void);


ATCA_STATUS atcab_cfg_discover( ATCAIfaceCfg cfgArray[], int max);


ATCA_STATUS atcab_info(uint8_t *revision);
ATCA_STATUS atcab_challenge( uint8_t *challenge);
ATCA_STATUS atcab_challenge_seed_update( uint8_t *seed, uint8_t* rand_out);
ATCA_STATUS atcab_nonce( uint8_t *tempkey);
ATCA_STATUS atcab_nonce_rand( uint8_t *seed, uint8_t* rand_out);
ATCA_STATUS atcab_random(uint8_t *rand_out);

ATCA_STATUS atcab_is_locked(uint8_t zone,  _Bool  *lock_state);
ATCA_STATUS atcab_is_slot_locked(uint8_t slot,  _Bool  *lock_state);

ATCA_STATUS atcab_get_addr(uint8_t zone, uint8_t slot, uint8_t block, uint8_t offset, uint16_t* addr);
ATCA_STATUS atcab_read_zone(uint8_t zone, uint8_t slot, uint8_t block, uint8_t offset, uint8_t *_data, uint8_t len);
ATCA_STATUS atcab_write_zone(uint8_t zone, uint8_t slot, uint8_t block, uint8_t offset, uint8_t * _data , uint8_t len);
ATCA_STATUS atcab_write_bytes_slot(uint8_t slot, uint16_t offset, uint8_t * _data , uint8_t len);
ATCA_STATUS atcab_write_bytes_zone(ATCADeviceType dev_type, uint8_t zone, uint16_t address, uint8_t * _data , uint8_t len);
ATCA_STATUS atcab_read_bytes_zone(ATCADeviceType dev_type, uint8_t zone, uint16_t address, uint8_t len, uint8_t * _data );

ATCA_STATUS atcab_read_serial_number(uint8_t* serial_number);
ATCA_STATUS atcab_read_pubkey(uint8_t slot8toF, uint8_t *pubkey);
ATCA_STATUS atcab_write_pubkey(uint8_t slot8toF, uint8_t *pubkey);
ATCA_STATUS atcab_read_sig(uint8_t slot8toF, uint8_t *sig);
ATCA_STATUS atcab_read_ecc_config_zone(uint8_t* config_data);
ATCA_STATUS atcab_write_ecc_config_zone( uint8_t* config_data);
ATCA_STATUS atcab_read_sha_config_zone( uint8_t* config_data);
ATCA_STATUS atcab_write_sha_config_zone( uint8_t* config_data);
ATCA_STATUS atcab_read_config_zone(ATCADeviceType dev_type, uint8_t* config_data);
ATCA_STATUS atcab_write_config_zone(ATCADeviceType dev_type, uint8_t* config_data);
ATCA_STATUS atcab_cmp_config_zone(uint8_t* config_data,  _Bool * same_config);

ATCA_STATUS atcab_read_enc(uint8_t slotid, uint8_t block, uint8_t * _data , uint8_t* enckey, uint16_t enckeyid);
ATCA_STATUS atcab_write_enc(uint8_t slotid, uint8_t block, uint8_t * _data , uint8_t* enckey, uint16_t enckeyid);

ATCA_STATUS atcab_lock_config_zone(uint8_t* lock_response);
ATCA_STATUS atcab_lock_data_zone(uint8_t* lock_response);
ATCA_STATUS atcab_lock_data_slot(uint8_t slot, uint8_t* lock_response);

ATCA_STATUS atcab_priv_write(uint8_t slot, uint8_t priv_key[36], uint8_t write_key_slot, uint8_t write_key[32]);
ATCA_STATUS atcab_genkey( int slot, uint8_t *pubkey );
ATCA_STATUS atcab_get_pubkey(uint8_t privSlotId, uint8_t *pubkey);
ATCA_STATUS atcab_calc_pubkey(uint8_t privSlotId, uint8_t *pubkey);
ATCA_STATUS atcab_sign(uint16_t slot, uint8_t *msg, uint8_t *signature);
ATCA_STATUS atcab_verify_extern( uint8_t *message, uint8_t *signature, uint8_t *pubkey,  _Bool  *verified);
ATCA_STATUS atcab_ecdh(uint16_t key_id, uint8_t* pub_key, uint8_t* ret_ecdh);
ATCA_STATUS atcab_ecdh_enc(uint16_t slotid, uint8_t* pubkey, uint8_t* ret_ecdh, uint8_t* enckey, uint8_t enckeyid);
ATCA_STATUS atcab_gendig(uint8_t zone, uint16_t key_id);
ATCA_STATUS atcab_gendig_host(uint8_t zone, uint16_t key_id, uint8_t *other_data, uint8_t len);
ATCA_STATUS atcab_mac( uint8_t mode, uint16_t key_id, uint8_t* challenge, uint8_t* digest );
ATCA_STATUS atcab_checkmac( uint8_t mode, uint16_t key_id, uint8_t *challenge, uint8_t *response, uint8_t *other_data);

ATCA_STATUS atcab_sha_start(void);
ATCA_STATUS atcab_sha_update(uint16_t length, uint8_t *message);
ATCA_STATUS atcab_sha_end(uint8_t *digest, uint16_t length, uint8_t *message);
ATCA_STATUS atcab_sha(uint16_t length, uint8_t *message, uint8_t *digest);
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/basic/atca_helpers.h"
#line 68 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/basic/atca_helpers.h"
ATCA_STATUS packHex( char* asciiHex, int asciiHexLen, char* packedHex, int* packedLen);
 _Bool  isDigit(char c);
 _Bool  isWhiteSpace(char c);
 _Bool  isHexAlpha(char c);
 _Bool  isHex(char c);
 _Bool  isHexDigit(char c);
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdlib.h"







 typedef struct divstruct {
 int quot;
 int rem;
 } div_t;

 typedef struct ldivstruct {
 long quot;
 long rem;
 } ldiv_t;

 typedef struct uldivstruct {
 unsigned long quot;
 unsigned long rem;
 } uldiv_t;

int abs(int a);
float atof(char * s);
int atoi(char * s);
long atol(char * s);
div_t div(int number, int denom);
ldiv_t ldiv(long number, long denom);
uldiv_t uldiv(unsigned long number, unsigned long denom);
long labs(long x);
long int max(long int a, long int b);
long int min(long int a, long int b);
void srand(unsigned x);
int rand();
int xtoi(char * s);
#line 154 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_helpers.c"
 _Bool  isDigit(char c)
{
 return (c >= '0') && (c <= '9');
}
#line 164 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_helpers.c"
 _Bool  isWhiteSpace(char c)
{
 return (c == '\n') || (c == '\r') || (c == '\t') || (c == ' ');
}
#line 174 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_helpers.c"
 _Bool  isHexAlpha(char c)
{
 return ((c >= 'A') && (c <= 'F')) || ((c >= 'a') && (c <= 'f'));
}
#line 185 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_helpers.c"
 _Bool  isHex(char c)
{
 return isDigit(c) || isWhiteSpace(c) || isHexAlpha(c);
}
#line 195 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/basic/atca_helpers.c"
 _Bool  isHexDigit(char c)
{
 return isDigit(c) || isHexAlpha(c);
}

ATCA_STATUS packHex( char* asciiHex, int asciiHexLen, char* packedHex, int* packedLen)
{
 int i = 0;
 int j = 0;


 if ((asciiHex ==  ((void *)0) ) || (packedHex ==  ((void *)0) ) || (packedLen ==  ((void *)0) ))
 return ATCA_BAD_PARAM;


 for (i = 0; i < asciiHexLen; i++) {
 if (isHexDigit(asciiHex[i])) {
 if (j > *packedLen) break;
 packedHex[j++] = asciiHex[i];
 }
 }


 return ATCA_SUCCESS;
}
