_CL_hashInit:
;sha1_routines.c,45 :: 		void CL_hashInit(CL_HashContext *ctx)
; ctx start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
MOV	R6, R0
; ctx end address is: 0 (R0)
; ctx start address is: 24 (R6)
;sha1_routines.c,56 :: 		memset(ctx, 0, sizeof(*ctx));
MOVS	R2, #92
SXTH	R2, R2
MOVS	R1, #0
MOV	R0, R6
BL	_memset+0
;sha1_routines.c,57 :: 		memcpy_P(ctx->h, hashContext_h_init, sizeof(ctx->h));
MOVS	R2, #20
SXTH	R2, R2
MOVW	R1, #lo_addr(CL_hashInit_hashContext_h_init_L0+0)
MOVT	R1, #hi_addr(CL_hashInit_hashContext_h_init_L0+0)
MOV	R0, R6
; ctx end address is: 24 (R6)
BL	_memmove+0
;sha1_routines.c,58 :: 		}
L_end_CL_hashInit:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _CL_hashInit
_CL_hashUpdate:
;sha1_routines.c,60 :: 		void CL_hashUpdate(CL_HashContext *ctx, U8 *src, int nbytes)
; ctx start address is: 0 (R0)
SUB	SP, SP, #16
STR	LR, [SP, #0]
STR	R1, [SP, #8]
STRH	R2, [SP, #12]
; ctx end address is: 0 (R0)
; ctx start address is: 0 (R0)
;sha1_routines.c,82 :: 		freeBytes = (U8)(ctx->byteCount);
ADDW	R3, R0, #84
LDR	R3, [R3, #0]
;sha1_routines.c,83 :: 		freeBytes &= 63;
UXTB	R3, R3
AND	R3, R3, #63
UXTB	R3, R3
;sha1_routines.c,84 :: 		freeBytes = (U8)(64 - freeBytes);
RSB	R3, R3, #64
; freeBytes start address is: 28 (R7)
UXTB	R7, R3
; ctx end address is: 0 (R0)
; freeBytes end address is: 28 (R7)
MOV	R8, R0
;sha1_routines.c,86 :: 		while (nbytes > 0) {
L_CL_hashUpdate0:
; freeBytes start address is: 28 (R7)
; ctx start address is: 32 (R8)
LDRSH	R3, [SP, #12]
CMP	R3, #0
IT	LE
BLE	L_CL_hashUpdate1
;sha1_routines.c,89 :: 		i = freeBytes;
; i start address is: 44 (R11)
UXTB	R11, R7
;sha1_routines.c,90 :: 		if (nbytes < i) i = (U8)nbytes;
LDRSH	R3, [SP, #12]
CMP	R3, R7
IT	GE
BGE	L__CL_hashUpdate33
LDRB	R11, [SP, #12]
; i end address is: 44 (R11)
UXTB	R9, R11
IT	AL
BAL	L_CL_hashUpdate2
L__CL_hashUpdate33:
UXTB	R9, R11
L_CL_hashUpdate2:
;sha1_routines.c,93 :: 		if (i == 64)
; i start address is: 36 (R9)
CMP	R9, #64
IT	NE
BNE	L_CL_hashUpdate3
;sha1_routines.c,95 :: 		*(Buf64*)(ctx->buf) = *(Buf64*)src;
ADD	R3, R8, #20
MOV	R6, #64
MOV	R5, R3
LDR	R4, [SP, #8]
; ctx end address is: 32 (R8)
; i end address is: 36 (R9)
; freeBytes end address is: 28 (R7)
UXTB	R0, R7
MOV	R1, R8
UXTB	R2, R9
IT	AL
BAL	L_CL_hashUpdate4
L__CL_hashUpdate34:
L_CL_hashUpdate4:
; freeBytes start address is: 0 (R0)
; ctx start address is: 4 (R1)
; i start address is: 8 (R2)
; i start address is: 8 (R2)
; i end address is: 8 (R2)
; ctx start address is: 4 (R1)
; ctx end address is: 4 (R1)
; freeBytes start address is: 0 (R0)
; freeBytes end address is: 0 (R0)
LDRB	R3, [R4, #0]
STRB	R3, [R5, #0]
SUBS	R6, R6, #1
ADDS	R4, R4, #1
ADDS	R5, R5, #1
CMP	R6, #0
IT	NE
BNE	L__CL_hashUpdate34
; i end address is: 8 (R2)
; ctx end address is: 4 (R1)
; freeBytes end address is: 0 (R0)
; freeBytes start address is: 0 (R0)
; ctx start address is: 4 (R1)
; i start address is: 8 (R2)
; i end address is: 8 (R2)
; ctx end address is: 4 (R1)
; freeBytes end address is: 0 (R0)
MOV	R10, R1
UXTB	R12, R2
IT	AL
BAL	L_CL_hashUpdate5
L_CL_hashUpdate3:
;sha1_routines.c,98 :: 		memcpy(((U8*)ctx->buf) + 64 - freeBytes, src, i);
; freeBytes start address is: 28 (R7)
; i start address is: 36 (R9)
; ctx start address is: 32 (R8)
ADD	R3, R8, #20
ADDS	R3, #64
SUB	R3, R3, R7
UXTB	R2, R9
LDR	R1, [SP, #8]
MOV	R0, R3
BL	_memcpy+0
; ctx end address is: 32 (R8)
; i end address is: 36 (R9)
; freeBytes end address is: 28 (R7)
UXTB	R0, R7
MOV	R10, R8
UXTB	R12, R9
L_CL_hashUpdate5:
;sha1_routines.c,101 :: 		src += i;
; i start address is: 48 (R12)
; ctx start address is: 40 (R10)
; freeBytes start address is: 0 (R0)
LDR	R3, [SP, #8]
ADD	R3, R3, R12, LSL #0
STR	R3, [SP, #8]
;sha1_routines.c,102 :: 		nbytes -= i;
LDRSH	R3, [SP, #12]
SUB	R3, R3, R12, LSL #0
STRH	R3, [SP, #12]
;sha1_routines.c,103 :: 		freeBytes -= i;
SUB	R3, R0, R12, LSL #0
; freeBytes end address is: 0 (R0)
;sha1_routines.c,106 :: 		if (freeBytes == 0)
UXTB	R3, R3
CMP	R3, #0
IT	NE
BNE	L_CL_hashUpdate6
;sha1_routines.c,107 :: 		shaEngine(ctx->buf, ctx->h);
ADD	R3, R10, #20
STR	R10, [SP, #4]
MOV	R1, R10
MOV	R0, R3
BL	_shaEngine+0
LDR	R10, [SP, #4]
L_CL_hashUpdate6:
;sha1_routines.c,110 :: 		temp32 = (ctx->byteCount += i);
ADD	R4, R10, #84
LDR	R3, [R4, #0]
ADD	R3, R3, R12, LSL #0
; i end address is: 48 (R12)
STR	R3, [R4, #0]
LDR	R3, [R4, #0]
;sha1_routines.c,111 :: 		if (temp32 == 0) ++ctx->byteCountHi;
CMP	R3, #0
IT	NE
BNE	L_CL_hashUpdate7
ADD	R4, R10, #88
LDR	R3, [R4, #0]
ADDS	R3, R3, #1
STR	R3, [R4, #0]
L_CL_hashUpdate7:
;sha1_routines.c,114 :: 		freeBytes = 64;
; freeBytes start address is: 28 (R7)
MOVS	R7, #64
;sha1_routines.c,115 :: 		}
MOV	R8, R10
; ctx end address is: 40 (R10)
; freeBytes end address is: 28 (R7)
IT	AL
BAL	L_CL_hashUpdate0
L_CL_hashUpdate1:
;sha1_routines.c,116 :: 		}
L_end_CL_hashUpdate:
LDR	LR, [SP, #0]
ADD	SP, SP, #16
BX	LR
; end of _CL_hashUpdate
_CL_hashFinal:
;sha1_routines.c,118 :: 		void CL_hashFinal(CL_HashContext *ctx, U8 *dest)
; dest start address is: 4 (R1)
; ctx start address is: 0 (R0)
SUB	SP, SP, #8
STR	LR, [SP, #0]
STR	R1, [SP, #4]
MOV	R1, R0
LDR	R0, [SP, #4]
; dest end address is: 4 (R1)
; ctx end address is: 0 (R0)
; ctx start address is: 4 (R1)
; dest start address is: 0 (R0)
;sha1_routines.c,131 :: 		nbytes = (U8)(ctx->byteCount) & 63;
ADDW	R2, R1, #84
LDR	R2, [R2, #0]
UXTB	R2, R2
AND	R3, R2, #63
UXTB	R3, R3
; nbytes start address is: 20 (R5)
UXTB	R5, R3
;sha1_routines.c,132 :: 		((U8*)ctx->buf)[nbytes] = 0x80;
ADDW	R2, R1, #20
ADDS	R3, R2, R3
MOVS	R2, #128
STRB	R2, [R3, #0]
;sha1_routines.c,133 :: 		for (i = (nbytes + 1); i < 64; i++) ((U8*)ctx->buf)[i] = 0;
ADDS	R2, R5, #1
; i start address is: 16 (R4)
UXTB	R4, R2
; ctx end address is: 4 (R1)
; nbytes end address is: 20 (R5)
; dest end address is: 0 (R0)
; i end address is: 16 (R4)
MOV	R12, R1
L_CL_hashFinal8:
; i start address is: 16 (R4)
; nbytes start address is: 20 (R5)
; dest start address is: 0 (R0)
; ctx start address is: 48 (R12)
CMP	R4, #64
IT	CS
BCS	L_CL_hashFinal9
ADD	R2, R12, #20
ADDS	R3, R2, R4
MOVS	R2, #0
STRB	R2, [R3, #0]
ADDS	R4, R4, #1
UXTB	R4, R4
; i end address is: 16 (R4)
IT	AL
BAL	L_CL_hashFinal8
L_CL_hashFinal9:
;sha1_routines.c,139 :: 		if (nbytes > (64 - 9)) {
CMP	R5, #55
IT	LE
BLE	L_CL_hashFinal11
; nbytes end address is: 20 (R5)
;sha1_routines.c,140 :: 		shaEngine(ctx->buf, ctx->h);
ADD	R2, R12, #20
STR	R0, [SP, #4]
MOV	R1, R12
MOV	R0, R2
BL	_shaEngine+0
;sha1_routines.c,141 :: 		memset(ctx->buf, 0, 64);
ADD	R2, R12, #20
MOVS	R1, #0
MOV	R0, R2
MOVS	R2, #64
SXTH	R2, R2
BL	_memset+0
LDR	R0, [SP, #4]
;sha1_routines.c,142 :: 		}
L_CL_hashFinal11:
;sha1_routines.c,149 :: 		temp = ctx->byteCount << 3; // low 4 bytes of bit count
ADD	R2, R12, #84
LDR	R2, [R2, #0]
LSLS	R4, R2, #3
; temp start address is: 16 (R4)
;sha1_routines.c,150 :: 		ptr = &((U8*)ctx->buf)[63]; // point to low byte of bit count
ADD	R1, R12, #20
ADDS	R1, #63
; ptr start address is: 4 (R1)
;sha1_routines.c,151 :: 		for (i = 0; i < 4; i++) {
; i start address is: 12 (R3)
MOVS	R3, #0
; dest end address is: 0 (R0)
; ctx end address is: 48 (R12)
; ptr end address is: 4 (R1)
; temp end address is: 16 (R4)
; i end address is: 12 (R3)
STR	R12, [SP, #4]
MOV	R12, R0
LDR	R0, [SP, #4]
L_CL_hashFinal12:
; i start address is: 12 (R3)
; ptr start address is: 4 (R1)
; temp start address is: 16 (R4)
; ctx start address is: 0 (R0)
; dest start address is: 48 (R12)
CMP	R3, #4
IT	CS
BCS	L_CL_hashFinal13
;sha1_routines.c,152 :: 		*ptr-- = (U8)temp;
UXTB	R2, R4
STRB	R2, [R1, #0]
SUBS	R1, R1, #1
;sha1_routines.c,153 :: 		temp >>= 8;
LSRS	R4, R4, #8
;sha1_routines.c,151 :: 		for (i = 0; i < 4; i++) {
ADDS	R3, R3, #1
UXTB	R3, R3
;sha1_routines.c,154 :: 		}
; temp end address is: 16 (R4)
; i end address is: 12 (R3)
IT	AL
BAL	L_CL_hashFinal12
L_CL_hashFinal13:
;sha1_routines.c,156 :: 		temp = ctx->byteCountHi << 3;
ADDW	R2, R0, #88
LDR	R2, [R2, #0]
LSLS	R3, R2, #3
;sha1_routines.c,157 :: 		temp |= ctx->byteCount >> (32 - 3); // high 4 bytes of bit count
ADDW	R2, R0, #84
LDR	R2, [R2, #0]
LSRS	R2, R2, #29
ORRS	R3, R2
; temp start address is: 12 (R3)
;sha1_routines.c,158 :: 		for (i = 0; i < 4; i++) {
; i start address is: 8 (R2)
MOVS	R2, #0
; ptr end address is: 4 (R1)
; i end address is: 8 (R2)
; dest end address is: 48 (R12)
; temp end address is: 12 (R3)
; ctx end address is: 0 (R0)
MOV	R4, R1
UXTB	R1, R2
L_CL_hashFinal15:
; i start address is: 4 (R1)
; temp start address is: 12 (R3)
; dest start address is: 48 (R12)
; ctx start address is: 0 (R0)
; ptr start address is: 16 (R4)
CMP	R1, #4
IT	CS
BCS	L_CL_hashFinal16
;sha1_routines.c,159 :: 		*ptr-- = (U8)temp;
UXTB	R2, R3
STRB	R2, [R4, #0]
SUBS	R4, R4, #1
;sha1_routines.c,160 :: 		temp >>= 8;
LSRS	R3, R3, #8
;sha1_routines.c,158 :: 		for (i = 0; i < 4; i++) {
ADDS	R1, R1, #1
UXTB	R1, R1
;sha1_routines.c,161 :: 		}
; ptr end address is: 16 (R4)
; temp end address is: 12 (R3)
; i end address is: 4 (R1)
IT	AL
BAL	L_CL_hashFinal15
L_CL_hashFinal16:
;sha1_routines.c,165 :: 		shaEngine(ctx->buf, ctx->h);
ADDW	R2, R0, #20
STR	R0, [SP, #4]
MOV	R1, R0
MOV	R0, R2
BL	_shaEngine+0
LDR	R0, [SP, #4]
;sha1_routines.c,168 :: 		memcpy(dest, ctx->h, 20);
STR	R0, [SP, #4]
MOVS	R2, #20
SXTH	R2, R2
MOV	R1, R0
MOV	R0, R12
BL	_memcpy+0
LDR	R0, [SP, #4]
;sha1_routines.c,169 :: 		for (i = 0; i < 5; i++) {
; i start address is: 4 (R1)
MOVS	R1, #0
; dest end address is: 48 (R12)
; i end address is: 4 (R1)
MOV	R5, R12
L_CL_hashFinal18:
; i start address is: 4 (R1)
; dest start address is: 20 (R5)
; ctx start address is: 0 (R0)
; ctx end address is: 0 (R0)
; dest start address is: 20 (R5)
; dest end address is: 20 (R5)
CMP	R1, #5
IT	CS
BCS	L_CL_hashFinal19
; ctx end address is: 0 (R0)
; dest end address is: 20 (R5)
;sha1_routines.c,170 :: 		dest[i * 4 + 0] = (ctx->h[i] >> 24) & 0xFF;
; dest start address is: 20 (R5)
; ctx start address is: 0 (R0)
LSLS	R2, R1, #2
SXTH	R2, R2
ADDS	R3, R5, R2
ADDS	R2, R0, R2
LDR	R2, [R2, #0]
LSRS	R2, R2, #24
AND	R2, R2, #255
STRB	R2, [R3, #0]
;sha1_routines.c,171 :: 		dest[i * 4 + 1] = (ctx->h[i] >> 16) & 0xFF;
LSLS	R4, R1, #2
SXTH	R4, R4
ADDS	R2, R4, #1
SXTH	R2, R2
ADDS	R3, R5, R2
SXTH	R2, R4
ADDS	R2, R0, R2
LDR	R2, [R2, #0]
LSRS	R2, R2, #16
AND	R2, R2, #255
STRB	R2, [R3, #0]
;sha1_routines.c,172 :: 		dest[i * 4 + 2] = (ctx->h[i] >>  8) & 0xFF;
LSLS	R4, R1, #2
SXTH	R4, R4
ADDS	R2, R4, #2
SXTH	R2, R2
ADDS	R3, R5, R2
SXTH	R2, R4
ADDS	R2, R0, R2
LDR	R2, [R2, #0]
LSRS	R2, R2, #8
AND	R2, R2, #255
STRB	R2, [R3, #0]
;sha1_routines.c,173 :: 		dest[i * 4 + 3] = (ctx->h[i] >>  0) & 0xFF;
LSLS	R4, R1, #2
SXTH	R4, R4
ADDS	R2, R4, #3
SXTH	R2, R2
ADDS	R3, R5, R2
SXTH	R2, R4
ADDS	R2, R0, R2
LDR	R2, [R2, #0]
AND	R2, R2, #255
STRB	R2, [R3, #0]
;sha1_routines.c,169 :: 		for (i = 0; i < 5; i++) {
ADDS	R1, R1, #1
UXTB	R1, R1
;sha1_routines.c,174 :: 		}
; ctx end address is: 0 (R0)
; dest end address is: 20 (R5)
; i end address is: 4 (R1)
IT	AL
BAL	L_CL_hashFinal18
L_CL_hashFinal19:
;sha1_routines.c,175 :: 		}
L_end_CL_hashFinal:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _CL_hashFinal
_CL_hash:
;sha1_routines.c,178 :: 		void CL_hash(U8 *msg, int msgBytes, U8 *dest)
; msgBytes start address is: 4 (R1)
; msg start address is: 0 (R0)
SUB	SP, SP, #100
STR	LR, [SP, #0]
MOV	R7, R0
SXTH	R8, R1
STR	R2, [SP, #96]
; msgBytes end address is: 4 (R1)
; msg end address is: 0 (R0)
; msg start address is: 28 (R7)
; msgBytes start address is: 32 (R8)
;sha1_routines.c,182 :: 		CL_hashInit(&ctx);
ADD	R3, SP, #4
MOV	R0, R3
BL	_CL_hashInit+0
;sha1_routines.c,183 :: 		CL_hashUpdate(&ctx, msg, msgBytes);
ADD	R3, SP, #4
SXTH	R2, R8
; msgBytes end address is: 32 (R8)
MOV	R1, R7
; msg end address is: 28 (R7)
MOV	R0, R3
BL	_CL_hashUpdate+0
;sha1_routines.c,184 :: 		CL_hashFinal(&ctx, dest);
ADD	R3, SP, #4
LDR	R1, [SP, #96]
MOV	R0, R3
BL	_CL_hashFinal+0
;sha1_routines.c,185 :: 		}
L_end_CL_hash:
LDR	LR, [SP, #0]
ADD	SP, SP, #100
BX	LR
; end of _CL_hash
_shaEngine:
;sha1_routines.c,187 :: 		void shaEngine(U32 *buf, U32 *h)
; h start address is: 4 (R1)
; buf start address is: 0 (R0)
SUB	SP, SP, #4
; h end address is: 4 (R1)
; buf end address is: 0 (R0)
; buf start address is: 0 (R0)
; h start address is: 4 (R1)
;sha1_routines.c,205 :: 		U32 temp = 0;
; temp start address is: 16 (R4)
MOV	R4, #0
;sha1_routines.c,207 :: 		U32 *w = (U32*)buf;
; w start address is: 20 (R5)
MOV	R5, R0
;sha1_routines.c,214 :: 		p = (U8*)w;
; p start address is: 24 (R6)
MOV	R6, R0
; buf end address is: 0 (R0)
;sha1_routines.c,215 :: 		for (t = 0; t < 16; t++) {
; t start address is: 0 (R0)
MOVS	R0, #0
; p end address is: 24 (R6)
; temp end address is: 16 (R4)
; h end address is: 4 (R1)
; w end address is: 20 (R5)
; t end address is: 0 (R0)
L_shaEngine21:
; t start address is: 0 (R0)
; p start address is: 24 (R6)
; w start address is: 20 (R5)
; temp start address is: 16 (R4)
; h start address is: 4 (R1)
CMP	R0, #16
IT	CS
BCS	L_shaEngine22
;sha1_routines.c,216 :: 		temp = (temp << 8) | *p++;
LSLS	R3, R4, #8
; temp end address is: 16 (R4)
LDRB	R2, [R6, #0]
ORR	R2, R3, R2, LSL #0
ADDS	R4, R6, #1
; p end address is: 24 (R6)
;sha1_routines.c,217 :: 		temp = (temp << 8) | *p++;
LSLS	R3, R2, #8
LDRB	R2, [R4, #0]
ORR	R2, R3, R2, LSL #0
ADDS	R4, R4, #1
;sha1_routines.c,218 :: 		temp = (temp << 8) | *p++;
LSLS	R3, R2, #8
LDRB	R2, [R4, #0]
ORR	R2, R3, R2, LSL #0
ADDS	R4, R4, #1
;sha1_routines.c,219 :: 		temp = (temp << 8) | *p++;
LSLS	R3, R2, #8
LDRB	R2, [R4, #0]
ORRS	R3, R2
; temp start address is: 24 (R6)
MOV	R6, R3
ADDS	R2, R4, #1
; p start address is: 16 (R4)
MOV	R4, R2
;sha1_routines.c,220 :: 		w[t] = temp;
LSLS	R2, R0, #2
ADDS	R2, R5, R2
STR	R3, [R2, #0]
;sha1_routines.c,215 :: 		for (t = 0; t < 16; t++) {
ADDS	R0, R0, #1
UXTB	R0, R0
;sha1_routines.c,221 :: 		}
STR	R4, [SP, #0]
; temp end address is: 24 (R6)
; p end address is: 16 (R4)
; t end address is: 0 (R0)
MOV	R4, R6
LDR	R6, [SP, #0]
IT	AL
BAL	L_shaEngine21
L_shaEngine22:
;sha1_routines.c,237 :: 		a = h[0];
LDR	R4, [R1, #0]
; a start address is: 16 (R4)
;sha1_routines.c,238 :: 		b = h[1];
ADDS	R2, R1, #4
LDR	R7, [R2, #0]
; b start address is: 28 (R7)
;sha1_routines.c,239 :: 		c = h[2];
ADDW	R2, R1, #8
LDR	R6, [R2, #0]
; c start address is: 24 (R6)
;sha1_routines.c,240 :: 		d = h[3];
ADDW	R2, R1, #12
LDR	R8, [R2, #0]
; d start address is: 32 (R8)
;sha1_routines.c,241 :: 		e = h[4];
ADDW	R2, R1, #16
LDR	R9, [R2, #0]
; e start address is: 36 (R9)
;sha1_routines.c,244 :: 		for (t = 0; t < 80; t++) {
; t start address is: 0 (R0)
MOVS	R0, #0
; a end address is: 16 (R4)
; h end address is: 4 (R1)
; e end address is: 36 (R9)
; d end address is: 32 (R8)
; c end address is: 24 (R6)
; b end address is: 28 (R7)
; t end address is: 0 (R0)
L_shaEngine24:
; t start address is: 0 (R0)
; e start address is: 36 (R9)
; d start address is: 32 (R8)
; c start address is: 24 (R6)
; b start address is: 28 (R7)
; a start address is: 16 (R4)
; h start address is: 4 (R1)
; w start address is: 20 (R5)
; w end address is: 20 (R5)
CMP	R0, #80
IT	CS
BCS	L_shaEngine25
; w end address is: 20 (R5)
;sha1_routines.c,247 :: 		leftRotate(temp, 5);
; w start address is: 20 (R5)
LSLS	R3, R4, #5
LSRS	R2, R4, #27
ORR	R2, R3, R2, LSL #0
;sha1_routines.c,248 :: 		temp += e;
ADD	R3, R2, R9, LSL #0
; e end address is: 36 (R9)
;sha1_routines.c,249 :: 		temp += w[t & 0xf];
AND	R2, R0, #15
UXTB	R2, R2
LSLS	R2, R2, #2
ADDS	R2, R5, R2
LDR	R2, [R2, #0]
ADDS	R2, R3, R2
; temp start address is: 36 (R9)
MOV	R9, R2
;sha1_routines.c,251 :: 		if (t < 20) {
CMP	R0, #20
IT	CS
BCS	L_shaEngine27
;sha1_routines.c,252 :: 		temp += (b & c) | (~b & d);
AND	R3, R7, R6, LSL #0
MVN	R2, R7
AND	R2, R2, R8, LSL #0
ORR	R2, R3, R2, LSL #0
ADD	R10, R9, R2, LSL #0
; temp end address is: 36 (R9)
;sha1_routines.c,253 :: 		temp += 0x5a827999L;
MOVW	R2, #31129
MOVT	R2, #23170
ADD	R10, R10, R2, LSL #0
; temp start address is: 40 (R10)
;sha1_routines.c,254 :: 		}else if (t < 40) {
; temp end address is: 40 (R10)
IT	AL
BAL	L_shaEngine28
L_shaEngine27:
; temp start address is: 36 (R9)
CMP	R0, #40
IT	CS
BCS	L_shaEngine29
;sha1_routines.c,255 :: 		temp += b ^ c ^ d;
EOR	R2, R7, R6, LSL #0
EOR	R2, R2, R8, LSL #0
ADD	R3, R9, R2, LSL #0
; temp end address is: 36 (R9)
;sha1_routines.c,256 :: 		temp += 0x6ed9eba1L;
MOVW	R2, #60321
MOVT	R2, #28377
ADDS	R2, R3, R2
; temp start address is: 8 (R2)
;sha1_routines.c,257 :: 		}else if (t < 60) {
MOV	R10, R2
; temp end address is: 8 (R2)
IT	AL
BAL	L_shaEngine30
L_shaEngine29:
; temp start address is: 36 (R9)
CMP	R0, #60
IT	CS
BCS	L_shaEngine31
;sha1_routines.c,258 :: 		temp += (b & c) | (b & d) | (c & d);
AND	R3, R7, R6, LSL #0
AND	R2, R7, R8, LSL #0
ORRS	R3, R2
AND	R2, R6, R8, LSL #0
ORR	R2, R3, R2, LSL #0
ADD	R3, R9, R2, LSL #0
; temp end address is: 36 (R9)
;sha1_routines.c,259 :: 		temp += 0x8f1bbcdcL;
MOVW	R2, #48348
MOVT	R2, #36635
ADDS	R2, R3, R2
; temp start address is: 8 (R2)
;sha1_routines.c,260 :: 		}else {
; temp end address is: 8 (R2)
IT	AL
BAL	L_shaEngine32
L_shaEngine31:
;sha1_routines.c,261 :: 		temp += b ^ c ^ d;
; temp start address is: 36 (R9)
EOR	R2, R7, R6, LSL #0
EOR	R2, R2, R8, LSL #0
ADD	R3, R9, R2, LSL #0
; temp end address is: 36 (R9)
;sha1_routines.c,262 :: 		temp += 0xca62c1d6L;
MOVW	R2, #49622
MOVT	R2, #51810
ADDS	R2, R3, R2
; temp start address is: 12 (R3)
MOV	R3, R2
; temp end address is: 12 (R3)
MOV	R2, R3
;sha1_routines.c,263 :: 		}
L_shaEngine32:
; temp start address is: 8 (R2)
MOV	R10, R2
; temp end address is: 8 (R2)
L_shaEngine30:
; temp start address is: 40 (R10)
; temp end address is: 40 (R10)
L_shaEngine28:
;sha1_routines.c,265 :: 		e = d;
; temp start address is: 40 (R10)
; e start address is: 36 (R9)
MOV	R9, R8
;sha1_routines.c,266 :: 		d = c;
MOV	R8, R6
; c end address is: 24 (R6)
;sha1_routines.c,267 :: 		c = b; leftRotate(c, 30);
LSLS	R3, R7, #30
LSRS	R2, R7, #2
; b end address is: 28 (R7)
ORR	R2, R3, R2, LSL #0
; c start address is: 24 (R6)
MOV	R6, R2
;sha1_routines.c,268 :: 		b = a;
; b start address is: 28 (R7)
MOV	R7, R4
; a end address is: 16 (R4)
;sha1_routines.c,269 :: 		a = temp;
; a start address is: 44 (R11)
MOV	R11, R10
; temp end address is: 40 (R10)
;sha1_routines.c,271 :: 		temp = w[t & 0xf] ^ w[(t - 3) & 0xf] ^ w[(t - 8) & 0xf] ^ w[(t - 14) & 0xf];
AND	R2, R0, #15
UXTB	R2, R2
LSLS	R2, R2, #2
ADDS	R4, R5, R2
LDR	R3, [R4, #0]
SUBS	R2, R0, #3
SXTH	R2, R2
AND	R2, R2, #15
SXTH	R2, R2
LSLS	R2, R2, #2
ADDS	R2, R5, R2
LDR	R2, [R2, #0]
EORS	R3, R2
SUBW	R2, R0, #8
SXTH	R2, R2
AND	R2, R2, #15
SXTH	R2, R2
LSLS	R2, R2, #2
ADDS	R2, R5, R2
LDR	R2, [R2, #0]
EORS	R3, R2
SUBW	R2, R0, #14
SXTH	R2, R2
AND	R2, R2, #15
SXTH	R2, R2
LSLS	R2, R2, #2
ADDS	R2, R5, R2
LDR	R2, [R2, #0]
EOR	R2, R3, R2, LSL #0
;sha1_routines.c,272 :: 		leftRotate(temp, 1);
LSLS	R3, R2, #1
LSRS	R2, R2, #31
ORR	R2, R3, R2, LSL #0
;sha1_routines.c,273 :: 		w[t & 0xf] = temp;
STR	R2, [R4, #0]
;sha1_routines.c,244 :: 		for (t = 0; t < 80; t++) {
ADDS	R0, R0, #1
UXTB	R0, R0
;sha1_routines.c,275 :: 		}
; w end address is: 20 (R5)
; a end address is: 44 (R11)
; t end address is: 0 (R0)
MOV	R4, R11
IT	AL
BAL	L_shaEngine24
L_shaEngine25:
;sha1_routines.c,278 :: 		h[0] += a;
; a start address is: 16 (R4)
LDR	R2, [R1, #0]
ADDS	R2, R2, R4
; a end address is: 16 (R4)
STR	R2, [R1, #0]
;sha1_routines.c,279 :: 		h[1] += b;
ADDS	R3, R1, #4
LDR	R2, [R3, #0]
ADDS	R2, R2, R7
; b end address is: 28 (R7)
STR	R2, [R3, #0]
;sha1_routines.c,280 :: 		h[2] += c;
ADDW	R3, R1, #8
LDR	R2, [R3, #0]
ADDS	R2, R2, R6
; c end address is: 24 (R6)
STR	R2, [R3, #0]
;sha1_routines.c,281 :: 		h[3] += d;
ADDW	R3, R1, #12
LDR	R2, [R3, #0]
ADD	R2, R2, R8, LSL #0
; d end address is: 32 (R8)
STR	R2, [R3, #0]
;sha1_routines.c,282 :: 		h[4] += e;
ADDW	R3, R1, #16
; h end address is: 4 (R1)
LDR	R2, [R3, #0]
ADD	R2, R2, R9, LSL #0
; e end address is: 36 (R9)
STR	R2, [R3, #0]
;sha1_routines.c,295 :: 		}
L_end_shaEngine:
ADD	SP, SP, #4
BX	LR
; end of _shaEngine
