#line 1 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/crypto/hashes/sha1_routines.c"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/crypto/hashes/sha1_routines.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdio.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdlib.h"







 typedef struct divstruct {
 int quot;
 int rem;
 } div_t;

 typedef struct ldivstruct {
 long quot;
 long rem;
 } ldiv_t;

 typedef struct uldivstruct {
 unsigned long quot;
 unsigned long rem;
 } uldiv_t;

int abs(int a);
float atof(char * s);
int atoi(char * s);
long atol(char * s);
div_t div(int number, int denom);
ldiv_t ldiv(long number, long denom);
uldiv_t uldiv(unsigned long number, unsigned long denom);
long labs(long x);
long int max(long int a, long int b);
long int min(long int a, long int b);
void srand(unsigned x);
int rand();
int xtoi(char * s);
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stddef.h"



typedef long ptrdiff_t;


 typedef unsigned long size_t;

typedef unsigned long wchar_t;
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 83 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/crypto/hashes/sha1_routines.h"
typedef struct {
  uint32_t  h[20 / 4];
  uint32_t  buf[64 / 4];
  uint32_t  byteCount;
  uint32_t  byteCountHi;
} CL_HashContext;



void shaEngine( uint32_t  *buf,  uint32_t  *h);
void CL_hashInit(CL_HashContext *ctx);
void CL_hashUpdate(CL_HashContext *ctx,  uint8_t  *src, int nbytes);
void CL_hashFinal(CL_HashContext *ctx,  uint8_t  *dest);
void CL_hash( uint8_t  *msg, int msgBytes,  uint8_t  *dest);
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/string.h"





void * memchr(void *p, char n, unsigned int v);
int memcmp(void *s1, void *s2, int n);
void * memcpy(void * d1, void * s1, int n);
void * memmove(void * to, void * from, int n);
void * memset(void * p1, char character, int n);
char * strcat(char * to, char * from);
char * strchr(char * ptr, char chr);
int strcmp(char * s1, char * s2);
char * strcpy(char * to, char * from);
int strlen(char * s);
char * strncat(char * to, char * from, int size);
char * strncpy(char * to, char * from, int size);
int strspn(char * str1, char * str2);
char strcspn(char * s1, char * s2);
int strncmp(char * s1, char * s2, char len);
char * strpbrk(char * s1, char * s2);
char * strrchr(char *ptr, char chr);
char * strstr(char * s1, char * s2);
char * strtok(char * s1, char * s2);
#line 45 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/crypto/hashes/sha1_routines.c"
void CL_hashInit(CL_HashContext *ctx)
{
 static  uint32_t  hashContext_h_init[] = {
 0x67452301,
 0xefcdab89,
 0x98badcfe,
 0x10325476,
 0xc3d2e1f0
 };


 memset(ctx, 0, sizeof(*ctx));
  memmove (ctx->h, hashContext_h_init, sizeof(ctx->h));
}

void CL_hashUpdate(CL_HashContext *ctx,  uint8_t  *src, int nbytes)
{
#line 67 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/crypto/hashes/sha1_routines.c"
  uint8_t  i, freeBytes;
  uint32_t  temp32;

 typedef struct {
  uint8_t  buf[64];
 } Buf64;









 freeBytes = ( uint8_t )(ctx->byteCount);
 freeBytes &= 63;
 freeBytes = ( uint8_t )(64 - freeBytes);

 while (nbytes > 0) {


 i = freeBytes;
 if (nbytes < i) i = ( uint8_t )nbytes;


 if (i == 64)

 *(Buf64*)(ctx->buf) = *(Buf64*)src;
 else

 memcpy((( uint8_t *)ctx->buf) + 64 - freeBytes, src, i);


 src += i;
 nbytes -= i;
 freeBytes -= i;


 if (freeBytes == 0)
 shaEngine(ctx->buf, ctx->h);


 temp32 = (ctx->byteCount += i);
 if (temp32 == 0) ++ctx->byteCountHi;


 freeBytes = 64;
 }
}

void CL_hashFinal(CL_HashContext *ctx,  uint8_t  *dest)
{
#line 125 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/crypto/hashes/sha1_routines.c"
  uint8_t  i;
  uint8_t  nbytes;
  uint32_t  temp;
  uint8_t  *ptr;


 nbytes = ( uint8_t )(ctx->byteCount) & 63;
 (( uint8_t *)ctx->buf)[nbytes] = 0x80;
 for (i = (nbytes + 1); i < 64; i++) (( uint8_t *)ctx->buf)[i] = 0;
#line 139 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/crypto/hashes/sha1_routines.c"
 if (nbytes > (64 - 9)) {
 shaEngine(ctx->buf, ctx->h);
 memset(ctx->buf, 0, 64);
 }
#line 149 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/crypto/hashes/sha1_routines.c"
 temp = ctx->byteCount << 3;
 ptr = &(( uint8_t *)ctx->buf)[63];
 for (i = 0; i < 4; i++) {
 *ptr-- = ( uint8_t )temp;
 temp >>= 8;
 }

 temp = ctx->byteCountHi << 3;
 temp |= ctx->byteCount >> (32 - 3);
 for (i = 0; i < 4; i++) {
 *ptr-- = ( uint8_t )temp;
 temp >>= 8;
 }



 shaEngine(ctx->buf, ctx->h);


 memcpy(dest, ctx->h, 20);
 for (i = 0; i < 5; i++) {
 dest[i * 4 + 0] = (ctx->h[i] >> 24) & 0xFF;
 dest[i * 4 + 1] = (ctx->h[i] >> 16) & 0xFF;
 dest[i * 4 + 2] = (ctx->h[i] >> 8) & 0xFF;
 dest[i * 4 + 3] = (ctx->h[i] >> 0) & 0xFF;
 }
}


void CL_hash( uint8_t  *msg, int msgBytes,  uint8_t  *dest)
{
 CL_HashContext ctx;

 CL_hashInit(&ctx);
 CL_hashUpdate(&ctx, msg, msgBytes);
 CL_hashFinal(&ctx, dest);
}

void shaEngine( uint32_t  *buf,  uint32_t  *h)
{
#line 203 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/crypto/hashes/sha1_routines.c"
  uint8_t  t;
  uint32_t  a, b, c, d, e;
  uint32_t  temp = 0;
  uint8_t  *p;
  uint32_t  *w = ( uint32_t *)buf;
#line 214 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/crypto/hashes/sha1_routines.c"
 p = ( uint8_t *)w;
 for (t = 0; t < 16; t++) {
 temp = (temp << 8) | *p++;
 temp = (temp << 8) | *p++;
 temp = (temp << 8) | *p++;
 temp = (temp << 8) | *p++;
 w[t] = temp;
 }
#line 237 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/crypto/hashes/sha1_routines.c"
 a = h[0];
 b = h[1];
 c = h[2];
 d = h[3];
 e = h[4];


 for (t = 0; t < 80; t++) {

 temp = a;
  (temp) = (((temp) << (5)) | ((temp) >> (32 - (5)))) ;
 temp += e;
 temp += w[t & 0xf];

 if (t < 20) {
 temp += (b & c) | (~b & d);
 temp += 0x5a827999L;
 }else if (t < 40) {
 temp += b ^ c ^ d;
 temp += 0x6ed9eba1L;
 }else if (t < 60) {
 temp += (b & c) | (b & d) | (c & d);
 temp += 0x8f1bbcdcL;
 }else {
 temp += b ^ c ^ d;
 temp += 0xca62c1d6L;
 }

 e = d;
 d = c;
 c = b;  (c) = (((c) << (30)) | ((c) >> (32 - (30)))) ;
 b = a;
 a = temp;

 temp = w[t & 0xf] ^ w[(t - 3) & 0xf] ^ w[(t - 8) & 0xf] ^ w[(t - 14) & 0xf];
  (temp) = (((temp) << (1)) | ((temp) >> (32 - (1)))) ;
 w[t & 0xf] = temp;

 }


 h[0] += a;
 h[1] += b;
 h[2] += c;
 h[3] += d;
 h[4] += e;
#line 295 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/crypto/hashes/sha1_routines.c"
}
