sha2_routines_sw_sha256_process:
;sha2_routines.c,54 :: 		static void sw_sha256_process(sw_sha256_ctx* ctx,  uint8_t* blocks, uint32_t block_count)
; block_count start address is: 8 (R2)
; blocks start address is: 4 (R1)
; ctx start address is: 0 (R0)
SUB	SP, SP, #288
MOV	R3, R2
MOV	R2, R1
MOV	R1, R0
; block_count end address is: 8 (R2)
; blocks end address is: 4 (R1)
; ctx end address is: 0 (R0)
; ctx start address is: 4 (R1)
; blocks start address is: 8 (R2)
; block_count start address is: 12 (R3)
;sha2_routines.c,56 :: 		int i = 0;
;sha2_routines.c,57 :: 		uint32_t block = 0;
;sha2_routines.c,76 :: 		for (block = 0; block < block_count; block++) {
; block start address is: 0 (R0)
MOVS	R0, #0
; ctx end address is: 4 (R1)
; block_count end address is: 12 (R3)
; block end address is: 0 (R0)
; blocks end address is: 8 (R2)
MOV	R9, R1
MOV	R5, R3
L_sha2_routines_sw_sha256_process0:
; block start address is: 0 (R0)
; block_count start address is: 20 (R5)
; blocks start address is: 8 (R2)
; ctx start address is: 36 (R9)
CMP	R0, R5
IT	CS
BCS	L_sha2_routines_sw_sha256_process1
;sha2_routines.c,83 :: 		uint8_t* cur_msg_block = &blocks[block * SHA256_BLOCK_SIZE];
LSLS	R3, R0, #6
ADDS	R1, R2, R3
; cur_msg_block start address is: 4 (R1)
;sha2_routines.c,86 :: 		for (i = 0; i < SHA256_BLOCK_SIZE; i += 4) {
; i start address is: 24 (R6)
MOVS	R6, #0
SXTH	R6, R6
; block_count end address is: 20 (R5)
; i end address is: 24 (R6)
; block end address is: 0 (R0)
; ctx end address is: 36 (R9)
; blocks end address is: 8 (R2)
L_sha2_routines_sw_sha256_process3:
; i start address is: 24 (R6)
; cur_msg_block start address is: 4 (R1)
; cur_msg_block end address is: 4 (R1)
; ctx start address is: 36 (R9)
; blocks start address is: 8 (R2)
; block_count start address is: 20 (R5)
; block start address is: 0 (R0)
CMP	R6, #64
IT	GE
BGE	L_sha2_routines_sw_sha256_process4
; cur_msg_block end address is: 4 (R1)
;sha2_routines.c,87 :: 		w_union.w_byte[i + 3] = cur_msg_block[i + 0];
; cur_msg_block start address is: 4 (R1)
ADDS	R4, R6, #3
SXTH	R4, R4
ADD	R3, SP, #32
ADDS	R4, R3, R4
ADDS	R3, R1, R6
LDRB	R3, [R3, #0]
STRB	R3, [R4, #0]
;sha2_routines.c,88 :: 		w_union.w_byte[i + 2] = cur_msg_block[i + 1];
ADDS	R4, R6, #2
SXTH	R4, R4
ADD	R3, SP, #32
ADDS	R4, R3, R4
ADDS	R3, R6, #1
SXTH	R3, R3
ADDS	R3, R1, R3
LDRB	R3, [R3, #0]
STRB	R3, [R4, #0]
;sha2_routines.c,89 :: 		w_union.w_byte[i + 1] = cur_msg_block[i + 2];
ADDS	R4, R6, #1
SXTH	R4, R4
ADD	R3, SP, #32
ADDS	R4, R3, R4
ADDS	R3, R6, #2
SXTH	R3, R3
ADDS	R3, R1, R3
LDRB	R3, [R3, #0]
STRB	R3, [R4, #0]
;sha2_routines.c,90 :: 		w_union.w_byte[i + 0] = cur_msg_block[i + 3];
ADD	R3, SP, #32
ADDS	R4, R3, R6
ADDS	R3, R6, #3
SXTH	R3, R3
ADDS	R3, R1, R3
LDRB	R3, [R3, #0]
STRB	R3, [R4, #0]
;sha2_routines.c,86 :: 		for (i = 0; i < SHA256_BLOCK_SIZE; i += 4) {
ADDS	R6, R6, #4
SXTH	R6, R6
;sha2_routines.c,91 :: 		}
; cur_msg_block end address is: 4 (R1)
; i end address is: 24 (R6)
IT	AL
BAL	L_sha2_routines_sw_sha256_process3
L_sha2_routines_sw_sha256_process4:
;sha2_routines.c,93 :: 		w_index = 16;
; w_index start address is: 40 (R10)
MOVW	R10, #16
; block_count end address is: 20 (R5)
; w_index end address is: 40 (R10)
; block end address is: 0 (R0)
; ctx end address is: 36 (R9)
; blocks end address is: 8 (R2)
MOV	R1, R5
;sha2_routines.c,94 :: 		while (w_index < SHA256_BLOCK_SIZE) {
L_sha2_routines_sw_sha256_process6:
; w_index start address is: 40 (R10)
; block start address is: 0 (R0)
; block_count start address is: 4 (R1)
; blocks start address is: 8 (R2)
; ctx start address is: 36 (R9)
CMP	R10, #64
IT	CS
BCS	L_sha2_routines_sw_sha256_process7
;sha2_routines.c,96 :: 		word_value = w_union.w_word[w_index - 15];
SUB	R3, R10, #15
ADD	R4, SP, #32
LSLS	R3, R3, #2
ADDS	R3, R4, R3
LDR	R6, [R3, #0]
;sha2_routines.c,97 :: 		s0 = rotate_right(word_value, 7) ^ rotate_right(word_value, 18) ^ (word_value >> 3);
LSRS	R4, R6, #7
LSLS	R3, R6, #25
ORR	R5, R4, R3, LSL #0
LSRS	R4, R6, #18
LSLS	R3, R6, #14
ORR	R3, R4, R3, LSL #0
EOR	R4, R5, R3, LSL #0
LSRS	R3, R6, #3
EOR	R8, R4, R3, LSL #0
;sha2_routines.c,99 :: 		word_value = w_union.w_word[w_index - 2];
SUB	R3, R10, #2
ADD	R4, SP, #32
LSLS	R3, R3, #2
ADDS	R3, R4, R3
LDR	R6, [R3, #0]
;sha2_routines.c,100 :: 		s1 = rotate_right(word_value, 17) ^ rotate_right(word_value, 19) ^ (word_value >> 10);
LSRS	R4, R6, #17
LSLS	R3, R6, #15
ORR	R5, R4, R3, LSL #0
LSRS	R4, R6, #19
LSLS	R3, R6, #13
ORR	R3, R4, R3, LSL #0
EOR	R4, R5, R3, LSL #0
LSRS	R3, R6, #10
EOR	R7, R4, R3, LSL #0
;sha2_routines.c,102 :: 		w_union.w_word[w_index] = w_union.w_word[w_index - 16] + s0 + w_union.w_word[w_index - 7] + s1;
ADD	R4, SP, #32
LSL	R3, R10, #2
ADDS	R6, R4, R3
SUB	R3, R10, #16
ADD	R4, SP, #32
LSLS	R3, R3, #2
ADDS	R3, R4, R3
LDR	R3, [R3, #0]
ADD	R5, R3, R8, LSL #0
SUB	R3, R10, #7
ADD	R4, SP, #32
LSLS	R3, R3, #2
ADDS	R3, R4, R3
LDR	R3, [R3, #0]
ADDS	R3, R5, R3
ADDS	R3, R3, R7
STR	R3, [R6, #0]
;sha2_routines.c,104 :: 		w_index++;
ADD	R10, R10, #1
;sha2_routines.c,105 :: 		}
; w_index end address is: 40 (R10)
IT	AL
BAL	L_sha2_routines_sw_sha256_process6
L_sha2_routines_sw_sha256_process7:
;sha2_routines.c,108 :: 		for (i = 0; i < 8; i++)
; i start address is: 24 (R6)
MOVS	R6, #0
SXTH	R6, R6
; i end address is: 24 (R6)
; block end address is: 0 (R0)
; ctx end address is: 36 (R9)
; blocks end address is: 8 (R2)
; block_count end address is: 4 (R1)
L_sha2_routines_sw_sha256_process8:
; i start address is: 24 (R6)
; ctx start address is: 36 (R9)
; blocks start address is: 8 (R2)
; block_count start address is: 4 (R1)
; block start address is: 0 (R0)
CMP	R6, #8
IT	GE
BGE	L_sha2_routines_sw_sha256_process9
;sha2_routines.c,109 :: 		rotate_register[i] = ctx->hash[i];
ADD	R3, SP, #0
LSLS	R5, R6, #2
ADDS	R4, R3, R5
ADD	R3, R9, #136
ADDS	R3, R3, R5
LDR	R3, [R3, #0]
STR	R3, [R4, #0]
;sha2_routines.c,108 :: 		for (i = 0; i < 8; i++)
ADDS	R6, R6, #1
SXTH	R6, R6
;sha2_routines.c,109 :: 		rotate_register[i] = ctx->hash[i];
; i end address is: 24 (R6)
IT	AL
BAL	L_sha2_routines_sw_sha256_process8
L_sha2_routines_sw_sha256_process9:
;sha2_routines.c,112 :: 		for (i = 0; i < SHA256_BLOCK_SIZE; i++) {
; i start address is: 40 (R10)
MOVW	R10, #0
SXTH	R10, R10
; block end address is: 0 (R0)
; ctx end address is: 36 (R9)
; i end address is: 40 (R10)
; blocks end address is: 8 (R2)
; block_count end address is: 4 (R1)
L_sha2_routines_sw_sha256_process11:
; i start address is: 40 (R10)
; block start address is: 0 (R0)
; block_count start address is: 4 (R1)
; blocks start address is: 8 (R2)
; ctx start address is: 36 (R9)
CMP	R10, #64
IT	GE
BGE	L_sha2_routines_sw_sha256_process12
;sha2_routines.c,113 :: 		s0 = rotate_right(rotate_register[0], 2)
ADD	R8, SP, #0
LDR	R7, [R8, #0]
LSRS	R4, R7, #2
LSLS	R3, R7, #30
ORR	R5, R4, R3, LSL #0
;sha2_routines.c,114 :: 		^ rotate_right(rotate_register[0], 13)
LSRS	R4, R7, #13
LSLS	R3, R7, #19
ORR	R3, R4, R3, LSL #0
EORS	R5, R3
;sha2_routines.c,115 :: 		^ rotate_right(rotate_register[0], 22);
LSRS	R4, R7, #22
LSLS	R3, R7, #10
ORR	R3, R4, R3, LSL #0
EOR	R6, R5, R3, LSL #0
;sha2_routines.c,116 :: 		maj = (rotate_register[0] & rotate_register[1])
ADD	R3, R8, #4
LDR	R3, [R3, #0]
AND	R4, R7, R3, LSL #0
;sha2_routines.c,117 :: 		^ (rotate_register[0] & rotate_register[2])
ADD	R3, R8, #8
LDR	R3, [R3, #0]
AND	R3, R7, R3, LSL #0
EOR	R5, R4, R3, LSL #0
;sha2_routines.c,118 :: 		^ (rotate_register[1] & rotate_register[2]);
ADD	R3, R8, #4
LDR	R4, [R3, #0]
ADD	R3, R8, #8
LDR	R3, [R3, #0]
AND	R3, R4, R3, LSL #0
EOR	R3, R5, R3, LSL #0
;sha2_routines.c,119 :: 		t2 = s0 + maj;
ADDS	R3, R6, R3
; t2 start address is: 28 (R7)
MOV	R7, R3
;sha2_routines.c,120 :: 		s1 = rotate_right(rotate_register[4], 6)
ADD	R3, R8, #16
LDR	R3, [R3, #0]
LSRS	R4, R3, #6
ADD	R3, R8, #16
LDR	R3, [R3, #0]
LSLS	R3, R3, #26
ORR	R5, R4, R3, LSL #0
;sha2_routines.c,121 :: 		^ rotate_right(rotate_register[4], 11)
ADD	R3, R8, #16
LDR	R3, [R3, #0]
LSRS	R4, R3, #11
ADD	R3, R8, #16
LDR	R3, [R3, #0]
LSLS	R3, R3, #21
ORR	R3, R4, R3, LSL #0
EORS	R5, R3
;sha2_routines.c,122 :: 		^ rotate_right(rotate_register[4], 25);
ADD	R3, R8, #16
LDR	R3, [R3, #0]
LSRS	R4, R3, #25
ADD	R3, R8, #16
LDR	R3, [R3, #0]
LSLS	R3, R3, #7
ORR	R3, R4, R3, LSL #0
EOR	R6, R5, R3, LSL #0
;sha2_routines.c,123 :: 		ch = (rotate_register[4] & rotate_register[5])
ADD	R3, R8, #16
LDR	R4, [R3, #0]
ADD	R3, R8, #20
LDR	R3, [R3, #0]
AND	R5, R4, R3, LSL #0
;sha2_routines.c,124 :: 		^ (~rotate_register[4] & rotate_register[6]);
ADD	R3, R8, #16
LDR	R3, [R3, #0]
MVN	R4, R3
ADD	R3, R8, #24
LDR	R3, [R3, #0]
AND	R3, R4, R3, LSL #0
EOR	R4, R5, R3, LSL #0
;sha2_routines.c,125 :: 		t1 = rotate_register[7] + s1 + ch + k[i] + w_union.w_word[i];
ADD	R3, R8, #28
LDR	R3, [R3, #0]
ADDS	R3, R3, R6
ADDS	R4, R3, R4
LSL	R5, R10, #2
MOVW	R3, #lo_addr(sha2_routines_sw_sha256_process_k_L0+0)
MOVT	R3, #hi_addr(sha2_routines_sw_sha256_process_k_L0+0)
ADDS	R3, R3, R5
LDR	R3, [R3, #0]
ADDS	R4, R4, R3
ADD	R3, SP, #32
ADDS	R3, R3, R5
LDR	R3, [R3, #0]
ADDS	R3, R4, R3
; t1 start address is: 20 (R5)
MOV	R5, R3
;sha2_routines.c,127 :: 		rotate_register[7] = rotate_register[6];
ADD	R4, R8, #28
ADD	R3, R8, #24
LDR	R3, [R3, #0]
STR	R3, [R4, #0]
;sha2_routines.c,128 :: 		rotate_register[6] = rotate_register[5];
ADD	R4, R8, #24
ADD	R3, R8, #20
LDR	R3, [R3, #0]
STR	R3, [R4, #0]
;sha2_routines.c,129 :: 		rotate_register[5] = rotate_register[4];
ADD	R4, R8, #20
ADD	R3, R8, #16
LDR	R3, [R3, #0]
STR	R3, [R4, #0]
;sha2_routines.c,130 :: 		rotate_register[4] = rotate_register[3] + t1;
ADD	R4, R8, #16
ADD	R3, R8, #12
LDR	R3, [R3, #0]
ADDS	R3, R3, R5
STR	R3, [R4, #0]
;sha2_routines.c,131 :: 		rotate_register[3] = rotate_register[2];
ADD	R4, R8, #12
ADD	R3, R8, #8
LDR	R3, [R3, #0]
STR	R3, [R4, #0]
;sha2_routines.c,132 :: 		rotate_register[2] = rotate_register[1];
ADD	R4, R8, #8
ADD	R3, R8, #4
LDR	R3, [R3, #0]
STR	R3, [R4, #0]
;sha2_routines.c,133 :: 		rotate_register[1] = rotate_register[0];
ADD	R4, R8, #4
LDR	R3, [R8, #0]
STR	R3, [R4, #0]
;sha2_routines.c,134 :: 		rotate_register[0] = t1 + t2;
ADDS	R3, R5, R7
; t2 end address is: 28 (R7)
; t1 end address is: 20 (R5)
STR	R3, [R8, #0]
;sha2_routines.c,112 :: 		for (i = 0; i < SHA256_BLOCK_SIZE; i++) {
ADD	R10, R10, #1
SXTH	R10, R10
;sha2_routines.c,135 :: 		}
; i end address is: 40 (R10)
IT	AL
BAL	L_sha2_routines_sw_sha256_process11
L_sha2_routines_sw_sha256_process12:
;sha2_routines.c,138 :: 		for (i = 0; i < 8; i++)
; i start address is: 28 (R7)
MOVS	R7, #0
SXTH	R7, R7
; block end address is: 0 (R0)
; ctx end address is: 36 (R9)
; blocks end address is: 8 (R2)
; block_count end address is: 4 (R1)
; i end address is: 28 (R7)
MOV	R6, R0
MOV	R0, R9
L_sha2_routines_sw_sha256_process14:
; i start address is: 28 (R7)
; ctx start address is: 0 (R0)
; blocks start address is: 8 (R2)
; block_count start address is: 4 (R1)
; block start address is: 24 (R6)
CMP	R7, #8
IT	GE
BGE	L_sha2_routines_sw_sha256_process15
;sha2_routines.c,139 :: 		ctx->hash[i] += rotate_register[i];
ADDW	R3, R0, #136
LSLS	R4, R7, #2
ADDS	R5, R3, R4
ADD	R3, SP, #0
ADDS	R3, R3, R4
LDR	R4, [R3, #0]
LDR	R3, [R5, #0]
ADDS	R3, R3, R4
STR	R3, [R5, #0]
;sha2_routines.c,138 :: 		for (i = 0; i < 8; i++)
ADDS	R7, R7, #1
SXTH	R7, R7
;sha2_routines.c,139 :: 		ctx->hash[i] += rotate_register[i];
; i end address is: 28 (R7)
IT	AL
BAL	L_sha2_routines_sw_sha256_process14
L_sha2_routines_sw_sha256_process15:
;sha2_routines.c,76 :: 		for (block = 0; block < block_count; block++) {
ADDS	R3, R6, #1
; block end address is: 24 (R6)
; block start address is: 12 (R3)
;sha2_routines.c,140 :: 		}
MOV	R9, R0
; ctx end address is: 0 (R0)
; blocks end address is: 8 (R2)
; block_count end address is: 4 (R1)
; block end address is: 12 (R3)
MOV	R0, R3
MOV	R5, R1
IT	AL
BAL	L_sha2_routines_sw_sha256_process0
L_sha2_routines_sw_sha256_process1:
;sha2_routines.c,141 :: 		}
L_end_sw_sha256_process:
ADD	SP, SP, #288
BX	LR
; end of sha2_routines_sw_sha256_process
_sw_sha256_init:
;sha2_routines.c,143 :: 		void sw_sha256_init(sw_sha256_ctx* ctx)
; ctx start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
MOV	R6, R0
; ctx end address is: 0 (R0)
; ctx start address is: 24 (R6)
;sha2_routines.c,151 :: 		memset(ctx, 0, sizeof(*ctx));
MOVS	R2, #168
SXTH	R2, R2
MOVS	R1, #0
MOV	R0, R6
BL	_memset+0
;sha2_routines.c,152 :: 		for (i = 0; i < 8; i++)
; i start address is: 0 (R0)
MOVS	R0, #0
SXTH	R0, R0
; ctx end address is: 24 (R6)
; i end address is: 0 (R0)
MOV	R4, R6
L_sw_sha256_init17:
; i start address is: 0 (R0)
; ctx start address is: 16 (R4)
; ctx start address is: 16 (R4)
; ctx end address is: 16 (R4)
CMP	R0, #8
IT	GE
BGE	L_sw_sha256_init18
; ctx end address is: 16 (R4)
;sha2_routines.c,153 :: 		ctx->hash[i] = hash_init[i];
; ctx start address is: 16 (R4)
ADDW	R1, R4, #136
LSLS	R3, R0, #2
ADDS	R2, R1, R3
MOVW	R1, #lo_addr(sw_sha256_init_hash_init_L0+0)
MOVT	R1, #hi_addr(sw_sha256_init_hash_init_L0+0)
ADDS	R1, R1, R3
LDR	R1, [R1, #0]
STR	R1, [R2, #0]
;sha2_routines.c,152 :: 		for (i = 0; i < 8; i++)
ADDS	R0, R0, #1
SXTH	R0, R0
;sha2_routines.c,153 :: 		ctx->hash[i] = hash_init[i];
; ctx end address is: 16 (R4)
; i end address is: 0 (R0)
IT	AL
BAL	L_sw_sha256_init17
L_sw_sha256_init18:
;sha2_routines.c,154 :: 		}
L_end_sw_sha256_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _sw_sha256_init
_sw_sha256_update:
;sha2_routines.c,156 :: 		void sw_sha256_update(sw_sha256_ctx* ctx,  uint8_t* msg, uint32_t msg_size)
; msg_size start address is: 8 (R2)
; msg start address is: 4 (R1)
; ctx start address is: 0 (R0)
SUB	SP, SP, #16
STR	LR, [SP, #0]
MOV	R11, R0
MOV	R0, R2
MOV	R12, R1
; msg_size end address is: 8 (R2)
; msg end address is: 4 (R1)
; ctx end address is: 0 (R0)
; ctx start address is: 44 (R11)
; msg start address is: 48 (R12)
; msg_size start address is: 0 (R0)
;sha2_routines.c,159 :: 		uint32_t rem_size = SHA256_BLOCK_SIZE - ctx->block_size;
ADD	R3, R11, #4
LDR	R3, [R3, #0]
RSB	R3, R3, #64
; rem_size start address is: 4 (R1)
MOV	R1, R3
;sha2_routines.c,160 :: 		uint32_t copy_size = msg_size > rem_size ? rem_size : msg_size;
CMP	R0, R3
IT	LS
BLS	L_sw_sha256_update20
; ?FLOC___sw_sha256_update?T328 start address is: 8 (R2)
MOV	R2, R1
; rem_size end address is: 4 (R1)
; ?FLOC___sw_sha256_update?T328 end address is: 8 (R2)
IT	AL
BAL	L_sw_sha256_update21
L_sw_sha256_update20:
; ?FLOC___sw_sha256_update?T328 start address is: 8 (R2)
MOV	R2, R0
; ?FLOC___sw_sha256_update?T328 end address is: 8 (R2)
L_sw_sha256_update21:
; ?FLOC___sw_sha256_update?T328 start address is: 8 (R2)
; copy_size start address is: 4 (R1)
MOV	R1, R2
;sha2_routines.c,163 :: 		memcpy(&ctx->block[ctx->block_size], msg, copy_size);
ADD	R4, R11, #8
ADD	R3, R11, #4
LDR	R3, [R3, #0]
ADDS	R3, R4, R3
STR	R1, [SP, #4]
; ?FLOC___sw_sha256_update?T328 end address is: 8 (R2)
STR	R0, [SP, #8]
SXTH	R2, R2
MOV	R1, R12
MOV	R0, R3
BL	_memcpy+0
LDR	R0, [SP, #8]
LDR	R1, [SP, #4]
;sha2_routines.c,165 :: 		if (ctx->block_size + msg_size < SHA256_BLOCK_SIZE) {
ADD	R3, R11, #4
LDR	R3, [R3, #0]
ADDS	R3, R3, R0
CMP	R3, #64
IT	CS
BCS	L_sw_sha256_update22
; msg end address is: 48 (R12)
; copy_size end address is: 4 (R1)
;sha2_routines.c,167 :: 		ctx->block_size += msg_size;
ADD	R4, R11, #4
; ctx end address is: 44 (R11)
LDR	R3, [R4, #0]
ADDS	R3, R3, R0
; msg_size end address is: 0 (R0)
STR	R3, [R4, #0]
;sha2_routines.c,168 :: 		return;
IT	AL
BAL	L_end_sw_sha256_update
;sha2_routines.c,169 :: 		}
L_sw_sha256_update22:
;sha2_routines.c,172 :: 		sw_sha256_process(ctx, ctx->block, 1);
; copy_size start address is: 4 (R1)
; msg_size start address is: 0 (R0)
; msg start address is: 48 (R12)
; ctx start address is: 44 (R11)
ADD	R3, R11, #8
STR	R1, [SP, #4]
STR	R0, [SP, #8]
MOVS	R2, #1
MOV	R1, R3
MOV	R0, R11
BL	sha2_routines_sw_sha256_process+0
LDR	R0, [SP, #8]
LDR	R1, [SP, #4]
;sha2_routines.c,175 :: 		msg_size -= copy_size; // Adjust to the remaining message bytes
SUB	R3, R0, R1
; msg_size end address is: 0 (R0)
; msg_size start address is: 8 (R2)
MOV	R2, R3
;sha2_routines.c,176 :: 		block_count = msg_size / SHA256_BLOCK_SIZE;
LSRS	R4, R3, #6
; block_count start address is: 0 (R0)
MOV	R0, R4
;sha2_routines.c,177 :: 		sw_sha256_process(ctx, &msg[copy_size], block_count);
ADD	R3, R12, R1, LSL #0
STR	R0, [SP, #4]
STR	R2, [SP, #8]
STR	R1, [SP, #12]
MOV	R2, R4
MOV	R1, R3
MOV	R0, R11
BL	sha2_routines_sw_sha256_process+0
LDR	R1, [SP, #12]
LDR	R2, [SP, #8]
LDR	R0, [SP, #4]
;sha2_routines.c,180 :: 		ctx->total_msg_size += (block_count + 1) * SHA256_BLOCK_SIZE;
ADDS	R3, R0, #1
LSLS	R4, R3, #6
LDR	R3, [R11, #0]
ADDS	R3, R3, R4
STR	R3, [R11, #0]
;sha2_routines.c,181 :: 		ctx->block_size = msg_size % SHA256_BLOCK_SIZE;
ADD	R4, R11, #4
AND	R3, R2, #63
; msg_size end address is: 8 (R2)
STR	R3, [R4, #0]
;sha2_routines.c,182 :: 		memcpy(ctx->block, &msg[copy_size + block_count * SHA256_BLOCK_SIZE], ctx->block_size);
ADD	R3, R11, #4
LDR	R3, [R3, #0]
SXTH	R5, R3
LSLS	R3, R0, #6
; block_count end address is: 0 (R0)
ADDS	R3, R1, R3
; copy_size end address is: 4 (R1)
ADD	R4, R12, R3, LSL #0
; msg end address is: 48 (R12)
ADD	R3, R11, #8
; ctx end address is: 44 (R11)
SXTH	R2, R5
MOV	R1, R4
MOV	R0, R3
BL	_memcpy+0
;sha2_routines.c,183 :: 		}
L_end_sw_sha256_update:
LDR	LR, [SP, #0]
ADD	SP, SP, #16
BX	LR
; end of _sw_sha256_update
_sw_sha256_final:
;sha2_routines.c,185 :: 		void sw_sha256_final(sw_sha256_ctx* ctx, uint8_t digest[SHA256_DIGEST_SIZE])
; digest start address is: 4 (R1)
; ctx start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
MOV	R11, R0
MOV	R12, R1
; digest end address is: 4 (R1)
; ctx end address is: 0 (R0)
; ctx start address is: 44 (R11)
; digest start address is: 48 (R12)
;sha2_routines.c,192 :: 		ctx->total_msg_size += ctx->block_size;
ADD	R2, R11, #4
LDR	R3, [R2, #0]
LDR	R2, [R11, #0]
ADDS	R2, R2, R3
STR	R2, [R11, #0]
;sha2_routines.c,193 :: 		msg_size_bits = ctx->total_msg_size * 8;
LDR	R2, [R11, #0]
LSLS	R2, R2, #3
; msg_size_bits start address is: 24 (R6)
MOV	R6, R2
;sha2_routines.c,196 :: 		pad_zero_count = (SHA256_BLOCK_SIZE - ((ctx->block_size + 9) % SHA256_BLOCK_SIZE)) % SHA256_BLOCK_SIZE;
ADD	R5, R11, #4
LDR	R3, [R5, #0]
ADDW	R2, R3, #9
AND	R2, R2, #63
RSB	R2, R2, #64
AND	R2, R2, #63
; pad_zero_count start address is: 28 (R7)
MOV	R7, R2
;sha2_routines.c,199 :: 		ctx->block[ctx->block_size++] = 0x80;
ADD	R2, R11, #8
MOV	R4, R5
ADDS	R3, R2, R3
MOVS	R2, #128
STRB	R2, [R3, #0]
LDR	R2, [R4, #0]
ADDS	R2, R2, #1
STR	R2, [R4, #0]
;sha2_routines.c,202 :: 		memset(&ctx->block[ctx->block_size], 0, pad_zero_count + 4);
ADDS	R4, R7, #4
ADD	R3, R11, #8
ADD	R2, R11, #4
LDR	R2, [R2, #0]
ADDS	R2, R3, R2
MOVS	R1, #0
MOV	R0, R2
SXTH	R2, R4
BL	_memset+0
;sha2_routines.c,203 :: 		ctx->block_size += pad_zero_count + 4;
ADD	R4, R11, #4
ADDS	R3, R7, #4
; pad_zero_count end address is: 28 (R7)
LDR	R2, [R4, #0]
ADDS	R2, R2, R3
STR	R2, [R4, #0]
;sha2_routines.c,207 :: 		ctx->block[ctx->block_size++] = (uint8_t)(msg_size_bits >> 24);
ADD	R3, R11, #8
ADD	R4, R11, #4
LDR	R2, [R4, #0]
ADDS	R3, R3, R2
LSRS	R2, R6, #24
UXTB	R2, R2
STRB	R2, [R3, #0]
LDR	R2, [R4, #0]
ADDS	R2, R2, #1
STR	R2, [R4, #0]
;sha2_routines.c,208 :: 		ctx->block[ctx->block_size++] = (uint8_t)(msg_size_bits >> 16);
ADD	R3, R11, #8
ADD	R4, R11, #4
LDR	R2, [R4, #0]
ADDS	R3, R3, R2
LSRS	R2, R6, #16
UXTB	R2, R2
STRB	R2, [R3, #0]
LDR	R2, [R4, #0]
ADDS	R2, R2, #1
STR	R2, [R4, #0]
;sha2_routines.c,209 :: 		ctx->block[ctx->block_size++] = (uint8_t)(msg_size_bits >> 8);
ADD	R3, R11, #8
ADD	R4, R11, #4
LDR	R2, [R4, #0]
ADDS	R3, R3, R2
LSRS	R2, R6, #8
UXTB	R2, R2
STRB	R2, [R3, #0]
LDR	R2, [R4, #0]
ADDS	R2, R2, #1
STR	R2, [R4, #0]
;sha2_routines.c,210 :: 		ctx->block[ctx->block_size++] = (uint8_t)(msg_size_bits >> 0);
ADD	R3, R11, #8
ADD	R4, R11, #4
LDR	R2, [R4, #0]
ADDS	R3, R3, R2
UXTB	R2, R6
; msg_size_bits end address is: 24 (R6)
STRB	R2, [R3, #0]
LDR	R2, [R4, #0]
ADDS	R2, R2, #1
STR	R2, [R4, #0]
;sha2_routines.c,212 :: 		sw_sha256_process(ctx, ctx->block, ctx->block_size / SHA256_BLOCK_SIZE);
ADD	R2, R11, #4
LDR	R2, [R2, #0]
LSRS	R3, R2, #6
ADD	R2, R11, #8
MOV	R1, R2
MOV	R2, R3
MOV	R0, R11
BL	sha2_routines_sw_sha256_process+0
;sha2_routines.c,216 :: 		for (i = 0; i < 8; i++)
; i start address is: 24 (R6)
MOVS	R6, #0
SXTH	R6, R6
; ctx end address is: 44 (R11)
; digest end address is: 48 (R12)
; i end address is: 24 (R6)
MOV	R0, R11
MOV	R1, R12
L_sw_sha256_final23:
; i start address is: 24 (R6)
; digest start address is: 4 (R1)
; ctx start address is: 0 (R0)
CMP	R6, #8
IT	GE
BGE	L_sw_sha256_final24
;sha2_routines.c,217 :: 		for (j = sizeof(int32_t) - 1; j >= 0; j--, ctx->hash[i] >>= 8)
; j start address is: 28 (R7)
MOVW	R7, #3
SXTH	R7, R7
; ctx end address is: 0 (R0)
; digest end address is: 4 (R1)
; j end address is: 28 (R7)
; i end address is: 24 (R6)
L_sw_sha256_final26:
; j start address is: 28 (R7)
; ctx start address is: 0 (R0)
; digest start address is: 4 (R1)
; i start address is: 24 (R6)
CMP	R7, #0
IT	LT
BLT	L_sw_sha256_final27
;sha2_routines.c,218 :: 		digest[i * sizeof(int32_t) + j] = ctx->hash[i] & 0xFF;
LSLS	R5, R6, #2
SXTH	R5, R5
ADDS	R2, R5, R7
SXTH	R2, R2
ADDS	R4, R1, R2
ADDW	R3, R0, #136
SXTH	R2, R5
ADDS	R2, R3, R2
LDR	R2, [R2, #0]
AND	R2, R2, #255
STRB	R2, [R4, #0]
;sha2_routines.c,217 :: 		for (j = sizeof(int32_t) - 1; j >= 0; j--, ctx->hash[i] >>= 8)
SUBS	R7, R7, #1
SXTH	R7, R7
ADDW	R3, R0, #136
LSLS	R2, R6, #2
ADDS	R3, R3, R2
LDR	R2, [R3, #0]
LSRS	R2, R2, #8
STR	R2, [R3, #0]
;sha2_routines.c,218 :: 		digest[i * sizeof(int32_t) + j] = ctx->hash[i] & 0xFF;
; j end address is: 28 (R7)
IT	AL
BAL	L_sw_sha256_final26
L_sw_sha256_final27:
;sha2_routines.c,216 :: 		for (i = 0; i < 8; i++)
ADDS	R6, R6, #1
SXTH	R6, R6
;sha2_routines.c,218 :: 		digest[i * sizeof(int32_t) + j] = ctx->hash[i] & 0xFF;
; ctx end address is: 0 (R0)
; digest end address is: 4 (R1)
; i end address is: 24 (R6)
IT	AL
BAL	L_sw_sha256_final23
L_sw_sha256_final24:
;sha2_routines.c,219 :: 		}
L_end_sw_sha256_final:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _sw_sha256_final
_sw_sha256:
;sha2_routines.c,221 :: 		void sw_sha256( uint8_t* message, unsigned int len, uint8_t digest[SHA256_DIGEST_SIZE])
; len start address is: 4 (R1)
; message start address is: 0 (R0)
SUB	SP, SP, #176
STR	LR, [SP, #0]
MOV	R7, R0
UXTH	R8, R1
STR	R2, [SP, #172]
; len end address is: 4 (R1)
; message end address is: 0 (R0)
; message start address is: 28 (R7)
; len start address is: 32 (R8)
;sha2_routines.c,225 :: 		sw_sha256_init(&ctx);
ADD	R3, SP, #4
MOV	R0, R3
BL	_sw_sha256_init+0
;sha2_routines.c,226 :: 		sw_sha256_update(&ctx, message, len);
ADD	R3, SP, #4
UXTH	R2, R8
; len end address is: 32 (R8)
MOV	R1, R7
; message end address is: 28 (R7)
MOV	R0, R3
BL	_sw_sha256_update+0
;sha2_routines.c,227 :: 		sw_sha256_final(&ctx, digest);
ADD	R3, SP, #4
LDR	R1, [SP, #172]
MOV	R0, R3
BL	_sw_sha256_final+0
;sha2_routines.c,228 :: 		}
L_end_sw_sha256:
LDR	LR, [SP, #0]
ADD	SP, SP, #176
BX	LR
; end of _sw_sha256
