_atcah_include_data:
;atca_host.c,51 :: 		uint8_t *atcah_include_data(struct atca_include_data_in_out *param)
; param start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
MOV	R6, R0
; param end address is: 0 (R0)
; param start address is: 24 (R6)
;atca_host.c,53 :: 		if (param->mode & MAC_MODE_INCLUDE_OTP_88) {
ADDW	R1, R6, #12
LDRB	R1, [R1, #0]
AND	R1, R1, #16
UXTB	R1, R1
CMP	R1, #0
IT	EQ
BEQ	L_atcah_include_data0
;atca_host.c,54 :: 		memcpy(param->p_temp, param->otp, ATCA_OTP_SIZE_8 + ATCA_OTP_SIZE_3);            // use OTP[0:10], Mode:5 is overridden
ADDS	R1, R6, #4
LDR	R1, [R1, #0]
MOV	R2, R1
LDR	R1, [R6, #0]
MOV	R0, R1
MOV	R1, R2
MOVW	R2, #11
SXTH	R2, R2
BL	_memcpy+0
;atca_host.c,55 :: 		param->p_temp += ATCA_OTP_SIZE_8 + ATCA_OTP_SIZE_3;
LDR	R1, [R6, #0]
ADDS	R1, #11
STR	R1, [R6, #0]
;atca_host.c,56 :: 		}else {
IT	AL
BAL	L_atcah_include_data1
L_atcah_include_data0:
;atca_host.c,57 :: 		if (param->mode & MAC_MODE_INCLUDE_OTP_64)
ADDW	R1, R6, #12
LDRB	R1, [R1, #0]
AND	R1, R1, #32
UXTB	R1, R1
CMP	R1, #0
IT	EQ
BEQ	L_atcah_include_data2
;atca_host.c,58 :: 		memcpy(param->p_temp, param->otp, ATCA_OTP_SIZE_8);         // use 8 bytes OTP[0:7] for (6)
ADDS	R1, R6, #4
LDR	R1, [R1, #0]
MOV	R2, R1
LDR	R1, [R6, #0]
MOV	R0, R1
MOV	R1, R2
MOVS	R2, #8
SXTH	R2, R2
BL	_memcpy+0
IT	AL
BAL	L_atcah_include_data3
L_atcah_include_data2:
;atca_host.c,60 :: 		memset(param->p_temp, 0, ATCA_OTP_SIZE_8);                  // use 8 zeros for (6)
LDR	R1, [R6, #0]
MOVS	R2, #8
SXTH	R2, R2
MOV	R0, R1
MOVS	R1, #0
BL	_memset+0
L_atcah_include_data3:
;atca_host.c,61 :: 		param->p_temp += ATCA_OTP_SIZE_8;
LDR	R1, [R6, #0]
ADDS	R1, #8
STR	R1, [R6, #0]
;atca_host.c,63 :: 		memset(param->p_temp, 0, ATCA_OTP_SIZE_3);                     // use 3 zeros for (7)
LDR	R1, [R6, #0]
MOVS	R2, #3
SXTH	R2, R2
MOV	R0, R1
MOVS	R1, #0
BL	_memset+0
;atca_host.c,64 :: 		param->p_temp += ATCA_OTP_SIZE_3;
LDR	R1, [R6, #0]
ADDS	R1, R1, #3
STR	R1, [R6, #0]
;atca_host.c,65 :: 		}
L_atcah_include_data1:
;atca_host.c,68 :: 		*param->p_temp++ = ATCA_SN_8;
MOV	R3, R6
LDR	R2, [R6, #0]
MOVS	R1, #238
STRB	R1, [R2, #0]
LDR	R1, [R3, #0]
ADDS	R1, R1, #1
STR	R1, [R3, #0]
;atca_host.c,71 :: 		if (param->mode & MAC_MODE_INCLUDE_SN)
ADDW	R1, R6, #12
LDRB	R1, [R1, #0]
AND	R1, R1, #64
UXTB	R1, R1
CMP	R1, #0
IT	EQ
BEQ	L_atcah_include_data4
;atca_host.c,72 :: 		memcpy(param->p_temp, &param->sn[4], ATCA_SN_SIZE_4);           //use SN[4:7] for (9)
ADDW	R1, R6, #8
LDR	R1, [R1, #0]
ADDS	R2, R1, #4
LDR	R1, [R6, #0]
MOV	R0, R1
MOV	R1, R2
MOVS	R2, #4
SXTH	R2, R2
BL	_memcpy+0
IT	AL
BAL	L_atcah_include_data5
L_atcah_include_data4:
;atca_host.c,74 :: 		memset(param->p_temp, 0, ATCA_SN_SIZE_4);                       //use zeros for (9)
LDR	R1, [R6, #0]
MOVS	R2, #4
SXTH	R2, R2
MOV	R0, R1
MOVS	R1, #0
BL	_memset+0
L_atcah_include_data5:
;atca_host.c,75 :: 		param->p_temp += ATCA_SN_SIZE_4;
LDR	R1, [R6, #0]
ADDS	R1, R1, #4
STR	R1, [R6, #0]
;atca_host.c,78 :: 		*param->p_temp++ = ATCA_SN_0;
MOV	R3, R6
LDR	R2, [R6, #0]
MOVS	R1, #1
STRB	R1, [R2, #0]
LDR	R1, [R3, #0]
ADDS	R1, R1, #1
STR	R1, [R3, #0]
;atca_host.c,79 :: 		*param->p_temp++ = ATCA_SN_1;
MOV	R3, R6
LDR	R2, [R6, #0]
MOVS	R1, #35
STRB	R1, [R2, #0]
LDR	R1, [R3, #0]
ADDS	R1, R1, #1
STR	R1, [R3, #0]
;atca_host.c,82 :: 		if (param->mode & MAC_MODE_INCLUDE_SN)
ADDW	R1, R6, #12
LDRB	R1, [R1, #0]
AND	R1, R1, #64
UXTB	R1, R1
CMP	R1, #0
IT	EQ
BEQ	L_atcah_include_data6
;atca_host.c,83 :: 		memcpy(param->p_temp, &param->sn[2], ATCA_SN_SIZE_2);           //use SN[2:3] for (11)
ADDW	R1, R6, #8
LDR	R1, [R1, #0]
ADDS	R2, R1, #2
LDR	R1, [R6, #0]
MOV	R0, R1
MOV	R1, R2
MOVS	R2, #2
SXTH	R2, R2
BL	_memcpy+0
IT	AL
BAL	L_atcah_include_data7
L_atcah_include_data6:
;atca_host.c,85 :: 		memset(param->p_temp, 0, ATCA_SN_SIZE_2);                       //use zeros for (9)
LDR	R1, [R6, #0]
MOVS	R2, #2
SXTH	R2, R2
MOV	R0, R1
MOVS	R1, #0
BL	_memset+0
L_atcah_include_data7:
;atca_host.c,86 :: 		param->p_temp += ATCA_SN_SIZE_2;
LDR	R1, [R6, #0]
ADDS	R1, R1, #2
STR	R1, [R6, #0]
;atca_host.c,88 :: 		return param->p_temp;
LDR	R1, [R6, #0]
; param end address is: 24 (R6)
MOV	R0, R1
;atca_host.c,89 :: 		}
L_end_atcah_include_data:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atcah_include_data
_atcah_nonce:
;atca_host.c,102 :: 		ATCA_STATUS atcah_nonce(struct atca_nonce_in_out *param)
; param start address is: 0 (R0)
SUB	SP, SP, #64
STR	LR, [SP, #0]
; param end address is: 0 (R0)
; param start address is: 0 (R0)
;atca_host.c,108 :: 		if (!param->temp_key || !param->num_in || (param->mode > NONCE_MODE_PASSTHROUGH) || (param->mode == NONCE_MODE_INVALID)
ADDW	R1, R0, #12
LDR	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L__atcah_nonce165
ADDS	R1, R0, #4
LDR	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L__atcah_nonce164
LDRB	R1, [R0, #0]
CMP	R1, #3
IT	HI
BHI	L__atcah_nonce163
LDRB	R1, [R0, #0]
CMP	R1, #2
IT	EQ
BEQ	L__atcah_nonce162
;atca_host.c,109 :: 		|| (((param->mode == NONCE_MODE_SEED_UPDATE || (param->mode == NONCE_MODE_NO_SEED_UPDATE)) && !param->rand_out)))
LDRB	R1, [R0, #0]
CMP	R1, #0
IT	EQ
BEQ	L__atcah_nonce160
LDRB	R1, [R0, #0]
CMP	R1, #1
IT	EQ
BEQ	L__atcah_nonce159
IT	AL
BAL	L__atcah_nonce157
L__atcah_nonce160:
L__atcah_nonce159:
ADDW	R1, R0, #8
LDR	R1, [R1, #0]
CMP	R1, #0
IT	NE
BNE	L__atcah_nonce161
; param end address is: 0 (R0)
IT	AL
BAL	L__atcah_nonce156
L__atcah_nonce157:
; param start address is: 0 (R0)
L__atcah_nonce161:
IT	AL
BAL	L_atcah_nonce14
; param end address is: 0 (R0)
L__atcah_nonce156:
;atca_host.c,108 :: 		if (!param->temp_key || !param->num_in || (param->mode > NONCE_MODE_PASSTHROUGH) || (param->mode == NONCE_MODE_INVALID)
L__atcah_nonce165:
L__atcah_nonce164:
L__atcah_nonce163:
L__atcah_nonce162:
;atca_host.c,110 :: 		return ATCA_BAD_PARAM;
MOVS	R0, #226
IT	AL
BAL	L_end_atcah_nonce
L_atcah_nonce14:
;atca_host.c,113 :: 		if ((param->mode == NONCE_MODE_SEED_UPDATE) || (param->mode == NONCE_MODE_NO_SEED_UPDATE)) {
; param start address is: 0 (R0)
LDRB	R1, [R0, #0]
CMP	R1, #0
IT	EQ
BEQ	L__atcah_nonce167
LDRB	R1, [R0, #0]
CMP	R1, #1
IT	EQ
BEQ	L__atcah_nonce166
IT	AL
BAL	L_atcah_nonce17
L__atcah_nonce167:
L__atcah_nonce166:
;atca_host.c,115 :: 		p_temp = temporary;
ADD	R2, SP, #8
; p_temp start address is: 24 (R6)
MOV	R6, R2
;atca_host.c,117 :: 		memcpy(p_temp, param->rand_out, NONCE_RSP_SIZE_LONG - ATCA_PACKET_OVERHEAD);
ADDW	R1, R0, #8
LDR	R1, [R1, #0]
STR	R0, [SP, #4]
MOV	R0, R2
MOVW	R2, #32
SXTH	R2, R2
BL	_memcpy+0
LDR	R0, [SP, #4]
;atca_host.c,118 :: 		p_temp += NONCE_RSP_SIZE_LONG - ATCA_PACKET_OVERHEAD;
ADDW	R2, R6, #32
MOV	R6, R2
;atca_host.c,120 :: 		memcpy(p_temp, param->num_in, NONCE_NUMIN_SIZE);
ADDS	R1, R0, #4
LDR	R1, [R1, #0]
STR	R0, [SP, #4]
MOV	R0, R2
MOVS	R2, #20
SXTH	R2, R2
BL	_memcpy+0
LDR	R0, [SP, #4]
;atca_host.c,121 :: 		p_temp += NONCE_NUMIN_SIZE;
ADDW	R2, R6, #20
; p_temp end address is: 24 (R6)
; p_temp start address is: 12 (R3)
MOV	R3, R2
;atca_host.c,123 :: 		*p_temp++ = ATCA_NONCE;
MOVS	R1, #22
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,124 :: 		*p_temp++ = param->mode;
LDRB	R1, [R0, #0]
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
; p_temp end address is: 12 (R3)
;atca_host.c,125 :: 		*p_temp++ = 0x00;
MOVS	R1, #0
STRB	R1, [R2, #0]
;atca_host.c,128 :: 		atcah_sha256(ATCA_MSG_SIZE_NONCE, temporary, param->temp_key->value);
ADDW	R1, R0, #12
LDR	R2, [R1, #0]
ADD	R1, SP, #8
STR	R0, [SP, #4]
MOVS	R0, #55
BL	_atcah_sha256+0
LDR	R0, [SP, #4]
;atca_host.c,131 :: 		param->temp_key->source_flag = 0;
ADDW	R1, R0, #12
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
MOVS	R2, #0
LDRB	R1, [R3, #0]
BFI	R1, R2, #4, #1
STRB	R1, [R3, #0]
;atca_host.c,132 :: 		}else if (param->mode == NONCE_MODE_PASSTHROUGH) {
IT	AL
BAL	L_atcah_nonce18
L_atcah_nonce17:
LDRB	R1, [R0, #0]
CMP	R1, #3
IT	NE
BNE	L_atcah_nonce19
;atca_host.c,134 :: 		memcpy(param->temp_key->value, param->num_in, NONCE_NUMIN_SIZE_PASSTHROUGH);
ADDS	R1, R0, #4
LDR	R1, [R1, #0]
MOV	R2, R1
ADDW	R1, R0, #12
LDR	R1, [R1, #0]
STR	R0, [SP, #4]
MOV	R0, R1
MOV	R1, R2
MOVS	R2, #32
SXTH	R2, R2
BL	_memcpy+0
LDR	R0, [SP, #4]
;atca_host.c,137 :: 		param->temp_key->source_flag = 1;
ADDW	R1, R0, #12
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
MOVS	R2, #1
LDRB	R1, [R3, #0]
BFI	R1, R2, #4, #1
STRB	R1, [R3, #0]
;atca_host.c,138 :: 		}
L_atcah_nonce19:
L_atcah_nonce18:
;atca_host.c,141 :: 		param->temp_key->key_id = 0;
ADDW	R1, R0, #12
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
MOVS	R2, #0
LDRB	R1, [R3, #0]
BFI	R1, R2, #0, #4
STRB	R1, [R3, #0]
;atca_host.c,142 :: 		param->temp_key->gen_data = 0;
ADDW	R1, R0, #12
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
MOVS	R2, #0
LDRB	R1, [R3, #0]
BFI	R1, R2, #5, #1
STRB	R1, [R3, #0]
;atca_host.c,143 :: 		param->temp_key->check_flag = 0;
ADDW	R1, R0, #12
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
MOVS	R2, #0
LDRB	R1, [R3, #0]
BFI	R1, R2, #6, #1
STRB	R1, [R3, #0]
;atca_host.c,144 :: 		param->temp_key->valid = 1;
ADDW	R1, R0, #12
; param end address is: 0 (R0)
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
MOVS	R2, #1
LDRB	R1, [R3, #0]
BFI	R1, R2, #7, #1
STRB	R1, [R3, #0]
;atca_host.c,146 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_host.c,147 :: 		}
L_end_atcah_nonce:
LDR	LR, [SP, #0]
ADD	SP, SP, #64
BX	LR
; end of _atcah_nonce
_atcah_mac:
;atca_host.c,158 :: 		ATCA_STATUS atcah_mac(struct atca_mac_in_out *param)
; param start address is: 0 (R0)
SUB	SP, SP, #112
STR	LR, [SP, #0]
; param end address is: 0 (R0)
; param start address is: 0 (R0)
;atca_host.c,165 :: 		include_data.otp = param->otp;
ADDW	R1, R0, #12
LDR	R1, [R1, #0]
STR	R1, [SP, #100]
;atca_host.c,166 :: 		include_data.sn = param->sn;
ADDW	R1, R0, #16
LDR	R1, [R1, #0]
STR	R1, [SP, #104]
;atca_host.c,167 :: 		include_data.mode = param->mode;
LDRB	R1, [R0, #0]
STRB	R1, [SP, #108]
;atca_host.c,170 :: 		if (!param->response
ADDW	R1, R0, #20
LDR	R1, [R1, #0]
;atca_host.c,171 :: 		|| (param->mode & ~MAC_MODE_MASK)
CMP	R1, #0
IT	EQ
BEQ	L__atcah_mac189
LDRB	R1, [R0, #0]
AND	R1, R1, #136
UXTB	R1, R1
CMP	R1, #0
IT	NE
BNE	L__atcah_mac188
;atca_host.c,172 :: 		|| (!(param->mode & MAC_MODE_BLOCK1_TEMPKEY) && !param->key)
LDRB	R1, [R0, #0]
AND	R1, R1, #2
UXTB	R1, R1
CMP	R1, #0
IT	NE
BNE	L__atcah_mac178
ADDW	R1, R0, #8
LDR	R1, [R1, #0]
CMP	R1, #0
IT	NE
BNE	L__atcah_mac177
; param end address is: 0 (R0)
IT	AL
BAL	L__atcah_mac170
L__atcah_mac178:
; param start address is: 0 (R0)
L__atcah_mac177:
;atca_host.c,173 :: 		|| (!(param->mode & MAC_MODE_BLOCK2_TEMPKEY) && !param->challenge)
LDRB	R1, [R0, #0]
AND	R1, R1, #1
UXTB	R1, R1
CMP	R1, #0
IT	NE
BNE	L__atcah_mac180
ADDS	R1, R0, #4
LDR	R1, [R1, #0]
CMP	R1, #0
IT	NE
BNE	L__atcah_mac179
; param end address is: 0 (R0)
IT	AL
BAL	L__atcah_mac170
L__atcah_mac180:
; param start address is: 0 (R0)
L__atcah_mac179:
;atca_host.c,174 :: 		|| ((param->mode & MAC_MODE_USE_TEMPKEY_MASK) && !param->temp_key)
LDRB	R1, [R0, #0]
AND	R1, R1, #3
UXTB	R1, R1
CMP	R1, #0
IT	EQ
BEQ	L__atcah_mac182
ADDW	R1, R0, #24
LDR	R1, [R1, #0]
CMP	R1, #0
IT	NE
BNE	L__atcah_mac181
; param end address is: 0 (R0)
IT	AL
BAL	L__atcah_mac170
L__atcah_mac182:
; param start address is: 0 (R0)
L__atcah_mac181:
;atca_host.c,175 :: 		|| (((param->mode & MAC_MODE_INCLUDE_OTP_64) || (param->mode & MAC_MODE_INCLUDE_OTP_88)) && !param->otp)
LDRB	R1, [R0, #0]
AND	R1, R1, #32
UXTB	R1, R1
CMP	R1, #0
IT	NE
BNE	L__atcah_mac184
LDRB	R1, [R0, #0]
AND	R1, R1, #16
UXTB	R1, R1
CMP	R1, #0
IT	NE
BNE	L__atcah_mac183
IT	AL
BAL	L__atcah_mac172
L__atcah_mac184:
L__atcah_mac183:
ADDW	R1, R0, #12
LDR	R1, [R1, #0]
CMP	R1, #0
IT	NE
BNE	L__atcah_mac185
; param end address is: 0 (R0)
IT	AL
BAL	L__atcah_mac170
L__atcah_mac172:
; param start address is: 0 (R0)
L__atcah_mac185:
;atca_host.c,176 :: 		|| ((param->mode & MAC_MODE_INCLUDE_SN) && !param->sn)
LDRB	R1, [R0, #0]
AND	R1, R1, #64
UXTB	R1, R1
CMP	R1, #0
IT	EQ
BEQ	L__atcah_mac187
ADDW	R1, R0, #16
LDR	R1, [R1, #0]
CMP	R1, #0
IT	NE
BNE	L__atcah_mac186
; param end address is: 0 (R0)
IT	AL
BAL	L__atcah_mac170
L__atcah_mac187:
; param start address is: 0 (R0)
L__atcah_mac186:
IT	AL
BAL	L_atcah_mac34
; param end address is: 0 (R0)
;atca_host.c,177 :: 		)
L__atcah_mac170:
;atca_host.c,171 :: 		|| (param->mode & ~MAC_MODE_MASK)
L__atcah_mac189:
L__atcah_mac188:
;atca_host.c,178 :: 		return ATCA_BAD_PARAM;
MOVS	R0, #226
IT	AL
BAL	L_end_atcah_mac
L_atcah_mac34:
;atca_host.c,181 :: 		if (((param->mode & MAC_MODE_USE_TEMPKEY_MASK) != 0)
; param start address is: 0 (R0)
LDRB	R1, [R0, #0]
AND	R1, R1, #3
UXTB	R1, R1
;atca_host.c,186 :: 		|| (!(param->mode & MAC_MODE_SOURCE_FLAG_MATCH) != !(param->temp_key->source_flag)))
CMP	R1, #0
IT	EQ
BEQ	L__atcah_mac193
;atca_host.c,183 :: 		&& (param->temp_key->check_flag || (param->temp_key->valid != 1)
ADDW	R1, R0, #24
LDR	R1, [R1, #0]
ADDS	R1, #32
LDRB	R2, [R1, #0]
UBFX	R1, R2, #6, #1
CMP	R1, #0
IT	NE
BNE	L__atcah_mac192
ADDW	R1, R0, #24
LDR	R1, [R1, #0]
ADDS	R1, #32
LDRB	R2, [R1, #0]
UBFX	R1, R2, #7, #1
CMP	R1, #0
IT	EQ
BEQ	L__atcah_mac191
;atca_host.c,186 :: 		|| (!(param->mode & MAC_MODE_SOURCE_FLAG_MATCH) != !(param->temp_key->source_flag)))
LDRB	R1, [R0, #0]
AND	R1, R1, #4
UXTB	R1, R1
CMP	R1, #0
MOVW	R3, #0
BNE	L__atcah_mac295
MOVS	R3, #1
L__atcah_mac295:
UXTB	R3, R3
ADDW	R1, R0, #24
LDR	R1, [R1, #0]
ADDS	R1, #32
LDRB	R2, [R1, #0]
UBFX	R1, R2, #4, #1
EOR	R1, R1, #1
UXTB	R1, R1
CMP	R3, R1
IT	NE
BNE	L__atcah_mac190
IT	AL
BAL	L_atcah_mac39
;atca_host.c,183 :: 		&& (param->temp_key->check_flag || (param->temp_key->valid != 1)
L__atcah_mac192:
L__atcah_mac191:
;atca_host.c,186 :: 		|| (!(param->mode & MAC_MODE_SOURCE_FLAG_MATCH) != !(param->temp_key->source_flag)))
L__atcah_mac190:
;atca_host.c,187 :: 		) {
L__atcah_mac168:
;atca_host.c,189 :: 		param->temp_key->valid = 0;
ADDW	R1, R0, #24
; param end address is: 0 (R0)
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
MOVS	R2, #0
LDRB	R1, [R3, #0]
BFI	R1, R2, #7, #1
STRB	R1, [R3, #0]
;atca_host.c,190 :: 		return ATCA_EXECUTION_ERROR;
MOVS	R0, #244
IT	AL
BAL	L_end_atcah_mac
;atca_host.c,191 :: 		}
L_atcah_mac39:
;atca_host.c,186 :: 		|| (!(param->mode & MAC_MODE_SOURCE_FLAG_MATCH) != !(param->temp_key->source_flag)))
; param start address is: 0 (R0)
L__atcah_mac193:
;atca_host.c,194 :: 		p_temp = temporary;
ADD	R6, SP, #8
; p_temp start address is: 24 (R6)
;atca_host.c,197 :: 		memcpy( p_temp, param->mode & MAC_MODE_BLOCK1_TEMPKEY ? (void*)param->temp_key->value : (void*)param->key, ATCA_KEY_SIZE);                // use Key[KeyID]
LDRB	R1, [R0, #0]
AND	R1, R1, #2
UXTB	R1, R1
CMP	R1, #0
IT	EQ
BEQ	L_atcah_mac40
ADDW	R1, R0, #24
LDR	R1, [R1, #0]
; ?FLOC___atcah_mac?T533 start address is: 4 (R1)
; ?FLOC___atcah_mac?T533 end address is: 4 (R1)
IT	AL
BAL	L_atcah_mac41
L_atcah_mac40:
ADDW	R1, R0, #8
LDR	R1, [R1, #0]
; ?FLOC___atcah_mac?T533 start address is: 8 (R2)
MOV	R2, R1
; ?FLOC___atcah_mac?T533 end address is: 8 (R2)
MOV	R1, R2
L_atcah_mac41:
; ?FLOC___atcah_mac?T533 start address is: 4 (R1)
STR	R0, [SP, #4]
MOVS	R2, #32
SXTH	R2, R2
; ?FLOC___atcah_mac?T533 end address is: 4 (R1)
MOV	R0, R6
BL	_memcpy+0
LDR	R0, [SP, #4]
;atca_host.c,198 :: 		p_temp += ATCA_KEY_SIZE;
ADDS	R6, #32
;atca_host.c,201 :: 		memcpy(p_temp, param->mode & MAC_MODE_BLOCK2_TEMPKEY ? (void*)param->temp_key->value : (void*)param->challenge, ATCA_KEY_SIZE);          // use Key[KeyID]
LDRB	R1, [R0, #0]
AND	R1, R1, #1
UXTB	R1, R1
CMP	R1, #0
IT	EQ
BEQ	L_atcah_mac42
ADDW	R1, R0, #24
LDR	R1, [R1, #0]
; ?FLOC___atcah_mac?T557 start address is: 4 (R1)
; ?FLOC___atcah_mac?T557 end address is: 4 (R1)
IT	AL
BAL	L_atcah_mac43
L_atcah_mac42:
ADDS	R1, R0, #4
LDR	R1, [R1, #0]
; ?FLOC___atcah_mac?T557 start address is: 8 (R2)
MOV	R2, R1
; ?FLOC___atcah_mac?T557 end address is: 8 (R2)
MOV	R1, R2
L_atcah_mac43:
; ?FLOC___atcah_mac?T557 start address is: 4 (R1)
STR	R0, [SP, #4]
MOVS	R2, #32
SXTH	R2, R2
; ?FLOC___atcah_mac?T557 end address is: 4 (R1)
MOV	R0, R6
BL	_memcpy+0
LDR	R0, [SP, #4]
;atca_host.c,202 :: 		p_temp += ATCA_KEY_SIZE;
ADDW	R2, R6, #32
; p_temp end address is: 24 (R6)
; p_temp start address is: 12 (R3)
MOV	R3, R2
;atca_host.c,205 :: 		*p_temp++ = ATCA_MAC;
MOVS	R1, #8
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,208 :: 		*p_temp++ = param->mode;
LDRB	R1, [R0, #0]
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,211 :: 		*p_temp++ = param->key_id & 0xFF;
ADDS	R1, R0, #2
LDRH	R1, [R1, #0]
AND	R1, R1, #255
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,212 :: 		*p_temp++ = (param->key_id >> 8) & 0xFF;
ADDS	R1, R0, #2
LDRH	R1, [R1, #0]
LSRS	R1, R1, #8
UXTH	R1, R1
AND	R1, R1, #255
STRB	R1, [R2, #0]
ADDS	R1, R3, #1
; p_temp end address is: 12 (R3)
;atca_host.c,214 :: 		include_data.p_temp = p_temp;
STR	R1, [SP, #96]
;atca_host.c,215 :: 		atcah_include_data(&include_data);
ADD	R1, SP, #96
STR	R0, [SP, #4]
MOV	R0, R1
BL	_atcah_include_data+0
LDR	R0, [SP, #4]
;atca_host.c,218 :: 		atcah_sha256(ATCA_MSG_SIZE_MAC, temporary, param->response);
ADDW	R1, R0, #20
LDR	R1, [R1, #0]
MOV	R2, R1
ADD	R1, SP, #8
STR	R0, [SP, #4]
MOVS	R0, #88
BL	_atcah_sha256+0
LDR	R0, [SP, #4]
;atca_host.c,221 :: 		if (param->temp_key)
ADDW	R1, R0, #24
LDR	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L_atcah_mac44
;atca_host.c,222 :: 		param->temp_key->valid = 0;
ADDW	R1, R0, #24
; param end address is: 0 (R0)
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
MOVS	R2, #0
LDRB	R1, [R3, #0]
BFI	R1, R2, #7, #1
STRB	R1, [R3, #0]
L_atcah_mac44:
;atca_host.c,224 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_host.c,225 :: 		}
L_end_atcah_mac:
LDR	LR, [SP, #0]
ADD	SP, SP, #112
BX	LR
; end of _atcah_mac
_atcah_check_mac:
;atca_host.c,249 :: 		ATCA_STATUS atcah_check_mac(struct atca_check_mac_in_out *param)
; param start address is: 0 (R0)
SUB	SP, SP, #100
STR	LR, [SP, #0]
; param end address is: 0 (R0)
; param start address is: 0 (R0)
;atca_host.c,255 :: 		if (((param->mode & MAC_MODE_USE_TEMPKEY_MASK) != MAC_MODE_BLOCK2_TEMPKEY)
LDRB	R1, [R0, #0]
AND	R1, R1, #3
UXTB	R1, R1
;atca_host.c,256 :: 		|| !param->password || !param->other_data
CMP	R1, #1
IT	NE
BNE	L__atcah_check_mac204
ADDS	R1, R0, #4
LDR	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L__atcah_check_mac203
ADDW	R1, R0, #8
LDR	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L__atcah_check_mac202
;atca_host.c,257 :: 		|| !param->target_key || !param->client_resp || !param->temp_key
ADDW	R1, R0, #16
LDR	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L__atcah_check_mac201
ADDW	R1, R0, #20
LDR	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L__atcah_check_mac200
ADDW	R1, R0, #24
LDR	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L__atcah_check_mac199
;atca_host.c,258 :: 		|| ((param->mode & MAC_MODE_INCLUDE_OTP_64) && !param->otp)
LDRB	R1, [R0, #0]
AND	R1, R1, #32
UXTB	R1, R1
CMP	R1, #0
IT	EQ
BEQ	L__atcah_check_mac198
ADDW	R1, R0, #12
LDR	R1, [R1, #0]
CMP	R1, #0
IT	NE
BNE	L__atcah_check_mac197
; param end address is: 0 (R0)
IT	AL
BAL	L__atcah_check_mac195
L__atcah_check_mac198:
; param start address is: 0 (R0)
L__atcah_check_mac197:
IT	AL
BAL	L_atcah_check_mac49
; param end address is: 0 (R0)
;atca_host.c,259 :: 		)
L__atcah_check_mac195:
;atca_host.c,256 :: 		|| !param->password || !param->other_data
L__atcah_check_mac204:
L__atcah_check_mac203:
L__atcah_check_mac202:
;atca_host.c,257 :: 		|| !param->target_key || !param->client_resp || !param->temp_key
L__atcah_check_mac201:
L__atcah_check_mac200:
L__atcah_check_mac199:
;atca_host.c,260 :: 		return ATCA_BAD_PARAM;
MOVS	R0, #226
IT	AL
BAL	L_end_atcah_check_mac
L_atcah_check_mac49:
;atca_host.c,264 :: 		if (param->temp_key->check_flag || (param->temp_key->valid != 1) || param->temp_key->source_flag) {
; param start address is: 0 (R0)
ADDW	R1, R0, #24
LDR	R1, [R1, #0]
ADDS	R1, #32
LDRB	R2, [R1, #0]
UBFX	R1, R2, #6, #1
CMP	R1, #0
IT	NE
BNE	L__atcah_check_mac207
ADDW	R1, R0, #24
LDR	R1, [R1, #0]
ADDS	R1, #32
LDRB	R2, [R1, #0]
UBFX	R1, R2, #7, #1
CMP	R1, #0
IT	EQ
BEQ	L__atcah_check_mac206
ADDW	R1, R0, #24
LDR	R1, [R1, #0]
ADDS	R1, #32
LDRB	R2, [R1, #0]
UBFX	R1, R2, #4, #1
CMP	R1, #0
IT	NE
BNE	L__atcah_check_mac205
IT	AL
BAL	L_atcah_check_mac52
L__atcah_check_mac207:
L__atcah_check_mac206:
L__atcah_check_mac205:
;atca_host.c,266 :: 		param->temp_key->valid = 0;
ADDW	R1, R0, #24
; param end address is: 0 (R0)
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
MOVS	R2, #0
LDRB	R1, [R3, #0]
BFI	R1, R2, #7, #1
STRB	R1, [R3, #0]
;atca_host.c,267 :: 		return ATCA_EXECUTION_ERROR;
MOVS	R0, #244
IT	AL
BAL	L_end_atcah_check_mac
;atca_host.c,268 :: 		}
L_atcah_check_mac52:
;atca_host.c,271 :: 		p_temp = temporary;
; param start address is: 0 (R0)
ADD	R2, SP, #12
; p_temp start address is: 24 (R6)
MOV	R6, R2
;atca_host.c,274 :: 		memcpy(p_temp, param->password, ATCA_KEY_SIZE);           // password to be checked
ADDS	R1, R0, #4
LDR	R1, [R1, #0]
STR	R0, [SP, #4]
MOV	R0, R2
MOVS	R2, #32
SXTH	R2, R2
BL	_memcpy+0
LDR	R0, [SP, #4]
;atca_host.c,275 :: 		p_temp += ATCA_KEY_SIZE;
ADDW	R2, R6, #32
MOV	R6, R2
;atca_host.c,278 :: 		memcpy(p_temp, param->temp_key->value, ATCA_KEY_SIZE);    // use TempKey.Value
ADDW	R1, R0, #24
LDR	R1, [R1, #0]
STR	R0, [SP, #4]
MOV	R0, R2
MOVS	R2, #32
SXTH	R2, R2
BL	_memcpy+0
LDR	R0, [SP, #4]
;atca_host.c,279 :: 		p_temp += ATCA_KEY_SIZE;
ADDW	R2, R6, #32
MOV	R6, R2
;atca_host.c,282 :: 		memcpy(p_temp, &param->other_data[0], ATCA_OTHER_DATA_SIZE_4);
ADDW	R1, R0, #8
LDR	R1, [R1, #0]
STR	R0, [SP, #4]
MOV	R0, R2
MOVS	R2, #4
SXTH	R2, R2
BL	_memcpy+0
LDR	R0, [SP, #4]
;atca_host.c,283 :: 		p_temp += ATCA_OTHER_DATA_SIZE_4;
ADDS	R3, R6, #4
; p_temp end address is: 24 (R6)
; p_temp start address is: 12 (R3)
;atca_host.c,286 :: 		if (param->mode & MAC_MODE_INCLUDE_OTP_64)
LDRB	R1, [R0, #0]
AND	R1, R1, #32
UXTB	R1, R1
CMP	R1, #0
IT	EQ
BEQ	L_atcah_check_mac53
;atca_host.c,287 :: 		memcpy(p_temp, param->otp, ATCA_OTP_SIZE_8);    // use 8 bytes OTP[0:7] for (6)
ADDW	R1, R0, #12
LDR	R1, [R1, #0]
STR	R3, [SP, #4]
STR	R0, [SP, #8]
MOVS	R2, #8
SXTH	R2, R2
MOV	R0, R3
BL	_memcpy+0
LDR	R0, [SP, #8]
LDR	R3, [SP, #4]
IT	AL
BAL	L_atcah_check_mac54
L_atcah_check_mac53:
;atca_host.c,289 :: 		memset(p_temp, 0, ATCA_OTP_SIZE_8);             // use 8 zeros for (6)
STR	R3, [SP, #4]
STR	R0, [SP, #8]
MOVS	R2, #8
SXTH	R2, R2
MOVS	R1, #0
MOV	R0, R3
BL	_memset+0
LDR	R0, [SP, #8]
LDR	R3, [SP, #4]
L_atcah_check_mac54:
;atca_host.c,290 :: 		p_temp += ATCA_OTP_SIZE_8;
ADDW	R2, R3, #8
; p_temp end address is: 12 (R3)
; p_temp start address is: 24 (R6)
MOV	R6, R2
;atca_host.c,293 :: 		memcpy(p_temp, &param->other_data[ATCA_OTHER_DATA_SIZE_4], ATCA_OTHER_DATA_SIZE_3);  // use OtherData[4:6] for (7)
ADDW	R1, R0, #8
LDR	R1, [R1, #0]
ADDS	R1, R1, #4
STR	R0, [SP, #4]
MOV	R0, R2
MOVS	R2, #3
SXTH	R2, R2
BL	_memcpy+0
LDR	R0, [SP, #4]
;atca_host.c,294 :: 		p_temp += ATCA_OTHER_DATA_SIZE_3;
ADDS	R2, R6, #3
; p_temp end address is: 24 (R6)
; p_temp start address is: 12 (R3)
MOV	R3, R2
;atca_host.c,297 :: 		*p_temp++ = ATCA_SN_8;
MOVS	R1, #238
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
; p_temp end address is: 12 (R3)
; p_temp start address is: 24 (R6)
MOV	R6, R2
;atca_host.c,300 :: 		memcpy(p_temp, &param->other_data[ATCA_OTHER_DATA_SIZE_4 + ATCA_OTHER_DATA_SIZE_3], ATCA_OTHER_DATA_SIZE_4);  // use OtherData[7:10] for (9)
ADDW	R1, R0, #8
LDR	R1, [R1, #0]
ADDS	R1, R1, #7
STR	R0, [SP, #4]
MOV	R0, R2
MOVS	R2, #4
SXTH	R2, R2
BL	_memcpy+0
LDR	R0, [SP, #4]
;atca_host.c,301 :: 		p_temp += ATCA_OTHER_DATA_SIZE_4;
ADDS	R2, R6, #4
; p_temp end address is: 24 (R6)
; p_temp start address is: 12 (R3)
MOV	R3, R2
;atca_host.c,304 :: 		*p_temp++ = ATCA_SN_0;
MOVS	R1, #1
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,305 :: 		*p_temp++ = ATCA_SN_1;
MOVS	R1, #35
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
; p_temp end address is: 12 (R3)
;atca_host.c,308 :: 		memcpy(p_temp, &param->other_data[ATCA_OTHER_DATA_SIZE_4 + ATCA_OTHER_DATA_SIZE_3 + ATCA_OTHER_DATA_SIZE_2],
ADDW	R1, R0, #8
LDR	R1, [R1, #0]
ADDS	R1, #9
;atca_host.c,309 :: 		ATCA_OTHER_DATA_SIZE_2);  // use OtherData[11:12] for (11)
STR	R0, [SP, #4]
;atca_host.c,308 :: 		memcpy(p_temp, &param->other_data[ATCA_OTHER_DATA_SIZE_4 + ATCA_OTHER_DATA_SIZE_3 + ATCA_OTHER_DATA_SIZE_2],
MOV	R0, R2
;atca_host.c,309 :: 		ATCA_OTHER_DATA_SIZE_2);  // use OtherData[11:12] for (11)
MOVS	R2, #2
SXTH	R2, R2
BL	_memcpy+0
LDR	R0, [SP, #4]
;atca_host.c,313 :: 		atcah_sha256(ATCA_MSG_SIZE_MAC, temporary, param->client_resp);
ADDW	R1, R0, #20
LDR	R1, [R1, #0]
MOV	R2, R1
ADD	R1, SP, #12
STR	R0, [SP, #4]
MOVS	R0, #88
BL	_atcah_sha256+0
LDR	R0, [SP, #4]
;atca_host.c,316 :: 		memcpy(param->temp_key->value, param->target_key, ATCA_KEY_SIZE);
ADDW	R1, R0, #16
LDR	R1, [R1, #0]
MOV	R2, R1
ADDW	R1, R0, #24
LDR	R1, [R1, #0]
STR	R0, [SP, #4]
MOV	R0, R1
MOV	R1, R2
MOVS	R2, #32
SXTH	R2, R2
BL	_memcpy+0
LDR	R0, [SP, #4]
;atca_host.c,317 :: 		param->temp_key->gen_data = 0;
ADDW	R1, R0, #24
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
MOVS	R2, #0
LDRB	R1, [R3, #0]
BFI	R1, R2, #5, #1
STRB	R1, [R3, #0]
;atca_host.c,318 :: 		param->temp_key->source_flag = 1;
ADDW	R1, R0, #24
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
MOVS	R2, #1
LDRB	R1, [R3, #0]
BFI	R1, R2, #4, #1
STRB	R1, [R3, #0]
;atca_host.c,319 :: 		param->temp_key->valid = 1;
ADDW	R1, R0, #24
; param end address is: 0 (R0)
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
MOVS	R2, #1
LDRB	R1, [R3, #0]
BFI	R1, R2, #7, #1
STRB	R1, [R3, #0]
;atca_host.c,321 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_host.c,322 :: 		}
L_end_atcah_check_mac:
LDR	LR, [SP, #0]
ADD	SP, SP, #100
BX	LR
; end of _atcah_check_mac
_atcah_hmac:
;atca_host.c,333 :: 		ATCA_STATUS atcah_hmac(struct atca_hmac_in_out *param)
; param start address is: 0 (R0)
SUB	SP, SP, #180
STR	LR, [SP, #0]
; param end address is: 0 (R0)
; param start address is: 0 (R0)
;atca_host.c,342 :: 		include_data.otp = param->otp;
ADDW	R1, R0, #8
LDR	R1, [R1, #0]
STR	R1, [SP, #16]
;atca_host.c,343 :: 		include_data.sn = param->sn;
ADDW	R1, R0, #12
LDR	R1, [R1, #0]
STR	R1, [SP, #20]
;atca_host.c,344 :: 		include_data.mode = param->mode;
LDRB	R1, [R0, #0]
STRB	R1, [SP, #24]
;atca_host.c,347 :: 		if (!param->response || !param->key || !param->temp_key
ADDW	R1, R0, #16
LDR	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L__atcah_hmac221
ADDS	R1, R0, #4
LDR	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L__atcah_hmac220
ADDW	R1, R0, #20
LDR	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L__atcah_hmac219
;atca_host.c,348 :: 		|| (param->mode & ~HMAC_MODE_MASK)
LDRB	R1, [R0, #0]
AND	R1, R1, #139
UXTB	R1, R1
CMP	R1, #0
IT	NE
BNE	L__atcah_hmac218
;atca_host.c,349 :: 		|| (((param->mode & MAC_MODE_INCLUDE_OTP_64) || (param->mode & MAC_MODE_INCLUDE_OTP_88)) && !param->otp)
LDRB	R1, [R0, #0]
AND	R1, R1, #32
UXTB	R1, R1
CMP	R1, #0
IT	NE
BNE	L__atcah_hmac214
LDRB	R1, [R0, #0]
AND	R1, R1, #16
UXTB	R1, R1
CMP	R1, #0
IT	NE
BNE	L__atcah_hmac213
IT	AL
BAL	L__atcah_hmac211
L__atcah_hmac214:
L__atcah_hmac213:
ADDW	R1, R0, #8
LDR	R1, [R1, #0]
CMP	R1, #0
IT	NE
BNE	L__atcah_hmac215
; param end address is: 0 (R0)
IT	AL
BAL	L__atcah_hmac209
L__atcah_hmac211:
; param start address is: 0 (R0)
L__atcah_hmac215:
;atca_host.c,350 :: 		|| ((param->mode & MAC_MODE_INCLUDE_SN) && !param->sn)
LDRB	R1, [R0, #0]
AND	R1, R1, #64
UXTB	R1, R1
CMP	R1, #0
IT	EQ
BEQ	L__atcah_hmac217
ADDW	R1, R0, #12
LDR	R1, [R1, #0]
CMP	R1, #0
IT	NE
BNE	L__atcah_hmac216
; param end address is: 0 (R0)
IT	AL
BAL	L__atcah_hmac209
L__atcah_hmac217:
; param start address is: 0 (R0)
L__atcah_hmac216:
IT	AL
BAL	L_atcah_hmac63
; param end address is: 0 (R0)
;atca_host.c,351 :: 		)
L__atcah_hmac209:
;atca_host.c,347 :: 		if (!param->response || !param->key || !param->temp_key
L__atcah_hmac221:
L__atcah_hmac220:
L__atcah_hmac219:
;atca_host.c,348 :: 		|| (param->mode & ~HMAC_MODE_MASK)
L__atcah_hmac218:
;atca_host.c,352 :: 		return ATCA_BAD_PARAM;
MOVS	R0, #226
IT	AL
BAL	L_end_atcah_hmac
L_atcah_hmac63:
;atca_host.c,356 :: 		param->temp_key->check_flag || (param->temp_key->valid != 1)
; param start address is: 0 (R0)
ADDW	R1, R0, #20
LDR	R1, [R1, #0]
ADDS	R1, #32
LDRB	R2, [R1, #0]
UBFX	R1, R2, #6, #1
CMP	R1, #0
IT	NE
BNE	L__atcah_hmac224
ADDW	R1, R0, #20
LDR	R1, [R1, #0]
ADDS	R1, #32
LDRB	R2, [R1, #0]
UBFX	R1, R2, #7, #1
CMP	R1, #0
IT	EQ
BEQ	L__atcah_hmac223
;atca_host.c,359 :: 		|| (!(param->mode & MAC_MODE_SOURCE_FLAG_MATCH) != !(param->temp_key->source_flag))
LDRB	R1, [R0, #0]
AND	R1, R1, #4
UXTB	R1, R1
CMP	R1, #0
MOVW	R3, #0
BNE	L__atcah_hmac298
MOVS	R3, #1
L__atcah_hmac298:
UXTB	R3, R3
ADDW	R1, R0, #20
LDR	R1, [R1, #0]
ADDS	R1, #32
LDRB	R2, [R1, #0]
UBFX	R1, R2, #4, #1
EOR	R1, R1, #1
UXTB	R1, R1
CMP	R3, R1
IT	NE
BNE	L__atcah_hmac222
IT	AL
BAL	L_atcah_hmac66
;atca_host.c,356 :: 		param->temp_key->check_flag || (param->temp_key->valid != 1)
L__atcah_hmac224:
L__atcah_hmac223:
;atca_host.c,359 :: 		|| (!(param->mode & MAC_MODE_SOURCE_FLAG_MATCH) != !(param->temp_key->source_flag))
L__atcah_hmac222:
;atca_host.c,362 :: 		param->temp_key->valid = 0;
ADDW	R1, R0, #20
; param end address is: 0 (R0)
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
MOVS	R2, #0
LDRB	R1, [R3, #0]
BFI	R1, R2, #7, #1
STRB	R1, [R3, #0]
;atca_host.c,363 :: 		return ATCA_EXECUTION_ERROR;
MOVS	R0, #244
IT	AL
BAL	L_end_atcah_hmac
;atca_host.c,364 :: 		}
L_atcah_hmac66:
;atca_host.c,367 :: 		p_temp = temporary;
; param start address is: 0 (R0)
ADD	R3, SP, #28
; p_temp start address is: 12 (R3)
;atca_host.c,372 :: 		for (i = 0; i < ATCA_KEY_SIZE; i++)
; i start address is: 8 (R2)
MOVS	R2, #0
; param end address is: 0 (R0)
; p_temp end address is: 12 (R3)
; i end address is: 8 (R2)
L_atcah_hmac67:
; i start address is: 8 (R2)
; p_temp start address is: 12 (R3)
; param start address is: 0 (R0)
CMP	R2, #32
IT	CS
BCS	L_atcah_hmac68
;atca_host.c,373 :: 		*p_temp++ = param->key[i] ^ 0x36;
ADDS	R1, R0, #4
LDR	R1, [R1, #0]
ADDS	R1, R1, R2
LDRB	R1, [R1, #0]
EOR	R1, R1, #54
STRB	R1, [R3, #0]
ADDS	R3, R3, #1
;atca_host.c,372 :: 		for (i = 0; i < ATCA_KEY_SIZE; i++)
ADDS	R2, R2, #1
UXTB	R2, R2
;atca_host.c,373 :: 		*p_temp++ = param->key[i] ^ 0x36;
; i end address is: 8 (R2)
IT	AL
BAL	L_atcah_hmac67
L_atcah_hmac68:
;atca_host.c,376 :: 		for (i = 0; i < HMAC_BLOCK_SIZE - ATCA_KEY_SIZE; i++)
; i start address is: 8 (R2)
MOVS	R2, #0
; param end address is: 0 (R0)
; p_temp end address is: 12 (R3)
; i end address is: 8 (R2)
L_atcah_hmac70:
; i start address is: 8 (R2)
; param start address is: 0 (R0)
; p_temp start address is: 12 (R3)
CMP	R2, #32
IT	GE
BGE	L_atcah_hmac71
;atca_host.c,377 :: 		*p_temp++ = 0 ^ 0x36;
MOVS	R1, #54
STRB	R1, [R3, #0]
ADDS	R3, R3, #1
;atca_host.c,376 :: 		for (i = 0; i < HMAC_BLOCK_SIZE - ATCA_KEY_SIZE; i++)
ADDS	R2, R2, #1
UXTB	R2, R2
;atca_host.c,377 :: 		*p_temp++ = 0 ^ 0x36;
; i end address is: 8 (R2)
IT	AL
BAL	L_atcah_hmac70
L_atcah_hmac71:
;atca_host.c,381 :: 		memset(p_temp, 0, HMAC_BLOCK_SIZE - ATCA_KEY_SIZE);
STR	R3, [SP, #4]
STR	R0, [SP, #8]
MOVW	R2, #32
SXTH	R2, R2
MOVS	R1, #0
MOV	R0, R3
BL	_memset+0
LDR	R0, [SP, #8]
LDR	R3, [SP, #4]
;atca_host.c,382 :: 		p_temp += HMAC_BLOCK_SIZE - ATCA_KEY_SIZE;
ADDW	R2, R3, #32
; p_temp end address is: 12 (R3)
; p_temp start address is: 24 (R6)
MOV	R6, R2
;atca_host.c,385 :: 		memcpy(p_temp, param->temp_key->value, ATCA_KEY_SIZE);
ADDW	R1, R0, #20
LDR	R1, [R1, #0]
STR	R0, [SP, #4]
MOV	R0, R2
MOVS	R2, #32
SXTH	R2, R2
BL	_memcpy+0
LDR	R0, [SP, #4]
;atca_host.c,386 :: 		p_temp += ATCA_KEY_SIZE;
ADDW	R2, R6, #32
; p_temp end address is: 24 (R6)
; p_temp start address is: 12 (R3)
MOV	R3, R2
;atca_host.c,389 :: 		*p_temp++ = ATCA_HMAC;
MOVS	R1, #17
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,392 :: 		*p_temp++ = param->mode;
LDRB	R1, [R0, #0]
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,395 :: 		*p_temp++ = param->key_id & 0xFF;
ADDS	R1, R0, #2
LDRH	R1, [R1, #0]
AND	R1, R1, #255
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
; p_temp end address is: 12 (R3)
;atca_host.c,396 :: 		*p_temp++ = (param->key_id >> 8) & 0xFF;
ADDS	R1, R0, #2
LDRH	R1, [R1, #0]
LSRS	R1, R1, #8
UXTH	R1, R1
AND	R1, R1, #255
STRB	R1, [R2, #0]
;atca_host.c,400 :: 		atcah_sha256(ATCA_MSG_SIZE_HMAC_INNER, temporary, param->response);
ADDW	R1, R0, #16
LDR	R1, [R1, #0]
MOV	R2, R1
ADD	R1, SP, #28
STR	R0, [SP, #4]
MOVS	R0, #152
BL	_atcah_sha256+0
LDR	R0, [SP, #4]
;atca_host.c,403 :: 		p_temp = temporary;
ADD	R3, SP, #28
; p_temp start address is: 12 (R3)
;atca_host.c,406 :: 		for (i = 0; i < ATCA_KEY_SIZE; i++)
; i start address is: 8 (R2)
MOVS	R2, #0
; param end address is: 0 (R0)
; p_temp end address is: 12 (R3)
; i end address is: 8 (R2)
L_atcah_hmac73:
; i start address is: 8 (R2)
; p_temp start address is: 12 (R3)
; param start address is: 0 (R0)
CMP	R2, #32
IT	CS
BCS	L_atcah_hmac74
;atca_host.c,407 :: 		*p_temp++ = param->key[i] ^ 0x5C;
ADDS	R1, R0, #4
LDR	R1, [R1, #0]
ADDS	R1, R1, R2
LDRB	R1, [R1, #0]
EOR	R1, R1, #92
STRB	R1, [R3, #0]
ADDS	R3, R3, #1
;atca_host.c,406 :: 		for (i = 0; i < ATCA_KEY_SIZE; i++)
ADDS	R2, R2, #1
UXTB	R2, R2
;atca_host.c,407 :: 		*p_temp++ = param->key[i] ^ 0x5C;
; i end address is: 8 (R2)
IT	AL
BAL	L_atcah_hmac73
L_atcah_hmac74:
;atca_host.c,410 :: 		for (i = 0; i < HMAC_BLOCK_SIZE - ATCA_KEY_SIZE; i++)
; i start address is: 8 (R2)
MOVS	R2, #0
; param end address is: 0 (R0)
; p_temp end address is: 12 (R3)
; i end address is: 8 (R2)
L_atcah_hmac76:
; i start address is: 8 (R2)
; param start address is: 0 (R0)
; p_temp start address is: 12 (R3)
CMP	R2, #32
IT	GE
BGE	L_atcah_hmac77
;atca_host.c,411 :: 		*p_temp++ = 0 ^ 0x5C;
MOVS	R1, #92
STRB	R1, [R3, #0]
ADDS	R3, R3, #1
;atca_host.c,410 :: 		for (i = 0; i < HMAC_BLOCK_SIZE - ATCA_KEY_SIZE; i++)
ADDS	R2, R2, #1
UXTB	R2, R2
;atca_host.c,411 :: 		*p_temp++ = 0 ^ 0x5C;
; i end address is: 8 (R2)
IT	AL
BAL	L_atcah_hmac76
L_atcah_hmac77:
;atca_host.c,414 :: 		memcpy(p_temp, param->response, ATCA_KEY_SIZE);
ADDW	R1, R0, #16
LDR	R1, [R1, #0]
STR	R3, [SP, #4]
STR	R0, [SP, #8]
MOVS	R2, #32
SXTH	R2, R2
MOV	R0, R3
BL	_memcpy+0
LDR	R0, [SP, #8]
LDR	R3, [SP, #4]
;atca_host.c,415 :: 		p_temp += ATCA_KEY_SIZE;
ADDW	R1, R3, #32
; p_temp end address is: 12 (R3)
;atca_host.c,417 :: 		include_data.p_temp = p_temp;
STR	R1, [SP, #12]
;atca_host.c,418 :: 		atcah_include_data(&include_data);
ADD	R1, SP, #12
STR	R0, [SP, #4]
MOV	R0, R1
BL	_atcah_include_data+0
LDR	R0, [SP, #4]
;atca_host.c,421 :: 		atcah_sha256(ATCA_MSG_SIZE_HMAC, temporary, param->response);
ADDW	R1, R0, #16
LDR	R1, [R1, #0]
MOV	R2, R1
ADD	R1, SP, #28
STR	R0, [SP, #4]
MOVS	R0, #96
BL	_atcah_sha256+0
LDR	R0, [SP, #4]
;atca_host.c,424 :: 		param->temp_key->valid = 0;
ADDW	R1, R0, #20
; param end address is: 0 (R0)
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
MOVS	R2, #0
LDRB	R1, [R3, #0]
BFI	R1, R2, #7, #1
STRB	R1, [R3, #0]
;atca_host.c,426 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_host.c,427 :: 		}
L_end_atcah_hmac:
LDR	LR, [SP, #0]
ADD	SP, SP, #180
BX	LR
; end of _atcah_hmac
_atcah_gen_dig:
;atca_host.c,443 :: 		ATCA_STATUS atcah_gen_dig(struct atca_gen_dig_in_out *param)
; param start address is: 0 (R0)
SUB	SP, SP, #104
STR	LR, [SP, #0]
; param end address is: 0 (R0)
; param start address is: 0 (R0)
;atca_host.c,449 :: 		if (!param->stored_value || !param->temp_key
ADDS	R1, R0, #4
LDR	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L__atcah_gen_dig233
ADDW	R1, R0, #8
LDR	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L__atcah_gen_dig232
;atca_host.c,450 :: 		|| ((param->zone != GENDIG_ZONE_OTP)
LDRB	R1, [R0, #0]
;atca_host.c,451 :: 		&& (param->zone != GENDIG_ZONE_DATA)
CMP	R1, #1
IT	EQ
BEQ	L__atcah_gen_dig231
LDRB	R1, [R0, #0]
CMP	R1, #2
IT	EQ
BEQ	L__atcah_gen_dig230
;atca_host.c,452 :: 		&& (param->zone != GENDIG_ZONE_CONFIG))
LDRB	R1, [R0, #0]
CMP	R1, #0
IT	EQ
BEQ	L__atcah_gen_dig229
; param end address is: 0 (R0)
IT	AL
BAL	L__atcah_gen_dig227
;atca_host.c,451 :: 		&& (param->zone != GENDIG_ZONE_DATA)
L__atcah_gen_dig231:
; param start address is: 0 (R0)
L__atcah_gen_dig230:
;atca_host.c,452 :: 		&& (param->zone != GENDIG_ZONE_CONFIG))
L__atcah_gen_dig229:
IT	AL
BAL	L_atcah_gen_dig83
; param end address is: 0 (R0)
;atca_host.c,453 :: 		)
L__atcah_gen_dig227:
;atca_host.c,449 :: 		if (!param->stored_value || !param->temp_key
L__atcah_gen_dig233:
L__atcah_gen_dig232:
;atca_host.c,454 :: 		return ATCA_BAD_PARAM;
MOVS	R0, #226
IT	AL
BAL	L_end_atcah_gen_dig
L_atcah_gen_dig83:
;atca_host.c,458 :: 		param->temp_key->check_flag || (param->temp_key->valid != 1)
; param start address is: 0 (R0)
ADDW	R1, R0, #8
LDR	R1, [R1, #0]
ADDS	R1, #32
LDRB	R2, [R1, #0]
UBFX	R1, R2, #6, #1
CMP	R1, #0
IT	NE
BNE	L__atcah_gen_dig235
ADDW	R1, R0, #8
LDR	R1, [R1, #0]
ADDS	R1, #32
LDRB	R2, [R1, #0]
UBFX	R1, R2, #7, #1
CMP	R1, #0
IT	EQ
BEQ	L__atcah_gen_dig234
IT	AL
BAL	L_atcah_gen_dig86
L__atcah_gen_dig235:
L__atcah_gen_dig234:
;atca_host.c,461 :: 		param->temp_key->valid = 0;
ADDW	R1, R0, #8
; param end address is: 0 (R0)
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
MOVS	R2, #0
LDRB	R1, [R3, #0]
BFI	R1, R2, #7, #1
STRB	R1, [R3, #0]
;atca_host.c,462 :: 		return ATCA_EXECUTION_ERROR;
MOVS	R0, #244
IT	AL
BAL	L_end_atcah_gen_dig
;atca_host.c,463 :: 		}
L_atcah_gen_dig86:
;atca_host.c,466 :: 		p_temp = temporary;
; param start address is: 0 (R0)
ADD	R2, SP, #8
; p_temp start address is: 24 (R6)
MOV	R6, R2
;atca_host.c,470 :: 		memcpy(p_temp, param->stored_value, ATCA_KEY_SIZE);
ADDS	R1, R0, #4
LDR	R1, [R1, #0]
STR	R0, [SP, #4]
MOV	R0, R2
MOVS	R2, #32
SXTH	R2, R2
BL	_memcpy+0
LDR	R0, [SP, #4]
;atca_host.c,471 :: 		p_temp += ATCA_KEY_SIZE;
ADDW	R2, R6, #32
; p_temp end address is: 24 (R6)
; p_temp start address is: 12 (R3)
MOV	R3, R2
;atca_host.c,474 :: 		*p_temp++ = ATCA_GENDIG;
MOVS	R1, #21
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,477 :: 		*p_temp++ = param->zone;
LDRB	R1, [R0, #0]
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,480 :: 		*p_temp++ = param->key_id & 0xFF;
ADDS	R1, R0, #2
LDRH	R1, [R1, #0]
AND	R1, R1, #255
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,481 :: 		*p_temp++ = (param->key_id >> 8) & 0xFF;
ADDS	R1, R0, #2
LDRH	R1, [R1, #0]
LSRS	R1, R1, #8
UXTH	R1, R1
AND	R1, R1, #255
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,484 :: 		*p_temp++ = ATCA_SN_8;
MOVS	R1, #238
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,487 :: 		*p_temp++ = ATCA_SN_0;
MOVS	R1, #1
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,488 :: 		*p_temp++ = ATCA_SN_1;
MOVS	R1, #35
STRB	R1, [R2, #0]
ADDS	R1, R3, #1
; p_temp end address is: 12 (R3)
; p_temp start address is: 24 (R6)
MOV	R6, R1
;atca_host.c,491 :: 		memset(p_temp, 0, ATCA_GENDIG_ZEROS_SIZE);
STR	R0, [SP, #4]
MOVS	R2, #25
SXTH	R2, R2
MOV	R0, R1
MOVS	R1, #0
BL	_memset+0
LDR	R0, [SP, #4]
;atca_host.c,492 :: 		p_temp += ATCA_GENDIG_ZEROS_SIZE;
ADDW	R2, R6, #25
; p_temp end address is: 24 (R6)
;atca_host.c,495 :: 		memcpy(p_temp, param->temp_key->value, ATCA_KEY_SIZE);
ADDW	R1, R0, #8
LDR	R1, [R1, #0]
STR	R0, [SP, #4]
MOV	R0, R2
MOVS	R2, #32
SXTH	R2, R2
BL	_memcpy+0
LDR	R0, [SP, #4]
;atca_host.c,498 :: 		atcah_sha256(ATCA_MSG_SIZE_GEN_DIG, temporary, param->temp_key->value);
ADDW	R1, R0, #8
LDR	R2, [R1, #0]
ADD	R1, SP, #8
STR	R0, [SP, #4]
MOVS	R0, #96
BL	_atcah_sha256+0
LDR	R0, [SP, #4]
;atca_host.c,501 :: 		param->temp_key->valid = 1;
ADDW	R1, R0, #8
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
MOVS	R2, #1
LDRB	R1, [R3, #0]
BFI	R1, R2, #7, #1
STRB	R1, [R3, #0]
;atca_host.c,503 :: 		if ((param->zone == GENDIG_ZONE_DATA) && (param->key_id <= 15)) {
LDRB	R1, [R0, #0]
CMP	R1, #2
IT	NE
BNE	L__atcah_gen_dig237
ADDS	R1, R0, #2
LDRH	R1, [R1, #0]
CMP	R1, #15
IT	HI
BHI	L__atcah_gen_dig236
L__atcah_gen_dig225:
;atca_host.c,504 :: 		param->temp_key->gen_data = 1;
ADDW	R1, R0, #8
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
MOVS	R2, #1
LDRB	R1, [R3, #0]
BFI	R1, R2, #5, #1
STRB	R1, [R3, #0]
;atca_host.c,505 :: 		param->temp_key->key_id = (param->key_id & 0xF);    // mask lower 4-bit only
ADDW	R1, R0, #8
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
ADDS	R1, R0, #2
; param end address is: 0 (R0)
LDRH	R1, [R1, #0]
AND	R1, R1, #15
UXTB	R2, R1
LDRB	R1, [R3, #0]
BFI	R1, R2, #0, #4
STRB	R1, [R3, #0]
;atca_host.c,506 :: 		}else {
IT	AL
BAL	L_atcah_gen_dig90
;atca_host.c,503 :: 		if ((param->zone == GENDIG_ZONE_DATA) && (param->key_id <= 15)) {
L__atcah_gen_dig237:
; param start address is: 0 (R0)
L__atcah_gen_dig236:
;atca_host.c,507 :: 		param->temp_key->gen_data = 0;
ADDW	R1, R0, #8
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
MOVS	R2, #0
LDRB	R1, [R3, #0]
BFI	R1, R2, #5, #1
STRB	R1, [R3, #0]
;atca_host.c,508 :: 		param->temp_key->key_id = 0;
ADDW	R1, R0, #8
; param end address is: 0 (R0)
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
MOVS	R2, #0
LDRB	R1, [R3, #0]
BFI	R1, R2, #0, #4
STRB	R1, [R3, #0]
;atca_host.c,509 :: 		}
L_atcah_gen_dig90:
;atca_host.c,511 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_host.c,512 :: 		}
L_end_atcah_gen_dig:
LDR	LR, [SP, #0]
ADD	SP, SP, #104
BX	LR
; end of _atcah_gen_dig
_atcah_gen_mac:
;atca_host.c,518 :: 		ATCA_STATUS atcah_gen_mac(struct atca_gen_dig_in_out *param)
; param start address is: 0 (R0)
SUB	SP, SP, #104
STR	LR, [SP, #0]
; param end address is: 0 (R0)
; param start address is: 0 (R0)
;atca_host.c,524 :: 		if (!param->stored_value || !param->temp_key)
ADDS	R1, R0, #4
LDR	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L__atcah_gen_mac242
ADDW	R1, R0, #8
LDR	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L__atcah_gen_mac241
IT	AL
BAL	L_atcah_gen_mac93
; param end address is: 0 (R0)
L__atcah_gen_mac242:
L__atcah_gen_mac241:
;atca_host.c,525 :: 		return ATCA_BAD_PARAM;
MOVS	R0, #226
IT	AL
BAL	L_end_atcah_gen_mac
L_atcah_gen_mac93:
;atca_host.c,529 :: 		param->temp_key->check_flag || (param->temp_key->valid != 1)
; param start address is: 0 (R0)
ADDW	R1, R0, #8
LDR	R1, [R1, #0]
ADDS	R1, #32
LDRB	R2, [R1, #0]
UBFX	R1, R2, #6, #1
CMP	R1, #0
IT	NE
BNE	L__atcah_gen_mac244
ADDW	R1, R0, #8
LDR	R1, [R1, #0]
ADDS	R1, #32
LDRB	R2, [R1, #0]
UBFX	R1, R2, #7, #1
CMP	R1, #0
IT	EQ
BEQ	L__atcah_gen_mac243
IT	AL
BAL	L_atcah_gen_mac96
L__atcah_gen_mac244:
L__atcah_gen_mac243:
;atca_host.c,532 :: 		param->temp_key->valid = 0;
ADDW	R1, R0, #8
; param end address is: 0 (R0)
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
MOVS	R2, #0
LDRB	R1, [R3, #0]
BFI	R1, R2, #7, #1
STRB	R1, [R3, #0]
;atca_host.c,533 :: 		return ATCA_EXECUTION_ERROR;
MOVS	R0, #244
IT	AL
BAL	L_end_atcah_gen_mac
;atca_host.c,534 :: 		}
L_atcah_gen_mac96:
;atca_host.c,537 :: 		p_temp = temporary;
; param start address is: 0 (R0)
ADD	R2, SP, #8
; p_temp start address is: 24 (R6)
MOV	R6, R2
;atca_host.c,541 :: 		memcpy(p_temp, param->temp_key->value, ATCA_KEY_SIZE);
ADDW	R1, R0, #8
LDR	R1, [R1, #0]
STR	R0, [SP, #4]
MOV	R0, R2
MOVS	R2, #32
SXTH	R2, R2
BL	_memcpy+0
LDR	R0, [SP, #4]
;atca_host.c,542 :: 		p_temp += ATCA_KEY_SIZE;
ADDW	R2, R6, #32
; p_temp end address is: 24 (R6)
; p_temp start address is: 12 (R3)
MOV	R3, R2
;atca_host.c,545 :: 		*p_temp++ = ATCA_WRITE;
MOVS	R1, #18
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,548 :: 		*p_temp++ = param->zone;
LDRB	R1, [R0, #0]
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,551 :: 		*p_temp++ = param->key_id & 0xFF;
ADDS	R1, R0, #2
LDRH	R1, [R1, #0]
AND	R1, R1, #255
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,552 :: 		*p_temp++ = (param->key_id >> 8) & 0xFF;
ADDS	R1, R0, #2
LDRH	R1, [R1, #0]
LSRS	R1, R1, #8
UXTH	R1, R1
AND	R1, R1, #255
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,555 :: 		*p_temp++ = ATCA_SN_8;
MOVS	R1, #238
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,558 :: 		*p_temp++ = ATCA_SN_0;
MOVS	R1, #1
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,559 :: 		*p_temp++ = ATCA_SN_1;
MOVS	R1, #35
STRB	R1, [R2, #0]
ADDS	R1, R3, #1
; p_temp end address is: 12 (R3)
; p_temp start address is: 24 (R6)
MOV	R6, R1
;atca_host.c,562 :: 		memset(p_temp, 0, ATCA_GENDIG_ZEROS_SIZE);
STR	R0, [SP, #4]
MOVS	R2, #25
SXTH	R2, R2
MOV	R0, R1
MOVS	R1, #0
BL	_memset+0
LDR	R0, [SP, #4]
;atca_host.c,563 :: 		p_temp += ATCA_GENDIG_ZEROS_SIZE;
ADDW	R2, R6, #25
; p_temp end address is: 24 (R6)
;atca_host.c,566 :: 		memcpy(p_temp, param->stored_value, ATCA_KEY_SIZE);
ADDS	R1, R0, #4
LDR	R1, [R1, #0]
STR	R0, [SP, #4]
MOV	R0, R2
MOVS	R2, #32
SXTH	R2, R2
BL	_memcpy+0
LDR	R0, [SP, #4]
;atca_host.c,569 :: 		atcah_sha256(ATCA_MSG_SIZE_GEN_DIG, temporary, param->temp_key->value);
ADDW	R1, R0, #8
LDR	R2, [R1, #0]
ADD	R1, SP, #8
STR	R0, [SP, #4]
MOVS	R0, #96
BL	_atcah_sha256+0
LDR	R0, [SP, #4]
;atca_host.c,572 :: 		param->temp_key->valid = 1;
ADDW	R1, R0, #8
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
MOVS	R2, #1
LDRB	R1, [R3, #0]
BFI	R1, R2, #7, #1
STRB	R1, [R3, #0]
;atca_host.c,574 :: 		if ((param->zone == GENDIG_ZONE_DATA) && (param->key_id <= 15)) {
LDRB	R1, [R0, #0]
CMP	R1, #2
IT	NE
BNE	L__atcah_gen_mac246
ADDS	R1, R0, #2
LDRH	R1, [R1, #0]
CMP	R1, #15
IT	HI
BHI	L__atcah_gen_mac245
L__atcah_gen_mac238:
;atca_host.c,575 :: 		param->temp_key->gen_data = 1;
ADDW	R1, R0, #8
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
MOVS	R2, #1
LDRB	R1, [R3, #0]
BFI	R1, R2, #5, #1
STRB	R1, [R3, #0]
;atca_host.c,576 :: 		param->temp_key->key_id = (param->key_id & 0xF);    // mask lower 4-bit only
ADDW	R1, R0, #8
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
ADDS	R1, R0, #2
; param end address is: 0 (R0)
LDRH	R1, [R1, #0]
AND	R1, R1, #15
UXTB	R2, R1
LDRB	R1, [R3, #0]
BFI	R1, R2, #0, #4
STRB	R1, [R3, #0]
;atca_host.c,577 :: 		}else {
IT	AL
BAL	L_atcah_gen_mac100
;atca_host.c,574 :: 		if ((param->zone == GENDIG_ZONE_DATA) && (param->key_id <= 15)) {
L__atcah_gen_mac246:
; param start address is: 0 (R0)
L__atcah_gen_mac245:
;atca_host.c,578 :: 		param->temp_key->gen_data = 0;
ADDW	R1, R0, #8
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
MOVS	R2, #0
LDRB	R1, [R3, #0]
BFI	R1, R2, #5, #1
STRB	R1, [R3, #0]
;atca_host.c,579 :: 		param->temp_key->key_id = 0;
ADDW	R1, R0, #8
; param end address is: 0 (R0)
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
MOVS	R2, #0
LDRB	R1, [R3, #0]
BFI	R1, R2, #0, #4
STRB	R1, [R3, #0]
;atca_host.c,580 :: 		}
L_atcah_gen_mac100:
;atca_host.c,582 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_host.c,583 :: 		}
L_end_atcah_gen_mac:
LDR	LR, [SP, #0]
ADD	SP, SP, #104
BX	LR
; end of _atcah_gen_mac
_atcah_write_auth_mac:
;atca_host.c,592 :: 		ATCA_STATUS atcah_write_auth_mac(struct atca_write_mac_in_out *param)
; param start address is: 0 (R0)
SUB	SP, SP, #136
STR	LR, [SP, #0]
; param end address is: 0 (R0)
; param start address is: 0 (R0)
;atca_host.c,600 :: 		if (!param->input_data || !param->temp_key)
ADDW	R1, R0, #8
LDR	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L__atcah_write_auth_mac250
ADDW	R1, R0, #20
LDR	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L__atcah_write_auth_mac249
IT	AL
BAL	L_atcah_write_auth_mac103
; param end address is: 0 (R0)
L__atcah_write_auth_mac250:
L__atcah_write_auth_mac249:
;atca_host.c,601 :: 		return ATCA_BAD_PARAM;
MOVS	R0, #226
IT	AL
BAL	L_end_atcah_write_auth_mac
L_atcah_write_auth_mac103:
;atca_host.c,605 :: 		param->temp_key->check_flag || (param->temp_key->valid != 1)
; param start address is: 0 (R0)
ADDW	R1, R0, #20
LDR	R1, [R1, #0]
ADDS	R1, #32
LDRB	R2, [R1, #0]
UBFX	R1, R2, #6, #1
CMP	R1, #0
IT	NE
BNE	L__atcah_write_auth_mac252
ADDW	R1, R0, #20
LDR	R1, [R1, #0]
ADDS	R1, #32
LDRB	R2, [R1, #0]
UBFX	R1, R2, #7, #1
CMP	R1, #0
IT	EQ
BEQ	L__atcah_write_auth_mac251
IT	AL
BAL	L_atcah_write_auth_mac106
L__atcah_write_auth_mac252:
L__atcah_write_auth_mac251:
;atca_host.c,608 :: 		param->temp_key->valid = 0;
ADDW	R1, R0, #20
; param end address is: 0 (R0)
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
MOVS	R2, #0
LDRB	R1, [R3, #0]
BFI	R1, R2, #7, #1
STRB	R1, [R3, #0]
;atca_host.c,609 :: 		return ATCA_EXECUTION_ERROR;
MOVS	R0, #244
IT	AL
BAL	L_end_atcah_write_auth_mac
;atca_host.c,610 :: 		}
L_atcah_write_auth_mac106:
;atca_host.c,612 :: 		for (i = 0; i < 32; i++)
; i start address is: 16 (R4)
; param start address is: 0 (R0)
MOVS	R4, #0
; param end address is: 0 (R0)
; i end address is: 16 (R4)
L_atcah_write_auth_mac107:
; i start address is: 16 (R4)
; param start address is: 0 (R0)
CMP	R4, #32
IT	CS
BCS	L_atcah_write_auth_mac108
;atca_host.c,613 :: 		param->encrypted_data[i] = param->encryption_key[i] ^ param->temp_key->value[i];
ADDW	R1, R0, #12
LDR	R1, [R1, #0]
ADDS	R3, R1, R4
ADDS	R1, R0, #4
LDR	R1, [R1, #0]
ADDS	R1, R1, R4
LDRB	R2, [R1, #0]
ADDW	R1, R0, #20
LDR	R1, [R1, #0]
ADDS	R1, R1, R4
LDRB	R1, [R1, #0]
EOR	R1, R2, R1, LSL #0
STRB	R1, [R3, #0]
;atca_host.c,612 :: 		for (i = 0; i < 32; i++)
ADDS	R4, R4, #1
UXTB	R4, R4
;atca_host.c,613 :: 		param->encrypted_data[i] = param->encryption_key[i] ^ param->temp_key->value[i];
; i end address is: 16 (R4)
IT	AL
BAL	L_atcah_write_auth_mac107
L_atcah_write_auth_mac108:
;atca_host.c,616 :: 		atcah_sha256(32, param->temp_key->value, session_key2);
ADD	R2, SP, #104
ADDW	R1, R0, #20
LDR	R1, [R1, #0]
STR	R0, [SP, #4]
MOVS	R0, #32
BL	_atcah_sha256+0
LDR	R0, [SP, #4]
;atca_host.c,619 :: 		if (param->auth_mac) {
ADDW	R1, R0, #16
LDR	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L_atcah_write_auth_mac110
;atca_host.c,621 :: 		p_temp = temporary;
ADD	R2, SP, #8
; p_temp start address is: 24 (R6)
MOV	R6, R2
;atca_host.c,624 :: 		memcpy(p_temp, param->temp_key->value, ATCA_KEY_SIZE);
ADDW	R1, R0, #20
LDR	R1, [R1, #0]
STR	R0, [SP, #4]
MOV	R0, R2
MOVS	R2, #32
SXTH	R2, R2
BL	_memcpy+0
LDR	R0, [SP, #4]
;atca_host.c,625 :: 		p_temp += ATCA_KEY_SIZE;
ADDW	R2, R6, #32
; p_temp end address is: 24 (R6)
; p_temp start address is: 12 (R3)
MOV	R3, R2
;atca_host.c,628 :: 		*p_temp++ = ATCA_PRIVWRITE;
MOVS	R1, #70
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,631 :: 		*p_temp++ = param->zone;
LDRB	R1, [R0, #0]
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,634 :: 		*p_temp++ = param->key_id & 0xFF;
ADDS	R1, R0, #2
LDRH	R1, [R1, #0]
AND	R1, R1, #255
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,635 :: 		*p_temp++ = (param->key_id >> 8) & 0xFF;
ADDS	R1, R0, #2
LDRH	R1, [R1, #0]
LSRS	R1, R1, #8
UXTH	R1, R1
AND	R1, R1, #255
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,638 :: 		*p_temp++ = ATCA_SN_8;
MOVS	R1, #238
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,641 :: 		*p_temp++ = ATCA_SN_0;
MOVS	R1, #1
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,642 :: 		*p_temp++ = ATCA_SN_1;
MOVS	R1, #35
STRB	R1, [R2, #0]
ADDS	R1, R3, #1
; p_temp end address is: 12 (R3)
; p_temp start address is: 24 (R6)
MOV	R6, R1
;atca_host.c,645 :: 		memset(p_temp, 0, ATCA_PRIVWRITE_MAC_ZEROS_SIZE);
STR	R0, [SP, #4]
MOVS	R2, #21
SXTH	R2, R2
MOV	R0, R1
MOVS	R1, #0
BL	_memset+0
LDR	R0, [SP, #4]
;atca_host.c,646 :: 		p_temp += ATCA_PRIVWRITE_MAC_ZEROS_SIZE;
ADDW	R2, R6, #21
; p_temp end address is: 24 (R6)
;atca_host.c,649 :: 		memcpy(p_temp, param->input_data, ATCA_PLAIN_TEXT_SIZE);
ADDW	R1, R0, #8
LDR	R1, [R1, #0]
STR	R0, [SP, #4]
MOV	R0, R2
MOVS	R2, #36
SXTH	R2, R2
BL	_memcpy+0
LDR	R0, [SP, #4]
;atca_host.c,652 :: 		atcah_sha256(ATCA_MSG_SIZE_PRIVWRITE_MAC, temporary, param->auth_mac);
ADDW	R1, R0, #16
LDR	R1, [R1, #0]
MOV	R2, R1
ADD	R1, SP, #8
STR	R0, [SP, #4]
MOVS	R0, #96
BL	_atcah_sha256+0
LDR	R0, [SP, #4]
;atca_host.c,653 :: 		}
L_atcah_write_auth_mac110:
;atca_host.c,655 :: 		param->temp_key->valid = 1;
ADDW	R1, R0, #20
; param end address is: 0 (R0)
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
MOVS	R2, #1
LDRB	R1, [R3, #0]
BFI	R1, R2, #7, #1
STRB	R1, [R3, #0]
;atca_host.c,657 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_host.c,658 :: 		}
L_end_atcah_write_auth_mac:
LDR	LR, [SP, #0]
ADD	SP, SP, #136
BX	LR
; end of _atcah_write_auth_mac
_atcah_privwrite_auth_mac:
;atca_host.c,667 :: 		ATCA_STATUS atcah_privwrite_auth_mac(struct atca_write_mac_in_out *param)
; param start address is: 0 (R0)
SUB	SP, SP, #136
STR	LR, [SP, #0]
; param end address is: 0 (R0)
; param start address is: 0 (R0)
;atca_host.c,675 :: 		if (!param->input_data || !param->temp_key)
ADDW	R1, R0, #8
LDR	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L__atcah_privwrite_auth_mac256
ADDW	R1, R0, #20
LDR	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L__atcah_privwrite_auth_mac255
IT	AL
BAL	L_atcah_privwrite_auth_mac113
; param end address is: 0 (R0)
L__atcah_privwrite_auth_mac256:
L__atcah_privwrite_auth_mac255:
;atca_host.c,676 :: 		return ATCA_BAD_PARAM;
MOVS	R0, #226
IT	AL
BAL	L_end_atcah_privwrite_auth_mac
L_atcah_privwrite_auth_mac113:
;atca_host.c,680 :: 		param->temp_key->check_flag || (param->temp_key->valid != 1)
; param start address is: 0 (R0)
ADDW	R1, R0, #20
LDR	R1, [R1, #0]
ADDS	R1, #32
LDRB	R2, [R1, #0]
UBFX	R1, R2, #6, #1
CMP	R1, #0
IT	NE
BNE	L__atcah_privwrite_auth_mac258
ADDW	R1, R0, #20
LDR	R1, [R1, #0]
ADDS	R1, #32
LDRB	R2, [R1, #0]
UBFX	R1, R2, #7, #1
CMP	R1, #0
IT	EQ
BEQ	L__atcah_privwrite_auth_mac257
IT	AL
BAL	L_atcah_privwrite_auth_mac116
L__atcah_privwrite_auth_mac258:
L__atcah_privwrite_auth_mac257:
;atca_host.c,683 :: 		param->temp_key->valid = 0;
ADDW	R1, R0, #20
; param end address is: 0 (R0)
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
MOVS	R2, #0
LDRB	R1, [R3, #0]
BFI	R1, R2, #7, #1
STRB	R1, [R3, #0]
;atca_host.c,684 :: 		return ATCA_EXECUTION_ERROR;
MOVS	R0, #244
IT	AL
BAL	L_end_atcah_privwrite_auth_mac
;atca_host.c,685 :: 		}
L_atcah_privwrite_auth_mac116:
;atca_host.c,692 :: 		for (i = 0; i < 4; i++)
; param start address is: 0 (R0)
; i start address is: 12 (R3)
MOVS	R3, #0
; i end address is: 12 (R3)
; param end address is: 0 (R0)
L_atcah_privwrite_auth_mac117:
; i start address is: 12 (R3)
; param start address is: 0 (R0)
CMP	R3, #4
IT	CS
BCS	L_atcah_privwrite_auth_mac118
;atca_host.c,693 :: 		param->encrypted_data[i] = 0 ^ param->temp_key->value[i];
ADDW	R1, R0, #12
LDR	R1, [R1, #0]
ADDS	R2, R1, R3
ADDW	R1, R0, #20
LDR	R1, [R1, #0]
ADDS	R1, R1, R3
LDRB	R1, [R1, #0]
STRB	R1, [R2, #0]
;atca_host.c,692 :: 		for (i = 0; i < 4; i++)
ADDS	R3, R3, #1
UXTB	R3, R3
;atca_host.c,693 :: 		param->encrypted_data[i] = 0 ^ param->temp_key->value[i];
; i end address is: 12 (R3)
IT	AL
BAL	L_atcah_privwrite_auth_mac117
L_atcah_privwrite_auth_mac118:
;atca_host.c,696 :: 		for (i = 4; i < 32; i++)
; i start address is: 16 (R4)
MOVS	R4, #4
; i end address is: 16 (R4)
; param end address is: 0 (R0)
L_atcah_privwrite_auth_mac120:
; i start address is: 16 (R4)
; param start address is: 0 (R0)
CMP	R4, #32
IT	CS
BCS	L_atcah_privwrite_auth_mac121
;atca_host.c,697 :: 		param->encrypted_data[i] = param->encryption_key[i - 4] ^ param->temp_key->value[i];
ADDW	R1, R0, #12
LDR	R1, [R1, #0]
ADDS	R3, R1, R4
ADDS	R1, R0, #4
SUBS	R2, R4, #4
SXTH	R2, R2
LDR	R1, [R1, #0]
ADDS	R1, R1, R2
LDRB	R2, [R1, #0]
ADDW	R1, R0, #20
LDR	R1, [R1, #0]
ADDS	R1, R1, R4
LDRB	R1, [R1, #0]
EOR	R1, R2, R1, LSL #0
STRB	R1, [R3, #0]
;atca_host.c,696 :: 		for (i = 4; i < 32; i++)
ADDS	R4, R4, #1
UXTB	R4, R4
;atca_host.c,697 :: 		param->encrypted_data[i] = param->encryption_key[i - 4] ^ param->temp_key->value[i];
; i end address is: 16 (R4)
IT	AL
BAL	L_atcah_privwrite_auth_mac120
L_atcah_privwrite_auth_mac121:
;atca_host.c,700 :: 		atcah_sha256(32, param->temp_key->value, session_key2);
ADD	R2, SP, #104
ADDW	R1, R0, #20
LDR	R1, [R1, #0]
STR	R0, [SP, #4]
MOVS	R0, #32
BL	_atcah_sha256+0
LDR	R0, [SP, #4]
;atca_host.c,703 :: 		for (i = 32; i < 36; i++)
; i start address is: 20 (R5)
MOVS	R5, #32
; param end address is: 0 (R0)
; i end address is: 20 (R5)
L_atcah_privwrite_auth_mac123:
; i start address is: 20 (R5)
; param start address is: 0 (R0)
CMP	R5, #36
IT	CS
BCS	L_atcah_privwrite_auth_mac124
;atca_host.c,704 :: 		param->encrypted_data[i] = param->encryption_key[i - 4] ^ session_key2[i - 32];
ADDW	R1, R0, #12
LDR	R1, [R1, #0]
ADDS	R4, R1, R5
ADDS	R1, R0, #4
SUBS	R2, R5, #4
SXTH	R2, R2
LDR	R1, [R1, #0]
ADDS	R1, R1, R2
LDRB	R3, [R1, #0]
SUBW	R2, R5, #32
SXTH	R2, R2
ADD	R1, SP, #104
ADDS	R1, R1, R2
LDRB	R1, [R1, #0]
EOR	R1, R3, R1, LSL #0
STRB	R1, [R4, #0]
;atca_host.c,703 :: 		for (i = 32; i < 36; i++)
ADDS	R5, R5, #1
UXTB	R5, R5
;atca_host.c,704 :: 		param->encrypted_data[i] = param->encryption_key[i - 4] ^ session_key2[i - 32];
; i end address is: 20 (R5)
IT	AL
BAL	L_atcah_privwrite_auth_mac123
L_atcah_privwrite_auth_mac124:
;atca_host.c,707 :: 		if (param->auth_mac) {
ADDW	R1, R0, #16
LDR	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L_atcah_privwrite_auth_mac126
;atca_host.c,709 :: 		p_temp = temporary;
ADD	R2, SP, #8
; p_temp start address is: 24 (R6)
MOV	R6, R2
;atca_host.c,712 :: 		memcpy(p_temp, param->temp_key->value, ATCA_KEY_SIZE);
ADDW	R1, R0, #20
LDR	R1, [R1, #0]
STR	R0, [SP, #4]
MOV	R0, R2
MOVS	R2, #32
SXTH	R2, R2
BL	_memcpy+0
LDR	R0, [SP, #4]
;atca_host.c,713 :: 		p_temp += ATCA_KEY_SIZE;
ADDW	R2, R6, #32
; p_temp end address is: 24 (R6)
; p_temp start address is: 12 (R3)
MOV	R3, R2
;atca_host.c,716 :: 		*p_temp++ = ATCA_PRIVWRITE;
MOVS	R1, #70
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,719 :: 		*p_temp++ = param->zone;
LDRB	R1, [R0, #0]
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,722 :: 		*p_temp++ = param->key_id & 0xFF;
ADDS	R1, R0, #2
LDRH	R1, [R1, #0]
AND	R1, R1, #255
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,723 :: 		*p_temp++ = (param->key_id >> 8) & 0xFF;
ADDS	R1, R0, #2
LDRH	R1, [R1, #0]
LSRS	R1, R1, #8
UXTH	R1, R1
AND	R1, R1, #255
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,726 :: 		*p_temp++ = ATCA_SN_8;
MOVS	R1, #238
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,729 :: 		*p_temp++ = ATCA_SN_0;
MOVS	R1, #1
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,730 :: 		*p_temp++ = ATCA_SN_1;
MOVS	R1, #35
STRB	R1, [R2, #0]
ADDS	R1, R3, #1
; p_temp end address is: 12 (R3)
; p_temp start address is: 24 (R6)
MOV	R6, R1
;atca_host.c,733 :: 		memset(p_temp, 0, ATCA_PRIVWRITE_MAC_ZEROS_SIZE);
STR	R0, [SP, #4]
MOVS	R2, #21
SXTH	R2, R2
MOV	R0, R1
MOVS	R1, #0
BL	_memset+0
LDR	R0, [SP, #4]
;atca_host.c,734 :: 		p_temp += ATCA_PRIVWRITE_MAC_ZEROS_SIZE;
ADDW	R2, R6, #21
; p_temp end address is: 24 (R6)
;atca_host.c,737 :: 		memcpy(p_temp, param->input_data, ATCA_PLAIN_TEXT_SIZE);
ADDW	R1, R0, #8
LDR	R1, [R1, #0]
STR	R0, [SP, #4]
MOV	R0, R2
MOVS	R2, #36
SXTH	R2, R2
BL	_memcpy+0
LDR	R0, [SP, #4]
;atca_host.c,740 :: 		atcah_sha256(ATCA_MSG_SIZE_PRIVWRITE_MAC, temporary, param->auth_mac);
ADDW	R1, R0, #16
LDR	R1, [R1, #0]
MOV	R2, R1
ADD	R1, SP, #8
STR	R0, [SP, #4]
MOVS	R0, #96
BL	_atcah_sha256+0
LDR	R0, [SP, #4]
;atca_host.c,741 :: 		}
L_atcah_privwrite_auth_mac126:
;atca_host.c,744 :: 		param->temp_key->valid = 1;
ADDW	R1, R0, #20
; param end address is: 0 (R0)
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
MOVS	R2, #1
LDRB	R1, [R3, #0]
BFI	R1, R2, #7, #1
STRB	R1, [R3, #0]
;atca_host.c,746 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_host.c,747 :: 		}
L_end_atcah_privwrite_auth_mac:
LDR	LR, [SP, #0]
ADD	SP, SP, #136
BX	LR
; end of _atcah_privwrite_auth_mac
_atcah_derive_key:
;atca_host.c,763 :: 		ATCA_STATUS atcah_derive_key(struct atca_derive_key_in_out *param)
; param start address is: 0 (R0)
SUB	SP, SP, #104
STR	LR, [SP, #0]
; param end address is: 0 (R0)
; param start address is: 0 (R0)
;atca_host.c,769 :: 		if (!param->parent_key || !param->target_key || !param->temp_key
ADDS	R1, R0, #4
LDR	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L__atcah_derive_key265
ADDW	R1, R0, #8
LDR	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L__atcah_derive_key264
ADDW	R1, R0, #12
LDR	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L__atcah_derive_key263
;atca_host.c,770 :: 		|| (param->random & ~DERIVE_KEY_RANDOM_FLAG) || (param->target_key_id > ATCA_KEY_ID_MAX))
LDRB	R1, [R0, #0]
AND	R1, R1, #251
UXTB	R1, R1
CMP	R1, #0
IT	NE
BNE	L__atcah_derive_key262
ADDS	R1, R0, #2
LDRH	R1, [R1, #0]
CMP	R1, #15
IT	HI
BHI	L__atcah_derive_key261
IT	AL
BAL	L_atcah_derive_key129
; param end address is: 0 (R0)
;atca_host.c,769 :: 		if (!param->parent_key || !param->target_key || !param->temp_key
L__atcah_derive_key265:
L__atcah_derive_key264:
L__atcah_derive_key263:
;atca_host.c,770 :: 		|| (param->random & ~DERIVE_KEY_RANDOM_FLAG) || (param->target_key_id > ATCA_KEY_ID_MAX))
L__atcah_derive_key262:
L__atcah_derive_key261:
;atca_host.c,771 :: 		return ATCA_BAD_PARAM;
MOVS	R0, #226
IT	AL
BAL	L_end_atcah_derive_key
L_atcah_derive_key129:
;atca_host.c,776 :: 		param->temp_key->check_flag || (param->temp_key->valid != 1)
; param start address is: 0 (R0)
ADDW	R1, R0, #12
LDR	R1, [R1, #0]
ADDS	R1, #32
LDRB	R2, [R1, #0]
UBFX	R1, R2, #6, #1
CMP	R1, #0
IT	NE
BNE	L__atcah_derive_key268
ADDW	R1, R0, #12
LDR	R1, [R1, #0]
ADDS	R1, #32
LDRB	R2, [R1, #0]
UBFX	R1, R2, #7, #1
CMP	R1, #0
IT	EQ
BEQ	L__atcah_derive_key267
;atca_host.c,779 :: 		|| (!(param->random & DERIVE_KEY_RANDOM_FLAG) != !(param->temp_key->source_flag))
LDRB	R1, [R0, #0]
AND	R1, R1, #4
UXTB	R1, R1
CMP	R1, #0
MOVW	R3, #0
BNE	L__atcah_derive_key304
MOVS	R3, #1
L__atcah_derive_key304:
UXTB	R3, R3
ADDW	R1, R0, #12
LDR	R1, [R1, #0]
ADDS	R1, #32
LDRB	R2, [R1, #0]
UBFX	R1, R2, #4, #1
EOR	R1, R1, #1
UXTB	R1, R1
CMP	R3, R1
IT	NE
BNE	L__atcah_derive_key266
IT	AL
BAL	L_atcah_derive_key132
;atca_host.c,776 :: 		param->temp_key->check_flag || (param->temp_key->valid != 1)
L__atcah_derive_key268:
L__atcah_derive_key267:
;atca_host.c,779 :: 		|| (!(param->random & DERIVE_KEY_RANDOM_FLAG) != !(param->temp_key->source_flag))
L__atcah_derive_key266:
;atca_host.c,782 :: 		param->temp_key->valid = 0;
ADDW	R1, R0, #12
; param end address is: 0 (R0)
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
MOVS	R2, #0
LDRB	R1, [R3, #0]
BFI	R1, R2, #7, #1
STRB	R1, [R3, #0]
;atca_host.c,783 :: 		return ATCA_EXECUTION_ERROR;
MOVS	R0, #244
IT	AL
BAL	L_end_atcah_derive_key
;atca_host.c,784 :: 		}
L_atcah_derive_key132:
;atca_host.c,787 :: 		p_temp = temporary;
; param start address is: 0 (R0)
ADD	R2, SP, #8
; p_temp start address is: 24 (R6)
MOV	R6, R2
;atca_host.c,790 :: 		memcpy(p_temp, param->parent_key, ATCA_KEY_SIZE);
ADDS	R1, R0, #4
LDR	R1, [R1, #0]
STR	R0, [SP, #4]
MOV	R0, R2
MOVS	R2, #32
SXTH	R2, R2
BL	_memcpy+0
LDR	R0, [SP, #4]
;atca_host.c,791 :: 		p_temp += ATCA_KEY_SIZE;
ADDW	R2, R6, #32
; p_temp end address is: 24 (R6)
; p_temp start address is: 12 (R3)
MOV	R3, R2
;atca_host.c,794 :: 		*p_temp++ = ATCA_DERIVE_KEY;
MOVS	R1, #28
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,797 :: 		*p_temp++ = param->random;
LDRB	R1, [R0, #0]
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,800 :: 		*p_temp++ = param->target_key_id & 0xFF;
ADDS	R1, R0, #2
LDRH	R1, [R1, #0]
AND	R1, R1, #255
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,801 :: 		*p_temp++ = (param->target_key_id >> 8) & 0xFF;
ADDS	R1, R0, #2
LDRH	R1, [R1, #0]
LSRS	R1, R1, #8
UXTH	R1, R1
AND	R1, R1, #255
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,804 :: 		*p_temp++ = ATCA_SN_8;
MOVS	R1, #238
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,807 :: 		*p_temp++ = ATCA_SN_0;
MOVS	R1, #1
STRB	R1, [R2, #0]
ADDS	R2, R3, #1
MOV	R3, R2
;atca_host.c,808 :: 		*p_temp++ = ATCA_SN_1;
MOVS	R1, #35
STRB	R1, [R2, #0]
ADDS	R1, R3, #1
; p_temp end address is: 12 (R3)
; p_temp start address is: 24 (R6)
MOV	R6, R1
;atca_host.c,811 :: 		memset(p_temp, 0, ATCA_DERIVE_KEY_ZEROS_SIZE);
STR	R0, [SP, #4]
MOVS	R2, #25
SXTH	R2, R2
MOV	R0, R1
MOVS	R1, #0
BL	_memset+0
LDR	R0, [SP, #4]
;atca_host.c,812 :: 		p_temp += ATCA_DERIVE_KEY_ZEROS_SIZE;
ADDW	R2, R6, #25
; p_temp end address is: 24 (R6)
;atca_host.c,815 :: 		memcpy(p_temp, param->temp_key->value, ATCA_KEY_SIZE);
ADDW	R1, R0, #12
LDR	R1, [R1, #0]
STR	R0, [SP, #4]
MOV	R0, R2
MOVS	R2, #32
SXTH	R2, R2
BL	_memcpy+0
LDR	R0, [SP, #4]
;atca_host.c,819 :: 		atcah_sha256(ATCA_MSG_SIZE_DERIVE_KEY, temporary, param->target_key);
ADDW	R1, R0, #8
LDR	R1, [R1, #0]
MOV	R2, R1
ADD	R1, SP, #8
STR	R0, [SP, #4]
MOVS	R0, #96
BL	_atcah_sha256+0
LDR	R0, [SP, #4]
;atca_host.c,822 :: 		param->temp_key->valid = 0;
ADDW	R1, R0, #12
; param end address is: 0 (R0)
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
MOVS	R2, #0
LDRB	R1, [R3, #0]
BFI	R1, R2, #7, #1
STRB	R1, [R3, #0]
;atca_host.c,824 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_host.c,825 :: 		}
L_end_atcah_derive_key:
LDR	LR, [SP, #0]
ADD	SP, SP, #104
BX	LR
; end of _atcah_derive_key
_atcah_derive_key_mac:
;atca_host.c,835 :: 		ATCA_STATUS atcah_derive_key_mac(struct atca_derive_key_mac_in_out *param)
; param start address is: 0 (R0)
SUB	SP, SP, #44
STR	LR, [SP, #0]
MOV	R6, R0
; param end address is: 0 (R0)
; param start address is: 24 (R6)
;atca_host.c,841 :: 		if (!param->parent_key || !param->mac || (param->random & ~DERIVE_KEY_RANDOM_FLAG)
ADDS	R1, R6, #4
LDR	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L__atcah_derive_key_mac273
ADDW	R1, R6, #8
LDR	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L__atcah_derive_key_mac272
LDRB	R1, [R6, #0]
AND	R1, R1, #251
UXTB	R1, R1
CMP	R1, #0
IT	NE
BNE	L__atcah_derive_key_mac271
;atca_host.c,842 :: 		|| (param->target_key_id > ATCA_KEY_ID_MAX))
ADDS	R1, R6, #2
LDRH	R1, [R1, #0]
CMP	R1, #15
IT	HI
BHI	L__atcah_derive_key_mac270
IT	AL
BAL	L_atcah_derive_key_mac135
; param end address is: 24 (R6)
;atca_host.c,841 :: 		if (!param->parent_key || !param->mac || (param->random & ~DERIVE_KEY_RANDOM_FLAG)
L__atcah_derive_key_mac273:
L__atcah_derive_key_mac272:
L__atcah_derive_key_mac271:
;atca_host.c,842 :: 		|| (param->target_key_id > ATCA_KEY_ID_MAX))
L__atcah_derive_key_mac270:
;atca_host.c,843 :: 		return ATCA_BAD_PARAM;
MOVS	R0, #226
IT	AL
BAL	L_end_atcah_derive_key_mac
L_atcah_derive_key_mac135:
;atca_host.c,846 :: 		p_temp = temporary;
; param start address is: 24 (R6)
ADD	R2, SP, #4
; p_temp start address is: 28 (R7)
MOV	R7, R2
;atca_host.c,849 :: 		memcpy(p_temp, param->parent_key, ATCA_KEY_SIZE);
ADDS	R1, R6, #4
LDR	R1, [R1, #0]
MOV	R0, R2
MOVS	R2, #32
SXTH	R2, R2
BL	_memcpy+0
;atca_host.c,850 :: 		p_temp += ATCA_KEY_SIZE;
ADDW	R2, R7, #32
; p_temp end address is: 28 (R7)
; p_temp start address is: 0 (R0)
MOV	R0, R2
;atca_host.c,853 :: 		*p_temp++ = ATCA_DERIVE_KEY;
MOVS	R1, #28
STRB	R1, [R2, #0]
ADDS	R2, R0, #1
MOV	R0, R2
;atca_host.c,856 :: 		*p_temp++ = param->random;
LDRB	R1, [R6, #0]
STRB	R1, [R2, #0]
ADDS	R2, R0, #1
MOV	R0, R2
;atca_host.c,859 :: 		*p_temp++ = param->target_key_id & 0xFF;
ADDS	R1, R6, #2
LDRH	R1, [R1, #0]
AND	R1, R1, #255
STRB	R1, [R2, #0]
ADDS	R2, R0, #1
MOV	R0, R2
;atca_host.c,860 :: 		*p_temp++ = (param->target_key_id >> 8) & 0xFF;
ADDS	R1, R6, #2
LDRH	R1, [R1, #0]
LSRS	R1, R1, #8
UXTH	R1, R1
AND	R1, R1, #255
STRB	R1, [R2, #0]
ADDS	R2, R0, #1
MOV	R0, R2
;atca_host.c,863 :: 		*p_temp++ = ATCA_SN_8;
MOVS	R1, #238
STRB	R1, [R2, #0]
ADDS	R2, R0, #1
MOV	R0, R2
;atca_host.c,866 :: 		*p_temp++ = ATCA_SN_0;
MOVS	R1, #1
STRB	R1, [R2, #0]
ADDS	R2, R0, #1
; p_temp end address is: 0 (R0)
;atca_host.c,867 :: 		*p_temp++ = ATCA_SN_1;
MOVS	R1, #35
STRB	R1, [R2, #0]
;atca_host.c,870 :: 		atcah_sha256(ATCA_MSG_SIZE_DERIVE_KEY_MAC, temporary, param->mac);
ADDW	R1, R6, #8
; param end address is: 24 (R6)
LDR	R1, [R1, #0]
MOV	R2, R1
ADD	R1, SP, #4
MOVS	R0, #39
BL	_atcah_sha256+0
;atca_host.c,872 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_host.c,873 :: 		}
L_end_atcah_derive_key_mac:
LDR	LR, [SP, #0]
ADD	SP, SP, #44
BX	LR
; end of _atcah_derive_key_mac
_atcah_encrypt:
;atca_host.c,895 :: 		ATCA_STATUS atcah_encrypt(struct atca_encrypt_in_out *param)
; param start address is: 0 (R0)
SUB	SP, SP, #104
STR	LR, [SP, #0]
MOV	R6, R0
; param end address is: 0 (R0)
; param start address is: 24 (R6)
;atca_host.c,902 :: 		if (!param->crypto_data || !param->temp_key || (param->zone & ~WRITE_ZONE_MASK))
ADDS	R1, R6, #4
LDR	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L__atcah_encrypt278
ADDW	R1, R6, #12
LDR	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L__atcah_encrypt277
LDRB	R1, [R6, #0]
AND	R1, R1, #60
UXTB	R1, R1
CMP	R1, #0
IT	NE
BNE	L__atcah_encrypt276
IT	AL
BAL	L_atcah_encrypt138
; param end address is: 24 (R6)
L__atcah_encrypt278:
L__atcah_encrypt277:
L__atcah_encrypt276:
;atca_host.c,903 :: 		return ATCA_BAD_PARAM;
MOVS	R0, #226
IT	AL
BAL	L_end_atcah_encrypt
L_atcah_encrypt138:
;atca_host.c,910 :: 		param->temp_key->check_flag
; param start address is: 24 (R6)
ADDW	R1, R6, #12
LDR	R1, [R1, #0]
ADDS	R1, #32
LDRB	R2, [R1, #0]
;atca_host.c,912 :: 		|| (param->temp_key->valid != 1)
UBFX	R1, R2, #6, #1
CMP	R1, #0
IT	NE
BNE	L__atcah_encrypt283
ADDW	R1, R6, #12
LDR	R1, [R1, #0]
ADDS	R1, #32
LDRB	R2, [R1, #0]
UBFX	R1, R2, #7, #1
CMP	R1, #0
IT	EQ
BEQ	L__atcah_encrypt282
;atca_host.c,914 :: 		|| (param->temp_key->gen_data != 1)
ADDW	R1, R6, #12
LDR	R1, [R1, #0]
ADDS	R1, #32
LDRB	R2, [R1, #0]
UBFX	R1, R2, #5, #1
CMP	R1, #0
IT	EQ
BEQ	L__atcah_encrypt281
;atca_host.c,916 :: 		|| param->temp_key->source_flag
ADDW	R1, R6, #12
LDR	R1, [R1, #0]
ADDS	R1, #32
LDRB	R2, [R1, #0]
UBFX	R1, R2, #4, #1
CMP	R1, #0
IT	NE
BNE	L__atcah_encrypt280
;atca_host.c,918 :: 		|| (param->address & ~ATCA_ADDRESS_MASK)
ADDS	R1, R6, #2
LDRH	R2, [R1, #0]
MOVW	R1, #65408
AND	R1, R2, R1, LSL #0
UXTH	R1, R1
CMP	R1, #0
IT	NE
BNE	L__atcah_encrypt279
IT	AL
BAL	L_atcah_encrypt141
;atca_host.c,912 :: 		|| (param->temp_key->valid != 1)
L__atcah_encrypt283:
L__atcah_encrypt282:
;atca_host.c,914 :: 		|| (param->temp_key->gen_data != 1)
L__atcah_encrypt281:
;atca_host.c,916 :: 		|| param->temp_key->source_flag
L__atcah_encrypt280:
;atca_host.c,918 :: 		|| (param->address & ~ATCA_ADDRESS_MASK)
L__atcah_encrypt279:
;atca_host.c,921 :: 		param->temp_key->valid = 0;
ADDW	R1, R6, #12
; param end address is: 24 (R6)
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
MOVS	R2, #0
LDRB	R1, [R3, #0]
BFI	R1, R2, #7, #1
STRB	R1, [R3, #0]
;atca_host.c,922 :: 		return ATCA_EXECUTION_ERROR;
MOVS	R0, #244
IT	AL
BAL	L_end_atcah_encrypt
;atca_host.c,923 :: 		}
L_atcah_encrypt141:
;atca_host.c,926 :: 		if (param->mac) {
; param start address is: 24 (R6)
ADDW	R1, R6, #8
LDR	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L_atcah_encrypt142
;atca_host.c,928 :: 		p_temp = temporary;
ADD	R2, SP, #8
; p_temp start address is: 28 (R7)
MOV	R7, R2
;atca_host.c,931 :: 		memcpy(p_temp, param->temp_key->value, ATCA_KEY_SIZE);
ADDW	R1, R6, #12
LDR	R1, [R1, #0]
MOV	R0, R2
MOVS	R2, #32
SXTH	R2, R2
BL	_memcpy+0
;atca_host.c,932 :: 		p_temp += ATCA_KEY_SIZE;
ADDW	R2, R7, #32
; p_temp end address is: 28 (R7)
; p_temp start address is: 0 (R0)
MOV	R0, R2
;atca_host.c,935 :: 		*p_temp++ = ATCA_WRITE;
MOVS	R1, #18
STRB	R1, [R2, #0]
ADDS	R2, R0, #1
MOV	R0, R2
;atca_host.c,938 :: 		*p_temp++ = param->zone;
LDRB	R1, [R6, #0]
STRB	R1, [R2, #0]
ADDS	R2, R0, #1
MOV	R0, R2
;atca_host.c,941 :: 		*p_temp++ = param->address & 0xFF;
ADDS	R1, R6, #2
LDRH	R1, [R1, #0]
AND	R1, R1, #255
STRB	R1, [R2, #0]
ADDS	R2, R0, #1
MOV	R0, R2
;atca_host.c,942 :: 		*p_temp++ = (param->address >> 8) & 0xFF;
ADDS	R1, R6, #2
LDRH	R1, [R1, #0]
LSRS	R1, R1, #8
UXTH	R1, R1
AND	R1, R1, #255
STRB	R1, [R2, #0]
ADDS	R2, R0, #1
MOV	R0, R2
;atca_host.c,945 :: 		*p_temp++ = ATCA_SN_8;
MOVS	R1, #238
STRB	R1, [R2, #0]
ADDS	R2, R0, #1
MOV	R0, R2
;atca_host.c,948 :: 		*p_temp++ = ATCA_SN_0;
MOVS	R1, #1
STRB	R1, [R2, #0]
ADDS	R2, R0, #1
MOV	R0, R2
;atca_host.c,949 :: 		*p_temp++ = ATCA_SN_1;
MOVS	R1, #35
STRB	R1, [R2, #0]
ADDS	R1, R0, #1
; p_temp end address is: 0 (R0)
; p_temp start address is: 28 (R7)
MOV	R7, R1
;atca_host.c,952 :: 		memset(p_temp, 0, ATCA_GENDIG_ZEROS_SIZE);
MOVS	R2, #25
SXTH	R2, R2
MOV	R0, R1
MOVS	R1, #0
BL	_memset+0
;atca_host.c,953 :: 		p_temp += ATCA_GENDIG_ZEROS_SIZE;
ADDW	R2, R7, #25
; p_temp end address is: 28 (R7)
;atca_host.c,956 :: 		memcpy(p_temp, param->crypto_data, ATCA_KEY_SIZE);
ADDS	R1, R6, #4
LDR	R1, [R1, #0]
MOV	R0, R2
MOVS	R2, #32
SXTH	R2, R2
BL	_memcpy+0
;atca_host.c,959 :: 		atcah_sha256(ATCA_MSG_SIZE_ENCRYPT_MAC, temporary, param->mac);
ADDW	R1, R6, #8
LDR	R1, [R1, #0]
MOV	R2, R1
ADD	R1, SP, #8
STR	R6, [SP, #4]
MOVS	R0, #96
BL	_atcah_sha256+0
LDR	R6, [SP, #4]
;atca_host.c,960 :: 		}
L_atcah_encrypt142:
;atca_host.c,963 :: 		for (i = 0; i < ATCA_KEY_SIZE; i++)
; i start address is: 16 (R4)
MOVS	R4, #0
; param end address is: 24 (R6)
; i end address is: 16 (R4)
MOV	R0, R6
L_atcah_encrypt143:
; i start address is: 16 (R4)
; param start address is: 0 (R0)
CMP	R4, #32
IT	CS
BCS	L_atcah_encrypt144
;atca_host.c,964 :: 		param->crypto_data[i] ^= param->temp_key->value[i];
ADDS	R1, R0, #4
LDR	R1, [R1, #0]
ADDS	R3, R1, R4
ADDW	R1, R0, #12
LDR	R1, [R1, #0]
ADDS	R1, R1, R4
LDRB	R2, [R1, #0]
LDRB	R1, [R3, #0]
EORS	R1, R2
STRB	R1, [R3, #0]
;atca_host.c,963 :: 		for (i = 0; i < ATCA_KEY_SIZE; i++)
ADDS	R4, R4, #1
UXTB	R4, R4
;atca_host.c,964 :: 		param->crypto_data[i] ^= param->temp_key->value[i];
; i end address is: 16 (R4)
IT	AL
BAL	L_atcah_encrypt143
L_atcah_encrypt144:
;atca_host.c,967 :: 		param->temp_key->valid = 0;
ADDW	R1, R0, #12
; param end address is: 0 (R0)
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
MOVS	R2, #0
LDRB	R1, [R3, #0]
BFI	R1, R2, #7, #1
STRB	R1, [R3, #0]
;atca_host.c,969 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_host.c,970 :: 		}
L_end_atcah_encrypt:
LDR	LR, [SP, #0]
ADD	SP, SP, #104
BX	LR
; end of _atcah_encrypt
_atcah_decrypt:
;atca_host.c,989 :: 		ATCA_STATUS atcah_decrypt(struct atca_decrypt_in_out *param)
; param start address is: 0 (R0)
; param end address is: 0 (R0)
; param start address is: 0 (R0)
;atca_host.c,994 :: 		if (!param->crypto_data || !param->temp_key)
LDR	R1, [R0, #0]
CMP	R1, #0
IT	EQ
BEQ	L__atcah_decrypt287
ADDS	R1, R0, #4
LDR	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L__atcah_decrypt286
IT	AL
BAL	L_atcah_decrypt148
; param end address is: 0 (R0)
L__atcah_decrypt287:
L__atcah_decrypt286:
;atca_host.c,995 :: 		return ATCA_BAD_PARAM;
MOVS	R0, #226
IT	AL
BAL	L_end_atcah_decrypt
L_atcah_decrypt148:
;atca_host.c,1002 :: 		param->temp_key->check_flag
; param start address is: 0 (R0)
ADDS	R1, R0, #4
LDR	R1, [R1, #0]
ADDS	R1, #32
LDRB	R2, [R1, #0]
;atca_host.c,1004 :: 		|| (param->temp_key->valid != 1)
UBFX	R1, R2, #6, #1
CMP	R1, #0
IT	NE
BNE	L__atcah_decrypt291
ADDS	R1, R0, #4
LDR	R1, [R1, #0]
ADDS	R1, #32
LDRB	R2, [R1, #0]
UBFX	R1, R2, #7, #1
CMP	R1, #0
IT	EQ
BEQ	L__atcah_decrypt290
;atca_host.c,1006 :: 		|| (param->temp_key->gen_data != 1)
ADDS	R1, R0, #4
LDR	R1, [R1, #0]
ADDS	R1, #32
LDRB	R2, [R1, #0]
UBFX	R1, R2, #5, #1
CMP	R1, #0
IT	EQ
BEQ	L__atcah_decrypt289
;atca_host.c,1008 :: 		|| param->temp_key->source_flag
ADDS	R1, R0, #4
LDR	R1, [R1, #0]
ADDS	R1, #32
LDRB	R2, [R1, #0]
UBFX	R1, R2, #4, #1
CMP	R1, #0
IT	NE
BNE	L__atcah_decrypt288
IT	AL
BAL	L_atcah_decrypt151
;atca_host.c,1004 :: 		|| (param->temp_key->valid != 1)
L__atcah_decrypt291:
L__atcah_decrypt290:
;atca_host.c,1006 :: 		|| (param->temp_key->gen_data != 1)
L__atcah_decrypt289:
;atca_host.c,1008 :: 		|| param->temp_key->source_flag
L__atcah_decrypt288:
;atca_host.c,1011 :: 		param->temp_key->valid = 0;
ADDS	R1, R0, #4
; param end address is: 0 (R0)
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
MOVS	R2, #0
LDRB	R1, [R3, #0]
BFI	R1, R2, #7, #1
STRB	R1, [R3, #0]
;atca_host.c,1012 :: 		return ATCA_EXECUTION_ERROR;
MOVS	R0, #244
IT	AL
BAL	L_end_atcah_decrypt
;atca_host.c,1013 :: 		}
L_atcah_decrypt151:
;atca_host.c,1016 :: 		for (i = 0; i < ATCA_KEY_SIZE; i++)
; i start address is: 16 (R4)
; param start address is: 0 (R0)
MOVS	R4, #0
; param end address is: 0 (R0)
; i end address is: 16 (R4)
L_atcah_decrypt152:
; i start address is: 16 (R4)
; param start address is: 0 (R0)
CMP	R4, #32
IT	CS
BCS	L_atcah_decrypt153
;atca_host.c,1017 :: 		param->crypto_data[i] ^= param->temp_key->value[i];
LDR	R1, [R0, #0]
ADDS	R3, R1, R4
ADDS	R1, R0, #4
LDR	R1, [R1, #0]
ADDS	R1, R1, R4
LDRB	R2, [R1, #0]
LDRB	R1, [R3, #0]
EORS	R1, R2
STRB	R1, [R3, #0]
;atca_host.c,1016 :: 		for (i = 0; i < ATCA_KEY_SIZE; i++)
ADDS	R4, R4, #1
UXTB	R4, R4
;atca_host.c,1017 :: 		param->crypto_data[i] ^= param->temp_key->value[i];
; i end address is: 16 (R4)
IT	AL
BAL	L_atcah_decrypt152
L_atcah_decrypt153:
;atca_host.c,1020 :: 		param->temp_key->valid = 0;
ADDS	R1, R0, #4
; param end address is: 0 (R0)
LDR	R1, [R1, #0]
ADDW	R3, R1, #32
MOVS	R2, #0
LDRB	R1, [R3, #0]
BFI	R1, R2, #7, #1
STRB	R1, [R3, #0]
;atca_host.c,1022 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_host.c,1023 :: 		}
L_end_atcah_decrypt:
BX	LR
; end of _atcah_decrypt
_atcah_sha256:
;atca_host.c,1034 :: 		ATCA_STATUS atcah_sha256(int32_t len,  uint8_t *message, uint8_t *digest)
; digest start address is: 8 (R2)
; message start address is: 4 (R1)
; len start address is: 0 (R0)
SUB	SP, SP, #8
STR	LR, [SP, #0]
; digest end address is: 8 (R2)
; message end address is: 4 (R1)
; len end address is: 0 (R0)
; len start address is: 0 (R0)
; message start address is: 4 (R1)
; digest start address is: 8 (R2)
;atca_host.c,1036 :: 		return atcac_sw_sha2_256(message, len, digest);
STR	R1, [SP, #4]
; digest end address is: 8 (R2)
MOV	R1, R0
; len end address is: 0 (R0)
LDR	R0, [SP, #4]
; message end address is: 4 (R1)
BL	_atcac_sw_sha2_256+0
UXTB	R0, R0
;atca_host.c,1037 :: 		}
L_end_atcah_sha256:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _atcah_sha256
