#line 1 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/host/atca_host.c"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/host/atca_host.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/cryptoauthlib.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stddef.h"



typedef long ptrdiff_t;


 typedef unsigned long size_t;

typedef unsigned long wchar_t;
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/string.h"





void * memchr(void *p, char n, unsigned int v);
int memcmp(void *s1, void *s2, int n);
void * memcpy(void * d1, void * s1, int n);
void * memmove(void * to, void * from, int n);
void * memset(void * p1, char character, int n);
char * strcat(char * to, char * from);
char * strchr(char * ptr, char chr);
int strcmp(char * s1, char * s2);
char * strcpy(char * to, char * from);
int strlen(char * s);
char * strncat(char * to, char * from, int size);
char * strncpy(char * to, char * from, int size);
int strspn(char * str1, char * str2);
char strcspn(char * s1, char * s2);
int strncmp(char * s1, char * s2, char len);
char * strpbrk(char * s1, char * s2);
char * strrchr(char *ptr, char chr);
char * strstr(char * s1, char * s2);
char * strtok(char * s1, char * s2);
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/hal/atca_hal.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_status.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdbool.h"



 typedef char _Bool;
#line 55 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_status.h"
typedef enum
{
 ATCA_SUCCESS = 0x00,
 ATCA_CONFIG_ZONE_LOCKED = 0x01,
 ATCA_DATA_ZONE_LOCKED = 0x02,
 ATCA_WAKE_FAILED = 0xD0,
 ATCA_CHECKMAC_VERIFY_FAILED = 0xD1,
 ATCA_PARSE_ERROR = 0xD2,
 ATCA_STATUS_CRC = 0xD4,
 ATCA_STATUS_UNKNOWN = 0xD5,
 ATCA_STATUS_ECC = 0xD6,
 ATCA_STATUS_SELFTEST_ERROR = 0xD7,
 ATCA_FUNC_FAIL = 0xE0,
 ATCA_GEN_FAIL = 0xE1,
 ATCA_BAD_PARAM = 0xE2,
 ATCA_INVALID_ID = 0xE3,
 ATCA_INVALID_SIZE = 0xE4,
 ATCA_RX_CRC_ERROR = 0xE5,
 ATCA_RX_FAIL = 0xE6,
 ATCA_RX_NO_RESPONSE = 0xE7,
 ATCA_RESYNC_WITH_WAKEUP = 0xE8,
 ATCA_PARITY_ERROR = 0xE9,
 ATCA_TX_TIMEOUT = 0xEA,
 ATCA_RX_TIMEOUT = 0xEB,
 ATCA_TOO_MANY_COMM_RETRIES = 0xEC,
 ATCA_SMALL_BUFFER = 0xED,
 ATCA_COMM_FAIL = 0xF0,
 ATCA_TIMEOUT = 0xF1,
 ATCA_BAD_OPCODE = 0xF2,
 ATCA_WAKE_SUCCESS = 0xF3,
 ATCA_EXECUTION_ERROR = 0xF4,
 ATCA_UNIMPLEMENTED = 0xF5,
 ATCA_ASSERT_FAILURE = 0xF6,
 ATCA_TX_FAIL = 0xF7,
 ATCA_NOT_LOCKED = 0xF8,
 ATCA_NO_DEVICES = 0xF9,
 ATCA_HEALTH_TEST_ERROR = 0xFA,
 ATCA_ALLOC_FAILURE = 0xFB,
} ATCA_STATUS;
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_iface.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_compiler.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_status.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_devtypes.h"
#line 53 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_devtypes.h"
typedef enum {
 ATSHA204A,
 ATECC108A,
 ATECC508A,
 ATECC608A,
 ATCA_DEV_UNKNOWN = 0x20
} ATCADeviceType;
#line 62 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
struct atca_command {
 ATCADeviceType dt;
 uint16_t *execution_times;
};


typedef struct atca_command * ATCACommand;
ATCACommand newATCACommand(ATCADeviceType device_type);
#pragma pack( push, ATCAPacket, 2 )
#line 97 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
typedef struct {


 uint8_t _reserved;


 uint8_t txsize;
 uint8_t opcode;
 uint8_t param1;
 uint16_t param2;
 uint8_t  _data [130];






 uint8_t execTime;
 uint16_t rxsize;




} ATCAPacket;
#pragma pack( pop, ATCAPacket)
#line 123 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
ATCA_STATUS atCheckMAC(ATCACommand cacmd, ATCAPacket *packet);
ATCA_STATUS atCounter(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atDeriveKey(ATCACommand cacmd, ATCAPacket *packet,  _Bool  hasMAC );
ATCA_STATUS atECDH(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atGenDig(ATCACommand cacmd, ATCAPacket *packet,  _Bool  hasMACKey );
ATCA_STATUS atGenKey(ATCACommand cacmd, ATCAPacket *packet,  _Bool  isPubKey );
ATCA_STATUS atHMAC(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atInfo(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atLock(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atMAC(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atNonce(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atPause(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atPrivWrite(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atRandom(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atRead(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atSHA(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atSign(ATCACommand cacmd, ATCAPacket *packet);
ATCA_STATUS atUpdateExtra(ATCACommand cacmd, ATCAPacket *packet);
ATCA_STATUS atVerify(ATCACommand cacmd, ATCAPacket *packet);
ATCA_STATUS atWrite(ATCACommand cacmd, ATCAPacket *packet);
ATCA_STATUS atWriteEnc(ATCACommand cacmd, ATCAPacket *packet);

 _Bool  atIsSHAFamily( ATCADeviceType deviceType );
 _Bool  atIsECCFamily( ATCADeviceType deviceType );
ATCA_STATUS isATCAError( uint8_t * _data  );


typedef enum {
 WAKE_TWHI,
 CMD_CHECKMAC,
 CMD_COUNTER,
 CMD_DERIVEKEY,
 CMD_ECDH,
 CMD_GENDIG,
 CMD_GENKEY,
 CMD_HMAC,
 CMD_INFO,
 CMD_LOCK,
 CMD_MAC,
 CMD_NONCE,
 CMD_PAUSE,
 CMD_PRIVWRITE,
 CMD_RANDOM,
 CMD_READMEM,
 CMD_SHA,
 CMD_SIGN,
 CMD_UPDATEEXTRA,
 CMD_VERIFY,
 CMD_WRITEMEM,
 CMD_LASTCOMMAND
} ATCA_CmdMap;

ATCA_STATUS atInitExecTimes(ATCACommand cacmd, ATCADeviceType device_type);
uint16_t atGetExecTime( ATCACommand cacmd, ATCA_CmdMap cmd );

void deleteATCACommand( ATCACommand * );



void atCRC( uint8_t length, uint8_t * _data , uint8_t *crc);
void atCalcCrc( ATCAPacket *pkt);
uint8_t atCheckCrc(uint8_t *response);
#line 316 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
typedef enum {
 COUNTER_MODE_READ = 0,
 COUNTER_MODE_INCREASE = 1
} enum_counter_mode;
#line 330 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
typedef enum {
 SHA_MODE_SHA256_START = ((uint8_t) 0x00),
 SHA_MODE_SHA256_UPDATE = ((uint8_t) 0x01),
 SHA_MODE_SHA256_END = ((uint8_t) 0x02),
 SHA_MODE_SHA256_PUBLIC = ((uint8_t) 0x03),
 SHA_MODE_HMAC_START = ((uint8_t) 0x04),
 SHA_MODE_HMAC_UPDATE = ((uint8_t) 0x05),
 SHA_MODE_HMAC_END = ((uint8_t) 0x04)
} enum_sha_mode;
#line 407 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
typedef enum {
 GENKEY_MODE_PRIVATE_KEY_GENERATE = ((uint8_t) 0x04),
 GENKEY_MODE_PUBLIC_KEY_DIGEST = ((uint8_t) 0x08),
 GENKEY_MODE_DIGEST_IN_TEMPKEY = ((uint8_t) 0x10)
} enum_genkey_mode;
#line 58 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_iface.h"
typedef enum {
 ATCA_I2C_IFACE,
 ATCA_SWI_IFACE,
 ATCA_UART_IFACE,
 ATCA_SPI_IFACE,
 ATCA_HID_IFACE

} ATCAIfaceType;
#line 74 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_iface.h"
typedef struct {

 ATCAIfaceType iface_type;
 ATCADeviceType devtype;

 union {
 struct ATCAI2C {
 uint8_t slave_address;
 uint8_t bus;
 uint32_t baud;
 } atcai2c;

 struct ATCASWI {
 uint8_t bus;
 } atcaswi;

 struct ATCAUART {
 int port;
 uint32_t baud;
 uint8_t wordsize;
 uint8_t parity;
 uint8_t stopbits;
 } atcauart;

 struct ATCAHID {
 int idx;
 uint32_t vid;
 uint32_t pid;
 uint32_t packetsize;
 uint8_t guid[16];
 } atcahid;

 };

 uint16_t wake_delay;
 int rx_retries;
 void *cfg_data;
} ATCAIfaceCfg;
#line 117 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_iface.h"
typedef struct atca_iface
{
 ATCAIfaceType mType;
 ATCAIfaceCfg *mIfaceCFG;

 ATCA_STATUS (*atinit)(void *hal, ATCAIfaceCfg *cfg);
 ATCA_STATUS (*atpostinit)(struct atca_iface *hal);
 ATCA_STATUS (*atsend)(struct atca_iface *hal, uint8_t *txdata, int txlength);
 ATCA_STATUS (*atreceive)(struct atca_iface *hal, uint8_t *rxdata, uint16_t *rxlength);
 ATCA_STATUS (*atwake)(struct atca_iface *hal);
 ATCA_STATUS (*atidle)(struct atca_iface *hal);
 ATCA_STATUS (*atsleep)(struct atca_iface *hal);


 void *hal_data;

}T_atca_iface;

typedef T_atca_iface* ATCAIface;

ATCAIface newATCAIface(ATCAIfaceCfg *cfg);


ATCA_STATUS atinit(ATCAIface caiface);
ATCA_STATUS atpostinit(ATCAIface caiface);
ATCA_STATUS atsend(ATCAIface caiface, uint8_t *txdata, int txlength);
ATCA_STATUS atreceive(ATCAIface caiface, uint8_t *rxdata, uint16_t *rxlength);
ATCA_STATUS atwake(ATCAIface caiface);
ATCA_STATUS atidle(ATCAIface caiface);
ATCA_STATUS atsleep(ATCAIface caiface);


ATCAIfaceCfg * atgetifacecfg(ATCAIface caiface);
void* atgetifacehaldat(ATCAIface caiface);

void deleteATCAIface( ATCAIface *dev );
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/hal/atca_start_config.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/hal/atca_start_iface.h"
#line 63 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/hal/atca_hal.h"
typedef struct
{



 ATCA_STATUS (*halinit)(void *hal, ATCAIfaceCfg *cfg);
 ATCA_STATUS (*halpostinit)(ATCAIface iface);
 ATCA_STATUS (*halsend)(ATCAIface iface, uint8_t *txdata, int txlength);
 ATCA_STATUS (*halreceive)(ATCAIface iface, uint8_t* rxdata, uint16_t* rxlength);
 ATCA_STATUS (*halwake)(ATCAIface iface);
 ATCA_STATUS (*halidle)(ATCAIface iface);
 ATCA_STATUS (*halsleep)(ATCAIface iface);
 ATCA_STATUS (*halrelease)(void* hal_data);

 void *hal_data;
} ATCAHAL_t;
#line 84 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/hal/atca_hal.h"
extern ATCA_STATUS hal_iface_init(ATCAIfaceCfg *, ATCAHAL_t* hal);
extern ATCA_STATUS hal_iface_release(ATCAIfaceType, void* hal_data);
#line 116 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/hal/atca_hal.h"
ATCA_STATUS hal_swi_init(void *hal, ATCAIfaceCfg *cfg);
ATCA_STATUS hal_swi_post_init(ATCAIface iface);
ATCA_STATUS hal_swi_send(ATCAIface iface, uint8_t *txdata, int txlength);
ATCA_STATUS hal_swi_receive( ATCAIface iface, uint8_t *rxdata, uint16_t *rxlength);
ATCA_STATUS hal_swi_wake(ATCAIface iface);
ATCA_STATUS hal_swi_idle(ATCAIface iface);
ATCA_STATUS hal_swi_sleep(ATCAIface iface);
ATCA_STATUS hal_swi_release(void *hal_data );
ATCA_STATUS hal_swi_discover_buses(int swi_buses[], int max_buses);
ATCA_STATUS hal_swi_discover_devices(int busNum, ATCAIfaceCfg *cfg, int *found);
#line 168 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/hal/atca_hal.h"
void atca_delay_us(uint32_t delay);
void atca_delay_10us(uint32_t delay);
void atca_delay_ms(uint32_t delay);
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_status.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_device.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_iface.h"
#line 59 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_device.h"
struct atca_device {
 ATCACommand mCommands;
 ATCAIface mIface;
};

typedef struct atca_device* ATCADevice;
ATCADevice newATCADevice(ATCAIfaceCfg *cfg );


ATCACommand atGetCommands( ATCADevice dev );
ATCAIface atGetIFace( ATCADevice dev );

void deleteATCADevice( ATCADevice *dev );
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_cfgs.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_iface.h"
#line 53 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_cfgs.h"
extern ATCAIfaceCfg SECURE7_ATCA_CFG;
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/basic/atca_basic.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/cryptoauthlib.h"
#line 63 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/basic/atca_basic.h"
ATCA_STATUS atcab_version( char *verstr );
ATCA_STATUS atcab_init(ATCAIfaceCfg *cfg);
ATCA_STATUS atcab_init_device(ATCADevice cadevice);
ATCA_STATUS atcab_release(void);
ATCADevice atcab_getDevice(void);

ATCA_STATUS atcab_wakeup(void);
ATCA_STATUS atcab_idle(void);
ATCA_STATUS atcab_sleep(void);


ATCA_STATUS atcab_cfg_discover( ATCAIfaceCfg cfgArray[], int max);


ATCA_STATUS atcab_info(uint8_t *revision);
ATCA_STATUS atcab_challenge( uint8_t *challenge);
ATCA_STATUS atcab_challenge_seed_update( uint8_t *seed, uint8_t* rand_out);
ATCA_STATUS atcab_nonce( uint8_t *tempkey);
ATCA_STATUS atcab_nonce_rand( uint8_t *seed, uint8_t* rand_out);
ATCA_STATUS atcab_random(uint8_t *rand_out);

ATCA_STATUS atcab_is_locked(uint8_t zone,  _Bool  *lock_state);
ATCA_STATUS atcab_is_slot_locked(uint8_t slot,  _Bool  *lock_state);

ATCA_STATUS atcab_get_addr(uint8_t zone, uint8_t slot, uint8_t block, uint8_t offset, uint16_t* addr);
ATCA_STATUS atcab_read_zone(uint8_t zone, uint8_t slot, uint8_t block, uint8_t offset, uint8_t *_data, uint8_t len);
ATCA_STATUS atcab_write_zone(uint8_t zone, uint8_t slot, uint8_t block, uint8_t offset, uint8_t * _data , uint8_t len);
ATCA_STATUS atcab_write_bytes_slot(uint8_t slot, uint16_t offset, uint8_t * _data , uint8_t len);
ATCA_STATUS atcab_write_bytes_zone(ATCADeviceType dev_type, uint8_t zone, uint16_t address, uint8_t * _data , uint8_t len);
ATCA_STATUS atcab_read_bytes_zone(ATCADeviceType dev_type, uint8_t zone, uint16_t address, uint8_t len, uint8_t * _data );

ATCA_STATUS atcab_read_serial_number(uint8_t* serial_number);
ATCA_STATUS atcab_read_pubkey(uint8_t slot8toF, uint8_t *pubkey);
ATCA_STATUS atcab_write_pubkey(uint8_t slot8toF, uint8_t *pubkey);
ATCA_STATUS atcab_read_sig(uint8_t slot8toF, uint8_t *sig);
ATCA_STATUS atcab_read_ecc_config_zone(uint8_t* config_data);
ATCA_STATUS atcab_write_ecc_config_zone( uint8_t* config_data);
ATCA_STATUS atcab_read_sha_config_zone( uint8_t* config_data);
ATCA_STATUS atcab_write_sha_config_zone( uint8_t* config_data);
ATCA_STATUS atcab_read_config_zone(ATCADeviceType dev_type, uint8_t* config_data);
ATCA_STATUS atcab_write_config_zone(ATCADeviceType dev_type, uint8_t* config_data);
ATCA_STATUS atcab_cmp_config_zone(uint8_t* config_data,  _Bool * same_config);

ATCA_STATUS atcab_read_enc(uint8_t slotid, uint8_t block, uint8_t * _data , uint8_t* enckey, uint16_t enckeyid);
ATCA_STATUS atcab_write_enc(uint8_t slotid, uint8_t block, uint8_t * _data , uint8_t* enckey, uint16_t enckeyid);

ATCA_STATUS atcab_lock_config_zone(uint8_t* lock_response);
ATCA_STATUS atcab_lock_data_zone(uint8_t* lock_response);
ATCA_STATUS atcab_lock_data_slot(uint8_t slot, uint8_t* lock_response);

ATCA_STATUS atcab_priv_write(uint8_t slot, uint8_t priv_key[36], uint8_t write_key_slot, uint8_t write_key[32]);
ATCA_STATUS atcab_genkey( int slot, uint8_t *pubkey );
ATCA_STATUS atcab_get_pubkey(uint8_t privSlotId, uint8_t *pubkey);
ATCA_STATUS atcab_calc_pubkey(uint8_t privSlotId, uint8_t *pubkey);
ATCA_STATUS atcab_sign(uint16_t slot, uint8_t *msg, uint8_t *signature);
ATCA_STATUS atcab_verify_extern( uint8_t *message, uint8_t *signature, uint8_t *pubkey,  _Bool  *verified);
ATCA_STATUS atcab_ecdh(uint16_t key_id, uint8_t* pub_key, uint8_t* ret_ecdh);
ATCA_STATUS atcab_ecdh_enc(uint16_t slotid, uint8_t* pubkey, uint8_t* ret_ecdh, uint8_t* enckey, uint8_t enckeyid);
ATCA_STATUS atcab_gendig(uint8_t zone, uint16_t key_id);
ATCA_STATUS atcab_gendig_host(uint8_t zone, uint16_t key_id, uint8_t *other_data, uint8_t len);
ATCA_STATUS atcab_mac( uint8_t mode, uint16_t key_id, uint8_t* challenge, uint8_t* digest );
ATCA_STATUS atcab_checkmac( uint8_t mode, uint16_t key_id, uint8_t *challenge, uint8_t *response, uint8_t *other_data);

ATCA_STATUS atcab_sha_start(void);
ATCA_STATUS atcab_sha_update(uint16_t length, uint8_t *message);
ATCA_STATUS atcab_sha_end(uint8_t *digest, uint16_t length, uint8_t *message);
ATCA_STATUS atcab_sha(uint16_t length, uint8_t *message, uint8_t *digest);
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/basic/atca_helpers.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/cryptoauthlib.h"
#line 68 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/basic/atca_helpers.h"
ATCA_STATUS packHex( char* asciiHex, int asciiHexLen, char* packedHex, int* packedLen);
 _Bool  isDigit(char c);
 _Bool  isWhiteSpace(char c);
 _Bool  isHexAlpha(char c);
 _Bool  isHex(char c);
 _Bool  isHexDigit(char c);
#line 158 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/host/atca_host.h"
typedef struct atca_temp_key {
 uint8_t value[ 32 ];
 unsigned int key_id : 4;
 unsigned int source_flag : 1;
 unsigned int gen_data : 1;
 unsigned int check_flag : 1;
 unsigned int valid : 1;
} atca_temp_key_t;
#line 177 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/host/atca_host.h"
struct atca_include_data_in_out {
 uint8_t *p_temp;
 uint8_t *otp;
 uint8_t *sn;
 uint8_t mode;
};
#line 196 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/host/atca_host.h"
typedef struct atca_nonce_in_out {
 uint8_t mode;
 uint8_t *num_in;
 uint8_t *rand_out;
 struct atca_temp_key *temp_key;
} atca_nonce_in_out_t;
#line 223 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/host/atca_host.h"
struct atca_mac_in_out {
 uint8_t mode;
 uint16_t key_id;
 uint8_t *challenge;
 uint8_t *key;
 uint8_t *otp;
 uint8_t *sn;
 uint8_t *response;
 struct atca_temp_key *temp_key;
};
#line 252 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/host/atca_host.h"
struct atca_hmac_in_out {
 uint8_t mode;
 uint16_t key_id;
 uint8_t *key;
 uint8_t *otp;
 uint8_t *sn;
 uint8_t *response;
 struct atca_temp_key *temp_key;
};
#line 274 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/host/atca_host.h"
typedef struct atca_gen_dig_in_out {
 uint8_t zone;
 uint16_t key_id;
 uint8_t *stored_value;
 struct atca_temp_key *temp_key;
} atca_gen_dig_in_out_t;
#line 298 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/host/atca_host.h"
typedef struct atca_write_mac_in_out {
 uint8_t zone;
 uint16_t key_id;
 uint8_t *encryption_key;
 uint8_t *input_data;
 uint8_t *encrypted_data;
 uint8_t *auth_mac;
 struct atca_temp_key *temp_key;
} atca_write_mac_in_out_t;
#line 321 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/host/atca_host.h"
struct atca_derive_key_in_out {
 uint8_t random;
 uint16_t target_key_id;
 uint8_t *parent_key;
 uint8_t *target_key;
 struct atca_temp_key *temp_key;
};
#line 341 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/host/atca_host.h"
struct atca_derive_key_mac_in_out {
 uint8_t random;
 uint16_t target_key_id;
 uint8_t *parent_key;
 uint8_t *mac;
};
#line 362 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/host/atca_host.h"
struct atca_encrypt_in_out {
 uint8_t zone;
 uint16_t address;
 uint8_t *crypto_data;
 uint8_t *mac;
 struct atca_temp_key *temp_key;
};
#line 378 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/host/atca_host.h"
struct atca_decrypt_in_out {
 uint8_t *crypto_data;
 struct atca_temp_key *temp_key;
};
#line 401 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/host/atca_host.h"
struct atca_check_mac_in_out {
 uint8_t mode;
 uint8_t *password;
 uint8_t *other_data;
 uint8_t *otp;
 uint8_t *target_key;
 uint8_t *client_resp;
 struct atca_temp_key *temp_key;
};
#line 423 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/host/atca_host.h"
struct atca_verify_in_out {
 uint16_t curve_type;
 uint8_t *signature;
 uint8_t *public_key;
 struct atca_temp_key *temp_key;
};
#line 434 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/host/atca_host.h"
ATCA_STATUS atcah_nonce(struct atca_nonce_in_out *param);
ATCA_STATUS atcah_mac(struct atca_mac_in_out *param);
ATCA_STATUS atcah_check_mac(struct atca_check_mac_in_out *param);
ATCA_STATUS atcah_hmac(struct atca_hmac_in_out *param);
ATCA_STATUS atcah_gen_dig(struct atca_gen_dig_in_out *param);
ATCA_STATUS atcah_gen_mac(struct atca_gen_dig_in_out *param);
ATCA_STATUS atcah_write_auth_mac(struct atca_write_mac_in_out *param);
ATCA_STATUS atcah_privwrite_auth_mac(struct atca_write_mac_in_out *param);
ATCA_STATUS atcah_derive_key(struct atca_derive_key_in_out *param);
ATCA_STATUS atcah_derive_key_mac(struct atca_derive_key_mac_in_out *param);
ATCA_STATUS atcah_encrypt(struct atca_encrypt_in_out *param);
ATCA_STATUS atcah_decrypt(struct atca_decrypt_in_out *param);
ATCA_STATUS atcah_sha256(int32_t len, uint8_t *message, uint8_t *digest);
uint8_t *atcah_include_data(struct atca_include_data_in_out *param);
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/crypto/atca_crypto_sw_sha2.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/crypto/atca_crypto_sw.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_status.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stddef.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"
#line 59 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/crypto/atca_crypto_sw_sha2.h"
typedef struct {
 uint32_t pad[48];
} atcac_sha2_256_ctx;
#line 67 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/crypto/atca_crypto_sw_sha2.h"
int atcac_sw_sha2_256_init(atcac_sha2_256_ctx* ctx);
int atcac_sw_sha2_256_update(atcac_sha2_256_ctx* ctx, uint8_t*  _data , size_t data_size);
int atcac_sw_sha2_256_finish(atcac_sha2_256_ctx * ctx, uint8_t digest[ (32) ]);
int atcac_sw_sha2_256( uint8_t *  _data , size_t data_size, uint8_t digest[ (32) ]);
#line 51 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/host/atca_host.c"
uint8_t *atcah_include_data(struct atca_include_data_in_out *param)
{
 if (param->mode &  ((uint8_t)0x10) ) {
 memcpy(param->p_temp, param->otp,  ( 8)  +  ( 3) );
 param->p_temp +=  ( 8)  +  ( 3) ;
 }else {
 if (param->mode &  ((uint8_t)0x20) )
 memcpy(param->p_temp, param->otp,  ( 8) );
 else
 memset(param->p_temp, 0,  ( 8) );
 param->p_temp +=  ( 8) ;

 memset(param->p_temp, 0,  ( 3) );
 param->p_temp +=  ( 3) ;
 }


 *param->p_temp++ =  (0xEE) ;


 if (param->mode &  ((uint8_t)0x40) )
 memcpy(param->p_temp, &param->sn[4],  ( 4) );
 else
 memset(param->p_temp, 0,  ( 4) );
 param->p_temp +=  ( 4) ;


 *param->p_temp++ =  (0x01) ;
 *param->p_temp++ =  (0x23) ;


 if (param->mode &  ((uint8_t)0x40) )
 memcpy(param->p_temp, &param->sn[2],  ( 2) );
 else
 memset(param->p_temp, 0,  ( 2) );
 param->p_temp +=  ( 2) ;

 return param->p_temp;
}
#line 102 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/host/atca_host.c"
ATCA_STATUS atcah_nonce(struct atca_nonce_in_out *param)
{
 uint8_t temporary[ (55) ];
 uint8_t *p_temp;


 if (!param->temp_key || !param->num_in || (param->mode >  ((uint8_t)0x03) ) || (param->mode ==  ((uint8_t)0x02) )
 || (((param->mode ==  ((uint8_t)0x00)  || (param->mode ==  ((uint8_t)0x01) )) && !param->rand_out)))
 return ATCA_BAD_PARAM;


 if ((param->mode ==  ((uint8_t)0x00) ) || (param->mode ==  ((uint8_t)0x01) )) {

 p_temp = temporary;

 memcpy(p_temp, param->rand_out,  ((uint8_t)35)  -  ( ((uint8_t)1)  + ((uint8_t)2) ) );
 p_temp +=  ((uint8_t)35)  -  ( ((uint8_t)1)  + ((uint8_t)2) ) ;

 memcpy(p_temp, param->num_in,  (20) );
 p_temp +=  (20) ;

 *p_temp++ =  ((uint8_t)0x16) ;
 *p_temp++ = param->mode;
 *p_temp++ = 0x00;


 atcah_sha256( (55) , temporary, param->temp_key->value);


 param->temp_key->source_flag = 0;
 }else if (param->mode ==  ((uint8_t)0x03) ) {

 memcpy(param->temp_key->value, param->num_in,  (32) );


 param->temp_key->source_flag = 1;
 }


 param->temp_key->key_id = 0;
 param->temp_key->gen_data = 0;
 param->temp_key->check_flag = 0;
 param->temp_key->valid = 1;

 return ATCA_SUCCESS;
}
#line 158 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/host/atca_host.c"
ATCA_STATUS atcah_mac(struct atca_mac_in_out *param)
{
 uint8_t temporary[ (88) ];
 uint8_t *p_temp;
 struct atca_include_data_in_out include_data;


 include_data.otp = param->otp;
 include_data.sn = param->sn;
 include_data.mode = param->mode;


 if (!param->response
 || (param->mode & ~ ((uint8_t)0x77) )
 || (!(param->mode &  ((uint8_t)0x02) ) && !param->key)
 || (!(param->mode &  ((uint8_t)0x01) ) && !param->challenge)
 || ((param->mode &  ((uint8_t)0x03) ) && !param->temp_key)
 || (((param->mode &  ((uint8_t)0x20) ) || (param->mode &  ((uint8_t)0x10) )) && !param->otp)
 || ((param->mode &  ((uint8_t)0x40) ) && !param->sn)
 )
 return ATCA_BAD_PARAM;


 if (((param->mode &  ((uint8_t)0x03) ) != 0)

 && (param->temp_key->check_flag || (param->temp_key->valid != 1)


 || (!(param->mode &  ((uint8_t)0x04) ) != !(param->temp_key->source_flag)))
 ) {

 param->temp_key->valid = 0;
 return ATCA_EXECUTION_ERROR;
 }


 p_temp = temporary;


 memcpy( p_temp, param->mode &  ((uint8_t)0x02)  ? (void*)param->temp_key->value : (void*)param->key,  (32) );
 p_temp +=  (32) ;


 memcpy(p_temp, param->mode &  ((uint8_t)0x01)  ? (void*)param->temp_key->value : (void*)param->challenge,  (32) );
 p_temp +=  (32) ;


 *p_temp++ =  ((uint8_t)0x08) ;


 *p_temp++ = param->mode;


 *p_temp++ = param->key_id & 0xFF;
 *p_temp++ = (param->key_id >> 8) & 0xFF;

 include_data.p_temp = p_temp;
 atcah_include_data(&include_data);


 atcah_sha256( (88) , temporary, param->response);


 if (param->temp_key)
 param->temp_key->valid = 0;

 return ATCA_SUCCESS;
}
#line 249 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/host/atca_host.c"
ATCA_STATUS atcah_check_mac(struct atca_check_mac_in_out *param)
{
 uint8_t temporary[ (88) ];
 uint8_t *p_temp;


 if (((param->mode &  ((uint8_t)0x03) ) !=  ((uint8_t)0x01) )
 || !param->password || !param->other_data
 || !param->target_key || !param->client_resp || !param->temp_key
 || ((param->mode &  ((uint8_t)0x20) ) && !param->otp)
 )
 return ATCA_BAD_PARAM;



 if (param->temp_key->check_flag || (param->temp_key->valid != 1) || param->temp_key->source_flag) {

 param->temp_key->valid = 0;
 return ATCA_EXECUTION_ERROR;
 }


 p_temp = temporary;


 memcpy(p_temp, param->password,  (32) );
 p_temp +=  (32) ;


 memcpy(p_temp, param->temp_key->value,  (32) );
 p_temp +=  (32) ;


 memcpy(p_temp, &param->other_data[0],  ( 4) );
 p_temp +=  ( 4) ;


 if (param->mode &  ((uint8_t)0x20) )
 memcpy(p_temp, param->otp,  ( 8) );
 else
 memset(p_temp, 0,  ( 8) );
 p_temp +=  ( 8) ;


 memcpy(p_temp, &param->other_data[ ( 4) ],  ( 3) );
 p_temp +=  ( 3) ;


 *p_temp++ =  (0xEE) ;


 memcpy(p_temp, &param->other_data[ ( 4)  +  ( 3) ],  ( 4) );
 p_temp +=  ( 4) ;


 *p_temp++ =  (0x01) ;
 *p_temp++ =  (0x23) ;


 memcpy(p_temp, &param->other_data[ ( 4)  +  ( 3)  +  ( 2) ],
  ( 2) );
 p_temp +=  ( 2) ;


 atcah_sha256( (88) , temporary, param->client_resp);


 memcpy(param->temp_key->value, param->target_key,  (32) );
 param->temp_key->gen_data = 0;
 param->temp_key->source_flag = 1;
 param->temp_key->valid = 1;

 return ATCA_SUCCESS;
}
#line 333 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/host/atca_host.c"
ATCA_STATUS atcah_hmac(struct atca_hmac_in_out *param)
{

 struct atca_include_data_in_out include_data;
 uint8_t temporary[ (152) ];
 uint8_t i;
 uint8_t *p_temp;


 include_data.otp = param->otp;
 include_data.sn = param->sn;
 include_data.mode = param->mode;


 if (!param->response || !param->key || !param->temp_key
 || (param->mode & ~ ((uint8_t)0x74) )
 || (((param->mode &  ((uint8_t)0x20) ) || (param->mode &  ((uint8_t)0x10) )) && !param->otp)
 || ((param->mode &  ((uint8_t)0x40) ) && !param->sn)
 )
 return ATCA_BAD_PARAM;


 if (
 param->temp_key->check_flag || (param->temp_key->valid != 1)


 || (!(param->mode &  ((uint8_t)0x04) ) != !(param->temp_key->source_flag))
 ) {

 param->temp_key->valid = 0;
 return ATCA_EXECUTION_ERROR;
 }


 p_temp = temporary;




 for (i = 0; i <  (32) ; i++)
 *p_temp++ = param->key[i] ^ 0x36;


 for (i = 0; i <  (64)  -  (32) ; i++)
 *p_temp++ = 0 ^ 0x36;



 memset(p_temp, 0,  (64)  -  (32) );
 p_temp +=  (64)  -  (32) ;


 memcpy(p_temp, param->temp_key->value,  (32) );
 p_temp +=  (32) ;


 *p_temp++ =  ((uint8_t)0x11) ;


 *p_temp++ = param->mode;


 *p_temp++ = param->key_id & 0xFF;
 *p_temp++ = (param->key_id >> 8) & 0xFF;



 atcah_sha256( (152) , temporary, param->response);


 p_temp = temporary;


 for (i = 0; i <  (32) ; i++)
 *p_temp++ = param->key[i] ^ 0x5C;


 for (i = 0; i <  (64)  -  (32) ; i++)
 *p_temp++ = 0 ^ 0x5C;


 memcpy(p_temp, param->response,  (32) );
 p_temp +=  (32) ;

 include_data.p_temp = p_temp;
 atcah_include_data(&include_data);


 atcah_sha256( (96) , temporary, param->response);


 param->temp_key->valid = 0;

 return ATCA_SUCCESS;
}
#line 443 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/host/atca_host.c"
ATCA_STATUS atcah_gen_dig(struct atca_gen_dig_in_out *param)
{
 uint8_t temporary[ (96) ];
 uint8_t *p_temp;


 if (!param->stored_value || !param->temp_key
 || ((param->zone !=  ((uint8_t)1) )
 && (param->zone !=  ((uint8_t)2) )
 && (param->zone !=  ((uint8_t)0) ))
 )
 return ATCA_BAD_PARAM;


 if (
 param->temp_key->check_flag || (param->temp_key->valid != 1)
 ) {

 param->temp_key->valid = 0;
 return ATCA_EXECUTION_ERROR;
 }


 p_temp = temporary;



 memcpy(p_temp, param->stored_value,  (32) );
 p_temp +=  (32) ;


 *p_temp++ =  ((uint8_t)0x15) ;


 *p_temp++ = param->zone;


 *p_temp++ = param->key_id & 0xFF;
 *p_temp++ = (param->key_id >> 8) & 0xFF;


 *p_temp++ =  (0xEE) ;


 *p_temp++ =  (0x01) ;
 *p_temp++ =  (0x23) ;


 memset(p_temp, 0,  (25) );
 p_temp +=  (25) ;


 memcpy(p_temp, param->temp_key->value,  (32) );


 atcah_sha256( (96) , temporary, param->temp_key->value);


 param->temp_key->valid = 1;

 if ((param->zone ==  ((uint8_t)2) ) && (param->key_id <= 15)) {
 param->temp_key->gen_data = 1;
 param->temp_key->key_id = (param->key_id & 0xF);
 }else {
 param->temp_key->gen_data = 0;
 param->temp_key->key_id = 0;
 }

 return ATCA_SUCCESS;
}
#line 518 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/host/atca_host.c"
ATCA_STATUS atcah_gen_mac(struct atca_gen_dig_in_out *param)
{
 uint8_t temporary[ (96) ];
 uint8_t *p_temp;


 if (!param->stored_value || !param->temp_key)
 return ATCA_BAD_PARAM;


 if (
 param->temp_key->check_flag || (param->temp_key->valid != 1)
 ) {

 param->temp_key->valid = 0;
 return ATCA_EXECUTION_ERROR;
 }


 p_temp = temporary;



 memcpy(p_temp, param->temp_key->value,  (32) );
 p_temp +=  (32) ;


 *p_temp++ =  ((uint8_t)0x12) ;


 *p_temp++ = param->zone;


 *p_temp++ = param->key_id & 0xFF;
 *p_temp++ = (param->key_id >> 8) & 0xFF;


 *p_temp++ =  (0xEE) ;


 *p_temp++ =  (0x01) ;
 *p_temp++ =  (0x23) ;


 memset(p_temp, 0,  (25) );
 p_temp +=  (25) ;


 memcpy(p_temp, param->stored_value,  (32) );


 atcah_sha256( (96) , temporary, param->temp_key->value);


 param->temp_key->valid = 1;

 if ((param->zone ==  ((uint8_t)2) ) && (param->key_id <= 15)) {
 param->temp_key->gen_data = 1;
 param->temp_key->key_id = (param->key_id & 0xF);
 }else {
 param->temp_key->gen_data = 0;
 param->temp_key->key_id = 0;
 }

 return ATCA_SUCCESS;
}
#line 592 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/host/atca_host.c"
ATCA_STATUS atcah_write_auth_mac(struct atca_write_mac_in_out *param)
{
 uint8_t temporary[ (96) ];
 uint8_t i;
 uint8_t *p_temp;
 uint8_t session_key2[32];


 if (!param->input_data || !param->temp_key)
 return ATCA_BAD_PARAM;


 if (
 param->temp_key->check_flag || (param->temp_key->valid != 1)
 ) {

 param->temp_key->valid = 0;
 return ATCA_EXECUTION_ERROR;
 }

 for (i = 0; i < 32; i++)
 param->encrypted_data[i] = param->encryption_key[i] ^ param->temp_key->value[i];


 atcah_sha256(32, param->temp_key->value, session_key2);


 if (param->auth_mac) {

 p_temp = temporary;


 memcpy(p_temp, param->temp_key->value,  (32) );
 p_temp +=  (32) ;


 *p_temp++ =  ((uint8_t)0x46) ;


 *p_temp++ = param->zone;


 *p_temp++ = param->key_id & 0xFF;
 *p_temp++ = (param->key_id >> 8) & 0xFF;


 *p_temp++ =  (0xEE) ;


 *p_temp++ =  (0x01) ;
 *p_temp++ =  (0x23) ;


 memset(p_temp, 0,  (21) );
 p_temp +=  (21) ;


 memcpy(p_temp, param->input_data,  (36) );


 atcah_sha256( (96) , temporary, param->auth_mac);
 }

 param->temp_key->valid = 1;

 return ATCA_SUCCESS;
}
#line 667 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/host/atca_host.c"
ATCA_STATUS atcah_privwrite_auth_mac(struct atca_write_mac_in_out *param)
{
 uint8_t temporary[ (96) ];
 uint8_t i;
 uint8_t *p_temp;
 uint8_t session_key2[32];


 if (!param->input_data || !param->temp_key)
 return ATCA_BAD_PARAM;


 if (
 param->temp_key->check_flag || (param->temp_key->valid != 1)
 ) {

 param->temp_key->valid = 0;
 return ATCA_EXECUTION_ERROR;
 }
#line 692 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/host/atca_host.c"
 for (i = 0; i < 4; i++)
 param->encrypted_data[i] = 0 ^ param->temp_key->value[i];


 for (i = 4; i < 32; i++)
 param->encrypted_data[i] = param->encryption_key[i - 4] ^ param->temp_key->value[i];


 atcah_sha256(32, param->temp_key->value, session_key2);


 for (i = 32; i < 36; i++)
 param->encrypted_data[i] = param->encryption_key[i - 4] ^ session_key2[i - 32];


 if (param->auth_mac) {

 p_temp = temporary;


 memcpy(p_temp, param->temp_key->value,  (32) );
 p_temp +=  (32) ;


 *p_temp++ =  ((uint8_t)0x46) ;


 *p_temp++ = param->zone;


 *p_temp++ = param->key_id & 0xFF;
 *p_temp++ = (param->key_id >> 8) & 0xFF;


 *p_temp++ =  (0xEE) ;


 *p_temp++ =  (0x01) ;
 *p_temp++ =  (0x23) ;


 memset(p_temp, 0,  (21) );
 p_temp +=  (21) ;


 memcpy(p_temp, param->input_data,  (36) );


 atcah_sha256( (96) , temporary, param->auth_mac);
 }


 param->temp_key->valid = 1;

 return ATCA_SUCCESS;
}
#line 763 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/host/atca_host.c"
ATCA_STATUS atcah_derive_key(struct atca_derive_key_in_out *param)
{
 uint8_t temporary[ (96) ];
 uint8_t *p_temp;


 if (!param->parent_key || !param->target_key || !param->temp_key
 || (param->random & ~ ((uint8_t)4) ) || (param->target_key_id >  ((uint8_t)15) ))
 return ATCA_BAD_PARAM;



 if (
 param->temp_key->check_flag || (param->temp_key->valid != 1)


 || (!(param->random &  ((uint8_t)4) ) != !(param->temp_key->source_flag))
 ) {

 param->temp_key->valid = 0;
 return ATCA_EXECUTION_ERROR;
 }


 p_temp = temporary;


 memcpy(p_temp, param->parent_key,  (32) );
 p_temp +=  (32) ;


 *p_temp++ =  ((uint8_t)0x1C) ;


 *p_temp++ = param->random;


 *p_temp++ = param->target_key_id & 0xFF;
 *p_temp++ = (param->target_key_id >> 8) & 0xFF;


 *p_temp++ =  (0xEE) ;


 *p_temp++ =  (0x01) ;
 *p_temp++ =  (0x23) ;


 memset(p_temp, 0,  (25) );
 p_temp +=  (25) ;


 memcpy(p_temp, param->temp_key->value,  (32) );
 p_temp +=  (32) ;


 atcah_sha256( (96) , temporary, param->target_key);


 param->temp_key->valid = 0;

 return ATCA_SUCCESS;
}
#line 835 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/host/atca_host.c"
ATCA_STATUS atcah_derive_key_mac(struct atca_derive_key_mac_in_out *param)
{
 uint8_t temporary[ (39) ];
 uint8_t *p_temp;


 if (!param->parent_key || !param->mac || (param->random & ~ ((uint8_t)4) )
 || (param->target_key_id >  ((uint8_t)15) ))
 return ATCA_BAD_PARAM;


 p_temp = temporary;


 memcpy(p_temp, param->parent_key,  (32) );
 p_temp +=  (32) ;


 *p_temp++ =  ((uint8_t)0x1C) ;


 *p_temp++ = param->random;


 *p_temp++ = param->target_key_id & 0xFF;
 *p_temp++ = (param->target_key_id >> 8) & 0xFF;


 *p_temp++ =  (0xEE) ;


 *p_temp++ =  (0x01) ;
 *p_temp++ =  (0x23) ;


 atcah_sha256( (39) , temporary, param->mac);

 return ATCA_SUCCESS;
}
#line 895 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/host/atca_host.c"
ATCA_STATUS atcah_encrypt(struct atca_encrypt_in_out *param)
{
 uint8_t temporary[ (96) ];
 uint8_t i;
 uint8_t *p_temp;


 if (!param->crypto_data || !param->temp_key || (param->zone & ~ ((uint8_t)0xC3) ))
 return ATCA_BAD_PARAM;





 if (
 param->temp_key->check_flag

 || (param->temp_key->valid != 1)

 || (param->temp_key->gen_data != 1)

 || param->temp_key->source_flag

 || (param->address & ~ (0x007F) )
 ) {

 param->temp_key->valid = 0;
 return ATCA_EXECUTION_ERROR;
 }


 if (param->mac) {

 p_temp = temporary;


 memcpy(p_temp, param->temp_key->value,  (32) );
 p_temp +=  (32) ;


 *p_temp++ =  ((uint8_t)0x12) ;


 *p_temp++ = param->zone;


 *p_temp++ = param->address & 0xFF;
 *p_temp++ = (param->address >> 8) & 0xFF;


 *p_temp++ =  (0xEE) ;


 *p_temp++ =  (0x01) ;
 *p_temp++ =  (0x23) ;


 memset(p_temp, 0,  (25) );
 p_temp +=  (25) ;


 memcpy(p_temp, param->crypto_data,  (32) );


 atcah_sha256( (96) , temporary, param->mac);
 }


 for (i = 0; i <  (32) ; i++)
 param->crypto_data[i] ^= param->temp_key->value[i];


 param->temp_key->valid = 0;

 return ATCA_SUCCESS;
}
#line 989 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/host/atca_host.c"
ATCA_STATUS atcah_decrypt(struct atca_decrypt_in_out *param)
{
 uint8_t i;


 if (!param->crypto_data || !param->temp_key)
 return ATCA_BAD_PARAM;





 if (
 param->temp_key->check_flag

 || (param->temp_key->valid != 1)

 || (param->temp_key->gen_data != 1)

 || param->temp_key->source_flag
 ) {

 param->temp_key->valid = 0;
 return ATCA_EXECUTION_ERROR;
 }


 for (i = 0; i <  (32) ; i++)
 param->crypto_data[i] ^= param->temp_key->value[i];


 param->temp_key->valid = 0;

 return ATCA_SUCCESS;
}
#line 1034 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/host/atca_host.c"
ATCA_STATUS atcah_sha256(int32_t len, uint8_t *message, uint8_t *digest)
{
 return atcac_sw_sha2_256(message, len, digest);
}
