_atcatls_config_default:
;atcatls.c,230 :: 		ATCA_STATUS atcatls_config_default()
SUB	SP, SP, #76
STR	LR, [SP, #0]
;atcatls.c,232 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atcatls.c,233 :: 		bool isLocked = false;
ADD	R11, SP, #4
ADD	R10, R11, #70
MOVW	R12, #lo_addr(?ICSatcatls_config_default_isLocked_L0+0)
MOVT	R12, #hi_addr(?ICSatcatls_config_default_isLocked_L0+0)
BL	___CC2DW+0
;atcatls.c,234 :: 		bool sameConfig = false;
;atcatls.c,235 :: 		uint8_t lockRsp[LOCK_RSP_SIZE] = { 0 };
;atcatls.c,236 :: 		uint8_t pubkey[ATCA_PUB_KEY_SIZE] = { 0 };
;atcatls.c,240 :: 		if ((status = atcab_is_locked(LOCK_ZONE_CONFIG, &isLocked)) != ATCA_SUCCESS) BREAK(status, "Read of lock byte failed");
ADD	R0, SP, #4
MOV	R1, R0
MOVS	R0, #0
BL	_atcab_is_locked+0
STRB	R0, [SP, #74]
CMP	R0, #0
IT	EQ
BEQ	L_atcatls_config_default3
IT	AL
BAL	L_atcatls_config_default1
L_atcatls_config_default3:
;atcatls.c,242 :: 		if (isLocked == false) {
LDRB	R0, [SP, #4]
CMP	R0, #0
IT	NE
BNE	L_atcatls_config_default4
;atcatls.c,244 :: 		if ((status = atcab_write_ecc_config_zone(config_data_default)) != ATCA_SUCCESS) BREAK(status, "Write config zone failed");
MOVW	R0, #lo_addr(_config_data_default+0)
MOVT	R0, #hi_addr(_config_data_default+0)
BL	_atcab_write_ecc_config_zone+0
STRB	R0, [SP, #74]
CMP	R0, #0
IT	EQ
BEQ	L_atcatls_config_default5
IT	AL
BAL	L_atcatls_config_default1
L_atcatls_config_default5:
;atcatls.c,247 :: 		if ((status = atcab_lock_config_zone(lockRsp) != ATCA_SUCCESS)) BREAK(status, "Lock config zone failed");
ADD	R0, SP, #6
BL	_atcab_lock_config_zone+0
CMP	R0, #0
MOVW	R0, #0
BEQ	L__atcatls_config_default213
MOVS	R0, #1
L__atcatls_config_default213:
STRB	R0, [SP, #74]
UXTB	R0, R0
CMP	R0, #0
IT	EQ
BEQ	L_atcatls_config_default6
IT	AL
BAL	L_atcatls_config_default1
L_atcatls_config_default6:
;atcatls.c,251 :: 		if ((status = atcab_genkey(TLS_SLOT_AUTH_PRIV, pubkey)) != ATCA_SUCCESS) BREAK(status, "Genkey failed:AUTH_PRIV_SLOT");
ADD	R0, SP, #10
MOV	R1, R0
MOVS	R0, #0
SXTH	R0, R0
BL	_atcab_genkey+0
STRB	R0, [SP, #74]
CMP	R0, #0
IT	EQ
BEQ	L_atcatls_config_default7
IT	AL
BAL	L_atcatls_config_default1
L_atcatls_config_default7:
;atcatls.c,252 :: 		if ((status = atcab_genkey(TLS_SLOT_ECDH_PRIV, pubkey)) != ATCA_SUCCESS) BREAK(status, "Genkey failed:ECDH_PRIV_SLOT");
ADD	R0, SP, #10
MOV	R1, R0
MOVS	R0, #2
SXTH	R0, R0
BL	_atcab_genkey+0
STRB	R0, [SP, #74]
CMP	R0, #0
IT	EQ
BEQ	L_atcatls_config_default8
IT	AL
BAL	L_atcatls_config_default1
L_atcatls_config_default8:
;atcatls.c,253 :: 		if ((status = atcab_genkey(TLS_SLOT_FEATURE_PRIV, pubkey)) != ATCA_SUCCESS) BREAK(status, "Genkey failed:FEATURE_PRIV_SLOT");
ADD	R0, SP, #10
MOV	R1, R0
MOVS	R0, #7
SXTH	R0, R0
BL	_atcab_genkey+0
STRB	R0, [SP, #74]
CMP	R0, #0
IT	EQ
BEQ	L_atcatls_config_default9
IT	AL
BAL	L_atcatls_config_default1
L_atcatls_config_default9:
;atcatls.c,254 :: 		}else {
IT	AL
BAL	L_atcatls_config_default10
L_atcatls_config_default4:
;atcatls.c,256 :: 		if ((status = atcab_cmp_config_zone(config_data_default, &sameConfig)) != ATCA_SUCCESS) BREAK(status, "Config compare failed");
ADD	R0, SP, #5
MOV	R1, R0
MOVW	R0, #lo_addr(_config_data_default+0)
MOVT	R0, #hi_addr(_config_data_default+0)
BL	_atcab_cmp_config_zone+0
STRB	R0, [SP, #74]
CMP	R0, #0
IT	EQ
BEQ	L_atcatls_config_default11
IT	AL
BAL	L_atcatls_config_default1
L_atcatls_config_default11:
;atcatls.c,257 :: 		if (sameConfig == false) {
LDRB	R0, [SP, #5]
CMP	R0, #0
IT	NE
BNE	L_atcatls_config_default12
;atcatls.c,259 :: 		status = ATCA_GEN_FAIL;
MOVS	R0, #225
STRB	R0, [SP, #74]
;atcatls.c,260 :: 		BREAK(status, "The device is locked with the wrong configuration");
IT	AL
BAL	L_atcatls_config_default1
;atcatls.c,261 :: 		}
L_atcatls_config_default12:
;atcatls.c,262 :: 		}
L_atcatls_config_default10:
;atcatls.c,265 :: 		atcab_lock_data_zone(lockRsp);
ADD	R0, SP, #6
BL	_atcab_lock_data_zone+0
;atcatls.c,267 :: 		} while (0);
L_atcatls_config_default1:
;atcatls.c,269 :: 		return status;
LDRB	R0, [SP, #74]
;atcatls.c,270 :: 		}
L_end_atcatls_config_default:
LDR	LR, [SP, #0]
ADD	SP, SP, #76
BX	LR
; end of _atcatls_config_default
_atcatls_init:
;atcatls.c,276 :: 		ATCA_STATUS atcatls_init(ATCAIfaceCfg* pCfg)
; pCfg start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; pCfg end address is: 0 (R0)
; pCfg start address is: 0 (R0)
;atcatls.c,278 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atcatls.c,281 :: 		status = atcab_init(pCfg);
; pCfg end address is: 0 (R0)
BL	_atcab_init+0
;atcatls.c,282 :: 		return status;
;atcatls.c,283 :: 		}
L_end_atcatls_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atcatls_init
_atcatls_finish:
;atcatls.c,288 :: 		ATCA_STATUS atcatls_finish()
SUB	SP, SP, #4
STR	LR, [SP, #0]
;atcatls.c,290 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atcatls.c,293 :: 		status = atcab_release();
BL	_atcab_release+0
;atcatls.c,294 :: 		return status;
;atcatls.c,295 :: 		}
L_end_atcatls_finish:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atcatls_finish
_atcatls_get_sn:
;atcatls.c,301 :: 		ATCA_STATUS atcatls_get_sn(uint8_t sn_out[ATCA_SERIAL_NUM_SIZE])
; sn_out start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; sn_out end address is: 0 (R0)
; sn_out start address is: 0 (R0)
;atcatls.c,303 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atcatls.c,307 :: 		if ((status = atcab_read_serial_number(sn_out)) != ATCA_SUCCESS) BREAK(status, "Get serial number failed");
; sn_out end address is: 0 (R0)
BL	_atcab_read_serial_number+0
; status start address is: 4 (R1)
UXTB	R1, R0
CMP	R0, #0
IT	EQ
BEQ	L_atcatls_get_sn16
IT	AL
BAL	L_atcatls_get_sn14
L_atcatls_get_sn16:
;atcatls.c,309 :: 		} while (0);
L_atcatls_get_sn14:
;atcatls.c,311 :: 		return status;
UXTB	R0, R1
; status end address is: 4 (R1)
;atcatls.c,312 :: 		}
L_end_atcatls_get_sn:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atcatls_get_sn
_atcatls_sign:
;atcatls.c,320 :: 		ATCA_STATUS atcatls_sign(uint8_t slotid, uint8_t *message, uint8_t *signature)
; signature start address is: 8 (R2)
; message start address is: 4 (R1)
; slotid start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; signature end address is: 8 (R2)
; message end address is: 4 (R1)
; slotid end address is: 0 (R0)
; slotid start address is: 0 (R0)
; message start address is: 4 (R1)
; signature start address is: 8 (R2)
;atcatls.c,322 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atcatls.c,326 :: 		if (message == NULL || signature == NULL) {
CMP	R1, #0
IT	EQ
BEQ	L__atcatls_sign173
CMP	R2, #0
IT	EQ
BEQ	L__atcatls_sign172
IT	AL
BAL	L_atcatls_sign22
; slotid end address is: 0 (R0)
; message end address is: 4 (R1)
; signature end address is: 8 (R2)
L__atcatls_sign173:
L__atcatls_sign172:
;atcatls.c,327 :: 		status = ATCA_BAD_PARAM;
; status start address is: 0 (R0)
MOVS	R0, #226
;atcatls.c,328 :: 		BREAK(status, "Bad input parameters");
; status end address is: 0 (R0)
IT	AL
BAL	L_atcatls_sign18
;atcatls.c,329 :: 		}
L_atcatls_sign22:
;atcatls.c,331 :: 		if ((status = atcab_sign(slotid, message, signature)) != ATCA_SUCCESS) BREAK(status, "Sign Failed");
; signature start address is: 8 (R2)
; message start address is: 4 (R1)
; slotid start address is: 0 (R0)
; signature end address is: 8 (R2)
; message end address is: 4 (R1)
; slotid end address is: 0 (R0)
BL	_atcab_sign+0
; status start address is: 4 (R1)
UXTB	R1, R0
CMP	R0, #0
IT	EQ
BEQ	L_atcatls_sign23
UXTB	R0, R1
IT	AL
BAL	L_atcatls_sign18
L_atcatls_sign23:
;atcatls.c,333 :: 		} while (0);
UXTB	R0, R1
L_atcatls_sign18:
; status end address is: 4 (R1)
;atcatls.c,335 :: 		return status;
; status start address is: 0 (R0)
; status end address is: 0 (R0)
;atcatls.c,336 :: 		}
L_end_atcatls_sign:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atcatls_sign
_atcatls_verify:
;atcatls.c,345 :: 		ATCA_STATUS atcatls_verify ( uint8_t *message, uint8_t *signature, uint8_t *pubkey, bool *verified)
; verified start address is: 12 (R3)
; pubkey start address is: 8 (R2)
; signature start address is: 4 (R1)
; message start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; verified end address is: 12 (R3)
; pubkey end address is: 8 (R2)
; signature end address is: 4 (R1)
; message end address is: 0 (R0)
; message start address is: 0 (R0)
; signature start address is: 4 (R1)
; pubkey start address is: 8 (R2)
; verified start address is: 12 (R3)
;atcatls.c,347 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atcatls.c,351 :: 		if (message == NULL || signature == NULL || pubkey == NULL || verified == NULL) {
CMP	R0, #0
IT	EQ
BEQ	L__atcatls_verify178
CMP	R1, #0
IT	EQ
BEQ	L__atcatls_verify177
CMP	R2, #0
IT	EQ
BEQ	L__atcatls_verify176
CMP	R3, #0
IT	EQ
BEQ	L__atcatls_verify175
IT	AL
BAL	L_atcatls_verify29
; message end address is: 0 (R0)
; signature end address is: 4 (R1)
; pubkey end address is: 8 (R2)
; verified end address is: 12 (R3)
L__atcatls_verify178:
L__atcatls_verify177:
L__atcatls_verify176:
L__atcatls_verify175:
;atcatls.c,352 :: 		status = ATCA_BAD_PARAM;
; status start address is: 0 (R0)
MOVS	R0, #226
;atcatls.c,353 :: 		BREAK(status, "Bad input parameters");
; status end address is: 0 (R0)
IT	AL
BAL	L_atcatls_verify25
;atcatls.c,354 :: 		}
L_atcatls_verify29:
;atcatls.c,356 :: 		if ((status = atcab_verify_extern(message, signature, pubkey, verified)) != ATCA_SUCCESS) BREAK(status, "Verify Failed");
; verified start address is: 12 (R3)
; pubkey start address is: 8 (R2)
; signature start address is: 4 (R1)
; message start address is: 0 (R0)
; verified end address is: 12 (R3)
; pubkey end address is: 8 (R2)
; signature end address is: 4 (R1)
; message end address is: 0 (R0)
BL	_atcab_verify_extern+0
; status start address is: 4 (R1)
UXTB	R1, R0
CMP	R0, #0
IT	EQ
BEQ	L_atcatls_verify30
UXTB	R0, R1
IT	AL
BAL	L_atcatls_verify25
L_atcatls_verify30:
;atcatls.c,358 :: 		} while (0);
UXTB	R0, R1
L_atcatls_verify25:
; status end address is: 4 (R1)
;atcatls.c,360 :: 		return status;
; status start address is: 0 (R0)
; status end address is: 0 (R0)
;atcatls.c,361 :: 		}
L_end_atcatls_verify:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atcatls_verify
_atcatls_verify_cert:
;atcatls.c,373 :: 		ATCA_STATUS atcatls_verify_cert( atcacert_def_t* cert_def,  uint8_t* cert, size_t cert_size,  uint8_t* ca_public_key)
; ca_public_key start address is: 12 (R3)
; cert_size start address is: 8 (R2)
; cert start address is: 4 (R1)
; cert_def start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; ca_public_key end address is: 12 (R3)
; cert_size end address is: 8 (R2)
; cert end address is: 4 (R1)
; cert_def end address is: 0 (R0)
; cert_def start address is: 0 (R0)
; cert start address is: 4 (R1)
; cert_size start address is: 8 (R2)
; ca_public_key start address is: 12 (R3)
;atcatls.c,375 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atcatls.c,379 :: 		if (cert_def == NULL || cert == NULL || ca_public_key == NULL) {
CMP	R0, #0
IT	EQ
BEQ	L__atcatls_verify_cert182
CMP	R1, #0
IT	EQ
BEQ	L__atcatls_verify_cert181
CMP	R3, #0
IT	EQ
BEQ	L__atcatls_verify_cert180
IT	AL
BAL	L_atcatls_verify_cert36
; cert_def end address is: 0 (R0)
; cert end address is: 4 (R1)
; cert_size end address is: 8 (R2)
; ca_public_key end address is: 12 (R3)
L__atcatls_verify_cert182:
L__atcatls_verify_cert181:
L__atcatls_verify_cert180:
;atcatls.c,380 :: 		status = ATCA_BAD_PARAM;
; status start address is: 0 (R0)
MOVS	R0, #226
;atcatls.c,381 :: 		BREAK(status, "Bad input parameters");
; status end address is: 0 (R0)
IT	AL
BAL	L_atcatls_verify_cert32
;atcatls.c,382 :: 		}
L_atcatls_verify_cert36:
;atcatls.c,384 :: 		status = atcacert_verify_cert_hw(cert_def, cert, cert_size, ca_public_key);
; ca_public_key start address is: 12 (R3)
; cert_size start address is: 8 (R2)
; cert start address is: 4 (R1)
; cert_def start address is: 0 (R0)
; ca_public_key end address is: 12 (R3)
; cert_size end address is: 8 (R2)
; cert end address is: 4 (R1)
; cert_def end address is: 0 (R0)
BL	_atcacert_verify_cert_hw+0
; status start address is: 4 (R1)
UXTB	R1, R0
;atcatls.c,385 :: 		if (status != ATCA_SUCCESS) BREAK(status, "Verify Failed");
UXTB	R4, R0
CMP	R4, #0
IT	EQ
BEQ	L_atcatls_verify_cert37
UXTB	R0, R1
IT	AL
BAL	L_atcatls_verify_cert32
L_atcatls_verify_cert37:
;atcatls.c,387 :: 		} while (0);
UXTB	R0, R1
L_atcatls_verify_cert32:
; status end address is: 4 (R1)
;atcatls.c,389 :: 		return status;
; status start address is: 0 (R0)
; status end address is: 0 (R0)
;atcatls.c,390 :: 		}
L_end_atcatls_verify_cert:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atcatls_verify_cert
_atcatls_ecdh:
;atcatls.c,398 :: 		ATCA_STATUS atcatls_ecdh(uint8_t slotid, uint8_t* pubkey, uint8_t* pmk)
; pmk start address is: 8 (R2)
; pubkey start address is: 4 (R1)
; slotid start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; pmk end address is: 8 (R2)
; pubkey end address is: 4 (R1)
; slotid end address is: 0 (R0)
; slotid start address is: 0 (R0)
; pubkey start address is: 4 (R1)
; pmk start address is: 8 (R2)
;atcatls.c,400 :: 		return atcatls_ecdh_enc(slotid, TLS_SLOT_ENC_PARENT, pubkey, pmk);
MOV	R3, R2
; pmk end address is: 8 (R2)
MOV	R2, R1
; pubkey end address is: 4 (R1)
MOVS	R1, #4
; slotid end address is: 0 (R0)
BL	_atcatls_ecdh_enc+0
;atcatls.c,401 :: 		}
L_end_atcatls_ecdh:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atcatls_ecdh
_atcatls_ecdh_enc:
;atcatls.c,411 :: 		ATCA_STATUS atcatls_ecdh_enc(uint8_t slotid, uint8_t enckeyId, uint8_t* pubkey, uint8_t* pmk)
; pmk start address is: 12 (R3)
; pubkey start address is: 8 (R2)
SUB	SP, SP, #52
STR	LR, [SP, #0]
STRB	R0, [SP, #44]
STRB	R1, [SP, #48]
MOV	R1, R2
MOV	R2, R3
; pmk end address is: 12 (R3)
; pubkey end address is: 8 (R2)
; pubkey start address is: 4 (R1)
; pmk start address is: 8 (R2)
;atcatls.c,413 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atcatls.c,414 :: 		uint8_t encKey[ECDH_KEY_SIZE] = { 0 };
ADD	R11, SP, #12
ADD	R10, R11, #32
MOVW	R12, #lo_addr(?ICSatcatls_ecdh_enc_encKey_L0+0)
MOVT	R12, #hi_addr(?ICSatcatls_ecdh_enc_encKey_L0+0)
BL	___CC2DW+0
;atcatls.c,418 :: 		if (pubkey == NULL || pmk == NULL) {
CMP	R1, #0
IT	EQ
BEQ	L__atcatls_ecdh_enc185
CMP	R2, #0
IT	EQ
BEQ	L__atcatls_ecdh_enc184
IT	AL
BAL	L_atcatls_ecdh_enc43
; pubkey end address is: 4 (R1)
; pmk end address is: 8 (R2)
L__atcatls_ecdh_enc185:
L__atcatls_ecdh_enc184:
;atcatls.c,419 :: 		status = ATCA_BAD_PARAM;
MOVS	R4, #226
STRB	R4, [SP, #49]
;atcatls.c,420 :: 		BREAK(status, "Bad input parameters");
IT	AL
BAL	L_atcatls_ecdh_enc39
;atcatls.c,421 :: 		}
L_atcatls_ecdh_enc43:
;atcatls.c,423 :: 		if ((status = atcatls_get_enckey(encKey)) != ATCA_SUCCESS) BREAK(status, "Get enckey Failed");
; pmk start address is: 8 (R2)
; pubkey start address is: 4 (R1)
ADD	R4, SP, #12
STR	R2, [SP, #4]
STR	R1, [SP, #8]
MOV	R0, R4
BL	_atcatls_get_enckey+0
LDR	R1, [SP, #8]
LDR	R2, [SP, #4]
STRB	R0, [SP, #49]
CMP	R0, #0
IT	EQ
BEQ	L_atcatls_ecdh_enc44
; pubkey end address is: 4 (R1)
; pmk end address is: 8 (R2)
IT	AL
BAL	L_atcatls_ecdh_enc39
L_atcatls_ecdh_enc44:
;atcatls.c,426 :: 		if ((status = atcab_ecdh_enc(slotid, pubkey, pmk, encKey, enckeyId)) != ATCA_SUCCESS) BREAK(status, "ECDH Failed");
; pmk start address is: 8 (R2)
; pubkey start address is: 4 (R1)
ADD	R5, SP, #12
LDRB	R4, [SP, #48]
MOV	R3, R5
; pmk end address is: 8 (R2)
; pubkey end address is: 4 (R1)
LDRB	R0, [SP, #44]
PUSH	(R4)
BL	_atcab_ecdh_enc+0
ADD	SP, SP, #4
STRB	R0, [SP, #49]
CMP	R0, #0
IT	EQ
BEQ	L_atcatls_ecdh_enc45
IT	AL
BAL	L_atcatls_ecdh_enc39
L_atcatls_ecdh_enc45:
;atcatls.c,428 :: 		} while (0);
L_atcatls_ecdh_enc39:
;atcatls.c,430 :: 		return status;
LDRB	R0, [SP, #49]
;atcatls.c,431 :: 		}
L_end_atcatls_ecdh_enc:
LDR	LR, [SP, #0]
ADD	SP, SP, #52
BX	LR
; end of _atcatls_ecdh_enc
_atcatls_ecdhe:
;atcatls.c,440 :: 		ATCA_STATUS atcatls_ecdhe(uint8_t slotid, uint8_t* pubkey, uint8_t* pubkeyret, uint8_t* pmk)
; pmk start address is: 12 (R3)
; pubkeyret start address is: 8 (R2)
; pubkey start address is: 4 (R1)
; slotid start address is: 0 (R0)
SUB	SP, SP, #24
STR	LR, [SP, #0]
STR	R2, [SP, #4]
MOV	R2, R1
UXTB	R1, R0
LDR	R0, [SP, #4]
; pmk end address is: 12 (R3)
; pubkeyret end address is: 8 (R2)
; pubkey end address is: 4 (R1)
; slotid end address is: 0 (R0)
; slotid start address is: 4 (R1)
; pubkey start address is: 8 (R2)
; pubkeyret start address is: 0 (R0)
; pmk start address is: 12 (R3)
;atcatls.c,442 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atcatls.c,446 :: 		if ((pubkey == NULL) || (pubkeyret == NULL) || (pmk == NULL)) {
CMP	R2, #0
IT	EQ
BEQ	L__atcatls_ecdhe189
CMP	R0, #0
IT	EQ
BEQ	L__atcatls_ecdhe188
CMP	R3, #0
IT	EQ
BEQ	L__atcatls_ecdhe187
IT	AL
BAL	L_atcatls_ecdhe51
; slotid end address is: 4 (R1)
; pubkey end address is: 8 (R2)
; pubkeyret end address is: 0 (R0)
; pmk end address is: 12 (R3)
L__atcatls_ecdhe189:
L__atcatls_ecdhe188:
L__atcatls_ecdhe187:
;atcatls.c,447 :: 		status = ATCA_BAD_PARAM;
MOVS	R4, #226
STRB	R4, [SP, #20]
;atcatls.c,448 :: 		BREAK(status, "Bad input parameters");
IT	AL
BAL	L_atcatls_ecdhe47
;atcatls.c,449 :: 		}
L_atcatls_ecdhe51:
;atcatls.c,451 :: 		if ((status = atcab_genkey(slotid, pubkeyret)) != ATCA_SUCCESS) BREAK(status, "Create key failed");
; pmk start address is: 12 (R3)
; pubkeyret start address is: 0 (R0)
; pubkey start address is: 8 (R2)
; slotid start address is: 4 (R1)
STR	R3, [SP, #4]
; pubkeyret end address is: 0 (R0)
STR	R2, [SP, #8]
STRB	R1, [SP, #12]
STRH	R1, [SP, #16]
MOV	R1, R0
LDRSH	R0, [SP, #16]
BL	_atcab_genkey+0
LDRB	R1, [SP, #12]
LDR	R2, [SP, #8]
LDR	R3, [SP, #4]
STRB	R0, [SP, #20]
CMP	R0, #0
IT	EQ
BEQ	L_atcatls_ecdhe52
; slotid end address is: 4 (R1)
; pubkey end address is: 8 (R2)
; pmk end address is: 12 (R3)
IT	AL
BAL	L_atcatls_ecdhe47
L_atcatls_ecdhe52:
;atcatls.c,454 :: 		if ((status = atcab_ecdh(slotid, pubkey, pmk)) != ATCA_SUCCESS) BREAK(status, "ECDH failed");
; pmk start address is: 12 (R3)
; pubkey start address is: 8 (R2)
; slotid start address is: 4 (R1)
UXTB	R0, R1
; pmk end address is: 12 (R3)
MOV	R1, R2
; pubkey end address is: 8 (R2)
MOV	R2, R3
; slotid end address is: 4 (R1)
BL	_atcab_ecdh+0
STRB	R0, [SP, #20]
CMP	R0, #0
IT	EQ
BEQ	L_atcatls_ecdhe53
IT	AL
BAL	L_atcatls_ecdhe47
L_atcatls_ecdhe53:
;atcatls.c,457 :: 		} while (0);
L_atcatls_ecdhe47:
;atcatls.c,459 :: 		return status;
LDRB	R0, [SP, #20]
;atcatls.c,460 :: 		}
L_end_atcatls_ecdhe:
LDR	LR, [SP, #0]
ADD	SP, SP, #24
BX	LR
; end of _atcatls_ecdhe
_atcatls_create_key:
;atcatls.c,467 :: 		ATCA_STATUS atcatls_create_key(uint8_t slotid, uint8_t* pubkey)
; pubkey start address is: 4 (R1)
; slotid start address is: 0 (R0)
SUB	SP, SP, #8
STR	LR, [SP, #0]
; pubkey end address is: 4 (R1)
; slotid end address is: 0 (R0)
; slotid start address is: 0 (R0)
; pubkey start address is: 4 (R1)
;atcatls.c,469 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atcatls.c,473 :: 		if (pubkey == NULL) {
CMP	R1, #0
IT	NE
BNE	L_atcatls_create_key57
; slotid end address is: 0 (R0)
; pubkey end address is: 4 (R1)
;atcatls.c,474 :: 		status = ATCA_BAD_PARAM;
MOVS	R2, #226
STRB	R2, [SP, #4]
;atcatls.c,475 :: 		BREAK(status, "NULL inputs");
IT	AL
BAL	L_atcatls_create_key55
;atcatls.c,476 :: 		}
L_atcatls_create_key57:
;atcatls.c,478 :: 		if ((status = atcab_genkey(slotid, pubkey)) != ATCA_SUCCESS) BREAK(status, "Create key failed");
; pubkey start address is: 4 (R1)
; slotid start address is: 0 (R0)
; pubkey end address is: 4 (R1)
; slotid end address is: 0 (R0)
BL	_atcab_genkey+0
STRB	R0, [SP, #4]
CMP	R0, #0
IT	EQ
BEQ	L_atcatls_create_key58
IT	AL
BAL	L_atcatls_create_key55
L_atcatls_create_key58:
;atcatls.c,480 :: 		} while (0);
L_atcatls_create_key55:
;atcatls.c,482 :: 		return status;
LDRB	R0, [SP, #4]
;atcatls.c,483 :: 		}
L_end_atcatls_create_key:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _atcatls_create_key
_atcatls_calc_pubkey:
;atcatls.c,490 :: 		ATCA_STATUS atcatls_calc_pubkey(uint8_t slotid, uint8_t *pubkey)
; pubkey start address is: 4 (R1)
; slotid start address is: 0 (R0)
SUB	SP, SP, #8
STR	LR, [SP, #0]
; pubkey end address is: 4 (R1)
; slotid end address is: 0 (R0)
; slotid start address is: 0 (R0)
; pubkey start address is: 4 (R1)
;atcatls.c,492 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atcatls.c,496 :: 		if (pubkey == NULL) {
CMP	R1, #0
IT	NE
BNE	L_atcatls_calc_pubkey62
; slotid end address is: 0 (R0)
; pubkey end address is: 4 (R1)
;atcatls.c,497 :: 		status = ATCA_BAD_PARAM;
MOVS	R2, #226
STRB	R2, [SP, #4]
;atcatls.c,498 :: 		BREAK(status, "NULL inputs");
IT	AL
BAL	L_atcatls_calc_pubkey60
;atcatls.c,499 :: 		}
L_atcatls_calc_pubkey62:
;atcatls.c,501 :: 		if ((status = atcab_get_pubkey(slotid, pubkey)) != ATCA_SUCCESS) BREAK(status, "Gen public key failed");
; pubkey start address is: 4 (R1)
; slotid start address is: 0 (R0)
; pubkey end address is: 4 (R1)
; slotid end address is: 0 (R0)
BL	_atcab_get_pubkey+0
STRB	R0, [SP, #4]
CMP	R0, #0
IT	EQ
BEQ	L_atcatls_calc_pubkey63
IT	AL
BAL	L_atcatls_calc_pubkey60
L_atcatls_calc_pubkey63:
;atcatls.c,503 :: 		} while (0);
L_atcatls_calc_pubkey60:
;atcatls.c,505 :: 		return status;
LDRB	R0, [SP, #4]
;atcatls.c,506 :: 		}
L_end_atcatls_calc_pubkey:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _atcatls_calc_pubkey
_atcatls_read_pubkey:
;atcatls.c,513 :: 		ATCA_STATUS atcatls_read_pubkey(uint8_t slotid, uint8_t *pubkey)
; pubkey start address is: 4 (R1)
; slotid start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; pubkey end address is: 4 (R1)
; slotid end address is: 0 (R0)
; slotid start address is: 0 (R0)
; pubkey start address is: 4 (R1)
;atcatls.c,515 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atcatls.c,519 :: 		if (pubkey == NULL || slotid < 8 || slotid > 0xF) {
CMP	R1, #0
IT	EQ
BEQ	L__atcatls_read_pubkey193
CMP	R0, #8
IT	CC
BCC	L__atcatls_read_pubkey192
CMP	R0, #15
IT	HI
BHI	L__atcatls_read_pubkey191
IT	AL
BAL	L_atcatls_read_pubkey69
; slotid end address is: 0 (R0)
; pubkey end address is: 4 (R1)
L__atcatls_read_pubkey193:
L__atcatls_read_pubkey192:
L__atcatls_read_pubkey191:
;atcatls.c,520 :: 		status = ATCA_BAD_PARAM;
; status start address is: 0 (R0)
MOVS	R0, #226
;atcatls.c,521 :: 		BREAK(status, "Bad atcatls_read_pubkey() input parameters");
; status end address is: 0 (R0)
IT	AL
BAL	L_atcatls_read_pubkey65
;atcatls.c,522 :: 		}
L_atcatls_read_pubkey69:
;atcatls.c,524 :: 		if ((status = atcab_read_pubkey(slotid, pubkey)) != ATCA_SUCCESS) BREAK(status, "Read public key failed");
; pubkey start address is: 4 (R1)
; slotid start address is: 0 (R0)
; pubkey end address is: 4 (R1)
; slotid end address is: 0 (R0)
BL	_atcab_read_pubkey+0
; status start address is: 4 (R1)
UXTB	R1, R0
CMP	R0, #0
IT	EQ
BEQ	L_atcatls_read_pubkey70
UXTB	R0, R1
IT	AL
BAL	L_atcatls_read_pubkey65
L_atcatls_read_pubkey70:
;atcatls.c,526 :: 		} while (0);
UXTB	R0, R1
L_atcatls_read_pubkey65:
; status end address is: 4 (R1)
;atcatls.c,528 :: 		return status;
; status start address is: 0 (R0)
; status end address is: 0 (R0)
;atcatls.c,529 :: 		}
L_end_atcatls_read_pubkey:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atcatls_read_pubkey
_atcatls_random:
;atcatls.c,535 :: 		ATCA_STATUS atcatls_random(uint8_t* randout)
; randout start address is: 0 (R0)
SUB	SP, SP, #8
STR	LR, [SP, #0]
; randout end address is: 0 (R0)
; randout start address is: 0 (R0)
;atcatls.c,537 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atcatls.c,541 :: 		if (randout == NULL) {
CMP	R0, #0
IT	NE
BNE	L_atcatls_random74
; randout end address is: 0 (R0)
;atcatls.c,542 :: 		status = ATCA_BAD_PARAM;
MOVS	R1, #226
STRB	R1, [SP, #4]
;atcatls.c,543 :: 		BREAK(status, "NULL inputs");
IT	AL
BAL	L_atcatls_random72
;atcatls.c,544 :: 		}
L_atcatls_random74:
;atcatls.c,546 :: 		if ((status = atcab_random(randout)) != ATCA_SUCCESS) BREAK(status, "Random command failed");
; randout start address is: 0 (R0)
; randout end address is: 0 (R0)
BL	_atcab_random+0
STRB	R0, [SP, #4]
CMP	R0, #0
IT	EQ
BEQ	L_atcatls_random75
IT	AL
BAL	L_atcatls_random72
L_atcatls_random75:
;atcatls.c,548 :: 		} while (0);
L_atcatls_random72:
;atcatls.c,550 :: 		return status;
LDRB	R0, [SP, #4]
;atcatls.c,551 :: 		}
L_end_atcatls_random:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _atcatls_random
_atcatlsfn_set_get_enckey:
;atcatls.c,557 :: 		ATCA_STATUS atcatlsfn_set_get_enckey(atcatlsfn_get_enckey* fn_get_enckey)
; fn_get_enckey start address is: 0 (R0)
; fn_get_enckey end address is: 0 (R0)
; fn_get_enckey start address is: 0 (R0)
;atcatls.c,559 :: 		ATCA_STATUS status = ATCA_SUCCESS;
; status start address is: 8 (R2)
MOVS	R2, #0
;atcatls.c,563 :: 		if (fn_get_enckey == NULL) {
CMP	R0, #0
IT	NE
BNE	L_atcatlsfn_set_get_enckey79
; fn_get_enckey end address is: 0 (R0)
; status end address is: 8 (R2)
;atcatls.c,564 :: 		status = ATCA_BAD_PARAM;
; status start address is: 0 (R0)
MOVS	R0, #226
;atcatls.c,565 :: 		BREAK(status, "NULL inputs");
; status end address is: 0 (R0)
IT	AL
BAL	L_atcatlsfn_set_get_enckey77
;atcatls.c,566 :: 		}
L_atcatlsfn_set_get_enckey79:
;atcatls.c,568 :: 		_fn_get_enckey = fn_get_enckey;
; status start address is: 8 (R2)
; fn_get_enckey start address is: 0 (R0)
MOVW	R1, #lo_addr(__fn_get_enckey+0)
MOVT	R1, #hi_addr(__fn_get_enckey+0)
STR	R0, [R1, #0]
; fn_get_enckey end address is: 0 (R0)
; status end address is: 8 (R2)
UXTB	R0, R2
;atcatls.c,570 :: 		} while (0);
L_atcatlsfn_set_get_enckey77:
;atcatls.c,572 :: 		return status;
; status start address is: 0 (R0)
; status end address is: 0 (R0)
;atcatls.c,573 :: 		}
L_end_atcatlsfn_set_get_enckey:
BX	LR
; end of _atcatlsfn_set_get_enckey
_atcatls_init_enckey:
;atcatls.c,583 :: 		ATCA_STATUS atcatls_init_enckey(uint8_t* enckeyout, uint8_t enckeyId, bool lock)
; enckeyout start address is: 0 (R0)
SUB	SP, SP, #16
STR	LR, [SP, #0]
STRB	R1, [SP, #8]
MOV	R1, R0
STRB	R2, [SP, #12]
; enckeyout end address is: 0 (R0)
; enckeyout start address is: 4 (R1)
;atcatls.c,585 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atcatls.c,589 :: 		if (enckeyout == NULL) {
CMP	R1, #0
IT	NE
BNE	L_atcatls_init_enckey83
; enckeyout end address is: 4 (R1)
;atcatls.c,590 :: 		status = ATCA_BAD_PARAM;
MOVS	R3, #226
STRB	R3, [SP, #13]
;atcatls.c,591 :: 		BREAK(status, "NULL inputs");
IT	AL
BAL	L_atcatls_init_enckey81
;atcatls.c,592 :: 		}
L_atcatls_init_enckey83:
;atcatls.c,594 :: 		if ((status = atcatls_random(enckeyout)) != ATCA_SUCCESS) BREAK(status, "Random command failed");
; enckeyout start address is: 4 (R1)
STR	R1, [SP, #4]
MOV	R0, R1
BL	_atcatls_random+0
LDR	R1, [SP, #4]
STRB	R0, [SP, #13]
CMP	R0, #0
IT	EQ
BEQ	L_atcatls_init_enckey84
; enckeyout end address is: 4 (R1)
IT	AL
BAL	L_atcatls_init_enckey81
L_atcatls_init_enckey84:
;atcatls.c,597 :: 		atcatls_set_enckey(enckeyout, enckeyId, lock);
; enckeyout start address is: 4 (R1)
LDRB	R2, [SP, #12]
MOV	R0, R1
LDRB	R1, [SP, #8]
; enckeyout end address is: 4 (R1)
BL	_atcatls_set_enckey+0
;atcatls.c,599 :: 		} while (0);
L_atcatls_init_enckey81:
;atcatls.c,601 :: 		return status;
LDRB	R0, [SP, #13]
;atcatls.c,602 :: 		}
L_end_atcatls_init_enckey:
LDR	LR, [SP, #0]
ADD	SP, SP, #16
BX	LR
; end of _atcatls_init_enckey
_atcatls_set_enckey:
;atcatls.c,612 :: 		ATCA_STATUS atcatls_set_enckey(uint8_t* enckeyin, uint8_t enckeyId, bool lock)
; block start address is: 16 (R4)
; enckeyId start address is: 4 (R1)
; enckeyin start address is: 0 (R0)
SUB	SP, SP, #16
STR	LR, [SP, #0]
;atcatls.c,615 :: 		uint8_t block = 0;
;atcatls.c,612 :: 		ATCA_STATUS atcatls_set_enckey(uint8_t* enckeyin, uint8_t enckeyId, bool lock)
STRB	R2, [SP, #12]
;atcatls.c,615 :: 		uint8_t block = 0;
;atcatls.c,612 :: 		ATCA_STATUS atcatls_set_enckey(uint8_t* enckeyin, uint8_t enckeyId, bool lock)
UXTB	R2, R1
; block end address is: 16 (R4)
; enckeyId end address is: 4 (R1)
; enckeyin end address is: 0 (R0)
; enckeyin start address is: 0 (R0)
; enckeyId start address is: 8 (R2)
;atcatls.c,614 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atcatls.c,615 :: 		uint8_t block = 0;
; block start address is: 16 (R4)
MOVS	R4, #0
;atcatls.c,616 :: 		uint8_t offset = 0;
; offset start address is: 20 (R5)
MOVS	R5, #0
;atcatls.c,617 :: 		uint8_t lockSuccess = 0;
MOVS	R3, #0
STRB	R3, [SP, #8]
;atcatls.c,618 :: 		uint8_t enckeyIdByte = (uint8_t)enckeyId;
; enckeyIdByte start address is: 4 (R1)
UXTB	R1, R2
; enckeyId end address is: 8 (R2)
;atcatls.c,622 :: 		if (enckeyin == NULL) {
CMP	R0, #0
IT	NE
BNE	L_atcatls_set_enckey88
; enckeyin end address is: 0 (R0)
; block end address is: 16 (R4)
; offset end address is: 20 (R5)
; enckeyIdByte end address is: 4 (R1)
;atcatls.c,623 :: 		status = ATCA_BAD_PARAM;
MOVS	R3, #226
STRB	R3, [SP, #13]
;atcatls.c,624 :: 		BREAK(status, "NULL inputs");
IT	AL
BAL	L_atcatls_set_enckey86
;atcatls.c,625 :: 		}
L_atcatls_set_enckey88:
;atcatls.c,627 :: 		if ((status = atcab_write_zone(ATCA_ZONE_DATA, enckeyIdByte, block, offset, enckeyin, ATCA_BLOCK_SIZE)) != ATCA_SUCCESS)
; enckeyIdByte start address is: 4 (R1)
; offset start address is: 20 (R5)
; block start address is: 16 (R4)
; enckeyin start address is: 0 (R0)
MOVS	R3, #32
STRB	R1, [SP, #4]
; offset end address is: 20 (R5)
PUSH	(R3)
PUSH	(R0)
UXTB	R3, R5
UXTB	R2, R4
; block end address is: 16 (R4)
MOVS	R0, #2
; enckeyin end address is: 0 (R0)
BL	_atcab_write_zone+0
ADD	SP, SP, #8
LDRB	R1, [SP, #4]
STRB	R0, [SP, #13]
CMP	R0, #0
IT	EQ
BEQ	L_atcatls_set_enckey89
; enckeyIdByte end address is: 4 (R1)
;atcatls.c,628 :: 		BREAK(status, "Write parent encryption key failed");
IT	AL
BAL	L_atcatls_set_enckey86
L_atcatls_set_enckey89:
;atcatls.c,631 :: 		if (lock)
; enckeyIdByte start address is: 4 (R1)
LDRB	R3, [SP, #12]
CMP	R3, #0
IT	EQ
BEQ	L_atcatls_set_enckey90
;atcatls.c,633 :: 		atcab_lock_data_slot(enckeyIdByte, &lockSuccess);
ADD	R3, SP, #8
UXTB	R0, R1
MOV	R1, R3
; enckeyIdByte end address is: 4 (R1)
BL	_atcab_lock_data_slot+0
L_atcatls_set_enckey90:
;atcatls.c,635 :: 		} while (0);
L_atcatls_set_enckey86:
;atcatls.c,637 :: 		return status;
LDRB	R0, [SP, #13]
;atcatls.c,638 :: 		}
L_end_atcatls_set_enckey:
LDR	LR, [SP, #0]
ADD	SP, SP, #16
BX	LR
; end of _atcatls_set_enckey
_atcatls_get_enckey:
;atcatls.c,646 :: 		ATCA_STATUS atcatls_get_enckey(uint8_t* enckeyout)
; enckeyout start address is: 0 (R0)
SUB	SP, SP, #8
STR	LR, [SP, #0]
MOV	R6, R0
; enckeyout end address is: 0 (R0)
; enckeyout start address is: 24 (R6)
;atcatls.c,648 :: 		ATCA_STATUS status = ATCA_SUCCESS;
MOVS	R1, #0
STRB	R1, [SP, #4]
;atcatls.c,652 :: 		if (enckeyout == NULL) {
CMP	R6, #0
IT	NE
BNE	L_atcatls_get_enckey94
; enckeyout end address is: 24 (R6)
;atcatls.c,653 :: 		status = ATCA_BAD_PARAM;
MOVS	R1, #226
STRB	R1, [SP, #4]
;atcatls.c,654 :: 		BREAK(status, "NULL inputs");
IT	AL
BAL	L_atcatls_get_enckey92
;atcatls.c,655 :: 		}
L_atcatls_get_enckey94:
;atcatls.c,657 :: 		memset(enckeyout, 0x00, ATCA_KEY_SIZE);
; enckeyout start address is: 24 (R6)
MOVS	R2, #32
SXTH	R2, R2
MOVS	R1, #0
MOV	R0, R6
BL	_memset+0
;atcatls.c,660 :: 		if (_fn_get_enckey != NULL)
MOVW	R1, #lo_addr(__fn_get_enckey+0)
MOVT	R1, #hi_addr(__fn_get_enckey+0)
LDR	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L_atcatls_get_enckey95
;atcatls.c,661 :: 		_fn_get_enckey(enckeyout, ATCA_KEY_SIZE);
MOVS	R1, #32
SXTH	R1, R1
MOV	R0, R6
; enckeyout end address is: 24 (R6)
MOVW	R4, #lo_addr(__fn_get_enckey+0)
MOVT	R4, #hi_addr(__fn_get_enckey+0)
LDR	R4, [R4, #0]
BLX	R4
IT	AL
BAL	L_atcatls_get_enckey96
L_atcatls_get_enckey95:
;atcatls.c,664 :: 		status = ATCA_FUNC_FAIL;
MOVS	R1, #224
STRB	R1, [SP, #4]
L_atcatls_get_enckey96:
;atcatls.c,665 :: 		} while (0);
L_atcatls_get_enckey92:
;atcatls.c,667 :: 		return status;
LDRB	R0, [SP, #4]
;atcatls.c,668 :: 		}
L_end_atcatls_get_enckey:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _atcatls_get_enckey
_atcatls_enc_read:
;atcatls.c,678 :: 		ATCA_STATUS atcatls_enc_read(uint8_t slotid, uint8_t block, uint8_t enckeyId, uint8_t* data, int16_t* bufsize)
; _data start address is: 12 (R3)
SUB	SP, SP, #56
STR	LR, [SP, #0]
STRB	R0, [SP, #44]
STRB	R1, [SP, #48]
MOV	R1, R3
STRB	R2, [SP, #52]
; _data end address is: 12 (R3)
; _data start address is: 4 (R1)
; bufsize start address is: 8 (R2)
LDR	R2, [SP, #56]
;atcatls.c,680 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atcatls.c,681 :: 		uint8_t enckey[ATCA_KEY_SIZE] = { 0 };
ADD	R11, SP, #12
ADD	R10, R11, #32
MOVW	R12, #lo_addr(?ICSatcatls_enc_read_enckey_L0+0)
MOVT	R12, #hi_addr(?ICSatcatls_enc_read_enckey_L0+0)
BL	___CC2DW+0
;atcatls.c,685 :: 		if (data == NULL || bufsize == NULL) {
CMP	R1, #0
IT	EQ
BEQ	L__atcatls_enc_read196
CMP	R2, #0
IT	EQ
BEQ	L__atcatls_enc_read195
IT	AL
BAL	L_atcatls_enc_read102
; _data end address is: 4 (R1)
; bufsize end address is: 8 (R2)
L__atcatls_enc_read196:
L__atcatls_enc_read195:
;atcatls.c,686 :: 		status = ATCA_BAD_PARAM;
MOVS	R4, #226
STRB	R4, [SP, #53]
;atcatls.c,687 :: 		BREAK(status, "NULL inputs");
IT	AL
BAL	L_atcatls_enc_read98
;atcatls.c,688 :: 		}
L_atcatls_enc_read102:
;atcatls.c,690 :: 		if ((status = atcatls_get_enckey(enckey)) != ATCA_SUCCESS) BREAK(status, "Get encryption key failed");
; bufsize start address is: 8 (R2)
; _data start address is: 4 (R1)
ADD	R4, SP, #12
STR	R2, [SP, #4]
STR	R1, [SP, #8]
MOV	R0, R4
BL	_atcatls_get_enckey+0
LDR	R1, [SP, #8]
LDR	R2, [SP, #4]
STRB	R0, [SP, #53]
CMP	R0, #0
IT	EQ
BEQ	L_atcatls_enc_read103
; _data end address is: 4 (R1)
; bufsize end address is: 8 (R2)
IT	AL
BAL	L_atcatls_enc_read98
L_atcatls_enc_read103:
;atcatls.c,693 :: 		memset(data, 0x00, *bufsize);
; bufsize start address is: 8 (R2)
; _data start address is: 4 (R1)
LDRSH	R4, [R2, #0]
; bufsize end address is: 8 (R2)
STR	R1, [SP, #4]
SXTH	R2, R4
MOV	R0, R1
MOVS	R1, #0
BL	_memset+0
LDR	R1, [SP, #4]
;atcatls.c,696 :: 		if ((status = atcab_read_enc(slotid, block, data, enckey, enckeyId)) != ATCA_SUCCESS) BREAK(status, "Read encrypted failed");
LDRB	R5, [SP, #52]
ADD	R4, SP, #12
MOV	R3, R4
MOV	R2, R1
; _data end address is: 4 (R1)
LDRB	R1, [SP, #48]
LDRB	R0, [SP, #44]
PUSH	(R5)
BL	_atcab_read_enc+0
ADD	SP, SP, #4
STRB	R0, [SP, #53]
CMP	R0, #0
IT	EQ
BEQ	L_atcatls_enc_read104
IT	AL
BAL	L_atcatls_enc_read98
L_atcatls_enc_read104:
;atcatls.c,698 :: 		} while (0);
L_atcatls_enc_read98:
;atcatls.c,700 :: 		return status;
LDRB	R0, [SP, #53]
;atcatls.c,701 :: 		}
L_end_atcatls_enc_read:
LDR	LR, [SP, #0]
ADD	SP, SP, #56
BX	LR
; end of _atcatls_enc_read
_atcatls_enc_write:
;atcatls.c,711 :: 		ATCA_STATUS atcatls_enc_write(uint8_t slotid, uint8_t block, uint8_t enckeyId, uint8_t* data, int16_t bufsize)
; _data start address is: 12 (R3)
SUB	SP, SP, #52
STR	LR, [SP, #0]
STRB	R0, [SP, #40]
STRB	R1, [SP, #44]
MOV	R1, R3
STRB	R2, [SP, #48]
; _data end address is: 12 (R3)
; _data start address is: 4 (R1)
; bufsize start address is: 16 (R4)
LDRSH	R4, [SP, #52]
; bufsize end address is: 16 (R4)
;atcatls.c,713 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atcatls.c,714 :: 		uint8_t enckey[ATCA_KEY_SIZE] = { 0 };
ADD	R11, SP, #8
ADD	R10, R11, #32
MOVW	R12, #lo_addr(?ICSatcatls_enc_write_enckey_L0+0)
MOVT	R12, #hi_addr(?ICSatcatls_enc_write_enckey_L0+0)
BL	___CC2DW+0
;atcatls.c,718 :: 		if (data == NULL) {
CMP	R1, #0
IT	NE
BNE	L_atcatls_enc_write108
; _data end address is: 4 (R1)
;atcatls.c,719 :: 		status = ATCA_BAD_PARAM;
MOVS	R4, #226
STRB	R4, [SP, #49]
;atcatls.c,720 :: 		BREAK(status, "NULL inputs");
IT	AL
BAL	L_atcatls_enc_write106
;atcatls.c,721 :: 		}
L_atcatls_enc_write108:
;atcatls.c,723 :: 		if ((status = atcatls_get_enckey(enckey)) != ATCA_SUCCESS) BREAK(status, "Get encryption key failed");
; _data start address is: 4 (R1)
ADD	R4, SP, #8
STR	R1, [SP, #4]
MOV	R0, R4
BL	_atcatls_get_enckey+0
LDR	R1, [SP, #4]
STRB	R0, [SP, #49]
CMP	R0, #0
IT	EQ
BEQ	L_atcatls_enc_write109
; _data end address is: 4 (R1)
IT	AL
BAL	L_atcatls_enc_write106
L_atcatls_enc_write109:
;atcatls.c,726 :: 		if ((status = atcab_write_enc(slotid, block, data, enckey, enckeyId)) != ATCA_SUCCESS) BREAK(status, "Write encrypted failed");
; _data start address is: 4 (R1)
LDRB	R5, [SP, #48]
ADD	R4, SP, #8
MOV	R3, R4
MOV	R2, R1
; _data end address is: 4 (R1)
LDRB	R1, [SP, #44]
LDRB	R0, [SP, #40]
PUSH	(R5)
BL	_atcab_write_enc+0
ADD	SP, SP, #4
STRB	R0, [SP, #49]
CMP	R0, #0
IT	EQ
BEQ	L_atcatls_enc_write110
IT	AL
BAL	L_atcatls_enc_write106
L_atcatls_enc_write110:
;atcatls.c,728 :: 		} while (0);
L_atcatls_enc_write106:
;atcatls.c,730 :: 		return status;
LDRB	R0, [SP, #49]
;atcatls.c,731 :: 		}
L_end_atcatls_enc_write:
LDR	LR, [SP, #0]
ADD	SP, SP, #52
BX	LR
; end of _atcatls_enc_write
_atcatls_enc_rsakey_read:
;atcatls.c,739 :: 		ATCA_STATUS atcatls_enc_rsakey_read(uint8_t enckeyId, uint8_t* rsakey, int16_t* keysize)
SUB	SP, SP, #60
STR	LR, [SP, #0]
STRB	R0, [SP, #44]
STR	R1, [SP, #48]
STR	R2, [SP, #52]
;atcatls.c,741 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atcatls.c,742 :: 		uint8_t enckey[ATCA_KEY_SIZE] = { 0 };
ADD	R11, SP, #8
ADD	R10, R11, #35
MOVW	R12, #lo_addr(?ICSatcatls_enc_rsakey_read_enckey_L0+0)
MOVT	R12, #hi_addr(?ICSatcatls_enc_rsakey_read_enckey_L0+0)
BL	___CC2DW+0
;atcatls.c,743 :: 		uint8_t slotid = RSA_KEY_SLOT;
;atcatls.c,744 :: 		uint8_t startBlock = RSA_KEY_START_BLOCK;
;atcatls.c,745 :: 		uint8_t memBlock = 0;
;atcatls.c,746 :: 		uint8_t numKeyBlocks = RSA2048_KEY_SIZE / ATCA_BLOCK_SIZE;
;atcatls.c,747 :: 		uint8_t block = 0;
;atcatls.c,748 :: 		uint8_t memLoc = 0;
;atcatls.c,752 :: 		if (rsakey == NULL || keysize == NULL) {
LDR	R3, [SP, #48]
CMP	R3, #0
IT	EQ
BEQ	L__atcatls_enc_rsakey_read199
LDR	R3, [SP, #52]
CMP	R3, #0
IT	EQ
BEQ	L__atcatls_enc_rsakey_read198
IT	AL
BAL	L_atcatls_enc_rsakey_read116
L__atcatls_enc_rsakey_read199:
L__atcatls_enc_rsakey_read198:
;atcatls.c,753 :: 		status = ATCA_BAD_PARAM;
MOVS	R3, #226
STRB	R3, [SP, #56]
;atcatls.c,754 :: 		BREAK(status, "NULL inputs");
IT	AL
BAL	L_atcatls_enc_rsakey_read112
;atcatls.c,755 :: 		}
L_atcatls_enc_rsakey_read116:
;atcatls.c,756 :: 		if (*keysize < RSA2048_KEY_SIZE) {
LDR	R3, [SP, #52]
LDRSH	R3, [R3, #0]
CMP	R3, #256
IT	GE
BGE	L_atcatls_enc_rsakey_read117
;atcatls.c,757 :: 		status = ATCA_BAD_PARAM;
MOVS	R3, #226
STRB	R3, [SP, #56]
;atcatls.c,758 :: 		BREAK(status, "RSA key buffer too small");
IT	AL
BAL	L_atcatls_enc_rsakey_read112
;atcatls.c,759 :: 		}
L_atcatls_enc_rsakey_read117:
;atcatls.c,762 :: 		if ((status = atcatls_get_enckey(enckey)) != ATCA_SUCCESS) BREAK(status, "Get encryption key failed");
ADD	R3, SP, #8
MOV	R0, R3
BL	_atcatls_get_enckey+0
STRB	R0, [SP, #56]
CMP	R0, #0
IT	EQ
BEQ	L_atcatls_enc_rsakey_read118
IT	AL
BAL	L_atcatls_enc_rsakey_read112
L_atcatls_enc_rsakey_read118:
;atcatls.c,765 :: 		for (memBlock = 0; memBlock < numKeyBlocks; memBlock++) {
; memBlock start address is: 44 (R11)
MOVW	R11, #0
; memBlock end address is: 44 (R11)
UXTB	R1, R11
L_atcatls_enc_rsakey_read119:
; memBlock start address is: 4 (R1)
LDRB	R3, [SP, #42]
CMP	R1, R3
IT	CS
BCS	L_atcatls_enc_rsakey_read120
;atcatls.c,766 :: 		block = startBlock + memBlock;
LDRB	R3, [SP, #41]
ADDS	R7, R3, R1
;atcatls.c,767 :: 		memLoc = ATCA_BLOCK_SIZE * memBlock;
LSLS	R3, R1, #5
SXTH	R3, R3
;atcatls.c,768 :: 		if ((status = atcab_read_enc(slotid, block, &rsakey[memLoc], enckey, enckeyId)) != ATCA_SUCCESS) BREAK(status, "Read RSA failed");
LDRB	R6, [SP, #44]
ADD	R5, SP, #8
UXTB	R4, R3
LDR	R3, [SP, #48]
ADDS	R3, R3, R4
STRB	R1, [SP, #4]
MOV	R2, R3
MOV	R3, R5
UXTB	R1, R7
LDRB	R0, [SP, #40]
PUSH	(R6)
BL	_atcab_read_enc+0
ADD	SP, SP, #4
LDRB	R1, [SP, #4]
STRB	R0, [SP, #56]
CMP	R0, #0
IT	EQ
BEQ	L_atcatls_enc_rsakey_read122
; memBlock end address is: 4 (R1)
IT	AL
BAL	L_atcatls_enc_rsakey_read120
L_atcatls_enc_rsakey_read122:
;atcatls.c,765 :: 		for (memBlock = 0; memBlock < numKeyBlocks; memBlock++) {
; memBlock start address is: 4 (R1)
ADDS	R3, R1, #1
; memBlock end address is: 4 (R1)
; memBlock start address is: 44 (R11)
UXTB	R11, R3
;atcatls.c,769 :: 		}
UXTB	R1, R11
; memBlock end address is: 44 (R11)
IT	AL
BAL	L_atcatls_enc_rsakey_read119
L_atcatls_enc_rsakey_read120:
;atcatls.c,770 :: 		*keysize = RSA2048_KEY_SIZE;
MOVW	R4, #256
SXTH	R4, R4
LDR	R3, [SP, #52]
STRH	R4, [R3, #0]
;atcatls.c,772 :: 		} while (0);
L_atcatls_enc_rsakey_read112:
;atcatls.c,774 :: 		return status;
LDRB	R0, [SP, #56]
;atcatls.c,775 :: 		}
L_end_atcatls_enc_rsakey_read:
LDR	LR, [SP, #0]
ADD	SP, SP, #60
BX	LR
; end of _atcatls_enc_rsakey_read
_atcatls_enc_rsakey_write:
;atcatls.c,783 :: 		ATCA_STATUS atcatls_enc_rsakey_write(uint8_t enckeyId, uint8_t* rsakey, int16_t keysize)
; keysize start address is: 8 (R2)
SUB	SP, SP, #56
STR	LR, [SP, #0]
STRB	R0, [SP, #44]
SXTH	R0, R2
STR	R1, [SP, #48]
; keysize end address is: 8 (R2)
; keysize start address is: 0 (R0)
;atcatls.c,785 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atcatls.c,786 :: 		uint8_t enckey[ATCA_KEY_SIZE] = { 0 };
ADD	R11, SP, #8
ADD	R10, R11, #35
MOVW	R12, #lo_addr(?ICSatcatls_enc_rsakey_write_enckey_L0+0)
MOVT	R12, #hi_addr(?ICSatcatls_enc_rsakey_write_enckey_L0+0)
BL	___CC2DW+0
;atcatls.c,787 :: 		uint8_t slotid = RSA_KEY_SLOT;
;atcatls.c,788 :: 		uint8_t startBlock = RSA_KEY_START_BLOCK;
;atcatls.c,789 :: 		uint8_t memBlock = 0;
;atcatls.c,790 :: 		uint8_t numKeyBlocks = RSA2048_KEY_SIZE / ATCA_BLOCK_SIZE;
;atcatls.c,791 :: 		uint8_t block = 0;
;atcatls.c,792 :: 		uint8_t memLoc = 0;
;atcatls.c,796 :: 		if (rsakey == NULL ) {
LDR	R3, [SP, #48]
CMP	R3, #0
IT	NE
BNE	L_atcatls_enc_rsakey_write126
; keysize end address is: 0 (R0)
;atcatls.c,797 :: 		status = ATCA_BAD_PARAM;
MOVS	R3, #226
STRB	R3, [SP, #52]
;atcatls.c,798 :: 		BREAK(status, "NULL inputs");
IT	AL
BAL	L_atcatls_enc_rsakey_write124
;atcatls.c,799 :: 		}
L_atcatls_enc_rsakey_write126:
;atcatls.c,800 :: 		if (keysize < RSA2048_KEY_SIZE) {
; keysize start address is: 0 (R0)
CMP	R0, #256
IT	GE
BGE	L_atcatls_enc_rsakey_write127
; keysize end address is: 0 (R0)
;atcatls.c,801 :: 		status = ATCA_BAD_PARAM;
MOVS	R3, #226
STRB	R3, [SP, #52]
;atcatls.c,802 :: 		BREAK(status, "RSA key buffer too small");
IT	AL
BAL	L_atcatls_enc_rsakey_write124
;atcatls.c,803 :: 		}
L_atcatls_enc_rsakey_write127:
;atcatls.c,806 :: 		if ((status = atcatls_get_enckey(enckey)) != ATCA_SUCCESS) BREAK(status, "Get encryption key failed");
ADD	R3, SP, #8
MOV	R0, R3
BL	_atcatls_get_enckey+0
STRB	R0, [SP, #52]
CMP	R0, #0
IT	EQ
BEQ	L_atcatls_enc_rsakey_write128
IT	AL
BAL	L_atcatls_enc_rsakey_write124
L_atcatls_enc_rsakey_write128:
;atcatls.c,809 :: 		for (memBlock = 0; memBlock < numKeyBlocks; memBlock++) {
; memBlock start address is: 40 (R10)
MOVW	R10, #0
; memBlock end address is: 40 (R10)
UXTB	R1, R10
L_atcatls_enc_rsakey_write129:
; memBlock start address is: 4 (R1)
LDRB	R3, [SP, #42]
CMP	R1, R3
IT	CS
BCS	L_atcatls_enc_rsakey_write130
;atcatls.c,810 :: 		block = startBlock + memBlock;
LDRB	R3, [SP, #41]
ADDS	R7, R3, R1
;atcatls.c,811 :: 		memLoc = ATCA_BLOCK_SIZE * memBlock;
LSLS	R3, R1, #5
SXTH	R3, R3
;atcatls.c,812 :: 		if ((status = atcab_write_enc(slotid, block, &rsakey[memLoc], enckey, enckeyId)) != ATCA_SUCCESS) BREAK(status, "Read RSA failed");
LDRB	R6, [SP, #44]
ADD	R5, SP, #8
UXTB	R4, R3
LDR	R3, [SP, #48]
ADDS	R3, R3, R4
STRB	R1, [SP, #4]
MOV	R2, R3
MOV	R3, R5
UXTB	R1, R7
LDRB	R0, [SP, #40]
PUSH	(R6)
BL	_atcab_write_enc+0
ADD	SP, SP, #4
LDRB	R1, [SP, #4]
STRB	R0, [SP, #52]
CMP	R0, #0
IT	EQ
BEQ	L_atcatls_enc_rsakey_write132
; memBlock end address is: 4 (R1)
IT	AL
BAL	L_atcatls_enc_rsakey_write130
L_atcatls_enc_rsakey_write132:
;atcatls.c,809 :: 		for (memBlock = 0; memBlock < numKeyBlocks; memBlock++) {
; memBlock start address is: 4 (R1)
ADDS	R3, R1, #1
; memBlock end address is: 4 (R1)
; memBlock start address is: 40 (R10)
UXTB	R10, R3
;atcatls.c,813 :: 		}
UXTB	R1, R10
; memBlock end address is: 40 (R10)
IT	AL
BAL	L_atcatls_enc_rsakey_write129
L_atcatls_enc_rsakey_write130:
;atcatls.c,815 :: 		} while (0);
L_atcatls_enc_rsakey_write124:
;atcatls.c,817 :: 		return status;
LDRB	R0, [SP, #52]
;atcatls.c,818 :: 		}
L_end_atcatls_enc_rsakey_write:
LDR	LR, [SP, #0]
ADD	SP, SP, #56
BX	LR
; end of _atcatls_enc_rsakey_write
_atcatls_get_signer_cert:
;atcatls.c,824 :: 		ATCA_STATUS atcatls_get_signer_cert(uint8_t *certout, size_t* certsize)
; certsize start address is: 4 (R1)
; certout start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
MOV	R6, R1
; certsize end address is: 4 (R1)
; certout end address is: 0 (R0)
; certout start address is: 0 (R0)
; certsize start address is: 24 (R6)
;atcatls.c,826 :: 		ATCA_STATUS status = ATCA_SUCCESS;
; status start address is: 28 (R7)
MOVS	R7, #0
;atcatls.c,827 :: 		size_t sigCertSize = 0;
;atcatls.c,831 :: 		if (certout == NULL || certsize == NULL) {
CMP	R0, #0
IT	EQ
BEQ	L__atcatls_get_signer_cert202
CMP	R6, #0
IT	EQ
BEQ	L__atcatls_get_signer_cert201
IT	AL
BAL	L_atcatls_get_signer_cert138
; certout end address is: 0 (R0)
; certsize end address is: 24 (R6)
; status end address is: 28 (R7)
L__atcatls_get_signer_cert202:
L__atcatls_get_signer_cert201:
;atcatls.c,832 :: 		status = ATCA_BAD_PARAM;
; status start address is: 0 (R0)
MOVS	R0, #226
;atcatls.c,833 :: 		BREAK(status, "NULL inputs");
; status end address is: 0 (R0)
IT	AL
BAL	L_atcatls_get_signer_cert134
;atcatls.c,834 :: 		}
L_atcatls_get_signer_cert138:
;atcatls.c,836 :: 		sigCertSize = sizeof(g_SignerCert);
; sigCertSize start address is: 32 (R8)
; status start address is: 28 (R7)
; certsize start address is: 24 (R6)
; certout start address is: 0 (R0)
MOVW	R8, #454
;atcatls.c,837 :: 		if (*certsize < sigCertSize) {
LDR	R2, [R6, #0]
CMP	R2, #454
IT	CS
BCS	L_atcatls_get_signer_cert139
; certout end address is: 0 (R0)
; certsize end address is: 24 (R6)
; status end address is: 28 (R7)
; sigCertSize end address is: 32 (R8)
;atcatls.c,838 :: 		status = ATCA_BAD_PARAM;
; status start address is: 0 (R0)
MOVS	R0, #226
;atcatls.c,839 :: 		BREAK(status, "Buffer not big enough for memcpy");
; status end address is: 0 (R0)
IT	AL
BAL	L_atcatls_get_signer_cert134
;atcatls.c,840 :: 		}
L_atcatls_get_signer_cert139:
;atcatls.c,841 :: 		memcpy(certout, g_SignerCert, sigCertSize);
; sigCertSize start address is: 32 (R8)
; status start address is: 28 (R7)
; certsize start address is: 24 (R6)
; certout start address is: 0 (R0)
SXTH	R2, R8
MOVW	R1, #lo_addr(_g_SignerCert+0)
MOVT	R1, #hi_addr(_g_SignerCert+0)
; certout end address is: 0 (R0)
BL	_memcpy+0
;atcatls.c,842 :: 		*certsize = sigCertSize;
STR	R8, [R6, #0]
; certsize end address is: 24 (R6)
; status end address is: 28 (R7)
; sigCertSize end address is: 32 (R8)
UXTB	R0, R7
;atcatls.c,844 :: 		} while (0);
L_atcatls_get_signer_cert134:
;atcatls.c,846 :: 		return status;
; status start address is: 0 (R0)
; status end address is: 0 (R0)
;atcatls.c,847 :: 		}
L_end_atcatls_get_signer_cert:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atcatls_get_signer_cert
_atcatls_get_device_cert:
;atcatls.c,853 :: 		ATCA_STATUS atcatls_get_device_cert(uint8_t *certout, size_t* certsize)
; certsize start address is: 4 (R1)
; certout start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
MOV	R6, R1
; certsize end address is: 4 (R1)
; certout end address is: 0 (R0)
; certout start address is: 0 (R0)
; certsize start address is: 24 (R6)
;atcatls.c,855 :: 		ATCA_STATUS status = ATCA_SUCCESS;
; status start address is: 28 (R7)
MOVS	R7, #0
;atcatls.c,856 :: 		size_t devCertSize = 0;
;atcatls.c,860 :: 		if (certout == NULL || certsize == NULL) {
CMP	R0, #0
IT	EQ
BEQ	L__atcatls_get_device_cert205
CMP	R6, #0
IT	EQ
BEQ	L__atcatls_get_device_cert204
IT	AL
BAL	L_atcatls_get_device_cert145
; certout end address is: 0 (R0)
; certsize end address is: 24 (R6)
; status end address is: 28 (R7)
L__atcatls_get_device_cert205:
L__atcatls_get_device_cert204:
;atcatls.c,861 :: 		status = ATCA_BAD_PARAM;
; status start address is: 0 (R0)
MOVS	R0, #226
;atcatls.c,862 :: 		BREAK(status, "NULL inputs");
; status end address is: 0 (R0)
IT	AL
BAL	L_atcatls_get_device_cert141
;atcatls.c,863 :: 		}
L_atcatls_get_device_cert145:
;atcatls.c,865 :: 		devCertSize = sizeof(g_DeviceCert);
; devCertSize start address is: 32 (R8)
; status start address is: 28 (R7)
; certsize start address is: 24 (R6)
; certout start address is: 0 (R0)
MOVW	R8, #428
;atcatls.c,866 :: 		if (*certsize < devCertSize) {
LDR	R2, [R6, #0]
CMP	R2, #428
IT	CS
BCS	L_atcatls_get_device_cert146
; certout end address is: 0 (R0)
; certsize end address is: 24 (R6)
; status end address is: 28 (R7)
; devCertSize end address is: 32 (R8)
;atcatls.c,867 :: 		status = ATCA_BAD_PARAM;
; status start address is: 0 (R0)
MOVS	R0, #226
;atcatls.c,868 :: 		BREAK(status, "Buffer not big enough for memcpy");
; status end address is: 0 (R0)
IT	AL
BAL	L_atcatls_get_device_cert141
;atcatls.c,869 :: 		}
L_atcatls_get_device_cert146:
;atcatls.c,870 :: 		memcpy(certout, g_DeviceCert, devCertSize);
; devCertSize start address is: 32 (R8)
; status start address is: 28 (R7)
; certsize start address is: 24 (R6)
; certout start address is: 0 (R0)
SXTH	R2, R8
MOVW	R1, #lo_addr(_g_DeviceCert+0)
MOVT	R1, #hi_addr(_g_DeviceCert+0)
; certout end address is: 0 (R0)
BL	_memcpy+0
;atcatls.c,871 :: 		*certsize = devCertSize;
STR	R8, [R6, #0]
; certsize end address is: 24 (R6)
; status end address is: 28 (R7)
; devCertSize end address is: 32 (R8)
UXTB	R0, R7
;atcatls.c,873 :: 		} while (0);
L_atcatls_get_device_cert141:
;atcatls.c,875 :: 		return status;
; status start address is: 0 (R0)
; status end address is: 0 (R0)
;atcatls.c,876 :: 		}
L_end_atcatls_get_device_cert:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atcatls_get_device_cert
_atcatls_get_ca_cert:
;atcatls.c,882 :: 		ATCA_STATUS atcatls_get_ca_cert(uint8_t *certout, size_t* certsize)
; certsize start address is: 4 (R1)
; certout start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
MOV	R6, R1
; certsize end address is: 4 (R1)
; certout end address is: 0 (R0)
; certout start address is: 0 (R0)
; certsize start address is: 24 (R6)
;atcatls.c,884 :: 		ATCA_STATUS status = ATCA_SUCCESS;
; status start address is: 28 (R7)
MOVS	R7, #0
;atcatls.c,885 :: 		size_t caCertSize = 0;
;atcatls.c,889 :: 		if (certout == NULL || certsize == NULL) {
CMP	R0, #0
IT	EQ
BEQ	L__atcatls_get_ca_cert208
CMP	R6, #0
IT	EQ
BEQ	L__atcatls_get_ca_cert207
IT	AL
BAL	L_atcatls_get_ca_cert152
; certout end address is: 0 (R0)
; certsize end address is: 24 (R6)
; status end address is: 28 (R7)
L__atcatls_get_ca_cert208:
L__atcatls_get_ca_cert207:
;atcatls.c,890 :: 		status = ATCA_BAD_PARAM;
; status start address is: 0 (R0)
MOVS	R0, #226
;atcatls.c,891 :: 		BREAK(status, "NULL inputs");
; status end address is: 0 (R0)
IT	AL
BAL	L_atcatls_get_ca_cert148
;atcatls.c,892 :: 		}
L_atcatls_get_ca_cert152:
;atcatls.c,894 :: 		caCertSize = sizeof(g_CaCert);
; caCertSize start address is: 32 (R8)
; status start address is: 28 (R7)
; certsize start address is: 24 (R6)
; certout start address is: 0 (R0)
MOVW	R8, #451
;atcatls.c,895 :: 		if (*certsize < caCertSize) {
LDR	R3, [R6, #0]
MOVW	R2, #451
MOVT	R2, #0
CMP	R3, R2
IT	CS
BCS	L_atcatls_get_ca_cert153
; certout end address is: 0 (R0)
; certsize end address is: 24 (R6)
; status end address is: 28 (R7)
; caCertSize end address is: 32 (R8)
;atcatls.c,896 :: 		status = ATCA_BAD_PARAM;
; status start address is: 0 (R0)
MOVS	R0, #226
;atcatls.c,897 :: 		BREAK(status, "Buffer not big enough for memcpy");
; status end address is: 0 (R0)
IT	AL
BAL	L_atcatls_get_ca_cert148
;atcatls.c,898 :: 		}
L_atcatls_get_ca_cert153:
;atcatls.c,899 :: 		memcpy(certout, g_CaCert, caCertSize);
; caCertSize start address is: 32 (R8)
; status start address is: 28 (R7)
; certsize start address is: 24 (R6)
; certout start address is: 0 (R0)
SXTH	R2, R8
MOVW	R1, #lo_addr(_g_CaCert+0)
MOVT	R1, #hi_addr(_g_CaCert+0)
; certout end address is: 0 (R0)
BL	_memcpy+0
;atcatls.c,900 :: 		*certsize = caCertSize;
STR	R8, [R6, #0]
; certsize end address is: 24 (R6)
; status end address is: 28 (R7)
; caCertSize end address is: 32 (R8)
UXTB	R0, R7
;atcatls.c,902 :: 		} while (0);
L_atcatls_get_ca_cert148:
;atcatls.c,904 :: 		return status;
; status start address is: 0 (R0)
; status end address is: 0 (R0)
;atcatls.c,905 :: 		}
L_end_atcatls_get_ca_cert:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atcatls_get_ca_cert
_atcatls_write_pubkey:
;atcatls.c,913 :: 		ATCA_STATUS atcatls_write_pubkey(uint8_t slotid, uint8_t pubkey[PUB_KEY_SIZE], bool lock)
; lock start address is: 8 (R2)
; pubkey start address is: 4 (R1)
; slotid start address is: 0 (R0)
SUB	SP, SP, #20
STR	LR, [SP, #0]
STR	R1, [SP, #4]
UXTB	R1, R0
LDR	R0, [SP, #4]
; lock end address is: 8 (R2)
; pubkey end address is: 4 (R1)
; slotid end address is: 0 (R0)
; slotid start address is: 4 (R1)
; pubkey start address is: 0 (R0)
; lock start address is: 8 (R2)
;atcatls.c,915 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atcatls.c,916 :: 		uint8_t lock_response = 0x00;
MOVS	R3, #0
STRB	R3, [SP, #16]
;atcatls.c,920 :: 		if ((status = atcab_write_pubkey(slotid, pubkey)) != ATCA_SUCCESS) BREAK(status, "Write of public key slot failed");
STRB	R2, [SP, #4]
; pubkey end address is: 0 (R0)
STRB	R1, [SP, #8]
STRB	R1, [SP, #12]
MOV	R1, R0
LDRB	R0, [SP, #12]
BL	_atcab_write_pubkey+0
LDRB	R1, [SP, #8]
LDRB	R2, [SP, #4]
STRB	R0, [SP, #17]
CMP	R0, #0
IT	EQ
BEQ	L_atcatls_write_pubkey157
; slotid end address is: 4 (R1)
; lock end address is: 8 (R2)
IT	AL
BAL	L_atcatls_write_pubkey155
L_atcatls_write_pubkey157:
;atcatls.c,924 :: 		if (lock == true)
; lock start address is: 8 (R2)
; slotid start address is: 4 (R1)
CMP	R2, #1
IT	NE
BNE	L_atcatls_write_pubkey158
; lock end address is: 8 (R2)
;atcatls.c,925 :: 		if ((status = atcab_lock_data_slot(slotid, &lock_response)) != ATCA_SUCCESS) BREAK(status, "Lock public key slot failed");
ADD	R3, SP, #16
UXTB	R0, R1
MOV	R1, R3
; slotid end address is: 4 (R1)
BL	_atcab_lock_data_slot+0
STRB	R0, [SP, #17]
CMP	R0, #0
IT	EQ
BEQ	L_atcatls_write_pubkey159
IT	AL
BAL	L_atcatls_write_pubkey155
L_atcatls_write_pubkey159:
L_atcatls_write_pubkey158:
;atcatls.c,927 :: 		} while (0);
L_atcatls_write_pubkey155:
;atcatls.c,929 :: 		return status;
LDRB	R0, [SP, #17]
;atcatls.c,931 :: 		}
L_end_atcatls_write_pubkey:
LDR	LR, [SP, #0]
ADD	SP, SP, #20
BX	LR
; end of _atcatls_write_pubkey
_atcatls_read_ca_pubkey:
;atcatls.c,938 :: 		ATCA_STATUS atcatls_read_ca_pubkey(uint8_t slotid, uint8_t caPubkey[PUB_KEY_SIZE])
; caPubkey start address is: 4 (R1)
; slotid start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; caPubkey end address is: 4 (R1)
; slotid end address is: 0 (R0)
; slotid start address is: 0 (R0)
; caPubkey start address is: 4 (R1)
;atcatls.c,940 :: 		ATCA_STATUS status = ATCA_GEN_FAIL;
;atcatls.c,944 :: 		if ((status = atcab_read_pubkey(slotid, caPubkey)) != ATCA_SUCCESS) BREAK(status, "Read of public key slot failed");
; caPubkey end address is: 4 (R1)
; slotid end address is: 0 (R0)
BL	_atcab_read_pubkey+0
; status start address is: 4 (R1)
UXTB	R1, R0
CMP	R0, #0
IT	EQ
BEQ	L_atcatls_read_ca_pubkey163
IT	AL
BAL	L_atcatls_read_ca_pubkey161
L_atcatls_read_ca_pubkey163:
;atcatls.c,947 :: 		} while (0);
L_atcatls_read_ca_pubkey161:
;atcatls.c,949 :: 		return status;
UXTB	R0, R1
; status end address is: 4 (R1)
;atcatls.c,950 :: 		}
L_end_atcatls_read_ca_pubkey:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atcatls_read_ca_pubkey
_atcatls_get_cert:
;atcatls.c,965 :: 		ATCA_STATUS atcatls_get_cert( atcacert_def_t* cert_def, uint8_t *ca_public_key, uint8_t *certout, size_t* certsize)
; certsize start address is: 12 (R3)
; certout start address is: 8 (R2)
; ca_public_key start address is: 4 (R1)
; cert_def start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; certsize end address is: 12 (R3)
; certout end address is: 8 (R2)
; ca_public_key end address is: 4 (R1)
; cert_def end address is: 0 (R0)
; cert_def start address is: 0 (R0)
; ca_public_key start address is: 4 (R1)
; certout start address is: 8 (R2)
; certsize start address is: 12 (R3)
;atcatls.c,967 :: 		ATCA_STATUS status = ATCA_SUCCESS;
;atcatls.c,971 :: 		if (certout == NULL || certsize == NULL) {
CMP	R2, #0
IT	EQ
BEQ	L__atcatls_get_cert211
CMP	R3, #0
IT	EQ
BEQ	L__atcatls_get_cert210
IT	AL
BAL	L_atcatls_get_cert169
; cert_def end address is: 0 (R0)
; ca_public_key end address is: 4 (R1)
; certout end address is: 8 (R2)
; certsize end address is: 12 (R3)
L__atcatls_get_cert211:
L__atcatls_get_cert210:
;atcatls.c,972 :: 		status = ATCA_BAD_PARAM;
; status start address is: 0 (R0)
MOVS	R0, #226
;atcatls.c,973 :: 		BREAK(status, "NULL inputs");
; status end address is: 0 (R0)
IT	AL
BAL	L_atcatls_get_cert165
;atcatls.c,974 :: 		}
L_atcatls_get_cert169:
;atcatls.c,977 :: 		status = atcacert_read_cert(cert_def, ca_public_key, certout, certsize);
; certsize start address is: 12 (R3)
; certout start address is: 8 (R2)
; ca_public_key start address is: 4 (R1)
; cert_def start address is: 0 (R0)
; certsize end address is: 12 (R3)
; certout end address is: 8 (R2)
; ca_public_key end address is: 4 (R1)
; cert_def end address is: 0 (R0)
BL	_atcacert_read_cert+0
; status start address is: 4 (R1)
UXTB	R1, R0
;atcatls.c,978 :: 		if (status != ATCACERT_E_SUCCESS)
UXTB	R4, R0
CMP	R4, #0
IT	EQ
BEQ	L_atcatls_get_cert170
;atcatls.c,979 :: 		BREAK(status, "Failed to read certificate");
UXTB	R0, R1
IT	AL
BAL	L_atcatls_get_cert165
L_atcatls_get_cert170:
;atcatls.c,981 :: 		} while (0);
UXTB	R0, R1
L_atcatls_get_cert165:
; status end address is: 4 (R1)
;atcatls.c,983 :: 		return status;
; status start address is: 0 (R0)
; status end address is: 0 (R0)
;atcatls.c,984 :: 		}
L_end_atcatls_get_cert:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atcatls_get_cert
