#line 1 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/tls/atcatls_tests.c"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/cryptoauthlib.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stddef.h"



typedef long ptrdiff_t;


 typedef unsigned long size_t;

typedef unsigned long wchar_t;
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/string.h"





void * memchr(void *p, char n, unsigned int v);
int memcmp(void *s1, void *s2, int n);
void * memcpy(void * d1, void * s1, int n);
void * memmove(void * to, void * from, int n);
void * memset(void * p1, char character, int n);
char * strcat(char * to, char * from);
char * strchr(char * ptr, char chr);
int strcmp(char * s1, char * s2);
char * strcpy(char * to, char * from);
int strlen(char * s);
char * strncat(char * to, char * from, int size);
char * strncpy(char * to, char * from, int size);
int strspn(char * str1, char * str2);
char strcspn(char * s1, char * s2);
int strncmp(char * s1, char * s2, char len);
char * strpbrk(char * s1, char * s2);
char * strrchr(char *ptr, char chr);
char * strstr(char * s1, char * s2);
char * strtok(char * s1, char * s2);
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/hal/atca_hal.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_status.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdbool.h"



 typedef char _Bool;
#line 55 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_status.h"
typedef enum
{
 ATCA_SUCCESS = 0x00,
 ATCA_CONFIG_ZONE_LOCKED = 0x01,
 ATCA_DATA_ZONE_LOCKED = 0x02,
 ATCA_WAKE_FAILED = 0xD0,
 ATCA_CHECKMAC_VERIFY_FAILED = 0xD1,
 ATCA_PARSE_ERROR = 0xD2,
 ATCA_STATUS_CRC = 0xD4,
 ATCA_STATUS_UNKNOWN = 0xD5,
 ATCA_STATUS_ECC = 0xD6,
 ATCA_STATUS_SELFTEST_ERROR = 0xD7,
 ATCA_FUNC_FAIL = 0xE0,
 ATCA_GEN_FAIL = 0xE1,
 ATCA_BAD_PARAM = 0xE2,
 ATCA_INVALID_ID = 0xE3,
 ATCA_INVALID_SIZE = 0xE4,
 ATCA_RX_CRC_ERROR = 0xE5,
 ATCA_RX_FAIL = 0xE6,
 ATCA_RX_NO_RESPONSE = 0xE7,
 ATCA_RESYNC_WITH_WAKEUP = 0xE8,
 ATCA_PARITY_ERROR = 0xE9,
 ATCA_TX_TIMEOUT = 0xEA,
 ATCA_RX_TIMEOUT = 0xEB,
 ATCA_TOO_MANY_COMM_RETRIES = 0xEC,
 ATCA_SMALL_BUFFER = 0xED,
 ATCA_COMM_FAIL = 0xF0,
 ATCA_TIMEOUT = 0xF1,
 ATCA_BAD_OPCODE = 0xF2,
 ATCA_WAKE_SUCCESS = 0xF3,
 ATCA_EXECUTION_ERROR = 0xF4,
 ATCA_UNIMPLEMENTED = 0xF5,
 ATCA_ASSERT_FAILURE = 0xF6,
 ATCA_TX_FAIL = 0xF7,
 ATCA_NOT_LOCKED = 0xF8,
 ATCA_NO_DEVICES = 0xF9,
 ATCA_HEALTH_TEST_ERROR = 0xFA,
 ATCA_ALLOC_FAILURE = 0xFB,
} ATCA_STATUS;
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_iface.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_compiler.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_status.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_devtypes.h"
#line 53 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_devtypes.h"
typedef enum {
 ATSHA204A,
 ATECC108A,
 ATECC508A,
 ATECC608A,
 ATCA_DEV_UNKNOWN = 0x20
} ATCADeviceType;
#line 62 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
struct atca_command {
 ATCADeviceType dt;
 uint16_t *execution_times;
};


typedef struct atca_command * ATCACommand;
ATCACommand newATCACommand(ATCADeviceType device_type);
#pragma pack( push, ATCAPacket, 2 )
#line 97 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
typedef struct {


 uint8_t _reserved;


 uint8_t txsize;
 uint8_t opcode;
 uint8_t param1;
 uint16_t param2;
 uint8_t  _data [130];






 uint8_t execTime;
 uint16_t rxsize;




} ATCAPacket;
#pragma pack( pop, ATCAPacket)
#line 123 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
ATCA_STATUS atCheckMAC(ATCACommand cacmd, ATCAPacket *packet);
ATCA_STATUS atCounter(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atDeriveKey(ATCACommand cacmd, ATCAPacket *packet,  _Bool  hasMAC );
ATCA_STATUS atECDH(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atGenDig(ATCACommand cacmd, ATCAPacket *packet,  _Bool  hasMACKey );
ATCA_STATUS atGenKey(ATCACommand cacmd, ATCAPacket *packet,  _Bool  isPubKey );
ATCA_STATUS atHMAC(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atInfo(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atLock(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atMAC(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atNonce(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atPause(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atPrivWrite(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atRandom(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atRead(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atSHA(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atSign(ATCACommand cacmd, ATCAPacket *packet);
ATCA_STATUS atUpdateExtra(ATCACommand cacmd, ATCAPacket *packet);
ATCA_STATUS atVerify(ATCACommand cacmd, ATCAPacket *packet);
ATCA_STATUS atWrite(ATCACommand cacmd, ATCAPacket *packet);
ATCA_STATUS atWriteEnc(ATCACommand cacmd, ATCAPacket *packet);

 _Bool  atIsSHAFamily( ATCADeviceType deviceType );
 _Bool  atIsECCFamily( ATCADeviceType deviceType );
ATCA_STATUS isATCAError( uint8_t * _data  );


typedef enum {
 WAKE_TWHI,
 CMD_CHECKMAC,
 CMD_COUNTER,
 CMD_DERIVEKEY,
 CMD_ECDH,
 CMD_GENDIG,
 CMD_GENKEY,
 CMD_HMAC,
 CMD_INFO,
 CMD_LOCK,
 CMD_MAC,
 CMD_NONCE,
 CMD_PAUSE,
 CMD_PRIVWRITE,
 CMD_RANDOM,
 CMD_READMEM,
 CMD_SHA,
 CMD_SIGN,
 CMD_UPDATEEXTRA,
 CMD_VERIFY,
 CMD_WRITEMEM,
 CMD_LASTCOMMAND
} ATCA_CmdMap;

ATCA_STATUS atInitExecTimes(ATCACommand cacmd, ATCADeviceType device_type);
uint16_t atGetExecTime( ATCACommand cacmd, ATCA_CmdMap cmd );

void deleteATCACommand( ATCACommand * );



void atCRC( uint8_t length, uint8_t * _data , uint8_t *crc);
void atCalcCrc( ATCAPacket *pkt);
uint8_t atCheckCrc(uint8_t *response);
#line 316 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
typedef enum {
 COUNTER_MODE_READ = 0,
 COUNTER_MODE_INCREASE = 1
} enum_counter_mode;
#line 330 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
typedef enum {
 SHA_MODE_SHA256_START = ((uint8_t) 0x00),
 SHA_MODE_SHA256_UPDATE = ((uint8_t) 0x01),
 SHA_MODE_SHA256_END = ((uint8_t) 0x02),
 SHA_MODE_SHA256_PUBLIC = ((uint8_t) 0x03),
 SHA_MODE_HMAC_START = ((uint8_t) 0x04),
 SHA_MODE_HMAC_UPDATE = ((uint8_t) 0x05),
 SHA_MODE_HMAC_END = ((uint8_t) 0x04)
} enum_sha_mode;
#line 407 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
typedef enum {
 GENKEY_MODE_PRIVATE_KEY_GENERATE = ((uint8_t) 0x04),
 GENKEY_MODE_PUBLIC_KEY_DIGEST = ((uint8_t) 0x08),
 GENKEY_MODE_DIGEST_IN_TEMPKEY = ((uint8_t) 0x10)
} enum_genkey_mode;
#line 58 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_iface.h"
typedef enum {
 ATCA_I2C_IFACE,
 ATCA_SWI_IFACE,
 ATCA_UART_IFACE,
 ATCA_SPI_IFACE,
 ATCA_HID_IFACE

} ATCAIfaceType;
#line 74 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_iface.h"
typedef struct {

 ATCAIfaceType iface_type;
 ATCADeviceType devtype;

 union {
 struct ATCAI2C {
 uint8_t slave_address;
 uint8_t bus;
 uint32_t baud;
 } atcai2c;

 struct ATCASWI {
 uint8_t bus;
 } atcaswi;

 struct ATCAUART {
 int port;
 uint32_t baud;
 uint8_t wordsize;
 uint8_t parity;
 uint8_t stopbits;
 } atcauart;

 struct ATCAHID {
 int idx;
 uint32_t vid;
 uint32_t pid;
 uint32_t packetsize;
 uint8_t guid[16];
 } atcahid;

 };

 uint16_t wake_delay;
 int rx_retries;
 void *cfg_data;
} ATCAIfaceCfg;
#line 117 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_iface.h"
typedef struct atca_iface
{
 ATCAIfaceType mType;
 ATCAIfaceCfg *mIfaceCFG;

 ATCA_STATUS (*atinit)(void *hal, ATCAIfaceCfg *cfg);
 ATCA_STATUS (*atpostinit)(struct atca_iface *hal);
 ATCA_STATUS (*atsend)(struct atca_iface *hal, uint8_t *txdata, int txlength);
 ATCA_STATUS (*atreceive)(struct atca_iface *hal, uint8_t *rxdata, uint16_t *rxlength);
 ATCA_STATUS (*atwake)(struct atca_iface *hal);
 ATCA_STATUS (*atidle)(struct atca_iface *hal);
 ATCA_STATUS (*atsleep)(struct atca_iface *hal);


 void *hal_data;

}T_atca_iface;

typedef T_atca_iface* ATCAIface;

ATCAIface newATCAIface(ATCAIfaceCfg *cfg);


ATCA_STATUS atinit(ATCAIface caiface);
ATCA_STATUS atpostinit(ATCAIface caiface);
ATCA_STATUS atsend(ATCAIface caiface, uint8_t *txdata, int txlength);
ATCA_STATUS atreceive(ATCAIface caiface, uint8_t *rxdata, uint16_t *rxlength);
ATCA_STATUS atwake(ATCAIface caiface);
ATCA_STATUS atidle(ATCAIface caiface);
ATCA_STATUS atsleep(ATCAIface caiface);


ATCAIfaceCfg * atgetifacecfg(ATCAIface caiface);
void* atgetifacehaldat(ATCAIface caiface);

void deleteATCAIface( ATCAIface *dev );
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/hal/atca_start_config.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/hal/atca_start_iface.h"
#line 63 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/hal/atca_hal.h"
typedef struct
{



 ATCA_STATUS (*halinit)(void *hal, ATCAIfaceCfg *cfg);
 ATCA_STATUS (*halpostinit)(ATCAIface iface);
 ATCA_STATUS (*halsend)(ATCAIface iface, uint8_t *txdata, int txlength);
 ATCA_STATUS (*halreceive)(ATCAIface iface, uint8_t* rxdata, uint16_t* rxlength);
 ATCA_STATUS (*halwake)(ATCAIface iface);
 ATCA_STATUS (*halidle)(ATCAIface iface);
 ATCA_STATUS (*halsleep)(ATCAIface iface);
 ATCA_STATUS (*halrelease)(void* hal_data);

 void *hal_data;
} ATCAHAL_t;
#line 84 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/hal/atca_hal.h"
extern ATCA_STATUS hal_iface_init(ATCAIfaceCfg *, ATCAHAL_t* hal);
extern ATCA_STATUS hal_iface_release(ATCAIfaceType, void* hal_data);
#line 116 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/hal/atca_hal.h"
ATCA_STATUS hal_swi_init(void *hal, ATCAIfaceCfg *cfg);
ATCA_STATUS hal_swi_post_init(ATCAIface iface);
ATCA_STATUS hal_swi_send(ATCAIface iface, uint8_t *txdata, int txlength);
ATCA_STATUS hal_swi_receive( ATCAIface iface, uint8_t *rxdata, uint16_t *rxlength);
ATCA_STATUS hal_swi_wake(ATCAIface iface);
ATCA_STATUS hal_swi_idle(ATCAIface iface);
ATCA_STATUS hal_swi_sleep(ATCAIface iface);
ATCA_STATUS hal_swi_release(void *hal_data );
ATCA_STATUS hal_swi_discover_buses(int swi_buses[], int max_buses);
ATCA_STATUS hal_swi_discover_devices(int busNum, ATCAIfaceCfg *cfg, int *found);
#line 168 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/hal/atca_hal.h"
void atca_delay_us(uint32_t delay);
void atca_delay_10us(uint32_t delay);
void atca_delay_ms(uint32_t delay);
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_status.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_device.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_iface.h"
#line 59 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_device.h"
struct atca_device {
 ATCACommand mCommands;
 ATCAIface mIface;
};

typedef struct atca_device* ATCADevice;
ATCADevice newATCADevice(ATCAIfaceCfg *cfg );


ATCACommand atGetCommands( ATCADevice dev );
ATCAIface atGetIFace( ATCADevice dev );

void deleteATCADevice( ATCADevice *dev );
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_cfgs.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_iface.h"
#line 53 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_cfgs.h"
extern ATCAIfaceCfg SECURE7_ATCA_CFG;
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/basic/atca_basic.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/cryptoauthlib.h"
#line 63 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/basic/atca_basic.h"
ATCA_STATUS atcab_version( char *verstr );
ATCA_STATUS atcab_init(ATCAIfaceCfg *cfg);
ATCA_STATUS atcab_init_device(ATCADevice cadevice);
ATCA_STATUS atcab_release(void);
ATCADevice atcab_getDevice(void);

ATCA_STATUS atcab_wakeup(void);
ATCA_STATUS atcab_idle(void);
ATCA_STATUS atcab_sleep(void);


ATCA_STATUS atcab_cfg_discover( ATCAIfaceCfg cfgArray[], int max);


ATCA_STATUS atcab_info(uint8_t *revision);
ATCA_STATUS atcab_challenge( uint8_t *challenge);
ATCA_STATUS atcab_challenge_seed_update( uint8_t *seed, uint8_t* rand_out);
ATCA_STATUS atcab_nonce( uint8_t *tempkey);
ATCA_STATUS atcab_nonce_rand( uint8_t *seed, uint8_t* rand_out);
ATCA_STATUS atcab_random(uint8_t *rand_out);

ATCA_STATUS atcab_is_locked(uint8_t zone,  _Bool  *lock_state);
ATCA_STATUS atcab_is_slot_locked(uint8_t slot,  _Bool  *lock_state);

ATCA_STATUS atcab_get_addr(uint8_t zone, uint8_t slot, uint8_t block, uint8_t offset, uint16_t* addr);
ATCA_STATUS atcab_read_zone(uint8_t zone, uint8_t slot, uint8_t block, uint8_t offset, uint8_t *_data, uint8_t len);
ATCA_STATUS atcab_write_zone(uint8_t zone, uint8_t slot, uint8_t block, uint8_t offset, uint8_t * _data , uint8_t len);
ATCA_STATUS atcab_write_bytes_slot(uint8_t slot, uint16_t offset, uint8_t * _data , uint8_t len);
ATCA_STATUS atcab_write_bytes_zone(ATCADeviceType dev_type, uint8_t zone, uint16_t address, uint8_t * _data , uint8_t len);
ATCA_STATUS atcab_read_bytes_zone(ATCADeviceType dev_type, uint8_t zone, uint16_t address, uint8_t len, uint8_t * _data );

ATCA_STATUS atcab_read_serial_number(uint8_t* serial_number);
ATCA_STATUS atcab_read_pubkey(uint8_t slot8toF, uint8_t *pubkey);
ATCA_STATUS atcab_write_pubkey(uint8_t slot8toF, uint8_t *pubkey);
ATCA_STATUS atcab_read_sig(uint8_t slot8toF, uint8_t *sig);
ATCA_STATUS atcab_read_ecc_config_zone(uint8_t* config_data);
ATCA_STATUS atcab_write_ecc_config_zone( uint8_t* config_data);
ATCA_STATUS atcab_read_sha_config_zone( uint8_t* config_data);
ATCA_STATUS atcab_write_sha_config_zone( uint8_t* config_data);
ATCA_STATUS atcab_read_config_zone(ATCADeviceType dev_type, uint8_t* config_data);
ATCA_STATUS atcab_write_config_zone(ATCADeviceType dev_type, uint8_t* config_data);
ATCA_STATUS atcab_cmp_config_zone(uint8_t* config_data,  _Bool * same_config);

ATCA_STATUS atcab_read_enc(uint8_t slotid, uint8_t block, uint8_t * _data , uint8_t* enckey, uint16_t enckeyid);
ATCA_STATUS atcab_write_enc(uint8_t slotid, uint8_t block, uint8_t * _data , uint8_t* enckey, uint16_t enckeyid);

ATCA_STATUS atcab_lock_config_zone(uint8_t* lock_response);
ATCA_STATUS atcab_lock_data_zone(uint8_t* lock_response);
ATCA_STATUS atcab_lock_data_slot(uint8_t slot, uint8_t* lock_response);

ATCA_STATUS atcab_priv_write(uint8_t slot, uint8_t priv_key[36], uint8_t write_key_slot, uint8_t write_key[32]);
ATCA_STATUS atcab_genkey( int slot, uint8_t *pubkey );
ATCA_STATUS atcab_get_pubkey(uint8_t privSlotId, uint8_t *pubkey);
ATCA_STATUS atcab_calc_pubkey(uint8_t privSlotId, uint8_t *pubkey);
ATCA_STATUS atcab_sign(uint16_t slot, uint8_t *msg, uint8_t *signature);
ATCA_STATUS atcab_verify_extern( uint8_t *message, uint8_t *signature, uint8_t *pubkey,  _Bool  *verified);
ATCA_STATUS atcab_ecdh(uint16_t key_id, uint8_t* pub_key, uint8_t* ret_ecdh);
ATCA_STATUS atcab_ecdh_enc(uint16_t slotid, uint8_t* pubkey, uint8_t* ret_ecdh, uint8_t* enckey, uint8_t enckeyid);
ATCA_STATUS atcab_gendig(uint8_t zone, uint16_t key_id);
ATCA_STATUS atcab_gendig_host(uint8_t zone, uint16_t key_id, uint8_t *other_data, uint8_t len);
ATCA_STATUS atcab_mac( uint8_t mode, uint16_t key_id, uint8_t* challenge, uint8_t* digest );
ATCA_STATUS atcab_checkmac( uint8_t mode, uint16_t key_id, uint8_t *challenge, uint8_t *response, uint8_t *other_data);

ATCA_STATUS atcab_sha_start(void);
ATCA_STATUS atcab_sha_update(uint16_t length, uint8_t *message);
ATCA_STATUS atcab_sha_end(uint8_t *digest, uint16_t length, uint8_t *message);
ATCA_STATUS atcab_sha(uint16_t length, uint8_t *message, uint8_t *digest);
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/basic/atca_helpers.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/cryptoauthlib.h"
#line 68 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/basic/atca_helpers.h"
ATCA_STATUS packHex( char* asciiHex, int asciiHexLen, char* packedHex, int* packedLen);
 _Bool  isDigit(char c);
 _Bool  isWhiteSpace(char c);
 _Bool  isHexAlpha(char c);
 _Bool  isHex(char c);
 _Bool  isHexDigit(char c);
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/tls/atcatls.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/cryptoauthlib.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stddef.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stddef.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_date.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert.h"
#line 58 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_date.h"
typedef struct atcacert_tm_utc_s {
 int tm_sec;
 int tm_min;
 int tm_hour;
 int tm_mday;
 int tm_mon;
 int tm_year;
} atcacert_tm_utc_t;
#line 70 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_date.h"
typedef enum atcacert_date_format_e {
 DATEFMT_ISO8601_SEP,
 DATEFMT_RFC5280_UTC,
 DATEFMT_POSIX_UINT32_BE,
 DATEFMT_POSIX_UINT32_LE,
 DATEFMT_RFC5280_GEN
} atcacert_date_format_t;








static size_t ATCACERT_DATE_FORMAT_SIZES[] = {
  (20) ,
  (13) ,
  (4) ,
  (4) ,
  (15) 
};
#line 109 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_date.h"
int atcacert_date_enc( atcacert_date_format_t format,
 atcacert_tm_utc_t* timestamp,
 uint8_t* formatted_date,
 size_t* formatted_date_size);
#line 124 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_date.h"
int atcacert_date_dec( atcacert_date_format_t format,
 uint8_t* formatted_date,
 size_t formatted_date_size,
 atcacert_tm_utc_t* timestamp);
#line 140 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_date.h"
int atcacert_date_enc_compcert( atcacert_tm_utc_t * issue_date,
 uint8_t expire_years,
 uint8_t enc_dates[3]);
#line 157 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_date.h"
int atcacert_date_dec_compcert( uint8_t enc_dates[3],
 atcacert_date_format_t expire_date_format,
 atcacert_tm_utc_t* issue_date,
 atcacert_tm_utc_t* expire_date);
#line 170 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_date.h"
int atcacert_date_get_max_date( atcacert_date_format_t format, atcacert_tm_utc_t* timestamp );

int atcacert_date_enc_iso8601_sep( atcacert_tm_utc_t * timestamp,
 uint8_t formatted_date[ (20) ]);

int atcacert_date_dec_iso8601_sep( uint8_t formatted_date[ (20) ],
 atcacert_tm_utc_t* timestamp);

int atcacert_date_enc_rfc5280_utc( atcacert_tm_utc_t * timestamp,
 uint8_t formatted_date[ (13) ]);

int atcacert_date_dec_rfc5280_utc( uint8_t formatted_date[ (13) ],
 atcacert_tm_utc_t* timestamp);

int atcacert_date_enc_rfc5280_gen( atcacert_tm_utc_t * timestamp,
 uint8_t formatted_date[ (15) ]);

int atcacert_date_dec_rfc5280_gen( uint8_t formatted_date[ (15) ],
 atcacert_tm_utc_t* timestamp);

int atcacert_date_enc_posix_uint32_be( atcacert_tm_utc_t * timestamp,
 uint8_t formatted_date[ (4) ]);

int atcacert_date_dec_posix_uint32_be( uint8_t formatted_date[ (4) ],
 atcacert_tm_utc_t* timestamp);

int atcacert_date_enc_posix_uint32_le( atcacert_tm_utc_t * timestamp,
 uint8_t formatted_date[ (4) ]);

int atcacert_date_dec_posix_uint32_le( uint8_t formatted_date[ (4) ],
 atcacert_tm_utc_t* timestamp);
#line 72 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
typedef enum atcacert_cert_type_e {
 CERTTYPE_X509,
 CERTTYPE_CUSTOM
} atcacert_cert_type_t;
#line 80 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
typedef enum atcacert_cert_sn_src_e {
 SNSRC_STORED = 0x0,
 SNSRC_DEVICE_SN = 0x8,
 SNSRC_SIGNER_ID = 0x9,
 SNSRC_PUB_KEY_HASH = 0xA,
 SNSRC_DEVICE_SN_HASH = 0xB,
 SNSRC_PUB_KEY_HASH_POS = 0xC,
 SNSRC_DEVICE_SN_HASH_POS = 0xD,
 SNSRC_PUB_KEY_HASH_RAW = 0xE,
 SNSRC_DEVICE_SN_HASH_RAW = 0xF
} atcacert_cert_sn_src_t;
#line 95 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
typedef enum atcacert_device_zone_e {
 DEVZONE_CONFIG = 0x00,
 DEVZONE_OTP = 0x01,
 DEVZONE_DATA = 0x02,
 DEVZONE_NONE = 0x07
} atcacert_device_zone_t;
#line 105 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
typedef enum atcacert_std_cert_element_e {
 STDCERT_PUBLIC_KEY,
 STDCERT_SIGNATURE,
 STDCERT_ISSUE_DATE,
 STDCERT_EXPIRE_DATE,
 STDCERT_SIGNER_ID,
 STDCERT_CERT_SN,
 STDCERT_AUTH_KEY_ID,
 STDCERT_SUBJ_KEY_ID,
 STDCERT_NUM_ELEMENTS
} atcacert_std_cert_element_t;
#pragma pack(push, 1)
#line 123 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
typedef struct atcacert_device_loc_s {
 atcacert_device_zone_t zone;
 uint8_t slot;
 uint8_t is_genkey;
 uint16_t offset;
 uint16_t count;
} atcacert_device_loc_t;
#line 134 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
typedef struct atcacert_cert_loc_s {
 uint16_t offset;
 uint16_t count;
} atcacert_cert_loc_t;
#line 142 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
typedef struct atcacert_cert_element_s {
 char id[16];
 atcacert_device_loc_t device_loc;
 atcacert_cert_loc_t cert_loc;
} atcacert_cert_element_t;
#line 154 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
typedef struct atcacert_def_s {
 atcacert_cert_type_t type;
 uint8_t template_id;
 uint8_t chain_id;
 uint8_t private_key_slot;
 atcacert_cert_sn_src_t sn_source;
 atcacert_device_loc_t cert_sn_dev_loc;
 atcacert_date_format_t issue_date_format;
 atcacert_date_format_t expire_date_format;
 atcacert_cert_loc_t tbs_cert_loc;
 uint8_t expire_years;
 atcacert_device_loc_t public_key_dev_loc;
 atcacert_device_loc_t comp_cert_dev_loc;
 atcacert_cert_loc_t std_cert_elements[STDCERT_NUM_ELEMENTS];
 atcacert_cert_element_t* cert_elements;
 uint8_t cert_elements_count;
 uint8_t* cert_template;
 uint16_t cert_template_size;
} atcacert_def_t;
#line 177 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
typedef struct atcacert_build_state_s {
 atcacert_def_t* cert_def;
 uint8_t* cert;
 size_t* cert_size;
 size_t max_cert_size;
 uint8_t is_device_sn;
 uint8_t device_sn[9];
} atcacert_build_state_t;
#pragma pack(pop)
#line 212 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_get_device_locs( atcacert_def_t* cert_def,
 atcacert_device_loc_t* device_locs,
 size_t* device_locs_count,
 size_t device_locs_max_count,
 size_t block_size);
#line 233 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_cert_build_start( atcacert_build_state_t* build_state,
 atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t* cert_size,
 uint8_t ca_public_key[64]);
#line 251 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_cert_build_process( atcacert_build_state_t* build_state,
 atcacert_device_loc_t* device_loc,
 uint8_t* device_data);
#line 267 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_cert_build_finish( atcacert_build_state_t* build_state );
#line 286 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_get_device_data( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 atcacert_device_loc_t* device_loc,
 uint8_t* device_data);
#line 302 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_set_subj_public_key( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 uint8_t subj_public_key[64]);
#line 318 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_get_subj_public_key( atcacert_def_t * cert_def,
 uint8_t * cert,
 size_t cert_size,
 uint8_t subj_public_key[64]);
#line 333 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_get_subj_key_id( atcacert_def_t * cert_def,
 uint8_t * cert,
 size_t cert_size,
 uint8_t subj_key_id[20]);
#line 350 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_set_signature( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t* cert_size,
 size_t max_cert_size,
 uint8_t signature[64]);
#line 367 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_get_signature( atcacert_def_t * cert_def,
 uint8_t * cert,
 size_t cert_size,
 uint8_t signature[64]);
#line 383 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_set_issue_date( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 atcacert_tm_utc_t* timestamp);
#line 399 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_get_issue_date( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 atcacert_tm_utc_t* timestamp);
#line 415 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_set_expire_date( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 atcacert_tm_utc_t* timestamp);
#line 431 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_get_expire_date( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 atcacert_tm_utc_t* timestamp);
#line 446 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_set_signer_id( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 uint8_t signer_id[2]);
#line 461 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_get_signer_id( atcacert_def_t * cert_def,
 uint8_t * cert,
 size_t cert_size,
 uint8_t signer_id[2]);
#line 477 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_set_cert_sn( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 uint8_t* cert_sn,
 size_t cert_sn_size);
#line 500 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_gen_cert_sn( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 uint8_t device_sn[9]);
#line 517 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_get_cert_sn( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 uint8_t* cert_sn,
 size_t* cert_sn_size);
#line 535 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_set_auth_key_id( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 uint8_t auth_public_key[64]);
#line 550 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_get_auth_key_id( atcacert_def_t * cert_def,
 uint8_t * cert,
 size_t cert_size,
 uint8_t auth_key_id[20]);
#line 570 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_set_comp_cert( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t* cert_size,
 size_t max_cert_size,
 uint8_t comp_cert[72]);
#line 586 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_get_comp_cert( atcacert_def_t * cert_def,
 uint8_t * cert,
 size_t cert_size,
 uint8_t comp_cert[72]);
#line 602 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_get_tbs( atcacert_def_t* cert_def,
 uint8_t* cert,
 size_t cert_size,
 uint8_t** tbs,
 size_t* tbs_size);
#line 618 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_get_tbs_digest( atcacert_def_t * cert_def,
 uint8_t * cert,
 size_t cert_size,
 uint8_t tbs_digest[32]);
#line 635 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_set_cert_element( atcacert_cert_loc_t* cert_loc,
 uint8_t* cert,
 size_t cert_size,
 uint8_t*  _data ,
 size_t data_size);
#line 653 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_get_cert_element( atcacert_cert_loc_t* cert_loc,
 uint8_t* cert,
 size_t cert_size,
 uint8_t*  _data ,
 size_t data_size);
#line 676 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_get_key_id( uint8_t public_key[64], uint8_t key_id[20] );
#line 700 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
int atcacert_merge_device_loc( atcacert_device_loc_t* device_locs,
 size_t* device_locs_count,
 size_t device_locs_max_count,
 atcacert_device_loc_t* device_loc,
 size_t block_size);

int atcacert_is_device_loc_overlap( atcacert_device_loc_t* device_loc1,
 atcacert_device_loc_t* device_loc2);
#line 720 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
void atcacert_public_key_add_padding( uint8_t raw_key[64], uint8_t padded_key[72] );
#line 732 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_def.h"
void atcacert_public_key_remove_padding( uint8_t padded_key[72], uint8_t raw_key[64] );
#line 69 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/tls/atcatls.h"
ATCA_STATUS atcatls_config_default(void);


ATCA_STATUS atcatls_init(ATCAIfaceCfg *pCfg);
ATCA_STATUS atcatls_finish(void);


ATCA_STATUS atcatls_sign(uint8_t slotid, uint8_t *message, uint8_t *signature);
ATCA_STATUS atcatls_verify( uint8_t *message, uint8_t *signature, uint8_t *pubkey,  _Bool  *verified);
ATCA_STATUS atcatls_ecdh(uint8_t slotid, uint8_t* pubkey, uint8_t* pmk);
ATCA_STATUS atcatls_ecdh_enc(uint8_t slotid, uint8_t enckeyId, uint8_t* pubkey, uint8_t* pmk);
ATCA_STATUS atcatls_ecdhe(uint8_t slotid, uint8_t* pubkey, uint8_t* pubkeyret, uint8_t* pmk);
ATCA_STATUS atcatls_create_key(uint8_t slotid, uint8_t *pubkey);
ATCA_STATUS atcatls_calc_pubkey(uint8_t slotid, uint8_t *pubkey);
ATCA_STATUS atcatls_write_pubkey(uint8_t slotid, uint8_t pubkey[ (64) ],  _Bool  lock);
ATCA_STATUS atcatls_read_pubkey(uint8_t slotid, uint8_t *pubkey);
ATCA_STATUS atcatls_random(uint8_t* randout);
ATCA_STATUS atcatls_get_sn(uint8_t sn_out[ (9) ]);


ATCA_STATUS atcatls_get_cert( atcacert_def_t* cert_def, uint8_t *ca_public_key, uint8_t *certout, size_t* certsize);
ATCA_STATUS atcatls_get_ca_cert(uint8_t *certout, size_t* certsize);
ATCA_STATUS atcatls_verify_cert( atcacert_def_t* cert_def, uint8_t* cert, size_t cert_size, uint8_t* ca_public_key);
ATCA_STATUS atcatls_read_ca_pubkey(uint8_t slotid, uint8_t caPubkey[ (64) ]);


ATCA_STATUS atcatls_get_device_cert(uint8_t *certout, size_t* certsize);
ATCA_STATUS atcatls_get_signer_cert(uint8_t *certout, size_t* certsize);


ATCA_STATUS atcatls_init_enckey(uint8_t* enckeyout, uint8_t enckeyId,  _Bool  lock);
ATCA_STATUS atcatls_set_enckey(uint8_t* enckeyin, uint8_t enckeyId,  _Bool  lock);
ATCA_STATUS atcatls_get_enckey(uint8_t* enckeyout);
ATCA_STATUS atcatls_enc_read(uint8_t slotid, uint8_t block, uint8_t enckeyId, uint8_t*  _data , int16_t* bufsize);
ATCA_STATUS atcatls_enc_write(uint8_t slotid, uint8_t block, uint8_t enckeyId, uint8_t*  _data , int16_t bufsize);
ATCA_STATUS atcatls_enc_rsakey_read(uint8_t enckeyId, uint8_t* rsakey, int16_t* keysize);
ATCA_STATUS atcatls_enc_rsakey_write(uint8_t enckeyId, uint8_t* rsakey, int16_t keysize);


typedef ATCA_STATUS atcatlsfn_get_enckey(uint8_t* enckey, int16_t keysize);
ATCA_STATUS atcatlsfn_set_get_enckey(atcatlsfn_get_enckey* fn_get_enckey);
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/basic/atca_basic.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/cryptoauthlib.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/tls/atcatls_tests.h"
#line 13 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/tls/atcatls_tests.h"
void atcatls_test_runner(void);

void test_atcatls_config_device(void);

void test_atcatls_init_finish(void);

void test_atcatls_create_key(void);
void test_atcatls_sign(void);
void test_atcatls_verify(void);
void test_atcatls_ecdh(void);
void test_atcatls_ecdhe(void);
void test_atcatls_random(void);
void test_atcatls_get_sn(void);

void test_atcatls_get_cert(void);

void test_atcatls_init_enc_key(void);
void test_atcatls_enc_write_read(void);
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/tls/atcatls_cfg.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/cryptoauthlib.h"
#line 69 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/tls/atcatls_cfg.h"
typedef struct {
 uint8_t authPrivSlot;
 uint8_t authPmkSlot;
 uint8_t ecdhPrivSlot;
 uint8_t ecdhePrivSlot;
 uint8_t ecdhPmkSlot;
 uint8_t encParentSlot;
 uint8_t shaKeySlot;
 uint8_t hostShaKeySlot;
 uint8_t featurePrivSlot;
 uint8_t encStoreSlot8;
 uint8_t encStoreSlot9;
 uint8_t authCertSlot;
 uint8_t signerPubkeySlot;
 uint8_t signerCertSlot;
 uint8_t featureCertSlot;
 uint8_t pkiCaPubkeySlot;
 uint8_t mfrCaPubkeySlot;
} TlsSlotDef;
#line 52 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/tls/atcatls_tests.c"
uint8_t serverPubKey[] =
{

 0xF4, 0x57, 0x47, 0x0E, 0x47, 0x8A, 0x0C, 0xC1, 0xC2, 0x0F, 0x06, 0x58, 0x36, 0x82, 0x55, 0xBD,
 0xAE, 0x39, 0x44, 0x24, 0x1E, 0xFF, 0xB2, 0x2F, 0x8D, 0xD3, 0xA9, 0x8B, 0x05, 0x8D, 0xBA, 0xF1,


 0xFA, 0x8E, 0x4A, 0xD1, 0x87, 0xDB, 0x01, 0xB9, 0xB8, 0xF4, 0xB2, 0x1F, 0x2F, 0x18, 0x03, 0xEB,
 0x64, 0xD8, 0x98, 0xE2, 0xCB, 0x3B, 0xC4, 0x97, 0x84, 0xEB, 0x64, 0xB4, 0x90, 0xE3, 0x78, 0x12
};

uint8_t pubKey1[] =
{

 0x3C, 0x30, 0x7F, 0x3A, 0x1B, 0x05, 0x96, 0x19, 0x21, 0xEB, 0x35, 0x50, 0x09, 0x1D, 0x1D, 0x48,
 0x5C, 0x68, 0xD4, 0xA4, 0x40, 0x21, 0x05, 0x90, 0x21, 0xF6, 0xA7, 0xF2, 0xA4, 0x7F, 0x2B, 0x8E,


 0xDD, 0x28, 0x1B, 0x0A, 0xA8, 0xF4, 0x5A, 0xF4, 0xAC, 0xDC, 0x85, 0xD9, 0x9A, 0xD0, 0x34, 0x6B,
 0x60, 0xB1, 0x7F, 0xE6, 0xD8, 0x43, 0x26, 0xD9, 0x39, 0x48, 0xC6, 0x34, 0xCF, 0x45, 0xDE, 0x81
};

uint8_t msg1[] =
{
 0x8C, 0x61, 0x64, 0xCE, 0xFD, 0x38, 0x06, 0x05, 0xF7, 0x29, 0x44, 0xE3, 0xB6, 0x5B, 0x9A, 0x33,
 0x34, 0x94, 0x63, 0x2D, 0x2E, 0x16, 0xFD, 0x9E, 0x77, 0x98, 0xF6, 0xF2, 0x67, 0x32, 0xA1, 0x76
};

uint8_t sig1[] =
{

 0xCC, 0x58, 0xBC, 0xB6, 0x7D, 0x8D, 0x82, 0x28, 0x6B, 0xF4, 0x9A, 0x22, 0x88, 0x71, 0x2B, 0x57,
 0x99, 0x73, 0x51, 0x56, 0x9E, 0xE6, 0x98, 0x0C, 0x06, 0xCD, 0x70, 0xEB, 0x82, 0xB5, 0x4D, 0x58,


 0xD1, 0x06, 0xF0, 0xBE, 0xDF, 0xBC, 0x9E, 0x00, 0x3E, 0x56, 0x53, 0xC6, 0x33, 0x6D, 0xFA, 0x9E,
 0xB5, 0x3E, 0xC1, 0x7E, 0x37, 0xE6, 0x66, 0xE8, 0x68, 0xCF, 0xB7, 0x7E, 0x49, 0x1E, 0xBA, 0xBB
};
