#line 1 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_command.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdlib.h"







 typedef struct divstruct {
 int quot;
 int rem;
 } div_t;

 typedef struct ldivstruct {
 long quot;
 long rem;
 } ldiv_t;

 typedef struct uldivstruct {
 unsigned long quot;
 unsigned long rem;
 } uldiv_t;

int abs(int a);
float atof(char * s);
int atoi(char * s);
long atol(char * s);
div_t div(int number, int denom);
ldiv_t ldiv(long number, long denom);
uldiv_t uldiv(unsigned long number, unsigned long denom);
long labs(long x);
long int max(long int a, long int b);
long int min(long int a, long int b);
void srand(unsigned x);
int rand();
int xtoi(char * s);
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/string.h"





void * memchr(void *p, char n, unsigned int v);
int memcmp(void *s1, void *s2, int n);
void * memcpy(void * d1, void * s1, int n);
void * memmove(void * to, void * from, int n);
void * memset(void * p1, char character, int n);
char * strcat(char * to, char * from);
char * strchr(char * ptr, char chr);
int strcmp(char * s1, char * s2);
char * strcpy(char * to, char * from);
int strlen(char * s);
char * strncat(char * to, char * from, int size);
char * strncpy(char * to, char * from, int size);
int strspn(char * str1, char * str2);
char strcspn(char * s1, char * s2);
int strncmp(char * s1, char * s2, char len);
char * strpbrk(char * s1, char * s2);
char * strrchr(char *ptr, char chr);
char * strstr(char * s1, char * s2);
char * strtok(char * s1, char * s2);
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_compiler.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_status.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdbool.h"



 typedef char _Bool;
#line 55 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_status.h"
typedef enum
{
 ATCA_SUCCESS = 0x00,
 ATCA_CONFIG_ZONE_LOCKED = 0x01,
 ATCA_DATA_ZONE_LOCKED = 0x02,
 ATCA_WAKE_FAILED = 0xD0,
 ATCA_CHECKMAC_VERIFY_FAILED = 0xD1,
 ATCA_PARSE_ERROR = 0xD2,
 ATCA_STATUS_CRC = 0xD4,
 ATCA_STATUS_UNKNOWN = 0xD5,
 ATCA_STATUS_ECC = 0xD6,
 ATCA_STATUS_SELFTEST_ERROR = 0xD7,
 ATCA_FUNC_FAIL = 0xE0,
 ATCA_GEN_FAIL = 0xE1,
 ATCA_BAD_PARAM = 0xE2,
 ATCA_INVALID_ID = 0xE3,
 ATCA_INVALID_SIZE = 0xE4,
 ATCA_RX_CRC_ERROR = 0xE5,
 ATCA_RX_FAIL = 0xE6,
 ATCA_RX_NO_RESPONSE = 0xE7,
 ATCA_RESYNC_WITH_WAKEUP = 0xE8,
 ATCA_PARITY_ERROR = 0xE9,
 ATCA_TX_TIMEOUT = 0xEA,
 ATCA_RX_TIMEOUT = 0xEB,
 ATCA_TOO_MANY_COMM_RETRIES = 0xEC,
 ATCA_SMALL_BUFFER = 0xED,
 ATCA_COMM_FAIL = 0xF0,
 ATCA_TIMEOUT = 0xF1,
 ATCA_BAD_OPCODE = 0xF2,
 ATCA_WAKE_SUCCESS = 0xF3,
 ATCA_EXECUTION_ERROR = 0xF4,
 ATCA_UNIMPLEMENTED = 0xF5,
 ATCA_ASSERT_FAILURE = 0xF6,
 ATCA_TX_FAIL = 0xF7,
 ATCA_NOT_LOCKED = 0xF8,
 ATCA_NO_DEVICES = 0xF9,
 ATCA_HEALTH_TEST_ERROR = 0xFA,
 ATCA_ALLOC_FAILURE = 0xFB,
} ATCA_STATUS;
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_devtypes.h"
#line 53 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_devtypes.h"
typedef enum {
 ATSHA204A,
 ATECC108A,
 ATECC508A,
 ATECC608A,
 ATCA_DEV_UNKNOWN = 0x20
} ATCADeviceType;
#line 62 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
struct atca_command {
 ATCADeviceType dt;
 uint16_t *execution_times;
};


typedef struct atca_command * ATCACommand;
ATCACommand newATCACommand(ATCADeviceType device_type);
#pragma pack( push, ATCAPacket, 2 )
#line 97 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
typedef struct {


 uint8_t _reserved;


 uint8_t txsize;
 uint8_t opcode;
 uint8_t param1;
 uint16_t param2;
 uint8_t  _data [130];






 uint8_t execTime;
 uint16_t rxsize;




} ATCAPacket;
#pragma pack( pop, ATCAPacket)
#line 123 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
ATCA_STATUS atCheckMAC(ATCACommand cacmd, ATCAPacket *packet);
ATCA_STATUS atCounter(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atDeriveKey(ATCACommand cacmd, ATCAPacket *packet,  _Bool  hasMAC );
ATCA_STATUS atECDH(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atGenDig(ATCACommand cacmd, ATCAPacket *packet,  _Bool  hasMACKey );
ATCA_STATUS atGenKey(ATCACommand cacmd, ATCAPacket *packet,  _Bool  isPubKey );
ATCA_STATUS atHMAC(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atInfo(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atLock(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atMAC(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atNonce(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atPause(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atPrivWrite(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atRandom(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atRead(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atSHA(ATCACommand cacmd, ATCAPacket *packet );
ATCA_STATUS atSign(ATCACommand cacmd, ATCAPacket *packet);
ATCA_STATUS atUpdateExtra(ATCACommand cacmd, ATCAPacket *packet);
ATCA_STATUS atVerify(ATCACommand cacmd, ATCAPacket *packet);
ATCA_STATUS atWrite(ATCACommand cacmd, ATCAPacket *packet);
ATCA_STATUS atWriteEnc(ATCACommand cacmd, ATCAPacket *packet);

 _Bool  atIsSHAFamily( ATCADeviceType deviceType );
 _Bool  atIsECCFamily( ATCADeviceType deviceType );
ATCA_STATUS isATCAError( uint8_t * _data  );


typedef enum {
 WAKE_TWHI,
 CMD_CHECKMAC,
 CMD_COUNTER,
 CMD_DERIVEKEY,
 CMD_ECDH,
 CMD_GENDIG,
 CMD_GENKEY,
 CMD_HMAC,
 CMD_INFO,
 CMD_LOCK,
 CMD_MAC,
 CMD_NONCE,
 CMD_PAUSE,
 CMD_PRIVWRITE,
 CMD_RANDOM,
 CMD_READMEM,
 CMD_SHA,
 CMD_SIGN,
 CMD_UPDATEEXTRA,
 CMD_VERIFY,
 CMD_WRITEMEM,
 CMD_LASTCOMMAND
} ATCA_CmdMap;

ATCA_STATUS atInitExecTimes(ATCACommand cacmd, ATCADeviceType device_type);
uint16_t atGetExecTime( ATCACommand cacmd, ATCA_CmdMap cmd );

void deleteATCACommand( ATCACommand * );



void atCRC( uint8_t length, uint8_t * _data , uint8_t *crc);
void atCalcCrc( ATCAPacket *pkt);
uint8_t atCheckCrc(uint8_t *response);
#line 316 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
typedef enum {
 COUNTER_MODE_READ = 0,
 COUNTER_MODE_INCREASE = 1
} enum_counter_mode;
#line 330 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
typedef enum {
 SHA_MODE_SHA256_START = ((uint8_t) 0x00),
 SHA_MODE_SHA256_UPDATE = ((uint8_t) 0x01),
 SHA_MODE_SHA256_END = ((uint8_t) 0x02),
 SHA_MODE_SHA256_PUBLIC = ((uint8_t) 0x03),
 SHA_MODE_HMAC_START = ((uint8_t) 0x04),
 SHA_MODE_HMAC_UPDATE = ((uint8_t) 0x05),
 SHA_MODE_HMAC_END = ((uint8_t) 0x04)
} enum_sha_mode;
#line 407 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_command.h"
typedef enum {
 GENKEY_MODE_PRIVATE_KEY_GENERATE = ((uint8_t) 0x04),
 GENKEY_MODE_PUBLIC_KEY_DIGEST = ((uint8_t) 0x08),
 GENKEY_MODE_DIGEST_IN_TEMPKEY = ((uint8_t) 0x10)
} enum_genkey_mode;
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_devtypes.h"
#line 64 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_command.c"
ATCACommand newATCACommand( ATCADeviceType device_type )
{
 ATCA_STATUS status = ATCA_SUCCESS;
 ATCACommand cacmd = (ATCACommand)Malloc(sizeof(struct atca_command));

 cacmd->dt = device_type;
 status = atInitExecTimes(cacmd, device_type);

 if (status != ATCA_SUCCESS) {
 Free((void*)cacmd, sizeof(cacmd));
 cacmd =  0 ;
 }

 return cacmd;
}
#line 88 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_command.c"
ATCA_STATUS atCheckMAC(ATCACommand cacmd, ATCAPacket *packet )
{

 packet->opcode =  ((uint8_t)0x28) ;
 packet->txsize =  (84) ;
 packet->rxsize =  ((uint8_t)4) ;

 atCalcCrc( packet );
 return ATCA_SUCCESS;
}
#line 104 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_command.c"
ATCA_STATUS atCounter(ATCACommand cacmd, ATCAPacket *packet )
{
 if ( !atIsECCFamily( cacmd->dt ) )
 return ATCA_BAD_OPCODE;


 packet->opcode =  ((uint8_t)0x24) ;
 packet->txsize =  ((uint8_t)7) ;
 packet->rxsize =  ((uint8_t)7) ;

 atCalcCrc( packet );
 return ATCA_SUCCESS;
}
#line 124 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_command.c"
ATCA_STATUS atDeriveKey(ATCACommand cacmd, ATCAPacket *packet,  _Bool  hasMAC )
{

 packet->opcode =  ((uint8_t)0x1C) ;



 switch ( hasMAC ) {
 case  1 :
 packet->txsize =  (39) ;
 break;
 case  0 :
 packet->txsize =  ((uint8_t)7) ;
 break;
 }

 packet->rxsize =  ((uint8_t)4) ;
 atCalcCrc( packet );
 return ATCA_SUCCESS;
}
#line 150 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_command.c"
ATCA_STATUS atECDH(ATCACommand cacmd, ATCAPacket *packet )
{


 packet->opcode =  ((uint8_t)0x43) ;
 packet->txsize =  (71) ;
 packet->rxsize =  ((uint8_t)35) ;

 atCalcCrc( packet );
 return ATCA_SUCCESS;
}
#line 168 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_command.c"
ATCA_STATUS atGenDig(ATCACommand cacmd, ATCAPacket *packet,  _Bool  hasMACKey )
{


 packet->opcode =  ((uint8_t)0x15) ;

 if ( packet->param1 == 0x03 )
 packet->txsize =  ((uint8_t)7)  + 32;
 else if ( hasMACKey ==  1  )
 packet->txsize =  (11) ;
 else
 packet->txsize =  ((uint8_t)7) ;

 packet->rxsize =  ((uint8_t)4) ;

 atCalcCrc( packet );
 return ATCA_SUCCESS;
}
#line 193 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_command.c"
ATCA_STATUS atGenKey(ATCACommand cacmd, ATCAPacket *packet,  _Bool  isPubKey )
{


 packet->opcode =  ((uint8_t)0x40) ;

 switch ( isPubKey ) {
 case  1 :
 packet->txsize =  (10) ;
 break;
 case  0 :
 packet->txsize =  ((uint8_t)7) ;
 break;
 }

 packet->rxsize =  ((uint8_t)75) ;

 atCalcCrc( packet );
 return ATCA_SUCCESS;
}
#line 219 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_command.c"
ATCA_STATUS atHMAC(ATCACommand cacmd, ATCAPacket *packet )
{


 packet->opcode =  ((uint8_t)0x11) ;
 packet->txsize =  ((uint8_t)7) ;
 packet->rxsize =  ((uint8_t)35) ;

 atCalcCrc( packet );
 return ATCA_SUCCESS;
}
#line 236 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_command.c"
ATCA_STATUS atInfo( ATCACommand cacmd, ATCAPacket *packet )
{


 packet->opcode =  ((uint8_t)0x30) ;
 packet->txsize =  ((uint8_t)7) ;
 packet->rxsize =  ((uint8_t)7) ;

 atCalcCrc( packet );
 return ATCA_SUCCESS;
}
#line 253 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_command.c"
ATCA_STATUS atLock( ATCACommand cacmd, ATCAPacket *packet )
{


 packet->opcode =  ((uint8_t)0x17) ;
 packet->txsize =  ((uint8_t)7) ;
 packet->rxsize =  ((uint8_t)4) ;

 atCalcCrc( packet );
 return ATCA_SUCCESS;
}
#line 270 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_command.c"
ATCA_STATUS atMAC( ATCACommand cacmd, ATCAPacket *packet )
{



 packet->opcode =  ((uint8_t)0x08) ;
 if ( packet->param1 == 0 )
 packet->txsize =  (39) ;
 else
 packet->txsize =  ((uint8_t)7) ;

 packet->rxsize =  ((uint8_t)35) ;

 atCalcCrc( packet );
 return ATCA_SUCCESS;
}
#line 292 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_command.c"
ATCA_STATUS atNonce( ATCACommand cacmd, ATCAPacket *packet )
{
 int mode;


 packet->opcode =  ((uint8_t)0x16) ;
 mode = packet->param1 & 0x03;

 if ( (mode == 0 || mode == 1) ) {
 packet->txsize =  (27) ;
 packet->rxsize =  ((uint8_t)35) ;
 } else if ( mode == 0x03 ) {
 packet->txsize =  (39) ;
 packet->rxsize =  ((uint8_t)4) ;
 } else
 return ATCA_BAD_PARAM;

 atCalcCrc( packet );
 return ATCA_SUCCESS;
}
#line 318 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_command.c"
ATCA_STATUS atPause( ATCACommand cacmd, ATCAPacket *packet )
{

 packet->opcode =  ((uint8_t)0x01) ;
 packet->txsize =  ((uint8_t)7) ;
 packet->rxsize =  ((uint8_t)4) ;

 atCalcCrc( packet );
 return ATCA_SUCCESS;
}
#line 334 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_command.c"
ATCA_STATUS atPrivWrite( ATCACommand cacmd, ATCAPacket *packet )
{

 packet->opcode =  ((uint8_t)0x46) ;
 packet->txsize =  (75) ;
 packet->rxsize =  ((uint8_t)4) ;

 atCalcCrc( packet );
 return ATCA_SUCCESS;
}
#line 350 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_command.c"
ATCA_STATUS atRandom( ATCACommand cacmd, ATCAPacket *packet )
{


 packet->opcode =  ((uint8_t)0x1B) ;
 packet->txsize =  ((uint8_t)7) ;
 packet->rxsize =  ((uint8_t)35) ;

 atCalcCrc( packet );
 return ATCA_SUCCESS;
}
#line 367 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_command.c"
ATCA_STATUS atRead( ATCACommand cacmd, ATCAPacket *packet )
{


 packet->opcode =  ((uint8_t)0x02) ;
 packet->txsize =  ((uint8_t)7) ;


 if ((packet->param1 & 0x80) == 0 )
 packet->rxsize =  ((uint8_t)7) ;
 else
 packet->rxsize =  ((uint8_t)35) ;

 atCalcCrc( packet );
 return ATCA_SUCCESS;
}
#line 389 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_command.c"
ATCA_STATUS atSHA( ATCACommand cacmd, ATCAPacket *packet )
{
 if ( packet->param2 >  (64)  )
 return ATCA_BAD_PARAM;

 if ( packet->param1 == 0x01 && packet->param2 !=  (64)  )
 return ATCA_BAD_PARAM;

 if ( packet->param1 == 0x02 && packet->param2 >  (64)  - 1 )
 return ATCA_BAD_PARAM;


 packet->opcode =  ((uint8_t)0x47) ;

 switch ( packet->param1 ) {
 case 0x00:
 packet->rxsize =  ((uint8_t)4) ;
 packet->txsize =  (7) ;
 break;
 case 0x01:
 packet->rxsize =  ((uint8_t)4) ;
 packet->txsize =  (7)  +  (64) ;
 break;
 case 0x02:
 packet->rxsize =  ((uint8_t)35) ;


 packet->txsize =  (7)  + packet->param2;
 break;
 }

 atCalcCrc( packet );
 return ATCA_SUCCESS;
}
#line 429 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_command.c"
ATCA_STATUS atSign( ATCACommand cacmd, ATCAPacket *packet )
{


 packet->opcode =  ((uint8_t)0x41) ;
 packet->txsize =  ((uint8_t)7) ;


 packet->rxsize =  ((uint8_t)67) ;

 atCalcCrc( packet );
 return ATCA_SUCCESS;
}
#line 448 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_command.c"
ATCA_STATUS atUpdateExtra( ATCACommand cacmd, ATCAPacket *packet )
{


 packet->opcode =  ((uint8_t)0x20) ;
 packet->txsize =  ((uint8_t)7) ;
 packet->rxsize =  ((uint8_t)4) ;

 atCalcCrc( packet );
 return ATCA_SUCCESS;
}
#line 465 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_command.c"
ATCA_STATUS atVerify( ATCACommand cacmd, ATCAPacket *packet )
{


 packet->opcode =  ((uint8_t)0x45) ;


 switch ( packet->param1 ) {
 case 0:
 packet->txsize =  ( 71) ;
 break;
 case 1:
 packet->txsize =  (135) ;
 break;
 case 2:
 packet->txsize =  (135) ;
 break;
 case 3:
 case 7:
 packet->txsize =  ( 90) ;
 break;
 default:
 return ATCA_BAD_PARAM;
 }
 packet->rxsize =  ((uint8_t)4) ;

 atCalcCrc( packet );
 return ATCA_SUCCESS;
}
#line 500 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_command.c"
ATCA_STATUS atWrite( ATCACommand cacmd, ATCAPacket *packet )
{
 int macsize;
 int writesize;


 packet->opcode =  ((uint8_t)0x12) ;

 macsize = ( packet->param1 & 0x40 ? 32 : 0 );
 writesize = ( packet->param1 & 0x80 ? 32 : 4 );

 if ( macsize == 32 && writesize == 32 )
 packet->txsize =  (71) ;
 else if ( macsize == 32 && writesize == 4 )
 packet->txsize =  (43) ;
 else if ( macsize == 0 && writesize == 32 )
 packet->txsize =  (39) ;
 else if ( macsize == 0 && writesize == 4 )
 packet->txsize =  (11) ;

 packet->rxsize =  ((uint8_t)4) ;
 atCalcCrc( packet );
 return ATCA_SUCCESS;
}
#line 530 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_command.c"
ATCA_STATUS atWriteEnc(ATCACommand cacmd, ATCAPacket *packet)
{

 packet->opcode =  ((uint8_t)0x12) ;
 packet->txsize =  (71) ;
 packet->rxsize =  ((uint8_t)4) ;
 atCalcCrc( packet );
 return ATCA_SUCCESS;
}
#line 544 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_command.c"
void deleteATCACommand( ATCACommand *cacmd )
{
 if ( *cacmd )
 Free((void*)*cacmd,sizeof(*cacmd));

 *cacmd =  0 ;
}
#line 555 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_command.c"
uint16_t exectimes_x08a[] = {
 1,
 13,
 20,
 50,
 58,
 11,
 115,
 23,
 2,
 32,
 14,
 29,
 3,
 48,
 23,
 1,
 9,
 60,
 10,
 72,
 26
};
#line 582 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_command.c"
uint16_t exectimes_204a[] = {
 3,
 38,
 0,
 62,
 0,
 43,
 0,
 69,
 2,
 24,
 35,
 60,
 2,
 0,
 50,
 4,
 22,
 0,
 12,
 0,
 42
};
#line 613 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_command.c"
ATCA_STATUS atInitExecTimes(ATCACommand cacmd, ATCADeviceType device_type)
{
 switch ( device_type ) {
 case ATECC108A:
 case ATECC508A:
 cacmd->execution_times = exectimes_x08a;
 break;
 case ATSHA204A:
 cacmd->execution_times = exectimes_204a;
 break;
 default:
 return ATCA_BAD_PARAM;
 break;
 }

 return ATCA_SUCCESS;
}
#line 638 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_command.c"
uint16_t atGetExecTime( ATCACommand cacmd, ATCA_CmdMap cmd )
{
 return cacmd->execution_times[cmd];
}
#line 651 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_command.c"
void atCRC( uint8_t length, uint8_t * _data , uint8_t *crc)
{
 uint8_t counter;
 uint16_t crc_register = 0;
 uint16_t polynom = 0x8005;
 uint8_t shift_register;
 uint8_t data_bit, crc_bit;

 for (counter = 0; counter < length; counter++) {
 for (shift_register = 0x01; shift_register > 0x00; shift_register <<= 1) {
 data_bit = ( _data [counter] & shift_register) ? 1 : 0;
 crc_bit = crc_register >> 15;
 crc_register <<= 1;
 if (data_bit != crc_bit)
 crc_register ^= polynom;
 }
 }
 crc[0] = (uint8_t)(crc_register & 0x00FF);
 crc[1] = (uint8_t)(crc_register >> 8);
}
#line 677 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_command.c"
void atCalcCrc( ATCAPacket *packet )
{
 uint8_t length, *crc;

 length = packet->txsize -  ((uint8_t)2) ;

 crc = &(packet->txsize) + length;


 atCRC(length, &(packet->txsize), crc);
}
#line 695 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_command.c"
uint8_t atCheckCrc(uint8_t *response)
{
 uint8_t crc[ ((uint8_t)2) ];
 uint8_t count = response[ (0) ];

 count -=  ((uint8_t)2) ;
 atCRC(count, response, crc);

 return (crc[0] == response[count] && crc[1] == response[count + 1]) ? ATCA_SUCCESS : ATCA_RX_CRC_ERROR;
}
#line 712 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_command.c"
 _Bool  atIsSHAFamily( ATCADeviceType deviceType )
{
 switch (deviceType) {
 case ATSHA204A:
 case ATECC108A:
 case ATECC508A:
 return  1 ;
 break;
 default:
 return  0 ;
 break;
 }
}
#line 731 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_command.c"
 _Bool  atIsECCFamily( ATCADeviceType deviceType )
{
 switch (deviceType) {
 case ATECC108A:
 case ATECC508A:
 return  1 ;
 break;
 default:
 return  0 ;
 break;
 }
}
#line 749 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atca_command.c"
ATCA_STATUS isATCAError( uint8_t * _data  )
{
 uint8_t good[4] = { 0x04, 0x00, 0x03, 0x40 };

 if ( memcmp(  _data , good, 4 ) == 0 )
 return ATCA_SUCCESS;

 if (  _data [0] == 0x04 ) {
 switch (  _data [1] ) {
 case 0x01:
 return ATCA_CHECKMAC_VERIFY_FAILED;
 break;
 case 0x03:
 return ATCA_BAD_OPCODE;
 break;
 case 0x0f:
 return ATCA_EXECUTION_ERROR;
 break;
 case 0x11:
 return ATCA_WAKE_SUCCESS;
 break;
 case 0xff:
 return ATCA_STATUS_CRC;
 break;
 default:
 return ATCA_GEN_FAIL;
 break;
 }
 } else
 return ATCA_SUCCESS;
}
