_newATCADevice:
;atca_device.c,56 :: 		ATCADevice newATCADevice(ATCAIfaceCfg *cfg )
; cfg start address is: 0 (R0)
SUB	SP, SP, #16
STR	LR, [SP, #0]
MOV	R2, R0
; cfg end address is: 0 (R0)
; cfg start address is: 8 (R2)
;atca_device.c,58 :: 		ATCADevice cadev = NULL;
;atca_device.c,60 :: 		if (cfg == NULL)
CMP	R2, #0
IT	NE
BNE	L_newATCADevice0
; cfg end address is: 8 (R2)
;atca_device.c,61 :: 		return NULL;
MOVS	R0, #0
IT	AL
BAL	L_end_newATCADevice
L_newATCADevice0:
;atca_device.c,63 :: 		cadev = (ATCADevice)Malloc(sizeof(struct atca_device));
; cfg start address is: 8 (R2)
STR	R2, [SP, #4]
MOVS	R0, #8
BL	_Malloc+0
LDR	R2, [SP, #4]
; cadev start address is: 12 (R3)
MOV	R3, R0
;atca_device.c,64 :: 		cadev->mCommands = (ATCACommand)newATCACommand(cfg->devtype);
MOV	R1, R0
STR	R1, [SP, #12]
ADDS	R1, R2, #1
LDRB	R1, [R1, #0]
STR	R3, [SP, #4]
STR	R2, [SP, #8]
UXTB	R0, R1
BL	_newATCACommand+0
LDR	R2, [SP, #8]
LDR	R3, [SP, #4]
LDR	R1, [SP, #12]
STR	R0, [R1, #0]
;atca_device.c,65 :: 		cadev->mIface    = (ATCAIface)newATCAIface(cfg);
ADDS	R1, R3, #4
STR	R1, [SP, #12]
STR	R3, [SP, #4]
; cfg end address is: 8 (R2)
MOV	R0, R2
BL	_newATCAIface+0
LDR	R3, [SP, #4]
LDR	R1, [SP, #12]
STR	R0, [R1, #0]
;atca_device.c,67 :: 		if (cadev->mCommands == NULL || cadev->mIface == NULL) {
LDR	R1, [R3, #0]
CMP	R1, #0
IT	EQ
BEQ	L__newATCADevice7
ADDS	R1, R3, #4
LDR	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L__newATCADevice6
MOV	R0, R3
IT	AL
BAL	L_newATCADevice3
L__newATCADevice7:
L__newATCADevice6:
;atca_device.c,68 :: 		Free((void*)cadev,sizeof(cadev));
MOVS	R1, #4
MOV	R0, R3
; cadev end address is: 12 (R3)
BL	_Free+0
;atca_device.c,69 :: 		cadev = NULL;
; cadev start address is: 0 (R0)
MOVS	R0, #0
; cadev end address is: 0 (R0)
;atca_device.c,70 :: 		}
L_newATCADevice3:
;atca_device.c,72 :: 		return cadev;
; cadev start address is: 0 (R0)
; cadev end address is: 0 (R0)
;atca_device.c,73 :: 		}
L_end_newATCADevice:
LDR	LR, [SP, #0]
ADD	SP, SP, #16
BX	LR
; end of _newATCADevice
_atGetCommands:
;atca_device.c,79 :: 		ATCACommand atGetCommands( ATCADevice dev )
; dev start address is: 0 (R0)
; dev end address is: 0 (R0)
; dev start address is: 0 (R0)
;atca_device.c,81 :: 		return dev->mCommands;
LDR	R1, [R0, #0]
; dev end address is: 0 (R0)
MOV	R0, R1
;atca_device.c,82 :: 		}
L_end_atGetCommands:
BX	LR
; end of _atGetCommands
_atGetIFace:
;atca_device.c,89 :: 		ATCAIface atGetIFace( ATCADevice dev )
; dev start address is: 0 (R0)
; dev end address is: 0 (R0)
; dev start address is: 0 (R0)
;atca_device.c,91 :: 		return dev->mIface;
ADDS	R1, R0, #4
; dev end address is: 0 (R0)
LDR	R1, [R1, #0]
MOV	R0, R1
;atca_device.c,92 :: 		}
L_end_atGetIFace:
BX	LR
; end of _atGetIFace
_deleteATCADevice:
;atca_device.c,99 :: 		void deleteATCADevice( ATCADevice *cadev ) // destructor
SUB	SP, SP, #12
STR	LR, [SP, #0]
STR	R0, [SP, #8]
;atca_device.c,101 :: 		struct atca_device *dev = *cadev;
LDR	R1, [SP, #8]
LDR	R1, [R1, #0]
; dev start address is: 0 (R0)
MOV	R0, R1
;atca_device.c,103 :: 		if ( *cadev ) {
CMP	R1, #0
IT	EQ
BEQ	L_deleteATCADevice4
;atca_device.c,104 :: 		deleteATCACommand( (ATCACommand*)&(dev->mCommands));
STR	R0, [SP, #4]
BL	_deleteATCACommand+0
LDR	R0, [SP, #4]
;atca_device.c,105 :: 		deleteATCAIface((ATCAIface*)&(dev->mIface));
ADDS	R1, R0, #4
; dev end address is: 0 (R0)
MOV	R0, R1
BL	_deleteATCAIface+0
;atca_device.c,106 :: 		Free((void*)*cadev,sizeof(*cadev));
LDR	R1, [SP, #8]
LDR	R1, [R1, #0]
MOV	R0, R1
MOVS	R1, #4
BL	_Free+0
;atca_device.c,107 :: 		}
L_deleteATCADevice4:
;atca_device.c,109 :: 		*cadev = NULL;
MOVS	R2, #0
LDR	R1, [SP, #8]
STR	R2, [R1, #0]
;atca_device.c,110 :: 		}
L_end_deleteATCADevice:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _deleteATCADevice
