_atcacert_read_cert:
;atcacert_client.c,52 :: 		size_t*               cert_size)
; cert_size start address is: 12 (R3)
; cert start address is: 8 (R2)
; ca_public_key start address is: 4 (R1)
; cert_def start address is: 0 (R0)
SUBW	SP, SP, #608
STR	LR, [SP, #0]
MOV	R7, R3
MOV	R3, R2
MOV	R2, R1
MOV	R1, R0
; cert_size end address is: 12 (R3)
; cert end address is: 8 (R2)
; ca_public_key end address is: 4 (R1)
; cert_def end address is: 0 (R0)
; cert_def start address is: 4 (R1)
; ca_public_key start address is: 8 (R2)
; cert start address is: 12 (R3)
; cert_size start address is: 28 (R7)
;atcacert_client.c,54 :: 		int ret = 0;
;atcacert_client.c,56 :: 		size_t device_locs_count = 0;
MOV	R4, #0
STR	R4, [SP, #604]
;atcacert_client.c,57 :: 		size_t i = 0;
;atcacert_client.c,60 :: 		if (cert_def == NULL || ca_public_key == NULL || cert == NULL || cert_size == NULL)
CMP	R1, #0
IT	EQ
BEQ	L__atcacert_read_cert27
CMP	R2, #0
IT	EQ
BEQ	L__atcacert_read_cert26
CMP	R3, #0
IT	EQ
BEQ	L__atcacert_read_cert25
CMP	R7, #0
IT	EQ
BEQ	L__atcacert_read_cert24
IT	AL
BAL	L_atcacert_read_cert2
; cert_def end address is: 4 (R1)
; ca_public_key end address is: 8 (R2)
; cert end address is: 12 (R3)
; cert_size end address is: 28 (R7)
L__atcacert_read_cert27:
L__atcacert_read_cert26:
L__atcacert_read_cert25:
L__atcacert_read_cert24:
;atcacert_client.c,61 :: 		return ATCACERT_E_BAD_PARAMS;
MOVS	R0, #2
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_read_cert
L_atcacert_read_cert2:
;atcacert_client.c,68 :: 		32);
; cert_size start address is: 28 (R7)
; cert start address is: 12 (R3)
; ca_public_key start address is: 8 (R2)
; cert_def start address is: 4 (R1)
MOVS	R6, #32
;atcacert_client.c,66 :: 		&device_locs_count,
ADD	R5, SP, #604
;atcacert_client.c,65 :: 		device_locs,
ADD	R4, SP, #448
;atcacert_client.c,67 :: 		sizeof(device_locs) / sizeof(device_locs[0]),
STR	R7, [SP, #4]
STR	R3, [SP, #8]
STR	R2, [SP, #12]
STR	R1, [SP, #16]
MOVW	R3, #16
;atcacert_client.c,66 :: 		&device_locs_count,
MOV	R2, R5
;atcacert_client.c,64 :: 		cert_def,
MOV	R0, R1
;atcacert_client.c,65 :: 		device_locs,
MOV	R1, R4
;atcacert_client.c,68 :: 		32);
PUSH	(R6)
BL	_atcacert_get_device_locs+0
ADD	SP, SP, #4
;atcacert_client.c,67 :: 		sizeof(device_locs) / sizeof(device_locs[0]),
LDR	R1, [SP, #16]
LDR	R2, [SP, #12]
LDR	R3, [SP, #8]
LDR	R7, [SP, #4]
;atcacert_client.c,68 :: 		32);
; ret start address is: 16 (R4)
SXTH	R4, R0
;atcacert_client.c,69 :: 		if (ret != ATCACERT_E_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_atcacert_read_cert3
; cert_def end address is: 4 (R1)
; ca_public_key end address is: 8 (R2)
; cert end address is: 12 (R3)
; cert_size end address is: 28 (R7)
;atcacert_client.c,70 :: 		return ret;
SXTH	R0, R4
; ret end address is: 16 (R4)
IT	AL
BAL	L_end_atcacert_read_cert
L_atcacert_read_cert3:
;atcacert_client.c,72 :: 		ret = atcacert_cert_build_start(&build_state, cert_def, cert, cert_size, ca_public_key);
; cert_size start address is: 28 (R7)
; cert start address is: 12 (R3)
; ca_public_key start address is: 8 (R2)
; cert_def start address is: 4 (R1)
ADD	R4, SP, #576
PUSH	(R2)
; cert_size end address is: 28 (R7)
MOV	R2, R3
MOV	R3, R7
; cert end address is: 12 (R3)
; cert_def end address is: 4 (R1)
MOV	R0, R4
; ca_public_key end address is: 8 (R2)
BL	_atcacert_cert_build_start+0
ADD	SP, SP, #4
; ret start address is: 4 (R1)
SXTH	R1, R0
;atcacert_client.c,73 :: 		if (ret != ATCACERT_E_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_atcacert_read_cert4
;atcacert_client.c,74 :: 		return ret;
SXTH	R0, R1
; ret end address is: 4 (R1)
IT	AL
BAL	L_end_atcacert_read_cert
L_atcacert_read_cert4:
;atcacert_client.c,76 :: 		for (i = 0; i < device_locs_count; i++) {
; i start address is: 4 (R1)
MOVS	R1, #0
; i end address is: 4 (R1)
L_atcacert_read_cert5:
; i start address is: 4 (R1)
LDR	R4, [SP, #604]
CMP	R1, R4
IT	CS
BCS	L_atcacert_read_cert6
;atcacert_client.c,78 :: 		if (device_locs[i].zone == DEVZONE_DATA && device_locs[i].is_genkey) {
ADD	R5, SP, #448
LSLS	R4, R1, #3
ADDS	R4, R5, R4
LDRB	R4, [R4, #0]
CMP	R4, #2
IT	NE
BNE	L__atcacert_read_cert29
ADD	R5, SP, #448
LSLS	R4, R1, #3
ADDS	R4, R5, R4
ADDS	R4, R4, #2
LDRB	R4, [R4, #0]
CMP	R4, #0
IT	EQ
BEQ	L__atcacert_read_cert28
L__atcacert_read_cert22:
;atcacert_client.c,79 :: 		ret = atcab_get_pubkey(device_locs[i].slot, data);
ADD	R6, SP, #32
ADD	R5, SP, #448
LSLS	R4, R1, #3
ADDS	R4, R5, R4
ADDS	R4, R4, #1
LDRB	R4, [R4, #0]
STR	R1, [SP, #4]
MOV	R1, R6
UXTB	R0, R4
BL	_atcab_get_pubkey+0
LDR	R1, [SP, #4]
; ret start address is: 0 (R0)
;atcacert_client.c,80 :: 		if (ret != ATCA_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_atcacert_read_cert11
; i end address is: 4 (R1)
;atcacert_client.c,81 :: 		return ret;
; ret end address is: 0 (R0)
IT	AL
BAL	L_end_atcacert_read_cert
L_atcacert_read_cert11:
;atcacert_client.c,82 :: 		}else {
; i start address is: 4 (R1)
IT	AL
BAL	L_atcacert_read_cert12
;atcacert_client.c,78 :: 		if (device_locs[i].zone == DEVZONE_DATA && device_locs[i].is_genkey) {
L__atcacert_read_cert29:
L__atcacert_read_cert28:
;atcacert_client.c,83 :: 		size_t start_block = device_locs[i].offset / 32;
ADD	R5, SP, #448
LSLS	R4, R1, #3
ADDS	R6, R5, R4
ADDS	R5, R6, #4
LDRH	R4, [R5, #0]
LSRS	R4, R4, #5
UXTH	R4, R4
STR	R4, [SP, #20]
;atcacert_client.c,85 :: 		size_t end_block = (device_locs[i].offset + device_locs[i].count) / 32;
LDRH	R5, [R5, #0]
ADDS	R4, R6, #6
LDRH	R4, [R4, #0]
ADDS	R4, R5, R4
UXTH	R4, R4
LSRS	R4, R4, #5
UXTH	R4, R4
STR	R4, [SP, #28]
;atcacert_client.c,86 :: 		for (block = (uint8_t)start_block; block < end_block; block++) {
LDRB	R4, [SP, #20]
STRB	R4, [SP, #24]
; i end address is: 4 (R1)
L_atcacert_read_cert13:
; i start address is: 4 (R1)
LDR	R5, [SP, #28]
LDRB	R4, [SP, #24]
CMP	R4, R5
IT	CS
BCS	L_atcacert_read_cert14
;atcacert_client.c,87 :: 		ret = atcab_read_zone(device_locs[i].zone, device_locs[i].slot, block, 0, &data[block * 32 - device_locs[i].offset], 32);
MOVW	R8, #32
LDRB	R4, [SP, #24]
LSLS	R6, R4, #5
SXTH	R6, R6
ADD	R5, SP, #448
LSLS	R4, R1, #3
ADDS	R7, R5, R4
ADDS	R4, R7, #4
LDRH	R4, [R4, #0]
SUB	R5, R6, R4
UXTH	R5, R5
ADD	R4, SP, #32
ADDS	R6, R4, R5
ADDS	R4, R7, #1
LDRB	R4, [R4, #0]
UXTB	R5, R4
LDRB	R4, [R7, #0]
STR	R1, [SP, #4]
MOVS	R3, #0
LDRB	R2, [SP, #24]
UXTB	R1, R5
UXTB	R0, R4
PUSH	32
PUSH	(R6)
BL	_atcab_read_zone+0
ADD	SP, SP, #8
LDR	R1, [SP, #4]
; ret start address is: 0 (R0)
;atcacert_client.c,88 :: 		if (ret != ATCA_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_atcacert_read_cert16
; i end address is: 4 (R1)
;atcacert_client.c,89 :: 		return ret;
; ret end address is: 0 (R0)
IT	AL
BAL	L_end_atcacert_read_cert
L_atcacert_read_cert16:
;atcacert_client.c,86 :: 		for (block = (uint8_t)start_block; block < end_block; block++) {
; i start address is: 4 (R1)
LDRB	R4, [SP, #24]
ADDS	R4, R4, #1
STRB	R4, [SP, #24]
;atcacert_client.c,90 :: 		}
IT	AL
BAL	L_atcacert_read_cert13
L_atcacert_read_cert14:
;atcacert_client.c,91 :: 		}
L_atcacert_read_cert12:
; i end address is: 4 (R1)
;atcacert_client.c,93 :: 		ret = atcacert_cert_build_process(&build_state, &device_locs[i], data);
; i start address is: 4 (R1)
ADD	R6, SP, #32
ADD	R5, SP, #448
LSLS	R4, R1, #3
ADDS	R5, R5, R4
ADD	R4, SP, #576
STR	R1, [SP, #4]
MOV	R2, R6
MOV	R1, R5
MOV	R0, R4
BL	_atcacert_cert_build_process+0
LDR	R1, [SP, #4]
; ret start address is: 8 (R2)
SXTH	R2, R0
;atcacert_client.c,94 :: 		if (ret != ATCACERT_E_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_atcacert_read_cert17
; i end address is: 4 (R1)
;atcacert_client.c,95 :: 		return ret;
SXTH	R0, R2
; ret end address is: 8 (R2)
IT	AL
BAL	L_end_atcacert_read_cert
L_atcacert_read_cert17:
;atcacert_client.c,76 :: 		for (i = 0; i < device_locs_count; i++) {
; i start address is: 4 (R1)
ADDS	R1, R1, #1
;atcacert_client.c,96 :: 		}
; i end address is: 4 (R1)
IT	AL
BAL	L_atcacert_read_cert5
L_atcacert_read_cert6:
;atcacert_client.c,98 :: 		ret = atcacert_cert_build_finish(&build_state);
ADD	R4, SP, #576
MOV	R0, R4
BL	_atcacert_cert_build_finish+0
; ret start address is: 4 (R1)
SXTH	R1, R0
;atcacert_client.c,99 :: 		if (ret != ATCACERT_E_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_atcacert_read_cert18
;atcacert_client.c,100 :: 		return ret;
SXTH	R0, R1
; ret end address is: 4 (R1)
IT	AL
BAL	L_end_atcacert_read_cert
L_atcacert_read_cert18:
;atcacert_client.c,102 :: 		return ATCACERT_E_SUCCESS;
MOVS	R0, #0
SXTH	R0, R0
;atcacert_client.c,103 :: 		}
L_end_atcacert_read_cert:
LDR	LR, [SP, #0]
ADDW	SP, SP, #608
BX	LR
; end of _atcacert_read_cert
_atcacert_get_response:
;atcacert_client.c,107 :: 		uint8_t response[64])
; response start address is: 8 (R2)
; challenge start address is: 4 (R1)
; device_private_key_slot start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; response end address is: 8 (R2)
; challenge end address is: 4 (R1)
; device_private_key_slot end address is: 0 (R0)
; device_private_key_slot start address is: 0 (R0)
; challenge start address is: 4 (R1)
; response start address is: 8 (R2)
;atcacert_client.c,109 :: 		if (device_private_key_slot > 15 || challenge == NULL || response == NULL)
CMP	R0, #15
IT	HI
BHI	L__atcacert_get_response33
CMP	R1, #0
IT	EQ
BEQ	L__atcacert_get_response32
CMP	R2, #0
IT	EQ
BEQ	L__atcacert_get_response31
IT	AL
BAL	L_atcacert_get_response21
; device_private_key_slot end address is: 0 (R0)
; challenge end address is: 4 (R1)
; response end address is: 8 (R2)
L__atcacert_get_response33:
L__atcacert_get_response32:
L__atcacert_get_response31:
;atcacert_client.c,110 :: 		return ATCACERT_E_BAD_PARAMS;
MOVS	R0, #2
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_get_response
L_atcacert_get_response21:
;atcacert_client.c,112 :: 		return atcab_sign(device_private_key_slot, challenge, response);
; response start address is: 8 (R2)
; challenge start address is: 4 (R1)
; device_private_key_slot start address is: 0 (R0)
; response end address is: 8 (R2)
; challenge end address is: 4 (R1)
; device_private_key_slot end address is: 0 (R0)
BL	_atcab_sign+0
;atcacert_client.c,113 :: 		}
L_end_atcacert_get_response:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atcacert_get_response
