#line 1 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atcacert/atcacert_date.c"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_date.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stddef.h"



typedef long ptrdiff_t;


 typedef unsigned long size_t;

typedef unsigned long wchar_t;
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 58 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_date.h"
typedef struct atcacert_tm_utc_s {
 int tm_sec;
 int tm_min;
 int tm_hour;
 int tm_mday;
 int tm_mon;
 int tm_year;
} atcacert_tm_utc_t;
#line 70 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_date.h"
typedef enum atcacert_date_format_e {
 DATEFMT_ISO8601_SEP,
 DATEFMT_RFC5280_UTC,
 DATEFMT_POSIX_UINT32_BE,
 DATEFMT_POSIX_UINT32_LE,
 DATEFMT_RFC5280_GEN
} atcacert_date_format_t;








static size_t ATCACERT_DATE_FORMAT_SIZES[] = {
  (20) ,
  (13) ,
  (4) ,
  (4) ,
  (15) 
};
#line 109 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_date.h"
int atcacert_date_enc( atcacert_date_format_t format,
 atcacert_tm_utc_t* timestamp,
 uint8_t* formatted_date,
 size_t* formatted_date_size);
#line 124 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_date.h"
int atcacert_date_dec( atcacert_date_format_t format,
 uint8_t* formatted_date,
 size_t formatted_date_size,
 atcacert_tm_utc_t* timestamp);
#line 140 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_date.h"
int atcacert_date_enc_compcert( atcacert_tm_utc_t * issue_date,
 uint8_t expire_years,
 uint8_t enc_dates[3]);
#line 157 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_date.h"
int atcacert_date_dec_compcert( uint8_t enc_dates[3],
 atcacert_date_format_t expire_date_format,
 atcacert_tm_utc_t* issue_date,
 atcacert_tm_utc_t* expire_date);
#line 170 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atcacert/atcacert_date.h"
int atcacert_date_get_max_date( atcacert_date_format_t format, atcacert_tm_utc_t* timestamp );

int atcacert_date_enc_iso8601_sep( atcacert_tm_utc_t * timestamp,
 uint8_t formatted_date[ (20) ]);

int atcacert_date_dec_iso8601_sep( uint8_t formatted_date[ (20) ],
 atcacert_tm_utc_t* timestamp);

int atcacert_date_enc_rfc5280_utc( atcacert_tm_utc_t * timestamp,
 uint8_t formatted_date[ (13) ]);

int atcacert_date_dec_rfc5280_utc( uint8_t formatted_date[ (13) ],
 atcacert_tm_utc_t* timestamp);

int atcacert_date_enc_rfc5280_gen( atcacert_tm_utc_t * timestamp,
 uint8_t formatted_date[ (15) ]);

int atcacert_date_dec_rfc5280_gen( uint8_t formatted_date[ (15) ],
 atcacert_tm_utc_t* timestamp);

int atcacert_date_enc_posix_uint32_be( atcacert_tm_utc_t * timestamp,
 uint8_t formatted_date[ (4) ]);

int atcacert_date_dec_posix_uint32_be( uint8_t formatted_date[ (4) ],
 atcacert_tm_utc_t* timestamp);

int atcacert_date_enc_posix_uint32_le( atcacert_tm_utc_t * timestamp,
 uint8_t formatted_date[ (4) ]);

int atcacert_date_dec_posix_uint32_le( uint8_t formatted_date[ (4) ],
 atcacert_tm_utc_t* timestamp);
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/string.h"





void * memchr(void *p, char n, unsigned int v);
int memcmp(void *s1, void *s2, int n);
void * memcpy(void * d1, void * s1, int n);
void * memmove(void * to, void * from, int n);
void * memset(void * p1, char character, int n);
char * strcat(char * to, char * from);
char * strchr(char * ptr, char chr);
int strcmp(char * s1, char * s2);
char * strcpy(char * to, char * from);
int strlen(char * s);
char * strncat(char * to, char * from, int size);
char * strncpy(char * to, char * from, int size);
int strspn(char * str1, char * str2);
char strcspn(char * s1, char * s2);
int strncmp(char * s1, char * s2, char len);
char * strpbrk(char * s1, char * s2);
char * strrchr(char *ptr, char chr);
char * strstr(char * s1, char * s2);
char * strtok(char * s1, char * s2);
#line 46 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atcacert/atcacert_date.c"
int atcacert_date_enc( atcacert_date_format_t format,
 atcacert_tm_utc_t* timestamp,
 uint8_t* formatted_date,
 size_t* formatted_date_size)
{
 if (timestamp ==  ((void *)0)  || formatted_date_size ==  ((void *)0)  || format < 0 || format >= sizeof(ATCACERT_DATE_FORMAT_SIZES) / sizeof(ATCACERT_DATE_FORMAT_SIZES[0]))
 return  2 ;

 if (formatted_date !=  ((void *)0)  && *formatted_date_size < ATCACERT_DATE_FORMAT_SIZES[format]) {
 *formatted_date_size = ATCACERT_DATE_FORMAT_SIZES[format];
 return  3 ;
 }
 *formatted_date_size = ATCACERT_DATE_FORMAT_SIZES[format];
 if (formatted_date ==  ((void *)0) )
 return  0 ;

 switch (format) {
 case DATEFMT_ISO8601_SEP: return atcacert_date_enc_iso8601_sep(timestamp, formatted_date);
 case DATEFMT_RFC5280_UTC: return atcacert_date_enc_rfc5280_utc(timestamp, formatted_date);
 case DATEFMT_POSIX_UINT32_BE: return atcacert_date_enc_posix_uint32_be(timestamp, formatted_date);
 case DATEFMT_POSIX_UINT32_LE: return atcacert_date_enc_posix_uint32_le(timestamp, formatted_date);
 case DATEFMT_RFC5280_GEN: return atcacert_date_enc_rfc5280_gen(timestamp, formatted_date);
 default: return  2 ;
 }

 return  2 ;
}

int atcacert_date_dec( atcacert_date_format_t format,
 uint8_t* formatted_date,
 size_t formatted_date_size,
 atcacert_tm_utc_t* timestamp)
{
 if (formatted_date ==  ((void *)0)  || timestamp ==  ((void *)0)  || format < 0 || format >= sizeof(ATCACERT_DATE_FORMAT_SIZES) / sizeof(ATCACERT_DATE_FORMAT_SIZES[0]))
 return  2 ;

 if (formatted_date_size < ATCACERT_DATE_FORMAT_SIZES[format])
 return  4 ;

 switch (format) {
 case DATEFMT_ISO8601_SEP: return atcacert_date_dec_iso8601_sep(formatted_date, timestamp);
 case DATEFMT_RFC5280_UTC: return atcacert_date_dec_rfc5280_utc(formatted_date, timestamp);
 case DATEFMT_POSIX_UINT32_BE: return atcacert_date_dec_posix_uint32_be(formatted_date, timestamp);
 case DATEFMT_POSIX_UINT32_LE: return atcacert_date_dec_posix_uint32_le(formatted_date, timestamp);
 case DATEFMT_RFC5280_GEN: return atcacert_date_dec_rfc5280_gen(formatted_date, timestamp);
 default: return  2 ;
 }

 return  0 ;
}

int atcacert_date_get_max_date( atcacert_date_format_t format, atcacert_tm_utc_t* timestamp )
{

 if (timestamp ==  ((void *)0)  || format < 0 || format >= sizeof(ATCACERT_DATE_FORMAT_SIZES) / sizeof(ATCACERT_DATE_FORMAT_SIZES[0]))
 return  2 ;

 switch (format) {
 case DATEFMT_ISO8601_SEP:
 timestamp->tm_year = 9999 - 1900;
 timestamp->tm_mon = 12 - 1;
 timestamp->tm_mday = 31;
 timestamp->tm_hour = 23;
 timestamp->tm_min = 59;
 timestamp->tm_sec = 59;
 break;

 case DATEFMT_RFC5280_UTC:
 timestamp->tm_year = 2049 - 1900;
 timestamp->tm_mon = 12 - 1;
 timestamp->tm_mday = 31;
 timestamp->tm_hour = 23;
 timestamp->tm_min = 59;
 timestamp->tm_sec = 59;
 break;

 case DATEFMT_POSIX_UINT32_BE:
 timestamp->tm_year = 2106 - 1900;
 timestamp->tm_mon = 2 - 1;
 timestamp->tm_mday = 7;
 timestamp->tm_hour = 6;
 timestamp->tm_min = 28;
 timestamp->tm_sec = 15;
 break;

 case DATEFMT_POSIX_UINT32_LE:
 timestamp->tm_year = 2106 - 1900;
 timestamp->tm_mon = 2 - 1;
 timestamp->tm_mday = 7;
 timestamp->tm_hour = 6;
 timestamp->tm_min = 28;
 timestamp->tm_sec = 15;
 break;

 case DATEFMT_RFC5280_GEN:
 timestamp->tm_year = 9999 - 1900;
 timestamp->tm_mon = 12 - 1;
 timestamp->tm_mday = 31;
 timestamp->tm_hour = 23;
 timestamp->tm_min = 59;
 timestamp->tm_sec = 59;
 break;

 default: return  2 ;
 }

 return  0 ;
}
#line 158 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atcacert/atcacert_date.c"
static uint8_t* uint_to_str(uint32_t num, int width, uint8_t* str)
{
 uint8_t* ret = str + width;
 int i;


 for (i = 0; i < width; i++)
 *(str++) = '0';

 for (; num; num /= 10)
 *(--str) = '0' + (num % 10);

 return ret;
}
#line 176 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atcacert/atcacert_date.c"
static uint8_t* str_to_uint( uint8_t* str, int width, uint32_t* num)
{
 uint8_t* error_ret = str;
 uint8_t* good_ret = str + width;
 uint32_t prev_num = 0;
 uint32_t digit_value = 1;
 int digit;

 str += width - 1;
 *num = 0;
 for (digit = 0; digit < width; digit++) {
 if (*str < '0' || *str > '9')
 return error_ret;
 if (digit >= 10) {
 if (*str != '0')
 return error_ret;
 continue;
 }
 if (digit == 9 && *str > '4')
 return error_ret;

 *num += digit_value * (*str - '0');
 if (*num < prev_num)
 return error_ret;

 digit_value *= 10;
 prev_num = *num;
 str--;
 }

 return good_ret;
}
#line 213 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atcacert/atcacert_date.c"
static uint8_t* str_to_int( uint8_t* str, int width, int* num)
{
 uint32_t unum = 0;
 uint8_t* ret = str_to_uint(str, width, &unum);

 if (ret != str && unum > 2147483647UL)
 ret = str;
 *num = (int)unum;
 return ret;
}

int atcacert_date_enc_iso8601_sep( atcacert_tm_utc_t* timestamp,
 uint8_t formatted_date[ (20) ])
{
 uint8_t* cur_pos = formatted_date;
 int year = 0;

 if (timestamp ==  ((void *)0)  || formatted_date ==  ((void *)0) )
 return  2 ;

 year = timestamp->tm_year + 1900;

 if (year < 0 || year > 9999)
 return  5 ;
 cur_pos = uint_to_str(year, 4, cur_pos);

 *(cur_pos++) = '-';

 if (timestamp->tm_mon < 0 || timestamp->tm_mon > 11)
 return  5 ;
 cur_pos = uint_to_str(timestamp->tm_mon + 1, 2, cur_pos);

 *(cur_pos++) = '-';

 if (timestamp->tm_mday < 1 || timestamp->tm_mday > 31)
 return  5 ;
 cur_pos = uint_to_str(timestamp->tm_mday, 2, cur_pos);

 *(cur_pos++) = 'T';

 if (timestamp->tm_hour < 0 || timestamp->tm_hour > 23)
 return  5 ;
 cur_pos = uint_to_str(timestamp->tm_hour, 2, cur_pos);

 *(cur_pos++) = ':';

 if (timestamp->tm_min < 0 || timestamp->tm_min > 59)
 return  5 ;
 cur_pos = uint_to_str(timestamp->tm_min, 2, cur_pos);

 *(cur_pos++) = ':';

 if (timestamp->tm_sec < 0 || timestamp->tm_sec > 59)
 return  5 ;
 cur_pos = uint_to_str(timestamp->tm_sec, 2, cur_pos);

 *(cur_pos++) = 'Z';

 return  0 ;
}

int atcacert_date_dec_iso8601_sep( uint8_t formatted_date[ (20) ],
 atcacert_tm_utc_t* timestamp)
{
 uint8_t* cur_pos = formatted_date;
 uint8_t* new_pos =  ((void *)0) ;

 if (formatted_date ==  ((void *)0)  || timestamp ==  ((void *)0) )
 return  2 ;

 memset(timestamp, 0, sizeof(*timestamp));

 new_pos = str_to_int(cur_pos, 4, &timestamp->tm_year);
 if (new_pos == cur_pos)
 return  4 ;
 cur_pos = new_pos;
 timestamp->tm_year -= 1900;

 if (*(cur_pos++) != '-')
 return  4 ;

 new_pos = str_to_int(cur_pos, 2, &timestamp->tm_mon);
 if (new_pos == cur_pos)
 return  4 ;
 cur_pos = new_pos;
 timestamp->tm_mon -= 1;

 if (*(cur_pos++) != '-')
 return  4 ;

 new_pos = str_to_int(cur_pos, 2, &timestamp->tm_mday);
 if (new_pos == cur_pos)
 return  4 ;
 cur_pos = new_pos;

 if (*(cur_pos++) != 'T')
 return  4 ;

 new_pos = str_to_int(cur_pos, 2, &timestamp->tm_hour);
 if (new_pos == cur_pos)
 return  4 ;
 cur_pos = new_pos;

 if (*(cur_pos++) != ':')
 return  4 ;

 new_pos = str_to_int(cur_pos, 2, &timestamp->tm_min);
 if (new_pos == cur_pos)
 return  4 ;
 cur_pos = new_pos;

 if (*(cur_pos++) != ':')
 return  4 ;

 new_pos = str_to_int(cur_pos, 2, &timestamp->tm_sec);
 if (new_pos == cur_pos)
 return  4 ;
 cur_pos = new_pos;

 if (*(cur_pos++) != 'Z')
 return  4 ;

 return  0 ;
}

int atcacert_date_enc_rfc5280_utc( atcacert_tm_utc_t* timestamp,
 uint8_t formatted_date[ (13) ])
{
 uint8_t* cur_pos = formatted_date;
 int year = 0;

 if (timestamp ==  ((void *)0)  || formatted_date ==  ((void *)0) )
 return  2 ;

 year = timestamp->tm_year + 1900;

 if (year >= 1950 && year <= 1999)
 year = year - 1900;
 else if (year >= 2000 && year <= 2049)
 year = year - 2000;
 else
 return  5 ;
 cur_pos = uint_to_str(year, 2, cur_pos);

 if (timestamp->tm_mon < 0 || timestamp->tm_mon > 11)
 return  5 ;
 cur_pos = uint_to_str(timestamp->tm_mon + 1, 2, cur_pos);

 if (timestamp->tm_mday < 1 || timestamp->tm_mday > 31)
 return  5 ;
 cur_pos = uint_to_str(timestamp->tm_mday, 2, cur_pos);

 if (timestamp->tm_hour < 0 || timestamp->tm_hour > 23)
 return  5 ;
 cur_pos = uint_to_str(timestamp->tm_hour, 2, cur_pos);

 if (timestamp->tm_min < 0 || timestamp->tm_min > 59)
 return  5 ;
 cur_pos = uint_to_str(timestamp->tm_min, 2, cur_pos);

 if (timestamp->tm_sec < 0 || timestamp->tm_sec > 59)
 return  5 ;
 cur_pos = uint_to_str(timestamp->tm_sec, 2, cur_pos);

 *(cur_pos++) = 'Z';

 return  0 ;
}

int atcacert_date_dec_rfc5280_utc( uint8_t formatted_date[ (13) ],
 atcacert_tm_utc_t* timestamp)
{
 uint8_t* cur_pos = formatted_date;
 uint8_t* new_pos =  ((void *)0) ;

 if (formatted_date ==  ((void *)0)  || timestamp ==  ((void *)0) )
 return  2 ;

 memset(timestamp, 0, sizeof(*timestamp));

 new_pos = str_to_int(cur_pos, 2, &timestamp->tm_year);
 if (new_pos == cur_pos)
 return  4 ;
 cur_pos = new_pos;
 if (timestamp->tm_year < 50)
 timestamp->tm_year += 2000;
 else
 timestamp->tm_year += 1900;
 timestamp->tm_year -= 1900;

 new_pos = str_to_int(cur_pos, 2, &timestamp->tm_mon);
 if (new_pos == cur_pos)
 return  4 ;
 cur_pos = new_pos;
 timestamp->tm_mon -= 1;

 new_pos = str_to_int(cur_pos, 2, &timestamp->tm_mday);
 if (new_pos == cur_pos)
 return  4 ;
 cur_pos = new_pos;

 new_pos = str_to_int(cur_pos, 2, &timestamp->tm_hour);
 if (new_pos == cur_pos)
 return  4 ;
 cur_pos = new_pos;

 new_pos = str_to_int(cur_pos, 2, &timestamp->tm_min);
 if (new_pos == cur_pos)
 return  4 ;
 cur_pos = new_pos;

 new_pos = str_to_int(cur_pos, 2, &timestamp->tm_sec);
 if (new_pos == cur_pos)
 return  4 ;
 cur_pos = new_pos;

 if (*(cur_pos++) != 'Z')
 return  4 ;

 return  0 ;
}

int atcacert_date_enc_rfc5280_gen( atcacert_tm_utc_t* timestamp,
 uint8_t formatted_date[ (15) ])
{
 uint8_t* cur_pos = formatted_date;
 int year = 0;

 if (timestamp ==  ((void *)0)  || formatted_date ==  ((void *)0) )
 return  2 ;

 year = timestamp->tm_year + 1900;

 if (year < 0 || year > 9999)
 return  5 ;
 cur_pos = uint_to_str(year, 4, cur_pos);

 if (timestamp->tm_mon < 0 || timestamp->tm_mon > 11)
 return  5 ;
 cur_pos = uint_to_str(timestamp->tm_mon + 1, 2, cur_pos);

 if (timestamp->tm_mday < 1 || timestamp->tm_mday > 31)
 return  5 ;
 cur_pos = uint_to_str(timestamp->tm_mday, 2, cur_pos);

 if (timestamp->tm_hour < 0 || timestamp->tm_hour > 23)
 return  5 ;
 cur_pos = uint_to_str(timestamp->tm_hour, 2, cur_pos);

 if (timestamp->tm_min < 0 || timestamp->tm_min > 59)
 return  5 ;
 cur_pos = uint_to_str(timestamp->tm_min, 2, cur_pos);

 if (timestamp->tm_sec < 0 || timestamp->tm_sec > 59)
 return  5 ;
 cur_pos = uint_to_str(timestamp->tm_sec, 2, cur_pos);

 *(cur_pos++) = 'Z';

 return  0 ;
}

int atcacert_date_dec_rfc5280_gen( uint8_t formatted_date[ (15) ],
 atcacert_tm_utc_t* timestamp)
{
 uint8_t* cur_pos = formatted_date;
 uint8_t* new_pos =  ((void *)0) ;

 if (formatted_date ==  ((void *)0)  || timestamp ==  ((void *)0) )
 return  2 ;

 memset(timestamp, 0, sizeof(*timestamp));

 new_pos = str_to_int(cur_pos, 4, &timestamp->tm_year);
 if (new_pos == cur_pos)
 return  4 ;
 cur_pos = new_pos;
 timestamp->tm_year -= 1900;

 new_pos = str_to_int(cur_pos, 2, &timestamp->tm_mon);
 if (new_pos == cur_pos)
 return  4 ;
 cur_pos = new_pos;
 timestamp->tm_mon -= 1;

 new_pos = str_to_int(cur_pos, 2, &timestamp->tm_mday);
 if (new_pos == cur_pos)
 return  4 ;
 cur_pos = new_pos;

 new_pos = str_to_int(cur_pos, 2, &timestamp->tm_hour);
 if (new_pos == cur_pos)
 return  4 ;
 cur_pos = new_pos;

 new_pos = str_to_int(cur_pos, 2, &timestamp->tm_min);
 if (new_pos == cur_pos)
 return  4 ;
 cur_pos = new_pos;

 new_pos = str_to_int(cur_pos, 2, &timestamp->tm_sec);
 if (new_pos == cur_pos)
 return  4 ;
 cur_pos = new_pos;

 if (*(cur_pos++) != 'Z')
 return  4 ;

 return  0 ;
}

static int is_leap_year(int year)
{
 return (year % 400 == 0) || ((year % 4 == 0) && (year % 100 != 0));
}

static uint32_t get_year_secs(int year)
{
 if (is_leap_year(year))
 return (31 + 29 + 31 + 30 + 31 + 30 + 31 + 31 + 30 + 31 + 30 + 31) * 86400;
 else
 return (31 + 28 + 31 + 30 + 31 + 30 + 31 + 31 + 30 + 31 + 30 + 31) * 86400;
}

static uint32_t get_month_secs(int year, int mon)
{
 static uint32_t month_secs[] = { 2678400, 2419200, 2678400, 2592000, 2678400, 2592000, 2678400, 2678400, 2592000, 2678400, 2592000, 2678400 };

 if (mon == 1 && is_leap_year(year))
 return 2505600;
 else if (mon < 12)
 return month_secs[mon];
 else
 return 0;
}

static atcacert_tm_utc_t *atcacert_gmtime32( uint32_t *posix_time, atcacert_tm_utc_t *result)
{
 uint32_t secs_remaining = *posix_time;
 uint32_t secs = 0;

 result->tm_year = 1970;
 result->tm_mon = 0;
 result->tm_mday = 1;
 result->tm_hour = 0;
 result->tm_min = 0;
 result->tm_sec = 0;

 secs = get_year_secs(result->tm_year);
 while (secs_remaining >= secs) {
 result->tm_year++;
 secs_remaining -= secs;
 secs = get_year_secs(result->tm_year);
 }

 secs = get_month_secs(result->tm_year, result->tm_mon);
 while (secs_remaining >= secs) {
 result->tm_mon++;
 secs_remaining -= secs;
 secs = get_month_secs(result->tm_year, result->tm_mon);
 }

 result->tm_year -= 1900;

 result->tm_mday += secs_remaining / 86400;
 secs_remaining %= 86400;

 result->tm_hour += secs_remaining / 3600;
 secs_remaining %= 3600;

 result->tm_min += secs_remaining / 60;
 secs_remaining %= 60;

 result->tm_sec += secs_remaining;

 return result;
}

static uint32_t atcacert_mkgmtime32( atcacert_tm_utc_t *timeptr)
{
 uint32_t posix_time = 0;
 int cur_value = 0;
 int year = timeptr->tm_year + 1900;

 cur_value = year - 1;
 while (cur_value >= 1970)
 posix_time += get_year_secs(cur_value--);

 cur_value = timeptr->tm_mon - 1;
 while (cur_value >= 0)
 posix_time += get_month_secs(year, cur_value--);

 posix_time += (uint32_t)(timeptr->tm_mday - 1) * 86400;
 posix_time += (uint32_t)timeptr->tm_hour * 3600;
 posix_time += (uint32_t)timeptr->tm_min * 60;
 posix_time += (uint32_t)timeptr->tm_sec;

 return posix_time;
}

static int atcacert_date_enc_posix_uint32( atcacert_tm_utc_t* timestamp, uint32_t* posix_uint32)
{


 int year = 0;

 if (timestamp ==  ((void *)0)  || posix_uint32 ==  ((void *)0) )
 return  2 ;

 year = timestamp->tm_year + 1900;

 if (year > 2106 || year < 1970)
 return  5 ;
 if (timestamp->tm_mon < 0 || timestamp->tm_mon > 11)
 return  5 ;
 if (timestamp->tm_mday < 1 || timestamp->tm_mday > 31)
 return  5 ;
 if (timestamp->tm_hour < 0 || timestamp->tm_hour > 23)
 return  5 ;
 if (timestamp->tm_min < 0 || timestamp->tm_min > 59)
 return  5 ;
 if (timestamp->tm_sec < 0 || timestamp->tm_sec > 59)
 return  5 ;

 if (year == 2106) {
 if (timestamp->tm_mon > 1)
 return  5 ;
 if (timestamp->tm_mon == 1) {
 if (timestamp->tm_mday > 7)
 return  5 ;
 if (timestamp->tm_mday == 7) {
 if (timestamp->tm_hour > 6)
 return  5 ;
 if (timestamp->tm_hour == 6) {
 if (timestamp->tm_min > 28)
 return  5 ;
 if (timestamp->tm_min == 28)
 if (timestamp->tm_sec > 14)
 return  5 ;
 }
 }
 }
 }
#line 690 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atcacert/atcacert_date.c"
 *posix_uint32 = atcacert_mkgmtime32(timestamp);

 return  0 ;
}

int atcacert_date_enc_posix_uint32_be( atcacert_tm_utc_t* timestamp,
 uint8_t formatted_date[ (4) ])
{
 uint32_t posix_uint32 = 0;
 int ret = 0;

 if (timestamp ==  ((void *)0)  || formatted_date ==  ((void *)0) )
 return  2 ;

 ret = atcacert_date_enc_posix_uint32(timestamp, &posix_uint32);
 if (ret !=  0 )
 return ret;

 formatted_date[0] = (uint8_t)((posix_uint32 >> 24) & 0xFF);
 formatted_date[1] = (uint8_t)((posix_uint32 >> 16) & 0xFF);
 formatted_date[2] = (uint8_t)((posix_uint32 >> 8) & 0xFF);
 formatted_date[3] = (uint8_t)((posix_uint32 >> 0) & 0xFF);

 return  0 ;
}

static int atcacert_date_dec_posix_uint32( uint32_t posix_uint32,
 atcacert_tm_utc_t* timestamp)
{
#line 741 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atcacert/atcacert_date.c"
 atcacert_gmtime32(&posix_uint32, timestamp);

 return  0 ;
}

int atcacert_date_dec_posix_uint32_be( uint8_t formatted_date[ (4) ],
 atcacert_tm_utc_t* timestamp)
{
 uint32_t posix_uint32 = 0;

 if (formatted_date ==  ((void *)0)  || timestamp ==  ((void *)0) )
 return  2 ;

 posix_uint32 =
 ((uint32_t)formatted_date[0] << 24) |
 ((uint32_t)formatted_date[1] << 16) |
 ((uint32_t)formatted_date[2] << 8) |
 ((uint32_t)formatted_date[3]);

 return atcacert_date_dec_posix_uint32(posix_uint32, timestamp);
}

int atcacert_date_enc_posix_uint32_le( atcacert_tm_utc_t* timestamp,
 uint8_t formatted_date[ (4) ])
{
 uint32_t posix_uint32 = 0;
 int ret = 0;

 if (timestamp ==  ((void *)0)  || formatted_date ==  ((void *)0) )
 return  2 ;

 ret = atcacert_date_enc_posix_uint32(timestamp, &posix_uint32);
 if (ret !=  0 )
 return ret;

 formatted_date[0] = (uint8_t)((posix_uint32 >> 0) & 0xFF);
 formatted_date[1] = (uint8_t)((posix_uint32 >> 8) & 0xFF);
 formatted_date[2] = (uint8_t)((posix_uint32 >> 16) & 0xFF);
 formatted_date[3] = (uint8_t)((posix_uint32 >> 24) & 0xFF);

 return  0 ;
}

int atcacert_date_dec_posix_uint32_le( uint8_t formatted_date[ (4) ],
 atcacert_tm_utc_t* timestamp)
{
 uint32_t posix_uint32 = 0;

 if (formatted_date ==  ((void *)0)  || timestamp ==  ((void *)0) )
 return  2 ;

 posix_uint32 =
 ((uint32_t)formatted_date[3] << 24) |
 ((uint32_t)formatted_date[2] << 16) |
 ((uint32_t)formatted_date[1] << 8) |
 ((uint32_t)formatted_date[0]);

 return atcacert_date_dec_posix_uint32(posix_uint32, timestamp);
}

int atcacert_date_enc_compcert( atcacert_tm_utc_t* issue_date,
 uint8_t expire_years,
 uint8_t enc_dates[3])
{
#line 818 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atcacert/atcacert_date.c"
 if (issue_date ==  ((void *)0)  || enc_dates ==  ((void *)0) )
 return  2 ;

 if ((issue_date->tm_year + 1900) < 2000 || (issue_date->tm_year + 1900) > 2031)
 return  5 ;
 if (issue_date->tm_mon < 0 || issue_date->tm_mon > 11)
 return  5 ;
 if (issue_date->tm_mday < 1 || issue_date->tm_mday > 31)
 return  5 ;
 if (issue_date->tm_hour < 0 || issue_date->tm_hour > 23)
 return  5 ;
 if (expire_years > 31)
 return  5 ;

 memset(enc_dates, 0, 3);

 enc_dates[0] = (enc_dates[0] & 0x07) | (((issue_date->tm_year + 1900 - 2000) & 0x1F) << 3);
 enc_dates[0] = (enc_dates[0] & 0xF8) | (((issue_date->tm_mon + 1) & 0x0F) >> 1);
 enc_dates[1] = (enc_dates[1] & 0x7F) | (((issue_date->tm_mon + 1) & 0x0F) << 7);
 enc_dates[1] = (enc_dates[1] & 0x83) | ((issue_date->tm_mday & 0x1F) << 2);
 enc_dates[1] = (enc_dates[1] & 0xFC) | ((issue_date->tm_hour & 0x1F) >> 3);
 enc_dates[2] = (enc_dates[2] & 0x1F) | ((issue_date->tm_hour & 0x1F) << 5);
 enc_dates[2] = (enc_dates[2] & 0xE0) | (expire_years & 0x1F);

 return  0 ;
}

int atcacert_date_dec_compcert( uint8_t enc_dates[3],
 atcacert_date_format_t expire_date_format,
 atcacert_tm_utc_t* issue_date,
 atcacert_tm_utc_t* expire_date)
{
 int ret =  0 ;
 uint8_t expire_years = 0;
#line 867 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/atcacert/atcacert_date.c"
 if (enc_dates ==  ((void *)0)  || issue_date ==  ((void *)0)  || expire_date ==  ((void *)0)  || expire_date_format < 0 || expire_date_format >= sizeof(ATCACERT_DATE_FORMAT_SIZES) / sizeof(ATCACERT_DATE_FORMAT_SIZES[0]))
 return  2 ;

 memset(issue_date, 0, sizeof(*issue_date));
 memset(expire_date, 0, sizeof(*expire_date));

 issue_date->tm_year = (enc_dates[0] >> 3) + 2000 - 1900;
 issue_date->tm_mon = (((enc_dates[0] & 0x07) << 1) | ((enc_dates[1] & 0x80) >> 7)) - 1;
 issue_date->tm_mday = ((enc_dates[1] & 0x7C) >> 2);
 issue_date->tm_hour = ((enc_dates[1] & 0x03) << 3) | ((enc_dates[2] & 0xE0) >> 5);

 expire_years = (enc_dates[2] & 0x1F);

 if (expire_years != 0) {
 expire_date->tm_year = issue_date->tm_year + expire_years;
 expire_date->tm_mon = issue_date->tm_mon;
 expire_date->tm_mday = issue_date->tm_mday;
 expire_date->tm_hour = issue_date->tm_hour;
 }else {

 ret = atcacert_date_get_max_date(expire_date_format, expire_date);
 if (ret !=  0 )
 return ret;
 }

 return  0 ;
}
