_atcacert_verify_cert_hw:
;atcacert_host_hw.c,49 :: 		uint8_t ca_public_key[64])
; ca_public_key start address is: 12 (R3)
; cert_size start address is: 8 (R2)
; cert start address is: 4 (R1)
; cert_def start address is: 0 (R0)
SUB	SP, SP, #120
STR	LR, [SP, #0]
STR	R3, [SP, #4]
MOV	R5, R2
MOV	R2, R0
MOV	R3, R1
LDR	R1, [SP, #4]
; ca_public_key end address is: 12 (R3)
; cert_size end address is: 8 (R2)
; cert end address is: 4 (R1)
; cert_def end address is: 0 (R0)
; cert_def start address is: 8 (R2)
; cert start address is: 12 (R3)
; cert_size start address is: 20 (R5)
; ca_public_key start address is: 4 (R1)
;atcacert_host_hw.c,51 :: 		int ret = 0;
;atcacert_host_hw.c,54 :: 		bool is_verified = false;
MOVS	R4, #0
STRB	R4, [SP, #116]
;atcacert_host_hw.c,56 :: 		if (cert_def == NULL || ca_public_key == NULL || cert == NULL)
CMP	R2, #0
IT	EQ
BEQ	L__atcacert_verify_cert_hw18
CMP	R1, #0
IT	EQ
BEQ	L__atcacert_verify_cert_hw17
CMP	R3, #0
IT	EQ
BEQ	L__atcacert_verify_cert_hw16
IT	AL
BAL	L_atcacert_verify_cert_hw2
; cert_def end address is: 8 (R2)
; cert end address is: 12 (R3)
; cert_size end address is: 20 (R5)
; ca_public_key end address is: 4 (R1)
L__atcacert_verify_cert_hw18:
L__atcacert_verify_cert_hw17:
L__atcacert_verify_cert_hw16:
;atcacert_host_hw.c,57 :: 		return ATCACERT_E_BAD_PARAMS;
MOVS	R0, #2
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_verify_cert_hw
L_atcacert_verify_cert_hw2:
;atcacert_host_hw.c,59 :: 		ret = atcacert_get_tbs_digest(cert_def, cert, cert_size, tbs_digest);
; ca_public_key start address is: 4 (R1)
; cert_size start address is: 20 (R5)
; cert start address is: 12 (R3)
; cert_def start address is: 8 (R2)
ADD	R4, SP, #20
STR	R1, [SP, #4]
STR	R5, [SP, #8]
STR	R3, [SP, #12]
STR	R2, [SP, #16]
MOV	R1, R3
MOV	R3, R4
MOV	R0, R2
MOV	R2, R5
BL	_atcacert_get_tbs_digest+0
LDR	R2, [SP, #16]
LDR	R3, [SP, #12]
LDR	R5, [SP, #8]
LDR	R1, [SP, #4]
; ret start address is: 16 (R4)
SXTH	R4, R0
;atcacert_host_hw.c,60 :: 		if (ret != ATCACERT_E_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_atcacert_verify_cert_hw3
; cert_def end address is: 8 (R2)
; cert end address is: 12 (R3)
; cert_size end address is: 20 (R5)
; ca_public_key end address is: 4 (R1)
;atcacert_host_hw.c,61 :: 		return ret;
SXTH	R0, R4
; ret end address is: 16 (R4)
IT	AL
BAL	L_end_atcacert_verify_cert_hw
L_atcacert_verify_cert_hw3:
;atcacert_host_hw.c,63 :: 		ret = atcacert_get_signature(cert_def, cert, cert_size, signature);
; ca_public_key start address is: 4 (R1)
; cert_size start address is: 20 (R5)
; cert start address is: 12 (R3)
; cert_def start address is: 8 (R2)
ADD	R4, SP, #52
STR	R1, [SP, #4]
MOV	R1, R3
MOV	R3, R4
; cert_size end address is: 20 (R5)
MOV	R0, R2
; cert end address is: 12 (R3)
MOV	R2, R5
; cert_def end address is: 8 (R2)
BL	_atcacert_get_signature+0
LDR	R1, [SP, #4]
; ret start address is: 8 (R2)
SXTH	R2, R0
;atcacert_host_hw.c,64 :: 		if (ret != ATCACERT_E_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_atcacert_verify_cert_hw4
; ca_public_key end address is: 4 (R1)
;atcacert_host_hw.c,65 :: 		return ret;
SXTH	R0, R2
; ret end address is: 8 (R2)
IT	AL
BAL	L_end_atcacert_verify_cert_hw
L_atcacert_verify_cert_hw4:
;atcacert_host_hw.c,67 :: 		ret = atcab_verify_extern(tbs_digest, signature, ca_public_key, &is_verified);
; ca_public_key start address is: 4 (R1)
ADD	R6, SP, #116
ADD	R5, SP, #52
ADD	R4, SP, #20
MOV	R3, R6
MOV	R2, R1
; ca_public_key end address is: 4 (R1)
MOV	R1, R5
MOV	R0, R4
BL	_atcab_verify_extern+0
; ret start address is: 0 (R0)
;atcacert_host_hw.c,68 :: 		if (ret != ATCA_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_atcacert_verify_cert_hw5
;atcacert_host_hw.c,69 :: 		return ret;
; ret end address is: 0 (R0)
IT	AL
BAL	L_end_atcacert_verify_cert_hw
L_atcacert_verify_cert_hw5:
;atcacert_host_hw.c,71 :: 		return is_verified ? ATCACERT_E_SUCCESS : ATCACERT_E_VERIFY_FAILED;
LDRB	R4, [SP, #116]
CMP	R4, #0
IT	EQ
BEQ	L_atcacert_verify_cert_hw6
; ?FLOC___atcacert_verify_cert_hw?T69 start address is: 0 (R0)
MOVS	R0, #0
SXTB	R0, R0
; ?FLOC___atcacert_verify_cert_hw?T69 end address is: 0 (R0)
IT	AL
BAL	L_atcacert_verify_cert_hw7
L_atcacert_verify_cert_hw6:
; ?FLOC___atcacert_verify_cert_hw?T69 start address is: 0 (R0)
MOVS	R0, #12
SXTB	R0, R0
; ?FLOC___atcacert_verify_cert_hw?T69 end address is: 0 (R0)
L_atcacert_verify_cert_hw7:
; ?FLOC___atcacert_verify_cert_hw?T69 start address is: 0 (R0)
; ?FLOC___atcacert_verify_cert_hw?T69 end address is: 0 (R0)
;atcacert_host_hw.c,72 :: 		}
L_end_atcacert_verify_cert_hw:
LDR	LR, [SP, #0]
ADD	SP, SP, #120
BX	LR
; end of _atcacert_verify_cert_hw
_atcacert_gen_challenge_hw:
;atcacert_host_hw.c,74 :: 		int atcacert_gen_challenge_hw( uint8_t challenge[32] )
; challenge start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; challenge end address is: 0 (R0)
; challenge start address is: 0 (R0)
;atcacert_host_hw.c,76 :: 		if (challenge == NULL)
CMP	R0, #0
IT	NE
BNE	L_atcacert_gen_challenge_hw8
; challenge end address is: 0 (R0)
;atcacert_host_hw.c,77 :: 		return ATCACERT_E_BAD_PARAMS;
MOVS	R0, #2
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_gen_challenge_hw
L_atcacert_gen_challenge_hw8:
;atcacert_host_hw.c,79 :: 		return atcab_random(challenge);
; challenge start address is: 0 (R0)
; challenge end address is: 0 (R0)
BL	_atcab_random+0
;atcacert_host_hw.c,80 :: 		}
L_end_atcacert_gen_challenge_hw:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atcacert_gen_challenge_hw
_atcacert_verify_response_hw:
;atcacert_host_hw.c,84 :: 		uint8_t response[64])
; response start address is: 8 (R2)
; challenge start address is: 4 (R1)
; device_public_key start address is: 0 (R0)
SUB	SP, SP, #12
STR	LR, [SP, #0]
; response end address is: 8 (R2)
; challenge end address is: 4 (R1)
; device_public_key end address is: 0 (R0)
; device_public_key start address is: 0 (R0)
; challenge start address is: 4 (R1)
; response start address is: 8 (R2)
;atcacert_host_hw.c,86 :: 		int ret = 0;
;atcacert_host_hw.c,87 :: 		bool is_verified = false;
MOVS	R3, #0
STRB	R3, [SP, #8]
;atcacert_host_hw.c,89 :: 		if (device_public_key == NULL || challenge == NULL || response == NULL)
CMP	R0, #0
IT	EQ
BEQ	L__atcacert_verify_response_hw22
CMP	R1, #0
IT	EQ
BEQ	L__atcacert_verify_response_hw21
CMP	R2, #0
IT	EQ
BEQ	L__atcacert_verify_response_hw20
IT	AL
BAL	L_atcacert_verify_response_hw11
; device_public_key end address is: 0 (R0)
; challenge end address is: 4 (R1)
; response end address is: 8 (R2)
L__atcacert_verify_response_hw22:
L__atcacert_verify_response_hw21:
L__atcacert_verify_response_hw20:
;atcacert_host_hw.c,90 :: 		return ATCACERT_E_BAD_PARAMS;
MOVS	R0, #2
SXTH	R0, R0
IT	AL
BAL	L_end_atcacert_verify_response_hw
L_atcacert_verify_response_hw11:
;atcacert_host_hw.c,92 :: 		ret = atcab_verify_extern(challenge, response, device_public_key, &is_verified);
; response start address is: 8 (R2)
; challenge start address is: 4 (R1)
; device_public_key start address is: 0 (R0)
ADD	R3, SP, #8
STR	R1, [SP, #4]
MOV	R1, R2
; device_public_key end address is: 0 (R0)
MOV	R2, R0
; response end address is: 8 (R2)
LDR	R0, [SP, #4]
; challenge end address is: 4 (R1)
BL	_atcab_verify_extern+0
; ret start address is: 0 (R0)
;atcacert_host_hw.c,93 :: 		if (ret != ATCA_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_atcacert_verify_response_hw12
;atcacert_host_hw.c,94 :: 		return ret;
; ret end address is: 0 (R0)
IT	AL
BAL	L_end_atcacert_verify_response_hw
L_atcacert_verify_response_hw12:
;atcacert_host_hw.c,96 :: 		return is_verified ? ATCACERT_E_SUCCESS : ATCACERT_E_VERIFY_FAILED;
LDRB	R3, [SP, #8]
CMP	R3, #0
IT	EQ
BEQ	L_atcacert_verify_response_hw13
; ?FLOC___atcacert_verify_response_hw?T85 start address is: 0 (R0)
MOVS	R0, #0
SXTB	R0, R0
; ?FLOC___atcacert_verify_response_hw?T85 end address is: 0 (R0)
IT	AL
BAL	L_atcacert_verify_response_hw14
L_atcacert_verify_response_hw13:
; ?FLOC___atcacert_verify_response_hw?T85 start address is: 0 (R0)
MOVS	R0, #12
SXTB	R0, R0
; ?FLOC___atcacert_verify_response_hw?T85 end address is: 0 (R0)
L_atcacert_verify_response_hw14:
; ?FLOC___atcacert_verify_response_hw?T85 start address is: 0 (R0)
; ?FLOC___atcacert_verify_response_hw?T85 end address is: 0 (R0)
;atcacert_host_hw.c,97 :: 		}
L_end_atcacert_verify_response_hw:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _atcacert_verify_response_hw
