_atcac_sw_sha1_init:
;atca_crypto_sw_sha1.c,46 :: 		int atcac_sw_sha1_init(atcac_sha1_ctx* ctx)
; ctx start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; ctx end address is: 0 (R0)
; ctx start address is: 0 (R0)
;atca_crypto_sw_sha1.c,49 :: 		return ATCA_ASSERT_FAILURE; // atcac_sha1_ctx isn't large enough for this implementation
L_atcac_sw_sha1_init0:
;atca_crypto_sw_sha1.c,50 :: 		CL_hashInit((CL_HashContext*)ctx);
; ctx end address is: 0 (R0)
BL	_CL_hashInit+0
;atca_crypto_sw_sha1.c,52 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
SXTH	R0, R0
;atca_crypto_sw_sha1.c,53 :: 		}
L_end_atcac_sw_sha1_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atcac_sw_sha1_init
_atcac_sw_sha1_update:
;atca_crypto_sw_sha1.c,55 :: 		int atcac_sw_sha1_update(atcac_sha1_ctx* ctx,  uint8_t* data, size_t data_size)
; data_size start address is: 8 (R2)
; _data start address is: 4 (R1)
; ctx start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; data_size end address is: 8 (R2)
; _data end address is: 4 (R1)
; ctx end address is: 0 (R0)
; ctx start address is: 0 (R0)
; _data start address is: 4 (R1)
; data_size start address is: 8 (R2)
;atca_crypto_sw_sha1.c,57 :: 		CL_hashUpdate((CL_HashContext*)ctx, data, (int)data_size);
SXTH	R2, R2
; data_size end address is: 8 (R2)
; _data end address is: 4 (R1)
; ctx end address is: 0 (R0)
BL	_CL_hashUpdate+0
;atca_crypto_sw_sha1.c,59 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
SXTH	R0, R0
;atca_crypto_sw_sha1.c,60 :: 		}
L_end_atcac_sw_sha1_update:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atcac_sw_sha1_update
_atcac_sw_sha1_finish:
;atca_crypto_sw_sha1.c,62 :: 		int atcac_sw_sha1_finish(atcac_sha1_ctx* ctx, uint8_t digest[ATCA_SHA1_DIGEST_SIZE])
; digest start address is: 4 (R1)
; ctx start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; digest end address is: 4 (R1)
; ctx end address is: 0 (R0)
; ctx start address is: 0 (R0)
; digest start address is: 4 (R1)
;atca_crypto_sw_sha1.c,64 :: 		CL_hashFinal((CL_HashContext*)ctx, digest);
; digest end address is: 4 (R1)
; ctx end address is: 0 (R0)
BL	_CL_hashFinal+0
;atca_crypto_sw_sha1.c,66 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
SXTH	R0, R0
;atca_crypto_sw_sha1.c,67 :: 		}
L_end_atcac_sw_sha1_finish:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atcac_sw_sha1_finish
_atcac_sw_sha1:
;atca_crypto_sw_sha1.c,69 :: 		int atcac_sw_sha1( uint8_t* data, size_t data_size, uint8_t digest[ATCA_SHA1_DIGEST_SIZE])
SUB	SP, SP, #144
STR	LR, [SP, #0]
STR	R0, [SP, #132]
STR	R1, [SP, #136]
STR	R2, [SP, #140]
;atca_crypto_sw_sha1.c,74 :: 		ret = atcac_sw_sha1_init(&ctx);
ADD	R3, SP, #4
MOV	R0, R3
BL	_atcac_sw_sha1_init+0
; ret start address is: 4 (R1)
SXTH	R1, R0
;atca_crypto_sw_sha1.c,75 :: 		if (ret != ATCA_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_atcac_sw_sha11
;atca_crypto_sw_sha1.c,76 :: 		return ret;
SXTH	R0, R1
; ret end address is: 4 (R1)
IT	AL
BAL	L_end_atcac_sw_sha1
L_atcac_sw_sha11:
;atca_crypto_sw_sha1.c,78 :: 		ret = atcac_sw_sha1_update(&ctx, data, data_size);
ADD	R3, SP, #4
LDR	R2, [SP, #136]
LDR	R1, [SP, #132]
MOV	R0, R3
BL	_atcac_sw_sha1_update+0
; ret start address is: 4 (R1)
SXTH	R1, R0
;atca_crypto_sw_sha1.c,79 :: 		if (ret != ATCA_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_atcac_sw_sha12
;atca_crypto_sw_sha1.c,80 :: 		return ret;
SXTH	R0, R1
; ret end address is: 4 (R1)
IT	AL
BAL	L_end_atcac_sw_sha1
L_atcac_sw_sha12:
;atca_crypto_sw_sha1.c,82 :: 		ret = atcac_sw_sha1_finish(&ctx, digest);
ADD	R3, SP, #4
LDR	R1, [SP, #140]
MOV	R0, R3
BL	_atcac_sw_sha1_finish+0
; ret start address is: 4 (R1)
SXTH	R1, R0
;atca_crypto_sw_sha1.c,83 :: 		if (ret != ATCA_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_atcac_sw_sha13
;atca_crypto_sw_sha1.c,84 :: 		return ret;
SXTH	R0, R1
; ret end address is: 4 (R1)
IT	AL
BAL	L_end_atcac_sw_sha1
L_atcac_sw_sha13:
;atca_crypto_sw_sha1.c,86 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
SXTH	R0, R0
;atca_crypto_sw_sha1.c,87 :: 		}
L_end_atcac_sw_sha1:
LDR	LR, [SP, #0]
ADD	SP, SP, #144
BX	LR
; end of _atcac_sw_sha1
