#line 1 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/crypto/atca_crypto_sw_sha1.c"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/crypto/atca_crypto_sw_sha1.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/crypto/atca_crypto_sw.h"
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_status.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdbool.h"



 typedef char _Bool;
#line 55 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/atca_status.h"
typedef enum
{
 ATCA_SUCCESS = 0x00,
 ATCA_CONFIG_ZONE_LOCKED = 0x01,
 ATCA_DATA_ZONE_LOCKED = 0x02,
 ATCA_WAKE_FAILED = 0xD0,
 ATCA_CHECKMAC_VERIFY_FAILED = 0xD1,
 ATCA_PARSE_ERROR = 0xD2,
 ATCA_STATUS_CRC = 0xD4,
 ATCA_STATUS_UNKNOWN = 0xD5,
 ATCA_STATUS_ECC = 0xD6,
 ATCA_STATUS_SELFTEST_ERROR = 0xD7,
 ATCA_FUNC_FAIL = 0xE0,
 ATCA_GEN_FAIL = 0xE1,
 ATCA_BAD_PARAM = 0xE2,
 ATCA_INVALID_ID = 0xE3,
 ATCA_INVALID_SIZE = 0xE4,
 ATCA_RX_CRC_ERROR = 0xE5,
 ATCA_RX_FAIL = 0xE6,
 ATCA_RX_NO_RESPONSE = 0xE7,
 ATCA_RESYNC_WITH_WAKEUP = 0xE8,
 ATCA_PARITY_ERROR = 0xE9,
 ATCA_TX_TIMEOUT = 0xEA,
 ATCA_RX_TIMEOUT = 0xEB,
 ATCA_TOO_MANY_COMM_RETRIES = 0xEC,
 ATCA_SMALL_BUFFER = 0xED,
 ATCA_COMM_FAIL = 0xF0,
 ATCA_TIMEOUT = 0xF1,
 ATCA_BAD_OPCODE = 0xF2,
 ATCA_WAKE_SUCCESS = 0xF3,
 ATCA_EXECUTION_ERROR = 0xF4,
 ATCA_UNIMPLEMENTED = 0xF5,
 ATCA_ASSERT_FAILURE = 0xF6,
 ATCA_TX_FAIL = 0xF7,
 ATCA_NOT_LOCKED = 0xF8,
 ATCA_NO_DEVICES = 0xF9,
 ATCA_HEALTH_TEST_ERROR = 0xFA,
 ATCA_ALLOC_FAILURE = 0xFB,
} ATCA_STATUS;
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stddef.h"



typedef long ptrdiff_t;


 typedef unsigned long size_t;

typedef unsigned long wchar_t;
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"
#line 59 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/crypto/atca_crypto_sw_sha1.h"
typedef struct {
 uint32_t pad[32];
} atcac_sha1_ctx;
#line 67 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/crypto/atca_crypto_sw_sha1.h"
int atcac_sw_sha1_init(atcac_sha1_ctx* ctx);
int atcac_sw_sha1_update(atcac_sha1_ctx* ctx, uint8_t*  _data , size_t data_size);
int atcac_sw_sha1_finish(atcac_sha1_ctx * ctx, uint8_t digest[ (20) ]);
int atcac_sw_sha1( uint8_t *  _data , size_t data_size, uint8_t digest[ (20) ]);
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/crypto/hashes/sha1_routines.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdio.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdlib.h"







 typedef struct divstruct {
 int quot;
 int rem;
 } div_t;

 typedef struct ldivstruct {
 long quot;
 long rem;
 } ldiv_t;

 typedef struct uldivstruct {
 unsigned long quot;
 unsigned long rem;
 } uldiv_t;

int abs(int a);
float atof(char * s);
int atoi(char * s);
long atol(char * s);
div_t div(int number, int denom);
ldiv_t ldiv(long number, long denom);
uldiv_t uldiv(unsigned long number, unsigned long denom);
long labs(long x);
long int max(long int a, long int b);
long int min(long int a, long int b);
void srand(unsigned x);
int rand();
int xtoi(char * s);
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stddef.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"
#line 83 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/crypto/hashes/sha1_routines.h"
typedef struct {
  uint32_t  h[20 / 4];
  uint32_t  buf[64 / 4];
  uint32_t  byteCount;
  uint32_t  byteCountHi;
} CL_HashContext;



void shaEngine( uint32_t  *buf,  uint32_t  *h);
void CL_hashInit(CL_HashContext *ctx);
void CL_hashUpdate(CL_HashContext *ctx,  uint8_t  *src, int nbytes);
void CL_hashFinal(CL_HashContext *ctx,  uint8_t  *dest);
void CL_hash( uint8_t  *msg, int msgBytes,  uint8_t  *dest);
#line 46 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/crypto/atca_crypto_sw_sha1.c"
int atcac_sw_sha1_init(atcac_sha1_ctx* ctx)
{
 if (sizeof(CL_HashContext) > sizeof(atcac_sha1_ctx))
 return ATCA_ASSERT_FAILURE;
 CL_hashInit((CL_HashContext*)ctx);

 return ATCA_SUCCESS;
}

int atcac_sw_sha1_update(atcac_sha1_ctx* ctx, uint8_t*  _data , size_t data_size)
{
 CL_hashUpdate((CL_HashContext*)ctx,  _data , (int)data_size);

 return ATCA_SUCCESS;
}

int atcac_sw_sha1_finish(atcac_sha1_ctx* ctx, uint8_t digest[ (20) ])
{
 CL_hashFinal((CL_HashContext*)ctx, digest);

 return ATCA_SUCCESS;
}

int atcac_sw_sha1( uint8_t*  _data , size_t data_size, uint8_t digest[ (20) ])
{
 int ret;
 atcac_sha1_ctx ctx;

 ret = atcac_sw_sha1_init(&ctx);
 if (ret != ATCA_SUCCESS)
 return ret;

 ret = atcac_sw_sha1_update(&ctx,  _data , data_size);
 if (ret != ATCA_SUCCESS)
 return ret;

 ret = atcac_sw_sha1_finish(&ctx, digest);
 if (ret != ATCA_SUCCESS)
 return ret;

 return ATCA_SUCCESS;
}
