_atcac_sw_sha2_256_init:
;atca_crypto_sw_sha2.c,50 :: 		int atcac_sw_sha2_256_init(atcac_sha2_256_ctx* ctx)
; ctx start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; ctx end address is: 0 (R0)
; ctx start address is: 0 (R0)
;atca_crypto_sw_sha2.c,53 :: 		return ATCA_ASSERT_FAILURE; // atcac_sha1_ctx isn't large enough for this implementation
L_atcac_sw_sha2_256_init0:
;atca_crypto_sw_sha2.c,54 :: 		sw_sha256_init((sw_sha256_ctx*)ctx);
; ctx end address is: 0 (R0)
BL	_sw_sha256_init+0
;atca_crypto_sw_sha2.c,56 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
SXTH	R0, R0
;atca_crypto_sw_sha2.c,57 :: 		}
L_end_atcac_sw_sha2_256_init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atcac_sw_sha2_256_init
_atcac_sw_sha2_256_update:
;atca_crypto_sw_sha2.c,67 :: 		int atcac_sw_sha2_256_update(atcac_sha2_256_ctx* ctx,  uint8_t* data, size_t data_size)
; data_size start address is: 8 (R2)
; _data start address is: 4 (R1)
; ctx start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; data_size end address is: 8 (R2)
; _data end address is: 4 (R1)
; ctx end address is: 0 (R0)
; ctx start address is: 0 (R0)
; _data start address is: 4 (R1)
; data_size start address is: 8 (R2)
;atca_crypto_sw_sha2.c,69 :: 		sw_sha256_update((sw_sha256_ctx*)ctx, data, (uint32_t)data_size);
; data_size end address is: 8 (R2)
; _data end address is: 4 (R1)
; ctx end address is: 0 (R0)
BL	_sw_sha256_update+0
;atca_crypto_sw_sha2.c,71 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
SXTH	R0, R0
;atca_crypto_sw_sha2.c,72 :: 		}
L_end_atcac_sw_sha2_256_update:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atcac_sw_sha2_256_update
_atcac_sw_sha2_256_finish:
;atca_crypto_sw_sha2.c,80 :: 		int atcac_sw_sha2_256_finish(atcac_sha2_256_ctx* ctx, uint8_t digest[ATCA_SHA2_256_DIGEST_SIZE])
; digest start address is: 4 (R1)
; ctx start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; digest end address is: 4 (R1)
; ctx end address is: 0 (R0)
; ctx start address is: 0 (R0)
; digest start address is: 4 (R1)
;atca_crypto_sw_sha2.c,82 :: 		sw_sha256_final((sw_sha256_ctx*)ctx, digest);
; digest end address is: 4 (R1)
; ctx end address is: 0 (R0)
BL	_sw_sha256_final+0
;atca_crypto_sw_sha2.c,84 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
SXTH	R0, R0
;atca_crypto_sw_sha2.c,85 :: 		}
L_end_atcac_sw_sha2_256_finish:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atcac_sw_sha2_256_finish
_atcac_sw_sha2_256:
;atca_crypto_sw_sha2.c,95 :: 		int atcac_sw_sha2_256( uint8_t* data, size_t data_size, uint8_t digest[ATCA_SHA2_256_DIGEST_SIZE])
SUB	SP, SP, #208
STR	LR, [SP, #0]
STR	R0, [SP, #196]
STR	R1, [SP, #200]
STR	R2, [SP, #204]
;atca_crypto_sw_sha2.c,100 :: 		ret = atcac_sw_sha2_256_init(&ctx);
ADD	R3, SP, #4
MOV	R0, R3
BL	_atcac_sw_sha2_256_init+0
; ret start address is: 4 (R1)
SXTH	R1, R0
;atca_crypto_sw_sha2.c,101 :: 		if (ret != ATCA_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_atcac_sw_sha2_2561
;atca_crypto_sw_sha2.c,102 :: 		return ret;
SXTH	R0, R1
; ret end address is: 4 (R1)
IT	AL
BAL	L_end_atcac_sw_sha2_256
L_atcac_sw_sha2_2561:
;atca_crypto_sw_sha2.c,104 :: 		ret = atcac_sw_sha2_256_update(&ctx, data, data_size);
ADD	R3, SP, #4
LDR	R2, [SP, #200]
LDR	R1, [SP, #196]
MOV	R0, R3
BL	_atcac_sw_sha2_256_update+0
; ret start address is: 4 (R1)
SXTH	R1, R0
;atca_crypto_sw_sha2.c,105 :: 		if (ret != ATCA_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_atcac_sw_sha2_2562
;atca_crypto_sw_sha2.c,106 :: 		return ret;
SXTH	R0, R1
; ret end address is: 4 (R1)
IT	AL
BAL	L_end_atcac_sw_sha2_256
L_atcac_sw_sha2_2562:
;atca_crypto_sw_sha2.c,108 :: 		ret = atcac_sw_sha2_256_finish(&ctx, digest);
ADD	R3, SP, #4
LDR	R1, [SP, #204]
MOV	R0, R3
BL	_atcac_sw_sha2_256_finish+0
; ret start address is: 4 (R1)
SXTH	R1, R0
;atca_crypto_sw_sha2.c,109 :: 		if (ret != ATCA_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_atcac_sw_sha2_2563
;atca_crypto_sw_sha2.c,110 :: 		return ret;
SXTH	R0, R1
; ret end address is: 4 (R1)
IT	AL
BAL	L_end_atcac_sw_sha2_256
L_atcac_sw_sha2_2563:
;atca_crypto_sw_sha2.c,112 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
SXTH	R0, R0
;atca_crypto_sw_sha2.c,113 :: 		}
L_end_atcac_sw_sha2_256:
LDR	LR, [SP, #0]
ADD	SP, SP, #208
BX	LR
; end of _atcac_sw_sha2_256
