_hal_iface_init:
;atca_hal.c,67 :: 		ATCA_STATUS hal_iface_init( ATCAIfaceCfg *cfg, ATCAHAL_t *hal )
; hal start address is: 4 (R1)
; cfg start address is: 0 (R0)
MOV	R2, R0
; hal end address is: 4 (R1)
; cfg end address is: 0 (R0)
; cfg start address is: 8 (R2)
; hal start address is: 4 (R1)
;atca_hal.c,73 :: 		ATCA_STATUS status = ATCA_COMM_FAIL;
; status start address is: 0 (R0)
MOVS	R0, #240
;atca_hal.c,75 :: 		switch (cfg->iface_type)
MOV	R4, R2
; cfg end address is: 8 (R2)
IT	AL
BAL	L_hal_iface_init0
; hal end address is: 4 (R1)
;atca_hal.c,77 :: 		case ATCA_I2C_IFACE:
L_hal_iface_init2:
;atca_hal.c,91 :: 		break;
; status end address is: 0 (R0)
IT	AL
BAL	L_hal_iface_init1
;atca_hal.c,92 :: 		case ATCA_SWI_IFACE:
L_hal_iface_init3:
;atca_hal.c,94 :: 		hal->halinit = &hal_swi_init;
; hal start address is: 4 (R1)
MOVW	R2, #lo_addr(_hal_swi_init+0)
MOVT	R2, #hi_addr(_hal_swi_init+0)
STR	R2, [R1, #0]
;atca_hal.c,95 :: 		hal->halpostinit = &hal_swi_post_init;
ADDS	R3, R1, #4
MOVW	R2, #lo_addr(_hal_swi_post_init+0)
MOVT	R2, #hi_addr(_hal_swi_post_init+0)
STR	R2, [R3, #0]
;atca_hal.c,96 :: 		hal->halreceive = &hal_swi_receive;
ADDW	R3, R1, #12
MOVW	R2, #lo_addr(_hal_swi_receive+0)
MOVT	R2, #hi_addr(_hal_swi_receive+0)
STR	R2, [R3, #0]
;atca_hal.c,97 :: 		hal->halsend = &hal_swi_send;
ADDW	R3, R1, #8
MOVW	R2, #lo_addr(_hal_swi_send+0)
MOVT	R2, #hi_addr(_hal_swi_send+0)
STR	R2, [R3, #0]
;atca_hal.c,98 :: 		hal->halsleep = &hal_swi_sleep;
ADDW	R3, R1, #24
MOVW	R2, #lo_addr(_hal_swi_sleep+0)
MOVT	R2, #hi_addr(_hal_swi_sleep+0)
STR	R2, [R3, #0]
;atca_hal.c,99 :: 		hal->halwake = &hal_swi_wake;
ADDW	R3, R1, #16
MOVW	R2, #lo_addr(_hal_swi_wake+0)
MOVT	R2, #hi_addr(_hal_swi_wake+0)
STR	R2, [R3, #0]
;atca_hal.c,100 :: 		hal->halidle = &hal_swi_idle;
ADDW	R3, R1, #20
MOVW	R2, #lo_addr(_hal_swi_idle+0)
MOVT	R2, #hi_addr(_hal_swi_idle+0)
STR	R2, [R3, #0]
;atca_hal.c,101 :: 		hal->halrelease = &hal_swi_release;
ADDW	R3, R1, #28
MOVW	R2, #lo_addr(_hal_swi_release+0)
MOVT	R2, #hi_addr(_hal_swi_release+0)
STR	R2, [R3, #0]
;atca_hal.c,102 :: 		hal->hal_data = NULL;
ADDW	R3, R1, #32
; hal end address is: 4 (R1)
MOVS	R2, #0
STR	R2, [R3, #0]
;atca_hal.c,104 :: 		status = ATCA_SUCCESS;
; status start address is: 0 (R0)
MOVS	R0, #0
;atca_hal.c,106 :: 		break;
IT	AL
BAL	L_hal_iface_init1
;atca_hal.c,107 :: 		case ATCA_UART_IFACE:
L_hal_iface_init4:
;atca_hal.c,124 :: 		break;
IT	AL
BAL	L_hal_iface_init1
;atca_hal.c,125 :: 		case ATCA_SPI_IFACE:
L_hal_iface_init5:
;atca_hal.c,129 :: 		break;
IT	AL
BAL	L_hal_iface_init1
;atca_hal.c,130 :: 		case ATCA_HID_IFACE:
L_hal_iface_init6:
;atca_hal.c,144 :: 		break;
IT	AL
BAL	L_hal_iface_init1
;atca_hal.c,145 :: 		}
L_hal_iface_init0:
; hal start address is: 4 (R1)
LDRB	R2, [R4, #0]
CMP	R2, #0
IT	EQ
BEQ	L_hal_iface_init2
LDRB	R2, [R4, #0]
CMP	R2, #1
IT	EQ
BEQ	L_hal_iface_init3
; hal end address is: 4 (R1)
LDRB	R2, [R4, #0]
CMP	R2, #2
IT	EQ
BEQ	L_hal_iface_init4
LDRB	R2, [R4, #0]
CMP	R2, #3
IT	EQ
BEQ	L_hal_iface_init5
LDRB	R2, [R4, #0]
CMP	R2, #4
IT	EQ
BEQ	L_hal_iface_init6
; status end address is: 0 (R0)
L_hal_iface_init1:
;atca_hal.c,146 :: 		return status;
; status start address is: 0 (R0)
; status end address is: 0 (R0)
;atca_hal.c,147 :: 		}
L_end_hal_iface_init:
BX	LR
; end of _hal_iface_init
_hal_iface_release:
;atca_hal.c,154 :: 		ATCA_STATUS hal_iface_release( ATCAIfaceType ifacetype, void *hal_data )
; hal_data start address is: 4 (R1)
; ifacetype start address is: 0 (R0)
SUB	SP, SP, #8
STR	LR, [SP, #0]
; hal_data end address is: 4 (R1)
; ifacetype end address is: 0 (R0)
; ifacetype start address is: 0 (R0)
; hal_data start address is: 4 (R1)
;atca_hal.c,156 :: 		ATCA_STATUS status = ATCA_GEN_FAIL;
MOVS	R2, #225
STRB	R2, [SP, #4]
;atca_hal.c,158 :: 		switch (ifacetype)
IT	AL
BAL	L_hal_iface_release7
; ifacetype end address is: 0 (R0)
; hal_data end address is: 4 (R1)
;atca_hal.c,160 :: 		case ATCA_I2C_IFACE:
L_hal_iface_release9:
;atca_hal.c,164 :: 		break;
IT	AL
BAL	L_hal_iface_release8
;atca_hal.c,165 :: 		case ATCA_SWI_IFACE:
L_hal_iface_release10:
;atca_hal.c,167 :: 		status = hal_swi_release(hal_data);
; hal_data start address is: 4 (R1)
MOV	R0, R1
; hal_data end address is: 4 (R1)
BL	_hal_swi_release+0
STRB	R0, [SP, #4]
;atca_hal.c,169 :: 		break;
IT	AL
BAL	L_hal_iface_release8
;atca_hal.c,170 :: 		case ATCA_UART_IFACE:
L_hal_iface_release11:
;atca_hal.c,177 :: 		break;
IT	AL
BAL	L_hal_iface_release8
;atca_hal.c,178 :: 		case ATCA_SPI_IFACE:
L_hal_iface_release12:
;atca_hal.c,182 :: 		break;
IT	AL
BAL	L_hal_iface_release8
;atca_hal.c,183 :: 		case ATCA_HID_IFACE:
L_hal_iface_release13:
;atca_hal.c,187 :: 		break;
IT	AL
BAL	L_hal_iface_release8
;atca_hal.c,188 :: 		}
L_hal_iface_release7:
; hal_data start address is: 4 (R1)
; ifacetype start address is: 0 (R0)
CMP	R0, #0
IT	EQ
BEQ	L_hal_iface_release9
CMP	R0, #1
IT	EQ
BEQ	L_hal_iface_release10
; hal_data end address is: 4 (R1)
CMP	R0, #2
IT	EQ
BEQ	L_hal_iface_release11
CMP	R0, #3
IT	EQ
BEQ	L_hal_iface_release12
CMP	R0, #4
IT	EQ
BEQ	L_hal_iface_release13
; ifacetype end address is: 0 (R0)
L_hal_iface_release8:
;atca_hal.c,190 :: 		return status;
LDRB	R0, [SP, #4]
;atca_hal.c,191 :: 		}
L_end_hal_iface_release:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _hal_iface_release
_hal_check_wake:
;atca_hal.c,193 :: 		ATCA_STATUS hal_check_wake(uint8_t* response, int response_size)
; response_size start address is: 4 (R1)
; response start address is: 0 (R0)
SUB	SP, SP, #12
STR	LR, [SP, #0]
MOV	R5, R0
; response_size end address is: 4 (R1)
; response end address is: 0 (R0)
; response start address is: 20 (R5)
; response_size start address is: 4 (R1)
;atca_hal.c,195 :: 		uint8_t expected_response[4] = { 0x04, 0x11, 0x33, 0x43 };
ADD	R11, SP, #4
ADD	R10, R11, #8
MOVW	R12, #lo_addr(?ICShal_check_wake_expected_response_L0+0)
MOVT	R12, #hi_addr(?ICShal_check_wake_expected_response_L0+0)
BL	___CC2DW+0
;atca_hal.c,196 :: 		uint8_t selftest_fail_resp[4] = { 0x04, 0x07, 0xC4, 0x40 };
;atca_hal.c,198 :: 		if (response_size != 4)
CMP	R1, #4
IT	EQ
BEQ	L_hal_check_wake14
; response end address is: 20 (R5)
; response_size end address is: 4 (R1)
;atca_hal.c,200 :: 		return ATCA_WAKE_FAILED;
MOVS	R0, #208
IT	AL
BAL	L_end_hal_check_wake
;atca_hal.c,201 :: 		}
L_hal_check_wake14:
;atca_hal.c,202 :: 		if (memcmp(response, expected_response, 4) == 0)
; response start address is: 20 (R5)
ADD	R2, SP, #4
MOV	R1, R2
MOVS	R2, #4
SXTH	R2, R2
MOV	R0, R5
BL	_memcmp+0
CMP	R0, #0
IT	NE
BNE	L_hal_check_wake15
; response end address is: 20 (R5)
;atca_hal.c,204 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
IT	AL
BAL	L_end_hal_check_wake
;atca_hal.c,205 :: 		}
L_hal_check_wake15:
;atca_hal.c,206 :: 		if (memcmp(response, selftest_fail_resp, 4) == 0)
; response start address is: 20 (R5)
ADD	R2, SP, #8
MOV	R1, R2
MOVS	R2, #4
SXTH	R2, R2
MOV	R0, R5
; response end address is: 20 (R5)
BL	_memcmp+0
CMP	R0, #0
IT	NE
BNE	L_hal_check_wake16
;atca_hal.c,208 :: 		return ATCA_STATUS_SELFTEST_ERROR;
MOVS	R0, #215
IT	AL
BAL	L_end_hal_check_wake
;atca_hal.c,209 :: 		}
L_hal_check_wake16:
;atca_hal.c,210 :: 		return ATCA_WAKE_FAILED;
MOVS	R0, #208
;atca_hal.c,211 :: 		}
L_end_hal_check_wake:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _hal_check_wake
_hal_swi_init:
;atca_hal.c,215 :: 		ATCA_STATUS hal_swi_init(void *hal, ATCAIfaceCfg *cfg)
;atca_hal.c,217 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_hal.c,218 :: 		}
L_end_hal_swi_init:
BX	LR
; end of _hal_swi_init
_hal_swi_post_init:
;atca_hal.c,220 :: 		ATCA_STATUS hal_swi_post_init(ATCAIface iface)
;atca_hal.c,222 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_hal.c,223 :: 		}
L_end_hal_swi_post_init:
BX	LR
; end of _hal_swi_post_init
_hal_swi_send:
;atca_hal.c,225 :: 		ATCA_STATUS hal_swi_send(ATCAIface iface, uint8_t *txdata, int txlength)
; iface start address is: 0 (R0)
SUB	SP, SP, #12
STR	LR, [SP, #0]
STR	R1, [SP, #4]
STRH	R2, [SP, #8]
; iface end address is: 0 (R0)
; iface start address is: 0 (R0)
;atca_hal.c,227 :: 		ATCAIfaceCfg *cfg = atgetifacecfg(iface);
; iface end address is: 0 (R0)
BL	_atgetifacecfg+0
;atca_hal.c,230 :: 		txdata++;
LDR	R3, [SP, #4]
ADDS	R3, R3, #1
STR	R3, [SP, #4]
;atca_hal.c,233 :: 		secure7_send_byte(SWI_FLAG_CMD);
MOVS	R0, #119
BL	_secure7_send_byte+0
;atca_hal.c,235 :: 		secure7_send_bytes((uint8_t)txlength, txdata);
LDR	R1, [SP, #4]
LDRB	R0, [SP, #8]
BL	_secure7_send_bytes+0
;atca_hal.c,237 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_hal.c,238 :: 		}
L_end_hal_swi_send:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _hal_swi_send
_hal_swi_receive:
;atca_hal.c,240 :: 		ATCA_STATUS hal_swi_receive( ATCAIface iface, uint8_t *rxdata, uint16_t *rxlength)
; iface start address is: 0 (R0)
SUB	SP, SP, #16
STR	LR, [SP, #0]
STR	R1, [SP, #8]
STR	R2, [SP, #12]
; iface end address is: 0 (R0)
; iface start address is: 0 (R0)
;atca_hal.c,242 :: 		ATCAIfaceCfg *cfg = atgetifacecfg(iface);
; iface end address is: 0 (R0)
BL	_atgetifacecfg+0
;atca_hal.c,243 :: 		ATCA_STATUS status = !ATCA_SUCCESS;
; status start address is: 0 (R0)
MOVS	R0, #1
;atca_hal.c,246 :: 		int retries = 10;
MOVW	R3, #10
STRH	R3, [SP, #6]
;atca_hal.c,247 :: 		uint16_t rxdata_max_size = *rxlength;
LDR	R3, [SP, #12]
LDRH	R3, [R3, #0]
STRH	R3, [SP, #4]
;atca_hal.c,249 :: 		*rxlength = 0;
MOVS	R4, #0
LDR	R3, [SP, #12]
STRH	R4, [R3, #0]
;atca_hal.c,250 :: 		if (rxdata_max_size < 1)
LDRH	R3, [SP, #4]
CMP	R3, #1
IT	CS
BCS	L_hal_swi_receive17
; status end address is: 0 (R0)
;atca_hal.c,252 :: 		return ATCA_SMALL_BUFFER;
MOVS	R0, #237
IT	AL
BAL	L_end_hal_swi_receive
;atca_hal.c,253 :: 		}
L_hal_swi_receive17:
;atca_hal.c,255 :: 		while (retries-- > 0 && status != ATCA_SUCCESS)
; status start address is: 0 (R0)
L_hal_swi_receive18:
; status end address is: 0 (R0)
; status start address is: 0 (R0)
LDRSH	R4, [SP, #6]
LDRSH	R3, [SP, #6]
SUBS	R3, R3, #1
STRH	R3, [SP, #6]
CMP	R4, #0
IT	LE
BLE	L__hal_swi_receive34
CMP	R0, #0
IT	EQ
BEQ	L__hal_swi_receive33
; status end address is: 0 (R0)
L__hal_swi_receive32:
;atca_hal.c,257 :: 		secure7_send_byte(SWI_FLAG_TX);
MOVS	R0, #136
BL	_secure7_send_byte+0
;atca_hal.c,258 :: 		status = secure7_receive_bytes((uint8_t)rxdata_max_size, rxdata);
LDR	R1, [SP, #8]
LDRB	R0, [SP, #4]
BL	_secure7_receive_bytes+0
; status start address is: 0 (R0)
;atca_hal.c,259 :: 		}
IT	AL
BAL	L_hal_swi_receive18
;atca_hal.c,255 :: 		while (retries-- > 0 && status != ATCA_SUCCESS)
L__hal_swi_receive34:
L__hal_swi_receive33:
;atca_hal.c,261 :: 		if (status != ATCA_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_hal_swi_receive22
;atca_hal.c,263 :: 		return status;
; status end address is: 0 (R0)
IT	AL
BAL	L_end_hal_swi_receive
;atca_hal.c,264 :: 		}
L_hal_swi_receive22:
;atca_hal.c,266 :: 		*rxlength = (uint16_t)rxdata[0];
LDR	R3, [SP, #8]
LDRB	R3, [R3, #0]
UXTB	R4, R3
LDR	R3, [SP, #12]
STRH	R4, [R3, #0]
;atca_hal.c,268 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_hal.c,269 :: 		}
L_end_hal_swi_receive:
LDR	LR, [SP, #0]
ADD	SP, SP, #16
BX	LR
; end of _hal_swi_receive
_hal_swi_wake:
;atca_hal.c,271 :: 		ATCA_STATUS hal_swi_wake(ATCAIface iface)
SUB	SP, SP, #16
STR	LR, [SP, #0]
STR	R0, [SP, #12]
;atca_hal.c,273 :: 		ATCAIfaceCfg *cfg = atgetifacecfg(iface);
LDR	R0, [SP, #12]
BL	_atgetifacecfg+0
;atca_hal.c,274 :: 		ATCA_STATUS status = ATCA_WAKE_FAILED;
;atca_hal.c,276 :: 		uint8_t _data[4] = { 0x00, 0x00, 0x00, 0x00 };
MOVS	R1, #0
STRB	R1, [SP, #4]
MOVS	R1, #0
STRB	R1, [SP, #5]
MOVS	R1, #0
STRB	R1, [SP, #6]
MOVS	R1, #0
STRB	R1, [SP, #7]
MOVW	R1, #4
STRH	R1, [SP, #8]
;atca_hal.c,277 :: 		uint16_t rxlength  = sizeof(_data);
;atca_hal.c,280 :: 		secure7_send_wake_token();
BL	_secure7_send_wake_token+0
;atca_hal.c,284 :: 		Delay_us( 1500 );
MOVW	R7, #18462
MOVT	R7, #1
NOP
NOP
L_hal_swi_wake23:
SUBS	R7, R7, #1
BNE	L_hal_swi_wake23
NOP
NOP
NOP
;atca_hal.c,286 :: 		status = hal_swi_receive(iface, _data, &rxlength);
ADD	R2, SP, #8
ADD	R1, SP, #4
LDR	R0, [SP, #12]
BL	_hal_swi_receive+0
; status start address is: 4 (R1)
UXTB	R1, R0
;atca_hal.c,288 :: 		if (status != ATCA_SUCCESS)
CMP	R0, #0
IT	EQ
BEQ	L_hal_swi_wake25
;atca_hal.c,290 :: 		return status;
UXTB	R0, R1
; status end address is: 4 (R1)
IT	AL
BAL	L_end_hal_swi_wake
;atca_hal.c,291 :: 		}
L_hal_swi_wake25:
;atca_hal.c,293 :: 		return hal_check_wake(_data, 4);
ADD	R1, SP, #4
MOV	R0, R1
MOVS	R1, #4
SXTH	R1, R1
BL	_hal_check_wake+0
;atca_hal.c,294 :: 		}
L_end_hal_swi_wake:
LDR	LR, [SP, #0]
ADD	SP, SP, #16
BX	LR
; end of _hal_swi_wake
_hal_swi_idle:
;atca_hal.c,296 :: 		ATCA_STATUS hal_swi_idle(ATCAIface iface)
; iface start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; iface end address is: 0 (R0)
; iface start address is: 0 (R0)
;atca_hal.c,298 :: 		ATCAIfaceCfg *cfg = atgetifacecfg(iface);
; iface end address is: 0 (R0)
BL	_atgetifacecfg+0
;atca_hal.c,300 :: 		secure7_send_byte(SWI_FLAG_IDLE);
MOVS	R0, #187
BL	_secure7_send_byte+0
;atca_hal.c,302 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_hal.c,303 :: 		}
L_end_hal_swi_idle:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _hal_swi_idle
_hal_swi_sleep:
;atca_hal.c,305 :: 		ATCA_STATUS hal_swi_sleep(ATCAIface iface)
; iface start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; iface end address is: 0 (R0)
; iface start address is: 0 (R0)
;atca_hal.c,307 :: 		ATCAIfaceCfg *cfg = atgetifacecfg(iface);
; iface end address is: 0 (R0)
BL	_atgetifacecfg+0
;atca_hal.c,310 :: 		secure7_send_byte(SWI_FLAG_SLEEP);
MOVS	R0, #204
BL	_secure7_send_byte+0
;atca_hal.c,312 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_hal.c,313 :: 		}
L_end_hal_swi_sleep:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _hal_swi_sleep
_hal_swi_release:
;atca_hal.c,315 :: 		ATCA_STATUS hal_swi_release(void *hal_data )
;atca_hal.c,317 :: 		return ATCA_SUCCESS;
MOVS	R0, #0
;atca_hal.c,318 :: 		}
L_end_hal_swi_release:
BX	LR
; end of _hal_swi_release
_hal_swi_discover_buses:
;atca_hal.c,320 :: 		ATCA_STATUS hal_swi_discover_buses(int swi_buses[], int max_buses)
;atca_hal.c,322 :: 		return ATCA_UNIMPLEMENTED;
MOVS	R0, #245
;atca_hal.c,323 :: 		}
L_end_hal_swi_discover_buses:
BX	LR
; end of _hal_swi_discover_buses
_hal_swi_discover_devices:
;atca_hal.c,325 :: 		ATCA_STATUS hal_swi_discover_devices(int busNum, ATCAIfaceCfg *cfg, int *found)
;atca_hal.c,327 :: 		return ATCA_UNIMPLEMENTED;
MOVS	R0, #245
;atca_hal.c,328 :: 		}
L_end_hal_swi_discover_devices:
BX	LR
; end of _hal_swi_discover_devices
_atca_delay_us:
;atca_hal.c,330 :: 		void atca_delay_us(uint32_t delay)
; delay start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; delay end address is: 0 (R0)
; delay start address is: 0 (R0)
;atca_hal.c,332 :: 		while (delay--)
L_atca_delay_us26:
; delay start address is: 0 (R0)
MOV	R2, R0
SUBS	R1, R0, #1
MOV	R0, R1
; delay end address is: 0 (R0)
CMP	R2, #0
IT	EQ
BEQ	L_atca_delay_us27
; delay end address is: 0 (R0)
;atca_hal.c,333 :: 		Delay_1us();
; delay start address is: 0 (R0)
BL	_Delay_1us+0
; delay end address is: 0 (R0)
IT	AL
BAL	L_atca_delay_us26
L_atca_delay_us27:
;atca_hal.c,334 :: 		}
L_end_atca_delay_us:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atca_delay_us
_atca_delay_10us:
;atca_hal.c,336 :: 		void atca_delay_10us(uint32_t delay)
; delay start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; delay end address is: 0 (R0)
; delay start address is: 0 (R0)
;atca_hal.c,338 :: 		while (delay--)
L_atca_delay_10us28:
; delay start address is: 0 (R0)
MOV	R2, R0
SUBS	R1, R0, #1
MOV	R0, R1
; delay end address is: 0 (R0)
CMP	R2, #0
IT	EQ
BEQ	L_atca_delay_10us29
; delay end address is: 0 (R0)
;atca_hal.c,339 :: 		Delay_10us();
; delay start address is: 0 (R0)
BL	_Delay_10us+0
; delay end address is: 0 (R0)
IT	AL
BAL	L_atca_delay_10us28
L_atca_delay_10us29:
;atca_hal.c,340 :: 		}
L_end_atca_delay_10us:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atca_delay_10us
_atca_delay_ms:
;atca_hal.c,342 :: 		void atca_delay_ms(uint32_t delay)
; delay start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; delay end address is: 0 (R0)
; delay start address is: 0 (R0)
;atca_hal.c,344 :: 		while (delay--)
L_atca_delay_ms30:
; delay start address is: 0 (R0)
MOV	R2, R0
SUBS	R1, R0, #1
MOV	R0, R1
; delay end address is: 0 (R0)
CMP	R2, #0
IT	EQ
BEQ	L_atca_delay_ms31
; delay end address is: 0 (R0)
;atca_hal.c,345 :: 		Delay_1ms();
; delay start address is: 0 (R0)
BL	_Delay_1ms+0
; delay end address is: 0 (R0)
IT	AL
BAL	L_atca_delay_ms30
L_atca_delay_ms31:
;atca_hal.c,346 :: 		}
L_end_atca_delay_ms:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _atca_delay_ms
